/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DataEntryPrograms;

import java.awt.Dimension;
import java.awt.Insets;
import javax.swing.JPanel;
import java.util.HashMap;
import java.io.File;
import java.io.IOException;
import javax.swing.JOptionPane;
import java.awt.Color;
import java.awt.GridBagConstraints;
import javax.swing.JButton;
import java.awt.GridBagLayout;
import static DataEntryPrograms.SpreadSheet.dataentryframe;
import static DataEntryPrograms.DotingEntry.grassHopper;
// keep these unused imports or it may have trouble constructing ErrorLogFile
import static DataEntryPrograms.DotingEntry.ErrorLogFile;

/*
 * WIRING DIAGRAM :
 *
 * Class Name : ChoiceSheet
 * Methods : Look in Class definition
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class contains methods that display a Choice Sheet of tables for data entry.
 * You choose one of these tables and it pops up a SpreadSheet containing data rows for the chosen table
 * if any.
 * NOTE:- Due to lack of time I have not plugged in code for some tables that are dumped by
 * MaintainData.Spy.dump(). Please cut and paste and add that code also for tables such as CustomerRegister
 * ShoppingCart InstalledTables ReportsTable, ChangeTracker. Warm Regards Lazy Ass.
 *
 * Technical References : Asterix and Ceasers Gift
 * 
 * Musical Accompanyments : An American Prayer JIM MORESONS Music by the Doors.
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * Last Modification Date : 5th June 2012
 * Last Modifications : Added these indexes (HashMaps) for various tables to help detect accidental data
 * entry of duplicate rows during data entry. If these indexes return null it means the row being entered
 * by the user during data entry is unique otherwise it means the row already exists and the form validations
 * will warn the user. Look at TxtFldLsnr.java for usage of these indexes.
 *
    static HashMap <String, String> indxlanguagetitles = new HashMap<String, String> (750);
    static HashMap <Integer, Integer> indxfiletabledatafilemap = new HashMap <Integer, Integer> (20);
    static HashMap <String, String> indxsearchdatabase = new HashMap<String, String> (1750);
    static HashMap <String, String> indxpaymenttype = new HashMap<String, String> (50);
    static HashMap <String, String> indxlanguagetransalations = new HashMap<String, String> (250);
    static HashMap <String, String> indxpictureoptions = new HashMap<String, String> (1000);
    static HashMap <String, String> indxpicturedatabase = new HashMap<String, String> (250);
    static HashMap <String, String> indxdefaultadvertisingimages = new HashMap <String, String> (50);
    static HashMap <String, String> indxlanguagesupport = new HashMap<String, String> (80);
 *
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class ChoiceSheet {

    static HashMap <String, String> indxlanguagetitles = new HashMap<String, String> (750);
    static HashMap <Integer, Integer> indxfiletabledatafilemap = new HashMap <Integer, Integer> (20);
    static HashMap <String, String> indxsearchdatabase = new HashMap<String, String> (1750);
    static HashMap <String, String> indxpaymenttype = new HashMap<String, String> (50);
    static HashMap <String, String> indxlanguagetransalations = new HashMap<String, String> (250);
    static HashMap <String, String> indxpictureoptions = new HashMap<String, String> (1000);
    static HashMap <String, String> indxpicturedatabase = new HashMap<String, String> (250);
    static HashMap <String, String> indxdefaultadvertisingimages = new HashMap <String, String> (50);
    static HashMap <String, String> indxlanguagesupport = new HashMap<String, String> (80);

    GridBagLayout layout = new GridBagLayout ();
    GridBagConstraints constraints ;
    JButton ftbtn, dambtn, lsbtn, ltbtn, ltrbtn, ptbtn, pdbtn, pobtn, sdbtn, ctbtn, exitbutton ;
    
    static JPanel choicesheetpanel ;

    // Ignore such stupid warnings like Overridable method call in constructor
    public ChoiceSheet ()
    {        
        ShowUngalChoices ();
    }

/*
 * WIRING DIAGRAM :
 * Method Name : void ShowUngalChoices ()
 * Parameters : None
 * Returns : None
 * Chained Methods : GridBagConstraints setConstraints (int X, int Y, int W, int H)
 * Called From : Constructor public ChoiceSheet ()
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method adds Choice Buttons to the ChoiceSheet and displays them. It registers
 * the following classes as Action Listeners for the various Buttons.
 * class ftButton, class damButton, class lsButton, class ltButton, class ltrButton, class ptButton,
 * class pdButton, class poButton, class sdButton, class ctButton.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    void ShowUngalChoices ()
    {
        Insets insets = dataentryframe.getInsets();
        int X = dataentryframe.getX() + insets.left , Y = dataentryframe.getY() + insets.top,
            W = DotingEntry.DEFAULT_WIDTH - insets.left - insets.right,
            H = DotingEntry.DEFAULT_HEIGHT - insets.top - insets.bottom;

        SpreadSheet.cells = null;
        
        if (choicesheetpanel != null)
            dataentryframe.remove(choicesheetpanel);
        
        System.gc(); // needed or else the screen repaint will be slow
        
        choicesheetpanel = new JPanel (new GridBagLayout());
        choicesheetpanel.setPreferredSize(new Dimension (W,H));
        choicesheetpanel.setSize(new Dimension(W,H));
        choicesheetpanel.setMinimumSize(new Dimension (W,H));
        choicesheetpanel.setMaximumSize(new Dimension(W+3, H+3));
        
        dataentryframe.add(choicesheetpanel, setConstraints(X, Y, W, H));

        choicesheetpanel.add(ltrbtn = new JButton("Table languagetransalations"), setConstraints (4,1,5,1));
        ltrbtn.setBackground(Color.ORANGE);
        ltrbtn.addActionListener(new ltrButton());

        choicesheetpanel.add(ltbtn = new JButton("Table languagetitles"), setConstraints (15,1,1,1));
        ltbtn.setBackground(Color.RED);
        ltbtn.addActionListener(new ltButton());

        choicesheetpanel.add(ftbtn = new JButton("Table filetabledatafilemap"), setConstraints (10,3,5,1));
        ftbtn.setBackground(Color.BLUE);
        ftbtn.setForeground(Color.WHITE);
        ftbtn.addActionListener(new ftButton());

        choicesheetpanel.add(ctbtn = new JButton ("Table celebritytable"), setConstraints(8,4,3,1));
        ctbtn.setBackground(Color.GREEN);
        ctbtn.addActionListener(new ctButton());


        choicesheetpanel.add(dambtn = new JButton("Table defaultadvertisingimages"), setConstraints (15,4,7,1));
        dambtn.setBackground(Color.BLACK);
        dambtn.setForeground(Color.YELLOW);
        dambtn.addActionListener(new damButton());

        choicesheetpanel.add(sdbtn = new JButton("Table searchdatabase"), setConstraints (4,6,3,1));
        sdbtn.setBackground(Color.CYAN);
        sdbtn.addActionListener(new sdButton());

        choicesheetpanel.add(lsbtn = new JButton("Table languagesupport"), setConstraints (11,6,3,1));
        lsbtn.setBackground(Color.LIGHT_GRAY);
        lsbtn.addActionListener(new lsButton());

        choicesheetpanel.add(pobtn = new JButton("Table pictureoptions"), setConstraints (8,7,3,1));
        pobtn.setBackground(Color.PINK);
        pobtn.addActionListener(new poButton());

        choicesheetpanel.add(ptbtn = new JButton("Table paymenttype"), setConstraints (14,7,3,1));
        ptbtn.setBackground(Color.MAGENTA);
        ptbtn.addActionListener(new ptButton());
        
        choicesheetpanel.add(pdbtn = new JButton("Table picturedatabase"), setConstraints (12,8,3,1));
        pdbtn.setBackground(Color.YELLOW);
        pdbtn.addActionListener(new pdButton());


        choicesheetpanel.add(exitbutton = new JButton("EXIT"), setConstraints (15,11,2,1));
        exitbutton.setBackground(Color.LIGHT_GRAY);
        exitbutton.setForeground(Color.RED);
        exitbutton.setToolTipText("YOU MUST SAVE ALL CHANGES BEFORE EXITING");
        exitbutton.addMouseListener(new exitAdapter());
        
        choicesheetpanel.repaint();
        choicesheetpanel.setVisible(true);
        choicesheetpanel.validate();
        //dataentryframe.p.pack();
    }

/*
 * WIRING DIAGRAM :
 * Method Name : GridBagConstraints setConstraints (int X, int Y, int W, int H)
 * Parameters : int X -- gridX
 *              int Y -- gridY
 *              int W -- gridwidth
 *              int H -- gridheight
 *
 * Returns : GridBagConstraints  -- an instance of the constraints that you set
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method sets constraints as per your params and returns an instance of the same
 * to be used with dataentryframe.add as in method ShowUngalChoices ().
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }

/*
 * WIRING DIAGRAM :
 * Method Name : static void DeleteTakenMarkerFile (String p_file)
 * Parameters : String p_file -- name of marker file to delete
 * Returns : boolean  true if no errors
 *           boolean  false if a marker file has already been created by some other user
 * 
 * Called From: SpreadSheet::static void displayButtons ()
 *              SpreadSheet::protected static boolean savespreadsheettofile ()
 *
 * Data File : DotingEntry.NetworkDrive + "LensViewDataEntry" + DotingEntry.FILESEPERATOR + p_file + "_de" + ".taken"
 *             where p_file is the value of chosen_table
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method deletes marker file *.taken created by CreateTakenMarkerFile (String p_file)
 * It works like this. Whenever the user chooses a table from the ChoiceSheet for data entry/edit a marker file
 * is created by the registered Action Listener for the Button in its actionPerformed method. So if you look at
 * class ctButton you will find a call to CreateTakenMarkerFile (String p_file). This marker file is needed to
 * prevent some other user from Choosing that table in the ChoiceSheet since this is a multi-user data entry
 * program.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 * 
 * Last Modification Date : 6th July 2012
 * Last Modifications : Altered method declaration to return boolean true or false. Earlier it
 * returned void.
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    static void DeleteTakenMarkerFile (String p_file)
    {
        if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").canWrite() == false)
        {
            if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").setWritable(true, true) == false)
            {
                System.err.println(grassHopper("cannot setWritable(true,true)"));
                JOptionPane.showMessageDialog(dataentryframe, "cannot setWritable(true,true) for directory"
                                    + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                    + "\n" + " contact SYSADM immediately" );
                JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                System.exit(1);
            }
        }

        if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + DotingEntry.FILESEPERATOR
                + p_file + "_de" + ".taken").delete() == false)
        {
            System.err.println("Cant delete " + DotingEntry.NetworkDrive + "LensViewDataEntry" + DotingEntry.FILESEPERATOR
                + p_file + "_de" + ".taken");
            JOptionPane.showMessageDialog(dataentryframe, "Unable to delete Marker File"
                  + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry" + DotingEntry.FILESEPERATOR
                + p_file + "_de" + ".taken");
            return;
        }

        // reset it to read again
        try{
                if (new File (DotingEntry.NetworkDrive + "LensViewDataEntry").setReadOnly() == false)
                {
                    System.err.println(grassHopper("denied perms to setReadOnly() LensViewDataEntry"));
                    JOptionPane.showMessageDialog(dataentryframe, "Could not setReadOnly() directory LensViewDataEntry");
                    JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
                }
            }catch (SecurityException ex_NOKIA93){
                System.err.println(grassHopper(ex_NOKIA93, "Security Manager denied perms to setReadOnly() LensViewDataEntry"));
                JOptionPane.showMessageDialog(dataentryframe, "Could not setReadOnly() directory LensViewDataEntry");
                JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + ErrorLogFile);
            }
    }
/*
 * WIRING DIAGRAM :
 * Method Name : static void CreateTakenMarkerFile (String p_file)
 * Parameters : String p_file -- marker file to create
 * Returns : None
 * Called From : Each of the registered classes of ActionListeners for each of Buttons in showUngalChoices()
 *
 * Data File : DotingEntry.NetworkDrive + "LensViewDataEntry" + DotingEntry.FILESEPERATOR + p_file + "_de" + ".taken"
 *             where p_file is the value of chosen_table
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method creates marker file *.taken. It works like this. When user chooses a table
 * from the ChoiceSheet for data entry/edit a marker file is created by the registered Action Listener for
 * Button in its actionPerformed method. Look at class ctButton you will find a call to this method.
 * This marker file is needed to prevent some other user from Choosing that table in the ChoiceSheet since
 * this is a multi-user data entry program.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 13th August 2011
 *
 * Last Modifications Date : 22nd June 2012
 * Last Modifications : Thru out this source file whereever there is a System.exit(1) there is a 
 * popup informing the user about the name of the log file for the current session. so I have added
 * the following source line everywhere
                      JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    static boolean CreateTakenMarkerFile (String p_file)
    {

      if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").canWrite() == false)
      {
          if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry").setWritable(true, true) == false)
          {
              System.err.println(grassHopper("cannot setWritable(true,true)"));
              JOptionPane.showMessageDialog(dataentryframe, "cannot setWritable(true,true) for directory"
                                    + "\n" + DotingEntry.NetworkDrive + "LensViewDataEntry"
                                    + "\n" + " contact SYSADM immediately" );
              JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
              System.exit(1);
          }
      }
      if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + DotingEntry.FILESEPERATOR
                + p_file + "_de" + ".taken").exists())
      {
          JOptionPane.showMessageDialog(dataentryframe, "Some Other Data Entry Operator"
                  + "\n" + " has already chosen this table for "
                  +  "\n" + "Dataentry. Choose some other table.");

          return false;
      }
      
      try{
            if (new File(DotingEntry.NetworkDrive + "LensViewDataEntry" + DotingEntry.FILESEPERATOR
                + p_file + "_de" + ".taken").createNewFile() == false)
            {
                System.err.println(grassHopper ("Error creating Taken marker file " + "filetabledatafilemap"));
                JOptionPane.showMessageDialog(dataentryframe,
                "Error creating Taken marker file " + "\n" +  "LensViewDataEntry\\" + "filetabledatafilemap");
                JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                System.exit(1);
            }
        }catch(IOException ex_NOKIA86){
            System.err.println(grassHopper (ex_NOKIA86, "Error creating Taken marker file " + "filetabledatafilemap"));
            JOptionPane.showMessageDialog(dataentryframe,
            "Error creating Taken marker file " + "\n" +  "LensViewDataEntry\\" + "filetabledatafilemap");
            JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
            System.exit(1);
        }

       // reset directory to readOnly once again
        // reset it to read again
        try{
                if (new File (DotingEntry.NetworkDrive + "LensViewDataEntry").setReadOnly() == false)
                {
                    System.err.println(grassHopper("denied perms to setReadOnly() LensViewDataEntry"));
                    JOptionPane.showMessageDialog(dataentryframe, "Could not setReadOnly() directory LensViewDataEntry");
                    JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                }
            }catch (SecurityException ex_NOKIA93){
                System.err.println(grassHopper(ex_NOKIA93, "Security Manager denied perms to setReadOnly() LensViewDataEntry"));
                JOptionPane.showMessageDialog(dataentryframe, "Could not setReadOnly() directory LensViewDataEntry");
                JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
            }
        return true;
    }
}
