/*
 * @(#)Packages MaintainData,PitStart,DataEntryPrograms
 * Version 1.0 of LensView Photographic Sales Software
 * Release Date : 17/10/2011
 * Author : Kodangudi Vaidyanathswamy Padmanabhan Sai Krishna
 *
 * Copyright (c) 2011 – until end of time FotoKrafts All Rights Reserved.
 * FotoKrafts (www.fotokrafts.net) C-1678, Sahakara Nagar, Bangalore -92.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL and COMMERCIAL purposes and
 * without fee is hereby granted EXCEPT (1) you may not re-produce this in
 * E-Books or other Books from any publishing house (2)You may not copy,
 * modify, and distribute this software as offerings clubbed with other
 * commercial software today, in future or commercial software released in
 * the past.
 *
 * FotoKrafts MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 * OR NON-INFRINGEMENT. FotoKrafts SHALL NOT BE LIABLE  FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS
 * SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES"). FotoKrafts
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 * THIS ENTIRE SOFTWARE IS DEDICATED TO MY CREATOR Group Captain K.V Padmanabhan [retd]
 */

package DataEntryPrograms;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.concurrent.Semaphore;
import java.io.EOFException;
import java.io.InvalidClassException;
import java.io.OptionalDataException;
import java.io.StreamCorruptedException;
import java.io.UTFDataFormatException;
import java.lang.reflect.InvocationTargetException;
import java.nio.channels.ClosedChannelException;
import java.nio.channels.OverlappingFileLockException;
import java.text.ParseException;
import java.util.MissingResourceException;
import javax.mail.MessagingException;
import javax.mail.internet.AddressException;
import java.util.Locale;
import java.util.Date;

import java.util.Random;
import javax.swing.JApplet;
import java.awt.Toolkit;
import java.util.Properties;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.InputStream;
import java.util.HashMap;
import java.io.IOException;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.UIManager;
import javax.swing.JOptionPane;
import java.io.File;
import static DataEntryPrograms.SpreadSheet.dataentryframe;
import java.awt.Font;
import java.awt.GraphicsEnvironment;

// keep these unused imports or it may have trouble constructing ErrorLogFile

/*
 * WIRING DIAGRAM :
 *
 * Class Name : DotingEntry
 * Methods : Look in Class definition
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class contains the main () method for your Data Entry Programs for LensView
 * application.
 *
 * Technical References : You will notice that nearly everything in this class is static. YES i want them
 * to be static and I dont want you to instantiate this class although you may extend it where you need it.
 * Since this is the main class for the Data Entry Programs here is a short explanation of the overall flow
 * of logic. When you run this application you will be presented with a ChoiceSheet where you choose the
 * table for which you wish to enter or edit data. It then pops up a spreadsheet containing data already
 * entered for the table in a previous session or a blank spreadsheet if no data exists. From the SpreadSheet
 * of rows you choose any one row at a time to either edit or fill data and then Save it. When you choose a
 * row you are taken to a large DataSheet to make it convenient to enter/edit data and then you press the
 * done button.
 *
 * Musical Accompanyments : An American Prayer JIM MORESONS Music by the Doors.
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 * Last Modified Date : 7th March 2012
 * Last Modifications : Changed Applet to JApplet in the following line
                // appframe is a static import
                dataentryframe = new DataEntry (new JApplet());
 *
 * Last Modifications Date : 22nd June 2012
 * Last Modifications : Thru out this source file whereever there is a System.exit(1) there is a
 * popup informing the user about the name of the log file for the current session. so I have added
 * the following source line everywhere
                      JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
 *
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class DotingEntry extends JApplet{

    static boolean HOME_EDITION = true;
    static String WINDOWS = "Windows";
    static String LINUX = "Linux";
    static String SOLARIS = "Solaris";
    static String MACINTOSH = "Mac";
    /* Fetch from system properties */
    static String FILESEPERATOR = System.getProperty("file.seperator",
            System.getProperty("os.name").indexOf(WINDOWS) != -1 ? "\\" : "/");
    // Changed on 26th June 2012
    static String OPERATINGSYSTEM = System.getProperty("os.name");
    static final long pid = new Random ().nextLong();
    static final Date today = new Date ();
    static final Locale DefaultLocale = Locale.getDefault (); // Installed Locale
    // these valid log file extensions are meant to confuse Mr Harry Hacker. He wont know which log file to
    // delete or corrupt even the sys admin will have to check system dates/time on all log files to spot the
    // correct log file totally 33 extensions to choose from ADD MORE bindaas more the merrier
    static final String LogExtensions [] = {".txt", ".logs", ".log", ".err", ".error", ".bug", ".bugs",
    ".errlog", ".errorlog", ".mistakes", ".dberr", ".dbfail", ".fail", ".erep", ".errrep", ".blunders", ".bugger",
    ".flaws", ".flaw", ".lfile", ".lfiles", ".logrep", ".logreps", ".lg", ".lgs", ".run", ".runs", ".exit",
    ".buggers", ".screwups", ".coredump", ".sys", ".system", ".fault", ".faults", ".galti", ".illegit", ".crash",
    };
    static String serializedfilespath = System.getProperty("user.dir") == null
            ? new String("."):System.getProperty("user.dir"); // Changed 26th June 2012
    static String lgfl = serializedfilespath
    + "LensViewLog" + String.valueOf(today.getTime()).trim() + "PID"
    + String.valueOf(pid).trim()
    + "_" + DefaultLocale.getDisplayName().toUpperCase().trim() + "_"
    + LogExtensions [(new Random ()).nextInt(LogExtensions.length)].toUpperCase().trim();

    static String ErrorLogFile = lgfl.substring(0, lgfl.indexOf(" ") == -1 ?lgfl.length():lgfl.indexOf(" "));
    static long logerrorno = 0L;
    static final String[][] tablenameidentifier =
    {
     // tableno, tablename, approx rows, exact cols
        {"00","FileTableDataFileMap","18","8"}, /* this field count */   /* RW table */
        {"01","ChangeTracker","5000","8"},        /* must be accurate here */  /* RW table */
        {"02","CustomerRegister","300","25"},  /* RW table */
        {"03","ShoppingCart","100","14"},  /* RW table */
        {"04","LanguageSupport","30","4"},
        {"05","LanguageTitles","1000","4"},
        {"06","LanguageTransalations","5000","6"},
        {"07","PaymentType","10", "3"},
        {"08","PictureDatabase","100", "10"},
        {"09","PictureOptions","3000", "5"},
        {"10","SearchDatabase","3000","3"},   // approx rows are initial guestimates can be updated later
        {"11","DefaultAdvertisingImages","32", "10"}, // i have added a little extra
        {"12","Artleaves","1", "30"},
        {"13","CrashRecovery","13", "4"}, /* RW table */
        {"14","InstalledTables","55", "9"}, /* RW table */
        {"15","ReportsTable","35", "10"}, /* RW table */
        {"16","CelebrityTable","750","1"},
        {"17","PlatformClearance","750","6"}
    };
    
    /* some frequently used tables dont delete final specifier */
    static final int ft = 0, cr = 2, sc = 3, ls = 4, lt = 5, ltr = 6, pt = 7, pd = 8,
                     po = 9, sd = 10, da = 11, ar = 12, clt = 16;
                               
    static PrintStream errfile = null;
    static final byte REALTABLES = 17;
    static String fieldseperator = "|"; // this is the best stick with this

    static
    {
        if (fieldseperator.equals("!") == false && fieldseperator.equals("|") == false
            && fieldseperator.equals(":") == false )
            fieldseperator = "|";
    }
    
    static String [] AlertLabels = {"SYSADM:", "INTRUDER:", "SABOTAGE:", "WARNING:",
            // four       five        six        seven                   eight        nine
       "CORRUPTION:", "ADVISORY:", "GENERAL:", "PROGRAMMING SCREWUPS:", "EMERGENCY:", "LOWBATTERY:",
       // ten        // eleven       // twelve         // thirteen     // fourteen      // fifteen
       "OUTOFSPACE:", "FAKEDATABASE:", "DATABASE CRASH:", "DISK FAILURE:", "OUT OF MEMORY:", "BAD-DATA:"
    };
    static int ALRTLVL = 0;
    static Semaphore GrassHopperLock = new Semaphore(2,true);
    static int ErrMesgNo = 0;
    static String [] ErrMesgs =
    {
        // 0 Default
        " Self Explanatory and/or read explanation below with same line number ",
        // 1 IOEXception
        " stream has been closed, input stream does not support reading after close or another I/O error occurs ",
        // 2 IOException
        " I/O error occurs ",
        // 3 IOException
        " file could not be created ",
        // 4
        " Variant 4 ", // must have single space on both sides
        // 5 UTFDataFormatException
        " the bytes do not represent a valid modified UTF-8 encoding of a string ",
        // 6
        " Variant 2 ", // must have single space on both sides
        // 7 EOFException
        " this input stream reaches the end before reading all the bytes ",
        // 8
        " Variant 2 ", // must have single space on both sides
        // 9 SecurityException
        " SecurityManager.checkRead(java.lang.String) method denies read access to file ",
        // 10 SecurityException
        " SecurityManager.checkWrite(java.lang.String) method denies write access to the file ",
        // 11 SecurityException
        "SecurityManager.checkExec(java.lang.String) method denies execute access to the file ",
        // 12 SecurityException
        " SecurityManager.checkDelete method denies delete access to the file ",
        // 13 SecurityException
        " a required system property value cannot be accessed ",
        // 14 SecurityException  use this with getFreeSpace getUsableSpace getTotalSpace etc
        " Security Manager denies RuntimePermission(\"getFileSystemAttributes\") or read denied to pathname ",
        // 15
        " the current thread cannot modify this thread ",
        // 16 IllegalArgumentsException
        " argument contains fewer characters or invalid number of arguments or invalid characters ",
        // 17 NumberFormatException
        " attempt to convert string to numeric types, string format incorrect ",
        // 18 NumberFormatException
        " Variant 2 ", // must have single space on both sides
        // 19 ClosedChannelException
        " this channel is already closed ",
        // 20 OverlappingFileLockException
        " lock overlaps request region held by JVM, other thread blocked in trylock overlap region same file ",
        // 21 ArrayOutofBoundsException
        " specified index argument is negative, or is greater than or equal to length of specified array ",
        // 22 NullPointerException
        " Specified Object is null ",
        // 23 IllegalThreadStateException
        " this thread is already active ",
        // 24 IllegalThreadStateException
        " Variant 2 ", // must have single space on both sides
        //25 ParseException
        " beginning of the specified string cannot be parsed ",
        //26 ParseException
        " Variant 2 ", // must have single space on both sides
        //27 ParseException
        " Variant 3 ", // plug in your customized error message here if you dont like system error message
        // 28 ClassNotFoundException
        " Class of a serialized object cannot be found ",
        // 29 InvalidClassException
        " Something is wrong with a class used by serialization ",
        // 30 StreamCorruptedException
        " Control information in the stream is inconsistent ",
        // 31 OptionalDataException No longer need with Java SE 6 autoboxing from primitive to Object
        " Primitive data was found in the stream instead of objects ",
        // 32 MissingResourceException
        " A Resource Bundle is Missing ",
        // 33 AddressException
        " Invalid Email Address Specified ",
        // 34 MessagingException
        " MessagePreparationFailure:cant add specified Recipient[s] addRecipient/addRecipients ",
        // 35 MessagingException
        " MessagePreparationFailure:cant set subject setSubject ",
        // 36 MessagingException
        " MessagePreparationFailure:cant set from setFrom ",
        // 37 MessagingException
        " MessagePreparationFailure:cant set body of message setContent ",
        // 38 MessagingException
        " MessagePreparationFailure:cant set text of message with attachment setText ",
        // 39 MessagingException
        " MessagePreparationFailure:cant set DataHandler for message setDataHandler ",
        // 40 MessagingException
        " MessagePreparationFailure:cant add body part for message addBodyPart ",
        // 41 MessagingException
        " MessagePreparationFailure:cant attach specified file to message setFileName ",
        // 42 MessagingException
        " AirportPostOfficeClosed:cant connect using specified username,password connect() ",
        // 43 MessagingException
        " MessageNotDelivered:message not delivered sendMessage ",
        // 44 MessagingException
        " PostBoxOpen:could not close transport connection Zip Up !! close () ",
        //45 IllegalAccessException
        " Executing method dont have access to definition of class,field,method or constructor ",
        //46 IllegalAccessException
        " Variant 2 ", // must have single space on both sides
        //47 InvocationTargetException
        " the underlying method invoked by Method throws an exception ",
        //48 InvocationTargetException
        " Variant 2 ", // must have single space on both sides
        //49 NoSuchMethodException
        " particular Method cannot be found in class ",
        //50 NoSuchMethodException
        " Variant 2 " // must have single space on both sides
    };

    static Character ChosenNetDriveLetter = SenseNetworkDrives()[0]; // maximum space
    static String NetworkDrive = HOME_EDITION ? OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ?
            ChosenNetDriveLetter + FILESEPERATOR : "C:\\" : OPERATINGSYSTEM.indexOf(WINDOWS) == -1 ? ChosenNetDriveLetter + FILESEPERATOR :
                                                                      ChosenNetDriveLetter + ":\\";
    public static Boolean NetworkDriveAbsent = false;
    public static Character [] ExternalDevices = null; // Drive letter for these
    public static Character [] HardDisks = null; // Drive letters for these
    public static Character [] PenDrives = null;
    public static String [] TapeDrives = null;

    static String InstalledLookAndFeels = null;
    
    static boolean WindowsSkin = false;
    static boolean MetalSkin = false;
    static boolean MotifSkin = false;
    static UIManager.LookAndFeelInfo  infos [] = null;
    static byte TotalSkins = 0;
    static String [] AvailableChomdis = null; // Chomdi = skin
    static String [] AvailableChomdisClassNames = null;
    static final int DEFAULT_HEIGHT = (int)Toolkit.getDefaultToolkit().getScreenSize().getHeight()/4 * 3;
    static final int DEFAULT_WIDTH = (int)Toolkit.getDefaultToolkit().getScreenSize().getWidth()/4 * 3;

/*
 * WIRING DIAGRAM :
 * @LOOKSY: None
 * Method Name : static String getFontName (String isocode)
 * Parameters : String isocode -- The ISO code for which a suitable Font is to be searched 
 * Returns : A font name , Can also be an empty String " "
 *
 * Data File : None
 * Called From : static synchronized void Validate () of tf3TxtFldLsnr.java
 * Chained Methods : static String getLohit(String isocode, String [] fonts)
 *                   static String getSamyak(String isocode, String [] fonts)
 *  
 * Associated Methods : DotingEntry::public static String grassHopper (Object... ex_Exception)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from void Validate () of tf3TxtFldLsnr.java and all
 * it does is to call GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
 * and GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts(); and search for a suitable font
 * for the iso language code passed in as a parameter. This method is necessary for just that one
 * TextField in DataSheetLanguageTitles method of DataSheet.java. The JTextField is tf5. This accepts
 * cut and paste input in various languages. For Roman languages cut and paste works fine and displays
 * For non-Roman languages specially Indic languages, Korean and Japanese and Chinese and Thai and
 * Khmer etc it will display junk on the screen when you cut and paste. So to avoid this junk display
 * we do a setFont on tf5 with the font name returned by this method. There are some multi-purpose
 * fonts like Times New Roman, Courier, Tahoma, Microsoft Sans Seriff etc that are well suited for
 * display of West European, Arabic, Hebrew, Cyrillic and Greek text but not for South East Asian
 * and Indic Languages. For Indic languages there is not one single font covering all languages.
 * There is the Lohit Family of fonts which supports around 16 Indian languages and each has a
 * different ttf file. There is also the Samyak Family of fonts for Indic Languages which covers
 * another four or five languages.
 * Okay this method getAvailableFontFamilyNames only lists those that came with Java/SDK. The Indic
 * family of fonts does not get listed and neither do some of the South East Asian Fonts. So for you
 * to display correctly the language words/text during data entry you need the fonts to be installed
 * somewhere on your system. So to do that you follow the following Steps
 * 1. Create a new folder by the name fallback on your C drive.
 * 2. Copy <fontname>.ttf file to this folder
 * 3. Copy this fallback folder to C:\ProgramFiles\Java\jdk1.6.0_21\jre\lib\fonts
 * 4. Also copy this fallback folder to C:\ProgramFiles\Java\jre6\lib\fonts
 * 5. Now delete the original fallback folder if it is at a location other than above
 * Now the Indic family font will be used by Java. So if you are keen on cutting and pasting
 * Malayalam text then pick whichever Malayalam font you like and copy that ttf file to this
 * fallback folder. What this fallback folder does is to instruct Java that when the user cuts
 * and pastes or other forms of user input a language font that it does not recognize then
 * fallback on the font contained in the fallback folder. Also Why this fallback folder at two
 * places. First jre folder inside jdk folder used to display language font in frames and windows.
 * The second jre folder is along with jdk folder.This is used to display language font in applets.");
 * 
 * Actually this method may seem superfluous in the light of the fallback folder and the indic
 * family of fonts and South East Asian fonts that this method will never find. But let this method
 * do the searching for all other fonts. Anyways as I stated in the previous passage using font
 * such as Microsoft Sans Seriff and not using this search method should also work fine.
 * 
 * Read the inline documentation of this method for various fonts of Indic family listed there.
 * 
 * Technical Reference : None
 *
 * Start Date: 19th July 2012
 * End Date: 19th July 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */    
    static String getFontName (String isocode)
    {        
        // There are some fonts that support Arabic, Hebrew, Cyrillic, West European (Roman)
        // These are Times New Roman, Microsoft Sans Seriff, Courier, Tahoma
        String font = "Courier";
        String fontnames [] = null;
        Font [] physicalfonts = null;
        boolean found = true;
        
        // Indic family fonts very diverse and very complicated
        if (isocode.equals("ta") || isocode.equals("te") || isocode.equals("sd") || isocode.equals("pa")
            || isocode.equals("ml") || isocode.equals("gu") || isocode.equals("ne") || isocode.equals("kn")
            || isocode.equals("mr") || isocode.equals("or") || isocode.equals("bn") || isocode.equals("hi")
            || isocode.equals("bh") || isocode.equals("as"))
        {
            fontnames = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
            for (int i = 0; i < fontnames.length; i++)
            {
                if (fontnames[i].indexOf("Lohit") != -1)
                {
                    font = getLohit(isocode, fontnames);
                    
                    if (font.equals("notfound")) { font = "Times New Roman"; found = false;}
                    else found = true;
                    
                    break;
                }
                else found = false;
            }
            
            
            if (found == false)
            { // Lamba Chowda list
                if (isocode.equals("bn") || isocode.equals("or") || isocode.equals("gu") 
                    || isocode.equals("ta"))
                {
                    // Look for Samyak font
                    for (int i = 0; i < fontnames.length; i++)
                    {
                        if (fontnames[i].indexOf("Samyak") != -1)
                        {                            
                            font = getSamyak(isocode, fontnames);
                            if (font.equals("notfound")) { font = "Times New Roman"; found = false;}
                            else found = true;   
                            
                            break;
                        }
                        else found = false;
                    }                    
                }
                
                // Actually we can keep searching further for fonts for each of the languages
                // but I am feeling lazy you write the rest of the code.
                // Here is the List 
/* Gujrati
 Padmaa - http://www.janabhaaratii.org.in/janabhaaratii/src/fonts/padmaa_0.7/padmaa.ttf (GPL) 
 Rekha - http://www.utkarsh.org/downloads/Rekha-medium.ttf (GPL) 
 Aakar - http://www.utkarsh.org/downloads/aakar-medium.ttf (GPL) 
 Kalapi - https://github.com/gujaratilexicon/font-kalapi
*/

/* Kannada
 Gubbi - https://github.com/aravindavk/Gubbi 
 Navilu - https://github.com/aravindavk/Navilu 
 Akshar Unicode - http://www.kamban.com.au/ 
 Arial Unicode - http://salrc.uchicago.edu/resources/fonts/kannadafonts.html (PROP) 
 JanaKannada - http://tdil.mit.gov.in/download/janakannada.htm (PROP) 
 Sampige - http://salrc.uchicago.edu/resources/fonts/kannadafonts.html (GPL) (This is an incomplete font) 
 Tunga - http://salrc.uchicago.edu/resources/fonts/kannadafonts.html (PROP) - (Shipped with Microsoft Windows) 
 Mallige - http://prdownloads.sourceforge.net/brahmi/kanotf.zip?download (GPL) 
 Kedage - http://prdownloads.sourceforge.net/brahmi/kanotf.zip?download (GPL)  
*/
                
/* Malayalam
 Anjalioldlipi - [1] 
 Meera - [2] 
 Kalyani - [3] 
 Rachana - [4] 
 RaghuMalayalam - [5] 
 Suruma - [6] 
 Dyuthi- [ 
 */
                
/* Oriya
 Utkal - download (GPL, gzip compressed. Best coverage.) 
 Raghu Oriya - download (GPL, works with IndiX, additional work needed to work with other renderers)
 */
      
/*
 Pothana2000 (default) - http://www.kavya-nandanam.com/Pothana2k-Li.zip (GNU GPL) 
 Vemana2000 - http://www.kavya-nandanam.com/Vemana2k-Li.zip (GNU GPL) 
 Srujana - TTF never released - [8] (GNU GPL) 
 Ramaneeya Font - [9] Derived from Lohit Telugu. 
 Three classical telugu fonts (Ponnala, RaviPrakash, LakkiReddy) released under SIL OFL (Telugu Vijayam fonts
 */
                if (found == false)
                {                    
                    String message = " Could not find font for iso code " + isocode                            
                            +  " install font";
                    System.err.println(DotingEntry.grassHopper(message));
                    
                    /* We will knock out this popup because it is irritating
                    JOptionPane.showMessageDialog(DataSheet.datasheetpanel,
                            "Could not find font for iso code " + "\"" + isocode + "\""
                            + '\n' + "To install the font on your system"
                            + '\n' + "Create a new folder called fallback"
                            + '\n' + "and copy the <fontname>.ttf file to"
                            + '\n' + "fallback folder and then copy fallback"
                            + '\n' + "to java/jdk1.6.0_21/jre/lib/fonts/ AND"
                            + '\n' + "java/jre6/lib/fonts and delete original"
                            + '\n' + "fallback folder at locations other than"
                            + '\n' + "above. First jre folder inside jdk folder"
                            + '\n' + "used to display language font in frames"
                            + '\n' + "and windows.The second jre folder is"
                            + '\n' + "along with the jdk folder. This is used"
                            + '\n' + "to display language font in applets.");
                     * 
                     */
                    font = " ";
                }                
            }                
        }
        // East Asian
        else if (isocode.equals("ko") || isocode.equals("zh") || isocode.equals("ja") 
                || isocode.equals("en"))
        {
            fontnames = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
            if (isocode.equals("ko"))
            {
                for (int i = 0; i < fontnames.length; i++)
                {
                    if (fontnames[i].indexOf("Batang") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    }
                    else if (fontnames[i].indexOf("BatangChe") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    }     
                    else if (fontnames[i].indexOf("DotumChe") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    }         
                    else if (fontnames[i].indexOf("Dotum") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    }  
                    else if (fontnames[i].indexOf("GulimChe") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    } 
                    else if (fontnames[i].indexOf("Gulim") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    }               
                    else if (fontnames[i].indexOf("Gungsuh") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    } 
                    else if (fontnames[i].indexOf("GungsuhChe") != -1)
                    {
                        font = fontnames[i]; // Korean
                        break;
                    }                    
                    else found = false;
                }               
                
            }
            else if (isocode.equals("zh")) // Chinese
            {
                for (int i = 0; i < fontnames.length; i++)
                {
                    if (fontnames[i].indexOf("MingLiu") != -1)
                    {
                        font = fontnames[i]; 
                        break;
                    }
                    if (fontnames[i].indexOf("Hei") != -1)
                    {
                        font = fontnames[i]; 
                        break;
                    }                    
                    else found = false;
                }                              
            }
            else if (isocode.equals("ja")) // Japanese
            {
                physicalfonts = GraphicsEnvironment.getLocalGraphicsEnvironment().getAllFonts();
                for (int i = 0; i < physicalfonts.length; i++)
                {
                    if (physicalfonts[i].toString().indexOf("MS Mincho") != -1)
                    {
                        font = "MS Mincho"; // Japanese Fall Back Font ??
                        break;
                    }
                    else if (physicalfonts[i].toString().indexOf("MS Gothic") != -1)
                    {
                        font = "MS Gothic";
                        break;
                    }
                    else if (physicalfonts[i].toString().indexOf("MS PGothic") != -1)
                    {
                        font = "MS PGothic";
                        break;
                    }
                    else if (physicalfonts[i].toString().indexOf("MS PMincho") != -1)
                    {
                        font = "MS PMincho";
                        break;
                    }
                    else found = false;
                }              
            }
        }
        // Middle East    
        else if (isocode.equals("ar") || isocode.equals("yi"))
        {
            if (DotingEntry.OPERATINGSYSTEM.indexOf(DotingEntry.WINDOWS) != -1)
                font = "Microsoft Sans Serif"; // fall back font
            else font = "Times New Roman";            
        }        
        // Cyrillic
        else if (isocode.equals("ru") )
        {
            if (DotingEntry.OPERATINGSYSTEM.indexOf(DotingEntry.WINDOWS) != -1)
                font = "Microsoft Sans Serif"; // fall back font
            else font = "Times New Roman";
        }
        else if (isocode.equals("el")) // Greek
        {
            if (DotingEntry.OPERATINGSYSTEM.indexOf(DotingEntry.WINDOWS) != -1)
                font = "Microsoft Sans Serif"; // fall back font
            else font = "Times New Roman";            
        }
        else if (isocode.equals("ur")) // Urdu
        {
            fontnames = GraphicsEnvironment.getLocalGraphicsEnvironment().getAvailableFontFamilyNames();
            for (int i = 0; i < fontnames.length; i++)
            {
                if (fontnames[i].indexOf("Nafees") != -1)
                {
                    font = fontnames[i];
                    break;
                }
                else found = false;
            }
        }
            
        return font.toString();
    }

    // This is chained auxilliary method for static String getFontName (String isocode)
    // It Searches for appropriate Lohit Font
    static String getLohit(String isocode, String [] fonts)
    {
        String lohitfont = "Lohit " + new Locale(isocode.toLowerCase().trim()).getDisplayLanguage();
        
        for (int i = 0; i < fonts.length; i++)
        {
            if (isocode.equals("as") && fonts[i].indexOf("Assamese") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("bn") && fonts[i].indexOf("Bengali") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("gu") && fonts[i].indexOf("Gujrati") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("kn") && fonts[i].indexOf("Kannada") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("ml") && fonts[i].indexOf("Malayalam") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("or") && fonts[i].indexOf("Oriya") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("ta") && fonts[i].indexOf("Tamil") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("te") && fonts[i].indexOf("Telegu") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("hi") && fonts[i].indexOf("Hindi") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("mr") && fonts[i].indexOf("Marathi") != -1)
                lohitfont = fonts[i]; 
            else if (isocode.equals("ne") && fonts[i].indexOf("Nepali") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("pa") && fonts[i].indexOf("Punjabi") != -1)
                lohitfont = fonts[i];
            else if (isocode.equals("sd") && fonts[i].indexOf("Sindhi") != -1)
                lohitfont = fonts[i];    
            else if (isocode.equals("bh") && fonts[i].indexOf("Maithili") != -1)
                lohitfont = fonts[i];    
            else lohitfont = "notfound";
        }
        
        return lohitfont.toString();
    }
    
    // This is chained auxilliary method for static String getFontName (String isocode)
    // It searches for appropriate Samyak Font
    static String getSamyak(String isocode, String [] fonts)
    {
        String samyakfont = "Samyak " + new Locale(isocode.toLowerCase().trim()).getDisplayLanguage();
        
        for (int i = 0; i < fonts.length; i++)
        {
            if (isocode.equals("bn") && fonts[i].indexOf("Bengali") != -1)
                samyakfont = fonts[i];
            else if (isocode.equals("gu") && fonts[i].indexOf("Gujrati") != -1)
                samyakfont = fonts[i];
            else if (isocode.equals("or") && fonts[i].indexOf("Oriya") != -1)
                samyakfont = fonts[i];
            else if (isocode.equals("ta") && fonts[i].indexOf("Tamil") != -1)
                samyakfont = fonts[i];    
            else samyakfont = "notfound";
        }        
        
        return samyakfont.toString();
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY: SpreadSheet.dataentryframe a static import, AvailableChomdisClassNames []
 * Method Name : static void setSkins (int n)
 * Parameters : int n -- Which Skin to set
 * Returns : None
 *
 * Data File : None
 * Called From : static void getSkins ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from getSkins() and all it does is to call static
 * UIManager.setLookAndFeel(AvailableChomdisClassNames[n]) with the skin you specified.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    static void setSkins (int n){
           // set just that one skin

        
           try{
                UIManager.setLookAndFeel(AvailableChomdisClassNames[n]);
           }catch (ClassNotFoundException ex_NOKIA99){
                System.err.println(grassHopper(ex_NOKIA99));
                JOptionPane.showMessageDialog(dataentryframe, "Skin cannot be set "
                                                          + AvailableChomdisClassNames[n]);
                JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                System.exit(1);
           }catch (InstantiationException ex_NOKIA91){
                   System.err.println(grassHopper(ex_NOKIA91));
                   JOptionPane.showMessageDialog(dataentryframe, "Skin cannot be set "
                                                          + AvailableChomdisClassNames[n]);
                   JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                   System.exit(1);
           }catch (IllegalAccessException ex_NOKIA92){
                   System.err.println(grassHopper(ex_NOKIA92));
                   JOptionPane.showMessageDialog(dataentryframe, "Skin cannot be set "
                                                          + AvailableChomdisClassNames[n]);
                   JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                   System.exit(1);
           }catch (UnsupportedLookAndFeelException ex_NOKIA87){
                   System.err.println(grassHopper(ex_NOKIA87));
                   JOptionPane.showMessageDialog(dataentryframe, "Skin cannot be set "
                                                          + AvailableChomdisClassNames[n]);
                   JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                   System.exit(1);
          }
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY: LiveDB.OPERATINGSYSTEM, LiveDB.WINDOWS, LiveDB.LINUX, LiveDB.SOLARIS
 * @LOOKSY : MetalSkin, WindowsSkin, MotifSkin, TotalSkins, AvailableChomdis
 * Method Name : static void getSkins ()
 * Parameters : None
 * Returns : None
 *
 * Data File : None
 * Called From : main() method
 * Chained Methods : DotingEntry::static void setSkins (int n)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method probes the local Java Installation for Available Skins and depending
 * on the OPERATINGSYSTEM on the workstation it sets the appropriate skins.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    static void getSkins (){

        infos = UIManager.getInstalledLookAndFeels();

        
        for (UIManager.LookAndFeelInfo info : infos)
        {
            if (info.getName().indexOf("MetalLookAndFeel") != -1)
            {
                MetalSkin = true;
                TotalSkins++;
                AvailableChomdis[AvailableChomdis.length] = info.getName();
                AvailableChomdisClassNames[AvailableChomdisClassNames.length] = info.getClassName();
            }
            else if (info.getClassName().indexOf("MotifLookandFeel") != -1)
            {
                MotifSkin = true;
                TotalSkins++;
                AvailableChomdis[AvailableChomdis.length] = info.getName();
                AvailableChomdisClassNames[AvailableChomdisClassNames.length] = info.getClassName();
            }
            else if (info.getClassName().indexOf("WindowsLookandFeel") != -1)
            {
                WindowsSkin =  true;
                TotalSkins++;
                AvailableChomdis[AvailableChomdis.length] = info.getName();
                // Chomdi javaa magar dhumdi na javaa
                AvailableChomdisClassNames[AvailableChomdisClassNames.length] = info.getClassName();
            }
            
        }

        
        if (TotalSkins > 1)
        {            
           if (OPERATINGSYSTEM.indexOf(WINDOWS) != -1)
           {
               if (TotalSkins == 3)
               {
                  setSkins(3);
               }
               else
               {
                    setSkins(0);
               }
           }
           else if (OPERATINGSYSTEM.indexOf(MACINTOSH) != -1)
           {
               if (TotalSkins == 3)
               {
                  setSkins(3);
               }
               else
               {
                    setSkins(1);
               }
           }
           else if (OPERATINGSYSTEM.indexOf(LINUX) != -1)
           {
               if (TotalSkins == 3)
               {
                   setSkins(1);
               }
               else
               {
                  setSkins(0);
               }
           }
           else if (OPERATINGSYSTEM.indexOf(SOLARIS) != -1)
           {
               if (TotalSkins == 3)
               {
                  setSkins(2);
               }
               else
               {
                  setSkins(1);
               }
           }
        }
        else if (TotalSkins == 1)
        {
             setSkins(0);
        }
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY: LiveDB.OPERATINGSYSTEM, LiveDB.WINDOWS, LiveDB.HOME_EDITION, this.NetworkDriveAbsent
 *
 * Method Name : public static Character [] SenseNetworkDrives ()
 * Parameters : None
 * Returns : Character [] -- Array of Drives which are networked one or more or even [0]='.' for
 *                           non-Windows O/S
 *
 * Data File : None
 * Called From : Initialization of Instance Variable ChosenNetDriveLetter
 * Chained Methods : DotingEntry::public static boolean checkthisdrive (String p_command)
 * Associated Methods : DotingEntry::public static boolean SenseExternalDevices ()
 *
 * 
 * @Since Version : 1.0
 *
 * Running Commentary : This method probes the local Java Installation for Available Network Drives if
 * and only if the OPERATINGSYSTEM is Windows. For every drive this method calls method checkthisdrive()
 * and this method checks to see if a "net use" command succeeds on the drive and builds an array of
 * networkdrives to choose from. It sets boolean NetworkDriveAbsent. Just in case networkdrives == 0
 * (not detected) it calls methods SenseExternalDevices to pick a hard disk for installation. This method
 * SenseExternalDevices not just fills an array of external devices but also array of HardDisks in parallel.
 *
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 *
 * Last Modified : 14th October 2011
 * Last Modifications : Slight changes to this patch of code
       if (OPERATINGSYSTEM.indexOf(WINDOWS) == -1)
       {
           networkdrives[0] = '.';
           return networkdrives;
       }
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   public static Character [] SenseNetworkDrives ()
   {
       File dl= null;
       long minspace = 1024 * 1024 * 1950;
       Character networkdrives [] = {'C'};
//       String netusecommand = null;
//       Process sensedrive = null;
       HashMap<Character,Boolean> BusyAndFreeDrives = new HashMap<Character,Boolean> (20);


       if (OPERATINGSYSTEM.indexOf(WINDOWS) == -1)
       {
           networkdrives[0] = new Character('.');   // Changed 26th June 2012
           return networkdrives;
       }

       for (char ch = 'G'; ch <= 'Z'; ch++)
       {
           if (checkthisdrive("net use " + ch + ":"))
           {
               // now Check space left on this drive
               if ((dl = new File(ch + ":\\")).getUsableSpace() > minspace)
                   BusyAndFreeDrives.put(ch, true);
               else BusyAndFreeDrives.put(ch, false);
           }
           else // busy drive
           {
               BusyAndFreeDrives.put(ch, false);
           }
       }

       int i = 0;
       for (char ch = 'G'; ch <= 'Z'; ch++)
       {
           if (BusyAndFreeDrives.get(ch) == true)
           {
               networkdrives[i] = new Character(ch);
               i++;
           }
       } 

       if (networkdrives.length == 1)
       {
           if (HOME_EDITION)
           {
               networkdrives[0] = new Character('C') ;
               return networkdrives ; // Added 26th June 2012
           }
           else
           {
               // so no network drives detected but will still need a professional install
               if (SenseExternalDevices () == false)
               {
                   System.err.println(grassHopper("No Network Drive Detected Assign " + HardDisks[0]
                           + ":" + "default"));
                   networkdrives[0] = HardDisks[0];
               }
               else
               {
                   JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
                   System.exit(1);
               }
           }
           
           NetworkDriveAbsent = true;
           return networkdrives;
       }
       else if (networkdrives.length == 2)
           return networkdrives;

       // if more than one we need to sort the drive letters descending based on space on each drive.
       // Imagine usable space as this 1800 1700 1650 1000 2000 2100 1800
       // therefore we have to loop it so many times
       // descending sort largest drive letter first.

       Character sd [] = null;

       for (int ii = 0; ii < networkdrives.length -1; ii++)
       {
           for (int iii = 0, l = 0; iii < networkdrives.length -1; iii++)
           {
                if ((new File (networkdrives[iii] + ":\\").getUsableSpace()) >
                   (new File(networkdrives[iii+1] + ":\\").getUsableSpace()))
                {
                    sd [l] = networkdrives[iii+1];
                    sd[l+1] = networkdrives[iii];
                    networkdrives[iii+1] = networkdrives[iii];
                    l++;
                }
                else
                {
                    sd[l] = networkdrives[iii];
                    sd[l+1] = networkdrives[iii+1];
                    l++;
                }
           }
       }

       return sd;
   }
/*
 * WIRING DIAGRAM :
 *
 * Method Name : public static boolean checkthisdrive (String p_command)
 * Parameters : p_command -- the command to run used for a net command
 * Returns : boolean true or false if command succeeds or fails
 *
 * Data File : None
 * Called From : public static Character [] SenseNetworkDrives ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will run a command usually a Net Command and return true/false. This
 * method can be used on non-Windows Operating Systems also with any command.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   public static boolean checkthisdrive (String p_command)
   {
       boolean netdrive = true;
       InputStream se = null; // standarderror
       BufferedReader brse = null; // this will read the stderr of command
       Process process = null;

       try{
             process = Runtime.getRuntime().exec(p_command);
       }catch(IOException ex_NOKIA62){
            System.err.println(grassHopper("Command:" + p_command, ex_NOKIA62));
            JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
            System.exit(1);
       }

       se = process.getErrorStream();

       brse = new BufferedReader(new InputStreamReader(se));

       try{
            while (brse.readLine() != null)
            {
                   netdrive = false;
                   break;
            }
       }catch (IOException ex_NOKIA5){
            System.err.println(grassHopper("Command:" + p_command, ex_NOKIA5));
            JOptionPane.showMessageDialog(dataentryframe,
                                            "YOUR LOG FILE FOR SESSION IS " + '\n' + ErrorLogFile);
            System.exit(1);
       }

       return netdrive;
   }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.ExternalDevices, this.HardDisks
 * Method Name : public static boolean SenseExternalDevices ()
 * Parameters : None
 * Returns : boolean true or false if error or no-error
 *
 * Data File : None
 * Called From : public static Character [] SenseNetworkDrives ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will sense External Devices and fill array. It will also parallely
 * sense HardDisks and fill an array. This method will only work if OPERATINGSYSTEM is WINDOWS.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   public static boolean SenseExternalDevices ()
   {
       if (OPERATINGSYSTEM.indexOf(WINDOWS) == -1)
           return false;

       // The user wants a professional install and so it is not home edition.
       // so if there are no network drives. Then I have to check all drives
       // to see if these are external devices like CDROM, DVD, floppy,
       // pen drive etc. External Add On Hard Disk of Large Capacity is allowed.
       // I assume that a hard disk will have 80GB at least. If less it is a
       // Pen Drive.


       InputStream se = null; // standarderror
       BufferedReader brse = null; // this will read the stderr of command
       Process process = null;
       String command = null;
       String filename = "testexternaldevices.tst";
       File fn = new File (filename);
       String cwd = new Properties().getProperty("user.dir");
       char drive = 'D'; // play safe start with 'D'
       long minspace = 1024 * 1024 * 1024 * 80 ;

       try{
            if (new File(cwd).setWritable(true) == false)
            {
                // try the next stunt
                if (new File(cwd).setWritable(true, false) == false)
                {
                    System.err.println(grassHopper("cannot File(cwd).setWritable(true, false)"));
                    return false;
                }
            }
       }catch (SecurityException ex_NOKIA76){
               System.err.println(grassHopper("Security mgr deny write access on " + cwd));
               return false;
       }
           
       if (fn.exists() == false)
       {
           try{
           if (fn.createNewFile() == false)
           {
               System.err.println(grassHopper("cant create " + filename + " at " + cwd));
               return false;
           }
           }catch (IOException ex_NOKIA8){
               System.err.println(grassHopper("cant create " + filename + " at " + cwd));
               return false;
           }
       }

       for (; drive <= 'Z'; drive++)
       {
            command = "copy " + filename + ' ' + drive + ":\\";

            try{
                process = Runtime.getRuntime().exec(command);
            }catch(IOException ex_NOKIA62){
                System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA62));
                return false;
            }

            se = process.getErrorStream();

            brse = new BufferedReader(new InputStreamReader(se));

            try{
                while (brse.readLine() != null)
                {
                   ExternalDevices [ExternalDevices.length] = drive;
                   continue;
                }
            }catch (IOException ex_NOKIA5){
                System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA5));
                return false;
            }
       
            // if it gets here command did not fail
            // but this could be a PenDrive upto 64GB
            // what to do dummy language one has to guess like this only
       
            // check if it really exists       
            if (new File(drive + ":\\" + filename).exists() == false)
            {
                // it still dont exist this wont happen
                ExternalDevices[ExternalDevices.length] = drive;
                continue;
            }
       
            if (new File(drive + ":\\" + filename).getTotalSpace() < minspace)
            {
                ExternalDevices[ExternalDevices.length] = drive;
                continue;
            }
            else
            {
                HardDisks[HardDisks.length] = drive;
                continue;
            }            
       } // for loop

       // if no HardDisk beyond 'C:' on this installation then we have to exit
       // because we are assuming that one of these HardDisks on which we install 
       // will be networked later but it cant be C: for sure.
       
       if (HardDisks.length == 0)
       {
           System.err.println(grassHopper("No Hard Disk after C: Cannot Professional Install"));
           return false;
       }
       
       return true;
   }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.PenDrives, this.HardDisks
 * Method Name : public static boolean SensePenDrives ()
 * Parameters : None
 * Returns : boolean true or false if error or no-error
 *
 * Data File : None
 * Called From : anywhere
 * Associated Methods : DotingEntry::public static boolean SenseExternalDevices ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will sense PenDrives and fill this array on Windows operating system
 * only. What it does is to pick the existing array of HardDisks and look for space <= 64 GB (Current max
 * capacity of Pen Drives modify later if there are higher capacity Pen Drives in market). Then to make
 * sure that it is a pen drive it copies two files with just a case difference in filename to that pen
 * drive. If the command succeeds and only one of those files exist on that pen drive then we are safe
 * in assuming that it is a pen drive. A crude way of sensing but it will work.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   public static boolean SensePenDrives ()
   {
       if (OPERATINGSYSTEM.indexOf(WINDOWS) == -1)
           return false;
       
       InputStream se = null; // standarderror
       BufferedReader brse = null; // this will read the stderr of command
       Process process = null;
       String command = null;
       String home = new Properties().getProperty("user.home");
       String cwd = new Properties().getProperty("user.dir");
       String filename1 = home + "testpendrive.tst";       
       File fn1 = new File (filename1);
       String filename2 = cwd + "Testpendrive.tst";
       File fn2 = new File (filename2);
       String drive = null;
       String [] filesinpendrive = null;       
       long maxspace = 1024 * 1024 * 1024 * 64 ;
       boolean file1 = false, file2 = false;


       if (HardDisks.length == 0)
       {
           if (SenseExternalDevices () == false)
           {
               System.err.println(grassHopper("Error while sensing Pen Drives"));
               return false;
           }
       }
       
       try{
            if (new File(cwd).setWritable(true) == false)
            {
                // try the next stunt
                if (new File(cwd).setWritable(true, false) == false)
                {
                    System.err.println(grassHopper("cannot File(cwd).setWritable(true, false)"));
                    return false;
                }
            }
       }catch (SecurityException ex_NOKIA76){
               System.err.println(grassHopper("Security mgr deny write access on " + cwd));
               return false;
       }

       if (fn1.exists() == false)
       {
           try{
           if (fn1.createNewFile() == false)
           {
               System.err.println(grassHopper("cant create " + filename1 + " at " + home));
               return false;
           }
           }catch (IOException ex_NOKIA8){
               System.err.println(grassHopper("cant create " + filename1 + " at " + home));
               return false;
           }
       }

       if (fn2.exists() == false)
       {
           try{
           if (fn2.createNewFile() == false)
           {
               System.err.println(grassHopper("cant create " + filename2 + " at " + cwd));
               return false;
           }
           }catch (IOException ex_NOKIA8){
               System.err.println(grassHopper("cant create " + filename2 + " at " + cwd));
               return false;
           }
       }

       for (int i = 0; i < HardDisks.length; i++)
       {
           drive = HardDisks[i] + ":\\" ;
           try{
                if (new File(drive).setWritable(true) == false)
                {
                    // try the next stunt
                    if (new File(drive).setWritable(true, false) == false)
                    {
                        System.err.println(grassHopper("cannot File(drive).setWritable(true, false)"));
                        return false;
                    }
                }
            }catch (SecurityException ex_NOKIA76){
               System.err.println(grassHopper("Security mgr deny write access on " + drive));
               return false;
            }

            if (new File(drive).getTotalSpace() <= maxspace)
            {
                // most probably a pen drive we need to double check
                command = "copy " + filename1 + ' ' +  drive;
                try{
                    process = Runtime.getRuntime().exec(command);
                }catch(IOException ex_NOKIA62){
                    System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA62));
                    return false;
                }

                se = process.getErrorStream();

                brse = new BufferedReader(new InputStreamReader(se));

                try{
                    while (brse.readLine() != null)
                    {
                        System.err.println(grassHopper("Failed Command:" + command));
                        continue;
                    }
                }catch (IOException ex_NOKIA5){
                    System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA5));
                    return false;
                }

                // okay no error if it gets here file copy was successfull
                // now copy the second file also
                command = "copy " + filename2 + ' ' +  drive;
                try{
                    process = Runtime.getRuntime().exec(command);
                }catch(IOException ex_NOKIA62){
                    System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA62));
                    return false;
                }

                se = process.getErrorStream();

                brse = new BufferedReader(new InputStreamReader(se));

                try{
                    while (brse.readLine() != null)
                    {
                        System.err.println(grassHopper("Failed Command:" + command));
                        continue;
                    }
                }catch (IOException ex_NOKIA5){
                    System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA5));
                    return false;
                }

                // okay both files copied to drive
                // so let us check if it is pen drive
                // actually a copy could copy to some other compatible filesystem format
                // and so this unneccessary patch of code.

                filesinpendrive = new File(drive).list();

                for (int y = 0; y < filesinpendrive.length; y++)
                {
                    if (filesinpendrive[y].indexOf("testpendrive.tst") != -1)
                        file1 = true;
                    else if (filesinpendrive[y].indexOf("Testpendrive.tst") != -1)
                        file2 = true;
                }

                if (!(file1 && file2))
                {
                   PenDrives[PenDrives.length] = HardDisks[i];
                   HardDisks[i] = ' ';
                }
            } // if maxspace
       } // for looop

       // now correct HardDisks remove blanks

       Character hd [] = null;
       for (int x = 0; x < HardDisks.length; x++)
       {
           if (HardDisks[x] != ' ')
               hd[hd.length] = HardDisks[x];
       }

       HardDisks = null;
       for (int h = 0; h < hd.length; h++)
           HardDisks[HardDisks.length] = new Character(hd[h]);
       
       return true;
   }
   
/*
 * WIRING DIAGRAM :
 * @LOOKSY:this.TapeDrives, LiveDB.OPERATINGSYSTEM, LiveDB.WINDOWS, LiveDB.LINUX, LiveDB.SOLARIS
 * Method Name : public static boolean SenseTapeDrives ()
 * Parameters : None
 * Returns : boolean true or false if error or no-error
 *
 * Data File : None
 * Called From : anywhere
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will sense Sense Tape Drives on Windows and Unixes. The method
 * is incomplete and documentation will be completed later.
 *
 * Technical Reference : None
 *
 * Start Date: 1st August 2011
 * End Date: 12th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   public static boolean SenseTapeDrives ()
   {
       // return false;
       InputStream se = null; // standarderror
       BufferedReader brse = null; // this will read the stderr of command
       Process process = null;
       String command = null;
       String home = new Properties().getProperty("user.home");
       String cwd = new Properties().getProperty("user.dir");
       String drive = null;

       if (ExternalDevices.length == 0)
       {
           if (SenseExternalDevices () == false)
           {
               System.err.println(grassHopper("Error while sensing Tape Drives"));
               return false;
           }
       }

       if (OPERATINGSYSTEM.indexOf(WINDOWS) != -1)
       {
            // just do a backup to tape of home directory and check stderr
            for (int i = 0; i < ExternalDevices.length; i++)
            {
                drive = ExternalDevices[i] + ":\\" ;
                // command = "copy " + filename2 + ' ' +  drive;
                try{
                    process = Runtime.getRuntime().exec(command);
                }catch(IOException ex_NOKIA62){
                    System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA62));
                    return false;
                }

                se = process.getErrorStream();

                brse = new BufferedReader(new InputStreamReader(se));

                try{
                    while (brse.readLine() != null)
                    {
                        System.err.println(grassHopper("Failed Command:" + command));
                        continue;
                    }
                }catch (IOException ex_NOKIA5){
                    System.err.println(grassHopper("Failed Command:" + command, ex_NOKIA5));
                    return false;
                }
            } // for
       }
       else if (OPERATINGSYSTEM.indexOf(LINUX) != -1 || OPERATINGSYSTEM.indexOf(SOLARIS) != -1)
       {
           // take a listing of /dev with a filter and then use those devices to check for tape drives
           // also sense tape drives on unixes with a cpio to tape with generic common options across
           // all flavors of unixes.
           // CRUDE BUGARS USE CRUDE METHODS !! chalega dowdega !!
           // fill up later
       }

       return true;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.GrassHopperLock, LiveDB.ALRTLVL, LiveDB.AlertLabels
 * @LOOKSY:LiveDB.errfile, LiveDB.ErrMesgNo, LiveDB.ErrMesgs
 *
 * Method Name : public static String grassHopper (Object... ex_Exception)
 * Parameters : Object... ex_Exception -- Variable arguments. Beyond two values passed it will ignore rest
 *                                        Typically either/or or both arguments. One would be an error mesg
 *                                        and the other would be an exception that occurred in the program.
 * Returns :String -- Formatted Error Message with all details filled up
 *
 * Calling Methods: Typically System.err.println () will call this method.
 *                  For example : System.err.println(LiveDB.grassHopper(ex_NOKIA52, "Error fl.release()"));
 *                                System.err.println(LiveDB.grassHopper("Error fl.release()", ex_NOKIA52));
 *                                System.err.println(LiveDB.grassHopper("Error fl.release()"));
 *                                System.err.println(LiveDB.grassHopper(ex_NOKIA52));
 *                  Immediately after calling grassHopper() as above you can take value of LiveDB.logerrorno
 *                  into a temp variable and then do the following two times at best because that is all
 *                  the linespace left on the page. So do the following as in this example
 *                  temp = LiveDB.logerrorno;
 *                  System.err.println("LINE:" + temp + "This is continuation of previous error message");
 *                  System.err.println("LINE:" + temp + "with same line number providing different details");
 *                  Other methods may also call this grassHopper () it will return a String which is nothing
 *                  but a formatted error message that you may want for some purpose.
 *
 * Assocaited Methods : protected static boolean SendLogFileMessage ()
 *
 * Log File : LiveDB.ErrorLogFile
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method serves two purposes. One as an error logger which formats a very detailed
 * error message and returns a formatted String. Two it also serves purpose of a rudimentary easy to lookup
 * debugger for novice programmers. It can also serve purpose of error message standardization to log file
 * and also serve as a quality document for Quality control purposes. Last but not the least this can help
 * trace sabotage to a specific node name.
 *
 * It works like magic if you pass just the exception instance to it. It will pick an appropriate error mesg
 * and format it for you. You can set your own LiveDB.ALRTLVL before the call to grassHopper() but even if
 * you dont do that it will default to SYSADM. Feel free to add some more magic to this if you wish to. I
 * felt keeping it nice and bare minimal and simple would be ideal. For xample you can also process a
 * LiveDB.ALRTLVL in the same call.
 *
 * Before this method returns a formatted error message for printing it also flushes the LiveDB.ErrorLogFile
 * and mails out the most recent log file as an attachment by calling method SendLogFileMessage ()
 *
 * Technical Reference : Carry on Jeeves P.G Wodehouse (Pricey ........... )
 *
 * Start Date: 18th October 2010
 * End Date: 30th May 2011
 * 
 * Last Modification Date : 26th September 2012
 * Last Modifications : Marked as 26th September 2012
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    public static String grassHopper (Object... ex_Exception){

        int alrtlvl = ALRTLVL;

        // use the system beep
        if (alrtlvl == 7)
            for (int b = 0; b < 11; b++)
                 System.out.print("\007");


        // Use the motherboard buzzer this time around
        if (alrtlvl == 8)
            for (int b = 0; b < 23; b++)
                 Toolkit.getDefaultToolkit().beep();

        System.out.flush();

        // You can also used the javax.sound API libraries to play your own pre-recorded voice error
        // messages. I am running out of time now. Next release there will be a voice message for every
        // LiveDB.ALRTLVL;

        // this funny step because if some other thread has set LiveDB.ALRTLVL before calling grassHopper()
        // and I blindly reset it to zero here then that value set by other thread is lost. It can happen
        // in a few milliseconds so just to catch that little error margin even if you dont its one in a
        // Jillion
        ALRTLVL = ALRTLVL == alrtlvl ? 0:ALRTLVL;

        GrassHopperLock.acquireUninterruptibly();

        int ii = 0;
        String verbose = " ";
        Exception EX = new Exception();
        StackTraceElement st [] = Thread.currentThread().getStackTrace();

        if (alrtlvl < 0 || alrtlvl > (AlertLabels.length - 1))
           alrtlvl = 6;

        if (ex_Exception.length > 0)
        {
            if (ex_Exception.length >= 2)
            {
                if (ex_Exception[0] instanceof String && ex_Exception[1] instanceof String)
                    verbose = String.valueOf(ex_Exception[0]);
                else if (ex_Exception[0] instanceof String)
                    verbose = String.valueOf(ex_Exception[0]);
                else if (ex_Exception[1] instanceof String)
                    verbose = String.valueOf(ex_Exception[1]);
                else if (ex_Exception[0] instanceof Exception && verbose == null)
                    EX = (Exception)ex_Exception[0];
                else if (ex_Exception[1] instanceof Exception && verbose == null)
                    EX = (Exception)ex_Exception[1];
                else verbose = ErrMesgs[0];
            }

            if (ex_Exception.length == 1)
                ii = 1;
            else ii = 2;

            for (int i = 0; i < ii ; i++)
            {
                if (ex_Exception[i] instanceof String)
                    verbose = String.valueOf(ex_Exception[i]);
                else if (ex_Exception[i] instanceof IOException)
                    EX = (IOException)ex_Exception[i];
                else if (ex_Exception[i] instanceof EOFException)
                    EX = (EOFException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ClosedChannelException)
                    EX = (ClosedChannelException)ex_Exception[i];
                else if (ex_Exception[i] instanceof OverlappingFileLockException)
                    EX = (OverlappingFileLockException)ex_Exception[i];
                else if (ex_Exception[i] instanceof NumberFormatException)
                    EX = (NumberFormatException)ex_Exception[i];
                else if (ex_Exception[i] instanceof IllegalArgumentException)
                    EX = (IllegalArgumentException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ArrayIndexOutOfBoundsException)
                    EX = (ArrayIndexOutOfBoundsException)ex_Exception[i];
                else if (ex_Exception[i] instanceof NullPointerException)
                    EX = (NullPointerException)ex_Exception[i];
                else if (ex_Exception[i] instanceof SecurityException)
                    EX = (SecurityException)ex_Exception[i];
                else if (ex_Exception[i] instanceof IllegalThreadStateException)
                    EX = (IllegalThreadStateException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ParseException)
                    EX = (ParseException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ClassNotFoundException)
                    EX = (ClassNotFoundException)ex_Exception[i];
                else if (ex_Exception[i] instanceof InvalidClassException)
                    EX = (InvalidClassException)ex_Exception[i];
                else if (ex_Exception[i] instanceof StreamCorruptedException)
                    EX = (StreamCorruptedException)ex_Exception[i];
                else if (ex_Exception[i] instanceof OptionalDataException)
                   EX = (OptionalDataException)ex_Exception[i];
                else if (ex_Exception[i] instanceof MissingResourceException)
                   EX = (MissingResourceException)ex_Exception[i];
                else if (ex_Exception[i] instanceof AddressException)
                   EX = (AddressException)ex_Exception[i];
                else if (ex_Exception[i] instanceof MessagingException)
                   EX = (MessagingException)ex_Exception[i];
                else if (ex_Exception[i] instanceof IllegalAccessException)
                   EX = (IllegalAccessException)ex_Exception[i];
                else if (ex_Exception[i] instanceof InvocationTargetException)
                   EX = (InvocationTargetException)ex_Exception[i];
                else if (ex_Exception[i] instanceof NoSuchMethodException)
                   EX = (NoSuchMethodException)ex_Exception[i];
            }

            if (EX instanceof IOException)
            {
                ErrMesgNo = 1;
                if (alrtlvl == 0)
                   alrtlvl = 4;
            }
            else if (EX instanceof MissingResourceException)
            {
                ErrMesgNo = 32;
                if (alrtlvl == 0)
                   alrtlvl = 2;
            }
            else if (EX instanceof ParseException)
            {
                ErrMesgNo = 25;
                if (alrtlvl == 0)
                   alrtlvl = 4;
            }
            else if (EX instanceof ClassNotFoundException)
            {
                ErrMesgNo = 28;
                if (alrtlvl == 0)
                   alrtlvl = 2;
            }
            else if (EX instanceof InvalidClassException)
            {
                ErrMesgNo = 29;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof StreamCorruptedException)
            {
                ErrMesgNo = 30;
                if (alrtlvl == 0)
                   alrtlvl = 4;
            }
            else if (EX instanceof OptionalDataException)
            {
                ErrMesgNo = 31;
                if (alrtlvl == 0)
                   alrtlvl = 6;
            }
            else if (EX instanceof UTFDataFormatException)
            {
                ErrMesgNo = 5;
                if (alrtlvl == 0)
                   alrtlvl = 4;
            }
            else if (EX instanceof EOFException)
            {
                ErrMesgNo = 7;
                if (alrtlvl == 0)
                   alrtlvl = 4;
            }
            else if (EX instanceof ClosedChannelException)
            {
                ErrMesgNo = 19;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof OverlappingFileLockException)
            {
                ErrMesgNo = 20;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof NumberFormatException)
            {
                ErrMesgNo = 17;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof IllegalAccessException)
            {
                ErrMesgNo = 45;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof InvocationTargetException)
            {
                ErrMesgNo = 47;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof NoSuchMethodException)
            {
                ErrMesgNo = 49;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof IllegalArgumentException)
            {
                ErrMesgNo = 16;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof ArrayIndexOutOfBoundsException)
            {
                ErrMesgNo = 21;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof NullPointerException)
            {
                ErrMesgNo = 22;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof AddressException)
            {
                ErrMesgNo = 33;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof MessagingException)
            {
                if (st.length >= 4)
                {
                    if (st[3].getMethodName().indexOf("addRecipient") != -1)
                        ErrMesgNo = 34;
                    else if (st[3].getMethodName().indexOf("setSubject") != -1)
                        ErrMesgNo = 35;
                    else if (st[3].getMethodName().indexOf("setFrom") != -1)
                        ErrMesgNo = 36;
                    else if (st[3].getMethodName().indexOf("setContent") != -1)
                        ErrMesgNo = 37;
                    else if (st[3].getMethodName().indexOf("setText") != -1)
                        ErrMesgNo = 38;
                    else if (st[3].getMethodName().indexOf("setDataHandler") != -1)
                        ErrMesgNo = 39;
                    else if (st[3].getMethodName().indexOf("addBodyPart") != -1)
                        ErrMesgNo = 40;
                    else if (st[3].getMethodName().indexOf("setFileName") != -1)
                        ErrMesgNo = 41;
                    else if (st[3].getMethodName().indexOf("connect") != -1)
                        ErrMesgNo = 42;
                    else if (st[3].getMethodName().indexOf("sendMessage") != -1)
                        ErrMesgNo = 43;
                    else if (st[3].getMethodName().indexOf("close") != -1)
                        ErrMesgNo = 44;
                }
                else if (st.length == 0)
                {
                    ErrMesgNo = 0;
                    if (alrtlvl == 0)
                       alrtlvl = 3;
                    verbose = "getStackTrace() returns 0 elements enable JSM" + "\n";
                }
            }
            else if (EX instanceof SecurityException)
            {
                if (st.length >= 4)
                {
                    if (st[3].getMethodName().indexOf("checkRead") != -1)
                        ErrMesgNo = 9;
                    else if (st[3].getMethodName().indexOf("checkWrite") != -1)
                        ErrMesgNo = 10;
                    else if (st[3].getMethodName().indexOf("checkDelete") != -1)
                        ErrMesgNo = 12;
                    else if (st[3].getMethodName().indexOf("checkExec") != -1)
                        ErrMesgNo = 11;
                    else if (st[3].getMethodName().indexOf("checkAccess") != -1)
                        ErrMesgNo = 15;
                    else if (st[3].getMethodName().indexOf("Space") != -1)
                        ErrMesgNo = 14;
                }
                else if (st.length == 0)
                {
                    ErrMesgNo = 0;
                    if (alrtlvl == 0)
                       alrtlvl = 3;
                    verbose = "Thread.currentThread().getStackTrace() returns zero elements enable JSM" + "\n";
                }
            }
            else if (EX instanceof IllegalThreadStateException)
            {
                ErrMesgNo = 23;
                if (alrtlvl == 0)
                    alrtlvl = 6;
            }
        } // if (ex_Exception.length > 0)
        
        // Major Changes on 26th September 2012
        // from here till end of method
        String eol = System.getProperty("line.seperator");  
        
        if (eol == null)
        {
            if (DotingEntry.OPERATINGSYSTEM.indexOf(DotingEntry.WINDOWS) != -1)
                eol = "\r\n";
            else eol = "\n";
        }
        
        String PrintErrorMesg = new String();
        String [] PrintMesg = new String[50];
        PrintMesg[0] = eol; 
        PrintMesg[1] = eol; 
        PrintMesg[2] = "LINE " +  ": " + logerrorno;
        PrintMesg[3] = "DATE NOW:" + new Date().toString();
        PrintMesg[4] =  eol; //1
        PrintMesg[5] =  " ALERTLEVEL:" + AlertLabels[alrtlvl] + ",";
        PrintMesg[6] =  eol; //2
        PrintMesg[7] =  "ERRMESG:" + ErrMesgs[ErrMesgNo];
        PrintMesg[8] =  eol; //3
        PrintMesg[9] =  " CLASS NAME :";
        PrintMesg[10] =  (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE":Thread.currentThread().getStackTrace()[2].getClassName());
        PrintMesg[11] =  "," + "METHOD NAME:";
        PrintMesg[12] =  (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE":Thread.currentThread().getStackTrace()[2].getMethodName());
        PrintMesg[13] =  ",";
        PrintMesg[14] =  eol; //4
        PrintMesg[15] =  "EXCEPTION VALUE : " ;
        PrintMesg[16] =  (EX == null ? "UNAVAILABLE" : EX.toString());
        PrintMesg[17] =  eol; //5
        PrintMesg[18] =  "SOURCE LINE NUMBER :";
        PrintMesg[19] =  (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE":String.valueOf(Thread.currentThread().getStackTrace()[2].getLineNumber()));
        PrintMesg[20] =  "THREADNAME :" + Thread.currentThread().getName() ;
        PrintMesg[21] =  " " +  "THREAD PRIORITY:" + String.valueOf(Thread.currentThread().getPriority());
        PrintMesg[22] =  " THREAD GROUP:";
        PrintMesg[23] =  Thread.currentThread().getThreadGroup().getName();
        PrintMesg[24] =  "SOURCE CODE UNIT :";
        PrintMesg[25] =  (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE" : Thread.currentThread().getStackTrace()[2].getFileName());
        PrintMesg[26] =  eol; //7
        PrintMesg[27] =  "THREAD STATE:";
        PrintMesg[28] =  String.valueOf(Thread.currentThread().getState());
        PrintMesg[29] =  eol; //8
        PrintMesg[30] =  "STACK TRACE:";
        PrintMesg[31] =  (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE" : Thread.currentThread().getStackTrace().length > 3 ?
            Thread.currentThread().getStackTrace()[2].getMethodName() + "," + Thread.currentThread().getStackTrace()[3].getMethodName() : Thread.currentThread().getStackTrace().length == 3
            ? Thread.currentThread().getStackTrace()[2].getMethodName():Thread.currentThread().getStackTrace()[1].getMethodName());
        PrintMesg[32] =  " OPERATING SYSTEM :" + OPERATINGSYSTEM ;
        PrintMesg[33] =  eol ;//9
        PrintMesg[34] =  "LOOK AT SESSION SPECIFIC ERRORLOGFILE NAME FOR DETAILS SUCH AS PID, COUNTRY NAME ";
        PrintMesg[35] =  eol; //12
        PrintMesg[36] =  "SESSION ERRORLOGFILE:" + ErrorLogFile;
        PrintMesg[37] =  eol; //17
        PrintMesg[38] =  " LOCALE LANGUAGE:";
        PrintMesg[39] =  DefaultLocale.getDisplayLanguage();             
        PrintMesg[40] =  eol; //19            
        PrintMesg[41] =  "VERBOSE ERROR MESSAGE FOR DUMMIES GIVEN BELOW MAY BE MISSING IN SOME PLACES :";
        PrintMesg[42] =  eol; //22
        PrintMesg[43] =  verbose == null ? "EXPLANATION:LOOK BELOW FOR SAME LINE NUMBER END VERBOSE": verbose;
        PrintMesg[44] =  eol; //23
        PrintMesg[45] =  "END VERBOSE";
        PrintMesg[46] =  eol; //24
        PrintMesg[47] =  "Print ErrorLog in Landscape mode on A4 plain paper";            
        PrintMesg[48] =  eol; //26  // whatever prescribed format replace with locale ISO Executives Name
        PrintMesg[49] =  "ISO CONTROL DOCUMENT NUMBER PIG/SWINE/PORK/HAM/" ;
            // Basically write a small method that will give you an iso control number and suffix it above
            // You know those iso pest control chaps dont you ??? any time you run out of meat in the
            // freezer for a sandwich you know where to get it !!!

        logerrorno++;
        // To the Above you can add just one line of any extra information that you want to print
        // i need the other lines and i am using them also at some places in the source code.
        // It will be an exact fit on one page.
        
        // Now concatenate all the String constants in PrintMesg
        for (int x = 0 ; x < PrintMesg.length; x++)
            PrintErrorMesg += PrintMesg[x];

        ErrMesgNo = 0;
        GrassHopperLock.release();
        errfile.flush();

        return PrintErrorMesg;
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ErrorLogFile, LiveDB.errfile
 *
 * Method Name : protected static boolean redirectstderr ()
 * Parameters : None
 * Returns : boolean true if stderr sucessfully redirected to LiveDB.ErrorLogFile
 *           boolean false if FileNotFound or Java Security Manager perms issues.
 *
 * Log File : LiveDB.ErrorLogFile
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will redirect stderr to LiveDB.ErrorLogFile
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 25th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean redirectstderr (){

        boolean okay = true;

        // close the previous errfile. Sometimes a prankser may delete the ErrorLogFile
        // and/or this may be a second redirect
        if (errfile != null)
        {
            errfile.close();
        }

        try {
                errfile = new PrintStream (ErrorLogFile);
                System.setErr(errfile);
            }catch (FileNotFoundException ex_NOKIA1){
                System.err.println(grassHopper(ex_NOKIA1));
                JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR THIS SESSION IS : " + ErrorLogFile);
                okay = false;
            }catch (SecurityException ex_NOKIA2){
                System.err.println(grassHopper(ex_NOKIA2, "Security does not permit Log File "
                                                                             + ErrorLogFile));
                JOptionPane.showMessageDialog(dataentryframe, "YOUR LOG FILE FOR THIS SESSION IS : " + ErrorLogFile);
                okay = false;
            }

        errfile.flush();

        return okay;
    }
}
