/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.io.Serializable;
import java.util.Date;
import java.util.Random;
import java.util.concurrent.Semaphore;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.indxinstalledTables, LiveDB.CopyFile, LiveDB.commit_database(), LiveDB.LASTLOCKMETHOD
 * @LOOKSY:LiveDB.CTSR, LiveDB.LiveSharedDB, LiveDB.ALRTLVL, LiveDB.qsort()
 *
 * Class Name : final class ArtLeaves implements Serializable
 *
 * Methods : Look in Class definition
 *
 * The Tables Interface has been faked here except for REFRESH because it is too very dangerous to provide it.
 *
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding.
 *
 * Relevant Indexes : None just one record in this table
 *
 * Data File : YES created by data entry programs
 *
 * @Since Version 1.0
 *
 * Running Commentary : This table lists all company details. The constructor does some
 * usual validations to ensure data compliance.
 *
 * Technical References : Buy and Read Asterix and Obelix all out at Sea.
 * Table Dedicated to : Michael Franks Album : The Art of Tea (Track St Elmo's Fire)
 *
 * Start Date: 18th October 2010
 * End Date: 15th May 2011
 * Last Modification Date : 1st October 2011
 * Last Modifications : Changed access specifier to protected for methods getEmail1(), getEmail2(),
 * getEmail3(), getEmail4(). Added two more methods String getSUpasswd (),
 * void setSUpasswd (String... p_passwd).
 * Also added statements rowlock.acquireUninterruptibly();  and rowlock.release() to all setters
 * SCHEMA CHANGE : Added Field superuserpassword. HACKERS CAN HACK THIS FIELD FOR superuser access.
 * You will receive a noble prize for brilliance if you manage it.
 *
 * Last Modification Date : 8th August 2012
 * Last Modifications : Added a new clone () method
 * 
 * Last Modification Date : 11th September 2012
 * Last Modifications : removed rowlock.acquireUninterruptibly(); and rowlock.release()
 * statements from the clone method because each of the setters will do the above.
 * 
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */


final class ArtLeaves implements Serializable, Cloneable {
    private String compname ; /* Company Name */
    private String addr1 ;
    private String addr2 ;
    private String addr3 ;
    private String addr4 ;
    private String city ;
    private String state ;
    private String country ;
    private String zipcode ;
    private String email1 ; // Mandatory emailid From which all emails will be sent must be gmail id
    private String email2 ; // Mandatory emailid to which LogFiles only will be emailed
    private String email3 ; // Mandatory emailid to which PurchaseOrders only will be emailed
    private String email4; // Mandatory email id notification mailbox telling about email in other mailboxes must be gmail
    private String email5; // Optional email id for Invoicing your customers otherwise notification mailbox used
    private String email6; // Optional email id for Return Material Authorizations otherwise notification mailbox used
    private String email7; // Optional email id for Legal Matters/Disputes/Correspondence otherwise email1
    private String email8; // Optional email id for all other Reports otherwise notification mailbox
    private String email9; // Optional email id for all In-Office Correspondence Personal .... !!! otherwise notification mailbox
    private String email10; // Optional email id for dump files only attachments so make it large otherwise notification mailbox used
    private String email11; // Optional email id for overflow condition in any of above mailboxes otherwise Email1
    private String email12; // Optional email id for Customer Correspondence regular non-Legal type otherwise Email1
    private String email13; // Mandatory email id for CrashRecovery of Business Emails. It is a Backup Mailbox
    private String phone1 ;
    private String phone2 ;
    private String mobile1 ;
    private String mobile2 ;
    private String fax1 ;
    private String fax2 ;
    private String superuserpassword;
    private long rowid; /* 30 FIELDS */

    private transient ArtLeaves art ;
    private transient int an;
    private static Semaphore rowlock;
    static
    {
        rowlock = new Semaphore(1,true);
    }
    {
        an = LiveDB.ar;
    }
       
    public ArtLeaves ()
    {
        compname = addr1 = addr2 = addr3 = addr4 = city = state = country = zipcode =
        email1 = email2 = email3 = email4 = email5 = email6 = email7 = email8 = email9 =
        email10 = email11 = email12 = email13 = phone1 = phone2 = mobile1 = mobile2 =
        fax1 = fax2 = superuserpassword = null;
        rowid = 0;                
    }    
    
    public ArtLeaves (String p_Compname, String p_Addr1, String p_Addr2,
            String p_Addr3, String p_Addr4, String p_City, String p_State,
            String p_Country, String p_Zipcode, String p_Email1,
            String p_Email2, String p_Email3, String p_Email4,
            String p_Email5, String p_Email6, String p_Email7,
            String p_Email8, String p_Email9, String p_Email10,
            String p_Email11, String p_Email12, String p_Email13,
            String p_Phone1,
            String p_Phone2, String p_Mobile1, String p_Mobile2,
            String p_Fax1, String p_Fax2, long p_Rowid)
    {        
        setCompname(p_Compname); 
        setAddr1(p_Addr1);
        setAddr2(p_Addr2);
        setAddr3(p_Addr3);
        setAddr4(p_Addr4);
        setCity(p_City);
        setState(p_State);
        setCountry(p_Country);
        setZipcode(p_Zipcode) ;
        setEmail1(p_Email1); // Mandatory emailid From which all emails will be sent must be gmail id
        setEmail2(p_Email2); // Mandatory emailid to which LogFiles only will be emailed
        setEmail3(p_Email3); // Mandatory emailid to which PurchaseOrders only will be emailed
        setEmail4(p_Email4); // Mandatory email id which is notification mailbox telling you about email in other mailboxes
        setEmail5(p_Email5);
        setEmail6(p_Email6);
        setEmail7(p_Email7);
        setEmail8(p_Email8);
        setEmail9(p_Email9);
        setEmail10(p_Email10);
        setEmail11(p_Email11);
        setEmail12(p_Email12);
        setEmail13(p_Email13);
        setPhone1(p_Phone1);
        setPhone2(p_Phone2);
        setMobile1(p_Mobile1);
        setMobile2(p_Mobile2);
        setFax1(p_Fax1);
        setFax2(p_Fax2);

        rowlock.acquireUninterruptibly();
        superuserpassword = "superuser"; // initial setting it will automatically reset the password
        if (p_Rowid == 0) // there can only be one row for now later subsidiaries can also be registered
            rowid = p_Rowid;
        else
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Rowid must be zero"));
            System.exit(1);
        }
        rowlock.release();
    }
    
    // Added this clone method on 8th August 2012
    @Override
    protected Object clone (){
        
        try{
            art = (ArtLeaves)super.clone();
            art.setCompname(art.getCompname());
            art.setAddr1(art.getAddr1());
            art.setAddr2(art.getAddr2());
            art.setAddr3(art.getAddr3());
            art.setAddr4(art.getAddr4());
            art.setCity(art.getCity());
            art.setState(art.getState());
            art.setCountry(art.getCountry());
            art.setZipcode(art.getZipcode());
            art.setEmail1(art.getEmail1());
            art.setEmail2(art.getEmail2());
            art.setEmail3(art.getEmail3());
            art.setEmail4(art.getEmail4());
            art.setEmail5(art.getEmail5());
            art.setEmail6(art.getEmail6());
            art.setEmail7(art.getEmail7());
            art.setEmail8(art.getEmail8());
            art.setEmail9(art.getEmail9());
            art.setEmail10(art.getEmail10());
            art.setEmail1(art.getEmail1());
            art.setEmail12(art.getEmail12());
            art.setEmail13(art.getEmail13());
            art.setPhone1(art.getPhone1());
            art.setPhone2(art.getPhone2());
            art.setMobile1(art.getMobile1());
            art.setMobile2(art.getMobile2());
            art.setFax1(art.getFax1());
            art.setFax2(art.getFax2());
            art.setSUpasswd(art.getSUpasswd());
            
        }catch (CloneNotSupportedException ex_NOKIA61){
            throw new InternalError (ex_NOKIA61.toString());
        }
        
        return art;
    }
    
    public String getCompname(){
        return new String(compname.toCharArray());
    }
    public String getAddr1(){
        return new String(addr1.toCharArray());
    }
    public String getAddr2(){
        return new String(addr2.toCharArray());
    }
    public String getAddr3(){
        return new String(addr3.toCharArray());
    }
    public String getAddr4(){
        return new String(addr4.toCharArray());
    }
    public String getCity(){
        return new String(city.toCharArray());
    }
    public String getState(){
        return new String(state.toCharArray());
    }
    public String getCountry() {
        return new String(country.toCharArray());
    }
    public String getZipcode() {
        return new String(zipcode.toCharArray());
    }
    protected String getEmail1(){
        return (email1 == null ? null : email1.equals("") ? "" : new String(email1.toCharArray()));
    }
    protected String getEmail2(){
        return (email2 == null ? null : email2.equals("") ? "" : new String(email2.toCharArray()));
    }
    protected String getEmail3(){
        return (email3 == null ? null : email3.equals("") ? "" : new String(email3.toCharArray()));
    }
    protected String getEmail4(){
        return (email4 == null ? null : email4.equals("") ? "" : new String(email4.toCharArray()));
    }
    public String getEmail5(){
        return (email5 == null ? null : email5.equals("") ? "" : new String(email5.toCharArray()));
    }
    public String getEmail6(){
        return (email6 == null ? null : email6.equals("") ? "" : new String(email6.toCharArray()));
    }
    public String getEmail7(){
        return (email7 == null ? null : email7.equals("") ? "" : new String(email7.toCharArray()));
    }
    public String getEmail8(){
        return (email8 == null ? null : email8.equals("") ? "" : new String(email8.toCharArray()));
    }
    public String getEmail9(){
        return (email9 == null ? null : email9.equals("") ? "" : new String(email9.toCharArray()));    
    }
    public String getEmail10(){
        return (email10 == null ? null : email10.equals("") ? "" : new String(email10.toCharArray()));
    }
    public String getEmail11(){
        return (email11 == null ? null : email11.equals("") ? "" : new String(email11.toCharArray()));
    }
    public String getEmail12(){
        return (email12 == null ? null : email12.equals("") ? "" : new String(email12.toCharArray()));
    }
    public String getEmail13(){
        // there is a difference between the null literal and null string. the null string will
        // return a length zero and also wont throw a null pointer exception. Also if you check
        // reference == null for a reference with a null string it will return false !
        return (email13 == null ? null : email13.equals("") ? "" : new String(email13.toCharArray()));        
    }
    public String getPhone1(){
        return new String(phone1.toCharArray());
    }
    public String getPhone2(){
        return new String(phone2.toCharArray());
    }
    public String getMobile1(){
        return new String(mobile1.toCharArray());
    }
    public String getMobile2() {
        return new String(mobile2.toCharArray());
    }
    public String getFax1(){
        return new String(fax1.toCharArray());
    }
    public String getFax2(){
        return new String (fax2.toCharArray());
    }
    String getSUpasswd (){
        return new String(superuserpassword.toCharArray());
    }
    public long getRowid(){
        return rowid;
    }

    @Override
    public String toString(){

        String filher = "%";

        return getCompname().concat(filher).concat(getAddr1()).concat(filher)
               .concat(getAddr2()).concat(filher).concat(getAddr3())
               .concat(filher).concat(getAddr4()).concat(filher).concat(getCity())
               .concat(filher).concat(getState()).concat(filher).concat(getCountry())
               .concat(filher).concat(getZipcode()).concat(filher)
               .concat(getEmail1()).concat(filher).concat(getEmail2())
               .concat(filher).concat(getEmail3()).concat(filher).concat(getEmail4()).concat(filher)
               .concat(getEmail5()).concat(filher).concat(getEmail6()).concat(filher).concat(getEmail7())
               .concat(filher).concat(getEmail8()).concat(filher).concat(getEmail9()).concat(filher)
               .concat(getEmail10()).concat(filher).concat(getEmail11()).concat(filher).concat(getEmail12())
               .concat(filher).concat(getEmail13()).concat(filher).concat(getPhone1())
               .concat(filher).concat(getPhone2()).concat(filher)
               .concat(getMobile1()).concat(filher).concat(getMobile2()).concat(filher)
               .concat(getFax1()).concat(filher).concat(getFax2()).concat(filher)
               .concat(String.valueOf(getRowid()));
    }

    void setPhone1(String p_phone){
     rowlock.acquireUninterruptibly();
     if (p_phone == null || p_phone.length() < 5)
      {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Phone1:" + p_phone));
            System.exit(1);
      }else phone1 = new String(p_phone.toCharArray());
             rowlock.release();
    }

    void setPhone2(String p_phone){
     rowlock.acquireUninterruptibly();
     if (p_phone == null || p_phone.length() < 5)
      {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Phone2:" + p_phone));
            System.exit(1);
      }else phone2 = new String(p_phone.toCharArray());
             rowlock.release();
    }

    void setFax1(String p_phone){
     rowlock.acquireUninterruptibly();
     if (p_phone == null || p_phone.length() < 5)
      {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Fax1:" + p_phone));
            System.exit(1);
      }else fax1 = new String(p_phone.toCharArray());
             rowlock.release();
    }

    void setFax2(String p_phone){
     rowlock.acquireUninterruptibly();
     if (p_phone == null || p_phone.length() < 5)
      {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Fax2:" + p_phone));
            System.exit(1);
      }else fax2 = new String(p_phone.toCharArray());
             rowlock.release();
    }

    void setMobile1(String p_phone){
     rowlock.acquireUninterruptibly();
     if (p_phone == null || p_phone.length() < 9)
      {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Mobile1:" + p_phone));
            System.exit(1);
      }else mobile1 = new String(p_phone.toCharArray());
             rowlock.release();
    }

    void setMobile2(String p_phone){
     rowlock.acquireUninterruptibly();
     if (p_phone == null || p_phone.length() < 5)
      {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Mobile2:" + p_phone));
            System.exit(1);
      }else mobile2 = new String(p_phone.toCharArray());
             rowlock.release();
    }

    void setCompname(String p_company){
      rowlock.acquireUninterruptibly();
      if (p_company == null || p_company.length() < 4)
      {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Address1:" + p_company));
            System.exit(1);
      }else compname = new String(p_company.toCharArray());
              rowlock.release();
    }

    void setAddr1(String p_Addr1){
       rowlock.acquireUninterruptibly();
       if (p_Addr1 == null || p_Addr1.length() < 2)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Address1:" + p_Addr1));
            System.exit(1);
        }else addr1 = new String(p_Addr1.toCharArray());
               rowlock.release();
    }

    void setAddr2(String p_Addr2){
       rowlock.acquireUninterruptibly();
       if (p_Addr2 == null || p_Addr2.length() < 2)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Address2:" + p_Addr2));
            System.exit(1);
        }else addr2 = new String(p_Addr2.toCharArray());
               rowlock.release();
    }

    void setAddr3(String p_Addr3){
       rowlock.acquireUninterruptibly();
       if (p_Addr3 == null || getAddr2().length() < 4 ? p_Addr3.length() < 10: p_Addr3.length() < 5)
       {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Address3:" + p_Addr3));
            System.exit(1);
       }else addr3 = new String(p_Addr3.toCharArray());
       rowlock.release();
    }

    void setAddr4(String p_Addr4){
       rowlock.acquireUninterruptibly();
       if (p_Addr4 == null)
       {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Address4:" + p_Addr4));
            System.exit(1);
       }else addr4 = new String(p_Addr4.toCharArray());
       rowlock.release();
    }

    void setCity(String p_city){
       rowlock.acquireUninterruptibly();
       if (p_city == null || p_city.length() < 4)
       {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid City:" + p_city));
            System.exit(1);
       }else city = new String(p_city.toCharArray());
       rowlock.release();
    }

    void setState(String p_state){
        rowlock.acquireUninterruptibly();
        if (p_state == null || p_state.length() < 2)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid State:" + p_state));
            System.exit(1);
        }else state = new String(p_state.toCharArray());
        rowlock.release();
    }
    
    void setCountry(String p_country){
        rowlock.acquireUninterruptibly();
        if (p_country == null || p_country.length() < 4)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Country:" + p_country));
            System.exit(1);
        }else
        {
            // check further // Balls to it no user interaction here so chalega
            country = new String (p_country.toCharArray());
        }
        rowlock.release();
    }

    void setZipcode(String p_zip){
        rowlock.acquireUninterruptibly();
        if (p_zip == null || p_zip.length() < 5)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Zip:" + p_zip));
            System.exit(1);
        }
        else zipcode = new String(p_zip.toCharArray());
        rowlock.release();
    }

    // VIEW ALL THESE MAILBOXES AS BUSINESS-ACCOUNTING MAIIL BOXES FOR AUDITING PURPOSES
    // IT WOULD BE NICE IF YOU COULD TEST AND FILL OUT VALID EMAILID'S FOR ALL 13 MAILBOXES
    // DO WRITE DOWN ALL THIRTEEN PASSWORDS ON A SEPERATE SHEET OF PAPER
    
    void setEmail1(String p_email){
       // Mandatory emailid From which all emails will be sent must be gmail id
       // first four email ids send test email to verify email id
/*
       protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
       String p_sendTo, String p_copyTo, String p_Bcc, String p_subject, String p_text,
       String p_attach) throws javax.mail.NoSuchProviderException
 */

        rowlock.acquireUninterruptibly();
        if (p_email != null)
        {
            if (p_email.indexOf("gmail") == -1)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id Specified. Must be a gmail id"));
                System.exit(1);
            }
            
            
            if (LiveDB.PrepareAndSendMailMesg(p_email, null, p_email, p_email, p_email, 
                    "Indian Assets Service has lot more money than Indian Asses Service",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email1 Specified. Must be a gmail id"));
                System.exit(1);
            }else email1 = new String(p_email.toCharArray());
        }
        else
        {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Email Id email1 Mandatory Must be a gmail id"));
                System.exit(1);
        }
        rowlock.release();
    }

    void setEmail2(String p_email){
       // first four email ids send test email to verify email id
        // Mandatory emailid to which LogFiles only will be emailed
        rowlock.acquireUninterruptibly();
        if (p_email != null)
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, p_email, p_email, 
                    "Indian store money in suit-cases preffered over swiss banks",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email2 Specified"));
                System.exit(1);
            }else email2 = new String(p_email.toCharArray());
        }
        else
        {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Email Id email2 Mandatory. Can be any email id"));
                System.exit(1);
        }
        rowlock.release();
    }

    void setEmail3(String p_email){
       // first four email ids send test email to verify email id
        // Mandatory emailid to which PurchaseOrders only will be emailed
        rowlock.acquireUninterruptibly();
        if (p_email != null)
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, p_email, p_email, 
                    "Indians have stacks of money at home more than the assets of swiss banks",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email3 Specified"));
                System.exit(1);
            }else email3 = new String(p_email.toCharArray());
        }
        else
        {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Email Id email3 Mandatory. Can be any email id"));
                System.exit(1);
        }
        rowlock.release();
    }

    void setEmail4(String p_email){
        // THIS IS THE NOTIFICATION MAILBOX
       // first four email ids send test email to verify email id

        // Mandatory email id which is notification mailbox telling you about email in other mailboxes
        rowlock.acquireUninterruptibly();
        if (p_email != null)
        {
            if (p_email.indexOf("gmail") == -1)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id Specified. Must be a gmail id"));
                System.exit(1);
            }

            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, p_email, p_email, 
                    "Indians are poor little rich boys like Richie Rich",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email4 Specified Must be a gmail id"));
                System.exit(1);
            }
            else email4 = new String(p_email.toCharArray());
        }
        else
        {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Email Id email4 Mandatory Must be a gmail id"));
                System.exit(1);
        }
        rowlock.release();
    }

    void setEmail13(String p_email){
        // first four email ids send test email to verify email id
        // Also this one for Backups
        // Mandatory emailid to which All Backups will be emailed for MailBox CrashRecovery
        // you can set a forwarder within this mailbox yourself for yet another level of backup
        // need not be a gmail id but MAKE IT LARGE !!
        rowlock.acquireUninterruptibly();
        if (p_email != null)
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, p_email, p_email,
                    "Kidnap Indian Bride or her jewellery ? She doesent need clothes !!",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email13 Specified"));
                System.exit(1);
            }else email13 = new String(p_email.toCharArray());
        }
        else
        {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Email Id email13 Mandatory. Can be any email id"));
                System.exit(1);
        }
        rowlock.release();
    }
    
    void setEmail5(String p_email){
        // Optional Email id
        // Optional email id for Invoicing your customers otherwise notification mailbox used
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email5 = new String (getEmail4().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, p_email, p_email, 
                    "Indians Buy Aston Martins and pour Martinis into the tank",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email5 Specified Setting to email4:" + getEmail4()));
                email5 = new String (getEmail4().toCharArray());
            }else email5 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setEmail6(String p_email){
        // Optional Email id
        // Optional email id for Return Material Authorizations otherwise notification mailbox used
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email6 = new String (getEmail4().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, p_email, p_email, 
                    "The car market in India is just short of mount everest",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email6 Specified Setting to email4:" + getEmail4()));
                email6 = new String (getEmail4().toCharArray());
            }else email6 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setEmail7(String p_email){
        // Optional Email id
        // Optional email id for Legal Matters/Disputes/Correspondence otherwise email1 used
        
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email7 = new String (getEmail1().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email + ";" + getEmail1(),
                    getEmail3() + "," + getEmail2(), getEmail4() + "," + getEmail3(), 
                    "The Big Bikes market in India is Insufficient for one Sholavaram",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email7 Specified Setting to email1:" + getEmail1()));
                email7 = new String (getEmail1().toCharArray());
            }else email7 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setEmail8(String p_email){
        // Optional Email id
        // Optional email id for all other Reports otherwise notification mailbox
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email8 = new String (getEmail4().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, p_email, p_email,
                    "Indian Women are Stinking Rich Just Zatak her",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email8 Specified Setting to email4:" + getEmail4()));
                email8 = new String (getEmail4().toCharArray());
            }else email8 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setEmail9(String p_email){
        // Optional Email id
       // Optional email id for all In-Office Correspondence Personal .... !!! otherwise notification mailbox
       // your personal secretaries mailbox prettypolly???@domain ?? three numbers maybe you are blessed with plenty
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email9 = new String (getEmail4().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email + ";" + getEmail1(),
                    getEmail3() + "," + getEmail2(), getEmail4() + "," + getEmail3(), 
                    "Indian Beggars die with 900,000 under their sacks",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email9 Specified Setting to email4:" + getEmail4()));
                email9 = new String (getEmail4().toCharArray());
            }else email9 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setEmail10(String p_email){
        // Optional Email id
        // Optional email id for dump files only attachments so make it large otherwise notification mailbox used
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email10 = new String (getEmail4().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email, getEmail1(), getEmail2(), 
                    "India hosted the first Corruption Wealth Games",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email10 Specified Setting to email4:" + getEmail4()));
                email10 = new String (getEmail4().toCharArray());
            }else email10 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setEmail11(String p_email){
        // Optional Email id
        // Optional email id for overflow condition in any of above mailboxes otherwise Email1
        // Also a special mailbox for Celebs and Royals to write in
        // Set to your personal email id preferably
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email11 = new String (getEmail1().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email + ";" + getEmail1(),
                    getEmail3() + "," + getEmail2(), getEmail4() + "," + getEmail3(), 
                    "To get a clean chit in India fly to Argentina and back",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email11 Specified Setting to email1:" + getEmail1()));
                email11 = new String (getEmail1().toCharArray());
            }else email11 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setEmail12(String p_email){
        // Optional Email id Customer Service
        // Optional email id for Customer Correspondence regular non-Legal type otherwise Email1
        // set to your second personal email id preferably
        // Otherwise i will need to check this mailbox for new messages and send you a notificaiton
        // email. No time I will do it in next release each line of code is adding to work
        rowlock.acquireUninterruptibly();
        if (p_email == null)
            email12 = new String (getEmail1().toCharArray());
        else
        {
            if (LiveDB.PrepareAndSendMailMesg(getEmail1(), null, p_email + ";" + getEmail1(),
                    getEmail3() + "," + getEmail2(), getEmail4() + "," + getEmail3(), 
                    "Indians have no taste buds for Yachts and Bacardi Blasts",
                    "This is a test email for emailid " + p_email, LiveDB.ErrorLogFile) == false)
            {
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper("Invalid Email Id email12 Specified Setting to email1:" + getEmail1()));
                email12 = new String (getEmail1().toCharArray());
            }else email12 = new String(p_email.toCharArray());
        }
        rowlock.release();
    }

    void setSUpasswd (String... p_passwd){
        long logno = 0L;
        char ch = 'A';
        int ii = new Random().nextInt(22);

        ch += ii;

        rowlock.acquireUninterruptibly();
        if (getSUpasswd().equals("superuser") || p_passwd.length == 0)
        {
           superuserpassword = ch + new Random().nextDouble() + "P" ;
           if (LiveDB.SendNotificationEmail("SUPER USER PASSWORD AUTO GENERATED ON"
                   + new Date().toString() + " " + superuserpassword) == false)
           {
               System.err.println(LiveDB.grassHopper("Eror Email SuperUserPasswd to Email:"
                       + getEmail4()));
               LiveDB.system_exit = 1;
               //LiveDB.SmoothExitCondition.signalAll();
           }
        }
        else if (p_passwd.length != 0)
        {
            superuserpassword = p_passwd[0];
            if (LiveDB.SendNotificationEmail("SUPER USER PASSWORD RESET ON"
                   + new Date().toString() + " " + superuserpassword) == false)
           {
               System.err.println(LiveDB.grassHopper("Eror Email SuperUserPasswd to Email:"
                       + getEmail4()));
               LiveDB.system_exit = 1;
               //LiveDB.SmoothExitCondition.signalAll();
           }
        }
        rowlock.release();
    }

    public final boolean COMMIT(){
        return true;
    }

    public final boolean COMMITINDEXES (){
        return true;
    }

    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(an) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
}
