/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.awt.BorderLayout;
import javax.swing.JButton;
import java.awt.Color;
import java.awt.Font;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Iterator;
import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import javax.swing.JLabel;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JPanel;
import static MaintainData.FirstPage.pageonetextpanel;
import static MaintainData.FirstPage.latestprodspanel;
import static MaintainData.FirstPage.infopanel;
import static MaintainData.FirstPage.cartpanel;
import static MaintainData.FirstPage.featuredpanel;
import static MaintainData.FirstPage.popularpanel;
import static MaintainData.FirstPage.cataloguepanel;
import static MaintainData.LiveDB.pd;
import static MaintainData.FirstPage.convertCurrency;
import static MaintainData.CurrencyPanel.Symbol;
import java.util.Arrays;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : CataloguePage
 *
 * @LOOKSY : PictureDatabase.java
 * @LOOKSY : TopPaneListener.java
 *
 * @LOOKSY : LensView.DEFAULT_HEIGHT, LiveDB.appframe, LiveDB.LiveSharedDB, LiveDB.ALRTLVL
 * @LOOKSY : LiveDB.serializedfilespath, FirstPage.pageonetextpanel, FirstPage.latestprodspanel
 * @LOOKSY : FirstPage.cartpanel, FirstPage.infopanel, FirstPage.featuredpanel, FirstPage.infopanel
 * @LOOKSY : FirstPage.catalogueitemspanel, LiveDB.indx3languageTransalations
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct a CataloguePage for the Chosen
 * Catalogue from TopPaneListener registered at CataloguePanel.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * Last Modifications Date : 9th August 2012
 * Last Modifications : Marked as 9th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : Marked as 17th August 2012
 * Also search for LiveDB.USEFONT. I have setFont to use this font name all thru the source code.
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class CataloguePage
{
    protected static JPanel catalogueitemspanel = null;
    GridBagConstraints constraints = null;
    int pages = 0;
    // removed final specifier for page[] 9th Aug 2012 
    Integer page [] = null;
    int frompic = 0;
    int topic = 0;
    // removed final specifier 9th Aug 2012
    String piccode [] = null;
    String picpath [] = null;
    String narrativesfile [] = null;
    String pictitles [] = null;
    float picdiscounts [] = null;
    float picprices [] = null;
    Integer pageno = 1;
    int MAXPICS = 6; // maximum pictures per page to be displayed
    String p_category;

    // removed final access specifier 9th August 2012
    JLabel pt [] = null;
    JButton [] buy = null;
    JButton [] more  = null;
    JPanel [] picpaintpanel = null;
    JLabel nl [] = null;
    JLabel picprice [] = null;
    JLabel picdisc [] = null;
    JLabel catname = new JLabel (p_category);
    JLabel prodin = new JLabel ("Products in:/");

    JLabel totpages = null;
    // removed final access specifier 8th Aug 2012
    JLabel pgs [] = null;
    JLabel img = new JLabel ("Image");
    JLabel desc = new JLabel ("Description");
    JLabel price = new JLabel ("Price");
    JPanel header = new JPanel (new GridBagLayout());
    
    Object thispicpage [] = new Object[3]  ; // 17th August 2012

    public CataloguePage (String p_catalogue)
    {
        int MF = 10;
        int H = 0;

        H = (int)(pageonetextpanel.BOTTOM_ALIGNMENT - pageonetextpanel.TOP_ALIGNMENT) * MF
                + (int) (latestprodspanel.BOTTOM_ALIGNMENT - latestprodspanel.TOP_ALIGNMENT) * MF;

        // just remove two panels and add the saleitemspanel
        // you are done with the SaleItemsPage
        LiveDB.appframe.remove(pageonetextpanel);
        LiveDB.appframe.remove(latestprodspanel);
        catalogueitemspanel = new JPanel (new GridBagLayout ());
        p_category = p_catalogue;
        getpicturedetails ();
        addpanel();
        
        LiveDB.appframe.add(catalogueitemspanel, setConstraints((int)(infopanel.RIGHT_ALIGNMENT * MF)+ 1,
            (int)(cartpanel.TOP_ALIGNMENT * MF),
            ((int)(featuredpanel.LEFT_ALIGNMENT) * MF -1) - ((int)(cartpanel.RIGHT_ALIGNMENT) * MF + 1), H));
    }

    void getpicturedetails ()
    {
        String unavailable = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                                                                           + "unavailable.txt";
        String file = null;
        String keyval = null;

        for (int rw = 0; rw < LiveDB.LiveSharedDB[pd].length; rw++)
        {
            if (((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_category()
                    .equalsIgnoreCase(p_category))
            {
               // growing Array here ... Code added 9th August 2012 
               piccode = piccode == null ? new String [1] : Arrays.copyOf(piccode, piccode.length + 1); 
               piccode[piccode.length - 1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic().toString();
               picpath = picpath == null ? new String[1] : Arrays.copyOf(picpath, picpath.length + 1);
               // growing Array here ... Code added 9th August 2012 
               picpath[picpath.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_img_location().toString();
               // growing Array here ... Code added 9th August 2012 
               pictitles = pictitles == null ? new String[1] : Arrays.copyOf(pictitles, pictitles.length + 1);
               pictitles [pictitles.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_title().toString();
               // growing Array here ... Code added 9th August 2012 
               picprices = picprices == null ? new float [1] : Arrays.copyOf(picprices, picprices.length + 1);
               picprices [picprices.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_price();
               // growing Array here ... Code added 9th August 2012 
               picdiscounts = picdiscounts == null ? new float[1] : Arrays.copyOf(picdiscounts, picdiscounts.length + 1);
               picdiscounts [picdiscounts.length -1] = picprices [picprices.length -1] -
                                        ((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_discount();
               keyval =  FirstPage.chosenlang + piccode[piccode.length - 1] + "JNarrative";
               file = LiveDB.indx3languageTransalations.get(keyval);
               // growing Array here ... Code added 9th August 2012 
               narrativesfile = narrativesfile == null ? new String [1] : 
                       Arrays.copyOf(narrativesfile, narrativesfile.length + 1);
               narrativesfile[narrativesfile.length -1] = file == null ? unavailable.toString():file.toString();
            }
        }
    }

    void addpanel()
    {
        ImageReader reader = null;
        Iterator<ImageReader> iter = null;
        ImageInputStream ImageIn = null;
        Image image = null;
        int infoflags = 0;
        File fl = null;
        FileReader fr = null;
        BufferedReader br = null;
                
        int MF = 10;        
        String line = null;
        int MAXCHARS = 71;        

        pages = piccode.length/MAXPICS + 1; // +1 always one extra page
        
        // okay found everything now start drawing images
        // draw at best five images at random
        
        prodin.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 10));
        prodin.setForeground(Color.BLACK);
        catname.setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 12));
        catname.setForeground(Color.BLACK);

        addpageheader(pageno);

        catalogueitemspanel.add(prodin, setConstraints(0,0,2,1));
        catalogueitemspanel.add(catname, setConstraints(3,0,2,1));

        int Y = (int)prodin.BOTTOM_ALIGNMENT * MF + 4;
        int X = (int)(cartpanel.RIGHT_ALIGNMENT * MF) + 1;
        final Integer I [] = null;
        boolean potrait  = false;

        for (int i = frompic, W = 0, H = 0; i <= topic && i < piccode.length; i++)
        {
            I[I.length] = i;

            try{
                image = ImageIO.read(new File(picpath[i]));
            }catch (IOException ex_YESKIA9){
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Image File:" + picpath[i]));
                continue;
            }

            try{
              ImageIn = ImageIO.createImageInputStream(new File(picpath[i]));
            }catch (IOException ex_YESKIA98){
                System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" + picpath[i]));
                continue;
            }

            iter = ImageIO.getImageReadersBySuffix("jpg");
            reader = iter.next();
            reader.setInput(ImageIn);

            try{
                W = reader.getWidth(0);
                H = reader.getHeight(0);
            }catch (IndexOutOfBoundsException ex_NOKIA8){
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper(ex_NOKIA8));
                continue;
            }catch (IOException ex_NOKIA66){
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper(ex_NOKIA66));
                continue;
            }

            if (W <= H)
                potrait = true;
            else if (H < W)
                potrait = false;

            fl = new File (narrativesfile[i]);
            try{
            fr = new FileReader (fl);
            }catch (FileNotFoundException ex_YESKIA9){
                System.err.println(LiveDB.grassHopper(ex_YESKIA9, "File:" + narrativesfile[i]));
                continue;
            }
            br = new BufferedReader (fr);

            try{
                if ((line = br.readLine()) == null)
                {
                    System.err.println(LiveDB.grassHopper("Insufficient characters in file:"
                                                             + narrativesfile[i]));
                    continue;
                }
            }catch (IOException ex_YESKIA7){
                System.err.println(LiveDB.grassHopper(ex_YESKIA7,"File:" + narrativesfile[i]));
                continue;
            }

            line = line.substring(0, line.length() >= MAXCHARS ? MAXCHARS : line.length());

            try{
               br.close();
            }catch (IOException ex_YESKIA11){
               System.err.println(LiveDB.grassHopper(ex_YESKIA11, "File:" + narrativesfile[i]));
               continue;
            }

            // paint on this panel and then attach this panel to catalogueitemspanel
            // otherwise removeall () on catalogueitemspanel will not remove the DrawImage
            // since the image drawn alone is not a component. removeall () removes only
            // components

            // grow the array 9th Aug 2012
            picpaintpanel = picpaintpanel == null ? new JPanel [1] :
                    Arrays.copyOf(picpaintpanel, picpaintpanel.length + 1);
            picpaintpanel[picpaintpanel.length -1] = new JPanel (new BorderLayout());
            picpaintpanel[picpaintpanel.length -1].setBounds(X, Y, W, H);
            FirstPage.DrawImage(picpath[i], picpaintpanel[picpaintpanel.length -1], 0, 0, 0, 0, potrait);
            picpaintpanel[picpaintpanel.length -1].addMouseListener(new MouseListener (){
                @Override
                public void mousePressed (MouseEvent evnt){}
                @Override
                public void mouseEntered (MouseEvent evnt){}
                @Override
                public void mouseClicked (MouseEvent evnt){
                    new PicturePage (piccode[I[I.length - 1]]);
                }
                @Override
                public void mouseExited (MouseEvent evnt){}
                @Override
                public void mouseReleased (MouseEvent evnt){}
            });

            catalogueitemspanel.add(picpaintpanel[picpaintpanel.length -1], setConstraints(X,Y,W,H));
            
            // growing Array here ... Code added 9th August 2012 
            pt = pt == null ? new JLabel [1] : Arrays.copyOf(pt, pt.length + 1);
            pt[pt.length -1] = new JLabel (pictitles[i]);
            pt[pt.length -1].setFont (new Font(LiveDB.USEFONT, Font.BOLD, 12 ));
            pt[pt.length  -1].setForeground(Color.BLUE);
            catalogueitemspanel.add(pt[pt.length -1], setConstraints( X, Y, 3, 1));
            // grow the array 8th Aug 2012
            nl = nl == null ? new JLabel [1] : Arrays.copyOf(nl, nl.length + 1);
            nl[nl.length -1] = new JLabel (line + "...");
            nl[nl.length -1].setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 10));
            nl[nl.length -1].setForeground(Color.BLACK);
            // grow the array 8th Aug 2012
            picdisc = picdisc == null ? new JLabel [1] : Arrays.copyOf(picdisc, picdisc.length + 1);
            picdisc[picdisc.length -1] = new JLabel (Symbol + convertCurrency(picdiscounts[i]));
            picdisc[picdisc.length -1].setFont (new Font(LiveDB.USEFONT, Font.BOLD, 10));
            picdisc[picdisc.length -1].setForeground(Color.RED);
            // grow the array 8thAug 2012
            picprice = picprice == null ? new JLabel [1] : Arrays.copyOf(picprice, picprice.length + 1);
            picprice[picprice.length -1] = new JLabel (Symbol + convertCurrency(picprices[i]));
            picprice[picprice.length -1].setFont(new Font (LiveDB.USEFONT, picdiscounts[i] != 0 ? Font.CENTER_BASELINE:Font.BOLD, 9));
            picprice[picprice.length -1].setForeground(Color.BLACK);
            catalogueitemspanel.add(nl[nl.length -1], setConstraints (X+7, Y+1, MAXCHARS/5, 1));
            catalogueitemspanel.add(picprice[picprice.length -1], 
                    setConstraints((int)(featuredpanel.LEFT_ALIGNMENT * MF) - (int)(cartpanel.RIGHT_ALIGNMENT * MF)/7,Y, 1, 1));
            catalogueitemspanel.add(picdisc[picdisc.length -1], 
                    setConstraints((int)(featuredpanel.LEFT_ALIGNMENT * MF) - (int)(cartpanel.RIGHT_ALIGNMENT * MF)/7,Y +1, 1, 1));

            pt[pt.length -1].addMouseListener(new MouseListener (){
                @Override
                public void mousePressed (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.RED);
                    pt[pt.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.BLUE);
                    pt[pt.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt){
                    thispicpage[0] = new PicturePage (piccode[I[I.length - 1]]); // 17th August 2012
                }
                @Override
                public void mouseEntered (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.RED);
                    pt[pt.length -1].validate();
                }
                @Override
                public void mouseExited (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.BLUE);
                    pt[pt.length -1].validate();
                }
            });

            // grow the array 9th Aug 2012
            buy = buy == null ? new JButton [1] : Arrays.copyOf(buy, buy.length + 1);
            buy[buy.length -1] = new JButton ("Buy");
            // grow the array 8th Aug 2012
            more = more == null ? new JButton [1] : Arrays.copyOf(more, more.length + 1);
            more[more.length -1] = new JButton ("More");
            buy[buy.length -1].setFont(new Font (LiveDB.USEFONT, Font.PLAIN, 9));
            more [more.length -1].setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 9));
            buy[buy.length -1].setBackground(Color.BLUE);
            more[more.length -1].setBackground(Color.BLUE);
            buy[buy.length -1].addMouseListener(new MouseListener (){

                @Override
                public void mousePressed (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.RED);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseEntered (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.RED);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.BLUE);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseExited (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.BLUE);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt){
                    // 17th August 2012
                    thispicpage [1] = new PicturePage (piccode [I[I.length - 1]]);
                }
            });

            more[more.length -1].addMouseListener(new MouseListener (){
                @Override
                public void mousePressed (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.RED);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseEntered (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.RED);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.BLUE);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseExited (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.BLUE);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt){
                    // 17th August 2012
                    thispicpage [2] = new PicturePage (piccode [I[I.length - 1]]);
                }
            });

            catalogueitemspanel.add(buy[buy.length -1], 
                    setConstraints ((int)(featuredpanel.LEFT_ALIGNMENT * MF) - (int)(cartpanel.RIGHT_ALIGNMENT * MF)/7 + 1,
                                                    Y, 1, 1));
            catalogueitemspanel.add(more[more.length -1], 
                    setConstraints ((int)(featuredpanel.LEFT_ALIGNMENT * MF) - (int)(cartpanel.RIGHT_ALIGNMENT * MF)/7 + 2,
                                                    Y + 1, 1, 1));
            Y = potrait == false ? Y + 5:Y + 7;
        }
    }

    void addpageheader (Integer p_page)
    {
        int MF = 10;
        int X = (int)(featuredpanel.LEFT_ALIGNMENT * MF) - (int)(cartpanel.RIGHT_ALIGNMENT * MF)/2;
        int Y = (int)(cataloguepanel.BOTTOM_ALIGNMENT * MF) + 4;


        header.setSize((int)(popularpanel.LEFT_ALIGNMENT - 1 - cartpanel.RIGHT_ALIGNMENT + 1) * MF, 2);
        header.setBackground(Color.DARK_GRAY);
        img.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        img.setForeground(Color.BLUE);
        desc.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        desc.setForeground(Color.BLUE);
        price.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        price.setForeground(Color.BLUE);
        header.add(img, setConstraints(0,0,2,1));
        header.add(desc, setConstraints((int)(header.RIGHT_ALIGNMENT * MF)/2,0,2,1));
        header.add(price, setConstraints((int)(header.RIGHT_ALIGNMENT * MF)/8,0,2,1));

        totpages = new JLabel (pages + "pages ");
        totpages.setForeground(Color.BLACK);
        
        catalogueitemspanel.removeAll();
        catalogueitemspanel.add(totpages, setConstraints (X, Y, 2, 1));
        X = X + 2;
        
        for ( int i = 1; i <= pages ; i++)
        {
            // grow the array 9th Aug 2012
            pgs = pgs == null ? new JLabel [1] : Arrays.copyOf(pgs, pgs.length + 1);
            pgs[pgs.length -1] = new JLabel ("[" + i + "]");
            pgs[pgs.length -1].setForeground(Color.BLACK);
            
            if (i != p_page)
            {
                pgs[pgs.length -1].setForeground(Color.BLUE);
                pgs[pgs.length -1].addMouseListener(new MouseListener()
                {
                     @Override
                     public void mousePressed (MouseEvent evnt)
                     {
                         pgs[pgs.length -1].setForeground(Color.RED);
                     }

                     @Override
                     public void mouseReleased (MouseEvent evnt)
                     {
                         pgs[pgs.length -1].setForeground(Color.BLUE);
                     }

                     @Override
                     public void mouseClicked (MouseEvent evnt)
                     {
                         // Added this array grow on 9th August 2012. 
                         // otherwise null pointer exception during run time
                         page = page == null ? new Integer[1] : Arrays.copyOf(page, page.length + 1);
                         page [page.length -1] = Integer.parseInt(pgs[pgs.length -1].getText()
                             .substring(pgs[pgs.length -1].getText().indexOf("[") + 1,
                             pgs[pgs.length -1].getText().indexOf("]")));
                         pageno = page [page.length -1];
                         frompic = page [page.length -1] * piccode.length/pages;
                         topic = frompic + MAXPICS -1;
                         addpanel();
                     }

                     @Override
                     public void mouseEntered (MouseEvent evnt)
                     {
                         pgs[pgs.length -1].setForeground(Color.RED);
                     }

                     @Override
                     public void mouseExited (MouseEvent evnt)
                     {
                         pgs[pgs.length -1].setForeground(Color.BLUE);
                     }
                });                               
            }
            
            catalogueitemspanel.add(pgs[pgs.length -1], setConstraints (X,Y,1,1));
            X++;
        }
        
        catalogueitemspanel.add(header, setConstraints(0, (int)(img.BOTTOM_ALIGNMENT * MF) + 1,
           (int) ((popularpanel.LEFT_ALIGNMENT * MF - 1) - ((cartpanel.RIGHT_ALIGNMENT * MF) + 1)), 2));
        
        header.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
