/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import java.awt.event.KeyEvent;
import java.util.HashMap;
import javax.swing.JTabbedPane;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static MaintainData.FirstPage.cataloguepanel;
import static MaintainData.LiveDB.pd;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : CataloguePanel
 *
 * @LOOKSY : PictureDatabase.java
 *
 * @LOOKSY : LensView.DEFAULT_HEIGHT, LiveDB.appframe, LiveDB.LiveSharedDB
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct top Tabbed Pane that has tabs
 * for Home Page and each of the catalogues/categories in PictureDatabase such as 'Expressions',
 * 'Coorg Pavillion'.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class CataloguePanel
{
    protected static JTabbedPane toppane;
    protected static String [] catnames = null;

    public CataloguePanel ()
    {
        int MF = 10;
        cataloguepanel = new JPanel();
        cataloguepanel.setBackground(Color.BLUE);
        cataloguepanel.setBorder(BorderFactory.createEtchedBorder(Color.BLUE, Color.BLACK));
        cataloguepanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.registerpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF),
                (int)(LensView.DEFAULT_HEIGHT)/25);
        
        addcataloguepanel();
    }

    void addcataloguepanel()
    {
        int ti = 0; // tab index for toppane
        
        HashMap <String, String> kats = new HashMap<String, String>(32);

        for (int i = 0; i < LiveDB.LiveSharedDB[pd].length; i++)
        {
            kats.put(((PictureDatabase)LiveDB.LiveSharedDB[pd][i]).getPic_category(),
                                      ((PictureDatabase)LiveDB.LiveSharedDB[pd][i]).getPic());
        }

        catnames = (String [])kats.keySet().toArray();

        toppane = new JTabbedPane ();
        toppane.addTab("Home Page", null);

        if ((ti = toppane.indexOfTab("Home Page")) != -1)
            toppane.setMnemonicAt(ti, KeyEvent.VK_H);
        
        toppane.addTab("Sale Items", null);
        if ((ti = toppane.indexOfTab("Sale Items")) != -1)
             toppane.setMnemonicAt(ti, KeyEvent.VK_S);

        for (int i = 0; i < catnames.length; i++)
        {
             toppane.addTab(catnames[i], null);
        }

        toppane.addChangeListener(new TopPaneListener());
        toppane.setForeground(Color.WHITE);
        
        if (catnames.length > 16) // this user is a miserable ....
            toppane.setTabLayoutPolicy(JTabbedPane.WRAP_TAB_LAYOUT);
        else
            toppane.setTabLayoutPolicy(JTabbedPane.SCROLL_TAB_LAYOUT);
    }
}
