/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;


import javax.swing.JOptionPane;
import java.io.EOFException;
import java.io.Externalizable;
import java.io.File;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.util.Date;
import java.util.concurrent.Semaphore;
import static MaintainData.LiveDB.ft;
import static MaintainData.LiveDB.it;
import static MaintainData.LiveDB.cr;
import static MaintainData.LiveDB.sc;
import static MaintainData.LiveDB.ls;
import static MaintainData.LiveDB.pd;
import static MaintainData.LiveDB.pc;
import static MaintainData.LiveDB.crr;
import static MaintainData.LiveDB.ar;
import static MaintainData.LiveDB.rt;
import static MaintainData.LiveDB.po;
import static MaintainData.LiveDB.ltr;
import static MaintainData.LiveDB.da;
import static MaintainData.LiveDB.sd;
import static MaintainData.LiveDB.pt;
import static MaintainData.LiveDB.lt;
import static MaintainData.LiveDB.clt;
// caution dont import MaintainData.LiveDB.ct;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:Spy.java method ForYourEyesOnly () -- Take a look at the in-source documentation for clarity on flags
 * @LOOKSY:WriteTables.java  --- Take a Quick Look
 * @LOOKSY:InstalledTables.java  --- Take a Quick Look
 * @LOOKSY:FileTableDataFileMap.java  --- Take a Quick Look
 * @LOOKSY:CustomerRegister.java  --- Take a Quick Look
 * @LOOKSY:ShoppingCart.java  --- Take a Quick Look
 * @LOOKSY:LanguageSupport.java    -- Optional
 * @LOOKSY:LanguageTitles.java    -- Optional
 * @LOOKSY:LanguageTransalations.java    -- Optional
 * @LOOKSY:PaymentType.java    -- Optional
 * @LOOKSY:PictureDatabase.java  --- Take a Quick Look
 * @LOOKSY:PictureOptions.java    -- Optional
 * @LOOKSY:SearchDatabase.java    -- Optional
 * @LOOKSY:DefaultAdvertisingImages.java    -- Optional
 * @LOOKSY:ArtLeaves.java    -- Optional
 * @LOOKSY:ReportsTable.java  --- Take a Quick Look
 * @LOOKSY:CrashRecovery.java  --- Take a Quick Look
 * @LOOKSY:CelebrityTable.java    -- Optional
 * @LOOKSY:PlatformClearance.java  --- Take a Quick Look
 * @LOOKSY:ArtLeavesInterfaces.java  --- Take a Quick Look
 * @LOOKSY:RefreshDatabase.read_database()  --- Take a Quick Look
 * @LOOKSY:LiveDB.indxinstalledTables, LiveDB.CopyFile, LiveDB.commit_database(), LiveDB.write_IndexFile()
 * @LOOKSY:LiveDB.CTSR, LiveDB.LiveSharedDB, LiveDB.ALRTLVL
 *
 * Class Name : ChangeTracker implements Externalizable, Tables, Cloneable
 *
 * Methods : Look in Class definition
 * There are two constructors here one is without parameters to help simulate a refresh in fsck
 * The other Constructor method public ChangeTracker (long p_Tableno, long p_Rowid, char p_Change_flag,
 * long p_Pid, Date p_Dmldate, Object p_row, long p_ctrowid) does a thorough validation before accepting
 * data. If data is non-compliant it does System.exit(1) rather than LiveDB.SmoothExitCondition.signalAll()
 * because the object has already been created the constructor is only filling in values into the instance.
 * 
 * The Tables Interface has been faked except COMMIT, COMMITINDEXES, REFRESH because I dont want you doing
 * naughty things with this table.
 *
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding.
 *
 * Relevant Indexes : LiveDB.indxchangeTracker -- Is there a ChangeTracker entry for a given tableno and rowid ?
 * searchkey = toString(AnyRealTableno) + toString(AnyRowid)
 * searchkey returns Long ctrowid which is the rowid for the ChangeTracker table.
 * This is a dual purpose index and so
 * searchkey = toString(AnyRealTableNo) -- Is there an entry for this tableno in ChangeTracker ?
 * searchkey returns Long the same tableno (Look at UpdateIndexes () below)
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This table is your saviour (start praying). Even if you have lost everything
 * including your wife as long as this saviour is present miracles will happen. Even a corrupted form
 * of the saviour will suffice to bring the database up but how long it will stand before collapsing
 * is a question mark. The first constructor as already explained is not meant for lesser mortals.
 * Second constructor is a heavy duty toughie that goes thru extensive validations as below. If you
 * look at the FastCommit code in WriteTables.java there is a special full stop entry to prevent the
 * growth of this table. If you ask me the other name for this table Absolutlifabulous !! Okay here
 * goes the explanation for this constructor. First ascertain the installation date for p_Tableno
 * from InstalledTables. Then check if p_Dmldate is after install date if the table is one of those
 * SerializeJustOnce tables. Then you switch p_Tableno and validate if Object p_row is an instance of
 * that table number. If it is an instance of that table number then you set the Rowid and also call
 * LiveDB.prepareCrashRecovery () to prepare the row for the CrashRecovery table and finally you set
 * the entire row, Update all relevant indexes at the end. Now LiveDB.prepareCrashRecovery () will
 * not be called for SerializeJustOnceTables. The ChangeTracker can only contain LiveDB.REALTABLES
 * not those fake ones from eighteen onwards.
 *
 * Technical References : Buy and Read Asterix the Gaul.
 *
 * Start Date: 18th October 2010
 * End Date: 16th May 2011
 *
 * Last Modification Date : 26th May 2012
 * Last Modifications : I just added a couple of clones in this method to quick fix a programming
 * screwup by immature programmers still drinking mama's milk.
 * Look at method protected void setEntirerow (Object p_obj)
 * and the inline comments in there.
 *
 * Last Modification Date : 3rd June 2012
 * Last Modifications : Made changes to protected void setRowid(long p_Rowid) to check for negative
 * parameter p_Rowid
 * Also changed access specifier in default constructor without params to protected from public
 * Also changed some hardcodings in the initialization blocks ctn = LiveDB.ct, itn = LiveDB.it
 *
 * Last Modification Date : 14th Augustus 2012
 * Last Modification : I have added this call to LiveDB.growMore(ctn) whereever I am growing
 * the LiveDB.LiveSharedDB array with a call to new.
 * 
 * Last Modification Date : 11th September 2012
 * Last Modifications : removed rowlock.acquireUninterruptibly(); and rowlock.release()
 * statements from the clone method because each of the setters will do the above.
 * 
 * Last Modification Date : 21st September 2012
 * Last Modifications : Marked as 21st September 2012
 * 
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class ChangeTracker implements Externalizable, Tables, Cloneable {
    private long tableno ; /* table number which has changed */
    private long rowid; /* altered rowid of that table that has changed */
    private char change_flag ; /* 'U' or 'I' or 'D' or 'R' or 'F' or 'J' (RollForward) or K (Database RollBack)
                                * or T (Database Reconstruct) or 'C' (Slow Commit)
                                * meaning Update or Insert or Delete or RollBack operation */
    private char oldchangeflag ; // whenever you set the change_flag it takes a backup usefull for reconstruct
    private long pid; /* which jvm instance not process id of O/S but our own internal process id you can also use O/S pid */
    private Date dmldate; // the date/time on which this table Change happened.
    private Object entirerow; // keep this for database reconstruction
    private long ctrowid; // change tracker rowid
    /* 8 FIELDS */
    private static final long serialVersionUID = 99998L;
    
    private transient long fieldchanges; // we will use this field in next release for an Ultra Fast Commit
    private transient int ctn;
    private transient int itn;
    private transient File srf;
    private transient ChangeTracker ct;
    private transient Semaphore rowlock;
    
    {        
       fieldchanges = 0L;
       ctn = LiveDB.ct;
       itn = LiveDB.it;
       srf = null;
       ct = null;
       rowlock = new Semaphore(2, true);
    }

    public ChangeTracker (){

        tableno = 0;
        rowid = 0;
        change_flag = ' ';
        oldchangeflag = ' ';
        pid = 0;
        dmldate = null;
        entirerow = null;
        ctrowid = 0;
    }

    public ChangeTracker (long p_Tableno, long p_Rowid, char p_Change_flag, long p_Pid, 
            Date p_Dmldate, Object p_row, long p_ctrowid) 
    {
            // THIS IS A HEAVY DUTY CONSTRUCTOR NOTHING MUST GO WRONG WITH THIS ONE TABLE OR
            // ANY KIND OF RECONSTRUCT/RECOVERY OF DATABASE IMPOSSIBLE.
                                
            rowlock.acquireUninterruptibly();
            
            // 13th September 2012
            if (p_Tableno >= 0 && p_Tableno <= LiveDB.REALTABLES)
            {
                tableno = p_Tableno;
            }            
            
            rowlock.release();
            
            setChange_flag(p_Change_flag);
            setOldchangeflag(p_Change_flag);
            setPid(p_Pid);
            
            setDmldate(p_Dmldate);
            setCtrowid(p_ctrowid);
            
            switch ((int)p_Tableno){
                case ft:
                    if (p_row instanceof FileTableDataFileMap)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        
                        if (LiveDB.command_line.equals("") == false)
                        {
                            
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof FileTableDataFileMap not allowed"));
                                System.exit(1);
                            }
                        }

                        
                        LiveDB.prepareCrashRecovery(p_Tableno, p_Rowid,
                        String.valueOf(((FileTableDataFileMap)p_row).getTableno()),
                        ((FileTableDataFileMap)p_row).getDatafilename(),
                        ((FileTableDataFileMap)p_row).getFilename(),
                        ((FileTableDataFileMap)p_row).getTable_identifier_name(),
                        ((FileTableDataFileMap)p_row).getClassname(),
                        ((FileTableDataFileMap)p_row).getTable_lock(),
                        String.valueOf(((FileTableDataFileMap)p_row).getPid()),
                        String.valueOf(((FileTableDataFileMap)p_row).getRowid()));
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof FileTableDataFileMap"));
                        System.exit(1);
                    }
                    setEntirerow ((FileTableDataFileMap)p_row);
                    break;
                case LiveDB.ct:
                    if (p_row instanceof ChangeTracker)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof ChangeTracker not allowed"));
                                System.exit(1);
                            }
                        }

                        
                        LiveDB.prepareCrashRecovery(p_Tableno, p_Rowid,
                        String.valueOf(((ChangeTracker)p_row).getTableno()),
                        String.valueOf(((ChangeTracker)p_row).getRowid()),
                        String.valueOf(((ChangeTracker)p_row).getChange_flag()),
                        String.valueOf(((ChangeTracker)p_row).getOldchangeflag()),
                        String.valueOf(((ChangeTracker)p_row).getPid()),
                        ((ChangeTracker)p_row).getDmldate().toString(),
                        // this is a bit dicey EntireRow may have to be dissected into Strings
                        // this should be okay i need to be carefull while dissecting this darn thing
                        ((ChangeTracker)p_row).getEntirerow().toString(),
                        String.valueOf(((ChangeTracker)p_row).getCtrowid()));
                        
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof ChangeTracker"));
                        System.exit(1);
                    }
                    setEntirerow ((ChangeTracker)p_row);
                    break;
                case cr:
                    if (p_row instanceof CustomerRegister)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("DeLeTe") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("RoLlBaCk") == false
                                && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof CustomerRegister not allowed"));
                                System.exit(1);
                            }
                        }

                        LiveDB.prepareCrashRecovery(p_Tableno, p_Rowid,
                        String.valueOf(((CustomerRegister)p_row).getCid()),
                        ((CustomerRegister)p_row).getCustname(),
                        ((CustomerRegister)p_row).getCustbirthdate().toString(),
                        ((CustomerRegister)p_row).getCustbirthcity(),
                        ((CustomerRegister)p_row).getCustbirthstate(),
                        ((CustomerRegister)p_row).getCustbirthnation(),
                        String.valueOf(((CustomerRegister)p_row).getCustsex()),
                        ((CustomerRegister)p_row).getCustmaritalstatus(),
                        ((CustomerRegister)p_row).getCustlogintime().toString(),
                        ((CustomerRegister)p_row).getCustlogouttime().toString(),
                        ((CustomerRegister)p_row).getCustregisterdate().toString(),
                        ((CustomerRegister)p_row).getCustaddr1(),
                        ((CustomerRegister)p_row).getCustaddr2(),
                        String.valueOf(((CustomerRegister)p_row).getCustaddr3()),
                        ((CustomerRegister)p_row).getCustaddr4(),
                        ((CustomerRegister)p_row).getLandmark(),
                        ((CustomerRegister)p_row).getCustcity(),
                        ((CustomerRegister)p_row).getCustnation(),
                        ((CustomerRegister)p_row).getCustzip(),
                        ((CustomerRegister)p_row).getCustemail(),
                        ((CustomerRegister)p_row).getCustphone(),
                        ((CustomerRegister)p_row).getCustfax(),
                        String.valueOf(((CustomerRegister)p_row).getCustflag()),
                        ((CustomerRegister)p_row).getCustlastdate().toString(),
                        String.valueOf(((CustomerRegister)p_row).getRowid()));
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof CustomerRegister"));
                        System.exit(1);
                    }
                    setEntirerow ((CustomerRegister)p_row);
                    break;
                case sc:
                    if (p_row instanceof ShoppingCart)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("DeLeTe") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("RoLlBaCk") == false
                                && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof ShoppingCart not allowed"));
                                System.exit(1);
                            }
                        }

                        LiveDB.prepareCrashRecovery(p_Tableno, p_Rowid,
                        ((ShoppingCart)p_row).getCid(),
                        ((ShoppingCart)p_row).getPic(),
                        ((ShoppingCart)p_row).getPonumber(),                        
                        ((ShoppingCart)p_row).getSub_opt_id(),
                        String.valueOf(((ShoppingCart)p_row).getPmtid()),
                        String.valueOf(((ShoppingCart)p_row).getPic_qty()),
                        String.valueOf(((ShoppingCart)p_row).getTotal()),
                        String.valueOf(((ShoppingCart)p_row).getBilled()),
                        ((ShoppingCart)p_row).getShopdate().toString(),
                        String.valueOf(((ShoppingCart)p_row).getOrdernumber()),
                        String.valueOf(((ShoppingCart)p_row).getOrderdiscount()),
                        String.valueOf(((ShoppingCart)p_row).getRma()),
                        String.valueOf(((ShoppingCart)p_row).getRefund()),
                        String.valueOf(((ShoppingCart)p_row).getRowid()));
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof ShoppingCart"));
                        System.exit(1);
                    }
                    setEntirerow ((ShoppingCart)p_row);
                    break;
                case ls:
                    if (p_row instanceof LanguageSupport)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }
                        
                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof LanguageSupport not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof LanguageSupport"));
                        System.exit(1);
                    }
                    setEntirerow ((LanguageSupport)p_row);
                    break;
                case lt:
                    if (p_row instanceof LanguageTitles)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof LanguageTitles not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof LanguageTitles"));
                        System.exit(1);
                    }
                    setEntirerow ((LanguageTitles)p_row);
                    break;
                case ltr:
                    if (p_row instanceof LanguageTransalations)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof LanguageTransalations not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof LanguageTransalations"));
                        System.exit(1);
                    }
                    setEntirerow ((LanguageTransalations)p_row);
                    break;
                case pt:
                    if (p_row instanceof PaymentType)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof PaymentType not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof PaymentType"));
                        System.exit(1);
                    }
                    setEntirerow ((PaymentType)p_row);
                    break;
                case pd:
                    if (p_row instanceof PictureDatabase)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false
                                && LiveDB.command_line.equals("DeLeTe") == false
                                && LiveDB.command_line.equals("NewPictureAdditions") == false
                                && LiveDB.command_line.equals("OldPictureDeletions") == false
                                && LiveDB.command_line.equals("PictureUpdates") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof PictureDatabase not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof PictureDatabase"));
                        System.exit(1);
                    }
                    setEntirerow ((PictureDatabase)p_row);
                    break;
                case po:
                    if (p_row instanceof PictureOptions)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof PictureOptions not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof PictureOptions"));
                        System.exit(1);
                    }
                    setEntirerow ((PictureOptions)p_row);
                    break;
                case sd:
                    if (p_row instanceof SearchDatabase)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof SearchDatabase not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof SearchDatabase"));
                        System.exit(1);
                    }
                    setEntirerow ((SearchDatabase)p_row);
                    break;
                case da:
                    if (p_row instanceof DefaultAdvertisingImages)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof DefaultAdvertisingImages not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof DefaultAdvertisingImages"));
                        System.exit(1);
                    }
                    setEntirerow ((DefaultAdvertisingImages)p_row);
                    break;
                case ar:
                    if (p_row instanceof ArtLeaves)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof ArtLeaves not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof ArtLeaves"));
                        System.exit(1);
                    }
                    setEntirerow ((ArtLeaves)p_row);
                    break;
                case crr:
                    // Dont call prepareCrashRecovery here it will go into a loop and hang
                    if (p_row instanceof CrashRecovery)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof CrashRecovery not allowed"));
                                System.exit(1);
                            }
                        }
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof CrashRecovery"));
                        System.exit(1);
                    }
                    setEntirerow ((CrashRecovery)p_row);
                    break;
                case it:
                    if (p_row instanceof InstalledTables)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false
                                && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof InstalledTables not allowed"));
                                System.exit(1);
                            }
                        }
                        
                        Date at,mt,it = null;
                        
                        at = ((InstalledTables)p_row).getAccesstime();
                        mt = ((InstalledTables)p_row).getModifiedtime();
                        it = ((InstalledTables)p_row).getInstalltime();
                        
                        LiveDB.prepareCrashRecovery(p_Tableno, p_Rowid,
                        String.valueOf(((InstalledTables)p_row).getTableno()),
                        at == null ? "" : at.toString(),
                        mt == null ? "" : mt.toString(),
                        it == null ? "" : it.toString(),
                        ((InstalledTables)p_row).getWhichlocale(),
                        ((InstalledTables)p_row).getIsocharset(),
                        String.valueOf(((InstalledTables)p_row).getInitialsize()),
                        String.valueOf(((InstalledTables)p_row).getRowid()));
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof InstalledTables"));
                        System.exit(1);
                    }
                    setEntirerow ((InstalledTables)p_row);
                    break;
                case rt:
                    if (p_row instanceof ReportsTable)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false
                                && LiveDB.command_line.equals("DeLeTe") == false
                                && LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") == false)
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof ReportsTable not allowed"));
                                System.exit(1);
                            }
                        }

                        LiveDB.prepareCrashRecovery(p_Tableno, p_Rowid,
                        String.valueOf(((ReportsTable)p_row).getDocumentno()),
                        String.valueOf(((ReportsTable)p_row).getId()),
                        ((ReportsTable)p_row).getDoctype(),
                        ((ReportsTable)p_row).getPathname(),
                        String.valueOf(((ReportsTable)p_row).getSize()),
                        ((ReportsTable)p_row).getReportdate().toString(),
                        String.valueOf(((ReportsTable)p_row).getStatus()),
                        String.valueOf(((ReportsTable)p_row).getByteswritten()),
                        String.valueOf(((ReportsTable)p_row).getPid()),
                        String.valueOf(((ReportsTable)p_row).getRowid()));
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof ReportsTable"));
                        System.exit(1);
                    }
                    setEntirerow ((ReportsTable)p_row);
                    break;
                case clt:
                    if (p_row instanceof CelebrityTable)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false)
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof CelebrityTable not allowed"));
                                System.exit(1);
                            }
                        }
                        // curretnly this is a SerializeJustOnce table if later it is not then you
                        // need to add a call to LiveDB.PrepareCrashRecovery here
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof CelebrityTable"));
                        System.exit(1);
                    }
                    setEntirerow ((CelebrityTable)p_row);
                    break;
                case pc:
                    if (p_row instanceof PlatformClearance)
                    {
                        if (p_Rowid >= 0 && p_Rowid < LiveDB.LiveSharedDB[(int)p_Tableno].length)
                            setRowid(p_Rowid);
                        else
                        {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Invalid Rowid " + p_Rowid));
                            System.exit(1);
                        }

                        if (LiveDB.command_line.equals("") == false )
                        {
                            if (LiveDB.command_line.equals("FileTableDataFileMap") == false
                                && LiveDB.command_line.equals("ArChIvE") == false
                                && LiveDB.command_line.equals("DeLeTe") == false
                                && LiveDB.command_line.equals("ReCoNsTrUcT") == false )
                            {
                                LiveDB.ALRTLVL = 7;
                                System.err.println(LiveDB.grassHopper("p_row instanceof PlatformClearance not allowed"));
                                System.exit(1);
                            }
                        }
                        
                        LiveDB.prepareCrashRecovery(p_Tableno, p_Rowid,
                        String.valueOf(((PlatformClearance)p_row).getRequestno()),
                        String.valueOf(((PlatformClearance)p_row).getSid()),
                        String.valueOf(((PlatformClearance)p_row).getRequest_type()),
                        ((PlatformClearance)p_row).getRequest_time().toString(),
                        String.valueOf(((PlatformClearance)p_row).getTrainid().getTrain()),
                        String.valueOf(((PlatformClearance)p_row).getTrainid().getTrack()),
                        String.valueOf(((PlatformClearance)p_row).getTrainid().getITrack()),
                        ((PlatformClearance)p_row).getTrainid().getTrackname(),
                        ((PlatformClearance)p_row).getTrainid().getLine(),
                        ((PlatformClearance)p_row).getTrainid().getDeparturetime() == null ? "":
                                ((PlatformClearance)p_row).getTrainid().getDeparturetime().toString(),
                        ((PlatformClearance)p_row).getTrainid().getArrivaltime() == null ? "":
                                ((PlatformClearance)p_row).getTrainid().getArrivaltime().toString(),
                        ((PlatformClearance)p_row).getTrainid().getArrivaltime() == null ? ""
                                :((PlatformClearance)p_row).getTrainid().getArrivaltime().toString(),
                        // this was commented out for some strange reason
                        ((PlatformClearance)p_row).getTrainid().getAccident() == null ? ""
                                :((PlatformClearance)p_row).getTrainid().getAccident().toString(),
                        String.valueOf(((PlatformClearance)p_row).getTrainid().getRunningtime()),
                        String.valueOf(((PlatformClearance)p_row).getRowid()));
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Invalid Args:p_row not instanceof PlatformClearance"));
                        System.exit(1);
                    }
                    setEntirerow ((PlatformClearance)p_row);
                    break;
                default:
                  LiveDB.ALRTLVL = 7;
                  System.err.println(LiveDB.grassHopper("Invalid Args:case default"));
	          JOptionPane.showMessageDialog(LiveDB.appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                  System.exit(1);
                  break;
            }
                        
            UpdateIndexes ();
    }

    private void UpdateIndexes (){
        String searchkey = null;
        Long value = 0L;

             if (this.getChange_flag() == 'D')
                 return; // no need to update index

             switch((int)this.getTableno()){
                 case ft:
                   searchkey = Integer.toString((int)((FileTableDataFileMap)getEntirerow()).getTableno());
                   if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                   {
                        value = ((FileTableDataFileMap)getEntirerow()).getRowid();
                        LiveDB.indxfileTableDataFileMap.put(searchkey,value);
                   }
                   else if (this.getChange_flag() == 'D')
                   {
                       value = LiveDB.indxfileTableDataFileMap.remove(searchkey);
                   }
                   break;
                 case LiveDB.ct:
                   searchkey = Integer.toString((int)((ChangeTracker)getEntirerow()).getTableno())
                                + Long.toString(((ChangeTracker)getEntirerow()).getRowid());                   
                   /* do a put into the HashMap */
                   if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                   {
                       value = getCtrowid(); /* take the rowid of ChangeTracker table */
                       LiveDB.indxchangeTracker.put(searchkey,value);
                   }
                   else if (this.getChange_flag() == 'D')
                        value = LiveDB.indxchangeTracker.remove(searchkey);
                   // this is a dual purpose index
                   // you can search for a tableno OR what is above in searchkey
                   // prefereably define those HashMaps as <String>, <Long> to be used as multiple
                   // purpose indexes such as this .. you can use it for n different purposes but
                   // overdoing it is fraught with danger
                   searchkey = Integer.toString((int)tableno);
                   if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                   {
                       value = tableno ;
                       LiveDB.indxchangeTracker.put(searchkey,value);
                   }
                   else if (this.getChange_flag() == 'D')
                        value = LiveDB.indxchangeTracker.remove(searchkey);
                   break;
                 case cr:
                   searchkey = ((CustomerRegister)getEntirerow()).getCid();
                   if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                   {
                        value = ((CustomerRegister)getEntirerow()).getRowid();
                        LiveDB.indxcustomerRegister.put(searchkey,value);
                   }
                   else if (this.getChange_flag() == 'D')
                        value = LiveDB.indxcustomerRegister.remove(searchkey);

                   break;
                 case sc:
                    searchkey = ((ShoppingCart)getEntirerow()).getCid()
                            + ((ShoppingCart)getEntirerow()).getPic()                     
                            + ((ShoppingCart)getEntirerow()).getSub_opt_id();
                    value = (long)((ShoppingCart)getEntirerow()).getRowid(); /* take the rowid */
                    if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                    {
                       /* do a put into the HashMap */
                       LiveDB.indx1shoppingCart.put(searchkey,value);
                    }
                    else if (this.getChange_flag() == 'D')
                         value = LiveDB.indx1shoppingCart.remove(searchkey);
                    /* Build a second index just to identify unique cid's in shopping cart duplicates will be overwritten */
                    // for example here you could have used a single dual purpose index but i am making it two for clarity
                    if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                    {
                        LiveDB.indx2shoppingCart.put(((ShoppingCart)getEntirerow()).getCid(), value);
                    }
                    else if (this.getChange_flag() == 'D')
                         value = LiveDB.indx2shoppingCart.remove(((ShoppingCart)getEntirerow()).getCid());
                    break;
                 case crr:
                    for (int k = 0; k < ((CrashRecovery)getEntirerow()).getValues().length; k++ )
                        searchkey += new String("|".toCharArray()) + ((CrashRecovery)getEntirerow()).getValues()[k];
                    searchkey += new String("|".toCharArray()); // add one more at end
                    if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                    {
                        LiveDB.indxcrashRecovery.put(((CrashRecovery)getEntirerow()).getTableno(),
                                     Long.toString(((CrashRecovery)getEntirerow()).getRowid()) + searchkey);
                    }
                    else if (this.getChange_flag() == 'D')
                         LiveDB.indxcrashRecovery.remove(((CrashRecovery)getEntirerow()).getTableno());
                    break;
                 case it:
                    searchkey = Integer.toString((int)(((InstalledTables)getEntirerow()).getTableno()));                    
                    /* do a put into the HashMap */
                    if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                    {
                        value = (long)((InstalledTables)getEntirerow()).getRowid();
                        LiveDB.indxinstalledTables.put(searchkey,value);
                    }
                    else if (this.getChange_flag() == 'D')
                        LiveDB.indxinstalledTables.remove(searchkey);
                    break;
                 case rt:
                    searchkey = Integer.toString((int)(((ReportsTable)getEntirerow()).getDocumentno()));
                    if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                    {
                        value = (long)((ReportsTable)getEntirerow()).getRowid(); /* take the rowid */
                        /* do a put into the HashMap */
                        LiveDB.indxreportsTable.put(searchkey,value);
                    }
                    else if (this.getChange_flag() == 'D')
                        LiveDB.indxreportsTable.remove(searchkey);
                    break;
                 case pc:  // index will be usefull create elsewhere also
                    if (this.getChange_flag() == 'U' || this.getChange_flag() == 'I')
                    {
                        LiveDB.indxplatformClearance.put(((PlatformClearance)getEntirerow()).getRequest_time().getTime(),
                                                           ((PlatformClearance)getEntirerow()).getRowid());
                        
                        LiveDB.indx1platformClearance.put(Integer.toString(((PlatformClearance)getEntirerow())
                            .getRequestno()) + Long.toString(((PlatformClearance)getEntirerow()).getSid()),
                                                           ((PlatformClearance)getEntirerow()).getRowid());
                    }
                    else if (this.getChange_flag() == 'D')
                    {
                         LiveDB.indxplatformClearance.remove(((PlatformClearance)getEntirerow()).getRequest_time());
                         LiveDB.indx1platformClearance.remove(Integer.toString(((PlatformClearance)getEntirerow())
                            .getRequestno()) + Long.toString(((PlatformClearance)getEntirerow()).getSid()));
                    }
                    break;
                 default:
                    break;
             }
    }

    @Override
    protected Object clone(){
        int tbl = 0;
        try{
            ct = (ChangeTracker)super.clone();
            ct.setDmldate(ct.getDmldate());
            ct.setEntirerow(ct.getEntirerow());
            // 13th September 2012            
        }catch (CloneNotSupportedException ex_NOKIA71){
            throw new InternalError (ex_NOKIA71.toString());
        }
        
        return ct;
    }

    // The ChangeTracker table can contain three levels of madness at Best which may appear to be four !!
    // 1. There is a ChangeTracker row for a table other than ChangeTracker so EntireRow will contain an
    //    instance of that other table row.
    // 2. There is a ChangeTracker row for the ChangeTracker table itself so EntireRow will contain an
    //    instance of ChangeTracker. This will happen when you update (set) the ChangeTracker row itself
    // 3. The above (2.) scenario will contain another ChangeTracker instance which will contain an
    //    instance of some table other than ChangeTracker or yet another instance of ChangeTracker.
    // So therefore to help dissect this madness I have four filher characters although we wont need
    // anything more than "~". If that misherable .... does several ChangeTracker updates for some silly
    // reason KILL HIM.
    // Read the Dogumentation for LiveDB.createValidInstance for an example to see clearly.

    @Override
    public String toString(){
        String filher = "%";

        // this is to figure out recursive calls. This ChangeTracker table is a major pain for the Ass
        if (Thread.currentThread().getStackTrace()[1].getMethodName().indexOf("toString") != -1
           && Thread.currentThread().getStackTrace()[2].getMethodName().indexOf("toString") != -1
           && Thread.currentThread().getStackTrace()[3].getMethodName().indexOf("toString") != -1)
        {
            LiveDB.ALRTLVL = 5;
            System.err.println(LiveDB.grassHopper("Miserable... where you learn programming ? Club n successive sets on ChangeTracker to one"));
            filher = "^";    // nah you dont havta keep running around the tree beyond this point
        }
        
        if (Thread.currentThread().getStackTrace()[1].getMethodName().indexOf("toString") != -1
           && Thread.currentThread().getStackTrace()[2].getMethodName().indexOf("toString") != -1 )
            filher = "~";

        if (Thread.currentThread().getStackTrace()[1].getMethodName().indexOf("toString") != -1)
            filher = "#";

        return String.valueOf(getTableno()).concat(filher).concat(String.valueOf(getRowid())).concat(filher)
        .concat(String.valueOf(getChange_flag())).concat(filher).concat(String.valueOf(getOldchangeflag ()))
        .concat(filher).concat(String.valueOf(getPid ())).concat(filher).concat(String.valueOf(getDmldate().getTime()))
        .concat(filher).concat(getEntirerow().toString()).concat(filher).concat(String.valueOf(getCtrowid()));
    }

    protected int SIZEOF(){
        int er = 0;        
        
        Object erw = getEntirerow();

        if (erw instanceof ShoppingCart)
            er = ((ShoppingCart)erw).SIZEOF();
        else if (erw instanceof CustomerRegister)
            er = ((CustomerRegister)erw).SIZEOF();
        else if (erw instanceof ReportsTable)
            er = ((ReportsTable)erw).SIZEOF();
        else if (erw instanceof InstalledTables)
            er = ((InstalledTables)erw).SIZEOF();
        else if (erw instanceof PlatformClearance)
            er = ((PlatformClearance)erw).SIZEOF();
        else if (erw instanceof ChangeTracker)
            er = ((ChangeTracker)erw).SIZEOF();
        else if (erw instanceof FileTableDataFileMap)
            er = ((FileTableDataFileMap)erw).SIZEOF();
        else if (erw instanceof CrashRecovery)
            er = ((CrashRecovery)erw).SIZEOF();

        return (8 + 8 + 2 + 2 + 8 + 8 + er + 8);
    }
    protected long getTableno(){
        return tableno;
    }
    protected long getRowid(){
        return rowid;   // this is the altered rowid of other table not this
    }
    protected char getChange_flag(){
        return change_flag;
    }
    protected char getOldchangeflag (){
        return oldchangeflag;
    }
    protected long getPid(){
        return pid;
    }
    protected Date getDmldate(){
       return new Date(dmldate.getTime()); // keep this date for a purge
    }
    
    protected long getCtrowid(){
        return ctrowid;   // this is the  rowid of ct table
    }
    
    protected Object getEntirerow (){
        
        if (entirerow instanceof ShoppingCart)
            return ((ShoppingCart)entirerow).clone();
        else if (entirerow instanceof PictureDatabase)
            return ((PictureDatabase)entirerow).clone();
        else if (entirerow instanceof CustomerRegister)
            return ((CustomerRegister)entirerow).clone();
        else if (entirerow instanceof ReportsTable)
            return ((ReportsTable)entirerow).clone();
        else if (entirerow instanceof InstalledTables)
            return ((InstalledTables)entirerow).clone();
        else if (entirerow instanceof PlatformClearance)
            return ((PlatformClearance)entirerow).clone();
        else if (entirerow instanceof ChangeTracker)
            return ((ChangeTracker)entirerow).clone();
        else if (entirerow instanceof FileTableDataFileMap)
            return ((FileTableDataFileMap)entirerow).clone();
        else if (entirerow instanceof CrashRecovery)
            return ((CrashRecovery)entirerow).clone();
        else if (entirerow instanceof ArtLeaves)
            return ((ArtLeaves)entirerow).clone();
        else if (entirerow instanceof LanguageSupport)
            return ((LanguageSupport)entirerow).clone();        
        else if (entirerow instanceof LanguageTitles)
            return ((LanguageTitles)entirerow).clone();
        else if (entirerow instanceof CelebrityTable)
            return ((CelebrityTable)entirerow).clone();
        else if (entirerow instanceof PaymentType)
            return ((PaymentType)entirerow).clone();
        else if (entirerow instanceof LanguageTransalations)
            return ((LanguageTransalations)entirerow).clone();        
        else if (entirerow instanceof PictureOptions)
            return ((PictureOptions)entirerow).clone();
        else if (entirerow instanceof SearchDatabase)
            return ((SearchDatabase)entirerow).clone();   
        return entirerow; // others i am too very lazy to write a clown you write it
    }
    
    protected void setRowid(long p_Rowid){
        rowlock.acquireUninterruptibly();
        if (p_Rowid >= 0)
        {
            rowid = p_Rowid;
        }
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Negative Rowid:" + p_Rowid));
            System.exit(1);
        }
        //UpdateIndexes ();
        rowlock.release();
    }
    
    protected void setChange_flag(char p_Change_flag){
        rowlock.acquireUninterruptibly();
        if (p_Change_flag == 'U' || p_Change_flag == 'I' || p_Change_flag == 'D'
            || p_Change_flag == 'F' || p_Change_flag == 'C' || p_Change_flag == 'T' 
            || p_Change_flag == 'K' || p_Change_flag == 'J' || p_Change_flag == 'R'
            || p_Change_flag == 'r')
        {            
            change_flag = p_Change_flag;
            rowlock.release();
            setOldchangeflag (getChange_flag());                        
        }
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid Args:p_Change_flag = " + String.valueOf(p_Change_flag) ));
	    JOptionPane.showMessageDialog(LiveDB.appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
            System.exit(1);          
        }
        rowlock.release();
    }
    
    protected void setOldchangeflag (char p_oldflag){
        rowlock.acquireUninterruptibly();
        oldchangeflag = p_oldflag;
        rowlock.release();
    }
    
    protected void setPid(long p_Pid){
        // you can set a wrong pid if you want here for future programming stunts not NOW
        rowlock.acquireUninterruptibly();   
        if (p_Pid == LiveDB.pid)
            this.pid = p_Pid;
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid Args:constructor p_Pid = "
                + String.valueOf(p_Pid)));
	    JOptionPane.showMessageDialog(LiveDB.appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
            System.exit(1);
        }        
        rowlock.release();
    }
    
    protected void setDmldate (Date p_Dmldate){
       rowlock.acquireUninterruptibly();       
       this.dmldate = new Date(p_Dmldate.getTime());
       rowlock.release();
    }
    
   
    protected void setEntirerow (Object p_obj){
        rowlock.acquireUninterruptibly();
            switch ((int)getTableno()){
                case ft:                    
                    if (p_obj instanceof FileTableDataFileMap)
                        entirerow = ((FileTableDataFileMap)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case LiveDB.ct:
                    if (p_obj instanceof ChangeTracker)
                        entirerow = ((ChangeTracker)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case cr:
                    if (p_obj instanceof CustomerRegister)
                        entirerow = ((CustomerRegister)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case sc:
                    if (p_obj instanceof ShoppingCart)
                        entirerow = ((ShoppingCart)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case ls:
                    if (p_obj instanceof LanguageSupport)
                        entirerow = ((LanguageSupport)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case lt:
                    if (p_obj instanceof LanguageTitles)
                        entirerow = ((LanguageTitles)p_obj).clone(); // 10th September   
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case ltr:
                    if (p_obj instanceof LanguageTransalations)
                        entirerow = ((LanguageTransalations)p_obj).clone(); // 10th September
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case pt:
                    if (p_obj instanceof PaymentType)
                        entirerow = ((PaymentType)p_obj).clone(); // 10th September
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case pd:
                    if (p_obj instanceof PictureDatabase)
                        entirerow = ((PictureDatabase)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case po:
                    if (p_obj instanceof PictureOptions)
                        entirerow = ((PictureOptions)p_obj).clone(); // 10th September
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case sd:
                    if (p_obj instanceof SearchDatabase)
                        entirerow = ((SearchDatabase)p_obj).clone(); // 10th September
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case da:
                    if (p_obj instanceof DefaultAdvertisingImages)
                        entirerow = ((DefaultAdvertisingImages)p_obj).clone(); // 10th September
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case ar:
                    if (p_obj instanceof ArtLeaves)
                        entirerow = ((ArtLeaves)p_obj).clone(); // 10th September
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case crr:
                    if (p_obj instanceof CrashRecovery)
                        entirerow = ((CrashRecovery)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case it:
                    if (p_obj instanceof InstalledTables)
                    {                                                               
                        entirerow = ((InstalledTables)p_obj).clone();
                    }
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case rt:
                    if (p_obj instanceof ReportsTable)
                        entirerow = ((ReportsTable)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case clt:
                    if (p_obj instanceof CelebrityTable)
                        entirerow = ((CelebrityTable)p_obj).clone(); // 10th September
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                case pc:
                    if (p_obj instanceof PlatformClearance)
                        entirerow = ((PlatformClearance)p_obj).clone();
                    else
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("Instance does not match tableno :" + String.valueOf(getTableno())));
                        System.exit(1);
                    }
                    break;
                default:
                  LiveDB.ALRTLVL = 7;
                  System.err.println(LiveDB.grassHopper("Invalid Args:case default"));
		  JOptionPane.showMessageDialog(LiveDB.appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                  System.exit(1);
                  break;
            }        
        rowlock.release();
    }
    
    protected void setCtrowid (long p_ctrowid){
        rowlock.acquireUninterruptibly();
        // dont validate will bounce during row renumbering
        ctrowid = p_ctrowid;
        rowlock.release();
    }

    // although each instance of this Class CustomerRegister represents a single row
    // we are committing the entire table here but before that a few checks and balances
    @Override
    public final boolean COMMIT(){
        
        boolean fnd = false;

        // we are committing the ChangeTracker table itself so mark those rows with change_flag 'F'
        for (int rw = (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ctn].length; rw++)
        {
            if (((ChangeTracker)LiveDB.LiveSharedDB[ctn][rw]).getTableno() == ctn
                && ((ChangeTracker)LiveDB.LiveSharedDB[ctn][rw]).getChange_flag() != 'F'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ctn][rw]).getChange_flag() != 'C'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ctn][rw]).getChange_flag() != 'K'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ctn][rw]).getChange_flag() != 'T')
            {
                   ((ChangeTracker)LiveDB.LiveSharedDB[ctn][rw]).setChange_flag('C');
                   fnd = true;
                   // insert an entry in ChangeTracker table for this table
                   // Basically what this does is to backup this entirerow where you
                   // setChange_flag('C') otherwise database reconstruct of ChangeTracker will fail.
                   // But in this case of ChangeTracker table this huge snake called ChangeTracker
                   // has to full stop somewhere before it devours your hard disk at 512MB per year.
                   // so instead of a call to constructor with update flag 'U'

                   /* LiveDB.LiveSharedDB[ctn][LiveDB.LiveSharedDB[ctn].length] =
                   new ChangeTracker ((long)ctn,rw, 'U', LiveDB.pid, new Date (),
                   LiveDB.LiveSharedDB[ctn][rw],(long)LiveDB.LiveSharedDB[ctn].length); */

                   // we will call the constructor with update flag 'F' so it will backup
                   // the change that you just made and also chop the tail of this snake.
                   LiveDB.LiveSharedDB[ctn][LiveDB.growMore(ctn)] =
                   new ChangeTracker ((long)ctn,rw, 'F', LiveDB.pid, new Date (),
                   LiveDB.LiveSharedDB[ctn][rw],(long)LiveDB.LiveSharedDB[ctn].length -1);
            }
        }

        if (fnd)
        {
            // for the sake of dbfRepair we take a restore file which may be a BAD copy
            // since we are not checking for the presence of a .syc file on disk. If we
            // look for a .syc file on disk then this commit will take very very long.
            LiveDB.CopyFile(LiveDB.serializedfilespath + 
                   ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][ctn]).getFilename() + ".ser",
                   LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
                   ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][ctn]).getFilename() + ".ser" + ".res");
            
            if ( LiveDB.commit_database(ctn) == false )
                return false;
        }
        
        return true;
    }

    @Override
    public final boolean COMMITINDEXES(){
        
        if (LiveDB.LiveSharedDB[ctn].length == 0)
            return false;
        return LiveDB.write_IndexFile(ctn);
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(ctn) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }

    @Override
    public final void writeExternal (ObjectOutput stream) throws IOException {

        int thisrow = 0;
        String file = null;
        rowlock.acquireUninterruptibly();
        int itr = -1; // Installed table row in InstalledTables

        // first find the rowid for this table ctn = 14 in InstalledTables
        if (LiveDB.indxinstalledTables.get(Integer.toString(ctn)) == null)
        {
            LiveDB.ALRTLVL = 4;
            System.err.println(LiveDB.grassHopper("ChangeTracker misses entry in indxinstalledTables"));
            // perhaps the index is corrupted or has not been updated someplace so check the physical table
            for (int i = 0; i < LiveDB.LiveSharedDB[itn].length; i++)
            {
                if (((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getTableno() == ctn)
                   itr = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getRowid();
            }

            if (itr == -1 || itr > LiveDB.maxtables)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("ChangeTracker misses entry in indxinstalledTables"));
                System.exit(1);
            }
        }
        else
            itr = (int)(long)LiveDB.indxinstalledTables.get(Integer.toString(ctn));

        thisrow = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).getTableno();
        file = ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][thisrow]).getFilename();
        file = LiveDB.serializedfilespath + file + ".ser";
        
        srf = new File (file);

        // outsize should be negative before every write
        rowlock.release();
        if (srf.exists())
           ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        else ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(-1L);
        rowlock.acquireUninterruptibly();
        
        
        
        // The following code has been commented out to avoid a java.lang.OutOfMemoryError
        /*
        thisrow = LiveDB.growMore(ctn);
        rowlock.release();
        LiveDB.LiveSharedDB[ctn][thisrow] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], thisrow);
        rowlock.acquireUninterruptibly();
        * 
        */
        
        try{
              stream.writeLong(tableno);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field tableno"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        
        try{
              stream.writeLong(rowid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        } */

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeChar(change_flag);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field change_flag"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        } */

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeChar(oldchangeflag);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field oldchangeflag"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeLong(pid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field pid"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        } */

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeLong(dmldate.getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field dmldate"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        // Changed on 21st September 2012

            try{
              stream.writeObject(entirerow);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field entirerow"));
              throw new IOException ();
            }


        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeLong(ctrowid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field ctrowid"));
              throw new IOException ();
        }


        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during ChangeTracker serialization"));
            System.exit(1);
        }

        // setOutsize to positive value after every successfull write
        // so if there is a power outage in between we will know that there has been a serialization
        // failure and the serialized file is corrupted and take necessary steps to restpre the
        // serialized file from CrashRecovery or ChangeTracker or if both CrashRecovery and ChangeTracker
        // are corrupted then restore from last autobackup
        rowlock.release();
        if (srf.exists())
           ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length());
        else ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(0L);
        
        // The following code has been commented out to avoid a java.lang.OutOfMemoryError
        // Its not all that important to backup the InstalledTables row each and every time
        /*
        thisrow = LiveDB.growMore(ctn);
        LiveDB.LiveSharedDB[ctn][thisrow] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], thisrow);
        * 
        */
    }

    @Override
    public final void readExternal (ObjectInput stream) throws IOException, ClassNotFoundException {
        // now read in all values here
        rowlock.acquireUninterruptibly();
        try{
              tableno = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field tableno"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field tableno"));
              throw new IOException ();
        }

        try{
              rowid = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field rowid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
        }

        try{
              change_flag = stream.readChar();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field change_flag"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field change_flag"));
              throw new IOException ();
        }

        try{
              oldchangeflag = stream.readChar();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field oldchangeflag"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field oldchangeflag"));
              throw new IOException ();
        }

        try{
              pid = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field pid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field pid"));
              throw new IOException ();
        }

        try{
              dmldate = new Date(stream.readLong());
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field dmldate"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field dmldate"));
              throw new IOException ();
        }
        
        try{
              entirerow = stream.readObject();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field entirerow"));
              throw new EOFException ();
        }catch (ClassNotFoundException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field entirerow"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field entirerow"));
              throw new IOException ();
        }

        try{
              ctrowid = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field ctrowid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field ctrowid"));
              throw new IOException ();
        }

        rowlock.release();
    }
}
