/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.util.Random;
import java.awt.Font;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import javax.imageio.ImageIO;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static MaintainData.FirstPage.featuredpanel;
import static MaintainData.LiveDB.pd;
import static MaintainData.FirstPage.registerpanel;
import static MaintainData.LanguagePanel.SelectedLanguage;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : FeaturedPanel
 *
 * @LOOKSY: PictureDatabase.java
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Featured Panel at east
 * of screen. It selects any one picture code at random from PictureDatabase and draws the image
 * on the panel.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * Last Modification Date : 9th August 2012
 * Last Modifications : Marked as 9th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : MArked as 17th August 2012
 * Also search for LiveDB.USEFONT
 * 
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class FeaturedPanel
{
    GridBagConstraints constraints = null;
    // removed declaration and its usage 9th August 2012
    //String langstring [] = null;
    JLabel featured = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Featured Product")
            == null ? "Featured Product" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Featured Product"));
    static JLabel tit;
    PicturePage thispicpage = null;  // 17th August 2012
    
    public FeaturedPanel ()
    {
        int MF = 10;
        featuredpanel = new JPanel (new GridBagLayout());
        featuredpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        featuredpanel.setBackground(Color.WHITE);
        featuredpanel.setBounds((int)(FirstPage.pageonetextpanel.RIGHT_ALIGNMENT * MF) +1,
                (int)(FirstPage.pageonetextpanel.TOP_ALIGNMENT * MF),
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF),
                (int)(FirstPage.cartpanel.BOTTOM_ALIGNMENT * MF) - (int) (FirstPage.cartpanel.TOP_ALIGNMENT * MF));
        
        addfeaturedpanel();
    }
    
    void addfeaturedpanel ()
    {
        Image image = null;
        int infoflags = 0;        
        String path = null;
        final int row;
        int MF = 10;

        row = new Random().nextInt(LiveDB.LiveSharedDB[pd].length);
        featured.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        featured.setForeground(Color.BLACK);

        path = ((PictureDatabase)LiveDB.LiveSharedDB[pd][row]).getPic_img_location();

        tit = new JLabel (((PictureDatabase)LiveDB.LiveSharedDB[pd][row]).getPic_title());
        tit.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        tit.setForeground(Color.BLACK);

        featuredpanel.add(featured, setConstraints(0,0,2,1));

        try{
            image = ImageIO.read(new File(path));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Icon File:" + path));
            return ;
        }

        if (featuredpanel.getGraphics().drawImage(image, (int)(registerpanel.LEFT_ALIGNMENT * MF) + 3,
                (int)(featuredpanel.TOP_ALIGNMENT * MF) + 1,
                (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF) - (int)(featuredpanel.LEFT_ALIGNMENT * MF) - 2, // width
                (int)(registerpanel.BOTTOM_ALIGNMENT * MF) - 2, // height
                null) == false)
        {
            featuredpanel.imageUpdate(image, infoflags,
                    (int)(registerpanel.LEFT_ALIGNMENT * MF) + 3,
                    (int)(featuredpanel.TOP_ALIGNMENT * MF) + 1,
                    (int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF) - (int)(featuredpanel.LEFT_ALIGNMENT * MF) - 2,
                    (int)(registerpanel.BOTTOM_ALIGNMENT * MF) - 2);

            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Error Drawing Image File:" + path));
            return;
        }
        featuredpanel.add(tit, setConstraints((int)(featuredpanel.LEFT_ALIGNMENT * MF) + 2,(int)(featuredpanel.BOTTOM_ALIGNMENT * MF) -1,2,1));
        
        tit.addMouseListener(new MouseListener(){            
            @Override
            public void mousePressed (MouseEvent evnt){
                tit.setForeground(Color.RED);
                tit.validate();
            }
            @Override
            public void mouseEntered (MouseEvent evnt){
                tit.setForeground(Color.RED);
                tit.validate();
            }
            @Override
            public void mouseClicked (MouseEvent evnt){
                // 17th August 2012
                thispicpage = new PicturePage(((PictureDatabase)LiveDB.LiveSharedDB[pd][row]).getPic());
                tit.validate();
            }
            @Override
            public void mouseExited (MouseEvent evnt){
                tit.setForeground(Color.BLUE);
                tit.validate();
            }
            @Override
            public void mouseReleased (MouseEvent evnt){
                tit.setForeground(Color.BLUE);
                tit.validate();
            }
        });
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
