/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.io.File;
import java.io.Serializable;
import java.util.Date;
import java.util.concurrent.Semaphore;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LanguageSupport.java
 * @LOOKSY:PictureDatabase.java
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java
 * @LOOKSY:ArtLeavesInterfaces.java
 * @LOOKSY:LiveDB.indxinstalledTables
 *
 * Class Name : class LanguageTransalations implements Serializable, Tables
 *
 * Methods : Look in Class definition
 *
 * The Tables Interface has been faked here except for REFRESH because it is too very dangerous to provide it.
 *
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding.
 *
 * Relevant Indexes : LiveDB.indx1languageTransalations
 * searchkey = toString((int)(AnyValid Lid from LanguageSupport) + toString(GUITEXTAREANO)
 * searchkey returns Long rowid in the table
 * LiveDB.indx2languageTransalations
 * searchkey = toString((int)(AnyValid Lid from LanguageSupport) + (AnyValid PictureCode from PictureDatabase)
 * searchkey returns Long rowid in the table
 * LiveDB.indx3languageTransalations
 * searchkey= toString(lid) + picturecode + guitextareatype
 * searchkey returns languagefilename the complete path
 *
 * Data File : YES the name of the dataentry file will be contained in FileTableDataFileMap. The data file
 * will contain the language transalations for each language and Picture Code for each GUI text area number.
 * A readymade data entry file will be provided to you dont loose that take a physical backup and keep safe.
 * Also language transalation files containing the ready transalated text for each language (*.lfn) will also
 * be provided which must be kept safe some place under lock and key. If you loose it its very difficult to
 * recreate it all over again.
 *
 * @Since Version 1.0
 *
 * Running Commentary : This table contains all the languages transalations for all languages supported by
 * this Application. The constructor does some usual validations. Basically for each GUI text area number
 * there will be a language transalations file available ready to serve on disk.
 *
 * Technical References : Buy and Read Asterix in America (Comming Soon .... In Sketch)
 *                        (I have sent standing instructions to Uderzo)
 * Table Dedicated to : Gypsy Kings (all of em) (IVolare)
 *
 * Start Date: 18th October 2010
 * End Date: 13th May 2011
 *
 * Last Modification Date : 3rd June 2012
 * Last Modification : Changed access specifier for default constructor without params from public to
 * protected
 * Also validated parameter p_Rowid in main constructor for negative value before assigning to rowid
 *
 * Last Modifications Date : 25th June 2012
 * Last Modifications : Marked as 25th June 2012
 * 
 * Last Modification Date : 8th August 2012
 * Last Modifications : Added new clone () method
 * 
 * Last Modification Date : 8th September 2012
 * Last Modifications : Marked as 8th September 2012
 * 
 * Last Modification Date : 10th September 2012
 * Last Modification : declared a new variable thisrow and its usage
 * private transient int thisrow;
 *
 * Last Modification Date : 11th September 2012
 * Last Modifications : removed rowlock.acquireUninterruptibly(); and rowlock.release()
 * statements from the clone method because each of the setters will do the above.
 * 
 * Last Modification Date : 13th September 2012
 * Last Modifications : Marked as 13th September 2012
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class LanguageTransalations implements Serializable, Tables, Cloneable {
    private long lid; /* Language id */
    private String pic; /* Picture Code */
    private long gui_text_area_no; /* GUI Text Area Number  NOT USING THIS ANYWAYS KEEPS FOR FUTURE */
    private String gui_text_area_type; /* GUI Text Area Type -- TextBox etc */
    private String lfn ; /* Language File Name ready to serve */
    private long rowid; /* 6 FIELDS */

    private transient int thisrow;
    private transient LanguageTransalations ltrans;
    private transient int ltn;
    private transient Semaphore rowlock;

    {
       thisrow = 0; 
       rowlock = new Semaphore(1, true);
       ltn = LiveDB.ltr;
    }

    // thou shall not flirt with this constructor -- ten commandments
    public LanguageTransalations ()
    {
        lid = gui_text_area_no = rowid = 0L;
        pic = gui_text_area_type = lfn = null;
    }
    
    public LanguageTransalations (long p_Lid, String p_Pic,
            long p_Gui_Text_Area_No, String p_Gui_Text_Area_Type,
            String p_Lfn, long p_Rowid){
        rowlock.acquireUninterruptibly();
        lid = p_Lid; /* Store Data for one row */
        if (p_Pic == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_Pic=null"));
            System.exit(1);
        }
        pic = new String(p_Pic.toCharArray()); /* Picture Code */
        gui_text_area_no = p_Gui_Text_Area_No; /* 1 - 8 ? */
        rowlock.release();
        setGui_text_area_type(p_Gui_Text_Area_Type);
        setLfn(p_Lfn);
        
        rowlock.acquireUninterruptibly();
        if (LiveDB.LiveSharedDB[ltn].length == 0 && p_Rowid != 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid rowid:" + String.valueOf(p_Rowid)));
            System.exit(1);
        }
        
        if (LiveDB.LiveSharedDB[ltn].length > 1) // Added on 25th June 2012
        {
            // 13th September 2012
           thisrow = LiveDB.LiveSharedDB[ltn].length -2; 
           if (p_Rowid != ((LanguageTransalations)LiveDB.LiveSharedDB[ltn][thisrow]).getRowid() + 1)
           {
              LiveDB.ALRTLVL = 7;
              System.err.println(LiveDB.grassHopper("Invalid rowid:" + String.valueOf(p_Rowid)));
              System.exit(1);
           }
        }
        
        if (p_Rowid >= 0)
            rowid = p_Rowid;
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Negative Rowid:" + p_Rowid));
            System.exit(1);
        }
        rowlock.release();
    }
    
    // Added new clone method on 8th August 2012
    @Override
    protected Object clone (){
            
        try{
            ltrans = (LanguageTransalations)super.clone();
            rowlock.acquireUninterruptibly();
            ltrans.pic = ltrans.getPic();
            rowlock.release();
            ltrans.setGui_text_area_type(ltrans.getGui_text_area_type());
            ltrans.setLfn(ltrans.getLfn());
        }catch (CloneNotSupportedException ex_NOKIA75){
            throw new InternalError (ex_NOKIA75.toString());
        }        
        
        return ltrans;
    }
    
    protected long getLid(){
        return lid;
    }
    protected String getPic(){
        return new String(pic.toCharArray());
    }
    protected long getGui_text_area_no(){
        return gui_text_area_no;
    }
    protected String getGui_text_area_type(){
        return new String(gui_text_area_type.toCharArray());
    }
    protected String getLfn(){
        return new String(lfn.toCharArray());
    }
    protected long getRowid(){
        return rowid;
    }

    @Override
    public String toString(){
        String filher = "%";
        return String.valueOf(getLid()).concat(filher).concat(getPic()).concat(filher)
               .concat(String.valueOf(getGui_text_area_no())).concat(filher).concat(getGui_text_area_type())
               .concat(filher).concat(getLfn()).concat(filher).concat(String.valueOf(getRowid()));
    }
    
    protected void setGui_text_area_type(String p_Gui_text_area_type){
        if (p_Gui_text_area_type == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_Gui_text_area_type=null"));
            System.exit(1);
        }
        rowlock.acquireUninterruptibly();
        gui_text_area_type = new String(p_Gui_text_area_type.toCharArray());
        rowlock.release();
    }
    protected void setLfn(String p_Lfn){
        if (p_Lfn == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_Lfn=null"));
            System.exit(1);
        }
        rowlock.acquireUninterruptibly();

        if (LiveDB.convertFileName(p_Lfn) == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_Lfn=null"));
            System.exit(1);
        }
        else
        {
            if (LiveDB.command_line.equals("FileTableDataFileMap"))
                lfn = new String(LiveDB.convertFileName(p_Lfn).toCharArray());
            else lfn = new String(p_Lfn.toCharArray());
            
            if (new File(lfn).exists() == false)
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Does not Exist File:" + lfn));
                System.err.println("CONTINUATION LINE:" + LiveDB.logerrorno +
                        " URGENT PLEASE COPY MISSING FILE");                
            }
            else
            {
                if (new File(lfn).canRead() == false)
                {
                    System.err.println(LiveDB.grassHopper("No Read Perms on File:" + lfn));
                    if (new File(lfn).setReadOnly() == false)
                        System.err.println(LiveDB.grassHopper("Can Set Readonly on File:" + lfn));                    
                }
            }
        }
        rowlock.release();
    }

    @Override
    public final boolean COMMIT(){
        return true;
    }

    @Override
    public final boolean COMMITINDEXES (){
        return true;
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(ltn) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
}
