/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.util.Locale;
import java.io.EOFException;
import java.io.Externalizable;
import java.io.File;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;
import java.io.UTFDataFormatException;
import java.util.Date;
import java.util.concurrent.Semaphore;
import static MaintainData.LiveDB.ft;
import static MaintainData.LiveDB.ct;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java
 * @LOOKSY:RefreshDatabase.read_database()
 * @LOOKSY:ArtLeavesInterfaces.java
 * @LOOKSY:LiveDB.indxinstalledTables
 *
 * Class Name : class PictureOptions implements Externalizable, Tables
 *
 * Methods : Look in Class definition
 *
 * The Tables Interface has been faked here except for REFRESH because i dont want to provide it.
 *
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding.
 *
 * Relevant Indexes : LiveDB.indxpictureOptions
 * searchkey = langcode + AnyOptionId (1 thru n Integer.toString)
 * searchkey returns lang_sub_text for the Option id for that langcode
 *
 * LiveDB.indx2pictureOptions
 * searchkey = AnyOptionId (1 thru n Integer.toString) + langcode
 * searchkey returns LiveDB.fieldseperator seperated string containing lang_sub_text for each of
 * sub_opt_id for opt_id, langcode.
 *
 * Data File : YES the name of the dataentry file will be contained in FileTableDataFileMap. The data file
 * will contain all pictures options for pictures up for sale. A readymade data entry file will be provided
 * to you which you need to customize a bit for your installation. Dont loose that take a physical backup and
 * keep safe.
 *
 * @Since Version 1.0
 *
 * Running Commentary : This table lists all the pictures options available for buyers. The constructor goes
 * thru a usual bunch of validations to ensure data compliance. Basically it contains the Language Sub Text
 * for each supported language for each langcode,opt_id,sub_opt_id. This is usefull for a ready lookup when
 * the user keeps changing the Language on the User Interface.
 *
 * Technical References : Buy and Read Obelix and Co.
 * Table Dedicated to : Sant Anna and Rob Thomas (Give me your heart baby or else forget about it)
 *                      This was a wild card wild ass entry they Rob it !!
 *
 * Start Date: 18th October 2010
 * End Date: 13th May 2011
 * Last Modified Date : 13th September 2011
 * Last Modifications : Change to table schema. The old schema was as under
 * private String pic ;
 * private long lid ;
 * private long opt_id ;
 * private long sub_opt_id ;
 * private String lang_sub_text ;
 * private long rowid ;
 *
 * The New Table Schema is as under
 * private String langcode ; 
 * private int opt_id ; Options ID such as Frame Color
 * private int sub_opt_id ; sub option id such as Gold, Silver etc
 * private String lang_sub_text ; Language sub text for each of the sub options
 * private long rowid ;  5 FIELDS
 *
 * As a result of table schema changes two old indexes which were defined as under have also changed
 * Relevant Indexes : LiveDB.indxpictureOptions
 * searchkey = AnyValidPictureCode + toString(Valid-Lid) + toString(Opt_id) + toString(Sub_opt_id)
 * searchkey returns Long rowid in the table
 * LiveDB.indx2pictureOptions
 * searchkey = AnyValidPictureCode + toString(Valid-Lid) + toString(Opt_id)
 * searchkey returns Long rowid in the table
 *
 * The above two indexes have changed as under
 * Relevant Indexes : LiveDB.indxpictureOptions
 * searchkey = langcode + AnyOptionId (1 thru n Integer.toString)
 * searchkey returns lang_sub_text for the Option id for that langcode
 *
 * LiveDB.indx2pictureOptions
 * searchkey = langcode + AnyOptionId (1 thru n Integer.toString)
 * searchkey returns LiveDB.fieldseperator seperated string containing lang_sub_text for each of
 * sub_opt_id for opt_id, langcode.
 * This second index is tough to build. It will be built in LaunchGUI. The entire table will
 * first be sorted and then entries added to the index.
 *
 * Last Modification Date : 3rd June 2012
 * Last Modifications : Changed access specifier from public to protected in default constructor without
 * params
 * Also changed some hardcodings in itn = LiveDB.it and pon = LiveDB.po in the initialization blocks
 *
 * Last Modifications Date : 25th June 2012
 * Last Modifications : Marked as 25th June 2012
 * 
 * Last Modifications : 8th August 2012
 * Last Modifications : As Below
        // Every writeUTF write two extra bytes of length info to stream/file
        // So we need to add this to the return value of SIZEOF
        int utfextras = 2 * 2;
 * 
 * Last Modification Date : 8th August 2012
 * Last Modifications : Added new clone () method
 * 
 * Last Modification Date : 14th Augustus 2012
 * Last Modification : Through out this source file I have added this call to LiveDB.growMore(ct)
 * whereever I am growing the LiveDB.LiveSharedDB array with a call to new.
 * growMore is a popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash. And when you cook
 * vegetable add Harissa (mild Afrikan spice from North Afrika) one ladel along with Bagar.
 * 
 * Last Modification Date : 8th September 2012
 * Last Modifications : Marked as 8th September 2012
 * 
 * Last Modification Date : 10th September 2012
 * Last Modifications : declared a new variable thisrow and its usage
 * 
 * Last Modification Date : 11th September 2012
 * Last Modifications : removed rowlock.acquireUninterruptibly(); and rowlock.release()
 * statements from the clone method because each of the setters will do the above.
 * 
 * Last Modification Date : 13th September 2012
 * Last Modifications : Marked as 13th September 2012
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class PictureOptions implements Externalizable, Tables, Cloneable {
    private String langcode ; /* Language Code */
    private int opt_id ; /* Options ID such as Frame Color */
    private int sub_opt_id ; /* sub option id such as Gold, Silver etc */
    private String lang_sub_text ; /* Language sub text for each of the sub options */
    private long rowid ;  /* 5 FIELDS */

    private static final long serialVersionUID = 99989L;
    private transient int thisrow;
    private transient PictureOptions popt;
    private transient Semaphore rowlock;
    private transient int itn;
    private transient int pon;
    private transient File srf;

    {
       thisrow = 0; 
       rowlock = new Semaphore(1, true);
       itn = LiveDB.it;
       pon = LiveDB.po;
       srf = null;
    }

    // thou shall not flirt with this constructor -- ten commandments
    public PictureOptions (){
        langcode = lang_sub_text = null;
        rowid = opt_id = sub_opt_id = 0;
    }

    public PictureOptions (String p_langcode, int p_Opt_Id,
            int p_Sub_Opt_Id, String p_Lang_Sub_Text, long p_Rowid)
    {
        rowlock.acquireUninterruptibly();
        if (new Locale(p_langcode) == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Bad param to constructor langcode = " + p_langcode));
            System.exit(1);
        }
        if (p_langcode == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_langcode=null"));
            System.exit(1);
        }
        langcode = new String(p_langcode.toCharArray());        
        opt_id = p_Opt_Id ;
        sub_opt_id = p_Sub_Opt_Id ;
        rowlock.release();
        setLang_sub_text(p_Lang_Sub_Text);
        rowlock.acquireUninterruptibly();
        // 8th September 2012
        // the previous if condition was
        // if (LiveDB.LiveSharedDB[pon].length == 0 && p_Rowid != 0)
        // which throws a null pointer exception
        if (LiveDB.LiveSharedDB[pon] == null && p_Rowid != 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid rowid:" + String.valueOf(p_Rowid)));
            System.exit(1);
        }
        
        // 8th September 2012
        // added this extra check over and above the nested if
        if (LiveDB.LiveSharedDB[pon] != null)
        {
            // 13th September 2012
            if (LiveDB.LiveSharedDB[pon].length > 1 ) // Added on 25th June 2012
            {
               thisrow = LiveDB.LiveSharedDB[pon].length -2;
               if( p_Rowid != ((PictureOptions)LiveDB.LiveSharedDB[pon][thisrow]).getRowid() + 1)
               {
                  LiveDB.ALRTLVL = 7;
                  System.err.println(LiveDB.grassHopper("Invalid rowid:" + String.valueOf(p_Rowid)));
                  System.exit(1);
               }
            }
        }
        // Added on 25th June 2012
        if (p_Rowid >= 0)
            rowid = p_Rowid;
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Negative Rowid:" + p_Rowid));
            System.exit(1);
        }
        rowlock.release();
    }

    /* Getters and Setters provide a public interface to private data */
    /* They follow the rulebook of encapsulation */
    /* Dont provide Setters for all fields specially key fields !! */
    /* If you have to provide a setter for some sensitive data then
     * make that setter package private or protected.
     */
    protected int SIZEOF(){ // dont use getters here at all it will trim and return
        // Every writeUTF write two extra bytes of length info to stream/file
        // So we need to add this to the return value of SIZEOF
        int utfextras = 2 * 2;
        return ((langcode.length() * 2) + 4 + 4 + (lang_sub_text.length() * 2) + 8 + utfextras);
                                                                        // Changed 8th Aug 2012
    }

    // Added new method clone () on 8th August 2012
    @Override
    protected Object clone () {
        
        try{
            popt = (PictureOptions)super.clone();
            rowlock.acquireUninterruptibly();
            popt.langcode = popt.getlangCode();
            rowlock.release();
            popt.setLang_sub_text(popt.getLang_sub_text());
        }catch (CloneNotSupportedException ex_NOKIA99){
            throw new InternalError (ex_NOKIA99.toString());
        }
        
        return popt;
    }
    
    protected String getlangCode (){
        return new String(langcode.toCharArray());
    }

    protected int getOpt_id() {
        return opt_id;
    }
    protected int getSub_opt_id(){
        return sub_opt_id;
    }
    protected String getLang_sub_text(){
        return new String(lang_sub_text.toCharArray());
    }
    protected long getRowid(){
        return rowid;
    }

    protected void setLang_sub_text(String p_Lang_sub_text){
        if (p_Lang_sub_text == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_Lang_sub_text=null"));
            System.exit(1);
        }        
        rowlock.acquireUninterruptibly();
        lang_sub_text = new String(p_Lang_sub_text.toCharArray());
        rowlock.release();
    }

    @Override
    public String toString(){
        String filher = "%";
        return getlangCode().concat(filher).concat(String.valueOf(getOpt_id())).concat(filher)
               .concat(String.valueOf(getSub_opt_id())).concat(filher).concat(getLang_sub_text())
               .concat(filher).concat(String.valueOf(getRowid()));
    }

    @Override
    public final void writeExternal (ObjectOutput stream) throws IOException {
        rowlock.acquireUninterruptibly();
        int itr = -1; // Installed table row in InstalledTables
        int thisrow = 0;
        String file = null;

        // first find the rowid for this table pon = 9 in InstalledTables
        if (LiveDB.indxinstalledTables.get(Integer.toString(pon)) == null)
        {
            LiveDB.ALRTLVL = 4;
            System.err.println(LiveDB.grassHopper("PictureOptions misses entry in indxinstalledTables"));
            // perhaps the index is corrupted or has not been updated someplace so check the physical table
            for (int i = 0; i < LiveDB.LiveSharedDB[itn].length; i++)
            {
                if (((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getTableno() == pon)
                   itr = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getRowid();
            }

            if (itr == -1 || itr > LiveDB.maxtables)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("PictureOptions misses entry in indxinstalledTables"));
                System.exit(1);
            }
        }
        else
            itr = (int)(long)LiveDB.indxinstalledTables.get(Integer.toString(pon));

        thisrow = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).getTableno();
        file = ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][thisrow]).getFilename();
        file = LiveDB.serializedfilespath + file + ".ser";
        srf = new File (file);

        // outsize should be negative before every write
        rowlock.release();
        if (srf.exists())
            ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        else ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(-1L);
        rowlock.acquireUninterruptibly();
        
        // The following code has been commented out to avoid a java.lang.OutOfMemoryError
        // Its not all that important to backup the InstalledTables row each and every time
        /*
        thisrow = LiveDB.growMore(ct);
        rowlock.release();
        LiveDB.LiveSharedDB[ct][thisrow] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], thisrow);
        rowlock.acquireUninterruptibly();
        * 
        */

        try{
              stream.writeUTF(langcode);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field pic"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PictureOptions serialization"));
            System.exit(1);
        }*/



        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeInt(opt_id);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field opt_id"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PictureOptions serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeInt(sub_opt_id);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field sub_opt_id"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PictureOptions serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeUTF(lang_sub_text);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field lang_sub_text"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PictureOptions serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeLong(rowid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
        }

        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PictureOptions serialization"));
            System.exit(1);
        }

        // setOutsize to positive value after every successfull write
        // so if there is a power outage in between we will know that there has been a serialization
        // failure and the serialized file is corrupted and take necessary steps to restpre the
        // serialized file from CrashRecovery or ChangeTracker or if both CrashRecovery and ChangeTracker
        // are corrupted then restore from last autobackup
        rowlock.release();
        if (srf.exists())
           ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length());
        else ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(0L);
        
        // The following code has been commented out to avoid a java.lang.OutOfMemoryError
        // Its not all that important to backup the InstalledTables row each and every time
        /*
        thisrow = LiveDB.growMore(ct);
        LiveDB.LiveSharedDB[ct][thisrow] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], thisrow);
        * 
        */
        
    }

    @Override
    public final void readExternal (ObjectInput stream) throws IOException, ClassNotFoundException {
        rowlock.acquireUninterruptibly();
     // now read in all values here
        try{
              langcode = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field langcode"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field langcode"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field langcode"));
              throw new IOException ();
        }

        try{
              opt_id = stream.readInt();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field opt_id"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field opt_id"));
              throw new IOException ();
        }
        try{
              sub_opt_id = stream.readInt();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field sub_opt_id"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field sub_opt_id"));
              throw new IOException ();
        }
        try{
              lang_sub_text = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field lang_sub_text"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field lang_sub_text"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field lang_sub_text"));
              throw new IOException ();
        }

        try{
              rowid = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "field rowid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
        }
        rowlock.release();
    }

    @Override
    public final boolean COMMIT(){
        return true;
    }

    @Override
    public final boolean COMMITINDEXES (){
        return true;
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(pon) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
} // final class Class PictureOptions implements Serializable
