/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import javax.swing.JOptionPane;
import java.util.Date;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import javax.swing.JTextField;
import javax.swing.JComboBox;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.BoxLayout;
import java.io.FileNotFoundException;
import java.io.BufferedReader;
import java.io.FileReader;
import javax.swing.JScrollPane;
import java.io.IOException;
import javax.imageio.ImageIO;
import java.io.File;
import java.awt.Image;
import javax.imageio.stream.ImageInputStream;
import java.util.Iterator;
import javax.imageio.ImageReader;
import java.awt.Font;
import java.awt.Color;
import java.awt.GridBagConstraints;
import javax.swing.JButton;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import javax.swing.JPanel;
import static MaintainData.LiveDB.pd;
import static MaintainData.FirstPage.latestprodspanel;
import static MaintainData.FirstPage.pageonetextpanel;
import static MaintainData.LanguagePanel.SelectedLanguage;
import static MaintainData.LiveDB.sc;
import static MaintainData.LiveDB.ct;
import static MaintainData.LiveDB.pt;
import static MaintainData.FirstPage.convertCurrency;
import static MaintainData.CurrencyPanel.Symbol;
import java.util.Arrays;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : PicturePage
 *
 * @LOOKSY : LiveDB.indx1shoppingCart, LoginPage.LoggedInCID, LiveDB.PrepareAndSendMailMesg, LiveDB.LiveSharedDB
 * @LOOKSY : LiveDB.appframe, FirstPage.latestprodspanel, LiveDB.system_exit, LiveDB.SmoothExitCondition
 * @LOOKSY : LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.indxpictureDatabase, LiveDB.grassHopper
 * @LOOKSY : LanguagePanel.SelectedLanguage, LiveDB.indx3languageTransalations, FirstPage.picturepagetextpanel
 * @LOOKSY : LiveDB.indxpictureOptions, LiveDB.indx2pictureOptions
 * @LOOKSY : PageOneTextPanel.java
 *           ChangeTracker.java
 *           ShoppingCart.java
 *
 * Date File : None
 *
 * Called From : can be called from just about any place.
 *
 * Chained Methods : String [] strip (String p_strip)
 *
 * Associated Methods : protected static float convertCurrency(float p_amt)
 *
 * Constructor Parameters : final String p_piccode
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct a Picture Page for picture code
 * passed as parameter. So it draws the picture image and then plugs in the narrative for the picture
 * along with several picture options and sub options for each of the picture options to choose from
 * along with an Add to Basket button.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 * Last Modified Date:7th March 2012
 * Last Modifications: I had forgotten to update field last_access in PictureDatabase every time
 * a picture code is accessed by user from the GUI. So I have added the following lines of code
 * to set that information correctly in the constructor.
        else rw = LiveDB.indxpictureDatabase.get(p_piccode);

        // First update picture database using rw
        // Update the field last_access since you are acessing it now
        ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).setLast_access(new Date());
        // Now a ChangeTracker Entry for this Update
        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
              new ChangeTracker (pd,rw, 'U', LiveDB.pid, new Date (),
                  LiveDB.LiveSharedDB[pd][(int)rw],
                  (long)LiveDB.LiveSharedDB[ct].length);

        FirstPage.picturepagetextpanel = new JPanel (new GridBagLayout());
 *
 * Last Modification Date : 3rd June 2012
 * Last Modifications : Added this patch of code to split the incomming line into 10 words per line
 * and then construct labels and display them.
        // if you change the font size tomorrow then reduce it to 7 words per line
        for (int i = 0, k = 0; i < nl.length; i++, k++)
             splitlines[k] = splitthisline(nl[i]);

        NPanel = new JPanel (new BoxLayout(NPanel, BoxLayout.PAGE_AXIS));

        for (int i = 0, j = 0; i < splitlines.length ; i++, j++)
        {
            for (int k = 0; k < splitlines[i].length; k++, j++)
            {
                NLines[j] = new JLabel (splitlines[i][k]);
                NLines[j].setForeground(Color.BLACK);
                NLines[j].setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 9));
            }
        }
 *
 *
 * Last Modification Date : 4th June 2012
 * Last Modifications : Added new method
   private String [] splitthisline (String p_line)
 * and a call to this method in the above code patch
 *
 * Last Modification Date : 5th June 2012
 * Last Modifications : Study this patch of code correction. What I have done is reduced the need for
 * data entry in this very large table called PictureOptions. So if there is no row in the index for
 * selected language for opt id indicated by null I search for language = "en" in the index which has
 * to be there if data entry has been done at least for one language english completely. So you just
 * need to do data entry for "en" only and not everything. The only disadvantage is the language 
 * transalations wont be displayed for selected language.
        do
        {
            if ((productoptions[optid -1] = LiveDB.indxpictureOptions.get(SelectedLanguage + optid)) == null)
            {
                // a row maybe missing for selected language code
                // the data entry may not have been done. So we take the english record
                if ((productoptions[optid -1] = LiveDB.indxpictureOptions.get("en" + optid)) == null)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "PictureOptions table Data Entry Incomplete"
                            + "\n" + "Table Misses Row for Product Option ID:" + optid);
                    System.exit(1);
                }
            }
            optid++;

        }while (optid <= LiveDB.indxpictureOptions.size());

        optid = 1;
        do
        {
            if ((subopts [optid -1] = LiveDB.indx2pictureOptions.get(optid + SelectedLanguage)) == null)
            {
                // a row maybe missing for selected language code
                // the data entry may not have been done. So we take the english record
                // this application is supposed to make such intelligent switches everywhere minimizing
                // the need for switches.
                if ((subopts [optid -1] = LiveDB.indx2pictureOptions.get(optid + "en")) == null)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "PictureOptions table Data Entry Incomplete"
                            + "\n" + "Table Misses Row for Product Sub Option ID:" + optid);
                    System.exit(1);
                }
            }
            stripped = strip (subopts[optid -1]);
            for (int i = 0 ; i < stripped.length; i++)
                 productsuboptions[optid -1][i] = stripped[i].toString();            
            optid++;
        }while (optid <= LiveDB.indx2pictureOptions.size());
 * 
 *
 * Last Modification Date : 11th June 2012
 * Last Modifications : In the Picture Page Product Options will only be available if the Picture
 * Code starts with "PIC" otherwise for any other picture code not starting with "PIC" the product
 * options wont be there. It will be just one flat price to the customer. To validate this I have
 * added an if condition in the patch of code starting below
        if (p_piccode.indexOf("PIC") == 0 || p_piccode.indexOf("pic") == 0)
        {
        prodopts.setForeground(Color.BLACK);
        prodopts.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 10));
        FirstPage.picturepagetextpanel.add(prodopts, setConstraints(0,Y = Y + 1,2,1));
 *
 * Also added some extra methods to addbasket anonymous class mouse listener type
 * These methods are meant to adjust the plus minus amounts indicated in the sub options
 * The methods added are
   private void suboptadjustments (Float p_adjustdisc, Float p_adjustotal, String p_subopt)
   This method is called from mouseClicked ()
 * private String getdigits (String p_string, int p_indx)
 *
 * Last Modification Date : 11th August 2012
 * Last Modifications : Marked as 11th August 2012
 * 
 * Last Modification Date : 14th Augustus 2012
 * Last Modification : Through out this source file I have added this call to LiveDB.growMore(ct)
 * whereever I am growing the LiveDB.LiveSharedDB array with a call to new.
 * growMore is a popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash. And when you cook
 * vegetable add Harissa (mild Afrikan spice from North Afrika) one ladel along with Bagar.
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : Marked as 17th August 2012
 * Also search for LiveDB.USEFONT
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class PicturePage {

    GridBagConstraints constraints = null;
    // removed declaration and its usage 11th August 2012
    //String langstring [] = null;
    long rw = -1L;
    float picprice = 0.0f;
    float picdiscount = 0.0f;


    String pictitle = null;
    String unavailable = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR + "unavailable.txt";
    String file = null;
    String keyval = null;
    String narrativesfile = null;
    String productoptions [] = null;
    String productsuboptions [][] = null;
    String [] eachstr = null;
    JLabel prodinfo = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Product Information")
            == null ? "Product Information" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Product Information"));
    JLabel location = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Location")
            == null ? "Location:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Location") + ":");
    JLabel price = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Price")
            == null ? "Price:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Price") + ":");
    JLabel tellafriend = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Tell a Friend")
            == null ? "Tell a Friend" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Tell a Friend"));
    JLabel prodopts = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Product Options")
            == null ? "Product Options:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Product Options") + ":");
    JLabel prodcode = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Product Code")
            == null ? "Product Code:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Product Code") + ":");
    JLabel quantity = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Quantity")
            == null ? "Quantity:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Quantity") + ":");
    JButton addbasket = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Add to Basket")
            == null ? "Add to Basket" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Add to Basket"));
    JLabel catname = null;
    JLabel pictit = null;
    JPanel NPanel = null;
    JLabel fullprice = null;
    JLabel discprice = null;
    JScrollPane NPanelScroll = null;
    JLabel NLines [] = null;
    JLabel prodoptlabel [] = null;
    JComboBox prodsuboptcombo [] = null;
    JTextField qtyfld = null;
    JLabel PaymentMode = new JLabel ("Payment Mode:");
    JComboBox paymentvia = null;
    String paymodes [] = null;
    
    Object retval = null; // 17th August 2012
    
    public PicturePage(final String p_piccode)
    {
        int optid = 1, W = 0, oW = 0,  H = 0, X = 0, Y = 0, MF = 10, ML = 12;
        int pX = 0, pY = 0, pW = 0, pH = 0;
        String subopts [] = null;
        String stripped [] = null;
        Iterator<ImageReader> iter = null;
        ImageInputStream ImageIn = null;
        Image image = null;
        ImageReader reader = null;
        File fileptr = null;
        String filename = null;
        String suffix = null;
        boolean potrait = false;
        File fl = null;
        FileReader fr = null;
        BufferedReader br = null;
        String nl [] = null;
        String splitlines [][] = null;
        boolean autotransalate = false;


        if (LiveDB.indxpictureDatabase.get(p_piccode) == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Picture Code not in Index:" + p_piccode));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
        }
        else rw = LiveDB.indxpictureDatabase.get(p_piccode);

        // First update picture database using rw
        // Update the field last_access since you are acessing it now
        ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).setLast_access(new Date());
        // Now a ChangeTracker Entry for this Update
        LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
              new ChangeTracker (pd,rw, 'U', LiveDB.pid, new Date (),
                  LiveDB.LiveSharedDB[pd][(int)rw],
                  (long)LiveDB.LiveSharedDB[ct].length -1);
        
        FirstPage.picturepagetextpanel = new JPanel (new GridBagLayout());
        pW = oW = W = ((int)pageonetextpanel.RIGHT_ALIGNMENT * MF) -
                                              (X = (int)pageonetextpanel.LEFT_ALIGNMENT * MF);
        pH = H = (((int)pageonetextpanel.BOTTOM_ALIGNMENT * MF) - ((int)pageonetextpanel.TOP_ALIGNMENT * MF))
            + (((int)latestprodspanel.BOTTOM_ALIGNMENT * MF) - ((int)latestprodspanel.TOP_ALIGNMENT * MF));
        FirstPage.picturepagetextpanel.setBounds(pX = (int)pageonetextpanel.LEFT_ALIGNMENT * MF,
                pY = (int)pageonetextpanel.RIGHT_ALIGNMENT * MF, W, H);

        LiveDB.appframe.remove(pageonetextpanel);
        LiveDB.appframe.remove(latestprodspanel);        

        // first get all the paymodes from the table
        for (long id = 1; id <= LiveDB.indxpaymentType.size(); id++)
        {
             // grow the array 11th August 2012
             paymodes = paymodes == null ? new String[1] : Arrays.copyOf(paymodes, paymodes.length + 1);
             paymodes[paymodes.length -1] = ((PaymentType)LiveDB.LiveSharedDB[pt]
                     [(int)(long)LiveDB.indxpaymentType.get(String.valueOf(id))]).getPmt_type();
        }

        picprice = convertCurrency(((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).getPic_price());
        picdiscount = convertCurrency(((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).getPic_discount());
        pictitle = ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).getPic_title();
        keyval =  FirstPage.chosenlang + p_piccode + "JNarrative";

        file = LiveDB.indx3languageTransalations.get(keyval);
        narrativesfile = file == null ? unavailable.toString():file.toString();

        autotransalate = false;
        do
        {
            // grow this array 11th August 2012
            productoptions = productoptions == null ? new String[1] : Arrays.copyOf (productoptions, optid);
            if ((productoptions[optid -1] = LiveDB.indxpictureOptions.get(SelectedLanguage + optid)) == null)
            {
                // a row maybe missing for selected language code
                // the data entry may not have been done. So we take the english record
                // grow this array 11th August 2012
                productoptions = productoptions == null ? new String[1] : Arrays.copyOf (productoptions, optid);
                if ((productoptions[optid -1] = LiveDB.indxpictureOptions.get("en" + optid)) == null)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "PictureOptions table Data Entry Incomplete"
                            + "\n" + "Table Misses Row for Product Option ID:" + optid);
                    System.exit(1);
                }else autotransalate = true;
            }
            optid++;

        }while (optid <= LiveDB.indxpictureOptions.size());

        // Now there is a way to transalate automatically even if you pick the english record and
        // have not done the data entry for other languages.
                                                             // true = shallow transalation
        if (autotransalate) productoptions = LiveDB.transalatethisline(productoptions, true);


        optid = 1;
        autotransalate = false;
        do
        {
            // grow this array 11th August 2012
            subopts = subopts == null ? new String[1] : Arrays.copyOf(subopts, optid);
            if ((subopts [optid -1] = LiveDB.indx2pictureOptions.get(optid + SelectedLanguage)) == null)
            {
                // a row maybe missing for selected language code
                // the data entry may not have been done. So we take the english record
                // this application is supposed to make such intelligent switches everywhere minimizing
                // the need for switches.
                if ((subopts [optid -1] = LiveDB.indx2pictureOptions.get(optid + "en")) == null)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "PictureOptions table Data Entry Incomplete"
                            + "\n" + "Table Misses Row for Product Sub Option ID:" + optid);
                    System.exit(1);
                }else autotransalate = true;
            }
            stripped = strip (subopts[optid -1]);
            if (autotransalate)
                stripped = LiveDB.transalatethisline(stripped, false); // deep transalation
            for (int i = 0 ; i < stripped.length; i++)
            {
                 // grow array 11th August 2012
                 productsuboptions = productsuboptions == null ? new String [1][0] :
                         Arrays.copyOf(productsuboptions, optid);
                 productsuboptions [optid -1] = Arrays.copyOf(productsuboptions[optid -1], i + 1);
                 productsuboptions[optid -1][i] = stripped[i].toString();
            }
            optid++;
        }while (optid <= LiveDB.indx2pictureOptions.size());


        FirstPage.picturepagetextpanel.add(location, setConstraints(0,0,2,1));
        catname = new JLabel(((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).getPic_category());
        FirstPage.picturepagetextpanel.add(catname, setConstraints(3,0,2,1));
        pictit = new JLabel (pictitle);
        pictit.setForeground(Color.BLUE);
        pictit.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        FirstPage.picturepagetextpanel.add(pictit, setConstraints(0,2, 2, 1));

        filename = ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).getPic_img_location();

        try{
            image = ImageIO.read(new File(filename));
        }catch (IOException ex_YESKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Picture File:" + filename));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
        }

        fileptr = new File (filename);
        try{
              ImageIn = ImageIO.createImageInputStream(fileptr);
        }catch (IOException ex_YESKIA98){
                System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" + filename));
                LiveDB.system_exit = 1;
               // LiveDB.SmoothExitCondition.signalAll();
        }

        if (filename.lastIndexOf('.') == -1)
            suffix = "jpg";
        else
        {
            if (filename.lastIndexOf('.') == filename.length() - 1)
                suffix = "jpg";
            else
                suffix = filename.substring(filename.lastIndexOf('.') + 1, filename.length());
        }

        iter = ImageIO.getImageReadersBySuffix(suffix);
        reader = iter.next();
        reader.setInput(ImageIn);

        try{
             W = reader.getWidth(0);
             H = reader.getHeight(0);
        }catch (IndexOutOfBoundsException ex_NOKIA8){
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper(ex_NOKIA8));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA66){
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper(ex_NOKIA66));
            LiveDB.system_exit = 1;
           // LiveDB.SmoothExitCondition.signalAll();
        }

        if (W > H)
        {
            potrait = false;
            W = 6 * 3;
            H = 4 * 3;
        }
        else
        {
            potrait = true;
            H = 6 * 3;
            W = 4 * 3;
        }

        FirstPage.DrawImage(((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)rw]).getPic_img_location(),
                FirstPage.picturepagetextpanel, (int)(FirstPage.picturepagetextpanel.RIGHT_ALIGNMENT * MF)/4,
                4, W, H, potrait);
        
        fl = new File (narrativesfile);
        try{
        fr = new FileReader (fl);
        }catch (FileNotFoundException ex_NOKIA41){
            System.err.println(LiveDB.grassHopper(ex_NOKIA41, "File:" + narrativesfile));
            LiveDB.system_exit = 1;
           // LiveDB.SmoothExitCondition.signalAll();
        }

        br = new BufferedReader(fr);

        for (int i = 0; nl[i] != null; i++)
        {
            try{
               // grow array 11th August 2012
               nl = nl == null ? new String[1]:Arrays.copyOf(nl, i+1); 
               nl[i] = br.readLine();
            }catch (IOException ex_YESKIA78){
              System.err.println(LiveDB.grassHopper(ex_YESKIA78, "File:" + narrativesfile));
              // dont exit chalega if some narratives lines are missing
            }
        }

        try{
            br.close();
        }catch (IOException ex_YESKIA87){
              System.err.println(LiveDB.grassHopper(ex_YESKIA87, "File:" + narrativesfile));
              // dont bother to exit as long as we have read the file.
              // Its okay not to close the stream and leave it open.
        }

        // if you change the font size tomorrow then reduce it to 7 words per line
        for (int i = 0, k = 0; i < nl.length; i++, k++)
        {
             // grow array 11th August 2012
             splitlines = splitlines == null ? new String[1][0]:Arrays.copyOf(splitlines, k + 1);
             splitlines[k] = LiveDB.splitthisline(nl[i]);
        }

        NPanel = new JPanel (new BoxLayout(NPanel, BoxLayout.PAGE_AXIS));

        for (int i = 0, j = 0; i < splitlines.length ; i++, j++)
        {
            for (int k = 0; k < splitlines[i].length; k++, j++)
            {
                // grow this array 11th August 2012
                NLines = NLines == null ? new JLabel [1] : Arrays.copyOf(NLines, j+1);
                NLines[j] = new JLabel (splitlines[i][k]);
                NLines[j].setForeground(Color.BLACK);
                NLines[j].setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 9));
            }
        }

        NPanelScroll = new JScrollPane (NPanel);
        NPanelScroll.setBounds(X, 4 + H + 5, oW, ML);

        for (int i = 0; i < NLines.length; i++)
            NPanel.add(NLines[i]);

        price.setForeground(Color.BLACK);
        price.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        FirstPage.picturepagetextpanel.add(price, setConstraints(0,Y = (int)(NPanelScroll.BOTTOM_ALIGNMENT * MF) + 1,1,1));

        fullprice = new JLabel (Symbol + String.valueOf(picprice));
        fullprice.setForeground(Color.BLACK);
        
        if (picdiscount > 0)
        {
           fullprice.setFont(new Font (LiveDB.USEFONT, Font.CENTER_BASELINE, 10));
           discprice = new JLabel(Symbol + String.valueOf(picprice - picdiscount));
           discprice.setForeground(Color.RED);
           discprice.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 10));
           FirstPage.picturepagetextpanel.add(fullprice, setConstraints(0,Y,1,1));
           FirstPage.picturepagetextpanel.add(discprice, setConstraints(1,Y,1,1));
        }
        else
        {
           fullprice.setFont(new Font (LiveDB.USEFONT, Font.PLAIN, 10));
           FirstPage.picturepagetextpanel.add(fullprice, setConstraints(0,Y,1,1));
        }

        tellafriend.setForeground(Color.BLUE);
        tellafriend.setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 10));
        FirstPage.picturepagetextpanel.add(tellafriend, setConstraints(1,Y = Y + 2,2,1));
        tellafriend.addMouseListener(new MouseListener (){

            @Override
            public void mousePressed (MouseEvent evnt){
                tellafriend.setForeground(Color.RED);
                tellafriend.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt){
                tellafriend.setForeground(Color.BLUE);
                tellafriend.validate();
            }

            @Override
            public void mouseEntered (MouseEvent evnt){
                tellafriend.setForeground(Color.RED);
                tellafriend.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt){
                tellafriend.setForeground(Color.BLUE);
                tellafriend.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt){
                retval = new TellAFriend (p_piccode); // 17th August 2012
            }
        });

        // The Product Options must not be displayed if the picture code does not start with
        // PIC.

        if (p_piccode.indexOf("PIC") == 0 || p_piccode.indexOf("pic") == 0)
        {
        prodopts.setForeground(Color.BLACK);
        prodopts.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 10));
        FirstPage.picturepagetextpanel.add(prodopts, setConstraints(0,Y = Y + 1,2,1));

        optid = 1;
        for (int i = 0; i < productoptions.length; i++, optid++)
        {
            // grow the array 11th August 2012
            prodoptlabel = prodoptlabel == null ? new JLabel[1] : Arrays.copyOf(prodoptlabel, i + 1);
            prodoptlabel [i] = new JLabel (productoptions[i]);
            prodoptlabel [i].setForeground(Color.BLACK);
            prodoptlabel [i].setFont(new Font(LiveDB.USEFONT, Font.BOLD, 10));
            FirstPage.picturepagetextpanel.add(prodoptlabel[i], setConstraints(0,Y = Y + 1,3,1));
            // grow the array 11th August 2012
            prodsuboptcombo = prodsuboptcombo == null ? new JComboBox [1] : Arrays.copyOf(prodsuboptcombo, optid);
            prodsuboptcombo [optid -1] = new JComboBox (productsuboptions[optid -1]);
            prodsuboptcombo [optid -1].setSelectedItem(productsuboptions[optid -1][0]);
            FirstPage.picturepagetextpanel.add(prodsuboptcombo[optid -1], setConstraints(5,Y = Y + 1,4,1));
        }
        }

        prodcode.setForeground(Color.BLACK);
        prodcode.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 10));
        FirstPage.picturepagetextpanel.add(prodcode, setConstraints(0,Y = Y + 2,3,1));
        FirstPage.picturepagetextpanel.add(new JLabel (p_piccode), setConstraints(5,Y,1,1));

        quantity.setForeground(Color.BLACK);
        quantity.setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 10));

        FirstPage.picturepagetextpanel.add(PaymentMode, setConstraints(1, Y = Y + 2, 3, 1));
        paymentvia = new JComboBox (paymodes);
        FirstPage.picturepagetextpanel.add(paymentvia, setConstraints(5, Y, 4, 1));
        paymentvia.setSelectedIndex(0);

        FirstPage.picturepagetextpanel.add(quantity, setConstraints(12,Y,2,1));
        FirstPage.picturepagetextpanel.add(qtyfld = new JTextField ("1", 3), setConstraints(15,Y,3,1));
        qtyfld.createToolTip().setToolTipText("Non Decimal Numeric Quantity Only");
        
        qtyfld.addInputMethodListener(new InputMethodListener (){

            @Override
            public void inputMethodTextChanged(InputMethodEvent event){
                try{
                    Integer.parseInt(qtyfld.getText());
                }catch (NumberFormatException ex_YESKIA71){
                    qtyfld.setText("1");
                    qtyfld.setFocusable(true);
                }
            }

            @Override
            public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
            }
        });


        addbasket.setBackground(Color.BLUE);
        addbasket.setForeground(Color.WHITE);
        addbasket.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 8));

        FirstPage.picturepagetextpanel.add(addbasket, setConstraints(20,Y,3,1));

        addbasket.addMouseListener(new MouseListener (){
            final Float suboptdeductions = 0.0f; // Added on 11th June 2012
            final Float suboptadditions = 0.0F; // Added on 11th June 2012

            @Override
            public void mousePressed (MouseEvent evnt){
                addbasket.setBackground(Color.RED);
                addbasket.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt){
                addbasket.setBackground(Color.BLUE);
                addbasket.validate();
            }

            @Override
            public void mouseEntered (MouseEvent evnt){
                addbasket.setBackground(Color.RED);
                addbasket.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt){
                addbasket.setBackground(Color.BLUE);
                addbasket.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt){
                // lumba chowdah processing of customer order
                String chosensubopts = "*";
                long rid = 0L;
                boolean found = false;
                
                for (int i = 0; i < prodsuboptcombo.length; i++)
                {
                     chosensubopts = chosensubopts + prodsuboptcombo[i].getSelectedIndex() + '*';
                     // Changes on 11th June 2012
                     suboptadjustments(suboptdeductions, suboptadditions, (String)prodsuboptcombo[i].getSelectedItem());
                }

                if (LiveDB.indx1shoppingCart.get(LoginPage.LoggedInCID + p_piccode + chosensubopts) == null)
                {
                    // not there insert a fresh row in ShoppingCart table
                    insertnewrow (p_piccode, chosensubopts, Long.parseLong(qtyfld.getText()),
                    (Long.parseLong(qtyfld.getText()) * picprice) - (Long.parseLong(qtyfld.getText()) * picdiscount),
                            (Long.parseLong(qtyfld.getText()) * picdiscount));

                }
                else
                {
                    rid = LiveDB.indx1shoppingCart.get(LoginPage.LoggedInCID + p_piccode + chosensubopts);
                    
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getShopdate() != null)
                    {
                        // previously an identical order has been placed and purchase order raised
                        // so start searching from this rowid onwards for the next row where
                        // the shop date is null. The shop date must only be filled when the user
                        // confirms the order.
                        for (int rw = (int)rid; rw < LiveDB.LiveSharedDB[sc].length; rw++)
                        {
                            if (((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getShopdate() == null)
                            {
                               found = true;
                               rid = ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRowid();
                            }
                        }
                    }
                    else
                    {
                        // shop date is null
                        // Update this rowid in the ShoppingCart table
                        updaterow (Long.parseLong(qtyfld.getText()),(Long.parseLong(qtyfld.getText()) * picprice)
                            - (Long.parseLong(qtyfld.getText()) * picdiscount),
                            (Long.parseLong(qtyfld.getText()) * picdiscount), rid);
                        return;
                    }
                }

                if (found)
                    // update the same row
                    updaterow (Long.parseLong(qtyfld.getText()),(Long.parseLong(qtyfld.getText()) * picprice)
                            - (Long.parseLong(qtyfld.getText()) * picdiscount),
                            (Long.parseLong(qtyfld.getText()) * picdiscount), rid);
                else
                    // not there insert a fresh row in ShoppingCart table
                    insertnewrow (p_piccode, chosensubopts, Long.parseLong(qtyfld.getText()),
                    (Long.parseLong(qtyfld.getText()) * picprice) - (Long.parseLong(qtyfld.getText()) * picdiscount),
                            (Long.parseLong(qtyfld.getText()) * picdiscount));

            } // public void mouseClicked (MouseEvent evnt)


            // This method added on 11th June 2012
            private void suboptadjustments (Float p_adjustdisc, Float p_adjustotal, String p_subopt){
            // p_subopt may be any one String as below in one invocation of this method
            // Circle (+$10.00),  Parallelogram (+$15.00), Rectangle, Six Sided (+$10.00), Square (+$5.00)
            // Exquisite (+$20.00), Sandwich (+$10.00), Simple, Wood Laminate (-$135.00)
            // we are going to get the plus(+) amts and place them in p_adjusttotal
            // and we are going to get the minus(-) amts and place them in p_adjustdisc
                int ndx = 0;

                if ((ndx = p_subopt.indexOf("$")) == -1)
                {
                    p_adjustdisc = 0.0f;
                    p_adjustotal = 0.0F;
                    return;
                }
                else
                {
                    if (ndx == 0)
                        p_adjustotal += Float.parseFloat(getdigits(p_subopt, 1));
                    
                    else if (ndx > 0)
                    {
                        if (p_subopt.toCharArray()[ndx -1] == '-')
                            p_adjustdisc += Float.parseFloat(getdigits(p_subopt, ndx));
                        else
                            p_adjustotal += Float.parseFloat(getdigits(p_subopt, ndx));
                    }
                }                
            }


            // This method added on 11th June 2012
            // This will parse the string for digits or float values and return that portion of p_string
            private String getdigits (String p_string, int p_indx){

                // if digits = p_string.substring ... the max can be a number string such as $135.59
                String ifdigit = p_string.substring(p_indx + 1, p_indx + 7);
                char checkchars [] = ifdigit.toCharArray();
                int i = checkchars.length - 1;

                for (; i > 0; i--)
                    if (Character.isDigit(checkchars[i]))
                        break;

                ifdigit = ifdigit.substring(p_indx + 1, i+1);

                try{
                    Float.parseFloat(ifdigit);
                }catch (NumberFormatException ex_NOKIA23){
                    LiveDB.ALRTLVL = 3;
                    System.err.println (LiveDB.grassHopper(ex_NOKIA23,
                                 "Possible Error Data Entry PictureOptions table Sub Options"));
                    return "0.00";
                }

                return ifdigit.toString();
            }
            
            private void insertnewrow (String p_piccode, String p_chosensubopts, long p_qty, float p_total, float p_disc )
            {
             /* public ShoppingCart (String p_Cid, String p_Pic, String p_PO, String p_Sub_opt_id,
                   long p_Pmtid, long p_Pic_qty, float p_Total, long p_Billed, Date p_Shopdate,
                   long p_Ordernumber, float p_Orderdiscount, long p_Rma, long p_Rowid )
              */

              LiveDB.LiveSharedDB[sc][LiveDB.growMore(sc)] = 
                     new ShoppingCart (LoginPage.LoggedInCID, p_piccode, null, p_chosensubopts,
                     paymentvia.getSelectedIndex() == -1 ? 1: paymentvia.getSelectedIndex() +1,
                     p_qty, p_total + suboptadditions, 0L, null, 0L, p_disc + suboptdeductions, 0L,
                     (long)LiveDB.LiveSharedDB[sc].length -1);

              // Now insert a new row in ChangeTracker for this table
              LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                   new ChangeTracker (sc,LiveDB.LiveSharedDB[sc].length -1, 'I', LiveDB.pid, new Date (),
                       LiveDB.LiveSharedDB[sc][(int)LiveDB.LiveSharedDB[sc].length -1],
                       (long)LiveDB.LiveSharedDB[ct].length -1);
            }

            private void updaterow (long p_qty, float p_total, float p_disc, long p_rid)
            {
                ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)p_rid]).setPic_qty(p_qty);
                ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)p_rid]).
                        setOrderdiscount(p_disc - suboptdeductions);
                ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)p_rid]).setTotal(p_total + suboptadditions);
                ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)p_rid]).setBilled(0L);
                ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)p_rid])
                  .setPmtid(paymentvia.getSelectedIndex() == -1 ? 1: paymentvia.getSelectedIndex() + 1);

                // add a ChangeTracker entry for this here
                LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                   new ChangeTracker (sc,p_rid, 'U', LiveDB.pid, new Date (),
                       LiveDB.LiveSharedDB[sc][(int)p_rid],
                       (long)LiveDB.LiveSharedDB[ct].length -1);
            }            
        });

        LiveDB.appframe.add(FirstPage.picturepagetextpanel, setConstraints (pX, pY, pW, pH));
        FirstPage.picturepagetextpanel.validate();
        
    }


    String [] strip (String p_strip)
    {
        int si = 0, ei = 0, ii = 0;

        eachstr = null;

        while ((ei = p_strip.indexOf(LiveDB.fieldseperator)) != -1)
        {
            // grow the array 11th August 2012
            eachstr = eachstr == null ? new String [1] : Arrays.copyOf(eachstr, ii + 1);
            eachstr[ii] = p_strip.substring(si, ei);
            ii++;
            if (ei + 1 < p_strip.length())
                p_strip = p_strip.substring(ei + 1, p_strip.length());
            else break;
        }

        return eachstr;
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
