/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.io.*;
import java.util.Date;
import java.util.concurrent.Semaphore;
import static MaintainData.LiveDB.ft;
import static MaintainData.LiveDB.ct;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:WriteTables.java  --- Take a Quick Look
 * @LOOKSY:InstalledTables.java  --- Take a Quick Look
 * @LOOKSY:FileTableDataFileMap.java  --- Take a Quick Look
 * @LOOKSY:ArtLeavesInterfaces.java  --- Take a Quick Look
 * @LOOKSY:RefreshDatabase.read_database()  --- Take a Quick Look
 * @LOOKSY:LiveDB.indxinstalledTables, LiveDB.CopyFile, LiveDB.commit_database(), LiveDB.write_IndexFile()
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.ALRTLVL, LiveDB.Action, LiveDB.maxtables, LiveDB.IPCSTrigger,
 * @LOOKSY:LiveDB.TrainsInWaiting, LiveDB.IPCSCondition, LiveDB.IPCSLOCK
 *
 * Class Name : PlatformClearance implements Externalizable, Cloneable, Tables
 *              Contains Instance of class TrainRunningInformation implements Serializable, Cloneable
 *
 * Methods : Look in Class definition
 * This constructor method is very complicated and so i will take a few lines to explain what it does.
 * TERMINALA replaces rowlock. It is just another semaphore. I find it more sensible to use these for
 * rowlocks. A couple of setters follow. Now whenever there is an Action that involves a write to the
 * database table. How do you know that the other bugar is not writing also ? So we create a .syc file
 * on disk using a LiveDB.IPCSTrigger(Object number) which is the table number in this release. It can
 * also be a sort number and index number. But we are not using it thataways yet. So the constructor
 * needs to delete the old .syc file first before creating a new one.  That trigger will check for the 
 * existence of a file on disk for the same ObjectNumber and create it if not found. That trigger takes
 * care of placing the thread on hold to keep waiting for the IPCSCondition and also does a SignalAll 
 * automatically. You wont have to bother about it in your code at all. In short every process that 
 * writes must create a File name synchronizedfilespath + "ipcssync_objid".syc and delete that file when
 * it has finished writing. CONFUSING ?? Dont read this at all. I have also allowed my imagination to
 * run wet and wild on those advanced type enums dont let that happen or you will never get to bed with
 * your spouse.
 *
 * The Tables Interface has been faked except COMMIT, COMMITINDEXES, REFRESH because I dont want you doing
 * naughty things with this table.
 *
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding.
 *
 * Relevant Indexes : LiveDB.indx1platformClearance
 * searchkey = Integer.toString(((PlatformClearance)getEntirerow()).getRequestno()) + Long.toString(((PlatformClearance)getEntirerow()).getSid())
 * searchkey returns Long rowid which is the rowid for this table.
 *
 * LiveDB.indxplatformClearance
 * searchkey = AnyValidDate.getTime 
 * searchkey returns Long rowid which is the rowid for this table
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : The purpose of this table is to register all I/O requests in the database. All
 * JVM instances of this application have to use this table to queue all their database I/O requests and
 * wait for their turn before proceeding with their I/O on the database. This is done by invoking the
 * constructor for this table with parameters. One of the parameters is request number. So your process
 * has to wait for its request number in the queue LiveDB.TrainsInWaiting. Wait for its request number
 * means waiting for the turn of the request number to be served. Look at the source code for LiveDB.
 * QueueTrainsInWaiting for a clearer understanding of waiting for the turn of the request number.
 * Having invoked this table constructor the reference is passed to LiveDB.QueueTrainsInWaiting for
 * queuing your request in LiveDB.TrainsInWaiting. This TrainsInWaiting is an ArrayDeque (works like
 * Queue class) on a FIFO basis. This ArrayDeque is of Type PlatformClearance. This queue constructed with
 * this table references acts as a synchronization mechanism for all LiveDB.Action posted by this instance
 * of running app. And when the request is completed it is also de-queued from LiveDB.TrainsInWaiting.
 * So any thread has to offer a I/O request (LiveDB.Action) for the Queue TrainsInWaiting to accept.
 * Now the understanding is that for any database related activity your thread must read only after a write
 * has happened by some other thread if a request has been placed in the queue for the same database object
 * (database object meaning a table or index). So only after the write request for table is done you read if
 * and only if a write request for the same table or index had already been queued previously. Whatever be
 * the type of request you must wait your turn patiently. This is as far as the queue TrainsInWaiting is concerned. Now the underlying table
 * PlatformClearance will also contain historical record of all database activity which I purge frequently
 * in Spy.java method public boolean LostSouls (). You dont have to worry about synchronization with other
 * processes on the system since the queue contains a reference to this table always and this table gets
 * refreshed constantly and also the constructor method creates a file on disk to avoid collisions.
 * This TrainsInWaiting is specific to your process (JVM instance of this application) and I dont merge
 * the different queues anywhere periodically. 
 *
 * Technical References : Buy and Read Asterix the Soothsayer.
 * Table Dedicated To: Joe Zawinul and Wayne Shorter
 *
 * Start Date: 18th October 2010
 * End Date: 16th May 2011
 *
 * Last Modified : 16th April 2012
 * Last Modifications : see changes to clone() method.
 *
 * Last Modification Date : 3rd June 2012
 * Last Modifications : Validated parameter p_Rowid in constructor for negative values before assigning
 * to rowid
 * Also changed some hardcoding in initialization blocks pcn = LiveDB.pc, itn = LiveDB.it
 *
 * Last Modification Date: 7th June 2012
 * Last Modifications : Just updated the running commentary above since it was originally written yak yak
 * yak at the Speed of Thought and was not clear to anybody
 * 
 * Last Modification Date : 15th Augustus 2012
 * Last Modification : Through out this source file I have added this call to LiveDB.growMore(ct)
 * whereever I am growing the LiveDB.LiveSharedDB array with a call to new.
 * growMore is a popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash. And when you cook
 * vegetable add Harissa (mild Afrikan spice from North Afrika) one ladel along with Bagar.
 *
 * Last Modification Date : 10th September 2012
 * Last Modifications : declared a new variable thisrow and its usage
 * 
 * Last Modification Date : 11th September 2012
 * Last Modifications : removed TERMINALA.acquireUninterruptibly(); and TERMINALA.release()
 * statements from the clone method because each of the setters will do the above.
 * 
 * Last Modification Date : 12th September 2012
 * Last Modifications : In method protected TrainRunningInformation getTrainid()
   the last code which has now been removed is as below       
        tri = (TrainRunningInformation) this.trainid.clone();
        tri.trackname = tri.trackname.trim();
        tri.line = tri.line.trim();
        return tri;       
 * Dont clone and return because it causes problems with ArrayDeque TrainsInWaiting methods like
 * peek(), peekLast() etc or any others that you may want to use in future.
 * 
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class PlatformClearance implements Externalizable, Cloneable, Tables {
        private int requestno;  /* random generation */
        private long sid ;  /* station id or process id */
        private int request_type; /* valid request types enum Action */
        private Date request_time;
        private TrainRunningInformation trainid;
        private long rowid; /* 6 FIELDS */

        private static final long serialVersionUID = 99979L;
        private transient int thisrow;
        private transient long fieldchanges;
        private transient TrainRunningInformation TRI; // this is just for manipulating and returning trainid
        private transient int pcn ;
        private transient File srf;
        private transient int itn;        
        private transient PlatformClearance pf;        
        private transient Semaphore TERMINALA;  // for international flights

        
        // initialization block
        {
           thisrow = 0;
           TRI = null;
           fieldchanges = 0L;
           pcn = LiveDB.pc;
           srf = null;
           itn = LiveDB.it;
           pf = null;
           TERMINALA = new Semaphore (1,true);           
        }
        
        public PlatformClearance () {
            requestno = 0;
            sid = 0;
            request_type = 0;
            request_time = new Date ();
            trainid = null;
            rowid = 0;
        }
        
        public PlatformClearance ( int p_Requestno, long p_Sid,int p_Request_type, 
                                   Date p_Request_time, TrainRunningInformation p_Trainid, long p_Rowid)
        {            
            
            setRequestno(p_Requestno);
            TERMINALA.acquireUninterruptibly();
            sid = p_Sid;
            TERMINALA.release();
            setTrainid(p_Trainid);
            setRequest_type(p_Request_type);
            setRequest_time(p_Request_time);
            

            TERMINALA.acquireUninterruptibly();
            if (LiveDB.LiveSharedDB[pcn] == null && p_Rowid != 0)
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Invalid rowid:" + String.valueOf(p_Rowid)));
                System.exit(1);
            }

            if (p_Rowid >= 0)
                rowid = p_Rowid;
            else
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Negative Rowid:" + p_Rowid));
                System.exit(1);
            }
            
            
            
            if (this.request_type == LiveDB.IOAction.WRITEOBJECT.ordinal() || this.request_type == LiveDB.IOAction.FASTCOMMIT.ordinal() ||
                this.request_type == LiveDB.IOAction.WRITELINE.ordinal())
            {
                // delete the previous ipcsfile created if certain conditions are met
                thisrow = LiveDB.LiveSharedDB[pcn].length -2;
                if ((((TrainRunningInformation)
                   ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getTrainid()).getTrain() == this.trainid.getTrain()
                   && ( ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getRequest_type()
                   == LiveDB.IOAction.FASTCOMMIT.ordinal() || ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getRequest_type()
                   == LiveDB.IOAction.WRITEOBJECT.ordinal() || ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getRequest_type()
                   == LiveDB.IOAction.WRITELINE.ordinal() )))
                {
                    /* if the previous write was on the same tableno or index number */
                    /* so go into a loop until accidenttime and arrivaltime is null.
                     * After that delete the file */
                    tohover:
                    while ((((TrainRunningInformation)
                        ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getTrainid()).getArrivaltime()
                         == null && ((TrainRunningInformation)
                        ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getTrainid()).getAccident()
                            == null))
                                          continue tohover;
                    LiveDB.IPCSTrigger(-1); // -1 or less than zero value will delete old ipcsfile[s]
                }
                else if ((((TrainRunningInformation) // this table number is not the same as previous entry
                   ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getTrainid()).getTrain() != this.trainid.getTrain()
                   && ( ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getRequest_type()
                   == LiveDB.IOAction.FASTCOMMIT.ordinal() || ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getRequest_type()
                   == LiveDB.IOAction.WRITEOBJECT.ordinal() || ((PlatformClearance)(LiveDB.LiveSharedDB[pcn][thisrow])).getRequest_type()
                   == LiveDB.IOAction.WRITELINE.ordinal() )))
                   LiveDB.IPCSTrigger(-1); // -1 or less than zero value will delete old ipcsfile[s]
              
                LiveDB.IPCSTrigger(this.trainid.getTrain()); // now the trigger will create a new ipcsfile
            }
            TERMINALA.release();
        }

        @Override
        protected Object clone () {
            
            try{
              pf = (PlatformClearance)super.clone();
              pf.setRequest_time(pf.getRequest_time());
              pf.trainid = (TrainRunningInformation)trainid.clone();
            }catch (CloneNotSupportedException ex_NOKIA46){
                // this is not possible unless a programming screwup so throw unchecked error
                throw new InternalError (ex_NOKIA46.toString());
            }
            
            return pf;
        }

    @Override
    public final void writeExternal (ObjectOutput stream) throws IOException {

        TERMINALA.acquireUninterruptibly();
        int itr = -1; // Installed table row in InstalledTables
        int thisrow = 0;
        String file = null;

        // first find the rowid for this table pcn = 17 in InstalledTables
        if (LiveDB.indxinstalledTables.get(Integer.toString(pcn)) == null)
        {
            LiveDB.ALRTLVL = 4;
            System.err.println(LiveDB.grassHopper("PlatformClearance misses entry for self in indxinstalledTables"));
            // perhaps the index is corrupted so check the physical table
            for (int i = 0; i < LiveDB.LiveSharedDB[itn].length; i++)
            {
                if (((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getTableno() == pcn)
                   itr = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getRowid();
            }

            if (itr == -1 || itr > LiveDB.maxtables)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("PlatformClearance misses entry for self in indxinstalledTables"));
                System.exit(1);
            }
        }
        else
            itr = (int)(long)LiveDB.indxinstalledTables.get(Integer.toString(pcn));

        thisrow = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).getTableno();
        file = ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][thisrow]).getFilename();
        file = LiveDB.serializedfilespath + file + ".ser";
        srf = new File (file);

        // outsize should be negative before every write
        TERMINALA.release();
        if (srf.exists())
           ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        else ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(-1L);
        TERMINALA.acquireUninterruptibly();
        
        // The following code has been commented out to avoid a java.lang.OutOfMemoryError
        // Its not all that important to backup the InstalledTables row each and every time
        // i say this Java is bad software memory hog
        /*
        thisrow = LiveDB.growMore(ct);        
        TERMINALA.release();
        LiveDB.LiveSharedDB[ct][thisrow] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], thisrow);
        TERMINALA.acquireUninterruptibly();
        * 
        */

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeInt(requestno);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91,"writeExternal Class PlatformClearance Field requestno"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PlatformClearance serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(sid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91,"writeExternal Class PlatformClearance Field sid"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PlatformClearance serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeInt(request_type);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class PlatformClearance Field request_type"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PlatformClearance serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(getRequest_time().getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class PlatformClearance Field request_time"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PlatformClearance serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              trainid.writeExternal(stream);              
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class PlatformClearance Field trainid"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PlatformClearance serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(rowid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class PlatformClearance Field rowid"));
              throw new IOException ();
        }

        
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during PlatformClearance serialization"));
            System.exit(1);
        }

        // setOutsize to positive value after every successfull write
        // so if there is a power outage in between we will know that there has been a serialization
        // failure and the serialized file is corrupted and take necessary steps to restpre the
        // serialized file from CrashRecovery or ChangeTracker or if both CrashRecovery and ChangeTracker
        // are corrupted then restore from last autobackup
        TERMINALA.release();
        if (srf.exists())
           ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length());
        else ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(0L);

        // The following code has been commented out to avoid a java.lang.OutOfMemoryError
        // Its not all that important to backup the InstalledTables row each and every time
        /*
        thisrow = LiveDB.growMore(ct);
        LiveDB.LiveSharedDB[ct][thisrow] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], thisrow);
        * 
        */
        
    }

    @Override
    public final void readExternal (ObjectInput stream) throws IOException, ClassNotFoundException {
   
        TERMINALA.acquireUninterruptibly();

        try{
              requestno = stream.readInt();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class PlatformClearance Field requestno"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class PlatformClearance Field requestno"));
              throw new IOException ();
        }

        try{
              sid = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class PlatformClearance Field sid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class PlatformClearance Field sid"));
              throw new IOException ();
        }

        try{
              request_type = stream.readInt();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class PlatformClearance Field request_type"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class PlatformClearance Field request_type"));
              throw new IOException ();
        }

        try{
              request_time = new Date(stream.readLong());
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class PlatformClearance Field request_time"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class PlatformClearance Field request_time"));
              throw new IOException ();
        }

        try{
            trainid = new TrainRunningInformation();
            trainid.readExternal(stream);
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class PlatformClearance Field trainid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class PlatformClearance Field trainid"));
              throw new IOException ();
        }

        try{
              rowid = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class PlatformClearance Field rowid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class PlatformClearance Field rowid"));
              throw new IOException ();
        }
        TERMINALA.release();
   }

   protected int SIZEOF(){
       
       return (4 + 8 + 4 + 8 + this.trainid.SIZEOF() + 8 );
   }

   protected int getRequestno (){
        return this.requestno;
   }
   protected long getSid(){
        return this.sid;
   }
   protected int getRequest_type(){
        return this.request_type;
   }
   protected Date getRequest_time() {
        return new Date(request_time.getTime());
   }
   protected TrainRunningInformation getTrainid(){
       // September 12th 2012
       /* this.trainid.trackname = this.trainid.trackname.trim();
        this.trainid.line = this.trainid.line.trim();
        */
        return this.trainid;        
   }
   
   protected long getRowid(){
       return this.rowid;
   }

   protected void setRequestno(int p_Request){
        TERMINALA.acquireUninterruptibly();
        this.requestno = p_Request;
        TERMINALA.release();
   }
   
   protected void setRequest_type(int p_Type){
            TERMINALA.acquireUninterruptibly();
            this.request_type = p_Type;
            if (this.request_type == LiveDB.IOAction.WRITEOBJECT.ordinal() 
                || this.request_type == LiveDB.IOAction.FASTCOMMIT.ordinal()
                || this.request_type == LiveDB.IOAction.WRITELINE.ordinal() )
                LiveDB.IPCSTrigger(this.trainid.getTrain());
            TERMINALA.release();
   }

   protected void setRequest_time (Date p_Time){
        TERMINALA.acquireUninterruptibly();
        this.request_time = new Date(p_Time.getTime());
        TERMINALA.release();
   }
   protected void setTrainid (TrainRunningInformation p_Trainid){
        TERMINALA.acquireUninterruptibly();
        this.trainid = (TrainRunningInformation)p_Trainid.clone();
        TERMINALA.release();
   }
   
   @Override
   public String toString(){
       String filher = "%";
       return String.valueOf(getRequestno()).concat(filher).concat(String.valueOf(getSid())).concat(filher)
              .concat(String.valueOf(getRequest_type())).concat(filher).concat(String.valueOf(getRequest_time().getTime()))
              .concat(filher).concat(getTrainid().toString()).concat(filher).concat(String.valueOf(getRowid()));
   }

   protected void setRowid (long p_row){
        TERMINALA.acquireUninterruptibly();
        this.rowid = p_row;
        TERMINALA.release();
   }

    // although each instance of this Class PlatformClearance represents a single row
    // we are committing the entire table here but before that a few checks and balances

    @Override
    public final boolean COMMIT(){
        
        boolean fnd = false;
 
        // we are committing the PlatformClearance table so mark those rows with change_flag 'F'
        for (int rw =  (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
            if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == pcn
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'F'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'C'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'K'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'T')
            {
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).setChange_flag('C');
                   fnd = true;
                   // insert an entry in ChangeTracker table for this table
                   // Basically what this does is to backup this entirerow where you
                   // setChange_flag('C') otherwise database reconstruct of ChangeTracker will fail.
                   thisrow = LiveDB.growMore(ct);
                   LiveDB.LiveSharedDB[ct][thisrow] =
                   new ChangeTracker ((long)ct,rw, 'U', LiveDB.pid, new Date (),
                   LiveDB.LiveSharedDB[ct][rw],(long)LiveDB.LiveSharedDB[ct].length -1);
            }
        }

        if (fnd)
        {
            // for the sake of dbfRepair we take a restore file which MAY be a BAD copy
            // since we are not checking for the presence of a .syc file on disk. If we
            // look for a .syc file on disk then this commit will take very very long.
            LiveDB.CopyFile(LiveDB.serializedfilespath 
                    + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][pcn]).getFilename() + ".ser",
                   LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
                   ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][pcn]).getFilename() + ".ser" + ".res");
            if ( LiveDB.commit_database(pcn) == false )
                return false;
        }
        
        return true;
    }

    @Override
    public final boolean COMMITINDEXES (){

        if (LiveDB.LiveSharedDB[pcn] == null)
            return false;
        return LiveDB.write_IndexFile(pcn);
    }

    @Override
    public final boolean REFRESH(){
        int pfc = 17;
        if (RefreshDatabase.read_database(pfc) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:class PlatformClearance
 * @LOOKSY:LiveDB.indxinstalledTables, LiveDB.ALRTLVL, LiveDB.Action, LiveDB.maxtables,
 *         LiveDB.TrainsInWaiting
 *
 * Class Name : TrainRunningInformation implements Serializable, Cloneable
 *
 * Methods : Look in Class definition
 * This constructor method is very complicated and so i will take a few lines to explain what it does.
 * Every time you construct a PlatformClearance object you also need to construct a TrainRunningInformation
 * object and pass it to that constructor. This instance of TrainRunningInformation contains a departure
 * time but accident time and arrival time will be null and running time will be zero. These are the times
 * for the various application actions listed at LiveDB.Action pertaining to a certain table number which
 * may be a real table or a fake table from 18 thru 50 like LiveDB.RunAwayBrideReport(). When LiveDB.Action
 * is completed the other stats like accident time (if error) or arrival time is filled in and cloned and
 * the PlatformClearance table is made to point to this clone.
 *
 * The Tables Interface is not implemented here
 *
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding.
 *
 * Relevant Indexes : LiveDB.indxplatformClearance
 * searchkey = Integer.toString(((PlatformClearance)getEntirerow()).getRequestno()) + Long.toString(((PlatformClearance)getEntirerow()).getSid())
 * searchkey returns Long rowid which is the rowid for this table.
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This is a contained class. It contains some usefull stats from a reporting angle
 * and you could also use this for ThunderBall tuning and posting speed limits for various threads. I am
 * not doing it as of now due to lack of time but will do so in next release. Remember that original shloka
 * aaj karanthaa kul kar. kul karanthaa parson. parson karantha narson from the city of hyderabad otherwise
 * the code will be filled with bugs (they taught you to count only 99 right ??).
 *
 * Technical References : Buy and Read Asterix the Soothsayer.
 * Table Dedicated To : Jaco Pastorius
 *
 * Start Date: 18th October 2010
 * End Date: 17th May 2011
 *
 * Last Modified : 16th April 2012
 * Last Modifications : New Declaration
 * private transient TrainRunningInformation tri;
 * Also see changes to clone() method. It returns tri now
 * 
 * Last Modification Date : 8th August 2012
 * Last Modifications : As Below
       // Every writeUTF writes two extra bytes of length info to file/stream 
       // so we must add those extra two bytes for every writeUTF to the return value of SIZEOF
       int utfextras = 2 * 2;
 * 
 * Last Modification Date : 6th September 2012 
 * Last Modifications : Marked as 6th September 2012
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

class TrainRunningInformation implements Externalizable, Cloneable {
        private int train; /* Either a tableno or index no or sorttable no */
        private long track; /* thread id Thread.currentThread.getId() */
        private int itrack; /* internal track or internal thread id as in ThreadController.DashBoardGPS */
        String trackname ; /* thread name */
        String line ; /* Which line South, North , North Western, East basically a threadgroup that created this thread Threadgroup.getName()*/
        private Date departuretime; /* departure time request execution start time */
        private Date arrivaltime; /* arrival time request completion time */
        private Date accident; /* accident time if request derails due to Yank or some other reason */
        private long runningtime; /* time taken to complete request */

        private static final long serialVersionUID = 99919L;
        
        private transient TrainRunningInformation tri;
        private transient long fieldchanges;
        private transient int pcn;
        private transient int metadatasize;
        private transient Semaphore TERMINALB;

        {
            tri = null;
            fieldchanges = 0L;
            pcn = 17;
            metadatasize = 0;
            TERMINALB = new Semaphore(1,true);
        }
        
        public TrainRunningInformation () {
            train =  itrack = 0;
            track = 0L;
            trackname = " ";
            line = " ";
            departuretime = new Date();
            arrivaltime = new Date ();
            accident = new Date ();
            runningtime = 0L;
        }
        
        public TrainRunningInformation ( int p_Train, long p_Track, String p_Trackname, String p_Line, Date p_Departuretime, Date p_Arrivaltime,
                Date p_Accident, long p_Runningtime ){
            train = p_Train;
            track = p_Track;
            itrack = ThreadController.getcurrenthread();
            setTrackname(p_Trackname);
            setLine(p_Line);
            setDeparturetime(p_Departuretime);
            setArrivaltime(p_Arrivaltime);
            setAccident(p_Accident);
            setRunningtime(p_Runningtime);
            
        }
        // Now do you understand why I have used primitive types inside classes
        // otherwise you will have to serialize any object and then deserialze
        // it into a new reference variable to create a copy of an object in Java
        // otherwise create a new instance and then copy yourself one attribute at
        // a time. Remember some objects such as Wrappers are immutable and so it
        // doesent make sense to clone and so they are not cloneable either.
        // but you can do your own copy constructor if the class is final
        // otherwise slicing can happen
        @Override
        protected Object clone () {
            try{
               tri = (TrainRunningInformation) super.clone ();
              /* Now do those funny things Both original and clone are
               * referencing the Same String objects trackname and line.
               * Therefore take the original and explicit copy and reassign
               * to clone. Do the same with any Object references other than
               * String.
               */
              // Thanks to a lesson from Bill Venneer
               tri.setTrackname(tri.getTrackname());
               tri.setLine(tri.getLine());
               tri.setDeparturetime(tri.getDeparturetime());
               tri.setArrivaltime(tri.getArrivaltime());
               tri.setAccident(tri.getAccident());
            }catch (CloneNotSupportedException ex_NOKIA47){
                // this is not possible so throw unchecked error
                throw new InternalError (ex_NOKIA47.toString());
            }
            return tri;
        }

   @Override
   public final void writeExternal (ObjectOutput stream) throws IOException {
       

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeInt(train);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field train"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(track);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field track"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeInt(itrack);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field itrack"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(trackname);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field trackname"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(line);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field line"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(getDeparturetime() == null ? 0L: getDeparturetime().getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field departuretime"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(getArrivaltime() == null ? 0L: getArrivaltime().getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field arrivaltime"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(getAccident() == null ? 0L: getAccident().getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field accident"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during TrainRunningInformation serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(runningtime);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class TrainRunningInformation Field runningtime"));
              throw new IOException ();
        }
    }


    @Override
    public final void readExternal (ObjectInput stream) throws IOException, ClassNotFoundException {

        // dont acquire rowlock here dummy
        
        try{
              train = stream.readInt();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field train"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field train"));
              throw new IOException ();
        }

        try{
              track = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field track"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field track"));
              throw new IOException ();
        }

        try{
              itrack = stream.readInt();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field itrack"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field itrack"));
              throw new IOException ();
        }

        try{
              trackname = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field trackname"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal TrainRunningInformation Field trackname"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field trackname"));
              throw new IOException ();
        }

        try{
              line = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field line"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal TrainRunningInformation Field line"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field line"));
              throw new IOException ();
        }

        try{
              departuretime = new Date(stream.readLong());
              if (departuretime.getTime() == new Date (0L).getTime())
                  departuretime = null;
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field departuretime"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field departuretime"));
              throw new IOException ();
        }
        
        try{
              arrivaltime = new Date(stream.readLong());
              if (arrivaltime.getTime() == new Date(0L).getTime() || arrivaltime.getTime() == 0L)
                  arrivaltime = null;
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field arrivaltime"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field arrivaltime"));
              throw new IOException ();
        }

        try{
              accident = new Date(stream.readLong());
              if (accident.getTime() == 0L)
                  accident = new Date(0L);
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field accident"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field accident"));
              throw new IOException ();
        }

        try{
              runningtime = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal TrainRunningInformation Field runningtime"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal TrainRunningInformation Field runningtime"));
              throw new IOException ();
        }
   }

   protected int SIZEOF(){
       // Every writeUTF writes two extra bytes of length info to file/stream 
       // so we must add those extra two bytes for every writeUTF to the return value of SIZEOF
       int utfextras = 2 * 2;
       return (4 + 8 + 4 + (getTrackname().length() * 2) + (getLine().length() * 2) + 8 + 8 + 8 + 8
               + utfextras); // Changed 8th August 2012
   }
   
   protected int getTrain(){
       return train;
   }

   protected long getTrack(){
       return track;
   }

   protected int getITrack(){
       return itrack;
   }

   protected String getTrackname(){
       return new String(trackname.toCharArray()).trim();
   }

   protected String getLine(){
       return new String(line.toCharArray()).trim();
   }

   protected Date getDeparturetime(){
       // 6th September 2012
       if (departuretime == null || departuretime.compareTo(new Date(0L)) == 0)
           return null;
       else
           return new Date(departuretime.getTime());
   }

   protected Date getArrivaltime(){
       if (arrivaltime == null || arrivaltime.compareTo(new Date(0L)) == 0)
           return null;
       else
           return new Date(arrivaltime.getTime());
   }

   protected Date getAccident(){
       // 6th September 2012
       if (accident == null || accident.compareTo(new Date(0L)) == 0)
           return null;
       else
           return new Date(accident.getTime());
   }

   protected long getRunningtime(){
       return runningtime;
   }
   
   @Override
   public String toString(){
       String filher = "#";
       return String.valueOf(getTrain()).concat(filher).concat(String.valueOf(getTrack())).concat(filher)
              .concat(String.valueOf(getITrack())).concat(filher).concat(getTrackname()).concat(filher)
              .concat(getLine()).concat(filher)
              .concat(String.valueOf(getDeparturetime() == null ? "":getDeparturetime().getTime())).concat(filher)
              .concat(String.valueOf(getArrivaltime() == null ? "" : getArrivaltime().getTime())).concat(filher)
              .concat(String.valueOf(getAccident() == null ? "": getAccident().getTime()))
              .concat(filher).concat(String.valueOf(getRunningtime()));
   }

   protected void setTrackname (String p_Trackname){
        if (p_Trackname == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_Trackname=null"));
            System.exit(1);
        }
       TERMINALB.acquireUninterruptibly();
       trackname = new String(p_Trackname.toCharArray());
//.concat(new String(LiveDB.BlankPads.toCharArray(),0,LiveDB.MAXSTRINGFLDLEN - p_Trackname.length()));
       TERMINALB.release();
   }

   protected void setLine (String p_Line){
       TERMINALB.acquireUninterruptibly();
       this.line = new String(p_Line.toCharArray());
//.concat(new String(LiveDB.BlankPads.toCharArray(),0,LiveDB.MAXSTRINGFLDLEN - p_Line.length()));
       TERMINALB.release();
   }

   protected void setDeparturetime(Date p_Departuretime){
       TERMINALB.acquireUninterruptibly();
       if (p_Departuretime != null && getArrivaltime() != null
               && p_Departuretime.after(getArrivaltime()))
       {
            LiveDB.ALRTLVL = 7;       // 6th September 2012
            System.err.println(LiveDB.grassHopper(("Departure post Arrival! Departure time ").concat 
                    (getDeparturetime() == null ? " " : getDeparturetime().toString())));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
       }
       if (p_Departuretime != null && getAccident() != null
               && p_Departuretime.after(getAccident()) )
       {
            LiveDB.ALRTLVL = 7;                // 6th September 2012
            System.err.println(LiveDB.grassHopper(("Departure post Accident! Departure time ").concat 
                    (getDeparturetime() == null ? " " : getDeparturetime().toString())));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
       }
       // 6th September 2012
       this.departuretime = p_Departuretime == null ? null : new Date(p_Departuretime.getTime());
       TERMINALB.release();
   }
   protected void setArrivaltime(Date p_Arrivaltime){
        TERMINALB.acquireUninterruptibly();
        // 6th September 2012 This null literal assigned to Date is creating problems everywhere
        if (getAccident() != null && p_Arrivaltime != null
                && p_Arrivaltime.before(getAccident()))
        {
            LiveDB.ALRTLVL = 7;                   // 6th September 2012
            System.err.println(LiveDB.grassHopper(("Arrival before Accident! Arrival time ").concat
                    (getArrivaltime() == null ? " " : getArrivaltime().toString())));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
        }
        // 6th September 2012
        if (getDeparturetime() != null && p_Arrivaltime != null
                && p_Arrivaltime.before(getDeparturetime()))
        {
            LiveDB.ALRTLVL = 7;                 // 6th September 2012
            System.err.println(LiveDB.grassHopper(("Arrival before Departure! Arrival time ").concat
                  (getArrivaltime() == null ? " " : getArrivaltime().toString())));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
        }
        // 6th September 2012
        this.arrivaltime = p_Arrivaltime == null ? null : new Date(p_Arrivaltime.getTime());
        TERMINALB.release();
   }
   protected void setAccident(Date p_Accident){
        TERMINALB.acquireUninterruptibly();
        if (p_Accident != null && (getDeparturetime() == null ? false:p_Accident.before(getDeparturetime())))
        {
            LiveDB.ALRTLVL = 7;                 // 6th September 2012
            System.err.println(LiveDB.grassHopper(("p_Accident before Departure ").concat
                    (getDeparturetime() == null ? " " : getDeparturetime().toString())));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
        }

        if (p_Accident != null && (getArrivaltime() == null ? false:p_Accident.after(getArrivaltime())))
        {
            LiveDB.ALRTLVL = 7;                 // 6th September 2012
            System.err.println(LiveDB.grassHopper(("p_Accident after Arrival ").concat 
                    (getArrivaltime() == null ? " " : getArrivaltime().toString())));
            LiveDB.system_exit = 1;
            //LiveDB.SmoothExitCondition.signalAll();
        }
        // 6th September 2012
        this.accident = p_Accident == null ? new Date(0L) : new Date(p_Accident.getTime());
        TERMINALB.release();
   }
   protected void setRunningtime(long p_Runningtime){
        TERMINALB.acquireUninterruptibly();
        this.runningtime = p_Runningtime;
        TERMINALB.release();
    }
}
