/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;


import java.io.EOFException;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.StreamCorruptedException;
import java.nio.channels.ClosedChannelException;
import java.nio.channels.FileChannel;
import java.nio.channels.FileLock;
import java.util.*;
import javax.swing.JOptionPane;


/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadrefreshdb
 * CLASS NAME : RefreshDatabase
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[]
 *         Dont read the entire ThreadController.java you will go mad.
 * @LOOKSY:LiveDB.LogFileSabotageCheck(), LiveDB.LiveSharedDB, LiveDB.databaseloading
 *
 * Method Name : public void run ()
 *
 * Chained Methods : protected synchronized boolean update_tracker ()
 *                   protected static boolean index_DataFile(int p_Tableno)
 * NOTE: For all these methods marked as Chained I should be checking the stack trace to ensure that it is
 * truly chained !! but i am not doing that for the sake of freedom of methods. Maybe next release i will
 * write a class (Un-related) that will chain methods and maintain an in memory Map of chainings to be
 * looked up every time a method is called.
 *
 * Associated Methods : protected static boolean read_database (int tableno)                   
 * 
 * Parameters : None
 * @Since Version : 1.0
 *
 * Running Commentary : This is a once in a while thread that loads data from raw byte streams into
 * LiveSharedDB & then it indexes all tables when there is fresh data load (LiveDB.databaseloading = 2).
 * At other times it does not bother to index tables since table indexes are always being updated to
 * time at ChangeTracker.java method UpdateIndexes(). The indexes are also being maintained upto time
 * at several other places in the source code. I have ensured that the indexes are updated at several
 * places in the source code without any delay at the earliest possible in the logic.
 * When LiveDB.databaseloading = 3 it does a constant refresh of LiveSharedDB by calling update_tracker
 * method to ascertain the tables to refresh. It refreshes those table only if those tables have been
 * modified. But before every call to method update_tracker tablestorefresh.clear(); is needed.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 20th May 2011
 * 
 * Last Modification Date : 15th Augustus 2012
 * Last Modification : Through out this source file I have added this call to LiveDB.growMore(ct)
 * whereever I am growing the LiveDB.LiveSharedDB array with a call to new.
 * growMore is a popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash. And when you cook
 * vegetable add Harissa (mild Afrikan spice from North Afrika) one ladel along with Bagar.
 * 
 * 
 * Musical Accompanyments : ALAN PARSONS ON AIR
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class RefreshDatabase extends LiveDB implements Runnable {
    
    private Map<Long, String> tablestorefresh = new HashMap<Long, String> ();
    static FileLock fl = null;
    static FileInputStream fi = null;
    static ObjectInputStream oi = null;
    static File psf = null;
    
    @Override
    public void run () {
        // grow Array 11th August 2012
        ThreadController.TakeOffTimes = ThreadController.TakeOffTimes == null ? new Date[4]:
                Arrays.copyOf(ThreadController.TakeOffTimes,11);
        ThreadController.TakeOffTimes[3] = new Date ();

        if (new File(LiveDB.serializedfilespath + "daemon").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "daemon"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
                LiveDB.system_exit = 1;
                //LiveDB.SmoothExitCondition.signalAll();
            }
        }

        try
        {
            new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadrefreshdb"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).createNewFile();
        }catch (IOException ex_YESKIA41){
            System.err.println(LiveDB.grassHopper(ex_YESKIA41, "Cant create DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadrefreshdb"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        } // to hell with this error it wont happen continue processing
        
        boolean okay = true;
        String tablename = null;
        int tableno;
        int itr = 0; // InstalledTables row
        Long [] loadarray = new Long[2];
        Date freshology = LiveDB.today;

        //try{
            /* wait for it to complete */
        //    InstallDB.threadsrtindx.join();
        //}catch (InterruptedException ex_YESKIA27){} // sqelch this error dont bother
        
        /* First time you installed this application and data was loaded into memory LiveSharedDB
         * from data entry files and the application autoexited after serializing all table data.
         * after Install you invoke the application again this time it needs to load all tables
         * from database serialized files.
         */
        
        if (LiveDB.databaseloading == 2 && LiveDB.system_exit == 0)
        {            
            /* load all tables into memory LiveSharedDB from serialized files */
            for ( int i = 0; i <= LiveDB.REALTABLES ; i++ )
            {
                tableno = Integer.parseInt(LiveDB.tablenameidentifier[i][0]);
                tablename = LiveDB.tablenameidentifier[i][1];                

                //if (LiveDB.LiveSharedDB[tableno] == null) continue;
                
                if ((okay = read_database (tableno)) == false)
                {                    
                    System.err.println(LiveDB.grassHopper("Failed Load Table method read_database "
                                                                                                + tablename));
                    JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                    //System.exit(1);
                }
                // Build all indexes.
                if (okay)
                {
                    index_DataFile(tableno);
                    System.out.println("LOADED AND INDEXED TABLE:" + tableno);
                }
            } /* for */
            LiveDB.CTSR = LiveDB.LiveSharedDB[ct] == null ? 0 : LiveDB.LiveSharedDB[ct].length;
            LiveDB.CRSR = LiveDB.LiveSharedDB[cr] == null ? 0 : LiveDB.LiveSharedDB[cr].length;
            LiveDB.SCSR = LiveDB.LiveSharedDB[sc] == null ? 0 : LiveDB.LiveSharedDB[sc].length;
            LiveDB.RTSR = LiveDB.LiveSharedDB[rt] == null ? 0 : LiveDB.LiveSharedDB[rt].length;
            LiveDB.databaseloading = 3;
        } /* if (LiveDB.databaseloading == 2) */

        // In Windows Pre-Emption style does not allow the other thread to run at all at times
        // so let me lower this thread priority one step below EXPRESS which is the thread priority
        // of the other thread threadsrtindex.
        if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) != -1)
        {
        try{
            InstallDB.threadrefreshdb.setPriority(LiveDB.Priority.INTERCITY.ordinal());
        }catch (IllegalArgumentException ex_NOKIA92){
           System.err.println(LiveDB.grassHopper(ex_NOKIA92));
           System.exit(1);
        }catch (SecurityException ex_NOKIA91){
           System.err.println(LiveDB.grassHopper(ex_NOKIA91));
           System.exit(1);
        }
        }
             
        /* If it gets here load only that table number that has been modified contained in reloadtables */
        while (LiveDB.databaseloading == 3 && LiveDB.system_exit == 0)
        {
            try{
            Thread.sleep (15000); // by the time it gets to the Runnable pool again it will be 25 seconds plus
            }catch (InterruptedException ex_NOKIA87){}
            
            /* commit the existing FileTableDataFileMap table in memory */
            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][0]).COMMIT() == false)
            {
                System.err.println(LiveDB.grassHopper("FileTableDataFileMap Critical Table failed Commit at update_tracker()"));
                Spy.dump();
                LiveDB.DECLARE_EMERGENCY(); // whenever you declare emergency also provide a dump()
	        JOptionPane.showMessageDialog(appframe, "SYSTEM EMERGENCY DECLARED AT " + new Date ().toString() + "Check Log");
                LiveDB.system_exit = 1;
                //LiveDB.SmoothExitCondition.signalAll();
                // Chalega smooth exit. Smooth exit is not to be done at all times because it can cause a
                // further corruption of serialized database files. So some times a belly landing System.exit
                // is better.
            }

            LiveDB.FRESHOLOGY = new Date(); // this is a different FRESHOLOGY looks at ManualTransmission ()
            tablestorefresh.clear();
            if (update_tracker () == true)
            {                
                loadarray  =  tablestorefresh.isEmpty() ? null:
                                     tablestorefresh.keySet().toArray(loadarray);
                for (int v = 0; loadarray != null && v < loadarray.length; v++)
                {
                    tableno = (int)(long)loadarray[v];
                    // This ct table has already been refreshed by update_tracker() so dont repeat refresh
                    if (tableno <= LiveDB.REALTABLES && tableno != ct )
                    {
                        // find the row id in Installed Tables for this tableno
                        for (itr = 0; itr < LiveDB.LiveSharedDB[it].length; itr++)
                        {
                            if (((InstalledTables)LiveDB.LiveSharedDB[it][itr]).getTableno() == tableno)
                            {
                                itr = (int)((InstalledTables)LiveDB.LiveSharedDB[it][itr]).getRowid();
                                break;
                            }
                        }

                        if (((InstalledTables)LiveDB.LiveSharedDB[it][itr]).getModifiedtime().before(freshology))
                            continue;                         
                        
                        tablename = LiveDB.tablenameidentifier[tableno][1];
                        if ((okay = read_database (tableno)) == false)
                        {
                            /* some problem somewhere so exit */
                            LiveDB.databaseloading = 0;
                            System.err.println(LiveDB.grassHopper("Failed Load Table method read_database "
                                                                                                + tablename));
                            JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                            System.exit(1);
                        }
                    } // if (tableno <= LiveDB.REALTABLES && tableno != ct)
                } // for (int v = 0; v < loadarray.length; v++)
                freshology = new Date ();
            } /* if update_tracker () */
            else
            {
                System.err.println(LiveDB.grassHopper("ChangeTracker failed load at update_tracker()"));
                Spy.dump();
                LiveDB.DECLARE_EMERGENCY();                
                JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                LiveDB.system_exit = 1;
                //LiveDB.SmoothExitCondition.signalAll();
            }  // if (update_tracker () == true)
            LiveDB.FRESHOLOGY = null;
                        
        } // while (LiveDB.databaseloading == 3 && LiveDB.system_exit == 0)

        LiveDB.LogFileSabotageCheck (); // see if all these calls are placed at the start then we are
                                       // wasting calls to this method because all threads start at
                                       // nearly the same time so try one call at the bottom of rack.

        if (new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadrefreshdb"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).delete() == false)
        {
            System.err.println(LiveDB.grassHopper("Cant delete DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadrefreshdb"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        }

        if (new File (LiveDB.serializedfilespath + "daemon").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }

        ThreadController.LandingTimes = ThreadController.LandingTimes == null ? new Date[4]:
                Arrays.copyOf(ThreadController.LandingTimes, 11);
        ThreadController.LandingTimes[3] = new Date ();        
    } /* public void run () */

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.LASTLOCKMETHOD, LiveDB.pid, LiveDB.today
 *
 * Method Name : protected synchronized boolean update_tracker ()
 * Parameters : None
 * Returns : boolean true if no errors
 *           boolean false if streams error in reading ChangeTracker.java
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : this will check the underlying physical files for change and then build a HashMap
 * of tablestorefresh. Based on the table numbers contained in tablestorefresh read_database () will be
 * called repeatedly by the run () method. This method has to go thru very fast so if it is slow then
 * there are two patches of code which I have marked with comments. Those two patches of code can be
 * commented or knocked off for speed injection into this method. Anyways setting that pid is purely
 * academic and I am not using it yet anywhere. Okay there is this LiveDB.today which is the date and time
 * your database service started. It is often confused with this users login time. There is a slight shade
 * of a difference.There is also a force tecnology along with MapByteBuffer which fatty has provided without
 * a factory guarantee card. You might want to read it up to curdle your brain.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 19th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected synchronized boolean update_tracker () {
 
        int searchbackwards = 0;
        int thisrow = 0;
       /* THIS IS ABOUT CONCURRENCY
        * Okay you have LiveSharedDB in which constant updates and inserts
        * take place by your instance of the jvm
        * So every time some update or insert or delete takes place in LiveSharedDB
        * you also update the change_flag in changeTracker table to 'U' , 'I', 'D'
        * The fast commit thread writes all these updates to disk BUT before it
        * does that it marks those tables as 'L' locked in table fileTableDataFileMap.
        * plugs in a row in changeTracker for fileTableDataFileMap also and then
        * It also marks all those rows as 'F' change_flag in change_Tracker table
        * So these row which were just updated in LiveSharedDB (in memory) have been
        * fast committed to disk. But there may be some rows which are still not
        * fast committed. So we sleep for some time and check again.
        *
        * We can only refresh a database table that has been fastcommitted by
        * some other process or instance of the JVM so we need to refresh the
        * change_Tracker table itself from disk. meaning desrialize it and then
        * refresh only those tables that have been fastcommitted by other process.
        *
        * So lock the changeTracker table in fileTableDataFileMap before we
        * proceed so that any other thread in this JVM can wait until we finish.
        * But the other process may have itself left some work undone (no fastcommit)
        * So the other process means "this process also" must always refresh
        * this table fileTableDataFileMap check for lock_flag for changeTracker
        * table because the other process may have 'L' locked this table too
        * for whatever purpose. So wait a while till that lock releases and
        * then refresh the changeTracker table and re-read all those tables into
        * memory where the changeTracker table change_flag = 'F' means fast
        * committed by other process. very very complicated. There will always
        * be that 100 millisecond of error margin; i will live with it till i die.
        * To identify the other process check FileTableDataFileMap table_lock field
        * and pid value
        */

        /* lock up the changeTracker table in fileTableDataFileMap */
        // Even this locking of table FileTableDataFileMap and ChangeTracker entry may not
        // be necessary since I have synchronized this method. But synchronization of this
        // method does not mean zero problems. So time this during testing and if there is
        // a performance issue . This entire update_tracker should not take more than five
        // to twelve seconds at worst !!. It fit goes thru in seven seconds Eureka run naked
        // in sheer delight. I expect one user transaction every twelve seconds on heavy
        // usage.

         // 100 milliseconds
        // If this is slow then the following two instructions can also be knocked off
         ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][ct])).setTable_lock ("L");
         // insert an entry in ChangeTracker table for this table
         // two seconds
         thisrow = LiveDB.growMore(ct);
         LiveDB.LiveSharedDB[ct][thisrow] =
         new ChangeTracker (ft,ct, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[ft][ct],
         thisrow);
         LiveDB.LASTLOCKMETHOD = "update_tracker"; 
         
         // If this is slow then the following two instructions can be knocked off
         /* process id that locked this table */
         /* Uncomment this code if you want to
         ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][ct])).setPid (LiveDB.pid) ;
         // insert an entry in ChangeTracker table for this table
         LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
         new ChangeTracker (ft,ct, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[ft][ct],
         (long)LiveDB.LiveSharedDB[ct].length); */

         
        /* The existing ChangeTracker table in memory may still have some rows that
         * have not been fastcommitted yet. So give fastcommit some time to play
         * catchup. NOTE:- We are not checking for getChange_flag () == 'J' (Rollforward)
         * or getChange_flag () == 'R' (Rollback). The reason is that (1) the FastCommit
         * mechanism cannot deal with 'R' or 'J' (2) In case of a RollBack or Rollforward
         * it is the responsibility of the thin client to do a COMMIT () on that table which
         * would be a slow commit. (3) The thin client may not have done a COMMIT() after a
         * RollBack ('R') or Rollforward ('J') for logical reasons or programming error.
         * So therefore we cant keep looping (toscan) forever looking getChange_flag() == 'J' || 'R'
         * BUt we must look for this process id specific rows.
         */
         
         if (LiveDB.usersloggedin == 0)
             searchbackwards = 25; // i assume that each user process creates at least 25 ChangeTracker entries
         else searchbackwards = LiveDB.usersloggedin * 25;
         
        // two seconds
        toscan:
        for ( int m = (int)LiveDB.CTSR -searchbackwards; m < LiveDB.LiveSharedDB[ct].length; m++ )
        {            
            if ((((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getChange_flag() == 'U' ||
                ((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getChange_flag() == 'I' ||
                ((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getChange_flag() == 'D')
                && ((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getPid() == LiveDB.pid )
                continue toscan;
                /* continue because you give fastcommit some time to do its job */
                /* if fastcommit does not clear this backlog your view is inconsistent */
        }

        /* so all set this idiot of a process has done all fastcommits */

        /* Now jump on it pronto and LOOK for all tables that are fastcommitted with change_flag = 'F'
         * in ChangeTracker table by some other process id but before that refresh that ChangeTracker
         * table in memory
         */        

        /* so re-read the ChangeTracker table into memory LiveDB.LiveSharedDB */
        // two seconds
        if (read_database(ct) == false)
             return false;
        
        /* so what we are doing here is to run thru the refreshed ChangeTracker table in memory
         * and looking for Rows that are fastcommited by some other process id and building a
         * map of such table numbers for our use.
         */
        // two seconds        
        
        for (int m = (int)LiveDB.CTSR -searchbackwards; m < LiveDB.LiveSharedDB[ct].length; m++)
        {            
            if (LiveDB.LiveSharedDB[ct][m] == null)
                System.out.println("null pointer at m=" + m);
            if ( (((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getChange_flag() == 'F'
                 || ((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getChange_flag() == 'C')
                 && ((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getPid() != LiveDB.pid &&
                 ((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getDmldate().after(LiveDB.today))                
                 tablestorefresh.put ((Long)((ChangeTracker)(LiveDB.LiveSharedDB[ct][m])).getTableno(),                         
                         "somejunk");
        }

        // 100 milliseconds
        /* now set those flags in FileTableDataFileMap to "U" Unlocked */
        // If this is slow then the following two instructions can also be knocked off
        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][ct])).setTable_lock ("U");
        // two seconds
        // insert an entry in ChangeTracker table for this table
        thisrow = LiveDB.growMore(ct);
        LiveDB.LiveSharedDB[ct][thisrow] =
        new ChangeTracker (ft,ct, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[ft][ct],
        thisrow);

        // If this is slow then the following two instructions can be knocked off
        /* process id that unlocked this table */
        /* Uncomment this code if you want to
        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][ct])).setPid (LiveDB.pid);
         
        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] = new ChangeTracker (ft,ct,'U',LiveDB.pid,
        new Date(),LiveDB.LiveSharedDB[ft][ct],(long)LiveDB.LiveSharedDB[ct].length);
         */

        return true;
    } //  protected synchronized boolean update_tracker ()

    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:LanguageSupport.java
 * @LOOKSY:LanguageTitles.java
 * @LOOKSY:LanguageTransalations.java
 * @LOOKSY:PaymentType.java
 * @LOOKSY:PictureDatabase.java
 * @LOOKSY:PictureOptions.java
 * @LOOKSY:SearchDatabase.java
 * @LOOKSY:DefaultAdvertisingImages.java
 * @LOOKSY:ArtLeaves.java
 * @LOOKSY:CrashRecovery.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:ReportsTables.java
 * @LOOKSY:CelebrityTable.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.tablenameidentifier, LiveDB.maxtables, LiveDB.CUSTOMREPORTSON, LiveDB.REALTABLES
 * @LOOKSY:LiveDB.LASTLOCKMETHOD, LiveDB.grassHopper()
 * @LOOKSY:LiveDB following
 * protected static Long [] RunAwayBrideReport
 * protected static Long [] OctopussyReport
 * protected static Long [] LivingDaylightsReport
 * protected static Long [] FrenchKissReport
 * protected static Long [] YouOnlyLiveTwiceReport
 * protected static Long [] HerMajestiesServiceReport
 * protected static Long [] CityOfAngelsReport
 * protected static Long [] TopGunReport
 * protected static Long [] iQReport
 * protected static Long [] DiamondsAreForeverReport
 * protected static String  QuantumOfSolaceReport
 * protected static Long [] CourageUnderFireReport
 * protected static Long [] YouGotMailReport
 * protected static Long [] NeverSayNeverAgainReport
 * protected static Long [] WhenHarryMetSallyReport
 * protected static Long [] TheDoorsReport
 * protected static Long [] SleeplessInSeattleReport
 * protected static Long [] MoneyMoneyMoneyReport
 * protected static Long [] DrNoReport
 * protected static Long [] CustomShoppingCartReport
 * protected static Long [] CustomCustomerRegisterReport
 * protected static Long [] EnvelopeReport
 * protected static Long [] BulkMailReport
 * protected static Long [] CustomBulkMailReport
 * protected static Long [] MicrophoneReport
 * protected static Long [] BlueToothReport
 * protected static Long [] EyeBallRecognitionReport
 * protected static Plotter [] PlotterReport
 * protected static Plotter [] CustomPlotterReport
 * protected static Graph [] GraphReport
 * protected static Graph [] CustomGraphReport
 * protected static Pie [] ApplePieReport
 * protected static Pie [] CustomApplePieReport
 *
 * Method Name : protected static boolean read_database (int tableno)
 * Parameters : int tableno -- the table number to deserialize
 * Returns : boolean true if data loaded from serialized (stream of raw bytes) file successfully
 *           boolean false if data did not load from serialized files successfully due whatever reasons
 *
 * Data File : YES the serialized file name on disk with a .ser extension at LiveDB.serializedfilespath.
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will deserialize a raw byte stream from a .ser file on disk and read
 * it into LiveDB.LiveSharedDB.It starts by gathering persistent file name from LiveDB.tablenameidentifier
 * then it calls LiveDB.QueueTrainsInWaiting to queue your request. Then it de-serializes the table. If an
 * exception or error condition of any kind other than EOF is thrown it calls LiveDB.DeQueueTrainsInWaiting()
 * If de-serialization is successfull it calls LiveDB.DeQueueTrainsInWaitingArrivals(). The difference in
 * the two Deque methods is provided in the documentation for those methods.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 19th May 2011
 *
 * Last Modification Date : 7th June 2012
 * Last Modifications : I had statements such as the code patch below for each of the tables listed
 * under switch(tableno). I have removed these code lines because they can play havoc with file perms
 * in a multi-user mode. Very difficult to perfect that
                if (psf.canWrite() == true)
                {
                    System.err.println(LiveDB.grassHopper("tampered file perms to write on "
                                                                                         + persistent_file));
                    if (psf.setReadOnly() == false)
                        System.err.println(LiveDB.grassHopper("Unable to setReadOnly via java application "
                                                                                          + persistent_file));
                }
 *
 * Last Modifications Date : 8th June 2012
 * Last Modifications : added the synchronized keyword to the header of the method
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static synchronized boolean read_database (int tableno) {

          boolean okay = true;

          if (tableno > LiveDB.maxtables || tableno < 0)
          {
             LiveDB.ALRTLVL = 7;
             System.err.println(LiveDB.grassHopper("Invalid argument to read_database(int tableno)"));
             return false;
          }

          
          if (LiveDB.CUSTOMREPORTSON == false)
          {
             if (tableno > 36)
                return false;
          }
          
          int reuserow = -1;
          int initial = 0;
          int thisrow = 0;
          String persistent_file = null;
          String resetfilename = null;
          Object adhoclock = new Object();
          boolean ok = true;
          int itr = 0; // installed table row
          int requestno = (new Random ()).nextInt();
          TrainRunningInformation myrunninginfo = new TrainRunningInformation (tableno,
                    Thread.currentThread().getId(), Thread.currentThread().getName(),
                Thread.currentThread().getThreadGroup().getName(), null, null, null, 0L);
          thisrow = LiveDB.growMore(pc);
          LiveDB.LiveSharedDB[pc][thisrow] = new PlatformClearance (requestno,
          LiveDB.pid, LiveDB.IOAction.READOBJECT.ordinal(), new Date (), myrunninginfo, thisrow);
          
          PlatformClearance mytrain = (PlatformClearance) LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1];
          //FileInputStream fi = null;
          //ObjectInputStream oi = null;
          //File psf = null;
          boolean eof = false;        

          if (tableno <= LiveDB.REALTABLES)
          {
              if (tableno == 0)
              {
                  persistent_file = LiveDB.serializedfilespath + LiveDB.tablenameidentifier[0][1] + ".ser";
                  resetfilename = LiveDB.tablenameidentifier[tableno][1] + ".ser";
              }
              else
                  persistent_file = LiveDB.serializedfilespath + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser";
          } 
          
          else if (tableno > LiveDB.REALTABLES && tableno <= LiveDB.maxtables)
          {
               for (int ftr = LiveDB.REALTABLES + 1 ; ftr < LiveDB.tablenameidentifier.length; ftr++)
               {
                   if (tableno == Integer.parseInt(LiveDB.tablenameidentifier[ftr][0]))                     
                       persistent_file = LiveDB.serializedfilespath + LiveDB.tablenameidentifier[ftr][1] + ".ser";
               }
          }
          
          psf = new File (persistent_file);
          
          if (psf.exists() == false) return false;
                    
          if (psf.setReadable(true, false) == false)
          {
              System.err.println(LiveDB.grassHopper("Unable to setReadable"
                                                                  + persistent_file));
              JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : "
                      + '\n' + LiveDB.ErrorLogFile);
              System.exit(1);
          }
                     
          try
          {
                fi = new FileInputStream (psf);                
                oi = new ObjectInputStream (fi);                
          }catch (IOException ex_NOKIA9){
                  System.err.println(LiveDB.grassHopper(ex_NOKIA9, "InputStream not opening "
                                                                                      + persistent_file));
                  return okay = false;
          }

          FileChannel ch = fi.getChannel(); /* return a Channel for locking */
          //FileLock fl = null;
        
          if (LiveDB.QueueTrainsInWaiting(mytrain, ch, fl, requestno) == false)
          {
               System.err.println(LiveDB.grassHopper("Error QueueTrainsInWaiting table :" +
                       mytrain.getTrainid().getTrain()));
               return false;
          }
          
          
          /*
          try{
          ch.position(0L);
          }catch (IOException ex_NOKIA21){
              System.err.println(LiveDB.grassHopper(ex_NOKIA21));
              System.exit(1);
          }
          * 
          */
          
          /* since this is just an advisory lock on some operating systems
           * set the lock_flag to "L" in fileTableDataFileMap
           */

          if (tableno != 0)
          {
            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("L");
            // insert an entry in ChangeTracker table for this table
            thisrow = LiveDB.growMore(ct);
            LiveDB.LiveSharedDB[ct][thisrow] =
            new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
            LiveDB.LiveSharedDB[ft][tableno], thisrow);
          }          

          LiveDB.LASTLOCKMETHOD = "read_database";

          if (tableno != 0)
          {
            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid (LiveDB.pid);
            // insert an entry in ChangeTracker table for this table
            thisrow = LiveDB.growMore(ct);
            LiveDB.LiveSharedDB[ct][thisrow] =
            new ChangeTracker ((long)ft,tableno,'U', LiveDB.pid, new Date (),
            LiveDB.LiveSharedDB[ft][tableno], thisrow);
          }

          
          /* switch the table number and deserialize the entire
           * table from the ".ser" files.
           */
           
          // find the row id in Installed Tables for this tableno
          for (itr = 0; LiveDB.databaseloading > 2 && itr < LiveDB.LiveSharedDB[it].length; itr++)
          {
               if (((InstalledTables)LiveDB.LiveSharedDB[it][itr]).getTableno() == tableno)
               {
                    itr = (int)((InstalledTables)LiveDB.LiveSharedDB[it][itr]).getRowid();
                    break;
               }
          }

          switch (tableno){
            case ft:
                
                if (LiveDB.databaseloading == 2)
                    LiveDB.LiveSharedDB[tableno] = null;  
                
                toreadexternal:
                for (int rw = 0; eof == false && rw <= LiveDB.REALTABLES ; rw++ )
                {   
                    if (LiveDB.databaseloading == 2)
                        LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new FileTableDataFileMap();
                    try{                        
                    ((FileTableDataFileMap)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch(ClassNotFoundException ex_NOKIA78){                        
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        okay = false;
                        continue toreadexternal;
                    }catch (EOFException ex_YESKIA67){     
                        // here is a goslin bug. Remove this additional check && rw <= LiveDB.REALTABLES
                        // for it to appear
                        // I am nullifying LiveDB.LiveSharedDB[tableno][rw] = null;
                        // but LiveDB.LiveSharedDB[tableno][rw].len returns 19 !! not correct 18
                        // i tried system.gc() but that does not help either
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91) {                        
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        
                        if (LiveDB.databaseloading > 2)
                        {
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);  
                        }
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                        
                        okay = false;
                    }
                    // Strange twist to logic here
                    // for row zero which is the row in FileTableDataFileMap table for the table itself
                    // the persistent storage file name has to be set to persistent_file. This is 
                    // because the user may have changed that persistent storage file to some value 
                    // other than the default value offered to him in DataSheetFileTableDataFileMap.
                    // the default value is tablenameidentifier[0][1] which I am using here. 
                    if (rw == 0)
                       ((FileTableDataFileMap)LiveDB.LiveSharedDB[tableno][rw]).setFilename(resetfilename.substring(0,
                               resetfilename.indexOf(".ser")));
                    
                    if (LiveDB.databaseloading > 2)
                    {
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length -1);                        
                    }                    
                }
                                
               break;
            case ct:
                if (LiveDB.databaseloading == 2)                    
                    initial = LiveDB.LiveSharedDB[tableno].length;
                else                    
                {
                    
                    LiveDB.LiveSharedDB[tableno] = null;
                    initial = 0;
                }
                toreadexternal:
                for (int rw = initial; eof == false ; rw++ )
                {                  
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new ChangeTracker();
                    try{
                        ((ChangeTracker)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);                        
                    }catch (ClassNotFoundException ex_NOKIA23){                       
                       LiveDB.LiveSharedDB[tableno][rw] = null; 
                       eof = true;                       
                       System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                       okay = false;
                       continue toreadexternal;                       
                    }catch (EOFException ex_YESKIA67){
                        reuserow = rw;
                        
                        //LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;                        
                        continue toreadexternal;
                    }catch (IOException ex_NOKIA11){                        
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid (LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA11, "InputStream not deserializing " + persistent_file));
                        okay = false;
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {                    
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                            new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[it][itr], thisrow);
                        rw++;
                    }                    
                }
               break;
            case cr:  // these tables use an externalizable interface   
                LiveDB.LiveSharedDB[tableno] = null;
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new CustomerRegister();
                    try{
                    ((CustomerRegister)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                       eof = true;
                       LiveDB.LiveSharedDB[tableno][rw] = null;
                       System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                       okay = false;
                       continue toreadexternal;                   
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop                        
                    }catch (IOException ex_NOKIA91){
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);                        
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "Persistent File:" + persistent_file));
                        okay = false;
                    }
                    if (LiveDB.databaseloading > 2)
                    {                     
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], thisrow);
                        
                    }                    
                }
                break;
            case sc: // this table uses an externalizable interface
                LiveDB.LiveSharedDB[tableno] = null;
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new ShoppingCart();
                    try{
                    ((ShoppingCart)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                        okay = false;
                        continue toreadexternal;                      
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        // normally the same process that locked the table must also unlock it
                        // if the process that unlocked the table is different from the process that locked
                        // then there is a locking BUGSY. You might argue why he is storing in ChangeTracker
                        // again and again when he is storing the entire row BECAUSE OF THIS BUGSY
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);                        
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "persistent file:" + persistent_file));
                        okay = false;
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {                     
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], thisrow);
                        
                    }
                    
                }
               break;
            case ltr:
                try{
                    // ClassCastException with LanguageSupport
                    LiveDB.LiveSharedDB[tableno] = (Object []) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA16){                                   
                        System.err.println(LiveDB.grassHopper(ex_NOKIA16, "File:" + persistent_file));
                        okay = false;                                                
                }catch (IOException ex_NOKIA17){                    
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA17, "File:" + persistent_file));
                        okay = false;
                }
                
                if (LiveDB.databaseloading > 2)
                { 
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[it][itr], thisrow);
                    
                }                
                break;
            case ls:                
                try{
                    // ClassCastException with LanguageSupport
                    LiveDB.LiveSharedDB[tableno] = (Object []) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA16){                                   
                        System.err.println(LiveDB.grassHopper(ex_NOKIA16, "File:" + persistent_file));
                        okay = false;
                                                
                }catch (IOException ex_NOKIA17){
                    
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA17, "File:" + persistent_file));
                        okay = false;
                }
                
                if (LiveDB.databaseloading > 2)
                { 
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[it][itr], thisrow);
                }
                break;
            case lt:
                LiveDB.LiveSharedDB[tableno] = null;
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new LanguageTitles();
                    try{
                         ((LanguageTitles)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                        okay = false;
                        continue toreadexternal;                       
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        // normally the same process that locked the table must also unlock it
                        // if the process that unlocked the table is different from the process that locked
                        // then there is a locking BUGSY. You might argue why he is storing in ChangeTracker
                        // again and again when he is storing the entire row BECAUSE OF THIS BUGSY
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    { 
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], thisrow);
                        
                    }                    
                }
                break;
            case pt:                
                
                try{
                    // ClassCastException with PaymentType[] so Object []
                    LiveDB.LiveSharedDB[tableno] = (Object []) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                    
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                        okay = false;
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:"  + persistent_file));
                        okay = false;
                }catch (IOException ex_NOKIA23){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA23, "File:" + persistent_file));
                        okay = false;
                }
                
                if (LiveDB.databaseloading > 2)
                {                 
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[it][itr], thisrow);
                }
                break;
            case pd:
                LiveDB.LiveSharedDB[tableno] = null;
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new PictureDatabase();
                    try{
                           ((PictureDatabase)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                       eof = true;
                       LiveDB.LiveSharedDB[tableno][rw] = null;
                       System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                       okay = false;
                       continue toreadexternal;
                       
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91){
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        // normally the same process that locked the table must also unlock it
                        // if the process that unlocked the table is different from the process that locked
                        // then there is a locking BUGSY. You might argue why he is storing in ChangeTracker
                        // again and again when he is storing the entire row BECAUSE OF THIS BUGSY
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {                     
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], thisrow);
                        
                    }                    
                }
                break;
            case po:
                LiveDB.LiveSharedDB[tableno] = null;
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new PictureOptions();
                    try{
                    ((PictureOptions)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                        okay = false;
                        continue toreadexternal;
                       
                    }catch (EOFException ex_YESKIA67){
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        // normally the same process that locked the table must also unlock it
                        // if the process that unlocked the table is different from the process that locked
                        // then there is a locking BUGSY. You might argue why he is storing in ChangeTracker
                        // again and again when he is storing the entire row BECAUSE OF THIS BUGSY
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {                     
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], thisrow);
                        
                    }
                    
                }
                break;
            case sd:
                try{
                    // ClassCastException with SearchDatabase []
                    LiveDB.LiveSharedDB[tableno] = (Object []) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);                        
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                        okay = false;
                        
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                }catch (IOException ex_NOKIA29){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA29, "File:" + persistent_file));
                        okay = false;
                }
                                    
                if (LiveDB.databaseloading > 2)
                {                 
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[it][itr], thisrow);
                }
                
                break;
            case da:
                try{
                    // ClassCastException with DefaultAdvertisingImages[]
                    LiveDB.LiveSharedDB[tableno] = (Object[]) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                        okay = false;
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                        okay = false;
                }catch (IOException ex_NOKIA31){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA31, "File:" + persistent_file));
                        okay = false;
                }
                if (LiveDB.databaseloading > 2)
                {                 
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[it][itr],
                                   thisrow);
                }
                break;
            case ar:
                try{
                    // ClassCastException with ArtLeaves []
                    LiveDB.LiveSharedDB[tableno] = (Object []) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                }catch (IOException ex_NOKIA33){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "File:" + persistent_file));
                        okay = false;
                }
                
                if (LiveDB.databaseloading > 2)
                {                 
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[it][itr], thisrow);
                }
                
                break;
            case crr:
                LiveDB.LiveSharedDB[tableno] = null;
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new CrashRecovery();
                    try{
                    ((CrashRecovery)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        eof = true;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                        okay = false;
                        continue toreadexternal;                       
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91) {
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {                     
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], thisrow);
                        
                    }                   
                }
                break;
            case it:
                if (LiveDB.databaseloading == 2)
                    LiveDB.LiveSharedDB[tableno] = null;
                
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new InstalledTables();
                    try{
                    ((InstalledTables)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                        okay = false;
                        continue toreadexternal;                        
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91) {
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {                     
                        ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[it][itr],
                        thisrow);
                        
                    }                    
                }
                break;
            case rt:  // this table uses an externalizable interface
                if (LiveDB.databaseloading == 2)
                    LiveDB.LiveSharedDB[tableno] = null;
                toreadexternal:
                for (int rw = 0; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new ReportsTable();
                    try{
                    ((ReportsTable)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                       eof = true;
                       LiveDB.LiveSharedDB[tableno][rw] = null;
                       System.err.println(LiveDB.grassHopper(ex_NOKIA23));     
                       okay = false;
                       continue toreadexternal;                       
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[it][itr],
                    thisrow);
                    
                    }
                    
                }
                break;
            case clt:
                try{
                    // ClassCastException with CelebrityTable []
                    LiveDB.LiveSharedDB[tableno] = (Object []) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                        okay = false;
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));                        
                }catch (IOException ex_NOKIA41){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA41, "File:" + persistent_file));
                        okay = false;
                }
                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[it][itr], thisrow);
                break;
            case pc:
                if (LiveDB.databaseloading == 2)
                    LiveDB.LiveSharedDB[tableno] = null;
                else
                    initial = LiveDB.LiveSharedDB[tableno].length;
                
                toreadexternal:
                for (int rw = initial; eof == false ; rw++ )
                {
                    LiveDB.growMore(tableno);
                    LiveDB.LiveSharedDB[tableno][rw] = new PlatformClearance();
                    try{
                         ((PlatformClearance)LiveDB.LiveSharedDB[tableno][rw]).readExternal(oi);
                    }catch (ClassNotFoundException ex_NOKIA23){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA23));
                        okay = false;
                        continue toreadexternal;
                       
                    }catch (EOFException ex_YESKIA67){
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        continue toreadexternal;
                         // not an error just break from loop
                    }catch (IOException ex_NOKIA91) {
                        eof = true;
                        LiveDB.LiveSharedDB[tableno][rw] = null;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA91, "File:" + persistent_file));
                    }
                    
                    if (LiveDB.databaseloading > 2)
                    {
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                    thisrow = LiveDB.growMore(ct);
                    LiveDB.LiveSharedDB[ct][thisrow] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[it][itr], thisrow);
                    
                    }
                }
                break;
            case 18:
            case 19:
            case 20:
            case 21:
            case 22:
            case 23:
            case 24:
            case 25:
            case 26:
            case 27:
            case 28:
            case 29:
            case 30:
            case 31:
            case 32:
            case 33:
            case 35:
            case 36:

                try{
                    LiveDB.LiveSharedDB[tableno] = (Long[]) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                }catch (IOException ex_NOKIA29){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA29, "File:" + persistent_file));
                        okay = false;
                }
                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[it][itr], thisrow);
                break;
            case 34:

                try{
                    LiveDB.LiveSharedDB[tableno] = (String[]) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                        okay = false;                        
                }catch (IOException ex_NOKIA29){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft, tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA29, "File:" + persistent_file));
                        okay = false;
                }
                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[it][itr], thisrow);
                break;
            case 40:
            case 41:
                try{
                    LiveDB.LiveSharedDB[tableno] = (LiveDB.Plotter[]) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                        okay = false;                        
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                        okay = false;                        
                }catch (IOException ex_NOKIA29){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA29, "File:" + persistent_file));
                        okay = false;
                }
                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[it][itr], thisrow);
                break;
            case 42: 
            case 43:
                try{
                    LiveDB.LiveSharedDB[tableno] = (LiveDB.Graph[]) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                        okay = false;                                                
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                        okay = false;                        
                }catch (IOException ex_NOKIA29){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA29, "File:" + persistent_file));
                        okay = false;
                }
                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[it][itr],
                thisrow);
                break;
            case 44:
            case 45:
                try{
                    LiveDB.LiveSharedDB[tableno] = (LiveDB.Pie[]) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                }catch (StreamCorruptedException ex_NOKIA39){
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        okay = false;
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));
                }catch (IOException ex_NOKIA29){
                        okay = false;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA29, "File:" + persistent_file));                        
                }
                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[it][itr], thisrow);
                break;
            case 46:
                try{
                    LiveDB.LiveSharedDB[tableno] = (Long[]) oi.readObject();
                }catch (ClassNotFoundException ex_NOKIA40){
                        okay = false;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA40, "File:" + persistent_file));
                }catch (StreamCorruptedException ex_NOKIA39){
                        okay = false;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                           LiveDB.ALRTLVL = 7; // programming screwup most probably
                           System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);

                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U',
                        LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],
                        thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA39, "File:" + persistent_file));                        
                }catch (IOException ex_NOKIA29){
                        okay = false;
                        if (LiveDB.DeQueueTrainsInWaiting() == false)
                        {
                            LiveDB.ALRTLVL = 7; // programming screwup most probably
                            System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                        }
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno],thisrow);
                        ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                        // insert an entry in ChangeTracker table for this table
                        thisrow = LiveDB.growMore(ct);
                        LiveDB.LiveSharedDB[ct][thisrow] =
                        new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[ft][tableno], thisrow);
                        System.err.println(LiveDB.grassHopper(ex_NOKIA29, "File:" + persistent_file));
                }
                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setAccesstime(new Date());
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[it][itr], thisrow);
                break;
            default:
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Invalid argument to read_database(int tableno)"));
                okay = false;
                break;
        } /* switch (tableno) */
        
        System.gc();  

        try{
            if (fl != null)
                fl.release();
        }catch (ClosedChannelException ex_NOKIA52){
            okay = false;
            System.err.println(LiveDB.grassHopper(ex_NOKIA52, "Error fl.release()"));
        }catch (IOException ex_NOKIA87){
            okay = false;
            System.err.println(LiveDB.grassHopper(ex_NOKIA87, "Error fl.release()"));
        }              
        
        try{
              ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
              // insert an entry in ChangeTracker table for this table
              if (tableno == ct)
                  thisrow = reuserow;
              else
                  thisrow = LiveDB.growMore(ct);
              
              LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ft][tableno], thisrow);                              
              ch.close();
              oi.close();              
        }catch (IOException ex_NOKIA50){
                
                if (LiveDB.DeQueueTrainsInWaiting() == false)
                {
                    LiveDB.ALRTLVL = 7; // programming screwup most probably
                    System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                }
                ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setTable_lock("U");
                // insert an entry in ChangeTracker table for this table
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ft][tableno], thisrow);
                ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tableno])).setPid(LiveDB.pid);
                // insert an entry in ChangeTracker table for this table
                thisrow = LiveDB.growMore(ct);
                LiveDB.LiveSharedDB[ct][thisrow] =
                new ChangeTracker ((long)ft,tableno, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ft][tableno],thisrow);
                System.err.println(LiveDB.grassHopper(ex_NOKIA50, "File:" + persistent_file));
                okay = false;
        }

        if (okay == false) return okay;

        if (okay)
        {
            if (LiveDB.DeQueueTrainsInWaitingArrivals() == false)
            {
                LiveDB.ALRTLVL = 7; // programming screwup most probably
                System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaitingArrivals()"));
                // dont return false here look at the code of LiveDB.DeQueueTrainsInWaitingArrivals()
                // either it will be a no such element or remove returned a null in any case no point
                // returning false.
            }
        }

        return okay;
    } /* protected boolean read_database () */
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY: LiveDB.java -- index declarations look at the declaration of each HashMap
 *                      -- search for "indx" in LiveDB.java
 *
 * Method Name : protected static boolean index_DataFile(int p_Tableno)
 * Parameters : int tableno -- the table number to build all indexes for
 * Returns : boolean true if indexing succeeded (always)
 *           boolean false if you modify this method to return false under certain conditions
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method builds the indexes immediately after a data load operation. At other
 * times the indexes are constantly update in ChangeTracker.java privaet method UpdateIndexes keeping
 * them up to date. The indexes are also constantly maintained upto-time at several other places in the
 * source code. Here in this method the indexes are all cleared first and indexed. All these indexes
 * built here are mostly declared as HashMap<String, Long> So the first element of HashMap is a String.
 * Declaring the first element of a HashMap as a string has its advantages because you can use this same
 * HashMap as a dual or multiple purpose index. But beyond a dual purpose index please proceed with caution
 * because there are several threads involved and all these threads are accessing the same index for multiple
 * searchkeys !!
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 20th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean index_DataFile(int p_Tableno) 
    {
        
        String searchkey = null;
        Long value = 0L;
        int maxrows = 0;

            switch (p_Tableno)
            {
                case ft:
                    LiveDB.indxfileTableDataFileMap.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <= LiveDB.REALTABLES; j++)
                    {
                        /* for each row */

                        searchkey = Integer.toString((int)((FileTableDataFileMap)LiveDB.LiveSharedDB[p_Tableno][j]).getTableno());
                        value = (long)j; /* take the rowid */
                          /* do a put into the HashMap */
                        value = LiveDB.indxfileTableDataFileMap.put(searchkey,value);
                    }
                    break;
                case ct:
                    LiveDB.indxchangeTracker.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    
                    maxrows = LiveDB.LiveSharedDB[p_Tableno].length;
                    for ( int j = 0; j < maxrows; j++)
                    {           
                        /* for each row */
                        searchkey = Integer.toString((int)((ChangeTracker)LiveDB.LiveSharedDB[p_Tableno][j]).getTableno())
                                + Long.toString(((ChangeTracker)LiveDB.LiveSharedDB[p_Tableno][j]).getRowid());
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indxchangeTracker.put(searchkey,value);
                        // this is a dual purpose index
                        value = LiveDB.indxchangeTracker.put(
                        Integer.toString((int)((ChangeTracker)LiveDB.LiveSharedDB[p_Tableno][j]).getTableno()),
                             (long) ((ChangeTracker)LiveDB.LiveSharedDB[p_Tableno][j]).getTableno());                        
                    }
                    break;
                case cr:
                    LiveDB.indxcustomerRegister.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j < LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = ((CustomerRegister) (LiveDB.LiveSharedDB[p_Tableno][j])).getCid();
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indxcustomerRegister.put(searchkey,value);
                    }
                    break;
                case sc:
                    LiveDB.indx1shoppingCart.clear();
                    LiveDB.indx2shoppingCart.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j < LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = ((ShoppingCart) (LiveDB.LiveSharedDB[p_Tableno][j])).getCid()
                                + ((ShoppingCart) (LiveDB.LiveSharedDB[p_Tableno][j])).getPic()                                
                                + ((ShoppingCart)LiveDB.LiveSharedDB[p_Tableno][j]).getSub_opt_id();
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indx1shoppingCart.put(searchkey,value);
                        /* Build a second index just to identify unique cid's in shopping cart duplicates will be overwritten */
                        value = LiveDB.indx2shoppingCart.put(((ShoppingCart) (LiveDB.LiveSharedDB[p_Tableno][j])).
                                getCid(), value);
                    }
                    break;
                case ls:
                    LiveDB.indxlanguageSupport.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j < LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = ((LanguageSupport)LiveDB.LiveSharedDB[p_Tableno][j]).getLanguage();
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indxlanguageSupport.put(searchkey,value);
                    }

                    LiveDB.indxLanguageIDs.clear();
                    for ( int j = 0; j < LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        searchkey = ((LanguageSupport)LiveDB.LiveSharedDB[p_Tableno][j]).getName();
                        
                        searchkey = LiveDB.indxLanguageIDs.put(searchkey,
                                ((LanguageSupport)LiveDB.LiveSharedDB[p_Tableno][j]).getLanguage());
                    }
                    
                    break;
                case lt:
                    LiveDB.indxlanguageTitles.clear();
                    
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = ((LanguageTitles)LiveDB.LiveSharedDB[p_Tableno][j]).getlangCode()
                                  + ((LanguageTitles)LiveDB.LiveSharedDB[p_Tableno][j]).getenglishLabel();
                            /* do a put into the HashMap */
                        searchkey = LiveDB.indxlanguageTitles.put(searchkey,
                                ((LanguageTitles)LiveDB.LiveSharedDB[p_Tableno][j]).getLanguage_text());
                    }
                    break;
                case ltr:
                    LiveDB.indx1languageTransalations.clear();
                    LiveDB.indx2languageTransalations.clear();
                    LiveDB.indx3languageTransalations.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = Integer.toString((int)((LanguageTransalations)LiveDB.LiveSharedDB[p_Tableno][j]).getLid())
                                  + Integer.toString((int)((LanguageTransalations)LiveDB.LiveSharedDB[p_Tableno][j]).getGui_text_area_no());
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indx1languageTransalations.put(searchkey,value);
                        searchkey = Integer.toString((int)((LanguageTransalations)LiveDB.LiveSharedDB[p_Tableno][j]).getLid())
                                  + ((LanguageTransalations) (LiveDB.LiveSharedDB[p_Tableno][j])).getPic();
                        value = (long)j; /* take the same rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indx2languageTransalations.put(searchkey,value);
                        searchkey = Long.toString(((LanguageTransalations)LiveDB.LiveSharedDB[p_Tableno][j]).getLid())
                                + ((LanguageTransalations)LiveDB.LiveSharedDB[p_Tableno][j]).getPic() +
                                ((LanguageTransalations)LiveDB.LiveSharedDB[p_Tableno][j]).getGui_text_area_type();
                        searchkey = LiveDB.indx3languageTransalations.put(searchkey,
                                       ((LanguageTransalations)LiveDB.LiveSharedDB[p_Tableno][j]).getLfn());
                    }
                    break;
                case pt:
                    LiveDB.indxpaymentType.clear();

                     /* just construct search key for every row
                      * and Long value and do a put()
                      */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = Integer.toString((int)((PaymentType)LiveDB.LiveSharedDB[p_Tableno][j]).getPmtid());
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indxpaymentType.put(searchkey,value);
                    }
                    break;
                case pd:
                    LiveDB.indxpictureDatabase.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = ((PictureDatabase) (LiveDB.LiveSharedDB[p_Tableno][j])).getPic();
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indxpictureDatabase.put(searchkey,value);
                    }
                    break;
                case po:
                    LiveDB.indxpictureOptions.clear();
                    
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        if (((PictureOptions) (LiveDB.LiveSharedDB[p_Tableno][j])).getSub_opt_id() == 0)
                        {
                            searchkey = ((PictureOptions) (LiveDB.LiveSharedDB[p_Tableno][j])).getlangCode()
                                  + Integer.toString((int)((PictureOptions)LiveDB.LiveSharedDB[p_Tableno][j]).getOpt_id());
                            /* do a put into the HashMap */
                            searchkey = LiveDB.indxpictureOptions.put(searchkey,((PictureOptions)LiveDB.LiveSharedDB[p_Tableno][j])
                                                                                                     .getLang_sub_text());
                        }
                        /* Build a second index on indx2pictureOptions in LaunchGUI
                         * This is a very difficult index to build and anyways it is used only in
                         * the GUI
                         */
                    }
                    break;
                case sd:
                    LiveDB.indxsearchDatabase.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = ((SearchDatabase) (LiveDB.LiveSharedDB[p_Tableno][j])).getKeyword();
                        
                        /* This time tuck in the picture code as value */
                            /* do a put into the HashMap */
                        searchkey = LiveDB.indxsearchDatabase.put(searchkey,
                                ((SearchDatabase) (LiveDB.LiveSharedDB[p_Tableno][j])).getPic());
                    }
                    break;
                case crr:
                    LiveDB.indxcrashRecovery.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = null;
                        /* value = (long)j; */  /* take the rowid ? not this time */
                            /* do a put into the HashMap */
                        for ( int k = 0; k < ((CrashRecovery)LiveDB.LiveSharedDB[p_Tableno][j]).getValues().length; k++ )
                        {
                            // let this remain hardcoded "|"
                            searchkey += new String("|".toCharArray()) + ((CrashRecovery)LiveDB.LiveSharedDB[p_Tableno][j]).getValues()[k];
                        }
                        searchkey += new String("|".toCharArray()); // add one more at end
                        searchkey =  LiveDB.indxcrashRecovery.put(((CrashRecovery)LiveDB.LiveSharedDB[p_Tableno][j]).getTableno(),
                        Long.toString(((CrashRecovery)LiveDB.LiveSharedDB[p_Tableno][j]).getRowid()) + searchkey );
                    }
                    break;
                case it:
                    LiveDB.indxinstalledTables.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    /* array subscript 2 is row count */
                    // because of a strange goslin I have to use LiveDB.LiveSharedDB[p_Tableno].length -1
                    // -1 check and search for goslin in read_database case ft:
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = Integer.toString((int)((InstalledTables)LiveDB.LiveSharedDB[p_Tableno][j]).getTableno());
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indxinstalledTables.put(searchkey,value);
                    }
                    break;
                case rt:
                    LiveDB.indxreportsTable.clear();
                    /* just construct search key for every row
                     * and Long value and do a put()
                     */
                    
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                            /* for each row */
                        searchkey = Integer.toString((int)((ReportsTable)LiveDB.LiveSharedDB[p_Tableno][j]).getDocumentno());
                        value = (long)j; /* take the rowid */
                            /* do a put into the HashMap */
                        value = LiveDB.indxreportsTable.put(searchkey,value);
                    }
                    break;
                case pc:
                    LiveDB.indxplatformClearance.clear();
                    for ( int j = 0; j <  LiveDB.LiveSharedDB[p_Tableno].length; j++)
                    {
                        if (LiveDB.LiveSharedDB[p_Tableno][j] == null) continue;
                        value = LiveDB.indxplatformClearance.put(((PlatformClearance)LiveDB.LiveSharedDB[p_Tableno][j])
                        .getRequest_time().getTime(),((PlatformClearance)LiveDB.LiveSharedDB[p_Tableno][j]).getRowid());
                        LiveDB.indx1platformClearance.put(Integer.toString(((PlatformClearance)LiveDB.LiveSharedDB[p_Tableno][j])
                            .getRequestno()) + Long.toString(((PlatformClearance)LiveDB.LiveSharedDB[p_Tableno][j]).getSid()),
                                                           ((PlatformClearance)LiveDB.LiveSharedDB[p_Tableno][j]).getRowid());
                    }
                    break;
                default:
                 break;
            } /* switch p_Tableno */
        return true;
    } /* index_Datafile () */

} /* class RefreshDatabase implements Runnable, RefreshDB  */
