/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;
import java.awt.GridBagLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.GridBagConstraints;
import java.awt.Font;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static MaintainData.FirstPage.salepanel;
import static MaintainData.LiveDB.pd;
import static MaintainData.LanguagePanel.SelectedLanguage;
import static MaintainData.FirstPage.convertCurrency;
import static MaintainData.CurrencyPanel.Symbol;
import java.util.Arrays;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : SalePanel
 *
 * @LOOKSY : LiveDB.indx2shoppingCart, LiveDB.indxlanguageTitles, LanguagePanel.SelectedLanguage
 * @LOOKSY : FirstPage.popularpanel, FirstPage.salepanel, LiveDB.indxpictureDatabase, LiveDB.appframe
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Sale Items Panel at east
 * corner of screen. Sale Items are those where pic discount is greater than zero. So it picks all
 * such picture codes and then displays them on the screen.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 * 
 * Last Modification Date : 11th August 2012
 * Last Modifications : Marked 11th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : MArked as 17th August 2012
 * Also search for LiveDB.USEFONT
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class SalePanel
{
    private GridBagConstraints constraints = null;
    // removed declaration and its usage 11th August 2012
    //String langstring [] = null;
    JLabel sit = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Sale Items")
            == null ? "Sale Items" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Sale Items"));
    String pics [] = (String []) LiveDB.indx2shoppingCart.keySet().toArray();
    // removed final access specifiers
    String [] piccode = null;
    JLabel pic [] = null;
    JLabel disp [] = null;
    Object retval = null; // 17th August 2012

    public SalePanel ()
    {
        int MF = 10;
        salepanel = new JPanel (new GridBagLayout());
        salepanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        salepanel.setBackground(Color.WHITE);
        salepanel.setBounds((int)(LiveDB.appframe.RIGHT_ALIGNMENT * MF)
                - (int)(FirstPage.pageonetextpanel.RIGHT_ALIGNMENT * MF) + 1,
                (int)(FirstPage.popularpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.popularpanel.RIGHT_ALIGNMENT * MF),
                (int)(FirstPage.popularpanel.BOTTOM_ALIGNMENT * MF) - (int)(FirstPage.popularpanel.TOP_ALIGNMENT * MF) + 1);
        addsalepanel();
        salepanel.validate();
    }

    void addsalepanel ()
    {    
        int MF = 10;
        
        sit.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
        sit.setForeground(Color.BLACK);
        salepanel.add(sit, setConstraints((int)salepanel.LEFT_ALIGNMENT * MF,
                                                          (int)salepanel.TOP_ALIGNMENT * MF, 2, 1));

        for (int rw = 0, sno = 1, y = 2; rw < pics.length; rw++)
        {
            if (((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)LiveDB.indxpictureDatabase.get(pics[rw])])
                    .getPic_discount() > 0 )
            {
                // grow array 11th August 2012
                piccode = piccode == null ? new String[1]:Arrays.copyOf(piccode, piccode.length + 1);
                piccode[piccode.length -1] = pics[rw];
                // grow array 11th August 2012
                pic = pic == null ? new JLabel[1] : Arrays.copyOf(pic, pic.length + 1);
                pic[pic.length -1] = new JLabel(sno + ". " + ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                        [(int)(long)LiveDB.indxpictureDatabase.get(pics[rw])]).getPic_title());
                // grow array 11th August 2012
                disp = disp == null ? new JLabel [1]:Arrays.copyOf(disp, disp.length + 1);
                disp[disp.length -1] = new JLabel ("Save " + Symbol + convertCurrency(((PictureDatabase)LiveDB.LiveSharedDB[pd]
                        [(int)(long)LiveDB.indxpictureDatabase.get(pics[rw])]).getPic_discount()));
                sno++;
                pic[pic.length -1].setFont(new Font (LiveDB.USEFONT, Font.PLAIN, 8));
                pic[pic.length -1].setForeground(Color.BLUE);
                disp[disp.length -1].setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 8));
                disp[disp.length -1].setForeground(Color.RED);
                salepanel.add(pic[pic.length -1], setConstraints((int)salepanel.LEFT_ALIGNMENT * MF,
                        (int)(sit.BOTTOM_ALIGNMENT * MF) + y,3,1));
                y++;
                salepanel.add(disp[disp.length -1], setConstraints((int)salepanel.LEFT_ALIGNMENT * MF,
                        (int)(pic[pic.length -1].BOTTOM_ALIGNMENT * MF) + 1,3,1));
                y++;
                pic[pic.length -1].addMouseListener(new MouseListener (){
                    @Override
                    public void mousePressed (MouseEvent evnt){
                       pic[pic.length -1].setForeground(Color.RED);
                       pic[pic.length -1].validate();
                    }
                    @Override
                    public void mouseReleased (MouseEvent evnt){
                       pic[pic.length -1].setForeground(Color.BLUE);
                       pic[pic.length -1].validate();
                    }
                    @Override
                    public void mouseExited (MouseEvent evnt){
                       pic[pic.length -1].setForeground(Color.BLUE);
                       pic[pic.length -1].validate();
                    }
                    @Override
                    public void mouseClicked (MouseEvent evnt){
                       // 17th August 2012 
                       retval = new PicturePage (piccode[piccode.length -1]);
                       
                    }
                    @Override
                    public void mouseEntered (MouseEvent evnt){
                       pic[pic.length -1].setForeground(Color.RED);
                       pic[pic.length -1].validate();
                    }
                });
            } // if (((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)LiveDB.indxpictureDatabase.get
        } // for (int rw = 0, sno = 1, y = 2; rw < pics.length; rw++)
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
