/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Iterator;
import java.util.Random;
import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import static MaintainData.FirstPage.pageonetextpanel;
import static MaintainData.FirstPage.latestprodspanel;
import static MaintainData.FirstPage.infopanel;
import static MaintainData.FirstPage.cartpanel;
import static MaintainData.FirstPage.featuredpanel;
import static MaintainData.FirstPage.popularpanel;
import static MaintainData.FirstPage.logopanel;
import static MaintainData.LiveDB.pd;
import static MaintainData.FirstPage.convertCurrency;
import static MaintainData.CurrencyPanel.Symbol;
import java.util.Arrays;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : SearchResultsPage
 *
 * @LOOKSY: PictureDatabase.java
 *
 * @LOOKSY:FirstPage.pageonetextpanel, FirstPage.maillistpanel, FirstPage.infopanel
 * @LOOKSY:FirstPage.popularpanel, FirstPage.featuredpanel, FirstPage.salepanel
 * @LOOKSY:FirstPage.cartpanel, LiveDB.grassHopper, LiveDB.ALRTLVL
 *
 * Associated Methods : protected static float convertCurrency(float p_amt)
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor will construct the searchresultspanel and attach it to the
 * front page after removing other panels. The addpanel(p_pics) method that the constructor calls will run
 * thru picture codes contained in p_pics and pick all details. These are the search result items and it
 * it will display them one at a time. It will also draw an image for each picture code along with
 * narratives along with a buy and more buttons.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 * 
 * Last Modification Date : 13th August 2012
 * Last Modifications : Marked as 13th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : MArked as 17th August 2012
 * I have declared a new variable retvals []. This is needed to collect the newly constructed
 * objects in the code. If this is not used a new object will be created but the JVM may view these
 * objects as Orphans and garbage collect them.
 * Also search for LiveDB.USEFONT
 * 
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class SearchResultsPage {

    protected static JPanel searchresultspanel = null;
    private GridBagConstraints constraints = null;

    JPanel header = new JPanel (new GridBagLayout());
    JLabel img = new JLabel ("Image");
    JLabel desc = new JLabel ("Description");
    JLabel price = new JLabel ("Price");
    JLabel saleitems = new JLabel ("Sale Items");
    // removed final access specifier  13th August 2012
    JLabel pt [] = null;
    JLabel nl [] = null;
    JButton [] buy = null;
    JButton [] more  = null;
    JLabel picprice [] = null;
    JLabel picdisc [] = null;
    String piccode [] = null;
    Object retvals [] = new Object [3]; // 17th August 2012

    public SearchResultsPage (String [] p_pics)
    {
        int MF = 10;
        int H = 0;
        int X = 0;

        H = (int)(pageonetextpanel.BOTTOM_ALIGNMENT - pageonetextpanel.TOP_ALIGNMENT) * MF
                + (int) (latestprodspanel.BOTTOM_ALIGNMENT - latestprodspanel.TOP_ALIGNMENT) * MF;

        X = (int)featuredpanel.LEFT_ALIGNMENT * MF;

        // just remove two panels and add the saleitemspanel
        // you are done with the SaleItemsPage
        LiveDB.appframe.remove(pageonetextpanel);
        LiveDB.appframe.remove(latestprodspanel);

        // i am removing the logo panel and adding the northwest advert panel
        LiveDB.appframe.remove(logopanel);
        LiveDB.appframe.pack();

        NorthWestAdvertPanel.northwestadvertpanel.setVisible(true);
        
        searchresultspanel = new JPanel (new GridBagLayout ());
        addpanel(p_pics);

        LiveDB.appframe.add(searchresultspanel, setConstraints((int)(infopanel.RIGHT_ALIGNMENT * MF)+ 1,
            (int)(cartpanel.TOP_ALIGNMENT * MF),
            ((int)(featuredpanel.LEFT_ALIGNMENT) * MF -1) - ((int)(cartpanel.RIGHT_ALIGNMENT) * MF + 1), H));
        LiveDB.appframe.pack();

    }

    void addpanel(String [] p_pics){

        ImageReader reader = null;
        Iterator<ImageReader> iter = null;
        ImageInputStream ImageIn = null;
        Image image = null;
        int infoflags = 0;
        File fl = null;
        FileReader fr = null;
        BufferedReader br = null;

        String unavailable = LiveDB.serializedfilespath + "etc"
                                              + LiveDB.FILESEPERATOR + "unavailable.txt";
        String file = null;
        String keyval = null;
        
        String picpath [] = null;
        String narrativesfile [] = null;
        String pictitles [] = null;
        float picdiscounts [] = null;
        float picprices [] = null;
        int MAXPICS = 6;
        int MF = 10;
        final  Integer [] randompics = null;
        String line = null;
        int MAXCHARS = 71;
        long rid = 0L;

        for (int rw = 0; rw < p_pics.length; rw++)
        {
            rid = LiveDB.indxpictureDatabase.get(p_pics[rw]);
            // grow the array 13th August 2012
            piccode = piccode == null ? new String [1] :Arrays.copyOf(piccode, piccode.length + 1);
            piccode[piccode.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)rid]).getPic();
            // grow the array 13th August 2012
            picpath = picpath == null ? new String [1]: Arrays.copyOf(picpath, picpath.length + 1);
            picpath[picpath.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)rid]).getPic_img_location();
            // grow the Array 13th August 2012
            pictitles = pictitles == null ? new String [1] : Arrays.copyOf(pictitles, pictitles.length + 1);
            pictitles [pictitles.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)rid]).getPic_title();
            // grow the Array 13th August 2012
            picprices = picprices == null ? new float [1] : Arrays.copyOf(picprices, picprices.length + 1);
            picprices [picprices.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)rid]).getPic_price();
            // grow the array 13th August 2012
            picdiscounts = picdiscounts == null ? new float[1] : Arrays.copyOf(picdiscounts, picdiscounts.length + 1);
            picdiscounts [picdiscounts.length -1] = picprices [picprices.length -1] 
                    - ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)rid]).getPic_discount();
            keyval =  FirstPage.chosenlang + piccode[piccode.length - 1] + "JNarrative";
            file = LiveDB.indx3languageTransalations.get(keyval);
            // grow the array 13th August 2012
            narrativesfile = narrativesfile == null ? new String [1] : Arrays.copyOf(narrativesfile, narrativesfile.length + 1);
            narrativesfile[narrativesfile.length -1] = file == null ? unavailable:file;            
        }

        for (int c = 0, r = 0, z = 0; (randompics == null ? 0 : randompics.length) < MAXPICS - 1; c++ )
        {
            topickagain:
            do{
                z = (new Random()).nextInt(piccode.length);
                if (randompics.length > 1 && z == randompics[r -1])
                    continue topickagain;
                else
                {
                    randompics[r] = (new Random()).nextInt(piccode.length);
                    r++;
                }

            }while (true);
        }

        // okay found everything now start drawing images
        // draw at best five images at random
        saleitems.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        saleitems.setForeground(Color.BLUE);
        header.setSize((int)(popularpanel.LEFT_ALIGNMENT - 1 - cartpanel.RIGHT_ALIGNMENT + 1) * MF, 2);
        header.setBackground(Color.DARK_GRAY);
        img.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        img.setForeground(Color.BLUE);
        desc.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        desc.setForeground(Color.BLUE);
        price.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
        price.setForeground(Color.BLUE);
        header.add(img, setConstraints(0,0,2,1));
        header.add(desc, setConstraints((int)(header.RIGHT_ALIGNMENT * MF)/2,0,2,1));
        header.add(price, setConstraints((int)(header.RIGHT_ALIGNMENT * MF)/8,0,2,1));
        header.validate();

        searchresultspanel.add(saleitems, setConstraints(0,0,2,1));
        searchresultspanel.add(header, setConstraints(0, (int)(saleitems.BOTTOM_ALIGNMENT * MF) + 2,
           (int) ((popularpanel.LEFT_ALIGNMENT * MF - 1) - ((cartpanel.RIGHT_ALIGNMENT * MF) + 1)), 2));

        int Y = (int)header.BOTTOM_ALIGNMENT * MF + 1;
        int X = (int)(cartpanel.RIGHT_ALIGNMENT * MF) + 1;
        final Integer I [] = null;
        boolean potrait  = false;

        for (int i = 0, W = 0, H = 0; i < MAXPICS && i < randompics.length; i++)
        {
            I[I.length] = randompics[i];

            try{
                image = ImageIO.read(new File(picpath[randompics[i]]));
            }catch (IOException ex_YESKIA9){
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper(ex_YESKIA9, "Missing Image File:" + picpath[randompics[i]]));
                continue;
            }

            try{
              ImageIn = ImageIO.createImageInputStream(file);
            }catch (IOException ex_YESKIA98){
                System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" + picpath[randompics[i]]));
                continue;
            }

            iter = ImageIO.getImageReadersBySuffix("gif");
            reader = iter.next();
            reader.setInput(ImageIn);

            try{
                W = reader.getWidth(0);
                H = reader.getHeight(0);
            }catch (IndexOutOfBoundsException ex_NOKIA8){
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper(ex_NOKIA8));
                continue;
            }catch (IOException ex_NOKIA66){
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper(ex_NOKIA66));
                continue;
            }

            if (W <= H)
                potrait = true;
            else if (H < W)
                potrait = false;

            fl = new File (narrativesfile[randompics[i]]);
            try{
            fr = new FileReader (fl);
            }catch (FileNotFoundException ex_YESKIA9){
                System.err.println(LiveDB.grassHopper(ex_YESKIA9, "File:" + narrativesfile[randompics[i]]));
                continue;
            }
            br = new BufferedReader (fr);

            try{
                if ((line = br.readLine()) == null)
                {
                    System.err.println(LiveDB.grassHopper("Insufficient characters in file:"
                                                             + narrativesfile[randompics[i]]));
                    continue;
                }
            }catch (IOException ex_YESKIA7){
                System.err.println(LiveDB.grassHopper(ex_YESKIA7,"File:" + narrativesfile[randompics[i]]));
                continue;
            }

            line = line.substring(0, line.length() >= MAXCHARS ? MAXCHARS : line.length());

            try{
               br.close();
            }catch (IOException ex_YESKIA11){
               System.err.println(LiveDB.grassHopper(ex_YESKIA11, "File:" + narrativesfile[randompics[i]]));
               continue;
            }

            FirstPage.DrawImage(picpath[i], searchresultspanel, X, Y, 0, 0, potrait);
            // grow the array 13th August 2012
            pt = pt == null ? new JLabel[1] : Arrays.copyOf(pt, pt.length + 1);
            pt[pt.length -1] = new JLabel (pictitles[randompics[i]]);
            pt[pt.length -1].setFont (new Font(LiveDB.USEFONT, Font.BOLD, 12 ));
            pt[pt.length  -1].setForeground(Color.BLUE);
            searchresultspanel.add(pt[pt.length -1], setConstraints( X, Y, 3, 1));
            // grow the Array 13th August 2012
            nl = nl == null ? new JLabel[1] : Arrays.copyOf(nl, nl.length + 1);
            nl[nl.length -1] = new JLabel (line + "...");
            nl[nl.length -1].setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 10));
            nl[nl.length -1].setForeground(Color.BLACK);
            // grow the array 13th August 2012
            picdisc = picdisc == null ? new JLabel [1] : Arrays.copyOf(picdisc, picdisc.length + 1); 
            picdisc[picdisc.length -1] = new JLabel (Symbol + convertCurrency(picdiscounts[randompics[i]]));
            picdisc[picdisc.length -1].setFont (new Font(LiveDB.USEFONT, Font.BOLD, 10));
            picdisc[picdisc.length -1].setForeground(Color.RED);
            // grow the array 13th August 2012
            picprice = picprice == null ? new JLabel [1] : Arrays.copyOf(picprice, picprice.length +1);
            picprice[picprice.length -1] = new JLabel (Symbol + convertCurrency(picprices[randompics[i]]));

            if (picdiscounts[randompics[i]] > 0)
            {
                picprice[picprice.length -1].setFont(new Font (LiveDB.USEFONT, Font.CENTER_BASELINE, 9));
                picprice[picprice.length -1].setForeground(Color.BLACK);
            }
            else
            {
                picprice[picprice.length -1].setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
                picprice[picprice.length -1].setForeground(Color.RED);
            }

            searchresultspanel.add(nl[nl.length -1], setConstraints (X+7, Y+1, MAXCHARS/5, 1));

            if (picdiscounts[randompics[i]] > 0)
            {
                searchresultspanel.add(picprice[picprice.length -1], setConstraints((int)(price.LEFT_ALIGNMENT * MF),Y, 1, 1));
                searchresultspanel.add(picdisc[picdisc.length -1], setConstraints((int)(price.LEFT_ALIGNMENT * MF),Y +1, 1, 1));
            }
            else
                searchresultspanel.add(picdisc[picdisc.length -1],
                        setConstraints((int)(price.LEFT_ALIGNMENT * MF),Y +1, 1, 1));

            pt[pt.length -1].addMouseListener(new MouseListener (){
                @Override
                public void mousePressed (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.RED);
                    pt[pt.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.BLUE);
                    pt[pt.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt){
                    // 17th August 2012
                    retvals [0] = new PicturePage (piccode[I[I.length - 1]]);
                }
                @Override
                public void mouseEntered (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.RED);
                    pt[pt.length -1].validate();
                }
                @Override
                public void mouseExited (MouseEvent evnt){
                    pt[pt.length -1].setForeground(Color.BLUE);
                    pt[pt.length -1].validate();
                }
            });

            // grow the array 13th August 2012
            buy = buy == null ? new JButton [1] : Arrays.copyOf(buy, buy.length +1);
            buy[buy.length -1] = new JButton ("Buy");
            // grow the array 13th August 2012
            more = more == null ? new JButton [1] : Arrays.copyOf(more, more.length + 1);
            more[more.length -1] = new JButton ("More");
            buy[buy.length -1].setFont(new Font (LiveDB.USEFONT, Font.PLAIN, 9));
            more [more.length -1].setFont(new Font(LiveDB.USEFONT, Font.PLAIN, 9));
            buy[buy.length -1].setBackground(Color.BLUE);
            more[more.length -1].setBackground(Color.BLUE);
            buy[buy.length -1].addMouseListener(new MouseListener (){

                @Override
                public void mousePressed (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.RED);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseEntered (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.RED);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.BLUE);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseExited (MouseEvent evnt){
                    buy[buy.length -1].setBackground(Color.BLUE);
                    buy[buy.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt){
                    // 17th August 2012
                    retvals [1] = new PicturePage (piccode [I[I.length - 1]]);
                }
            });

            more[more.length -1].addMouseListener(new MouseListener (){
                @Override
                public void mousePressed (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.RED);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseEntered (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.RED);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.BLUE);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseExited (MouseEvent evnt){
                    more[more.length -1].setBackground(Color.BLUE);
                    more[more.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt){
                    // 17th August 2012
                    retvals[2] = new PicturePage (piccode [I[I.length - 1]]);
                }
            });

            searchresultspanel.add(buy[buy.length -1], setConstraints ((int)(price.RIGHT_ALIGNMENT * MF) +1,
                                                    Y, 1, 1));
            searchresultspanel.add(more[more.length -1], setConstraints ((int)(price.RIGHT_ALIGNMENT * MF) +1,
                                                    Y + 1, 1, 1));

            Y = potrait == false ? Y + 5:Y + 7;
        }
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
