/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.util.Date;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import static MaintainData.LiveDB.sc;
import static MaintainData.LiveDB.ar;
import static MaintainData.LiveDB.ct;
import static MaintainData.LoginPage.LoggedInCID;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : SysAdminPage
 *
 * @LOOKSY : LiveDB.indx1shoppingCart, LoginPage.LoggedInCID, LiveDB.PrepareAndSendMailMesg
 * @LOOKSY : LiveDB.appframe, LiveDB.EasyMail, LiveDB.system_exit, LiveDB.SmoothExitCondition
 * @LOOKSY : LiveDB.serializedfilespath, LiveDB.ALRTLVL
 *
 * @LOOKSY : PageOneTextPanel.java
 *           LoginPage.java
 *           ChangeTracker.java
 *           ShoppingCart.java
 *           ArtLeaves.java
 *           BottomPaneListener.java
 *
 * Date File : None
 *
 * Called From : public void stateChanged (ChangeEvent evnt) of BottomPaneListener.java
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the System Administration Page
 * when the user click on Sys Admin on the FooterPanel. Currently only two activities can be done on
 * the Sys Admin page which is "Invoice Cancellation" and "Editing conf/LENSVIEWPROPERTIESFILE".
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 * 
 * Last Modification Date : 15th Augustus 2012
 * Last Modification : Through out this source file I have added this call to LiveDB.growMore(ct)
 * whereever I am growing the LiveDB.LiveSharedDB array with a call to new.
 * growMore is a popular enriched bomb grade fertilizer used in the Indian Agricultural sector
 * to spice up the fruit and it contains both Urea and Potash to make Matash. And when you cook
 * vegetable add Harissa (mild Afrikan spice from North Afrika) one ladel along with Bagar.
 * 
 * Last Modification Date : 15th August 2012
 * Last Modifications : Changed this patch of code
                              emailbody[0] =
                               "CID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getCid() + '\n';
                               emailbody[1] =
                               "PIC CODE = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic() + '\n';
                               emailbody[2] =
                               "PO NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPonumber() + '\n';
                               emailbody[3] =
                               "SUBOPT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getSub_opt_id() + '\n';
                               emailbody[4] =
                               "PMT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPmtid() + '\n';
 *
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : MArked as 17th August 2012
 * I have declared a new variable retvals []. This is needed to collect the newly constructed
 * objects in the code. If this is not used a new object will be created but the JVM may view these
 * objects as Orphans and garbage collect them.
 * 
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class SysAdminPage {

    GridBagConstraints constraints = null;
    static JPanel sysadminpanel = new JPanel (new BorderLayout());
    JLabel option1 = new JLabel ("Cancel Invoice");
    JLabel option2 = new JLabel ("Edit " + LiveDB.versionControl.getApplicationName() + " Properties File");
    JLabel option3 = new JLabel ("MORE TABLE MAINTENANCE/LOOKUP MODULES COMMING UP IN NEAR FUTURE");
    JLabel keycode = new JLabel ("KEYCODE FOR INVOICE CANCELLATION:");
    JTextField kcode = new JTextField ("Enter keycode emailed to you", 30);
    JTextArea propsfile = new JTextArea ();
    JLabel editprops = new JLabel ("Edit Properties File in Box");
    JButton WriteFile = new JButton ("WriteFile");
    String lensviewpropsfile = new String(LiveDB.LENSVIEWPROPERTIESFILE.toCharArray());
    
    Object retvals [] = new Object [3]; // 17th August 2012

    public SysAdminPage ()
    {
        int pX = 0, pY = 0, pW = 0, pH = 0;
        int MF = 10;
        String reppath = LiveDB.serializedfilespath + "etc";

        // check some perms quickly
        if (new File(reppath).canWrite() == false)
        {
            if (new File(reppath).exists() == false)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("directory destroyed:" + reppath));
                System.exit(1);
            }
            else
            {
                if (new File(reppath).setWritable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("can set write perms:" + reppath));
                    System.exit(1);
                }
            }
        }
        
        sysadminpanel.setBounds(pX = (int)FirstPage.pageonetextpanel.LEFT_ALIGNMENT * MF,
                           pY = (int)FirstPage.pageonetextpanel.TOP_ALIGNMENT * MF,
                           pW = (int)FirstPage.pageonetextpanel.RIGHT_ALIGNMENT * MF
                           - (int)FirstPage.pageonetextpanel.LEFT_ALIGNMENT * MF,
                           pH = (int)FirstPage.pageonetextpanel.BOTTOM_ALIGNMENT * MF
                           - (int)FirstPage.pageonetextpanel.TOP_ALIGNMENT * MF);

        option1.setForeground(Color.ORANGE);
        option1.setFont( new Font (LiveDB.USEFONT, Font.BOLD, 14));
        sysadminpanel.add( option1, BorderLayout.CENTER);
        option1.addMouseListener(new MouseListener ()
        {
           @Override
           public void mouseClicked (MouseEvent evnt)
           {
               sysadminpanel.removeAll();
               sysadminpanel.add( keycode, BorderLayout.CENTER);
               sysadminpanel.add(kcode, BorderLayout.CENTER);
               kcode.addInputMethodListener(new InputMethodListener ()
               {
                  @Override
                  public void inputMethodTextChanged(InputMethodEvent event)
                  {
                     String custemail = null;
                     String emailbody [] = new String [13];  // Changed 15th August 2012
                     String emailbodytxt = null;
                     String rmafile = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                                          + "cancelled.rma";
                     File fl = new File (rmafile);
                     FileWriter fw = null;
                     BufferedWriter bw = null;
                      // Invoice Cancellation
                      // Please dont abuse this facility provided
                      // It is only for customers who have place a purchase order
                      // and then an invoice raised to customer and then he refuses
                      // to pay up before goods are dispatched to him. So then you
                      // have to cancel the invoice under such extreme circumstances
                      // but anyways the customer will also be sent an email so you cant
                      // get away with fraud.
                     
                      if (LoggedInCID.equals("superuser"))
                      {
                          // then proceed
                          long rid = 0L;
                          if (LiveDB.indx1shoppingCart.get(kcode.getText().trim()) == null)
                          {
                              JOptionPane.showMessageDialog(LiveDB.appframe, "Invald KEYCODE Re-Enter");
                              kcode.setText(" ");
                              kcode.setFocusable(true);
                          }
                          else
                          {
                              rid = LiveDB.indx1shoppingCart.get(kcode.getText().trim());
                              ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(8);
                               // ChangeTracker entry here
                               LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                               new ChangeTracker (sc, rid, 'U', LiveDB.pid, new Date (),
                                   LiveDB.LiveSharedDB[sc][(int)rid],
                                   (long)LiveDB.LiveSharedDB[ct].length -1);
                               JOptionPane.showMessageDialog(LiveDB.appframe, "INVOICE CANCELLED PLEASE WAIT"
                                       + '\n' + "FOR REPORT TO BE EMAILED");

                               // Pick this entire shopping cart row details and email to company
                               // notification email box as an attachment
                               emailbody[0] =
                               "CID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getCid() + '\n';
                               emailbody[1] =
                               "PIC CODE = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic() + '\n';
                               emailbody[2] =
                               "PO NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPonumber() + '\n';
                               emailbody[3] =
                               "SUBOPT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getSub_opt_id() + '\n';
                               emailbody[4] =
                               "PMT ID = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPmtid() + '\n';
                               emailbody[5] =
                               "PIC QTY = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getPic_qty() + '\n';
                               emailbody[6] =
                               "TOTAL = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getTotal() + '\n';
                               emailbody[7] =
                               "BILLED = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getBilled() + '\n';
                               emailbody[8] =
                               "SHOPDATE = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getShopdate().toString() + '\n';
                               emailbody[9] =
                               "ORDER NUMBER = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getOrdernumber() + '\n';
                               emailbody[10] =
                               "ORDER DISCOUNT = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getOrderdiscount() + '\n';
                               emailbody[11] =
                               "RMA = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRma() + '\n';
                               emailbody[12] =
                               "REFUND = " + ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).getRefund() + '\n';

                               try{
                                  fw = new FileWriter (fl);
                               }catch (IOException ex_NOKIA92){
                                  // send out an email here to customer with emailbody
                                  // maybe the file does not write its okay we will still send
                                  // an email to both customer and self and then exit.
                                  // Send customer an email
                                  for (int ln = 0; ln < emailbody.length; ln++)
                                      emailbodytxt += emailbody[ln];

                                  if (LiveDB.PrepareAndSendMailMesg(null, null, custemail,
                                          ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                          null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " SYSADMIN DESK INVOICE CANCELLATION ",
                                          emailbodytxt,
                                          rmafile) == false)
                                  {
                                      JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "Cancelled Invoice could not be emailed to " + custemail);
                                  }
                                  else
                                      JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "CANCELLED INVOICE DETAILS EMAILED TO" + custemail);
                                  System.err.println(LiveDB.grassHopper(ex_NOKIA92, "File:"
                                                                     + rmafile));
                                  JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                + LiveDB.ErrorLogFile);
                                  LiveDB.system_exit = 1;
                                 // LiveDB.SmoothExitCondition.signalAll();
                               }

                               bw = new BufferedWriter (fw);

                               for (int i = 0; i < emailbody.length; i++)
                               {
                                   try{
                                   bw.write(emailbody[i]);
                                   }catch (IOException ex_NOKIA76){
                                     // send out an email here to customer with emailbody
                                     // maybe the file does not write its okay we will still send
                                     // an email to both customer and self and then exit.
                                     if (emailbodytxt == null)
                                     {
                                         for (int ln = 0; ln < emailbody.length; ln++)
                                              emailbodytxt += emailbody[ln];
                                     }

                                     if (LiveDB.PrepareAndSendMailMesg(null, null, custemail,
                                          ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                                          null, "EMAIL FROM " +
                                          LiveDB.versionControl.getApplicationName() +
                                          " SYS ADMIN DESK INVOICE CANCELLATION ",
                                          emailbodytxt,
                                          rmafile) == false)
                                     {
                                        JOptionPane.showMessageDialog(LiveDB.appframe,
                                              "Cancelled Invoice could not be emailed to " + custemail);
                                     }
                                     else
                                         JOptionPane.showMessageDialog(LiveDB.appframe,
                                                 "CANCELLED  INVOICE DETAILS EMAILED TO" + custemail);
                                     System.err.println(LiveDB.grassHopper(ex_NOKIA76, "File:" + rmafile));
                                     JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                   + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                   + LiveDB.ErrorLogFile);
                                     LiveDB.system_exit = 1;
                                    // LiveDB.SmoothExitCondition.signalAll();
                                   }
                               } // for (int i = 0; i < emailbody.length; i++)

                               try{
                                 bw.close();
                               }catch (IOException ex_NOKIA44){
                                     System.err.println(LiveDB.grassHopper(ex_NOKIA44, "File:" + rmafile));
                                     JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                                   + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                                   + LiveDB.ErrorLogFile);
                                     LiveDB.system_exit = 1;
                                    // LiveDB.SmoothExitCondition.signalAll();
                               }

                               if (emailbodytxt == null)
                               {
                                   for (int l = 0; l < emailbody.length; l++)
                                        emailbodytxt += emailbody[l];
                               }

                               if (LiveDB.EasyMail(custemail, emailbodytxt, rmafile) == false)
                               {
                                   JOptionPane.showMessageDialog(LiveDB.appframe,
                                           "Cancelled Invoice File on Disk " + rmafile
                                           + '\n'
                                           + "Could not be emailed to recipients"
                                           + '\n'
                                           + "Even after several retries");
                               }
                               else
                               {
                                   if (fl.delete() == false)
                                   {
                                       System.err.println(LiveDB.grassHopper("CANT DELETE FILE:"
                                               + rmafile));
                                   }
                                   JOptionPane.showMessageDialog(LiveDB.appframe,
                                           " CANCELLED INVOICE FILE:" + rmafile + '\n'
                                           + "Emailed as an attachment to"
                                           + '\n'
                                           + custemail);
                               }
                          }
                      }
                      else
                      {
                         JOptionPane.showMessageDialog(LiveDB.appframe, "You need to be logged in as"
                                 + '\n' + "superuser for Invoice Cancellation"
                                 + '\n' + "Taking you to login page");
                         retvals [0] = new LoginPage (); // 17th August 2012    
                      }
                      LiveDB.appframe.remove(sysadminpanel);
                      retvals [1] = new PageOneTextPanel (); // 17th August 2012
                  }

                  @Override
                  public void caretPositionChanged(InputMethodEvent event){
                            ; // dont bother
                  }
               });
               sysadminpanel.validate();
           }
           @Override
           public void mousePressed (MouseEvent evnt){
               option1.setForeground(Color.RED);
               option1.validate();
           }
           @Override
           public void mouseEntered (MouseEvent evnt){
               option1.setForeground(Color.RED);
               option1.validate();
           }
           @Override
           public void mouseReleased (MouseEvent evnt){
               option1.setForeground(Color.BLUE);
               option1.validate();
           }
           @Override
           public void mouseExited (MouseEvent evnt){
               option1.setForeground(Color.BLUE);
               option1.validate();
           }
        });

        option2.setForeground(Color.ORANGE);
        option2.setFont( new Font (LiveDB.USEFONT, Font.BOLD, 14));
        sysadminpanel.add( option2, BorderLayout.CENTER);
        option2.addMouseListener(new MouseListener (){
           @Override
           public void mouseClicked (MouseEvent evnt)
           {
               String propstext = null;
               File fl = new File (lensviewpropsfile);
               FileReader fr = null ;
               BufferedReader br = null;

               try{
               fr = new FileReader (fl);
               }catch (FileNotFoundException ex_NOKIA67){
                   System.err.println(LiveDB.grassHopper(ex_NOKIA67, "File:"
                                                            + lensviewpropsfile));
                   JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                     + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                     + LiveDB.ErrorLogFile);
                   LiveDB.system_exit = 1;
                   //LiveDB.SmoothExitCondition.signalAll();
               }
               
               br = new BufferedReader (fr);
               
               try{
                   while ((propstext = propstext + '\n' + br.readLine()) != null)
                                  ;
               }catch (IOException ex_NOKIA88){
                   System.err.println(LiveDB.grassHopper(ex_NOKIA88, "File:"
                                                            + lensviewpropsfile));
                   JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                     + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                     + LiveDB.ErrorLogFile);
                   LiveDB.system_exit = 1;
                   //LiveDB.SmoothExitCondition.signalAll();                   
               }

               sysadminpanel.removeAll();
               sysadminpanel.add(editprops, BorderLayout.CENTER);
               propsfile.setText(propstext);
               sysadminpanel.add(propsfile, BorderLayout.CENTER);
               sysadminpanel.add(WriteFile, BorderLayout.SOUTH);
               WriteFile.setBackground(Color.BLUE);
               WriteFile.setForeground(Color.WHITE);
               WriteFile.addMouseListener(new MouseListener ()
               {
                    @Override
                    public void mouseClicked (MouseEvent evnt)
                    {
                         
                         String text = propsfile.getText();
                         File fl = new File (lensviewpropsfile);
                         FileWriter fw = null;
                         BufferedWriter bw = null;
                         boolean exit = false;
                         int bi = 0;
                         char ch = '\n';

                         if (text.indexOf(ch) == -1)
                         {
                             if (text.indexOf('\r') == -1)
                             {
                                 JOptionPane.showMessageDialog(LiveDB.appframe, "Edited Properties File in"
                                         + '\n' + "Text Area does not contain"
                                         + '\n' + "newlines or carriage returns"
                                         + '\n' + "Insert newlines or carriage returns"
                                         + '\n' + "in Text Area & WriteFile again");
                                 propsfile.setFocusable(true);
                             }
                             else ch = '\r';
                         }

                         try{
                         fw = new FileWriter(fl);
                         }catch (IOException ex_NOKIA22){
                             System.err.println(LiveDB.grassHopper(ex_NOKIA22, "File:"
                                                                     + lensviewpropsfile));
                             JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                     + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                     + LiveDB.ErrorLogFile);
                             LiveDB.system_exit = 1;
                            // LiveDB.SmoothExitCondition.signalAll();
                         }

                         bw = new BufferedWriter (fw);

                         do
                         {
                             try{
                                bw.write(text.substring(bi, bi = text.indexOf(ch, bi)));
                             }catch (IOException ex_NOKIA99){
                                 System.err.println(LiveDB.grassHopper(ex_NOKIA99, "File:"
                                                                     + lensviewpropsfile));
                                 JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                           + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                           + LiveDB.ErrorLogFile);
                                 LiveDB.system_exit = 1;
                                // LiveDB.SmoothExitCondition.signalAll();
                                 exit = true;
                             }
                             if (!exit)
                             {
                                 if (bi == -1)
                                     exit = true;
                                 else
                                 {
                                    bi += 1;
                                    text = text.substring(bi);
                                 }
                             }
                         }while (exit == false);

                         try {
                           bw.close();
                         }catch (IOException ex_NOKIA45){
                             System.err.println(LiveDB.grassHopper(ex_NOKIA45, "File:"
                                                                     + lensviewpropsfile));
                             JOptionPane.showMessageDialog(LiveDB.appframe, "Exiting IOException" + '\n'
                                     + "YOUR LOG FILE FOR SESSION IS:" + '\n'
                                     + LiveDB.ErrorLogFile);
                             LiveDB.system_exit = 1;
                             //LiveDB.SmoothExitCondition.signalAll();
                         }

                         JOptionPane.showMessageDialog(LiveDB.appframe,
                                 LiveDB.versionControl.getApplicationName() + '\n' +
                                 " Properties File Written" );
                         LiveDB.appframe.remove(sysadminpanel);
                         retvals [2] = new PageOneTextPanel (); // 17th August 2012
                    }
                    @Override
                    public void mousePressed (MouseEvent evnt){
                        WriteFile.setForeground(Color.RED);
                        WriteFile.validate();
                    }
                    @Override
                    public void mouseEntered (MouseEvent evnt){
                        WriteFile.setForeground(Color.RED);
                        WriteFile.validate();
                    }
                    @Override
                    public void mouseReleased (MouseEvent evnt){
                        WriteFile.setForeground(Color.BLUE);
                        WriteFile.validate();
                    }
                    @Override
                    public void mouseExited (MouseEvent evnt){
                        WriteFile.setForeground(Color.BLUE);
                        WriteFile.validate();
                    }
               });
               sysadminpanel.validate();
           }
           @Override
           public void mousePressed (MouseEvent evnt){
               option1.setForeground(Color.RED);
               option1.validate();
           }
           @Override
           public void mouseEntered (MouseEvent evnt){
               option1.setForeground(Color.RED);
               option1.validate();
           }
           @Override
           public void mouseReleased (MouseEvent evnt){
               option1.setForeground(Color.BLUE);
               option1.validate();
           }
           @Override
           public void mouseExited (MouseEvent evnt){
               option1.setForeground(Color.BLUE);
               option1.validate();
           }
        });

        option3.setForeground(Color.ORANGE);
        option3.setFont( new Font (LiveDB.USEFONT, Font.BOLD, 14));
        sysadminpanel.add( option3, BorderLayout.CENTER);
        
        LiveDB.appframe.add(sysadminpanel, setConstraints(pX, pY, pW, pH));
        sysadminpanel.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
