/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import javax.swing.JOptionPane;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.Font;
import java.awt.Color;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JTextArea;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import static MaintainData.LiveDB.pd;
import static MaintainData.LanguagePanel.SelectedLanguage;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : TellAFriend
 *
 * @LOOKSY : LiveDB.indxpictureDatabase, LiveDB.appframe, LiveDB.PrepareAndSendMailMesg
 * @LOOKSY : LiveDB.serializedfilespath, LiveDB.ALRTLVL, FirstPage.cartpanel,
 *           FirstPage.picturepagetextpanel, LiveDB.LiveSharedDB
 *
 * Date File : None
 *
 * Called From : PicturePage()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Tell A Friend Panel
 * when the user clicks on PicturePage. It constructs a mail form for the picture to be emailed
 * to your friend along with a message from you and along with you personal email id and name.
 * All email ids are validated before a send.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 * 
 * Last Modification Date : 13th August 2012
 * Last Modifications : MArked as 13th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : search for LiveDB.USEFONT
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class TellAFriend {

    GridBagConstraints constraints = null;
    // removed declaration and its usage 13th August 2012
    //String langstring [] = null;
    JLabel tellafriend = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Tell A Friend")
            == null ? "Tell A Friend" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Tell A Friend"));
    JLabel pleasesubmit = null;
    JLabel friendsname = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Friends Name")
            == null ? "Friends Name:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Friends Name") + ":");
    JTextField fname = new JTextField ("Shirley", 20);
    JLabel friendsemail = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Friends Email")
            == null ? "Friends Email:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Friends Email") + ":");
    JTextField femail = new JTextField ("pskris@sify.com", 20);
    JLabel yourname = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your Name")
            == null ? "Your Name:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your Name") + ":");
    JTextField yname = new JTextField ("McLaine", 20);
    JLabel youremail = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your Email")
            == null ? "Your Email:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your Email") + ":");
    JTextField yemail = new JTextField ("smclaine1@gmail.com", 20);
    JLabel message = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Message")
            == null ? "Message:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Message") + ":");
    JTextArea mesg = new JTextArea ();
    JButton send = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Send")
            == null ? "Send" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Send"));
    static JPanel tellafriendpanel = new JPanel (new GridBagLayout ());


    public TellAFriend (final String p_piccode)
    {
        int pX = 0, pY = 0, pW = 0, pH = 0;
        int MF = 10;
        int Y = 0;
        String initialtext = null;

        tellafriendpanel.setBounds(pX = (int)FirstPage.cartpanel.LEFT_ALIGNMENT * MF,
                pY = (int)FirstPage.cartpanel.TOP_ALIGNMENT * MF,
                pW = (int)(FirstPage.picturepagetextpanel.RIGHT_ALIGNMENT * MF) -
                     (int)(FirstPage.picturepagetextpanel.LEFT_ALIGNMENT * MF),
                pH = (int)FirstPage.picturepagetextpanel.BOTTOM_ALIGNMENT * MF -
                      (int)FirstPage.picturepagetextpanel.TOP_ALIGNMENT * MF);
        
        LiveDB.appframe.remove(FirstPage.picturepagetextpanel);

        tellafriend.setForeground(Color.BLUE);
        tellafriendpanel.add(tellafriend, setConstraints(0,Y = 1,4,2));

        pleasesubmit = new JLabel ("Please submit the form below to tell a friend about '" +
             ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)LiveDB.indxpictureDatabase.get(p_piccode)])
             .getPic_title() + "'." );

        tellafriendpanel.add(pleasesubmit, setConstraints(0, Y += 2, 15, 1));

        friendsname.setForeground(Color.BLACK);
        friendsname.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        tellafriendpanel.add(friendsname, setConstraints((int)(tellafriendpanel.RIGHT_ALIGNMENT * MF)/2,
                Y += 2, 3, 1));
        tellafriendpanel.add(fname, setConstraints((int)(friendsname.RIGHT_ALIGNMENT * MF) + 1,
                Y, 4, 1));

        friendsemail.setForeground(Color.BLACK);
        friendsemail.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        tellafriendpanel.add(friendsemail, setConstraints((int)(friendsname.LEFT_ALIGNMENT * MF),
                Y += 1, 3, 1));
        tellafriendpanel.add(femail, setConstraints((int)(friendsemail.RIGHT_ALIGNMENT * MF) + 1,
                Y, 4, 1));
        femail.addInputMethodListener(new InputMethodListener (){

            @Override
            public void inputMethodTextChanged(InputMethodEvent event)
            {
                if (LiveDB.PrepareAndSendMailMesg(null, null, femail.getText().trim(),
                    null, null, "EMAIL FROM " + LiveDB.USRNAME, null, null) == false)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Invalid Friend Email ID Re-Enter");
                    femail.setFocusable(true);
                }
            }

            @Override
            public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
            }
        });

        yourname.setForeground(Color.BLACK);
        yourname.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        tellafriendpanel.add(yourname, setConstraints((int)(friendsname.LEFT_ALIGNMENT * MF),
                Y += 1, 3, 1));
        tellafriendpanel.add(yname, setConstraints((int)(yourname.RIGHT_ALIGNMENT * MF) + 1,
                Y, 4, 1));

        youremail.setForeground(Color.BLACK);
        youremail.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        tellafriendpanel.add(youremail, setConstraints((int)(friendsname.LEFT_ALIGNMENT * MF),
                Y += 1, 3, 1));
        tellafriendpanel.add(yemail, setConstraints((int)(youremail.RIGHT_ALIGNMENT * MF) + 1,
                Y, 4, 1));
        yemail.addInputMethodListener(new InputMethodListener (){

            @Override
            public void inputMethodTextChanged(InputMethodEvent event)
            {
                if (LiveDB.PrepareAndSendMailMesg(null, null, yemail.getText().trim(),
                    null, null, "EMAIL FROM " + LiveDB.USRNAME, null, null) == false)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Invalid Your Email ID Re-Enter");
                    yemail.setFocusable(true);
                }
            }

            @Override
            public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
            }
        });

        message.setForeground(Color.BLACK);
        message.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 12));
        tellafriendpanel.add(message, setConstraints((int)(friendsname.LEFT_ALIGNMENT * MF),
                Y += 2, 2, 1));
        tellafriendpanel.add(mesg, setConstraints((int)(message.RIGHT_ALIGNMENT * MF) + 1,
                Y, 7, 5));
        mesg.setSize(7, 5);
        initialtext = "Dear " + fname.getText().trim() + "," + '\n' + " I found this " +
        ((PictureDatabase)LiveDB.LiveSharedDB[pd][(int)(long)LiveDB.indxpictureDatabase.get(p_piccode)])
             .getPic_title() + '\n' + " and thought that you may be interested." + '\n'
        + " Revert to me if you wish to place an order " + '\n'
        +  " Best Regards" + '\n' + " " + yname.getText().trim() + '\n' + " My Email:"
        + yemail.getText().trim();
        mesg.setText(initialtext);

        send.setBackground(Color.ORANGE);
        send.setForeground(Color.WHITE);
        tellafriend.add(send, setConstraints((int)(mesg.LEFT_ALIGNMENT * MF), Y+= 2, 2, 1));
        send.addMouseListener(new MouseListener (){

            @Override
            public void mousePressed (MouseEvent evnt){
                send.setBackground(Color.GREEN);
                send.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt) {
                 // send out the email here with picture attachment
                if (LiveDB.PrepareAndSendMailMesg(null, null, femail.getText().trim(),
                    null, null, "EMAIL FROM " 
                    + yname.getText().trim() + ", RARE PHOTOGRAPHIC TREASURES DISCOVERED",
                    mesg.getText().trim(), 
                    ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                    [(int)(long)LiveDB.indxpictureDatabase.get(p_piccode)]).getPic_img_location()) == false)
                {
                    JOptionPane.showMessageDialog(LiveDB.appframe, "Friends MailBox Full. Try Another.");
                    femail.setFocusable(true);
                }
            }

            @Override
            public void mouseEntered (MouseEvent evnt) {
                send.setBackground(Color.GREEN);
                send.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt) {
                send.setBackground(Color.ORANGE);
                send.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt) {
                send.setBackground(Color.ORANGE);
                send.validate();
            }
        });

        LiveDB.appframe.add(tellafriendpanel, setConstraints(pX, pY, pW, pH));
        tellafriendpanel.validate();
    }
    
    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
