/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import static MaintainData.LiveDB.appframe;

/*
 * WIRING DIAGRAM :
 * LISTENER CLASS NAME : TopPaneListener implements ChangeListener
 *
 * @LOOKSY : FirstPage.java
 * @LOOKSY : SaleItemsPage.java
 * @LOOKSY : CataloguePage.java
 *
 * @LOOKSY : FirstPage.picturepagetextpanel, FirstPage.pageonetextpanel, CataloguePanel.toppane,
 *           LiveDB.appframe.
 *
 * Date File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class is a listener for the toppane of the screen which is initialized
 * in CataloguePanel and registered. So whenever the user changes his choice in the toppane the
 * appropriate page is constructed.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * Last Modification Date : 17th August 2012
 * Last Modifications : MArked as 17th August 2012
 * I have declared a new variable retvals []. This is needed to collect the newly constructed
 * objects in the code. If this is not used a new object will be created but the JVM may view these
 * objects as Orphans and garbage collect them.
 *
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class TopPaneListener implements ChangeListener
{
    Object retvals [] = new Object [3]; // 17th August 2012
    @Override
    public void stateChanged (ChangeEvent evnt)
    {
        int si = CataloguePanel.toppane.getSelectedIndex();
        int n = 0;
        String tit = CataloguePanel.toppane.getTitleAt(si);

        appframe.remove(FirstPage.picturepagetextpanel);
        FirstPage.pageonetextpanel.removeAll();

        if (tit.toLowerCase().indexOf("home") != -1)
            retvals [0] = new FirstPage (); // 17th August 2012
        else if (tit.toLowerCase().indexOf("sale") != -1) 
            retvals [1] = new SaleItemsPage (); // 17th August 2012
        else
            retvals [2] = new CataloguePage (tit); // 17th August 2012
    }
}
