/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.NotActiveException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.Date;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : VersionControl
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[]
 *         Dont read the entire ThreadController.java you will go mad.
 * @LOOKSY:InstallDB.java main () method
 * @LOOKSY:LiveDB.version
 *
 * Method Names : public VersionControl () -- Constructor method
 *                protected boolean refresh ()
 *                protected boolean backup ()
 *                private boolean restorebackup ()
 *                private boolean commit ()
 *                private void readObject (ObjectInputStream p_in) throws IOException, ClassNotFoundException
 *                private void writeObject (ObjectOutputStream p_out) throws IOException
 *                public String getDatabaseReleaseName ()
 *                public String getGUIReleaseName ()
 *                public String getPunchLine ()
 *                public String getApplicationName ()
 *                public String getPrivillegedcodeusername ()
 *                public String getPrivillegedcodenodename ()
 *                public short getReleaseNumber ()
 *                public boolean isSpecialRelease ()
 *                public boolean isBetaRelease ()
 *                public short getVersionNumber ()
 *                public short getBugFixNumber ()
 *                public Date getBugFixDate ()
 *                public String getIntegratedReleaseName ()
 *                protected boolean isFrozen ()
 *                protected void setFreeze (boolean YES)
 *                protected void setSpecialRelease ()
 *                protected void setBetaRelease (boolean YES)
 *                protected void setReleaseNumber (short p_rn)
 *                protected void setBugFixDate ()
 *                protected void setProgramVersion ()
 *                protected void setDatabaseReleaseName()
 *                protected void setGUIReleaseName()
 *                protected void setIntegratedReleaseName()
 *
 * @Since Version : 1.0
 *
 *  Data Attributes :
 *  private String ProgramVersion; Stores current Program Version as [S]Y.X.BB.DATE where
 *                                 Y Release Number 1 thru 9 if prefix 'S' Special Release for unspecified Customer.
 *                                 X Version Number from 0 thru 9 so 1.9 and then Y=2 and X=0
 *                                 BB is the Bug Fix Number from one thru 99 So 1.8.45 is bug fix 45 of Release 1 and version 8
 *                                 Date as a long indicating date and time of every BUGFIX in same Release and version number.
 *  private String OldProgramRelease;  This variable stores the entire OLD ProgramVersion for a restore if you need it
 *  private boolean Freeze; This variable indicates if a release is frozen/unfrozen if frozen application can run multiuser
 *  private String privillegedcodeusername; Only this user can run application he may compile it but cant launch
 *  private String privillegedcodenodename; Only this computer name can run application can compile but cant launch
 *  private String DatabaseReleaseName; Every database release has a new release name
 *  private String GUIReleaseName; Every release has a new GUI name
 *  private String IntegratedReleaseName; Every release has a new IntegratedReleaseName
 *  private String PunchLine; Every release has a new PunchLine (Free Thumping for Romans/Goths/Normans
 *                            we dont charge because of our charitable disposition).
 *                            Those other gauls in Brighton surrendered to Romans (Coorg)
 *  private transient String ApplicationName; transient so it wont be serialized. This is Application Name
 *                                            you can change it if you want but Integration will not detect
 *                                            it at all at the time of Integration with other databases.
 * 
 * This is the only perfect book example of Object Oriented Programming where a self contained Object
 * does everything to itself other than a destructor which is not needed here you are not un-installing
 * the program are you ??
 *
 * Technical Reference : Watch Gods Must be Crazy Parts I, II, III (Chinese Version)
 *                       For a better understand please read individual dogumentation.
 * 
 * Start Date: 18th October 2010
 * End Date: 11th May 2011
 * Last Modification Date : 7th October 2011
 * Last Modifications : validating ApplicationName in constructor
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */


final public class VersionControl implements Serializable {

   private String ProgramVersion;
   private String OldProgramRelease;
   private boolean Freeze;
   private String privillegedcodeusername;
   private String privillegedcodenodename;
   private String DatabaseReleaseName;
   private String GUIReleaseName;
   private String IntegratedReleaseName;
   private String PunchLine;
   private transient String ApplicationName;

   {
        // karma karma chameleon you can change the name here and camoflouge it from intruders
        ApplicationName = "LensView";
   }
   
/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstallDB.java until the second call from main() method to LiveDB.redirectstderr()
 * @LOOKSY:LiveDB.command_line,LiveDB.serializedfilespath, LiveDB.ErrorLogFile, LiveDB.redirectstderr()
 * @LOOKSY:LiveDB.serializedfilespath/version/VersionControl.ver using Hex Editor if you so desire
 * @LOOKSY:InstallDB.java main () method
 *
 * CONSTRUCTOR Method Name : public VersionControl ()
 * Parameters : None
 * Returns : None -- it is new which returns the Object
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is the default constructor replacement without parameters. It checks if it is
 * install time using LiveDB.command_line. If so it sets some Release Names and default program version and
 * declares it a Beta Release (Optional).
 * If not Install time then the constructor checks for the existence of the VersionControl.ver file at path
 * LiveDB.serializedfilespath/version specified by user at installtime. If file does not exist it tries to
 * restore a backup file. If that restore of backup fails then it resets everything back to program version
 * 1.0.00 and commits it. If that VersionControl.ver file already exists then it does a refresh and reads in
 * those values from the stream.
 *
 * Technical Reference : Read Asterix Mansion of the Gods
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  public VersionControl (){

      File vc = new File (LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver");

      if (ApplicationName.trim().length() < 3)  // at least three chars to make a sensible name
      {
          LiveDB.ALRTLVL = 15;
          System.err.println(LiveDB.grassHopper("Invalid Applcation Name reseting to LensView"));
          ApplicationName = "LensView";
      }
      
      
      
      if (LiveDB.command_line.equals("FileTableDataFileMap"))
      {          
           ProgramVersion = ("1.0.00." + new Date().getTime()).trim();    
           privillegedcodeusername = "pskris";
           privillegedcodenodename = "Zoa";
           setDatabaseReleaseName();
           setGUIReleaseName();
           setIntegratedReleaseName();        
           setPunchLine();
           setBetaRelease(true); // this is a Beta Release
           // Uncomment the line below for your version of the program
           // or use setRelease() for a new release. 
           // setProgramVersion ();
           OldProgramRelease = ProgramVersion;
           
          // if (LiveDB.command_line.equals("FileTableDataFileMap") == false)
               if (this.commit() == false)
                   System.exit(1);
      }
      else
      {
            if (vc.exists() == false)
            {
                // removed this
                if (restorebackup() == false)
                {
                    // ProgramVersion Format
                    // String [S]Y.X.BB.DATE
                    ProgramVersion = ("1.0.00." + new Date().getTime()).trim();
                    OldProgramRelease = ProgramVersion;
                    privillegedcodeusername = "pskris";
                    privillegedcodenodename = "Zoa";
                    setDatabaseReleaseName();
                    setGUIReleaseName();                    
                    setIntegratedReleaseName();
                    setPunchLine();
                    
                    setBetaRelease(true);
                    
                    if (this.commit() == false)
                        System.exit(1);
                    return;
                }                
            }
            
            if (refresh() == false)
                System.exit(1); 
      }
      
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.serializedfilespath/version/VersionControl.ver
 * @LOOKSY: LiveDB.serializedfilespath/version/VersionControl.ver.bkp, LiveDB.CopyFile(), LiveDB.grassHopper()
 *
 * Method Name : protected boolean refresh ()
 * Parameters : None
 * Returns : boolean true if read of file VersionControl.ver is successfull.
 *           boolean false if streams error or any other error
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from the constructor and it de-serializes the stream
 * VersionControl.ver and reads in all values.
 *
 * Technical Reference : Asterix and the Class Act (Buy and Read fresh stock)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  
  protected boolean refresh (){

      File vc = new File (LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver");
      FileInputStream fis = null;
      ObjectInputStream ois = null;

      
      if (vc.canWrite())
      {
         LiveDB.ALRTLVL = 1;
         System.err.println (LiveDB.grassHopper("File Perms tampered to write on VersionControl.ver resetting"));

         if (vc.setReadOnly() == false)
            System.err.println (LiveDB.grassHopper("Unable to set perms readonly on VersionControl.ver via Application"));
      }

      // DONT QUEUE THIS IN PLATFORM CLEARANCE NO NEED REALLY
      try{
            fis = new FileInputStream (vc);
          
      }catch (FileNotFoundException ex_NOKIA71){
         System.err.println(LiveDB.grassHopper(ex_NOKIA71, "File:" + LiveDB.serializedfilespath
                 + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver"));
         return false;
      }

      try{
          ois = new ObjectInputStream(fis);
      }catch (IOException ex_NOKIA86){
         System.err.println(LiveDB.grassHopper(ex_NOKIA86, "File:" + LiveDB.serializedfilespath
                 + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver"));
         return false;
      }

      
      try{
          LiveDB.versionControl = (VersionControl)ois.readObject();
      }catch (IOException ex_NOKIA82){
         System.err.println(LiveDB.grassHopper(ex_NOKIA82));
         return false;
      }catch (ClassNotFoundException ex_NOKIA87){
         System.err.println(LiveDB.grassHopper(ex_NOKIA87));
         return false;
      }
      
      LiveDB.versionControl.ApplicationName = "LensView";
      

      try{
          ois.close();
      }catch (IOException ex_NOKIA82){
          System.err.println(LiveDB.grassHopper(ex_NOKIA82, "File:" + LiveDB.serializedfilespath
                  + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver"));
          return false;
      }

      return true;
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.serializedfilespath/version/VersionControl.ver
 * @LOOKSY: LiveDB.serializedfilespath/version/VersionControl.ver.bkp, LiveDB.CopyFile(), LiveDB.grassHopper()
 *
 * Method Name : protected boolean backup ()
 * Parameters : None
 * Returns : boolean true if backup succeeds to LiveDB.serializedfilespath/version/VersionControl.ver.bkp
 *           boolean false if backup fails due to streams error or any other error.
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method takes a simple backup of LiveDB.serializedfilespath/version/VersionControl.ver
 *                      to LiveDB.serializedfilespath/version/VersionControl.ver.bkp using LiveDB.CopyFile()
 *
 * Technical Reference : Asterix and Obelix's Birthday -- Golden Book -- (Buy/Gift to your Gaulish Children)
 *                       http://gb.asterix.com for an encyclopedia on Thumping Romans.
 * 
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected boolean backup (){

      if (new File(LiveDB.serializedfilespath + "version").canWrite())
      {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "version"));
      }
      else
      {
            if (new File(LiveDB.serializedfilespath + "version").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "version"));
                LiveDB.system_exit = 1;
               // LiveDB.SmoothExitCondition.signalAll();
            }
      }
      // take a backup whenever you want to
      String from = LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver";
      String to = LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver" + ".bkp";

      if (LiveDB.CopyFile(from, to) == false)
      {
          LiveDB.ALRTLVL = 3;
          System.err.println (LiveDB.grassHopper(LiveDB.serializedfilespath
                  + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver.bkp Failed"));
          return false;
      }

      if (new File (LiveDB.serializedfilespath + "version").setReadOnly() == false)
      {
          LiveDB.ALRTLVL = 3;
          System.err.println(LiveDB.grassHopper("Cant setReadonly File:" + LiveDB.serializedfilespath
                                                                                        + "version"));
      }
      
      return true;
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.serializedfilespath/version/VersionControl.ver
 * @LOOKSY: LiveDB.serializedfilespath/version/VersionControl.ver.bkp, LiveDB.CopyFile(), LiveDB.grassHopper()
 *
 * Method Name : private boolean restorebackup ()
 * Parameters : None
 * Returns : boolean true if backup has been restored successfully
 *           boolean false if streams error or any other error.
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This restores backup from  LiveDB.serializedfilespath/version/VersionControl.ver.bkp
 *                      to LiveDB.serializedfilespath/version/VersionControl.ver
 *
 * Technical Reference : Asterix and the Chieftains Shield (grab it back)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  private boolean restorebackup (){

     // if some miserable ...... has deleted the VersionControl.ver file
     // then restore from backup but this restoration from backup may not
     // be accurate on Bug Fix Numbers.

      String to = LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver";
      String from = LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver" + ".bkp";

      if (new File(from).exists() == false)          
          return false;
      
      
      if (new File(LiveDB.serializedfilespath + "version").canWrite())
      {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "version"));
      }
      else
      {
            if (new File(LiveDB.serializedfilespath + "version").setWritable(true, false) == false)
            {                
               /*  System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "version")); */
                
                if (LiveDB.command_line.equals("FileTableDataFileMap"))
                    return true; // fake it because at install time version directory may not exist
                else
                    return false;
                /*
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
                * 
                */
            }
      }
      
      if (LiveDB.CopyFile(from, to) == false)
      {
          LiveDB.ALRTLVL = 3;
          System.err.println (LiveDB.grassHopper("Restore" +  LiveDB.serializedfilespath
                  + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver.bkp Failed"));
          return false;
      }

      if (new File (LiveDB.serializedfilespath + "version").setReadOnly() == false)
      {
          LiveDB.ALRTLVL = 3;
          System.err.println(LiveDB.grassHopper("Cant setReadonly File:" + LiveDB.serializedfilespath
                                                                                        + "version"));
      }

      return true;
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath,LiveDB.serializedfilespath/version/VersionControl.ver,LiveDB.grassHopper
 *
 * Method Name : private boolean commit ()
 * Parameters : None
 * Returns : boolean true if class VersionControl has been successfully serialized to stream
 *           boolean false if streams error
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This commits this class contents serializing it to a filename VersionControl.ver
 * at LiveDB.serializedfilespath/version/
 * 
 * Technical Reference : Asterix and the Great Divide (Borrow)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  private boolean commit (){

      if (LiveDB.command_line.equals("FileTableDataFileMap") == false)
      {
      if (new File(LiveDB.serializedfilespath  + "version").canWrite())
      {
          System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "version"));
      }
      else
      {
            if (new File(LiveDB.serializedfilespath  + "version").setWritable(true, false) == false)
            {                
                if (LiveDB.command_line.equals("FileTableDataFileMap"))
                    return true;
                else
                    return false;                
            }
      }
      }
      
      File vc = null;
      FileOutputStream fos = null;
      ObjectOutputStream oos = null;

      if (LiveDB.command_line.equals("FileTableDataFileMap") == true)
            vc = new File (LiveDB.serializedfilespath + "VersionControl.ver");           
      else          
            vc = new File (LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR 
               + "VersionControl.ver");
       
      try{
      vc.createNewFile();
      }catch (SecurityException ex_NOKIA89){          
          System.err.println(LiveDB.grassHopper(ex_NOKIA89, "Denied write Access to File:" +
                  LiveDB.serializedfilespath + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver"));
          return false;
      }catch (IOException ex_NOKIA71){          
          System.err.println(LiveDB.grassHopper(ex_NOKIA71));
          return false;
      }
      
      
      // DONT QUEUE THIS IN PLATFORM CLEARANCE NO NEED REALLY
      try{
            fos = new FileOutputStream (vc);
      }catch (FileNotFoundException ex_NOKIA71){}
      
      /*catch (FileNotFoundException ex_NOKIA71){
         System.out.println("returning false FileNotFound");
         System.err.println(LiveDB.grassHopper(ex_NOKIA71, "File:" + LiveDB.serializedfilespath
                 + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver"));         
         return false;
      }*/
      
      
      try{
          oos = new ObjectOutputStream(fos);
      }catch (IOException ex_NOKIA86){
          
         System.err.println(LiveDB.grassHopper(ex_NOKIA86, "File:" + LiveDB.serializedfilespath
                 + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver"));
         
         return false;
      }
      
      try{
          oos.writeObject(this);
      }catch (IOException ex_NOKIA82){
         System.err.println(LiveDB.grassHopper(ex_NOKIA82));
         return false;
      }
      
      try{
          oos.close();
      }catch (IOException ex_NOKIA82){
          System.err.println(LiveDB.grassHopper(ex_NOKIA82, "File:" + LiveDB.serializedfilespath
                  + "version" + LiveDB.FILESEPERATOR + "VersionControl.ver"));
          return false;
      }

      return true;
  }

  // Tree SCCS commands will be added Paisa mungtah hai
  protected boolean CheckIn (String... p_files){

      // hey dorks fake the class loader mechanism instead of loading all classes
      // there is some way out
      // because the user will call using command line
      // $InstallDB CheckIn rosy.java jasmine.java khusboo.java yasmin.java
      // Thombi complicated pah
      // there may be some snippets of source code on the net to cut and steal !!
      // also you will have to modify privillegedcodenodename and privillegedcodeusername
      // to a String array of dimension String[DEVELOPMENTTEAMSIZE] and serialize that also
      // so pay some java programmer $100 worth of pizza's and six packs of beer on a weekend !!!
      // maybe even movie tickets will do as long as the development will take .... cheaper option
      return true;
  }

  protected boolean CheckOut (String... p_files){

      // hey dorks fake the class loader mechanism instead of loading all classes
      // there is some way out
      // because the user will call using command line
      // $InstallDB CheckOut rosy.java jasmine.java khusboo.java yasmin.java
      // Thombi complicated pah
      // there may be some snippets of source code on the net to cut and steal !!
      // also you will have to modify privillegedcodenodename and privillegedcodeusername
      // to a String array of dimension String[DEVELOPMENTTEAMSIZE] and serialize that also
      return true;
  }

  protected boolean ChuckOut (String... p_files){

      // because the user will call using command line
      // $InstallDB ChuckOut rosy.java jasmine.java khusboo.java yasmin.java
      
      // there may be some snippets of source code on the net to cut and steal !!
      // also you will have to modify privillegedcodenodename and privillegedcodeusername
      // to a String array of dimension String[DEVELOPMENTTEAMSIZE] and serialize that also
      return true;
  }
  
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.grassHopper(), LiveDB.system_exit, LiveDB.SmoothExitCondition
 *
 * Method Name : private void readObject (ObjectInputStream p_in) throws IOException, ClassNotFoundException
 * Parameters : p_in -- the stream to de-serialize from or read from
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a private override of the default de-serialization mechanism in Java
 * using this method you can control the data to be de-serialized.
 *
 * Technical Reference : Buy and Read Asterix and the Goths.
 *                       Goscinny was just fine but Uderzo's Gaulishness is increasingly suspect.
 *                       He is not working anymore to add to treasure house of Gaulish literature on shelf.
 *                       A sold out Gaul it appears.
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
/*
  private void readObject (ObjectInputStream p_in) throws IOException, ClassNotFoundException{

        System.out.println("p_in=" + p_in);
        try{
         p_in.defaultReadObject();
        }catch (ClassNotFoundException ex_NOKIA67){
            
            System.out.println("Class Not Found");
        }catch (NotActiveException ex_NOKIA88){
        
           System.out.println("NotActiveException");
        }catch (IOException ex_NOKIA71){
            System.err.println(LiveDB.grassHopper(ex_NOKIA71, "De-Serialization Error VersionControl"));
            System.exit(1);
        } 
        
        //System.out.println("ProgramVersion=" + LiveDB.versionControl.getProgramVersion());
        // THIS IS NOT BEHAVING ALTHOUGH IT SHOULD BE THE EQUIVALENT OF defaultReadObject
        // try readObject instead of readUTF. Actually it reads well but later when I try
        // and access versionControl.getProgramversion () or any othe method it hangs.
        
        try{
              ProgramVersion = p_in.readUTF();
              
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field ProgramVersion"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field ProgramVersion"));
              throw new IOException ();
        }

        try{
              OldProgramRelease = p_in.readUTF();
              
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field OldProgramRelease"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field OldProgramRelease"));              
              throw new IOException ();
        }

        try{
              Freeze = p_in.readBoolean();
        }catch (EOFException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field Freeze"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field Freeze"));              
              throw new IOException ();
        }

        try{
              privillegedcodeusername = p_in.readUTF();
              
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field privillegedcodeusername"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field privillegedcodeusername"));
              throw new IOException ();
        }

        try{
              privillegedcodenodename = p_in.readUTF();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field privillegedcodenodename"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field privillegedcodenodename"));
              throw new IOException ();
        }

        try{
              DatabaseReleaseName = p_in.readUTF();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field DatabaseReleaseName"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field DatabaseReleaseName"));
              throw new IOException ();
        }


        try{
              GUIReleaseName = p_in.readUTF();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field GUIReleaseName"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field GUIReleaseName"));
              throw new IOException ();
        }


        try{
              IntegratedReleaseName = p_in.readUTF();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field IntegratedReleaseName"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field IntegratedReleaseName"));              
              throw new IOException ();
        }

        try{
              PunchLine = p_in.readUTF();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field PunchLine"));
              throw new IOException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field PunchLine"));
              throw new IOException ();
        }
        
  }
*/
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.grassHopper()
 *
 * Method Name : private void writeObject (ObjectOutputStream p_out) throws IOException
 * Parameters : p_out -- the stream to serialize to
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a private override of the default serialization mechanism in Java
 * using this method you can control the data to be written to the stream. I am writing yeverthing.
 *
 * Technical Reference : Buy and Read Asterix and the Cauldron.
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
/*
  private void writeObject (ObjectOutputStream p_out) throws IOException {

      try{
      p_out.defaultWriteObject ();
      }catch( IOException ex_NOKIA72){
          System.err.println(LiveDB.grassHopper(ex_NOKIA72, "VersionControl Serialization Error"));
          System.exit(1);
      }

     // THIS IS NOT BEHAVING ALTHOUGH IT SHOULD BE THE EQUIVALENT OF defaultWriteObject
     // try writeObject instead of writeUTF
      try{
              p_out.writeUTF(ProgramVersion);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field ProgramVersion"));
         throw new IOException ();
      }

      try{
              p_out.writeUTF(OldProgramRelease);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field OldProgramRelease"));
         throw new IOException ();
      }

      try{
             p_out.writeBoolean(Freeze);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field Freeze"));
         throw new IOException ();
      }

      try{
              p_out.writeUTF(privillegedcodeusername);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field privillegedcodeusername"));
         throw new IOException ();
      }

      try{
              p_out.writeUTF(privillegedcodenodename);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field privillegedcodenodename"));
         throw new IOException ();
      }

      try{
              p_out.writeUTF(DatabaseReleaseName);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field DatabaseReleaseName"));
         throw new IOException ();
      }

      try{
              p_out.writeUTF(GUIReleaseName);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field GUIReleaseName"));
         throw new IOException ();
      }

      try{
              p_out.writeUTF(IntegratedReleaseName);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field IntegratedReleaseName"));
         throw new IOException ();
      }

      try{
              p_out.writeUTF(PunchLine);
      }catch (IOException ex_NOKIA91){
         System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field PunchLine"));
         throw new IOException ();
      }

      try{
          p_out.flush();
      }catch (IOException ex_NOKIA73){
         System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during VersionControl serialization"));
         System.exit(1);
      }
      

  }
*/
  // A whole bunch of getters Self Explanatory dont need dogumentation

  public String getProgramVersion (){
      return new String((ProgramVersion.trim()).toCharArray());
  }
  public String getDatabaseReleaseName (){
      return new String(DatabaseReleaseName.trim().toCharArray());
  }

  public String getGUIReleaseName (){
      return new String(GUIReleaseName.trim().toCharArray());
  }

  public String getPunchLine (){
     return new String(PunchLine.trim().toCharArray());
  }

  public String getApplicationName (){
      return new String((ApplicationName.trim()).toCharArray());
  }
  
  public String getPrivillegedcodeusername (){
      return new String(privillegedcodeusername.trim().toCharArray());
  }

  public String getPrivillegedcodenodename (){
      return new String((privillegedcodenodename.trim()).toCharArray());
  }

  public short getReleaseNumber (){
      
      int i = 0;

      if (ProgramVersion.indexOf('.') == -1)
      {
          LiveDB.ALRTLVL = 1;
          System.err.println (LiveDB.grassHopper("ProgramVersion details corrupted Exiting"));
          System.exit(1);
      }

      if (ProgramVersion.indexOf('S') != -1 || ProgramVersion.indexOf('B') != -1)
               i = 1;
      
      return Short.parseShort(ProgramVersion.substring(i, i+1));
      
  }

  public boolean isSpecialRelease (){
      if (ProgramVersion.indexOf('S') != -1)
         return true;
      else return false;
  }

  public boolean isBetaRelease (){
      if (ProgramVersion.indexOf('B') != -1)
         return true;
      else return false;
  }
  
  public short getVersionNumber (){

      int n = 0;

      if ((n = ProgramVersion.indexOf('.')) == -1)
      {
          LiveDB.ALRTLVL = 1;
          System.err.println (LiveDB.grassHopper("ProgramVersion details corrupted Exiting"));
          System.exit(1);
      }

      return Short.parseShort(ProgramVersion.substring(n+1, n+2));
  }

  public short getBugFixNumber (){
      // ProgramVersion Format
      // String [S]Y.X.BB.DATE

      int n = 0;

      if ((n = ProgramVersion.lastIndexOf('.')) == -1)
      {
          LiveDB.ALRTLVL = 1;
          System.err.println (LiveDB.grassHopper("ProgramVersion details corrupted Exiting"));
          System.exit(1);
      }

      return Short.parseShort(ProgramVersion.substring(n-2, n));

  }

  public Date getBugFixDate (){
      // ProgramVersion Format
      // String [S]Y.X.BB.DATE

      int n = 0;

      if ((n = ProgramVersion.lastIndexOf('.')) == -1)
      {
          LiveDB.ALRTLVL = 1;
          System.err.println (LiveDB.grassHopper("ProgramVersion details corrupted Exiting"));
          System.exit(1);
      }

      return new Date(Long.parseLong(ProgramVersion.substring(n+1, ProgramVersion.length())));
  }

  public String getIntegratedReleaseName (){
      return new String(IntegratedReleaseName.trim().toCharArray());
  }

  protected boolean isFrozen (){
      return Freeze;
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper()
 *
 * Method Name : protected void setIntegratedReleaseName (String... p_name)
 * Parameters : None or Many
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method without any params will set IntegratedReleaseName to Xi.
 * Xi is always the default even if you call this method with an erroneous parameter. For Release2
 * and higher the defaults are set to Martina (a rare swiss flower).
 *
 * Technical Reference : Buy and Read Asterix in Switzerland (in Search of a Flower)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setIntegratedReleaseName (String... p_name){

       if (getReleaseNumber () == 1 || p_name.length == 0 )
       {
          IntegratedReleaseName = "Xi"; // With other databases like NANPA JANPA etc
          return;
       }

       if (getReleaseNumber () > 1 && p_name.length > 0)
       {
           if (p_name[0].equals("Xi") == false)
               IntegratedReleaseName = p_name[0];
           else
           {
               LiveDB.ALRTLVL = 6;
               System.err.println(LiveDB.grassHopper
                       ("IntegratedReleaseName for Release2/higher must not be Xi.Defaults to Martina"));
               IntegratedReleaseName = "Martina";
           }
           return;
       }

       if (getReleaseNumber () == 1 && p_name.length != 0 && (p_name[0].equals("Xi") == false))
       {
           LiveDB.ALRTLVL = 6;
           System.err.println(LiveDB.grassHopper("IntegratedReleaseName for Release1 must be Xi. This time for Africa"));
           IntegratedReleaseName = "Xi";
           return;
       }

       if (getReleaseNumber () > 1 && p_name.length == 0)
          IntegratedReleaseName = "Martina"; // pretty species
       
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper()
 *
 * Method Name : protected void setGUIReleaseName (String... p_name)
 * Parameters : None or Many
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method without any params will set GUIReleaseName to Xisa.
 * Xisa is always the default even if you call this method with an erroneous parameter.For Release2
 * and higher the defaults are set to Isabella.
 *
 * Technical Reference : Buy and Read Asterix in Spain (OLE Klik Klak)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  
  protected void setGUIReleaseName (String... p_name){

       if (getReleaseNumber () == 1 || p_name.length == 0 )
       {
          GUIReleaseName = "Xisa";
          return;
       }

       if (getReleaseNumber () > 1 && p_name.length > 0)
       {          
           if (p_name[0].equals("Xisa") == false)
               GUIReleaseName = p_name[0];
           else
           {
               LiveDB.ALRTLVL = 6;
               System.err.println(LiveDB.grassHopper
                       ("GUIReleaseName for Release2/higher must not be Xisa.Defaults to Isabella"));
               GUIReleaseName = "Isabella";
           }
           return;
       }

       if (getReleaseNumber () == 1 && p_name.length != 0 && (p_name[0].equals("Xisa") == false))
       {
           LiveDB.ALRTLVL = 6;
           System.err.println(LiveDB.grassHopper("GUIReleaseName for Release1 must be Xisa. This time for Africa"));
           GUIReleaseName = "Xisa";
           return;
       }

       if (getReleaseNumber () > 1 && p_name.length == 0)
          GUIReleaseName = "Isabella";
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper()
 *
 * Method Name : protected void setDatabaseReleaseName (String... p_name)
 * Parameters : None or Many
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method without any params will set DatabaseReleaseName to Xira.
 * Xira is always the default even if you call this method with an erroneous parameter.For Release2
 * and higher the defaults are set to Species.
 *
 * Technical Reference : Buy and Read Asterix and the Banquet (Dont beg, borrow and steal)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setDatabaseReleaseName (String... p_name){

       if (getReleaseNumber () == 1 && p_name.length == 0)
       {
          DatabaseReleaseName = "Xira";
          return;
       }
       
       if (getReleaseNumber () > 1 && p_name.length > 0)
       {
           if (p_name[0].equals("Xira") == false)
               DatabaseReleaseName = p_name[0];
           else
           {
               LiveDB.ALRTLVL = 6;
               System.err.println(LiveDB.grassHopper
                       ("DatabaseReleaseName for Release2/higher must not be Xira.Defaults to Species"));
               DatabaseReleaseName = "Species";
           }
           return;
       }

       if (getReleaseNumber () == 1 && p_name.length != 0 && (p_name[0].equals("Xira") == false))
       {
           LiveDB.ALRTLVL = 6;
           System.err.println(LiveDB.grassHopper("DatabaseReleaseName for Release1 must be Xira. This time for Africa"));
           DatabaseReleaseName = "Xira";
           return;
       }

       if (getReleaseNumber () > 1 && p_name.length == 0)
          DatabaseReleaseName = "Species";
       
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper()
 *
 * Method Name : protected void setDatabaseReleaseName (String... p_name)
 * Parameters : None or Many
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method without any params will set PunchLine to
 * "Until End of Earth thru Xi's Lenses" which is always the default even if you call this method with an
 * erroneous parameter.For Release2 and higher the defaults are set to
 * "From small seaside village of Indomitable Gauls (Kodangudi)". Kodangudi is the Gaulish Capital.
 * For a quick look at the Map of Gaul buy a map of TamilNadu state. Gaul has always been surrounded
 * by Roman fortifications of Totaram, Lungdaram, Gangaram etc. The Romans have never had enough of us.
 * 
 * Technical Reference : Buy and Read Asterix and the Big Fight
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  
  protected void setPunchLine (String... p_name){
      
       if (getReleaseNumber () == 1 || p_name.length == 0 )
          PunchLine = "Until End of Earth thru Xi's Lenses";
       else
          PunchLine = p_name[0];
       if (getReleaseNumber () > 1 && p_name.length > 0)
       {
           if (p_name[0].equals("Until End of Earth thru Xi's Lenses") == false)
               PunchLine = p_name[0];
           else
           {
               LiveDB.ALRTLVL = 6;
               System.err.println(LiveDB.grassHopper
                       ("PunchLine for Release2/higher must not be Until End of Earth thru Xi's Lenses.Defaults applied"));
               PunchLine = "From small seaside village of Indomitable Gauls (Kodangudi)";
           }
           return;
       }

       if (getReleaseNumber () == 1 && p_name.length != 0 && (p_name[0].equals("Until End of Earth thru Xi's Lenses") == false))
       {
           LiveDB.ALRTLVL = 6;
           System.err.println(LiveDB.grassHopper("PunchLine for Release1 must be Until End of Earth thru Xi's Lenses."));
           PunchLine = "Until End of Earth thru Xi's Lenses";
           return;
       }
       if (getReleaseNumber () > 1 && p_name.length == 0)
          PunchLine = "From small seaside village of Indomitable Gauls (Kodangudi)";
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper(), LiveDB.NODENAME, LiveDB.USRNAME, LiveDB.CHECKPROGRAM
 *
 * Method Name : protected void setFreeze (boolean YES)
 * Parameters : None or Many
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method with true or false Freezes or UnFreezes a release. Only when
 * a release is Frozen can you launch the program otherwise it will exit if getPrivillegedcodenodename()
 * or getPrivillegedcodeusername() dont match with LiveDB.NODENAME, LiveDB.USRNAME. Secondly you cant
 * Freeze a Beta Release.
 *
 * Technical Reference : Buy and Read Asterix in Corsica
 *                       Vendettas, fierce family pride, resistance fighters dodging the enemy in the Maquis
 *                       -- we are in Corsica  in 50BC, Asterix and Obelix help Chief Boneywasawarriorwayayix
 *                       to foil the evil designs of Julius Caesar .. for the only emperor proud Corsicans
 *                       will ever accept must be a Corsican himself.
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setFreeze (boolean YES){
 
      if (isBetaRelease ())
      {
          if (YES)
          {
              LiveDB.ALRTLVL = 3;
              System.err.println(LiveDB.grassHopper("VersionControl denies Freeze on Beta Version"));
          }
          LiveDB.CHECKPROGRAM = true;
          return;
      }
      else if (isSpecialRelease () == true)
          LiveDB.CHECKPROGRAM = false;

      // set unset Freeze
      setFreeze(YES);

      if (isFrozen() == false)
      {
          if (LiveDB.NODENAME.equals(getPrivillegedcodenodename()) == false
              || LiveDB.USRNAME.equals(getPrivillegedcodeusername()) == false)
          {
              LiveDB.ALRTLVL = 3;
              System.err.println(LiveDB.grassHopper("LiveDB.versionControl denies perms to run program"));
	      JOptionPane.showMessageDialog( LiveDB.appframe,"LiveDB.versionControl denies perms to run program");
              JOptionPane.showMessageDialog(LiveDB.appframe," Set privillegedcodeusername to " + getPrivillegedcodeusername() +
                      "to run this program");
              System.exit(1);
          }
      }
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper(), LiveDB.NODENAME, LiveDB.USRNAME, LiveDB.CHECKPROGRAM
 *
 * Method Name : protected void setFreeze (boolean YES)
 * Parameters : None or Many
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method with true or false Freezes or UnFreezes a release. Only when
 * a release is Frozen can you launch the program otherwise it will exit if getPrivillegedcodenodename()
 * or getPrivillegedcodeusername() dont match with LiveDB.NODENAME, LiveDB.USRNAME. Secondly you cant
 * Freeze a Beta Release.
 *
 * Technical Reference : Buy and Read Asterix in Corsica
 *                       Vendettas, fierce family pride, resistance fighters dodging the enemy in the Maquis
 *                       -- we are in Corsica  in 50BC, Asterix and Obelix help Chief Boneywasawarriorwayayix
 *                       to foil the evil designs of Julius Caesar .. for the only emperor proud Corsicans
 *                       will ever accept must be a Corsican himself.
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setSpecialRelease (){
      if (this.isSpecialRelease() == false)
      {
          if (this.isBetaRelease() == true)
             ProgramVersion = "S" + ProgramVersion.substring(1, ProgramVersion.length());
          else
             ProgramVersion = "S" + ProgramVersion.substring(0, ProgramVersion.length());
          LiveDB.CHECKPROGRAM = false;
          this.setFreeze(true);
          if (this.commit() == false)
             System.exit(1);
      }
      else return;
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper(), LiveDB.CHECKPROGRAM
 *
 * Method Name : protected void setBetaRelease (boolean YES)
 * Parameters : None or Many
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method with true or false Freezes or UnFreezes a Beta release.
 * If this release is already Frozen it will return doing nothing. If set or unset from Beta Release
 * it is committed and then the method returns.
 *
 * Technical Reference : Buy and Read Asterix and the Actress
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  
  protected void setBetaRelease (boolean YES){
      // ProgramVersion Format
      // String [S]Y.X.BB.DATE

      if (this.isFrozen() && YES == true)
      {
         LiveDB.ALRTLVL = 5;
         System.err.println(LiveDB.grassHopper("Frozen Release use setFreeze (false) to unfreeze"));
         return;
      }
      
      // set and unset Beta Release
      int i = 0;

      if (this.isBetaRelease() && YES)
          return;

      if (this.isBetaRelease() && YES == false)
          i = 1;

      if (this.isSpecialRelease() && YES == true)
              i = 1;

      if (this.isSpecialRelease() && YES == false)
          return;
      
      ProgramVersion = "B".concat(ProgramVersion.substring(i, ProgramVersion.length()));
      

      LiveDB.CHECKPROGRAM = true;

      
      if (this.isBetaRelease())
          setFreeze(false);
      

      if (LiveDB.command_line.equals("FileTableDataFileMap") == false)
         if (this.commit() == false )
         {            
            System.exit(1);
         }
  }


/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper(), LiveDB.CHECKPROGRAM, LiveDB.NODENAME, LiveDB.USRNAME
 *
 * Method Name : protected void setReleaseNumber (short p_rn)
 * Parameters : short p_rn -- Release Numbers 1 thru 9
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method sets a new release number and also sets the Version and Bug
 * numbers to zero. But it does a lot many checks to ensure the following compliance.
 * Release numbers 1 thru 6 are for privilleged USAGE getPrivillegedcodeusername() = pskris
 * and getPrivillegedcodenodename() = "Zoa". The other numbers 7 thru 9 are meant for your Usage. It then
 * commits and does a backup.
 * In addition to the above enforced checks please stick to the following which has not been enforced yet.
 * Please stick to the release numbers. And use versions within each Release Number for your version
 * 7 -- North America, South America, Tiny British Island heading straight south from tip of South America
 * 8 -- Europe, Eastern Europe, Arctic Circle
 * 9 -- Asia, Africa, Australasia, Antartica
 * (Dont think Igloo's program but there are some advanced Igloo's settled there)
 * I will have to enforce it in next release after checking locale
 *
 * Technical Reference : Buy and Read Asterix and the Secret Weapon
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  
  protected void setReleaseNumber (short p_rn){

     if (this.isFrozen())
     {
         LiveDB.ALRTLVL = 5;
         System.err.println(LiveDB.grassHopper("Frozen Release use setFreeze (false) to unfreeze"));
         return;
     }

     if ((LiveDB.USRNAME.equals(this.getPrivillegedcodeusername()) == false ||
         LiveDB.NODENAME.equals(this.getPrivillegedcodenodename()) == false)
         && p_rn <= 6)
     {
         LiveDB.ALRTLVL = 5;
         System.err.println(LiveDB.grassHopper("Release numbers 1 thru 6 are privilleged USE 7 thru 9"));
         return;
     }

     if ((LiveDB.USRNAME.equals(this.getPrivillegedcodeusername()) == true ||
         LiveDB.NODENAME.equals(this.getPrivillegedcodenodename()) == true)
         && p_rn >= 7)
     {
         LiveDB.ALRTLVL = 5;
         System.err.println(LiveDB.grassHopper("Releases 7 thru 9 are for non-privilleged USE 1 thru 6"));
         return;
     }

     int i = 0;
     short rn = 0;
     String pfx = null;


     if (p_rn < 1 || p_rn > 9)
     {
         LiveDB.ALRTLVL = 7;
         System.err.println(LiveDB.grassHopper("Release Number out of Range 1-9"));
         return;
     }

     if (this.isSpecialRelease())
     {
         i = 1;
         pfx = "S";
     }

     if (this.isBetaRelease())
     {
         i = 1;
         pfx = "B";
     }

     rn = this.getReleaseNumber();

     if (rn > p_rn)
     {
         LiveDB.ALRTLVL = 3;
         System.err.println(LiveDB.grassHopper("You are decrementing release number"));
         // decrement it for him now if he wants it that way
         ProgramVersion = OldProgramRelease;
     }
     else if (rn == p_rn)
     {
         LiveDB.ALRTLVL = 7;
         System.err.println(LiveDB.grassHopper("Its the same release number set again"));
     }
     else if (rn < p_rn)
     {
         OldProgramRelease = ProgramVersion;
         if ((rn + 1) != p_rn)
         {
             LiveDB.ALRTLVL = 7;
             System.err.println (LiveDB.grassHopper("Your Release Number is not sequential"));
         }
         // reset the version number here and Bug Fix Number
         // ProgramVersion Format
         // String [S]Y.X.BB.DATE
         if (i == 1) ProgramVersion = pfx.concat(String.valueOf(p_rn).
                 concat(".0.").concat("00.").concat(ProgramVersion.substring(8, ProgramVersion.length())));
         else ProgramVersion = String.valueOf(p_rn).
                 concat(".0").concat("00.").concat(ProgramVersion.substring(7, ProgramVersion.length()));
         this.setBugFixDate();
         this.setFreeze(true); // Freeze it
     }

     LiveDB.CHECKPROGRAM = false;
     if (this.commit() == false)
         System.exit(1);

     if (this.backup() == false)
         return;
  }
  
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper(), LiveDB.CHECKPROGRAM, LiveDB.NODENAME, LiveDB.USRNAME
 *
 * Method Name : protected void setVersionNumber ()
 * Parameters : None
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method increments the version number always. If already frozen it
 * returns doing nothing. But otherwise it commits and takes a backup. It will also reset the BugFix number
 * to one for the new version.
 *
 * Technical Reference : Buy and Read Asterix in Belgium
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setVersionNumber (){
        // ProgramVersion Format
       // String [S]Y.X.BB.DATE

      if (this.isFrozen()) return;
      // dont allow decrement always increment
      int n = 0;

      if ((n = ProgramVersion.indexOf('.')) == -1)
      {
          LiveDB.ALRTLVL = 1;
          System.err.println (LiveDB.grassHopper("ProgramVersion details corrupted Exiting"));
          System.exit(1);
      }
      else
      {
          if (this.getVersionNumber() == 9)
          {
              LiveDB.ALRTLVL = 3;
              System.err.println(LiveDB.grassHopper("Run out of version numbers"));
              System.exit(1);
          }
          ProgramVersion = ProgramVersion.substring(0, n+1).
          concat(String.valueOf(this.getVersionNumber() + 1)).concat(".")
          .concat("01.").concat(ProgramVersion.substring(n+6, ProgramVersion.length()));

          if (this.commit() == false)
             System.exit(1);

          if (this.backup() == false)
               return; // take a backup whenever version number changes
      }
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper()
 *
 * Method Name : protected void setBugFixNumber (int p_bug)
 * Parameters : int p_bug -- this is the BugFix number
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method increments the bug fix number always. If the Bug Fix number
 * passed to this method is lower than the existing BugFix number it does nothing. If already frozen it
 * returns doing nothing. But otherwise it commits. BugFix numbers must be in the range of 1 thru 99 per
 * version. Anything more than 99 Bugs per version your programming ability is questionable !!
 *
 * Technical Reference : Asterix and the Golden Sickle (Beg Borrow or Steal)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setBugFixNumber (int p_bug){
         // dont allow decrement always increment
        // ProgramVersion Format
       // String [S]Y.X.BB.DATE      

      if (this.isFrozen()) return;

      if (p_bug > 99 || p_bug < 1)
      {
          LiveDB.ALRTLVL = 7;
          System.err.println (LiveDB.grassHopper("Bug Fix Number out of range"));

          if (p_bug > 99)
          {
              LiveDB.ALRTLVL = 5;
              System.err.println (LiveDB.grassHopper("Bug > 99 Use setVersionNumber to increment version,set Bug to 1"));
          }  
          System.exit(1);
      }
     
      int n = 0;

      if ((n = ProgramVersion.lastIndexOf('.')) == -1)
      {
          LiveDB.ALRTLVL = 1;
          System.err.println (LiveDB.grassHopper("ProgramVersion details corrupted Exiting"));
          System.exit(1);
      }

      if (this.getBugFixNumber() <= p_bug)
      {
          ProgramVersion = ProgramVersion.substring(0, n-2).
          concat(String.valueOf(p_bug))
          .concat(ProgramVersion.substring(n, ProgramVersion.length()));

          if (this.commit() == false)
             System.exit(1);
      }

  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper()
 *
 * Method Name : protected void setBugFixDate ()
 * Parameters : None
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method sets the BugFix date to Date (NOW) in long format and then
 * it commits it. Basically for all these methods I can automatically check the compile time of the file 
 * on disk and then do some auto increments. but I have decided to leave that to the user with a call to
 * appropriate methods.
 *
 * Technical Reference : Asterix and Cleopatra (She is a steal right ?)
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setBugFixDate (){
        // ProgramVersion Format
       // String [S]Y.X.BB.DATE

      if (this.isFrozen()) return;

      int n = 0;

      if ((n = ProgramVersion.lastIndexOf('.')) == -1)
      {
          LiveDB.ALRTLVL = 1;
          System.err.println (LiveDB.grassHopper("ProgramVersion details corrupted Exiting"));
          System.exit(1);
      }
      else
      {
          ProgramVersion = ProgramVersion.substring(0, n+1).
          concat(String.valueOf(new Date().getTime()));
          if (this.commit() == false)
             System.exit(1);
      }
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ALRTLVL,LiveDB.grassHopper()
 *
 * Method Name : protected void setBugFixNumber (int p_bug)
 * Parameters : None
 * Returns : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : A call to this method increments the version number always if the currently not
 * frozen. It also resets the BugFix Number to 01 and sets BugFix date to NOW in long format.
 *
 * Technical Reference : Buy and Read Asterix and the Magic Carpet
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected void setProgramVersion (){
      // this will almost increment everything in one go except release number

      if (this.isFrozen()) return;

      this.setVersionNumber();
      this.setBugFixDate();
  }

} // End of Class VersionControl Get Out of My Class !!
