/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package MaintainData;

import java.util.Date;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.JScrollPane;
import java.awt.event.InputMethodEvent;
import java.awt.event.InputMethodListener;
import java.awt.GridBagConstraints;
import java.awt.Font;
import javax.swing.BorderFactory;
import java.awt.Color;
import java.awt.GridBagLayout;
import javax.swing.JPanel;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JTextField;
import static MaintainData.LanguagePanel.SelectedLanguage;
import static MaintainData.FirstPage.viewbasketpanel;
import static MaintainData.FirstPage.cartpanel;
import static MaintainData.LiveDB.sc;
import static MaintainData.LiveDB.pd;
import static MaintainData.LoginPage.LoggedInCID;
import static MaintainData.LiveDB.ct;
import static MaintainData.FirstPage.convertCurrency;
import java.util.Arrays;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : ViewBasketPanel
 *
 * @LOOKSY: LoginPage.java
 *          ShoppingCart.java
 *          ChangeTracker.java
 *
 * @LOOKSY:FirstPage.pageonetextpanel, FirstPage.maillistpanel, FirstPage.infopanel, FirstPage.languagepanel
 * @LOOKSY:FirstPage.currencypanel, FirstPage.popularpanel, FirstPage.featuredpanel, FirstPage.salepanel
 * @LOOKSY:LiveDB.indx2shoppingCart, LiveDB.system_exit, LiveDB.SmoothExitCondition, LiveDB.indx1shoppingCart
 * @LOOKSY:FirstPage.footerpanel, FirstPage.cartpanel, LoginPage.LoggedInCID, LiveDB.logerrorno
 * @LOOKSY:LiveDB.grassHopper, LiveDB.ALRTLVL
 *
 * Associated Methods : protected static float convertCurrency(float p_amt)
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor will construct the viewbasketpanel and attach it to the
 * front page after removing other panels. It will check your shopping basket and display all items
 * in it and also draw images of those pictures. It will also display all pricing details along with
 * sub options selected by user.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 *
 * Last Modified : 11th April 2012
 * Last Modifications :Whatever is displayed in ViewBasketPanel must be checked for billed status
 * in ShoppingCart before display. Look at the ShoppingCart table inlne documentation for a listing
 * of codes. So if the billed status is 2,3,6,7,8 dont display it in ViewBasketPanel. To fix this
 * minor bug there is a new declaration
   long billedstatus [] = null;
 * Then there is this patch of code
   billedstatus [billedstatus.length] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getBilled();
 * Followed by this patch of code that skips the display of these items with billed 2,3,6,7,8
                 if (billedstatus[i] == 2 || billedstatus[i] == 3 || billedstatus[i] == 6
                     || billedstatus[i] == 7 || billedstatus [i] == 8)
                     continue;
 *
 * Last Modification Date : 14th Augustus 2012
 * Last Modifications : Marked as 14th August 2012
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : Added this patch of Code. The user has requested a CheckOut so we
 * have to set the billed field of ShoppingCart table to 1L.
                      for (int j = 0; j < piccode.length; j++ )
                      {
                          Rid = LiveDB.indx1shoppingCart.get(LoggedInCID +
                              piccode[j] + picsubopts[j]);
                          ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)Rid]).setBilled(1L);
                          LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                                new ChangeTracker (sc, Rid, 'U', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[sc][(int)Rid],
                                (long)LiveDB.LiveSharedDB[ct].length);                     
                      }
 * 
 * 
 * Last Modification Date : 17th August 2012
 * Last Modifications : MArked as 17th August 2012
 * I have declared a new variable retvals []. This is needed to collect the newly constructed
 * objects in the code. If this is not used a new object will be created but the JVM may view these
 * objects as Orphans and garbage collect them.
 * Also search for LiveDB.USEFONT
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class ViewBasketPanel
{
    GridBagConstraints constraints = null;
    // remove declaration and its usage
    //String langstring [] = null;
    JLabel viewbasket = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket")
            == null ? "View Basket" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "View Basket"));
    JLabel emptycart = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your shopping cart is currently empty")
            == null ? "Your shopping cart is currently empty" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Your shopping cart is currently empty"));
    JLabel addmore = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Want to add more items")
            == null ? "Want to add more items ?" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Want to add more items") + " ?");
    JLabel enterprodcode = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Enter the Product Code")
            == null ? "Enter the Product Code:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Enter the Product Code") + ":");
    JTextField addprod = new JTextField ("PIC01", 7);
    JButton addprodcode = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Add")
            == null ? "Add" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Add"));
    JPanel titlebar = new JPanel (new GridBagLayout());
    
    // Dont transalate these into languages let it remain in English
    JLabel Qty = new JLabel ("Qty");
    JLabel Product = new JLabel ("Product");
    JLabel Code = new JLabel ("Code");
    JLabel Stock = new JLabel ("Stock");
    JLabel Price = new JLabel ("Price");
    JLabel LinePrice = new JLabel ("Line Price");
    long picqty [] = null;
    String piccode [] = null;
    String picimg [] = null;
    String pictitle [] = null;
    String picsubopts [] = null;
    float picprice [] = null;
    float picdiscount [] = null;
    long billedstatus [] = null;
    JPanel stampsize [] = null;
    String globalsubopts [][] = null;
    JButton delete [] = null;
    JTextField QtyTxtFlds [] = null;
    JScrollPane basketpane = null;
    JLabel BasketTotal = null;
    JButton cont = null;
    JButton emptybasket = null;
    float baskettotals = 0.0F;
    Integer I[] = null;
    Object retvals [] = new Object [4];
    
    public ViewBasketPanel ()
    {
        int MF = 10;
        long rid = 0L;
        long logno = 0L;
        
        int Y = 5, y = 0;
        int pX = 0, pY = 0, pW = 0, pH = 0;
        
        I = null; // 14th Augustus 2012
        

        LiveDB.appframe.remove(FirstPage.pageonetextpanel);
        LiveDB.appframe.remove(FirstPage.maillistpanel);
        LiveDB.appframe.remove(FirstPage.infopanel);
        LiveDB.appframe.remove(FirstPage.languagepanel);
        LiveDB.appframe.remove(FirstPage.currencypanel);
        LiveDB.appframe.remove(FirstPage.popularpanel);
        LiveDB.appframe.remove(FirstPage.featuredpanel);
        LiveDB.appframe.remove(FirstPage.salepanel);
        
/* Old logix        
        for (int rw = 1, i = 0;
        (globalsubopts[globalsubopts.length][i] =
                LiveDB.indx2pictureOptions.get(rw + SelectedLanguage)) != null; rw++, i++)
            ;
* */
        // New logic do ... While 14th Augustus 2012
        int RW = 1, II = 0;
        do
        {
            globalsubopts = globalsubopts == null ? new String[1][0] : 
                    Arrays.copyOf(globalsubopts, globalsubopts.length + 1);
            globalsubopts[globalsubopts.length -1] =
                    globalsubopts[globalsubopts.length -1].length == 0 ? new String [1]:
                    Arrays.copyOf(globalsubopts[globalsubopts.length -1], II + 1);
            RW++;II++;
        }while ((globalsubopts[globalsubopts.length -1][II] = 
                LiveDB.indx2pictureOptions.get(RW + SelectedLanguage)) != null);
            
        viewbasketpanel = new JPanel (new GridBagLayout());
        viewbasketpanel.setBounds(pX = 0, pY = (int)(cartpanel.TOP_ALIGNMENT * MF), pW = LaunchGUI.MAX_WIDTH - 6,
               pH = (int) (FirstPage.footerpanel.TOP_ALIGNMENT * MF) - 2);

        LiveDB.appframe.remove(FirstPage.cartpanel);
        
        basketpane = new JScrollPane(viewbasketpanel);

        viewbasketpanel.setBorder(BorderFactory.createLineBorder(Color.GRAY));
        
        viewbasketpanel.add(viewbasket, setConstraints(0,0,2,1));
        viewbasketpanel.add(addmore, setConstraints(16, 2, 4, 1));
        viewbasketpanel.add(enterprodcode, setConstraints(21, 2, 4, 1));
        viewbasketpanel.add(addprod, setConstraints(26, 2, 1, 1));

        addprod.addInputMethodListener(new InputMethodListener (){

            @Override
            public void inputMethodTextChanged(InputMethodEvent event)
            {
               if (LiveDB.indxpictureDatabase.get(addprod.getText()) == null)
               {
                   addprod.setText("Enter Valid Picture Code");
                   addprod.setFocusable(true);
                   addprod.validate();
               }
            }

            @Override
            public void caretPositionChanged(InputMethodEvent event){
                      ; // dont bother
            }
        });

        viewbasketpanel.add(addprodcode, setConstraints(28, 2, 1, 1));

        addprodcode.addMouseListener(new MouseClickHandler (addprod.getText()));
        
        if (LiveDB.indx2shoppingCart.get(LoginPage.LoggedInCID) == null)
        {
            viewbasketpanel.add(emptycart, setConstraints (0,4, 6, 1));
            LiveDB.appframe.add(viewbasketpanel, setConstraints(pX, pY, pW, pH));
            viewbasketpanel.validate();
            return;
        }
        else
        {
            rid = LiveDB.indx2shoppingCart.get(LoginPage.LoggedInCID);

            titlebar.setBackground(Color.GRAY);
            titlebar.setForeground(Color.WHITE);
            Qty.setForeground(Color.WHITE);
            Qty.setFont(new Font(LiveDB.USEFONT, Font.BOLD, 9));
            Product.setForeground(Color.WHITE);
            Product.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
            Code.setForeground(Color.WHITE);
            Code.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
            Stock.setForeground(Color.WHITE);
            Stock.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
            Price.setForeground(Color.WHITE);
            Price.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));
            LinePrice.setForeground(Color.WHITE);
            LinePrice.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 9));

            titlebar.add(Qty, setConstraints(1,0,1,1));
            titlebar.add(Product, setConstraints(6,0,2,1));
            titlebar.add(Code, setConstraints(14,0,1,1));
            titlebar.add(Stock, setConstraints(17,0,1,1));
            titlebar.add(Price, setConstraints(21,0,1,1));
            titlebar.add(LinePrice, setConstraints(23,0,1,1));

            viewbasketpanel.add(titlebar, setConstraints(0,4,(int)(viewbasket.RIGHT_ALIGNMENT * MF)
                - (int)(viewbasket.LEFT_ALIGNMENT * MF),1));

            // now search backwards
            for (int rw = (int)rid; rw >= 0; rw--)
            {
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getShopdate().after(LiveDB.today))
                {
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getBilled() == 0)
                    {
                       // grow the array 14th August 2012
                       piccode = piccode == null ? new String[1] : Arrays.copyOf(piccode, piccode.length + 1); 
                       piccode[piccode.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getPic();
                       // grow the Array 14th August 2012
                       picqty = picqty == null ? new long[1] : Arrays.copyOf(picqty, picqty.length + 1);
                       picqty[picqty.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getPic_qty();
                       // grow the array 14th August 2012
                       picsubopts = picsubopts == null ? new String[1]:Arrays.copyOf(picsubopts, picsubopts.length + 1);
                       picsubopts[picsubopts.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getSub_opt_id();
                       // grow the array 14th August 2012
                       billedstatus = billedstatus == null ? new long[1]:Arrays.copyOf(billedstatus, billedstatus.length + 1);
                       billedstatus [billedstatus.length -1] = ((ShoppingCart)LiveDB.LiveSharedDB[sc][rw]).getBilled();
                       if (LiveDB.indxpictureDatabase.get(piccode[piccode.length -1]) != null )
                       {
                           // grow the array 14th August 2012
                           picimg = picimg == null ? new String [1] : Arrays.copyOf(picimg, picimg.length + 1);
                           picimg[picimg.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_img_location();
                           picprice = picprice == null ? new float[1]:Arrays.copyOf(picprice, picprice.length + 1);
                           picprice[picprice.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_price();
                           pictitle = pictitle == null ? new String [1]:Arrays.copyOf(pictitle, pictitle.length + 1);
                           pictitle [pictitle.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_title();
                           picdiscount = picdiscount == null ? new float[1]:Arrays.copyOf(picdiscount, picdiscount.length + 1);
                           picdiscount[picdiscount.length -1] = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                           [(int)(long)LiveDB.indxpictureDatabase.get(piccode[piccode.length -1])]).getPic_discount();
                           if (LiveDB.indx2shoppingCart.get(LoggedInCID) != null)
                           {
                              for (int row = (int)(long)LiveDB.indx2shoppingCart.get(LoggedInCID);
                                           row >= 0; row--)
                              {
                                  if (((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getCid()
                                          .equals(LoggedInCID) &&
                                      ((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getPic()
                                      .equals(piccode[piccode.length -1]) &&
                                      ((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getShopdate()
                                      .after(LiveDB.today))
                                  {
                                       // grow the array 14th August 2012 ? BUG HERE CHECK TEST
                                       //picsubopts = picsubopts == null ? new String[1]
                                         //       : Arrays.copyOf(picsubopts, picsubopts.length + 1);                                      
                                       picsubopts[picsubopts.length -1] =
                                               ((ShoppingCart)LiveDB.LiveSharedDB[sc][row]).getSub_opt_id();
                                  }
                              }
                           }
                           else
                           {
                               LiveDB.ALRTLVL = 15;
                               System.err.println(LiveDB.grassHopper("indx2shoppingCart corruption"));
                               System.exit(1);
                           }
                       }
                       else
                       {
                           LiveDB.ALRTLVL = 15;
                           System.err.println(LiveDB.grassHopper("Master/Detail Corruption PictureDatabase/ShoppingCart"));
                           logno = LiveDB.logerrorno;
                           System.err.println ("LINE:" + logno + " " + "Missing pic code in indxpictureDatabase " + piccode[piccode.length -1]);
                           System.exit(1);
                       }
                    }
                }
            } // for (int rw = (int)rid; rw >= 0; rw--)

            for (int i = 0; i < piccode.length; i++)
            {
                 // grow this array 14th Augustus 2012
                 I = I == null ? new Integer[1]:Arrays.copyOf(I, I.length + 1);
                 I[I.length -1] = i;
                 if (billedstatus[i] == 2 || billedstatus[i] == 3 || billedstatus[i] == 6
                     || billedstatus[i] == 7 || billedstatus [i] == 8)
                     continue;

                 viewbasketpanel.add(new JLabel (pictitle[i]), setConstraints(6,Y,3,1));
                 viewbasketpanel.add(new JLabel(LiveDB.indxpictureOptions.get(1 + SelectedLanguage) 
                 + ":" + globalsubopts[0][Integer.parseInt(picsubopts[0].substring(1, 2))]), setConstraints(6, ++Y, 3, 1));
                 // grow the array 14th August 2012
                 stampsize = stampsize == null ? new JPanel [1]:Arrays.copyOf(stampsize, i + 1);
                 stampsize [i] = new JPanel (new GridBagLayout());
                 FirstPage.DrawImage(null, picimg[i], stampsize[i], 
                         picimg[i].substring(picimg[i].lastIndexOf('.'), picimg[i].length()));

                 viewbasketpanel.add(stampsize[i], setConstraints(4, Y, 6, 6));
                 viewbasketpanel.add(new JLabel(LiveDB.indxpictureOptions.get(2 + SelectedLanguage) 
                 + ":" + globalsubopts[1][Integer.parseInt(picsubopts[1].substring(3, 4))]),
                         setConstraints(6, ++Y, 3, 1));
                 // grow the arrray 14th August 2012
                 delete = delete == null ? new JButton[1]: Arrays.copyOf(delete, delete.length + 1);
                 delete[delete.length -1] = new JButton ("X");
                 delete[delete.length -1].setBackground(Color.RED);
                 delete[delete.length -1].setForeground(Color.WHITE);
                 delete[delete.length -1].createToolTip().setToolTipText("Delete");
                 
                 delete[delete.length -1].addMouseListener(new MouseListener (){
                 
                     @Override
                     public void mousePressed (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.YELLOW);
                         delete[delete.length -1].validate();
                     }
                     @Override
                     public void mouseClicked (MouseEvent evnt){

                         // we have to delete this row from the table
                         // but our database engine only allows mark for deletion
                         // so we will do some hera pheri
                         // maybe we should include an extra method called isDeleted ()
                         // in every table
                         
                         long rid = LiveDB.indx1shoppingCart.get(LoggedInCID +
                              piccode[I[I.length -1]] + picsubopts[I[I.length -1]]);
                         
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(2L);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setPic_qty(0L);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setShopdate(null);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setTotal(0.0f);
                         ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setOrderdiscount(0.0f);
                         // Now mark this record for Deletion
                         LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                               new ChangeTracker (sc, rid, 'D', LiveDB.pid, new Date (),
                                   LiveDB.LiveSharedDB[sc][(int)rid],
                                   (long)LiveDB.LiveSharedDB[ct].length -1);

                         retvals [0] = new ViewBasketPanel (); // 17th August 2012
                     }
                     @Override
                     public void mouseEntered (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.YELLOW);
                         delete[delete.length -1].validate();                         
                     }
                     @Override
                     public void mouseReleased (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.RED);
                         delete[delete.length -1].validate();                         
                     }
                     @Override
                     public void mouseExited (MouseEvent evnt){
                         delete[delete.length -1].setBackground(Color.RED);
                         delete[delete.length -1].validate();                         
                     }
                 });

                 viewbasketpanel.add(delete[delete.length -1], setConstraints(1,++Y,1,1));
                 y = Y;
                 // grow the array 14th Augustus 2012
                 QtyTxtFlds = QtyTxtFlds == null ? new JTextField[1]:Arrays.copyOf(QtyTxtFlds, QtyTxtFlds.length + 1);
                 QtyTxtFlds [QtyTxtFlds.length -1] = new JTextField (picqty[i] + "", 3);
                 QtyTxtFlds [QtyTxtFlds.length -1].createToolTip().setToolTipText("Enter Non Decimal Integer Number");
                 QtyTxtFlds [QtyTxtFlds.length -1].addInputMethodListener(new InputMethodListener (){
                    @Override
                    public void inputMethodTextChanged(InputMethodEvent event)
                    {
                        float disco = 0.0f;
                        long rid = 0L;
                        try{
                          picqty[I[I.length -1]] =
                                Integer.parseInt(QtyTxtFlds [QtyTxtFlds.length -1].getText());
                        }catch (NumberFormatException ex_YESKIA23){
                            QtyTxtFlds [QtyTxtFlds.length -1].setText(picqty[I[I.length -1]] + "");
                            QtyTxtFlds [QtyTxtFlds.length -1].setFocusable(true);
                        }

                        // Update Basket here
                        ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                        [(int)(long) (rid = LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[I[I.length-1]]
                         + picsubopts[I[I.length -1]]))])
                         .setPic_qty(Long.parseLong(QtyTxtFlds [QtyTxtFlds.length -1].getText()));

                        ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                        [(int)(long)LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[I[I.length-1]]
                         + picsubopts[I[I.length -1]])])
                         .setOrderdiscount(disco = ((PictureDatabase)LiveDB.LiveSharedDB[pd]
                         [(int)(long)LiveDB.indxpictureDatabase.get(piccode[I[I.length-1]])]).getPic_discount()
                         * picqty[I[I.length-1]]);

                        ((ShoppingCart)LiveDB.LiveSharedDB[sc]
                        [(int)(long)LiveDB.indx1shoppingCart.get(LoggedInCID + piccode[I[I.length-1]]
                         + picsubopts[I[I.length -1]])])
                         .setTotal((Long.parseLong(QtyTxtFlds [QtyTxtFlds.length -1].getText())
                                                                    * picqty[I[I.length-1]]) - disco);

                        // Now one single U entry for the entire row in ChangeTracker table
                        LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                               new ChangeTracker (sc, rid, 'U', LiveDB.pid, new Date (),
                                   LiveDB.LiveSharedDB[sc][(int)rid],
                                   (long)LiveDB.LiveSharedDB[ct].length -1);
                    }

                    @Override
                    public void caretPositionChanged(InputMethodEvent event){
                              ; // dont bother
                    }
                    
                 });

                 viewbasketpanel.add(QtyTxtFlds[QtyTxtFlds.length -1], setConstraints(3,y,1,1));
                 for (int opt = 3, X = 6; opt <= LiveDB.indxpictureOptions.size(); opt++, Y++)
                 {
                    viewbasketpanel.add(new JLabel(LiveDB.indxpictureOptions.get(opt + SelectedLanguage)
                    + ":" + globalsubopts[opt -1][Integer.parseInt(picsubopts[opt -1].substring(opt + 2, opt + 3))]),
                         setConstraints(X, Y, 3, 1));        // *1*2*3*4*5
                    opt++; // dont knock this out
                 }

                 viewbasketpanel.add(new JLabel(piccode[i]),
                    setConstraints((int)Code.LEFT_ALIGNMENT * MF, y, 2, 1));
                 viewbasketpanel.add(new JLabel ("IN-STOCK"),
                        setConstraints((int)Stock.LEFT_ALIGNMENT * MF, y, 2, 1));
                 viewbasketpanel.add(new JLabel ("" + convertCurrency(picprice[i])),
                        setConstraints((int)Price.LEFT_ALIGNMENT * MF, y, 2, 1));
                 viewbasketpanel.add(new JLabel ("" + ((convertCurrency(picprice[i]) * picqty[i])
                         - (convertCurrency(picdiscount[i]) * picqty[i]))),
                        setConstraints((int)LinePrice.LEFT_ALIGNMENT * MF, y, 2, 1));
                 baskettotals += ((convertCurrency(picprice[i]) * picqty[i]) -
                         (convertCurrency(picdiscount[i]) * picqty[i]));
            }
        }

        viewbasketpanel.add(new JLabel ("Subtotal:"), setConstraints((int)(Price.LEFT_ALIGNMENT * MF) - 4,
                Y++, 2, 1));
        viewbasketpanel.add(new JLabel ("Tax:"), setConstraints((int)(Price.LEFT_ALIGNMENT * MF) + 2,
                Y, 2, 1));
        viewbasketpanel.add(new JLabel ("n/a"), setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF) + 2,
                Y, 2, 1));
        Y++;
        viewbasketpanel.add(new JLabel ("Shipping:"), setConstraints((int)(Price.LEFT_ALIGNMENT * MF) - 4,
                Y, 2, 1));
        viewbasketpanel.add(new JLabel ("n/a"), setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF) - 4,
                Y, 2, 1)); Y++;
        BasketTotal = new JLabel (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Basket Total")
            == null ? "Basket Total:" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Basket Total") + ":");
        BasketTotal.setForeground(Color.BLACK);
        BasketTotal.setFont(new Font (LiveDB.USEFONT, Font.BOLD, 10));
        viewbasketpanel.add(BasketTotal, setConstraints((int)(Price.LEFT_ALIGNMENT * MF) - 8,
                Y, 2, 1));
        viewbasketpanel.add(new JLabel ("" + baskettotals), setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF),
                Y, 2, 1));
        cont = new JButton (LiveDB.indxlanguageTitles.get(SelectedLanguage + "Continue")
            == null ? "Continue" : LiveDB.indxlanguageTitles.get(SelectedLanguage + "Continue"));

        cont.setBackground(Color.GREEN);
        cont.setForeground(Color.WHITE);
        viewbasketpanel.add(cont, setConstraints((int)(LinePrice.LEFT_ALIGNMENT * MF),
                ++Y, 2, 1));

        cont.addMouseListener(new MouseListener (){
            @Override
            public void mouseClicked (MouseEvent evnt){
                  long Rid;
                  if (LoggedInCID == null)
                      retvals [1] = new LoginPage (); // 17th August 2012
                  else
                  { //FILL THIS UP WITH AN INVOICE PAGE
                    // and connect to a payment processor page in next release
                      
                      // Added this loop on 17th August 2012
                      // The user has requested a CheckOut So we must setBilled(1L)
                      for (int j = 0; j < piccode.length; j++ )
                      {
                          Rid = LiveDB.indx1shoppingCart.get(LoggedInCID +
                              piccode[j] + picsubopts[j]);
                          ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)Rid]).setBilled(1L);
                          LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                                new ChangeTracker (sc, Rid, 'U', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[sc][(int)Rid],
                                (long)LiveDB.LiveSharedDB[ct].length -1);                     
                      }
                      retvals [2] = new InvoicePage (); // 17th August 2012
                  }
            }
            @Override
            public void mousePressed (MouseEvent evnt){
                 cont.setBackground(Color.ORANGE);
                 cont.validate();
            }
            @Override
            public void mouseReleased (MouseEvent evnt){
                 cont.setBackground(Color.GREEN);
                 cont.validate();
            }
            @Override
            public void mouseExited (MouseEvent evnt){
                 cont.setBackground(Color.GREEN);
                 cont.validate();
            }
            @Override
            public void mouseEntered (MouseEvent evnt){
                 cont.setBackground(Color.ORANGE);
                 cont.validate();
            }
        });

        emptybasket = new JButton ("Empty Basket");
        emptybasket.setBackground(Color.YELLOW);
        emptybasket.setForeground(Color.WHITE);
        emptybasket.createToolTip().setToolTipText("Danger Drag your mouse away !!");

        emptybasket.addMouseListener(new MouseListener (){

            @Override
            public void mousePressed (MouseEvent evnt){
                emptybasket.setBackground(Color.RED);
                emptybasket.validate();
            }

            @Override
            public void mouseClicked (MouseEvent evnt) {
                // Booo hooo miserable son .......
                long rid = 0; // 17th August 2012
                for (int k = 0; k < piccode.length; k++ )
                {
                     // we have to delete this row from the table
                     // but our database engine only allows mark for deletion
                     // so we will do some hera pheri
                     // maybe we should include an extra method called isDeleted ()
                     // in every table

                     rid = LiveDB.indx1shoppingCart.get(LoggedInCID +
                              piccode[k] + picsubopts[k]);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setBilled(7L);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setPic_qty(0L);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setShopdate(null);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setTotal(0.0f);
                     ((ShoppingCart)LiveDB.LiveSharedDB[sc][(int)rid]).setOrderdiscount(0.0f);
                     // Now mark this record for Deletion
                     LiveDB.LiveSharedDB[ct][LiveDB.growMore(ct)] =
                            new ChangeTracker (sc, rid, 'D', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[sc][(int)rid],
                                (long)LiveDB.LiveSharedDB[ct].length -1);
                }
                retvals [3] = new ViewBasketPanel();  // 17th August 2012
            }

            @Override
            public void mouseEntered (MouseEvent evnt) {
                emptybasket.setBackground(Color.RED);
                emptybasket.validate();
            }

            @Override
            public void mouseReleased (MouseEvent evnt) {
                emptybasket.setBackground(Color.YELLOW);
                emptybasket.validate();
            }

            @Override
            public void mouseExited (MouseEvent evnt) {
                emptybasket.setBackground(Color.YELLOW);
                emptybasket.validate();
            }
        });

        viewbasketpanel.add(emptybasket, setConstraints(0, Y++, 2, 1));
        LiveDB.appframe.add(viewbasketpanel, setConstraints(pX, pY, pW, pH));
        viewbasketpanel.validate();
    }

    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
