/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.applet.Applet;
import java.applet.AudioClip;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Iterator;
import javax.imageio.ImageIO;
import javax.imageio.ImageReader;
import javax.imageio.stream.ImageInputStream;
import javax.swing.JPanel;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : Animation
 * @LOOKSY: LiveDB.ALRTLVL, LiveDB.system_exit, LiveDB.SmoothExitCondition, LiveDB.appframe
 *
 * Date File : String p_path passed to constructor
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct and then dissect and draw each of
 * frames of the animated gif file along with an audio.play. To really understand this code pick the
 * java book up and go thru it.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class Animation extends Applet implements Runnable {

     JPanel thispanel = null;
     Graphics Context = null;
     AudioClip audio = null;
     int loadtime = 2; // the maximum load time for an animation
     int delay = 0;
     int fps = 0; // frames per second
     int nimgs = 0; // number of images in the animation
     Image entireimage = null;
     BufferedImage [] imgs = null ; // strip of images [nimgs]
     int frametopaint = 0;
     Integer inWidth [] = null; // the actual width of animated gif you may have got it wrong
     Integer inHeight [] = null; // the actual height of animated gif
     Image [] offimgs = null;
     boolean DELAY = false; // change to true for slow motion animations
     int imgsWidth = 0; // image width
     int imgsHeight = 0; // image height
     Thread animator = null; // the animation thread

     public Animation (String p_size, String p_path, JPanel p_panel)
     {
         this.setBackground(Color.WHITE);
         getImageDetails (p_path);
         Context = p_panel.getGraphics();
         thispanel = p_panel;
         imgsWidth = Integer.parseInt(p_size.substring(0,p_size.toLowerCase().indexOf('x')));
         imgsHeight = Integer.parseInt(p_size.substring(p_size.toLowerCase().indexOf('x'), p_size.length()));
         init();
     }

     private void getImageDetails (String p_path)
     {
        BufferedImage img = null;
        ImageReader reader = null;
        ImageInputStream ImageIn = null;
        Iterator<ImageReader> iter = null;
        int infoflags = 0;
        int ii = 0;        
        
        try{
            entireimage = ImageIO.read(new File(p_path));
        }catch (IOException ex_NOKIA9){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_NOKIA9, "Missing Icon File:" + p_path));
            LiveDB.system_exit = 1;
            LiveDB.SmoothExitCondition.signalAll();
        }

        try{
              ImageIn = ImageIO.createImageInputStream(new File(p_path));
        }catch (IOException ex_NOKIA98){
            System.err.println(LiveDB.grassHopper(ex_NOKIA98, "File:" + p_path));
            LiveDB.system_exit = 1;
            LiveDB.SmoothExitCondition.signalAll();
        }

        iter = ImageIO.getImageReadersBySuffix("gif");
        reader = iter.next();
        reader.setInput(ImageIn);

        try{
            nimgs = reader.getNumImages(true);
        }catch (IllegalStateException ex_NOKIA1){

            try{
                if ((nimgs = reader.getNumImages(false)) == -1)
                {
                   do
                   {
                       try{
                             img = reader.read(ii);
                             inWidth[ii] = reader.getWidth(ii);
                             inHeight[ii] = reader.getHeight(ii);
                       }catch(IndexOutOfBoundsException ex_YESKIA1){
                             break;
                       }

                       ii++;
                   }while (img != null);
                   nimgs = ii;
                }
            }catch (IOException ex_NOKIA71){
                System.err.println(LiveDB.grassHopper(ex_NOKIA71, "File:" + p_path));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }catch (IOException ex_NOKIA71){
                System.err.println(LiveDB.grassHopper(ex_NOKIA71, "File:" + p_path));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
        }

        // now get the strip of images to draw one over/after the other
        if (nimgs > 0)
        {
            ii = 0;
            do{
                try{
                    imgs [ii] = reader.read(ii);
                }catch (IndexOutOfBoundsException ex_YESKIA73){
                    break;
                }catch (IOException ex_NOKIA99){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA99, "File:" + p_path));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                }
                ii++;
            }while (ii < nimgs);
        }
        else
        {
           LiveDB.ALRTLVL = 15;
           System.err.println(LiveDB.grassHopper("Fake Animation File:" + p_path));
           LiveDB.system_exit = 1;
           LiveDB.SmoothExitCondition.signalAll();
        }

        fps = nimgs/loadtime;

        // this is superfluous for now
        try{
          audio = getAudioClip (new URL (p_path));
        }catch (MalformedURLException ex_YESKIA5){
            audio = null;
        }

        // default delay to 10 ms because it does not always wake up again in 10 ms might
        // take 100 ms
        delay = fps <= 0 ? 10: 1000/fps ;
     }

     @Override
     public void run ()
     {
         long time = System.currentTimeMillis();

         Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
         audio.play();
         while (Thread.currentThread() == animator)
         {
            repaint(); // will call update and not paint()

            if (DELAY)
            {
                // Delay depending on how far we are behind.
                try {
                    time += delay;
                    Thread.sleep(Math.max(0, time - System.currentTimeMillis()));
                }catch (InterruptedException e) {}
            }            
         }
     }

     @Override
     public void init ()
     {
         for (int i = 0; i < nimgs; i++)
             offimgs[i] = createImage(imgsWidth, imgsHeight);             
         start();
     }

     @Override
     public void update (Graphics p_graphics)
     {
        Dimension d = this.getSize();
	// Erase the previous image
        if (nimgs > 0)
        {
          // Erase previous
	  p_graphics.setColor(getBackground());
	  p_graphics.fillRect(0, 0, d.width, d.height);
	  p_graphics.setColor(Color.WHITE);

          if (frametopaint == 0)
             audio.play();

          if (frametopaint == nimgs)
             frametopaint = 0;
          
          offimgs[frametopaint] = imgs[frametopaint].getScaledInstance(imgsWidth, imgsHeight, Image.SCALE_FAST);

          // this drawImage call will itself create a delay so the use of int delay is not needed
          // unless there are some slow motion animations
	  p_graphics.drawImage(offimgs[frametopaint], 0, 0, null);

          frametopaint++;
        }	         
     }

     @Override
     public void paint (Graphics p_graphics)
     {
         // even if repaint (0 calls paint() redirect to update
          update(p_graphics);
     }

     @Override
     public void start ()
     {
         animator = new Thread(this);
         animator.start();
     }

     // wont need this you might if you use html to invoke applet
     @Override
     public void stop () 
     {
         animator = null;
         entireimage = null;
         offimgs = null;         
         audio.stop();
     }
}
