/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadautobackup
 * CLASS NAME : AutoBackup
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[]
 *         Dont read the entire ThreadController.java you will go mad.
 * @LOOKSY:LiveDB.LogFileSabotageCheck()
 * @LOOKSY:AutoBackup.java run () method
 *
 * Method Name : public void run ()
 * Chained Methods : protected boolean TblBackup (int tableno)
 *                   protected boolean ConfFilesBkup ()
 * 
 * Parameters : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a heavy duty thread that takes backups of various tables and conf files on
 * disk based on a frequency that you specify.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class AutoBackup extends LiveDB implements Runnable {

    @Override
    public void run () {
        ThreadController.TakeOffTimes[10] = new Date ();

        if (new File(LiveDB.serializedfilespath + "daemon").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "daemon"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }

        try
        {
            new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadautobackup"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).createNewFile();
        }catch (IOException ex_YESKIA41){
            System.err.println(LiveDB.grassHopper(ex_YESKIA41, "Cant create DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadautobackup"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        } // to hell with this error it wont happen continue processing
        
        LiveDB.LogFileSabotageCheck ();

        for ( int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++ )
            if (TblBackup (tbl) == false)
               System.err.println(LiveDB.grassHopper("Table Backup failed " + String.valueOf(tbl)));

        if (ConfFilesBkup () == false)
           System.err.println(LiveDB.grassHopper("Configuration Files Backup failed"));

        if (new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadautobackup"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).delete() == false)
        {
            System.err.println(LiveDB.grassHopper("Cant delete DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadautobackup"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        }

        if (new File (LiveDB.serializedfilespath + "daemon").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }

        ThreadController.LandingTimes[10] = new Date ();
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.checkSpaceLeft(), LiveDB.CopyFile(), LiveDB.TakeExternalBackupToMailBox(), LiveDB.BACKUPFREQUENCY
 *
 * @LOOKSY:AutoBackup.java run () method
 *
 * Method Name : protected boolean TblBackup (int tableno)
 *
 * Parameters : int tableno -- table number to backup
 * Returns : boolean true if backup of requested table is done successfully to disk. It will return true
 *           even if there is a mailing error in taking external backup to mailbox OR old backup failed.
 *
 *           boolean false if streams error or low disk space
 * 
 * @Since Version : 1.0
 *
 * Running Commentary : takes a backup of the requested table number to disk as well as External Mailbox
 * which is a free media of sorts you dont have to buy any. This is part of the effort to automate system
 * adminsitration for you. In the next release you just wont need to spot his face after installation.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

 protected boolean TblBackup (int tableno){
        if (new File(LiveDB.serializedfilespath + "backup").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                        + "backup"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "backup").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "backup"));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }
    // This is a theoritical superfluous method that wont be needed really
    // most corporates servers and also home computers have tons of unused space.    
    LiveDB.checkSpaceLeft(); // is there bare minimal space ?

    String backup = "backup" + LiveDB.FILESEPERATOR;
    String bf = ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser";
    File in = new File(LiveDB.serializedfilespath + bf);
    File ou = new File(LiveDB.serializedfilespath + backup + bf + ".dsk" + ".bkp");
    File bd = new File(LiveDB.serializedfilespath + "backup");

    if (in.exists() == false)
    {
       System.err.println(LiveDB.grassHopper("File to Back Up From Does not exist "
               + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename()));
       return false;
    }

    if (in.canRead() == false)
    {
       System.err.println(LiveDB.grassHopper("JSM denied read Permission on File to Backup From "
       + ((FileTableDataFileMap)LiveDB.LiveSharedDB[0][tableno]).getFilename()));
       return false;
    }

    // first check the backup directory for space File bd

    if (bd.isDirectory() == true)
    {
        if (bd.getUsableSpace() < (in.length() * LiveDB.SPACEFACTOR))
        {
            LiveDB.ALRTLVL = 10;
            System.err.println(LiveDB.grassHopper("File:" + LiveDB.serializedfilespath + backup 
                      + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getFilename() + ".ser"
                                                                                    + ".dsk" + ".bkp"));
            // you can add code here to create filespace by deleting the files in the temp area
            // but system administrators will not approve of this without their explicit permission.
            // it can also lead to data loss if the temp area is being used to unzip and install some other program
            // UNCOMMENT THIS IF YOU WANT TO AUTOFIX SPACE PROBLEM
            /* if (LiveDB.createSpace(in.length() + 1024L) < in.length())
              return false; */
            if (bd.getUsableSpace() < in.length())
            {
                LiveDB.serializedfilespath = LiveDB.USRHOMEDIR + LiveDB.FILESEPERATOR;
                Spy.dump();
                LiveDB.ALRTLVL = 8;
                System.err.println(LiveDB.grassHopper("Redirecting database to " + LiveDB.serializedfilespath));
                LiveDB.DECLARE_EMERGENCY(); // Running out of space find a new planet
                return false;
            }
        }
    }
    else
    {
        LiveDB.ALRTLVL = 2;
        System.err.println(LiveDB.grassHopper("serializedfilespath tampered in memory no longer directory "
        + LiveDB.serializedfilespath + "source"));
        return false;
    }

    if (ou.exists() == true)
    {
        // copy the bkp file to oldbkup for safekeeping
        if (LiveDB.CopyFile(LiveDB.serializedfilespath + backup + bf + ".dsk" + ".bkp",
                   LiveDB.serializedfilespath + backup + bf + ".dsk" + ".bkp" + ".old") == false)
            System.err.println(LiveDB.grassHopper("Old Backup failed in AutoBackup"));
        else
        {
            if (LiveDB.TakeExternalBackupToMailBox(LiveDB.serializedfilespath + backup + bf
                                                               + ".dsk" + ".bkp" + ".old") == false)
                System.err.println(LiveDB.grassHopper("TakeExternalBackupToMailBox for File:" +
                LiveDB.serializedfilespath + backup + bf + ".dsk" + ".bkp" + ".old" + " Failed"));
        }
        // check date of access and if it is today then exit some other user process has already done bkup
        long bkf = 1000 * 60 * LiveDB.BACKUPFREQUENCY;  // allow backup every ten-20 minutes for it to be usefull
        if ((new Date().getTime() - ou.lastModified()) <= bkf)
           return true; // backup taken dont bother

       // if this program you feel is not very heavily used then you increase to one hour
       // i assume heavy use and one user transaction every ten minutes
    }

    if (LiveDB.CopyFile(LiveDB.serializedfilespath + bf, LiveDB.serializedfilespath + backup + bf + ".dsk" + ".bkp") == false)
        return false;

    if (LiveDB.TakeExternalBackupToMailBox(LiveDB.serializedfilespath + backup + bf + ".dsk" + ".bkp") == false)
        System.err.println(LiveDB.grassHopper("TakeExternalBackupToMailBox for File:" +
                LiveDB.serializedfilespath + backup + bf + ".dsk" + ".bkp" + " Failed"));

    if (new File (LiveDB.serializedfilespath + "backup").setReadOnly() == false)
    {
        LiveDB.ALRTLVL = 3;
        System.err.println(LiveDB.grassHopper("Cant setReadonly File:" + LiveDB.serializedfilespath + "backup"));
    }

    return true;
}

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.CopyFile(), LiveDB.TakeExternalBackupToMailBox(), LiveDB.BACKUPFREQUENCY
 *
 * @LOOKSY:AutoBackup.java run () method
 *
 * Method Name : protected boolean ConfFilesBkup ()
 *
 * Parameters : None
 * Returns : boolean true if backup of config files is done successfully
 *           boolean false if streams error or low disk space
 * 
 * @Since Version : 1.0
 *
 * Running Commentary : takes a backup of the config file photodbapp.conf
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan (Bring Large Quantums of Dowry) : C-1678, Sahakara Nagar, Bangalore - 92.
 */
 protected boolean ConfFilesBkup (){
    
    String pf = "photodbapp.conf";
    
    File in = new File(LiveDB.USRHOMEDIR + pf);
    File ou = new File(LiveDB.serializedfilespath + "conf" + pf + ".dsk" + ".bkp");
    
    File bd = new File (LiveDB.serializedfilespath + "conf");

    // first check the backup directory for space File bd

    if (bd.isDirectory() == true)
    {
        if (bd.canWrite())
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("File perms tampered to write File:"
                  + LiveDB.serializedfilespath + "conf"));
        }
        else
        {
            if (bd.setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Unable to set perms to write File:"
                        + LiveDB.serializedfilespath + "conf"));
                return false;
            }
        }

        if (bd.getUsableSpace() < (in.length() * LiveDB.SPACEFACTOR))
        {
            LiveDB.ALRTLVL = 10;
            System.err.println(LiveDB.grassHopper("File:" + LiveDB.serializedfilespath + "conf"
                                                                                 + pf + ".dsk" + ".bkp"));
	    JOptionPane.showMessageDialog(LiveDB.appframe, "SYSTEM ADMIN URGENT ALERT : INSUFFICIENT BARE MINIMAL SPACE ON FILE SYSTEM TO TAKE A BACKUP CREATE FREE SPACE IMMEDIATELY " + "\n");
            // you can add code here to create filespace by deleting the files in the temp area
            // but system administrators will not approve of this without their explicit permission.
            // it can also lead to data loss if the temp area is being used to unzip and install some other program
            // UNCOMMENT THIS IF YOU WANT TO AUTOFIX SPACE PROBLEM
            /* if (createspace () < (in.length() * LiveDB.SPACEFACTOR))
              return false; */
            if (bd.getUsableSpace() < in.length())
            {
                LiveDB.serializedfilespath = LiveDB.USRHOMEDIR + LiveDB.FILESEPERATOR;
                LiveDB.DECLARE_EMERGENCY(); // Running out of space find a new planet
                return false;
            }
        }
    }
    else
    {
        LiveDB.ALRTLVL = 1;
        System.err.println(LiveDB.grassHopper("serializedfilespath tampered with in memory no longer directory "
        + LiveDB.serializedfilespath + "conf"));
        return false;
    }

    if (ou.exists() == true)
    {
        // check date of access and if it is today then exit some other user process has already done bkup
       long bkf = 1000 * 60 * LiveDB.BACKUPFREQUENCY;  // allow backup every ten-20 minutes for it to be usefull
       if ((new Date().getTime() - ou.lastModified()) <= bkf)
          return true; // backup taken dont bother
       // if this program you feel is not very heavily used then you increase to one hour
       // i assume heavy use and one user transaction every ten minutes
    }
    
    if (LiveDB.CopyFile(LiveDB.USRHOMEDIR + pf, LiveDB.serializedfilespath + "conf" + pf + ".dsk" + ".bkp") == false)
        return false;

    if (LiveDB.TakeExternalBackupToMailBox(LiveDB.serializedfilespath + "conf" + pf + ".dsk" + ".bkp") == false)
        System.err.println(LiveDB.grassHopper("TakeExternalBackupToMailBox for File:" +
                LiveDB.serializedfilespath + "conf" + pf + ".dsk" + ".bkp" + " Failed"));

    if (bd.setReadOnly() == false)
    {
        LiveDB.ALRTLVL = 3;
        System.err.println(LiveDB.grassHopper("Unable to setReadOnly File:"
                + LiveDB.serializedfilespath + "conf"));
    }
    
    return true;
}

}

