/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import javax.swing.JOptionPane;
import java.io.File;
import java.io.IOException;
import javax.swing.JEditorPane;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import static DatabaseEngine.LiveDB.appframe;
import static DatabaseEngine.FirstPage.win;
import static DatabaseEngine.LoginPage.LoggedInCID;

/*
 * WIRING DIAGRAM :
 * LISTENER CLASS NAME : BottomPaneListener implements ChangeListener
 *
 * @LOOKSY : FirstPage.picturepagetextpanel, FirstPage.pageonetextpanel, FooterPanel.bottompane
 *           LiveDB.appframe, FooterPanel.bottompane, LiveDB.serializedfilespath, LiveDB.FILESEPERATOR
 *           LoginPage.LoggedInCID, FirstPage.win
 *
 * @LOOKSY : RMAPage.java
 *           LoginPage.java
 *           SysAdminPage.java
 *
 * Date File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class is a listener for the bottompane of the screen which is initialized
 * in FooterPanel and registered. So whenever the user changes his choice in the bottompane the
 * appropriate html page is loaded.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class BottomPaneListener implements ChangeListener {

    String filelocale = null;
    
    @Override
    public void stateChanged (ChangeEvent evnt)
    {
        int si = FooterPanel.bottompane.getSelectedIndex(); // selected index
        int n = 0; // look in substr idiot
        String tit = null;

        // find filelocale from LanguageTransalations for various picture codes
        // but for this central display the text will be contained in html files in /etc directory
        // these html file names will trail with the two letter iso language code and the filename
        // must start with LENSVIEW

        tit = FooterPanel.bottompane.getTitleAt(si);

        if (tit.equalsIgnoreCase("Customer Returns"))
            ;
            // new RMAPage();
        else if (tit.equalsIgnoreCase("System Admin"))
        {
            if (LoggedInCID.equals("superuser"))
                new SysAdminPage();
            else
            {
                while (LoggedInCID.equals("superuser") == false)
                {
                   JOptionPane.showMessageDialog(appframe, "You must Login as superuser" + '\n'
                        + "For System Administration" + '\n'
                        + "Taking you to Login Page" );
                   new LoginPage();
                }
            }
        }
                
        filelocale = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
        + "LENSVIEW" + tit.substring(0, n = (tit.lastIndexOf(' ') == -1 ? tit.length() : tit.indexOf(' '))).trim()
        + (tit.indexOf(' ') != -1 ? '_':"") +  (n == tit.length() ? "" : tit.substring(n+1, tit.length())).trim()
        + LanguagePanel.SelectedLanguage + ".html";

        try{
        if (new File(filelocale).canRead() == false)
        {
            filelocale = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
            + "LENSVIEW" + tit.substring(0, n = (tit.indexOf(' ') == -1 ? tit.length() : tit.indexOf(' '))).trim()
            + (tit.indexOf(' ') != -1 ? '_':"") + (n == tit.length() ? "" : tit.substring(n+1, tit.length())).trim()
            + "en" + ".html";
        }
        }catch (SecurityException ex_NOKIA9){
            System.err.println(LiveDB.grassHopper(ex_NOKIA9, "JSM denied read perms"));
            System.exit(1);
        }

        if (new File(filelocale).canWrite())
            new File(filelocale).setReadOnly();
        
        filelocale = "file:" + filelocale;

        appframe.remove(FirstPage.picturepagetextpanel);
        FirstPage.pageonetextpanel.removeAll();

        win = new JEditorPane();
        
        win.addHyperlinkListener(new DisplayHyperLinkListener());
        
        try{
        win.setPage(filelocale);
        }catch (IOException ex_NOKIA8){
            win.setText(ex_NOKIA8.toString());
            System.err.println(LiveDB.grassHopper(ex_NOKIA8, "URL:" + filelocale));
            System.exit(1);
        }
        
        win.setEditable(false);

        FirstPage.pageonetextpanel.add(win, 1);
    }
}
