/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;
import java.awt.Font;
import javax.swing.BoxLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static DatabaseEngine.FirstPage.currencypanel;
import static DatabaseEngine.LanguagePanel.SelectedLanguage;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : CurrencyPanel
 *
 * @LOOKSY : LiveDB.system_exit, LiveDB.SmoothExitCondition, LiveDB.appframe,
 *           this.currency, this.Symbol
 *
 * @LOOKSY : CartPanel.java
 *           SalePanel.java
 *           LatestProductsPanel
 * 
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * Associated Methods : public CartPanel ()
 *                      public SalePanel ()
 *                      public LatestProductsPanel ()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructs the currency panel on the center west end of screen and
 * provides combo boxes for user to select a currency. After currency is selected all other panels are
 * redrawn with the newly selected currency.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 10th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class CurrencyPanel
{

    protected static String currency = "US Dollar";
    protected static String Symbol = "$"; // this will be set in convertCurrency()
    protected static JComboBox currencycombo = null;
    String langstring [] = null;
    JLabel label = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Currency")
            == null ? "Currency" : new String(langstring[langstring.length -1].toCharArray()));

    public CurrencyPanel ()
    {
        int MF = 10;
        currencypanel = new JPanel ();
        currencypanel.setLayout(new BoxLayout(currencypanel, BoxLayout.Y_AXIS));
        currencypanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        currencypanel.setBackground(Color.WHITE);
        currencypanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.infopanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.currencypanel.RIGHT_ALIGNMENT * MF),
                (int)(FirstPage.currencypanel.BOTTOM_ALIGNMENT * MF) - (int)(FirstPage.currencypanel.TOP_ALIGNMENT * MF));
        addcurrencypanel();
    }
    
    void addcurrencypanel()
    {
        currencycombo = new JComboBox (new String [] {"US Dollar", "Euro", "British Pound", "Indian Rupee"});
        currencycombo.setForeground(Color.BLACK);
        label.setFont(new Font("Dialog",Font.BOLD, 8));
        label.setForeground(Color.BLACK);
        currencypanel.add(label);
        currencypanel.add(currencycombo);
        label.validate();
        currencycombo.validate();

        currencycombo.addActionListener(new ActionListener ()
        {
            @Override
            public void actionPerformed (ActionEvent evnt){
                currency = (String)currencycombo.getSelectedItem();
                if (currency.equalsIgnoreCase("Indian Rupee"))
                    Symbol = "INR".toString();
                else if (currency.equalsIgnoreCase("Euro"))
                    Symbol = "EURO".toString();
                else if(currency.equalsIgnoreCase("British Pound"))
                    Symbol = "Sterling".toString();  // sorry I got yankee keyboard
                new CartPanel();
                new SalePanel();
                new LatestProductsPanel();
            }
        });
    }
}
