/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.io.ObjectOutput;
import java.io.UTFDataFormatException;
import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.Externalizable;
import java.util.Date;
import java.util.concurrent.Semaphore;
import static DatabaseEngine.LiveDB.cp;
import static DatabaseEngine.LiveDB.ct;
import static DatabaseEngine.LiveDB.ft;

/**
 *
 * @author SAI KRISHNA
 */
public class CustomerPayments implements Externalizable, Cloneable, Tables {

       private String cid;
       private float amtpaid;
       private byte validity;  // 0 life time, 1 -- 1 year, 2 -- 2 year , 3 -- 3 year
       private Date validfrom;
       private byte block;  // 1 block 0 open
       private long rowid; // 6 fields
       
       private transient Semaphore rowlock;
       private transient CustomerPayments cpt;
       private transient File srf;
       private transient int itn;
       private transient long fieldchanges ; // for Ultra Fast Commits

       {
           cpt = null;
           srf = null;
           fieldchanges = 0L;
           itn = 14;
           rowlock = new Semaphore (1, true);
       }

       public CustomerPayments (String p_cid, float p_amtpaid, byte p_valid, byte p_block, long p_rowid)
       {
           setCid(p_cid);
           setAmtpaid (p_amtpaid);
           setValidity(p_valid);
           setValidfrom(new Date());
           setBlock(p_block);
           setRowid(p_rowid);
       }

       @Override
       protected Object clone() {

           rowlock.acquireUninterruptibly();
           try{
           cpt = (CustomerPayments)super.clone();
           cpt.setCid(cpt.getCid());
           }catch (CloneNotSupportedException ex_NOKIA9){
               throw new InternalError(ex_NOKIA9.toString());
           }
           rowlock.release();
           return cpt;
       }

       protected int SIZEOF () {
           return (cid.length() * 2 + 4 + 1 + 8 + 1 + 8);
       }
       
       protected String getCid () {
           return new String(cid.toCharArray()).trim();
       }

       protected float getAmtpaid () {
           return amtpaid;
       }

       protected byte getValidity () {
           return validity;
       }

       protected Date getValidfrom () {
           return new Date(validfrom.getTime());
       }

       protected byte getBlock () {
           return block;
       }

       protected long getRowid () {
           return rowid;
       }

       void setCid(String p_cid){

           if (p_cid == null)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println(LiveDB.grassHopper("Invalid p_Cid=null"));
               System.exit(1);
           }

           if (LiveDB.indxcustomerRegister.get(p_cid) == null)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println(LiveDB.grassHopper("Invalid Cid:" + p_cid + " table CustomerPayments"));
               System.exit(1);
           }
           rowlock.acquireUninterruptibly();
           cid = new String(p_cid.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_cid.length()));
           rowlock.release();
       }

       void setAmtpaid (float p_amt) {
           if (p_amt >= 0)
               amtpaid = p_amt;
           else
           {
               LiveDB.ALRTLVL = 15;
               System.err.println(LiveDB.grassHopper("Invalid amtpaid:" + p_amt
                                                                + " table CustomerPayments"));
               System.exit(1);
           }
           rowlock.acquireUninterruptibly();
           amtpaid = p_amt;
           rowlock.release();
       }

       void setValidity (byte p_valid){

           if (p_valid < 0 || p_valid > 3)
           {
               LiveDB.ALRTLVL = 15;
               System.err.println(LiveDB.grassHopper("Invalid p_valid:" + p_valid
                       + " table CustomerPayments"));
               System.exit(1);
           }

           rowlock.acquireUninterruptibly();
           validity = p_valid;
           rowlock.release();
       }

       void setValidfrom (Date p_validfrom) {

           if (p_validfrom == null)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println(LiveDB.grassHopper("null p_validfrom table CustomerPayments"));
               System.exit(1);
           }
           rowlock.acquireUninterruptibly();
           validfrom = new Date (p_validfrom.getTime());
           rowlock.release();
       }

       void setBlock (byte p_block){

           if (p_block < 0 || p_block > 1 )
           {
               LiveDB.ALRTLVL = 7;
               System.err.println(LiveDB.grassHopper("Invalid value block = " + p_block
                       + " CustomerPayments"));
               System.exit(1);
           }

           rowlock.release();
           block = p_block;
           rowlock.acquireUninterruptibly();
       }

       void setRowid (long p_rowid){

           if (LiveDB.LiveSharedDB[cp].length == 0 && p_rowid != 0)
           {
              LiveDB.ALRTLVL = 7;
              System.err.println(LiveDB.grassHopper("Invalid Args p_Rowid " + p_rowid));
              System.exit(1);
           }
           rowlock.acquireUninterruptibly();
           rowid = p_rowid;
           rowlock.release();
       }

       @Override
       public final void readExternal (ObjectInput stream) throws EOFException, IOException {
            rowlock.acquireUninterruptibly();
            // now read in all values here
            try{
              cid = stream.readUTF();
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "CustomerPayments field cid"));
              throw new EOFException ();
            }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "CustomerPayments field cid"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "CustomerPayments field cid"));
              throw new IOException ();
            }

            try{
              amtpaid = stream.readFloat();
            }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "CustomerPayments Field amtpaid"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "CustomerPayments Field amtpaid"));
              throw new IOException ();
            }

            try{
              validity = stream.readByte();
            }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "CustomerPayments Field validity"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "CustomerPayments Field validity"));
              throw new IOException ();
            }

            try{
              validfrom = new Date(stream.readLong());
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "CustomerPayments field validfrom"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "CustomerPayments field validfrom"));
              throw new IOException ();
            }

            try{
              block = stream.readByte();
            }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "CustomerPayments Field block"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "CustomerPayments Field block"));
              throw new IOException ();
            }

            try{
              rowid = stream.readLong();
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "CustomerPayments field rowid"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "CustomerPayments field rowid"));
              throw new IOException ();
            }

            rowlock.release();
       }

       @Override
       public final void writeExternal (ObjectOutput stream) throws IOException {
            rowlock.acquireUninterruptibly();
            int itr = -1; // Installed table row in InstalledTables

            // first find the rowid for this table in InstalledTables
            if (LiveDB.indxinstalledTables.get(Integer.toString(cp)) == null)
            {
                LiveDB.ALRTLVL = 4;
                System.err.println(LiveDB.grassHopper("CustomerPayments misses entry in indxinstalledTables"));
                // perhaps the index is corrupted or has not been updated someplace so check the physical table
                for (int i = 0; i < LiveDB.LiveSharedDB[itn].length; i++)
                {
                    if (((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getTableno() == cp)
                        itr = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getRowid();
                }

                if (itr == -1 || itr > LiveDB.maxtables)
                {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("CustomerPayments misses entry in indxinstalledTables"));
                    System.exit(1);
                }
            }
            else
                itr = (int)(long)LiveDB.indxinstalledTables.get(Integer.toString(cp));

            srf = new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft]
                [(int)((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).getTableno()]).getFilename());

            // outsize should be negative before every write
            ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
            LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);

            try{
              stream.writeUTF(cid);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field cid"));
              throw new IOException ();
            }

            /*
             try{
             stream.flush();
             }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during CustomerPayments serialization"));
                System.exit(1);
             }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeFloat(amtpaid);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field amtpaid"));
              throw new IOException ();
            }

            /*
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during CustomerPayments serialization"));
                System.exit(1);
            }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeByte(validity);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field validity"));
              throw new IOException ();
            }

            /*
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during CustomerPayments serialization"));
                System.exit(1);
            }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeLong(validfrom.getTime());
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field validfrom"));
              throw new IOException ();
            }

            /*
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during CustomerPayments serialization"));
                System.exit(1);
            }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);


            try{
              stream.writeByte(block);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field block"));
              throw new IOException ();
            }

            /*
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during CustomerPayments serialization"));
                System.exit(1);
            }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeLong(rowid);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
            }

            // This last flush is valid after each row Uncomment the above flushes for UltraFastCommits
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during CustomerPayments serialization"));
                System.exit(1);
            }

            // setOutsize to positive value after every successfull write
            // so if there is a power outage in between we will know that there has been a serialization
            // failure and the serialized file is corrupted and take necessary steps to restpre the
            // serialized file from CrashRecovery or ChangeTracker or if both CrashRecovery and ChangeTracker
            // are corrupted then restore from last autobackup
            ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length());
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
            LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);
            rowlock.release();            
       }
    // although each instance of this Class InstallerDues represents a single row
    // we are committing the entire table here but before that a few checks and balances

    @Override
    public final boolean COMMIT(){

        boolean fnd = false;

        // we are committing the FileTableDataFileMap so mark those rows with change_flag 'C'
        for (int rw =  (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
            if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == cp
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'F'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'C'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'K'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'T')
            {
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).setChange_flag('C');
                fnd = true;
                // insert an entry in ChangeTracker table for this table
                // Basically what this does is to backup this entirerow where you
                // setChange_flag('C') otherwise database reconstruct of ChangeTracker will fail.
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker ((long)ct,rw, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ct][rw],(long)LiveDB.LiveSharedDB[ct].length);
            }
        }

        if (fnd)
        {
            // for the sake of dbfRepair we take a restore file which may be a BAD copy
            // since we are not checking for the presence of a .syc file on disk. If we
            // look for a .syc file on disk then this commit will take very very long.
            LiveDB.CopyFile(LiveDB.serializedfilespath
                   + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][cp]).getFilename() + ".ser",
                   LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
                   ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][cp]).getFilename() + ".ser" + ".res");
            if ( LiveDB.commit_database(cp) == false )
                return false;
        }

        return true;
    }

    @Override
    public final boolean COMMITINDEXES(){

        if (LiveDB.LiveSharedDB[cp].length == 0)
            return false;
        return LiveDB.write_IndexFile(cp);
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(cp) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
}
