/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.io.Serializable;
import java.util.Date;
import java.util.concurrent.Semaphore;

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.tablenameidentifier, LiveDB.SerializeJustOnceTable(long p_tbl)
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java
 * @LOOKSY:ArtLeavesInterfaces.java
 *
 * Class Name : DefaultAdvertisingImages implements Serializable, Tables
 *
 * Methods : Look in Class definition
 * The Constructor method does a thorough validation before accepting data. If data is non-compliant it
 * does a System.exit(1) rather than a LiveDB.SmoothExitCondition.signalAll() because the object has
 * already been created the constructor is only filling in values into the instance.
 * There are no Setters for this table at all.
 *
 * The Tables Interface has been faked here except for REFRESH because it is too very dangerous to provide it.
 *
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding.
 *
 * Relevant Indexes : None, Maybe we will add some later
 *
 * Data File : YES Data present at Install time in datafilename name in FileTableDataFileMap
 *
 * @Since Version 1.0
 *
 * Running Commentary : This is one of those LiveDB.SerializeJustOnceTable(long p_tbl). These are tables
 * which are static in nature where data is loaded from a data entry file at Install time and then the
 * application serializes all that data to a stream and exits. After the application is installed the
 * data is read in from the stream after which the table just remains a lookup table for data.
 * There are no Setters for this table at all.
 *
 * Technical References : Buy and Read Asterix and Son 
 *
 * Start Date: 18th October 2010
 * End Date: 12th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class DefaultAdvertisingImages implements Serializable, Tables {

    private String imagename ;
    private String imagesize; /* String such as 200X100
                               * meaning 200 pixels height
                               * 100 pixels width
                               */
    private String directoryname; /* any directory in which the image resides
                                   * on your server computer. Each of your
                                   * images could reside in a different path
                                   * name. Make sure they exist there or else
                                   * the program may not load advert.
                                   */
    private long directions ; /* Choose from any one of the several directions
                               * on top of this file. just a number. Make
                               * sure they dont overlap or else the images
                               * may not display correctly.
                               * Valid values 0 thru 8
                               */
    private long video; /* the image is a video file true ? then 1 else 0 */
    private long audio; /* the image is an audio file true ? then 1 else 0 */
    private String XYcoordinates; /* example 1X1, 15X10 meaning X=15, Y=10 */
    private long childsafe; /* the image is childsafe true then 1 else 0 */
    private String imagetype; /* The advert image type
                              * "U" Loaded by User
                              * "P" one additional flag for Parental Guidance ??
                              * "D" Default
                              * If image type = "U" and childsafe = 0
                              *    then update image type = "I"
                              *    meaning Inappropriate content
                              *    So the next time the application will only
                              *    load image type = "D"
                              */
    private long rowid; /* 10 FIELDS */

    private transient int dan;
    private static Semaphore rowlock;
    static
    {
       rowlock = new Semaphore(1, true);
    }
    {
        dan = LiveDB.da;
    }
    
    // This is the superb constructor
    protected DefaultAdvertisingImages ()
    {
          imagename = imagesize = directoryname = XYcoordinates = imagetype = null;
          directions = video = audio = childsafe = rowid = 0L;
    }

    public DefaultAdvertisingImages (String p_Imagename,
            String p_Imagesize, String p_Directoryname, long p_Directions,
            long p_Video, long p_Audio, String p_XYcoordinates,
            long p_Childsafe, String p_Imagetype, long p_Rowid) {
         /* Store one Row of Data per instance */
        rowlock.acquireUninterruptibly();
        imagename = imagename == null ? " " : (new String(p_Imagename.toCharArray()));

        if (p_Imagesize.toCharArray()[0] == 'X'
            || p_Imagesize.indexOf('X') == -1
            || p_Imagesize.indexOf('x') == -1
            || Character.isDigit(p_Imagesize.toCharArray()[0]) == false)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Image Size " + p_Imagesize));
            System.exit(1);
        }
        
        imagesize = p_Imagesize == null ? " " : new String(p_Imagesize.toCharArray());

        if (new File (p_Directoryname).isDirectory() == false)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Directory does not exits " + p_Directoryname));
            System.exit(1);
        }

        if (LiveDB.convertFileName(p_Directoryname) == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_Directoryname=null"));
            System.exit(1);
        }
        directoryname =  new String(LiveDB.convertFileName(p_Directoryname).toCharArray());

        if (p_Directions < LiveDB.north && p_Directions > LiveDB.southeast)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Args p_Directions " + String.valueOf(p_Directions)));
            System.exit(1);
        }
        directions = p_Directions;

        if (p_Video != 0 && p_Video != 1)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Args p_Video " + String.valueOf(p_Video)));
            System.exit(1);
        }
        video = p_Video;

        if (p_Audio != 0 && p_Audio != 1)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Args p_Audio " + String.valueOf(p_Audio)));
            System.exit(1);
        }
        audio = p_Audio;

        if (p_XYcoordinates.toCharArray()[0] == 'X'
            || p_Imagesize.indexOf('X') == -1
            || p_Imagesize.indexOf('x') == -1
            || Character.isDigit(p_Imagesize.toCharArray()[0]) == false)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid coordinates " + p_XYcoordinates));
            System.exit(1);
        }

        if (p_XYcoordinates == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid p_XYcoordinates=null"));
            System.exit(1);
        }
        XYcoordinates = new String(p_XYcoordinates.toCharArray());

        if (p_Childsafe != 0 && p_Childsafe != 1)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid Args p_Childsafe " + String.valueOf(p_Childsafe)));
            System.exit(1);
        }
        childsafe = p_Childsafe;

        if (p_Imagetype.equals("U") || p_Imagetype.equals("D") || p_Imagetype.equals("P") || p_Imagetype.equals("I"))
                 imagetype = new String(p_Imagetype.toCharArray());
        else imagetype = "P";
        
        if (LiveDB.LiveSharedDB[dan].length == 0 && p_Rowid != 0)
        {
            LiveDB.ALRTLVL = 15;
            System.err.println(LiveDB.grassHopper("Invalid rowid:" + String.valueOf(p_Rowid)));
            System.exit(1);
        }
        if (p_Rowid >= 0)
            rowid = p_Rowid;
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Negative Rowid:" + p_Rowid));
            System.exit(1);
        }
        rowlock.release();

    }

    protected void setChildsafe (long val){
        if (val > 1 || val < 0)
            val = 0;
        
        this.childsafe = val;
    }

    protected String getImagename (){
        return new String(imagename.toCharArray());
    }
    protected String getImagesize (){
        return new String(imagesize.toCharArray());
    }
    protected String getDirectoryname(){
        return new String(directoryname.toCharArray());
    }
    protected long getDirections(){
        return directions;
    }
    protected long getVideo(){
        return video;
    }
    protected long getAudio(){
        return audio;
    }
    protected String getXYcoordinates(){
        return new String(XYcoordinates.toCharArray());
    }
    protected long getChildsafe(){
        return childsafe;
    }
    protected String getImagetype(){
        return new String(imagetype.toCharArray());
    }
    protected long getRowid(){
        return rowid;
    }

    // This toString Override is common to all tables and does a toString of this row Instance    
    @Override
    public String toString(){
        String filher = "%";

        return getImagename().concat(filher).concat(getImagesize()).concat(filher).concat(getDirectoryname())
               .concat(filher).concat(String.valueOf(getDirections())).concat(filher)
               .concat(String.valueOf(getVideo())).concat(filher).concat(String.valueOf(getAudio())).concat(filher)
               .concat(getXYcoordinates()).concat(filher).concat(String.valueOf(getChildsafe())).concat(filher)
               .concat(getImagetype()).concat(filher).concat(String.valueOf(getRowid()));
    }
    

    @Override
    public final boolean COMMIT(){
        return true;
    }

    @Override
    public final boolean COMMITINDEXES (){
        return true;
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(dan) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
}
