/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;
import java.awt.Font;
import javax.swing.JLabel;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import static DatabaseEngine.FirstPage.infopanel;
import static DatabaseEngine.CurrencyPanel.currency;
import static DatabaseEngine.CataloguePanel.catnames;

import static DatabaseEngine.LanguagePanel.SelectedLanguage;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : InfoPanel
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Info Panel at top west corner
 * of screen. It provides information on number of Categories, Products, Prices.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class InfoPanel {

    String langstring [] = null;
    JLabel cats = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Categories")
            == null ? "Categories: " + catnames.length : new String(langstring[langstring.length -1].toCharArray()) + ": " + catnames.length);
    JLabel prods = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Products")
            == null ? "Products: " + LiveDB.LiveSharedDB[pd].length : new String(langstring[langstring.length -1].toCharArray()) + ": " + LiveDB.LiveSharedDB[pd].length);
    JLabel prices = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Prices")
            == null ? "Prices: " + currency : new String(langstring[langstring.length -1].toCharArray()) + ": " + currency);
    JLabel info = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Information")
            == null ? "Information" : new String(langstring[langstring.length -1].toCharArray()));

    public InfoPanel ()
    {
        int MF = 10;
        infopanel = new JPanel ();
        infopanel.setLayout(new BoxLayout(infopanel, BoxLayout.Y_AXIS));
        infopanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        infopanel.setBackground(Color.WHITE);
        infopanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.cartpanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.cartpanel.RIGHT_ALIGNMENT * MF),
                (int)(FirstPage.cartpanel.BOTTOM_ALIGNMENT * MF) - (int)(FirstPage.cartpanel.TOP_ALIGNMENT * MF) -1);
    }

    void addinfopanel ()
    {
        cats.setFont(new Font("Dialog", Font.BOLD, 8));
        cats.setForeground(Color.BLUE);
        prods.setFont(new Font("Dialog", Font.BOLD, 8));
        prods.setForeground(Color.BLUE);
        prices.setFont(new Font("Dialog", Font.BOLD, 8));
        prices.setForeground(Color.BLUE);
        info.setFont(new Font("Dialog", Font.BOLD, 10));
        infopanel.add(info);
        infopanel.add(prods);
        infopanel.add(cats);
        infopanel.add(prices);
        info.validate();
        prods.validate();
        cats.validate();
        prices.validate();
    }

}
