/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.io.UTFDataFormatException;
import java.io.ObjectOutput;
import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.Externalizable;
import java.util.Date;
import java.util.concurrent.Semaphore;
import static DatabaseEngine.LiveDB.id;
import static DatabaseEngine.LiveDB.ct;
import static DatabaseEngine.LiveDB.ft;

/**
 *
 * @author SAI KRISHNA
 */
public class InstallerDues implements Tables, Cloneable, Externalizable {

    private String invoicenumber;
    private Date datebilled;
    private Date datedue;
    private float amount;
    private byte reminders;
    private byte softwarelock; // 0 false 1 true 2 for future use
    private Date softwarelockdate;
    private short softwarelockperiod;
    private long rowid; //9 fields
    
    private transient InstallerDues idu;
    private transient Semaphore rowlock;
    private transient long fieldchanges ; // for Ultra Fast Commits
    private transient int itn = 14;
    private transient File srf ;

    {
       fieldchanges = 0L;
       srf = null;
       idu = null;
       rowlock = new Semaphore(1, true);
    }

    public InstallerDues (String p_invnum, Date p_datebill, Date p_datedue, float p_amount,
            byte p_remind, byte p_softlock, Date p_lockdate, short p_lockperiod, long p_rowid )
    {
         setInvoicenumber (p_invnum);
         setDatebilled(p_datebill);
         setDatedue(p_datedue);
         setAmount(p_amount);
         setReminders(p_remind);
         setSoftwarelock (p_softlock);
         setSoftwarelockdate (p_lockdate);
         setSoftwarelockperiod (p_lockperiod);
         setRowid(p_rowid);
    }

    @Override
    protected Object clone () {

        rowlock.acquireUninterruptibly();
        try{
            idu = (InstallerDues) super.clone();
            idu.setInvoicenumber(idu.getInvoicenumber());
            idu.setDatebilled(idu.getDatebilled());
            idu.setDatedue(idu.getDatedue());
            idu.setSoftwarelockdate(idu.getSoftwarelockdate());
        }catch (CloneNotSupportedException ex_NOKIA3){
            throw new InternalError (ex_NOKIA3.toString());
        }
        rowlock.release();
        return idu;
    }

    protected int SIZEOF() {
        return (invoicenumber.length() * 2) + 8 + 8 + 4 + 1 + 1 + 8 + 2 + 8;
    }

    protected String getInvoicenumber (){
        return new String (invoicenumber.toCharArray());
    }

    protected Date getDatebilled () {
        return new Date (datebilled.getTime());
    }

    protected Date getDatedue () {
        return new Date (datedue.getTime());
    }

    protected float getAmount () {
        return amount;
    }

    protected byte getReminders () {
        return reminders;
    }

    protected byte getSoftwarelock () {
        return softwarelock;
    }

    protected Date getSoftwarelockdate () {
        return new Date (softwarelockdate.getTime());
    }

    protected short getSoftwarelockperiod () {
        return softwarelockperiod;
    }

    protected long getRowid () {
        return rowid;
    }

    void setInvoicenumber (String p_inv) {
        rowlock.acquireUninterruptibly();
        invoicenumber = new String(p_inv.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_inv.length()));
        rowlock.release();
    }

    void setDatebilled (Date p_datebill){
        rowlock.acquireUninterruptibly();
        datebilled = new Date (p_datebill.getTime());
        rowlock.release();
    }

    void setDatedue (Date p_datedue) {
        rowlock.acquireUninterruptibly();
        datedue = new Date (p_datedue.getTime());
        rowlock.release();
    }

    void setAmount (float p_amt) {
        rowlock.acquireUninterruptibly();
        amount = p_amt;
        rowlock.release();
    }

    void setReminders (byte p_remind){
         rowlock.acquireUninterruptibly();
         reminders = p_remind;
         rowlock.release();
    }

    void setSoftwarelock (byte p_softlock){

        if (p_softlock != 0 && p_softlock != 1)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid value for p_softlock"));
            System.exit(1);
        }
        rowlock.acquireUninterruptibly();
        softwarelock = p_softlock;
        rowlock.release();
    }

    void setSoftwarelockdate (Date p_softlockdate){
        rowlock.acquireUninterruptibly();
        softwarelockdate = new Date (p_softlockdate.getTime());
        rowlock.release();
    }

    void setSoftwarelockperiod (short p_period) {
        rowlock.acquireUninterruptibly();
        softwarelockperiod = p_period;
        rowlock.release();
    }

    void setRowid (long p_rowid){
        if (LiveDB.LiveSharedDB[id].length == 0 && p_rowid != 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid Args p_Rowid " + p_rowid +
                    " table InstallerDues"));
            System.exit(1);
        }
        rowlock.acquireUninterruptibly();
        rowid = p_rowid;
        rowlock.release();
    }

    @Override
    public final void readExternal (ObjectInput stream) throws IOException, EOFException {
        rowlock.acquireUninterruptibly();
        // now read in all values here
        try{
              invoicenumber = stream.readUTF();
        }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "field invoicenumber"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "field invoicenumber"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field invoicenumber"));
              throw new IOException ();
        }

        try{
              datebilled = new Date(stream.readLong());
        }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "field datebilled"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field datebilled"));
              throw new IOException ();
        }

        try{
              datedue = new Date(stream.readLong());
        }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "field datedue"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field datedue"));
              throw new IOException ();
        }

        try{
              amount = stream.readFloat();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "ShoppingCart Field amount"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "ShoppingCart Field amount"));
              throw new IOException ();
        }

        try{
              reminders = stream.readByte();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "ShoppingCart Field reminders"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "ShoppingCart Field reminders"));
              throw new IOException ();
        }

        try{
              softwarelock = stream.readByte();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "ShoppingCart Field softwarelock"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "ShoppingCart Field softwarelock"));
              throw new IOException ();
        }

        try{
              softwarelockdate = new Date(stream.readLong());
        }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "field softwarelockdate"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field softwarelockdate"));
              throw new IOException ();
        }

        try{
              softwarelockperiod = stream.readShort();
        }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "field softwarelockperiod"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field softwarelockperiod"));
              throw new IOException ();
        }

        try{
              rowid = stream.readLong();
        }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "field rowid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
        }

        rowlock.release();
    }

    @Override
    public final void writeExternal (ObjectOutput stream) throws IOException {
        rowlock.acquireUninterruptibly();
        int itr = -1; // Installed table row in InstalledTables

        // first find the rowid for this table in InstalledTables
        if (LiveDB.indxinstalledTables.get(Integer.toString(id)) == null)
        {
            LiveDB.ALRTLVL = 4;
            System.err.println(LiveDB.grassHopper("InstallerDues misses entry in indxinstalledTables"));
            // perhaps the index is corrupted or has not been updated someplace so check the physical table
            for (int i = 0; i < LiveDB.LiveSharedDB[itn].length; i++)
            {
                if (((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getTableno() == id)
                   itr = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getRowid();
            }

            if (itr == -1 || itr > LiveDB.maxtables)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("InstallerDues misses entry in indxinstalledTables"));
                System.exit(1);
            }
        }
        else
            itr = (int)(long)LiveDB.indxinstalledTables.get(Integer.toString(id));

        srf = new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft]
                [(int)((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).getTableno()]).getFilename());

        // outsize should be negative before every write
        ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);

        try{
              stream.writeUTF(invoicenumber);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field invoicenumber"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{

              stream.writeLong(datebilled.getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field datebilled"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{

              stream.writeLong(datedue.getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field datedue"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{

              stream.writeFloat(amount);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field amount"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{

              stream.writeByte(reminders);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field reminders"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

        try{
              stream.writeLong(softwarelock);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field softwarelock"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{

              stream.writeLong(softwarelockdate.getTime());
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field softwarelockdate"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{

              stream.writeShort(softwarelockperiod);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field softwarelockperiod"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{

              stream.writeLong(rowid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
        }

         // This last flush is valid after each row Uncomment the above flushes for UltraFastCommits
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during InstallerDues serialization"));
            System.exit(1);
        }

        // setOutsize to positive value after every successfull write
        // so if there is a power outage in between we will know that there has been a serialization
        // failure and the serialized file is corrupted and take necessary steps to restpre the
        // serialized file from CrashRecovery or ChangeTracker or if both CrashRecovery and ChangeTracker
        // are corrupted then restore from last autobackup
        ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length());
        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);
        rowlock.release();
    }
    // although each instance of this Class InstallerDues represents a single row
    // we are committing the entire table here but before that a few checks and balances

    @Override
    public final boolean COMMIT(){

        boolean fnd = false;

        // we are committing the FileTableDataFileMap so mark those rows with change_flag 'C'
        for (int rw =  (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
            if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == id
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'F'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'C'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'K'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'T')
            {
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).setChange_flag('C');
                fnd = true;
                // insert an entry in ChangeTracker table for this table
                // Basically what this does is to backup this entirerow where you
                // setChange_flag('C') otherwise database reconstruct of ChangeTracker will fail.
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker ((long)ct,rw, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ct][rw],(long)LiveDB.LiveSharedDB[ct].length);
            }
        }

        if (fnd)
        {
            // for the sake of dbfRepair we take a restore file which may be a BAD copy
            // since we are not checking for the presence of a .syc file on disk. If we
            // look for a .syc file on disk then this commit will take very very long.
            LiveDB.CopyFile(LiveDB.serializedfilespath
                   + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][id]).getFilename() + ".ser",
                   LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
                   ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][id]).getFilename() + ".ser" + ".res");
            if ( LiveDB.commit_database(id) == false )
                return false;
        }
        
        return true;
    }

    @Override
    public final boolean COMMITINDEXES(){

        if (LiveDB.LiveSharedDB[id].length == 0)
            return false;
        return LiveDB.write_IndexFile(id);
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(id) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
}
