/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import DatabaseEngine.LiveDB.Action;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.Random;
import javax.swing.JOptionPane;
import javax.swing.ProgressMonitor;

/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadleash
 * CLASS NAME : IntranetCompliantRadioTaggedCollar
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[]
 *         Dont read the entire ThreadController.java you will go mad.
 * @LOOKSY:LiveDB.LogFileSabotageCheck(), LiveDB.LiveSharedDB
 * @LOOKSY:Spy.java run () method
 *
 * Method Name : public void run ()
 *
 * Parameters : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a once in a while thread that loads data from character streams into
 * LiveDB.LiveSharedDB and then serializes that data and exits the application. Then you need to restart
 * the application once again to use it. The thread is launched from InstallDB.threadlaunch() if and only
 * if LiveDB.command_line.equals("FileTableDataFileMap") || LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN").
 * The run() method calls LiveDB.REVOKE_EMERGENCY() to revoke system emergency. This is the only place where
 * emergency can be revoked. So it loads table zero first
 * 
 * Technical Reference : Watch 101 Dalmations
 * Musical Accompanyments : Weather Report Black Market
 *
 * Start Date: 18th October 2010
 * End Date: 18th May 2011
 *
 * Last Modified Date : 28th July 2011
 * Last Modifications : Added a ProgressMonitor to indicate progress of loading from character data files.
 * It also allows user to abort/cancel operation. If user cancels operation do a System.exit(1).
 *
 * Last Modified : 14th October 2011
 * Last Modifications : added this code patch.At the time of Install the character data file must be
 * present in LiveDB.USRDIR but later when you use commands like "FiXdAtAcOrRuPtIoN" it cam be present
 * at a different location as specified in table FileTableDataFileMap
 *
          if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
              filename = ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][0]).getDatafilename();
 *
 * Last Modified : 17th october 2011
 * Last Modifications : plugged in this path of code to check for USER ERRORS at Install time
          // Quick check if opening install file exists on disk
          if (LiveDB.command_line.equals("FileTableDataFileMap"))
          {
              if (new File(filename).exists() == false)
              {
                  if (new File(LiveDB.USRDIR +
                              "filetabledatafilemap" + "_de" + ".de").exists() == false)
                  {
                      if (new File(LiveDB.USRHOMEDIR +
                              "filetabledatafilemap" + "_de" + ".de").exists() == false)
                      {
                          JOptionPane.showMessageDialog(appframe, "Please manually copy oon O/S"
                                  + '\n' + "filetabledatafilemap" + "_de" + ".de" + " TO" + '\n'
                                  + LiveDB.USRHOMEDIR + " and restart Installation");
                          System.exit(1);
                      }
                      else filename = LiveDB.USRHOMEDIR + "filetabledatafilemap" + "_de" + ".de";
                  }
                  else filename = LiveDB.USRDIR + "filetabledatafilemap" + "_de" + ".de";
              }
          }
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class IntranetCompliantRadioTaggedCollar extends LiveDB implements Runnable {

    private boolean okay = true;
    private String filename = LiveDB.USRDIR + "LensViewDataEntry" + LiveDB.FILESEPERATOR +
                              "filetabledatafilemap" + "_de" + ".de";
    private short tableno = 0;
    private int fldcnt = 0;
    ProgressMonitor progressmonitor;
    int pm = 5;
    

    @Override
    public void run (){
          ThreadController.TakeOffTimes[1] = new Date ();
          LiveDB.LogFileSabotageCheck();
          short fs = 3; /* fs is field subscript in LiveDB.tablenameidentifier */
          short ti = 1; /* ti is the tablename identifer subscript in tablenameidentifier */
          final short tw = 2; /* array subscript 2 in LiveDB.tablenameidentifier is rows in table */
          long insize = 0L; /* IN size of data entry file on disk this will be reset later to actual
                             * size after serialization since the file size will change slightly
                             * after serialization.
                             */
          File df = null; /* data entry file */
          boolean em = false;
          
          LiveDB.LogFileSabotageCheck ();

          // Quick check if opening install file exists on disk
          if (LiveDB.command_line.equals("FileTableDataFileMap") ||
                  LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") )
          {
              if (new File(filename).exists() == false)
              {
                  if (new File(LiveDB.USRDIR +
                              "filetabledatafilemap" + "_de" + ".de").exists() == false)
                  {
                      if (new File(LiveDB.USRHOMEDIR +
                              "filetabledatafilemap" + "_de" + ".de").exists() == false)
                      {
                          JOptionPane.showMessageDialog(appframe, "Please manually copy oon O/S"
                                  + '\n' + "filetabledatafilemap" + "_de" + ".de" + " TO" + '\n'
                                  + LiveDB.USRHOMEDIR + " and restart Installation");
                          System.exit(1);
                      }
                      else filename = LiveDB.USRHOMEDIR + "filetabledatafilemap" + "_de" + ".de";
                  }
                  else filename = LiveDB.USRDIR + "filetabledatafilemap" + "_de" + ".de";
              }
          }

          // LOAD table zero first irrespective of the command line
          if ((okay = get_DataEntryFile(tableno)) == true)
          {
              progressmonitor = new ProgressMonitor(appframe, "Loading Data from Character Files",
                  "Loading " + LiveDB.tablenameidentifier[tableno][ti], 0, 100);
             /* set number of rows for each table from LiveSharedDB for tableno */
              LiveDB.tablenameidentifier[tableno][tw] =
                           Integer.toString(LiveDB.LiveSharedDB[tableno].length);

              if (LiveDB.REALTABLES != LiveDB.LiveSharedDB[tableno].length -1)
              {
                  System.err.println(LiveDB.grassHopper(filename + " Incorrect number of tables"));                                                   
                  System.exit(1);
              }

              for (int rw = 0, tn = 0, ptn = -1; rw < LiveDB.LiveSharedDB[tableno].length; rw++)
              {
                   tn = (int)((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getTableno();
                   if ((tn != 0 && rw == 0) || tn != (ptn + 1))
                   {
                       System.err.println(LiveDB.grassHopper(filename + " Incorrect table numbering"));
                       okay = false;
                   }
                   ptn = tn;
              }

              /* Now insert a row into InstalledTables for each table no */
              /* InstalledTables (long p_Tableno, Date p_Accesstime,
               * Date p_Modifiedtime, long p_Initialsize,long p_Rowid )
               * Accesstime is the last read time
               * ModifiedTime is the last write time
               * Leave ModifiedTime null if there is no write
               * BUT where there is a new Install of the database fill install time also
               */
               if (LiveDB.command_line.equals("FileTableDataFileMap"))
               {
                   df = new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getDatafilename());
                   insize = df.length();
                   LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
                   new InstalledTables(tableno,new Date(),null,new Date(),
                                Locale.getDefault().getDisplayName(),
                                Locale.getDefault().getISO3Language(),
                                insize,
                                LiveDB.LiveSharedDB[it].length);
                   /* Update Change Tracker Table by inserting a new row there */
                   /* ChangeTracker (long p_Tableno, long p_Rowid, char p_Change_flag) */
                   LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                   new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'U', LiveDB.pid, new Date(),
                   LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
                   (long)LiveDB.LiveSharedDB[ct].length);
                }
          }
          else
          {
              System.err.println(LiveDB.grassHopper(filename + " failed Load"));
              System.exit(1);
          }

          // check if command_line equals "FiXdAtAcOrRuPtIoN" if so call REVOKE_EMERGENCY
          // but before that check if DECLARE_EMERGENCY was actually called


          for (int rw = 0; rw < LiveDB.LiveSharedDB[ft].length; rw++)
          {     
              if (em == true && ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][rw]).
                      getTable_lock().equals("E") == false)
              // previously true but now false this table has been corrupted
              // maybe others also possible intruder
              {
                  LiveDB.ALRTLVL = 4;
                  System.err.println(LiveDB.grassHopper("FileTableDataFileMap Corrupted"));
		  JOptionPane.showMessageDialog(appframe, "INTRUDER ALERT FILE CORRUPTION TO"
                          + '\n' + "CRITICAL TABLE FileTableDataFileMap"
                          + '\n' + "DECLARING EMERGENCY AGAIN" + '\n');
                  Spy.dump();
                  LiveDB.DECLARE_EMERGENCY();
		  JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                  System.exit(1);
              }
              else if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][rw]).getTable_lock().equals("E"))
                  em = true;
          } // for (int rw = 0; rw < LiveDB.LiveSharedDB[ft].length; rw++)
          
          
          if (em) // emergency had been declared
          {
              if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
                  LiveDB.REVOKE_EMERGENCY();
          }

          // first load table zero this must be present even if command_line equals "FiXdAtAcOrRuPtIoN"
          // as a datafile in path and filename specified in the filetabledatafile.txt at Install time.
          if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
              filename = ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][0]).getDatafilename();



          // start loading from reverse table number 16 because I am nullifying LiveDB.LiveSharedDB[tableno]
          // in method get_DataEntryFile (int tableno) when LiveDB.command_line equals "FiXdAtAcOrRuPtIoN"
          
          for (tableno = LiveDB.REALTABLES, okay = true; tableno >= 1 && okay ; tableno--,
                               progressmonitor.setProgress(pm + 5),
                               progressmonitor.setNote("Loading " + LiveDB.tablenameidentifier[tableno][ti]))
          {
                if (progressmonitor.isCanceled())
                {
                    System.err.println(LiveDB.grassHopper("Data EntryFile " + filename
                                                                    + " load cancelled by user"));                    
                    JOptionPane.showMessageDialog(appframe, "User Cancelled Data Load Operation");
                    System.exit(1);
                }

                /* These tableno 1,2,3,13,14,15 dont have a data entry file to load at Install time */
                /* But if you invoke the InstallDB program with param "FiXdAtAcOrRuPtIoN" then it attempts
                 * to reload data from dump files that have been corrected and copied to correct filenames
                 * for reload. These dump files are for tables 1,2,3,14,15.
                 */
                if ( tableno != crr )
                {
                    /* get the next datafilename */
                    filename = (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).getDatafilename());
                    fldcnt = Integer.parseInt(LiveDB.tablenameidentifier[tableno][fs]);
                    if ((okay = get_DataEntryFile(tableno)) == true)
                    {
                        /* set number of rows for each table from LiveSharedDB for tableno */
                        LiveDB.tablenameidentifier[tableno][tw] =
                                          Integer.toString(LiveDB.LiveSharedDB[tableno].length);
                        df = new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tableno]).
                                getDatafilename());
                        insize = df.length();
                        /* Now insert a row into InstalledTables for each table no */
                        /* InstalledTables (long p_Tableno, Date p_Accesstime,
                         * Date p_Modifiedtime, long p_Initialsize,long p_Rowid )
                         *
                         * Accesstime is the last read time
                         * ModifiedTime is the last write time
                         * Leave ModifiedTime null if there is no write
                         * BUT where there is a new Install of the database fill install time also
                         */
                         if (LiveDB.command_line.equals("FileTableDataFileMap"))
                         {
                                LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
                                new InstalledTables(tableno,new Date(),null,new Date(),
                                Locale.getDefault().getDisplayName(),
                                Locale.getDefault().getISO3Language(),
                                insize,
                                LiveDB.LiveSharedDB[it].length);
                                /* Update Change Tracker Table by inserting a new row there */
                                /* ChangeTracker (long p_Tableno, long p_Rowid, char p_Change_flag) */
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'U', LiveDB.pid, new Date(),
                                LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
                                (long)LiveDB.LiveSharedDB[ct].length);
                         }
                    } // if ((okay = get_DataEntryFile(tableno)) == true)
                } /* if ( tableno != crr ) */                
          } // for (tableno = LiveDB.REALTABLES; tableno >= 0 && okay ; tableno--)

          LiveDB.databaseloading = 0; // database is not loading
          progressmonitor.close();
          
          if (okay == false)
          {
              if (progressmonitor.isCanceled())
              {
                  System.err.println(LiveDB.grassHopper("Data EntryFile " + filename + " load cancelled by user"));
                  JOptionPane.showMessageDialog(appframe, "User Cancelled Data Load Operation");
                  System.exit(1);
              }
              else
              {
                  System.err.println(LiveDB.grassHopper("Data EntryFile " + filename + " is missing/corrupted/empty"));
		  JOptionPane.showMessageDialog( appframe,"A data entry file " + filename + " is missing/corrupted/empty for Loading" + "\n");
		  JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                  System.exit(1);
              }
          }

          boolean retval = true;
          // all loaded now set the perms for these DataEntryFiles to ReadOnly so they cant be deleted at o/s
          for (int rw = 0; rw < LiveDB.LiveSharedDB[ft].length; rw++)
          {
              df = new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][rw]).getDatafilename());
              retval = df.setReadOnly();
              if (retval == false)
                  System.err.println(LiveDB.grassHopper("Could not set ReadOnly perms on data file "
                          + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][rw]).getDatafilename()));
          }
           
          LiveDB.LogFileSabotageCheck ();
          LiveDB.system_exit = 1;
          LiveDB.SmoothExitCondition.signalAll();
          ThreadController.LandingTimes[1] = new Date ();
    } /* end : public void run () */

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:LanguageSupport.java
 * @LOOKSY:LanguageTitles.java
 * @LOOKSY:LanguageTransalations.java
 * @LOOKSY:PaymentType.java
 * @LOOKSY:PictureDatabase.java
 * @LOOKSY:PictureOptions.java
 * @LOOKSY:SearchDatabase.java
 * @LOOKSY:DefaultAdvertisingImages.java
 * @LOOKSY:ArtLeaves.java
 * @LOOKSY:CrashRecovery.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:ReportsTables.java
 * @LOOKSY:CelebrityTable.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:Spy.java -- method dump()
 * @LOOKSY:LiveDB.LiveSharedDB,LiveDB.tablenameidentifier,LiveDB.Action,LiveDB.databaseloading,LiveDB.CTSR
 * @LOOKSY:LiveDB.LiveDB.TrainsInWaiting, LiveDB.command_line, LiveDB.pid, LiveDB.CABINGATEC
 *
 * Method Name : protected final boolean get_DataEntryFile (int tableno)
 * Parameters : int tableno
 * Returns : boolean true if data loaded from character files successfully
 *           boolean false if data did not load from character files successfully due whatever reasons
 *
 * Associated Methods : LiveDB::protected Object createValidInstance (StringBuffer parsedinst, int p_tbl)
 *                LiveDB::protected void ParseThisRow(String p_rowdata, StringBuffer [] p_stuff, char p_char)
 *                LiveDB::protected static boolean DeQueueTrainsInWaitingRunning ()
 *                LiveDB::protected static boolean DeQueueTrainsInWaiting ()
 *
 * Data File : YES Data present at Install time specified by filename filetabledatafile.txt in local directory
 * from which you install the program with command line $InstallDB FileTableDataFileMap. Without dataentry
 * file for this table the application cannot install. It is mandatory to specify data for Critical table zero
 * in file filetabledatafile.txt at Install time. It looks for this file only. A readymade data entry file will
 * be provided to you which you need to customize specific to your installation. dont loose it take a physical
 * backup and keep it safe some place. Also dump files created by Spy.dump() corrected and copied to correct
 * path and filename for each table number as specified in filetabledatafile.txt. Also when you are reloading
 * data with command_line equals "FiXdAtAcOrRuPtIoN" the file filetabledatafile.txt must me in path/datafilename
 * specified inside that file corresponding to table zero.
 *
 * @Since Version : 1.0
 *
 * Running Commentary : It loads data from character files into the database. It loads data from character
 * files on many occasions. First when you are Installing application LensView and zero or more occasions
 * when the application encounters a serious issue with data corruption. At such times the application
 * does a Spy.dump() and also declares a system emergency using LiveDB.DECLARE_EMERGENCY(); So what the
 * method does is to differentiate between a Install time load of data files with LiveDB.command_line
 * equals "FileTableDataFileMap" and a later reload of data files (after correction of corrupted data)
 * using LiveDB.command_line equals "FiXdAtAcOrRuPtIoN".It starts with Queuing request with Action.READLINE.
 * Then it reads each line from the data entry file and splits into fields using LiveDB.fieldseperator. Having
 * done this it switches (tableno) and calls the appropriate constructors for each table. Now table ct is a
 * problem table because this ChangeTracker table will contain an EntireRow. This table ct is loaded only
 * when LiveDB.command_line equals "FiXdAtAcOrRuPtIoN". Basically this ChangeTracker table row will contain
 * an instance of EntireRow which is an instance of the impacted table fld[0]. And that EntireRow in turn
 * will/may contain another EntireRow and so on ... You get the headache. So fld[5] contains EntireRow which
 * is a backup of row of table on which some DML was done. So call ParseThisRow(fld[5], parsedRow, '%') to
 * split this EntireRow into its component fields and then call that constructor. BUT where EntireRow is
 * a ct again it is a major pain in the ass which is cured by calling createValidInstance().
 *
 * Technical Reference : In simple terms it loads Stanley ka Dubba
 *
 * Start Date: 18th October 2010
 * End Date: 17th May 2011
 *
 * Last Modified Date : 28th July 2011
 * Last Modifications : checking progressmonitor.isCanceled() to indicate user cancelled operation. If so
 * return false from this method.
 * 
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected final boolean get_DataEntryFile (int tableno){
        String [] fld = null; // maximum 64 fields supported in all releases of this software
        Object ADHOCKLOCK = new Object ();
        String Row; /* A single row of data */
        FileReader fr;
        BufferedReader br = null;
        File filenam = new File (filename);
        SimpleDateFormat sdf = new SimpleDateFormat();
        Date ld1 = null, ld2 = null, ld3 = null, ld4 = null, ld5 = null; // loaddate for loading date from character files
        Object LO = null; // Object to load into ChangeTracker table
        boolean ok = true;
        
        int requestno = (new Random ()).nextInt();
        TrainRunningInformation myrunninginfo = new TrainRunningInformation (tableno, Thread.currentThread().getId(), Thread.currentThread().getName(),
                Thread.currentThread().getThreadGroup().getName(), null, null, null, 0L);
        PlatformClearance mytrain = new PlatformClearance ( requestno, LiveDB.pid, Action.READLINE, new Date (), myrunninginfo,
                LiveDB.LiveSharedDB[pc].length);
        StringBuffer parsedRow [] = null;
        StringBuffer parsedVals [] = null;
        String Vals [] = null;
        TrainRunningInformation tid = null ;
        int j = -1, i = 0, ii = 0, cn = 0; /* cn counts commas (,) LiveDB.fieldseperator in a string */
        int rs = 0; /* row subscript for reference into LiveDB.LiveSharedDB[tableno][rs] */
        final int erfno = 6; // EntireRow field number
        
        if (filenam.length() == 0)
            return false;

        if (LiveDB.AllUsersKickedOut() == false)
            return false;

        if (pm == 85)
            progressmonitor.setNote("Almost Done");

        LiveDB.databaseloading = 1; // Database data entry files are starting/in process of loading.
      
        try {
            fr = new FileReader (filenam);
            br = new BufferedReader(fr);
        }catch (FileNotFoundException ex_NOKIA3){
              LiveDB.databaseloading = 0; /* database is not loading any more */
              System.err.println(LiveDB.grassHopper(ex_NOKIA3));
	      JOptionPane.showMessageDialog(appframe, "Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
	      JOptionPane.showMessageDialog(appframe, "A data entry file " + filename + " is missing for Loading" + "\n");
              return false;
        }

        /* Check the local queue first then queue your request number or goahead if queue is empty */
        if (LiveDB.TrainsInWaiting.isEmpty() == false)
         /* NOT EMPTY Then queue your request also and keep waiting */
           yellingatstationmaster:
           while (LiveDB.TrainsInWaiting.size() > LiveDB.MAXPLATFORMENTRIES)
           {
               System.err.println(LiveDB.grassHopper("Failed platform clearance method get_DataEntryFile " + Integer.toString(tableno)));
               if (progressmonitor.isCanceled())
                   return false;
               continue yellingatstationmaster; 
           }

        // starting to load data so nullify just that table number in LiveSharedDB
        if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
            LiveDB.LiveSharedDB[tableno] = null;

        do
        {
           if (progressmonitor.isCanceled())
               return false;

           /* queue your request also (discipline) but you have permission
            * to proceed immediately FlyingScottsMan if isEmpty == true
            */
            LiveDB.CABINGATEC.acquireUninterruptibly();
            do{
              ((PlatformClearance)mytrain).setRequestno(requestno = (new Random ()).nextInt());
              ok = LiveDB.TrainsInWaiting.offer (mytrain) ;
            }while (ok == false); /* be disciplined add your request to the queue and wait your turn */

            topeep:  /* chutiya ki sarkari naukri hai keep peeping */
            while ((LiveDB.TrainsInWaiting.peek()).getRequestno() != requestno)
                   continue topeep;
            LiveDB.CABINGATEC.release();

            synchronized(ADHOCKLOCK){
            LiveDB.TrainsInWaiting.peek().getTrainid().setDeparturetime (new Date ());
            }
            
            try {
                if ((Row = br.readLine()) != null)
                {
                    // discover time taken to read each line but use LiveDB.DeQueueTrainsInWaitingRunning()
                    // at the bottom now that wont set the arrival time just running time.
                    // I hope it clears this ADHOCLOCK Object in some way before re-use ?? check during test
                    synchronized(ADHOCKLOCK){
                    LiveDB.TrainsInWaiting.peek().getTrainid().setArrivaltime(new Date ());
                    }
                     
                     // this is LiveDB.fieldseperator seperated data parse this string and plug it into fld []
                     while ((j = Row.indexOf(LiveDB.fieldseperator, j+1)) != -1)
                     {
                            if (i == j)
                            {
                                fld[ii] = "".toString(); // this  toString will return a final
                                LiveDB.ALRTLVL = 15;
                                System.err.println(LiveDB.grassHopper("Null Value in Date Entry File:"
                                        + filenam));
                                if (tableno != LiveDB.ar)
                                   System.exit(1);
                            }
                            else
                                fld [ii] = Row.substring (i, j).toString();
                            i = j + 1;
                            cn++;
                            ii++;
                            if (progressmonitor.isCanceled())
                                return false;
                     }
                     
                     if (cn > 0)
                     {
                     if (cn == (fldcnt -1)) // the rowid field is not counted in cn so -1
                     {
                         switch (tableno) { 
                             case ft:
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                 new FileTableDataFileMap(Integer.parseInt(fld[0]),
                                                              fld[1],fld[2],fld[3],fld[4],fld[5],rs);
                                 // insert an entry in ChangeTracker table for this table
                                 LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                 new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                 LiveDB.pid, new Date (),
                                 LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                 (long)LiveDB.LiveSharedDB[ct].length);
                                 rs++;
                                 break;
                             case ct: // ChangeTracker table we are reloading from dump files here  
                                if (progressmonitor.isCanceled())
                                    return false;
                                if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
                                {
                                    try{
                                        ld1 = sdf.parse(fld[5]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception File " + filename));
			                JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }

                                 
                                 // check the table number here for typecasting the entirerow Object
                                 ParseThisRow(fld[erfno], parsedRow, '%');
                                 switch ((int)Long.parseLong(fld[0])){
                                     case ft: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         // call the appropriate constructor

                                         LO =  new FileTableDataFileMap(Integer.parseInt(parsedRow[0].toString().trim()),
                                         parsedRow[1].toString().trim(),parsedRow[2].toString().trim(),
                                         parsedRow[3].toString().trim(),parsedRow[4].toString().trim(),
                                         parsedRow[5].toString().trim(),Long.parseLong(parsedRow[6].toString().trim()));
                                         break;
                                     case ct: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         // CHECK DURING BETA TESTING
                                         LO = new ChangeTracker(Long.parseLong(parsedRow[0].toString().trim()),
                                         Long.parseLong(parsedRow[1].toString().trim()),
                                         (parsedRow[2].toString().trim().toCharArray())[0],
                                         Long.parseLong(parsedRow[3].toString().trim()),
                                         new Date(Long.parseLong(parsedRow[4].toString().trim())),
                                         // it has to be a ChangeTracker row because fld[0] == ct
                                         createValidInstance(parsedRow[erfno],ct, '#'),
                                         Long.parseLong(parsedRow[7].toString().trim()));
                                         break;

                                     case cr: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         LO = new CustomerRegister(parsedRow[0].toString().trim(),
                                         parsedRow[1].toString().trim(),
                                         new Date(Long.parseLong(parsedRow[2].toString().trim())),
                                         parsedRow[3].toString().trim(),
                                         parsedRow[4].toString().trim(), parsedRow[5].toString().trim(),
                                         (parsedRow[6].toString().toCharArray())[0],
                                         parsedRow[7].toString().trim(),
                                         new Date(Long.parseLong(parsedRow[8].toString().trim())),
                                         new Date(Long.parseLong(parsedRow[9].toString().trim())),
                                         new Date(Long.parseLong(parsedRow[10].toString().trim())),
                                         parsedRow[11].toString().trim(),
                                         parsedRow[12].toString().trim(),
                                         parsedRow[13].toString().trim(),
                                         parsedRow[14].toString().trim(),
                                         parsedRow[15].toString().trim(),
                                         parsedRow[16].toString().trim(),
                                         parsedRow[17].toString().trim(),
                                         parsedRow[18].toString().trim(),
                                         parsedRow[19].toString().trim(),
                                         parsedRow[20].toString().trim(),
                                         parsedRow[21].toString().trim(),
                                         (parsedRow[22].toString().toCharArray())[0],
                                         new Date(Long.parseLong(parsedRow[23].toString().trim())),
                                         Long.parseLong(parsedRow[24].toString().trim()));
                                         break;

                                     case id:
                                         if (progressmonitor.isCanceled())
                                            return false;

                                        try{
                                        ld1 = sdf.parse(parsedRow[1].toString().trim());
                                        }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception File " + filename));
			                JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                        }

                                        try{
                                        ld2 = sdf.parse(parsedRow[2].toString().trim());
                                        }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception File " + filename));
			                JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                        }

                                        try{
                                        ld3 = sdf.parse(parsedRow[6].toString().trim());
                                        }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception File " + filename));
			                JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                        }
                                        LO = new InstallerDues (parsedRow[0].toString().trim(),
                                                 ld1,ld2,
                                                 Float.parseFloat(parsedRow[3].toString().trim()),
                                                 Byte.parseByte(parsedRow[4].toString().trim()),
                                                 Byte.parseByte(parsedRow[5].toString().trim()),
                                                 ld3,
                                                 Short.parseShort(parsedRow[7].toString().trim()),
                                                 Long.parseLong(parsedRow[8].toString().trim()));
                                         break;
                                     case ls: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         LO = new LanguageSupport(Integer.parseInt(parsedRow[0].toString().trim()),
                                         parsedRow[1].toString().trim(),
                                         Long.parseLong(parsedRow[2].toString().trim()));
                                         break;
                                     case lt: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         LO = new LanguageTitles(parsedRow[0].toString().trim(),
                                         parsedRow[1].toString().trim(),
                                         parsedRow[2].toString().trim(),
                                         Long.parseLong(parsedRow[3].toString().trim()));
                                         break;

                                     case cp:
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         LO = new CustomerPayments (parsedRow[0].toString().trim(),
                                                 Float.parseFloat(parsedRow[1].toString().trim()),
                                                 Byte.parseByte(parsedRow[2].toString().trim()),
                                                 Byte.parseByte(parsedRow[4].toString().trim()),
                                                 Long.parseLong(parsedRow[5].toString().trim()));
                                         break;
                                     case pt: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         LO = new PaymentType(Integer.parseInt(parsedRow[0].toString().trim()),
                                         parsedRow[1].toString().trim(),
                                         Long.parseLong(parsedRow[2].toString().trim()));
                                         break;
                                     case ni:
                                         if (progressmonitor.isCanceled())
                                            return false;
                                         LO = new NodalInfo (Short.parseShort(parsedRow[0].toString().trim()),
                                                 Short.parseShort(parsedRow[1].toString().trim()),
                                                 parsedRow[2].toString().trim(),parsedRow[3].toString().trim(),
                                                 parsedRow[4].toString().trim(),
                                                 createValidWildLifeTypes (parsedRow[5]),
                                                 parsedRow[6].toString().trim(),
                                                 parsedRow[7].toString().trim(),parsedRow[8].toString().trim(),
                                                 parsedRow[9].toString().trim(),parsedRow[10].toString().trim(),
                                                 parsedRow[11].toString().trim(),parsedRow[12].toString().trim(),
                                                 parsedRow[13].toString().trim(),parsedRow[14].toString().trim(),
                                                 parsedRow[15].toString().trim(),parsedRow[16].toString().trim(),
                                                 parsedRow[17].toString().trim(),parsedRow[18].toString().trim(),
                                                 parsedRow[19].toString().trim(),parsedRow[20].toString().trim(),
                                                 parsedRow[21].toString().trim(),parsedRow[22].toString().trim(),
                                                 parsedRow[23].toString().trim(),parsedRow[24].toString().trim(),
                                                 parsedRow[25].toString().trim(),parsedRow[26].toString().trim(),
                                                 parsedRow[27].toString().trim(),parsedRow[28].toString().trim(),
                                                 parsedRow[29].toString().trim(),parsedRow[30].toString().trim(),
                                                 parsedRow[31].toString().trim(),parsedRow[32].toString().trim(),
                                                 parsedRow[33].toString().trim(),parsedRow[34].toString().trim(),
                                                 parsedRow[35].toString().trim(),parsedRow[36].toString().trim(),
                                                 parsedRow[37].toString().trim(),parsedRow[38].toString().trim(),
                                                 parsedRow[39].toString().trim(),parsedRow[40].toString().trim(),
                                                 parsedRow[41].toString().trim(),parsedRow[42].toString().trim(),
                                                 parsedRow[43].toString().trim(),parsedRow[44].toString().trim(),
                                                 parsedRow[45].toString().trim(),parsedRow[46].toString().trim(),
                                                 parsedRow[47].toString().trim(),parsedRow[48].toString().trim(),
                                                 parsedRow[49].toString().trim(),
                                                 Long.parseLong(parsedRow[51].toString().trim()));
                                                 
                                         break;

                                     case sd: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         LO = new SearchDatabase(parsedRow[0].toString().trim(),
                                         parsedRow[1].toString().trim(),
                                         Long.parseLong(parsedRow[2].toString().trim()));
                                         break;
                                     case da: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         LO = new DefaultAdvertisingImages(parsedRow[0].toString().trim(),
                                         parsedRow[1].toString().trim(),
                                         parsedRow[2].toString().trim(),
                                         Integer.parseInt(parsedRow[3].toString().trim()),
                                         Integer.parseInt(parsedRow[4].toString().trim()),
                                         Integer.parseInt(parsedRow[5].toString().trim()),
                                         parsedRow[6].toString().trim(),
                                         Integer.parseInt(parsedRow[7].toString().trim()),
                                         parsedRow[8].toString().trim(),
                                         Long.parseLong(parsedRow[9].toString().trim()));
                                         break;
                                     case ar: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         LO = new ArtLeaves ( parsedRow[0].toString().trim(),
                                         parsedRow[1].toString().trim(),
                                         parsedRow[2].toString().trim(),
                                         parsedRow[3].toString().trim(),
                                         parsedRow[4].toString().trim(),
                                         parsedRow[5].toString().trim(),
                                         parsedRow[6].toString().trim(),
                                         parsedRow[7].toString().trim(),
                                         parsedRow[8].toString().trim(),
                                         parsedRow[9].toString().trim(),
                                         parsedRow[10].toString().trim(),
                                         parsedRow[11].toString().trim(),
                                         parsedRow[12].toString().trim(),
                                         parsedRow[13].toString().trim(),
                                         parsedRow[14].toString().trim(),
                                         parsedRow[15].toString().trim(),
                                         parsedRow[16].toString().trim(),
                                         parsedRow[17].toString().trim(),
                                         parsedRow[18].toString().trim(),
                                         parsedRow[19].toString().trim(),
                                         parsedRow[20].toString().trim(),
                                         parsedRow[21].toString().trim(),
                                         parsedRow[22].toString().trim(),
                                         parsedRow[23].toString().trim(),
                                         parsedRow[24].toString().trim(),
                                         parsedRow[25].toString().trim(),
                                         parsedRow[26].toString().trim(),
                                         parsedRow[27].toString().trim(),
                                         Long.parseLong(parsedRow[28].toString().trim()));
                                         break;
                                     case crr: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         ParseThisRow(parsedRow[3].toString().trim(), parsedVals, '#');
                                         for (int k = 0; k < parsedVals.length; k++)
                                             Vals[k] = parsedVals[k].toString();
                                         LO = new CrashRecovery (Long.parseLong(parsedRow[0].toString().trim()),
                                         Long.parseLong(parsedRow[1].toString().trim()),
                                         Long.parseLong(parsedRow[2].toString().trim()),
                                         Vals);
                                         break;
                                     case it: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         LO = new InstalledTables(Long.parseLong(parsedRow[0].toString().trim()),
                                         new Date(Long.parseLong(parsedRow[1].toString().trim())),
                                         new Date(Long.parseLong(parsedRow[2].toString().trim())),
                                         new Date(Long.parseLong(parsedRow[3].toString().trim())),
                                         parsedRow[4].toString().trim(),
                                         parsedRow[5].toString().trim(),
                                         Long.parseLong(parsedRow[6].toString().trim()),
                                         Long.parseLong(parsedRow[7].toString().trim()));
                                         break;
                                     case rt: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         LO = new ReportsTable (Long.parseLong(parsedRow[0].toString().trim()),
                                         Long.parseLong(parsedRow[1].toString().trim()),
                                         parsedRow[2].toString().trim(),
                                         parsedRow[3].toString().trim(),
                                         Long.parseLong(parsedRow[4].toString().trim()),
                                         new Date(Long.parseLong(parsedRow[5].toString().trim())),
                                         (parsedRow[6].toString().toCharArray())[0],
                                         Long.parseLong(parsedRow[7].toString().trim()),
                                         Long.parseLong(parsedRow[8].toString().trim()),
                                         Long.parseLong(parsedRow[9].toString().trim()));
                                         break;
                                     case ll:
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         LO = new LatLongMap (Short.parseShort(parsedRow[0].toString().trim()),
                                                 Short.parseShort(parsedRow[1].toString().trim()),
                                                 Short.parseShort(parsedRow[2].toString().trim()),
                                                 Short.parseShort(parsedRow[3].toString().trim()),
                                                 Long.parseLong(parsedRow[4].toString().trim()));
                                         break;
                                     case pc: // Hey dont confuse Switching ChangTracker EntireRow here
                                         if (progressmonitor.isCanceled())
                                             return false;
                                         LiveDB.Action act = null;
                                         switch(Integer.parseInt(parsedRow[2].toString().trim())){
                                             case 0:
                                                 act = LiveDB.Action.READFILES;
                                                 break;
                                             case 1:
                                                 act = LiveDB.Action.WRITEFILES;
                                                 break;
                                             case 2:
                                                 act = LiveDB.Action.READLINE;
                                                 break;
                                             case 3:
                                                 act = LiveDB.Action.WRITELINE;
                                                 break;
                                             case 4:
                                                 act = LiveDB.Action.READOBJECT;
                                                 break;
                                             case 5:
                                                 act = LiveDB.Action.WRITEOBJECT;
                                                 break;
                                             case 6:
                                                 act = LiveDB.Action.FASTCOMMIT;
                                                 break;
                                             case 7:
                                                 act = LiveDB.Action.OTHERS;
                                                 break;
                                             case 8:
                                                 act = LiveDB.Action.REPORTWRITER;
                                                 break;
                                             default:
                                                 act = LiveDB.Action.OTHERS;
                                                 LiveDB.ALRTLVL = 15;
                                                 System.err.println(LiveDB.grassHopper("Invalid Action ordinal : FiXdAtAcOrRuPtIoN "
                                                         + String.valueOf(Integer.parseInt(parsedRow[2].toString().trim()))));
                                                 break;
                                         }
                                         ParseThisRow(parsedRow[4].toString().trim(), parsedVals, '#');
                                         tid = new TrainRunningInformation (Integer.parseInt(parsedVals[0].toString().trim()),
                                         Long.parseLong(parsedVals[1].toString().trim()),
                                         parsedVals[2].toString().trim(),
                                         parsedVals[3].toString().trim(),
                                         new Date(Long.parseLong(parsedVals[4].toString().trim())),
                                         new Date(Long.parseLong(parsedVals[5].toString().trim())),
                                         new Date(Long.parseLong(parsedVals[6].toString().trim())),
                                         Long.parseLong(parsedVals[7].toString().trim()));

                                         LO = new PlatformClearance (Integer.parseInt(parsedRow[0].toString().trim()),
                                         Long.parseLong(parsedRow[1].toString().trim()),
                                         act,
                                         new Date(Long.parseLong(parsedRow[3].toString().trim())),
                                         tid,
                                         Long.parseLong(parsedRow[5].toString().trim()));
                                         break;
                                     default:
                                        System.err.println(LiveDB.grassHopper("case default:"));
                                        break;
                                 }

                                 // CHECK THIS DURING BETA TESTING
                                 LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                 new ChangeTracker(Long.parseLong(fld[0]),Long.parseLong(fld[1]),
                                     (fld[2].toCharArray())[0],Long.parseLong(fld[3]),ld1,LO,rs);
                                     
                                // insert an entry in ChangeTracker table for this table
                                // this may seem a double entry but indicates that the ChangeTracker table itself
                                // was reloaded after a data corruption. We may need this for re-constructing the
                                // database to a consistent state. This could also create a logical Bug during testing
                                // so watch out.
                                 LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                 new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                 LiveDB.pid, new Date (),
                                 LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                 (long)LiveDB.LiveSharedDB[ct].length);
                                 rs++;
                                }
                                LiveDB.CTSR = LiveDB.LiveSharedDB[ct].length;
                                break;
                             case cr: // customer register we are reloading from dump files here
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN") ||
                                     LiveDB.command_line.equals("FileTableDataFileMap"))
                                 {
                                    try{
                                        ld1 = sdf.parse(fld[2]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    try{
                                        ld2 = sdf.parse(fld[8]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    try{
                                        ld3 = sdf.parse(fld[9]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    try{
                                        ld4 = sdf.parse(fld[10]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    try{
                                        ld5 = sdf.parse(fld[23]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }

                                  LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                  new CustomerRegister(fld[0],fld[1], ld1, fld[3],fld[4],fld[5],
                                      (fld[6].toCharArray())[0],fld[7],ld2,ld3,ld4,fld[11],fld[12],fld[13],
                                      fld[14],fld[15],fld[16],fld[17],fld[18],fld[19],fld[20],fld[21],
                                      (fld[22].toCharArray())[0],ld5,rs);
                                      
                                  // insert an entry in ChangeTracker table for this table
                                  LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                  new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                  LiveDB.pid, new Date (),
                                  LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                  (long)LiveDB.LiveSharedDB[ct].length);
                                  rs++;
                                 }
                                 LiveDB.CRSR = LiveDB.LiveSharedDB[cr].length;

                                 break;
                             case id:
                                if (progressmonitor.isCanceled())
                                    return false;

                                if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
                                {
                                    try{
                                        ld1 = sdf.parse(fld[1]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }

                                    try{
                                        ld1 = sdf.parse(fld[2]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }

                                    try{
                                        ld3 = sdf.parse(fld[6]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    
                                   LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                   new InstallerDues (fld[0], ld1,
                                           ld2, Float.parseFloat(fld[3]),Byte.parseByte(fld[4]),
                                           Byte.parseByte(fld[5]), ld3,Short.parseShort(fld[7]) ,rs);
                                   // insert an entry in ChangeTracker table for this table
                                   // this may seem a double entry but indicates that ChangeTracker table itself
                                   // was reloaded after a data corruption. We may need this for re-constructing the
                                   // database to a consistent state. This could also create a logical Bug during testing
                                   // so watch out.

                                   LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                      new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                          LiveDB.pid, new Date (),
                                          LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                          (long)LiveDB.LiveSharedDB[ct].length);
                                   rs++;
                                }
                                break;
                             case ls:           
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FileTableDataFileMap"))
                                 {
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                                 new LanguageSupport(Integer.parseInt(fld[0]),fld[1],rs);
                                     // insert an entry in ChangeTracker table for this table
                                     LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                     new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                     LiveDB.pid, new Date (),
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                     (long)LiveDB.LiveSharedDB[ct].length);
                                     rs++;
                                 }
                                 break;
                             case lt:
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FileTableDataFileMap"))
                                 {
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                     new LanguageTitles(fld[0],fld[1], fld[2], Long.parseLong(fld[3]));
                                     // insert an entry in ChangeTracker table for this table
                                     LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                     new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                     LiveDB.pid, new Date (),
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                     (long)LiveDB.LiveSharedDB[ct].length);
                                     rs++;
                                 }
                                 // This on the fly Language Transalations are cancelled because the
                                 // code points for one language may not match the other plus it will
                                 // be a garbled transalation like a Spanish city in ruins.
                                 // Hire a data entry operator to do cut and paste and create a data
                                 // entry file for language titles other than english for this table.
                                 break;
                             case cp:
                                if (progressmonitor.isCanceled())
                                    return false;

                                if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
                                {
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                     new CustomerPayments (fld[0], Float.parseFloat(fld[1]), Byte.parseByte(fld[2]),
                                             Byte.parseByte(fld[3]), Long.parseLong(fld[4]));
                                     // insert an entry in ChangeTracker table for this table
                                     LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                     new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                     LiveDB.pid, new Date (),
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                     (long)LiveDB.LiveSharedDB[ct].length);
                                     rs++;
                                }
                                 break;
                             case pt:
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FileTableDataFileMap"))
                                 {
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                                     new PaymentType(Integer.parseInt(fld[0]),fld[1],rs);
                                     // insert an entry in ChangeTracker table for this table
                                     LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                     new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                     LiveDB.pid, new Date (),
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                     (long)LiveDB.LiveSharedDB[ct].length);
                                     rs++;
                                 }                                 
                                 break;
                             
                             case sd:
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FileTableDataFileMap"))
                                 {
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                            new SearchDatabase(fld[0],fld[1],rs);
                                     // insert an entry in ChangeTracker table for this table
                                     LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                     new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                     LiveDB.pid, new Date (),
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                     (long)LiveDB.LiveSharedDB[ct].length);
                                     rs++;
                                 }
                                 break;
                             case da:
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FileTableDataFileMap"))
                                 {
                                    LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                    new DefaultAdvertisingImages(fld[0],fld[1],fld[2],Integer.parseInt(fld[3]),
                                         Integer.parseInt(fld[4]),Integer.parseInt(fld[5]),
                                         fld[6],Integer.parseInt(fld[7]), fld[8], rs);
                                    // insert an entry in ChangeTracker table for this table
                                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                      new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                      LiveDB.pid, new Date (),
                                      LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                      (long)LiveDB.LiveSharedDB[ct].length);
                                      rs++;
                                 }
                                 break;
                             case ar:
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FileTableDataFileMap"))
                                 {
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                     new ArtLeaves(fld[0],fld[1],fld[2],fld[3],fld[4],fld[5], fld[6],
                                         fld[7], fld[8], fld[9], fld[10], fld[11], fld[12], fld[13],
                                         fld[14], fld[15], fld[16], fld[17],fld[18], fld[19], fld[20],
                                         fld[21], fld[22], fld[23], fld[24], fld[25], fld[26], fld[27],rs);
                                     // insert an entry in ChangeTracker table for this table
                                     LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                     new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                     LiveDB.pid, new Date (),
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                     (long)LiveDB.LiveSharedDB[ct].length);
                                     rs++;
                                 }
                                 break;
                             case it: // we are reloading from dump files here
                                if (progressmonitor.isCanceled())
                                    return false;
                                if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN")
                                    || LiveDB.command_line.equals("FileTableDataFileMap"))
                                {
                                    try{
                                        ld1 = sdf.parse(fld[1]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    try{
                                        ld2 = sdf.parse(fld[2]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    try{
                                        ld3 = sdf.parse(fld[3]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }
                                    
                                    LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                       new InstalledTables(Long.parseLong(fld[0]),ld1,ld2,ld3,fld[4],fld[5],
                                           Long.parseLong(fld[6]),rs);

                                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                       new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                       LiveDB.pid, new Date (),
                                       LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                       (long)LiveDB.LiveSharedDB[ct].length);
                                       rs++;
                                }
                                break;
                             case rt: // we are reloading from dump files here
                                if (progressmonitor.isCanceled())
                                    return false;
                                if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN")
                                    || LiveDB.command_line.equals("FileTableDataFileMap"))
                                {
                                    try{
                                        ld1 = sdf.parse(fld[5]);
                                    }catch (ParseException ex_NOKIA33){
                                        System.err.println(LiveDB.grassHopper(ex_NOKIA33, "Date Parse Exception in File " + filename));
			                JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                                        return false;
                                    }

                                    LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                    new ReportsTable(Long.parseLong(fld[0]),
                                    Long.parseLong(fld[1]),fld[2],fld[3],Long.parseLong(fld[4]),
                                    ld1,fld[5].toCharArray()[0],
                                    Long.parseLong(fld[6]), Long.parseLong(fld[7]), rs);

                                    // insert an entry in ChangeTracker table for this table
                                    // this may seem a double entry but indicates that ChangeTracker table itself
                                    // was reloaded after a data corruption. We may need this for re-constructing the
                                    // database to a consistent state. This could also create a logical Bug during testing
                                    // so watch out.

                                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                    new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                    LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                    (long)LiveDB.LiveSharedDB[ct].length);
                                    rs++;
                                 }
                                 LiveDB.RTSR = LiveDB.LiveSharedDB[rt].length;
                                 break;
                             case ll:
                                if (progressmonitor.isCanceled())
                                    return false;

                                if (LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN")
                                    || LiveDB.command_line.equals("FileTableDataFileMap"))
                                {
                                   LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                   new LatLongMap (Short.parseShort(fld[0]), Short.parseShort(fld[1]),
                                           Short.parseShort(fld[2]), Short.parseShort(fld[3]), rs);
                                // insert an entry in ChangeTracker table for this table
                                // this may seem a double entry but indicates that ChangeTracker table itself
                                // was reloaded after a data corruption. We may need this for re-constructing the
                                // database to a consistent state. This could also create a logical Bug during testing
                                // so watch out.

                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                    LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                    (long)LiveDB.LiveSharedDB[ct].length);
                                 rs++;
                                 }
                                 break;
                             case ni: // Data Entry File for this table will be written as it were dump file
                                 if (progressmonitor.isCanceled())
                                     return false;
                                 if (LiveDB.command_line.equals("FileTableDataFileMap") ||
                                     LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
                                 {
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
                                     new NodalInfo (Short.parseShort(fld[0]),Short.parseShort(fld[1]),
                                                 fld[2],fld[3],fld[4],
                                                 createValidWildLifeTypes (new StringBuffer(fld[5])),
                                                 fld[6],fld[7],fld[8],fld[9],fld[10],fld[11],fld[12],
                                                 fld[13],fld[14],fld[15],fld[16],fld[17],fld[18],
                                                 fld[19],fld[20],fld[21],fld[22],fld[23],fld[24],
                                                 fld[25],fld[26],fld[27],fld[28],fld[29],fld[30],
                                                 fld[31],fld[32],fld[33],fld[34],fld[35],fld[36],
                                                 fld[37],fld[38],fld[39],fld[40],fld[41],fld[42],
                                                 fld[43],fld[44],fld[45],fld[46],fld[47],fld[48],
                                                 fld[49],Long.parseLong(fld[50]));

                                     // insert an entry in ChangeTracker table for this table
                                     LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                     new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
                                     LiveDB.pid, new Date (),
                                     LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1],
                                     (long)LiveDB.LiveSharedDB[ct].length);
                                     rs++;
                                 }
                             default:
                                 /* these tables dont have a data entry file at Install Time */
                                 break;
                         } /* switch (tableno) */
                     } /* if if ((cn + 1) == fldcnt) */
                     else
                     {
                         /* if cn + 1 != fldcnt in tablenameidentifier then there is a mismatch
                          * either the data entered in the data entry file is not correct or
                          * the fldcnt value is not correct. WE GO BY THE fldcnt value taken
                          * from tablenameidentifier in the source file as sacrosanct.
                          */
                          LiveDB.databaseloading = 0; /* database is not loading any more */
                          System.err.println(LiveDB.grassHopper("File:" + filename));
			  JOptionPane.showMessageDialog(appframe, "Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
			  JOptionPane.showMessageDialog(appframe, "A data entry file " + filename + " has wrong number of data fields" + "\n");
                          return false;
                     }
                     } // if (cn > 0)

                } /* if ((Row = br.readLine()) != null) */
                else LiveDB.TrainsInWaiting.peek().getTrainid().setArrivaltime (new Date ());

            }catch (IOException ex_NOKIA4) {
              if (LiveDB.DeQueueTrainsInWaiting() == false)
              {
                  LiveDB.ALRTLVL = 7; // programming screwup most probably
                  System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
              }
              LiveDB.databaseloading = 0; /* database is not loading any more */
              System.err.println(LiveDB.grassHopper("File:" + filename + " is not readable"));
	      JOptionPane.showMessageDialog(appframe, "Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
	      JOptionPane.showMessageDialog(appframe, "A data entry file " + filename + " is not readable" + "\n");
              return false;
            }

            if (LiveDB.DeQueueTrainsInWaitingRunning() == false)
            {
                LiveDB.ALRTLVL = 7; // programming screwup most probably
                System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaitingArrivals()"));
                // dont return false here look at the code of LiveDB.DeQueueTrainsInWaitingArrivals()
                // either it will be a no such element or remove returned a null in any case no point
                // returning false.
            }
        }while (Row != null);


        try
        {
           br.close ();
        }catch (IOException ex_NOKIA4) {
           LiveDB.databaseloading = 0; /* database is not loading any more */
           System.err.println(LiveDB.grassHopper(ex_NOKIA4));
	   JOptionPane.showMessageDialog(appframe, "Fatal Error Check Log File Name " + LiveDB.ErrorLogFile + "\n");
	   JOptionPane.showMessageDialog(appframe, "A data entry file " + filename + " is not closing after Loading" + "\n");
           return false;
        }


        return true ;

    } /* get_DataEntryFile () */

}

