/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Font;
import javax.swing.JLabel;
import java.util.Locale;
import javax.swing.JComboBox;
import java.awt.BorderLayout;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static DatabaseEngine.FirstPage.languagepanel;
import static DatabaseEngine.LiveDB.LanguageSelections;
import static DatabaseEngine.LiveDB.ls;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : LanguagePanel
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Language Panel at west corner
 * of screen. It provides a combo box to select currencies.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class LanguagePanel
{
    protected static String SelectedLanguage = "en";
    protected static JComboBox langcombo;
    String langstring [] = null;
    private JLabel label = new JLabel (langstring[langstring.length] = LiveDB.indxlanguageTitles.get(SelectedLanguage + "Languages")
            == null ? "Languages" : new String(langstring[langstring.length -1].toCharArray()));
    String langs [] = null;
    
    public LanguagePanel ()
    {
        int MF = 10;
        languagepanel = new JPanel (new BorderLayout());
        languagepanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        languagepanel.setBackground(Color.WHITE);
        languagepanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * MF),
                (int)(FirstPage.currencypanel.BOTTOM_ALIGNMENT * MF) + 1,
                (int)(FirstPage.currencypanel.RIGHT_ALIGNMENT * MF),
                (int)(FirstPage.currencypanel.BOTTOM_ALIGNMENT * MF)
                - (int)(FirstPage.currencypanel.TOP_ALIGNMENT * MF));
        
        addlanguagepanel();
    }
    
    void  addlanguagepanel()
    {
        int n = -1;
        

        while (LanguageSelections.indexOf(',') != -1)
        {
            if (n == LanguageSelections.length())
                break;            
            langs[langs.length] =
                new String (LanguageSelections.substring(n + 1,
                (n = LanguageSelections.indexOf(','))).toCharArray());
        }
        
        for (int i = 0 ; i < langs.length; i++)
             langs[i] = (new Locale(langs[i])).getDisplayLanguage();

        langcombo = new JComboBox (langs);
        langcombo.setForeground(Color.BLACK);
        langcombo.setSelectedItem(langs[0]);
        langcombo.addActionListener(new ActionListener(){
            @Override
            public void actionPerformed (ActionEvent evnt){
                String item = null;
                item = (String)langcombo.getSelectedItem();
                SelectedLanguage = LiveDB.indxLanguageIDs.get(item);
                FirstPage.chosenlang =  ((LanguageSupport)LiveDB.LiveSharedDB[ls]
                        [(int)(long)LiveDB.indxlanguageSupport.get(SelectedLanguage.trim())]).getLid() + " ".trim();
                // calling validate on each of those panels will not work at all
                // for a change in language so call call new FirstPage () What to do ?
                // unless i can figure out a faster way later
                new FirstPage ();
            }
        });

        label.setFont(new Font("Dialog",Font.BOLD, 8));
        label.setForeground(Color.BLACK);
        languagepanel.add(label, BorderLayout.NORTH);
        languagepanel.add(langcombo, BorderLayout.CENTER);
        label.validate();
        langcombo.validate();

    }
}
