/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.awt.Toolkit;
import java.io.Serializable;
import java.util.concurrent.Semaphore;

import static DatabaseEngine.LiveDB.ll;
/**
 *
 * @author SAI KRISHNA
 */
public class LatLongMap implements Serializable, Cloneable {
     private short latitude;
     private short longitude;
     private short screenX; // latitude
     private short screenY; // longitude
     private long rowid ; // 5 fields

     private transient Semaphore rowlock;
     private transient LatLongMap llm ;

     public LatLongMap ( short p_lat, short p_long, short p_sx, short p_sy, long p_rowid){
         setLatitude (p_lat);
         setLongitude (p_long);
         setScreenX (p_sx);
         setScreenY (p_sy);
         setRowid (p_rowid);
     }

     @Override
     protected Object clone(){
         rowlock.acquireUninterruptibly();
         try{
         llm = (LatLongMap)super.clone();
         }catch (CloneNotSupportedException ex_NOKIA1){
             throw new InternalError (ex_NOKIA1.toString());
         }
         rowlock.release();
         return llm;
     }

     protected int SIZEOF () {
           return (2 + 2 + 2 + 2 + 8);
     }     

     protected short getLatitude (){
        return latitude;
     }

     protected short getLongitude () {
         return longitude;
     }

     protected short getScreenX () {
         return screenX;
     }

     protected short getScreenY () {
         return screenY;
     }

     protected long getRowid () {
         return rowid;
     }

     void setLatitude ( short p_lat ){
         if (p_lat > LiveDB.MAXLATITUDE || p_lat < LiveDB.MINLATITUDE)
         {
             LiveDB.ALRTLVL = 15;
             System.err.println(LiveDB.grassHopper("Incorrect value for latitude " + p_lat));
             System.exit(1);
             return;
         }
         rowlock.acquireUninterruptibly();
         latitude = p_lat;
         rowlock.release();
     }

     void setLongitude ( short p_long ){
         if (p_long > LiveDB.MAXLONGITUDE || p_long < LiveDB.MINLONGITUDE)
         {
             LiveDB.ALRTLVL = 15;
             System.err.println(LiveDB.grassHopper("Incorrect value for longitude " + p_long
                     + " MAXLONGITUDE" + LiveDB.MAXLONGITUDE));
             System.exit(1);
             return;
         }
         rowlock.acquireUninterruptibly();
         longitude = p_long;
         rowlock.release();
     }

     void setScreenX ( short p_sx ){
       if ((int)Toolkit.getDefaultToolkit().getScreenSize().getWidth() < p_sx )
       {
           LiveDB.ALRTLVL = 15;
           System.err.println(LiveDB.grassHopper("Invalid value for Screen X cooordinate:" + p_sx));
           System.exit(1);
       }

       rowlock.acquireUninterruptibly();
       screenX = p_sx;
       rowlock.release();
     }

     void setScreenY ( short p_sy ){
       if ((int)Toolkit.getDefaultToolkit().getScreenSize().getHeight() < p_sy )
       {
           LiveDB.ALRTLVL = 15;
           System.err.println(LiveDB.grassHopper("Invalid value for Screen Y cooordinate:" + p_sy));
           System.exit(1);
       }
       rowlock.acquireUninterruptibly();
       screenY = p_sy;
       rowlock.release();
     }

     void setRowid (long p_rowid){
        
        if (LiveDB.LiveSharedDB[ll].length == 0 && p_rowid != 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid Args p_Rowid " + p_rowid));
            System.exit(1);
        }
        rowlock.acquireUninterruptibly();
        rowid = p_rowid;
        rowlock.release();
    }
}
