/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;
import java.awt.GridBagConstraints;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.Font;
import javax.swing.JLabel;
import java.awt.GridBagLayout;
import java.io.IOException;
import java.io.File;
import javax.imageio.ImageIO;
import java.util.Iterator;
import javax.imageio.ImageReader;
import java.awt.Image;
import javax.imageio.stream.ImageInputStream;
import java.awt.Color;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import static DatabaseEngine.FirstPage.latestprodspanel;
import static DatabaseEngine.FirstPage.pageonetextpanel;
import static DatabaseEngine.LaunchGUI.MAX_HEIGHT;


/*
 * WIRING DIAGRAM :
 * CLASS NAME : LatestProductsPanel
 *
 * @LOOKSY : PictureDatabase.java
 *
 * Date File : None
 *
 * Called From : void addpanels() method of class FirstPage
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the Latest Products Panel at south
 * of screen. It take the latest products added to the PictureDatabase and adds those to the panel.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class LatestProductsPanel
{
    GridBagConstraints constraints = null;
    JLabel picprice = null;
    JLabel latest = new JLabel ("Latest Products");
    final JLabel pictit [] = null;
    JPanel pictures [] = null;
    String picpath [] = null;
    String pictitle = null;
    int MF = 10;
    
    public LatestProductsPanel ()
    {
        if (latestprodspanel != null) LiveDB.appframe.remove(latestprodspanel);
        latestprodspanel = new JPanel (new GridBagLayout ());
        latestprodspanel.setBorder(BorderFactory.createLineBorder(Color.LIGHT_GRAY, 10));
        latestprodspanel.setBackground(Color.WHITE);
        latestprodspanel.setBounds((int)(pageonetextpanel.LEFT_ALIGNMENT * MF),
        (int)(pageonetextpanel.BOTTOM_ALIGNMENT * MF) + 1,
        (int)(pageonetextpanel.RIGHT_ALIGNMENT * MF) - (int)(pageonetextpanel.LEFT_ALIGNMENT * MF),
        (int)(MAX_HEIGHT + 30) - ((int)(pageonetextpanel.BOTTOM_ALIGNMENT * MF) + 1));

        addlatestprodspanel();
        latestprodspanel.validate();
    }

    void addlatestprodspanel ()
    {
        int pW = 8, pH = 8;
        int MAXPICS = 14;
        boolean potrait = false;

        Image image = null;
        ImageInputStream ImageIn = null;
        ImageReader reader = null;
        Iterator <ImageReader> iter = null;

        latest.setForeground(Color.BLUE);
        latest.setFont(new Font ("Dialog", Font.BOLD, 12));

        latestprodspanel.add (latest, setConstraints (0,0,2,1));

        for (int rw = LiveDB.LiveSharedDB[pd].length -1, cnt = 0, W = 0, H = 0, X = 0, Y = 0; rw >= 0 && cnt < MAXPICS; rw--)
        {
            //if (((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_discount() > 0)
              //  continue;

            //picprice = new JLabel (Symbol + convertCurrency(((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_price()));
            //picpath[picpath.length] = ((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_img_location().toString();
            //pictitle = ((PictureDatabase)LiveDB.LiveSharedDB[pd][rw]).getPic_title();

            try{
                image = ImageIO.read(new File(picpath[picpath.length -1]));
            }catch (IOException ex_YESKIA9){
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper(ex_YESKIA9, "File:" + picpath[picpath.length -1]));                
                continue;
            }

            try{
              ImageIn = ImageIO.createImageInputStream(new File (picpath[picpath.length -1]));
            }catch (IOException ex_YESKIA98){
                System.err.println(LiveDB.grassHopper(ex_YESKIA98, "File:" + picpath[picpath.length -1]));                
                continue;
            }

            iter = ImageIO.getImageReadersBySuffix("jpg");
            reader = iter.next();
            reader.setInput(ImageIn);

            try{
                W = reader.getWidth(0);
                H = reader.getHeight(0);
            }catch (IndexOutOfBoundsException ex_NOKIA8){
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper(ex_NOKIA8));                
                continue;
            }catch (IOException ex_NOKIA66){
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper(ex_NOKIA66));                
                continue;
            }

            if (W <= H)
                potrait = true;
            else if (H < W)
                potrait = false;

            pictures [pictures.length] = new JPanel (new GridBagLayout ());
            
            pictures [pictures.length -1].setBounds(pictures.length <= 1 ? 2 :
                (int)(pictures [pictures.length -2].RIGHT_ALIGNMENT * MF) + 2,
                pictures.length <= 1 ? 2 : (pictures[pictures.length -2].RIGHT_ALIGNMENT * MF)
                > (latestprodspanel.RIGHT_ALIGNMENT * MF) - pW - 2 ?
                (int)(pictures [pictures.length -2].BOTTOM_ALIGNMENT * MF) + 2 :
                (int)(pictures [pictures.length -2].TOP_ALIGNMENT * MF),
                pW, pH);

            FirstPage.DrawImage(picpath[picpath.length -1], 
                    pictures[pictures.length -1], X + 1, Y, 0, 0, potrait);
            
            pictit [pictit.length] = new JLabel (pictitle);
            
            pictit[pictit.length -1].setFont(new Font ("Dialog", Font.PLAIN, 9));
            pictit[pictit.length -1].setForeground(Color.BLUE);

            pictures[pictures.length -1].add(pictit[pictit.length -1],
                  setConstraints(0, (int)(pictures[pictures.length -1].BOTTOM_ALIGNMENT * MF) -2,
                  2, 1));
            
            pictit[pictit.length].addMouseListener(new MouseListener(){
            
                @Override
                public void mousePressed (MouseEvent evnt){
                    pictit[pictit.length -1].setForeground(Color.RED);
                    pictit[pictit.length -1].validate();
                }
                @Override
                public void mouseReleased (MouseEvent evnt){
                    pictit[pictit.length -1].setForeground(Color.BLUE);
                    pictit[pictit.length -1].validate();
                }
                @Override
                public void mouseEntered (MouseEvent evnt){
                    pictit[pictit.length -1].setForeground(Color.RED);
                    pictit[pictit.length -1].validate();
                }
                @Override
                public void mouseClicked (MouseEvent evnt){
                    //new PicturePage (picpath[picpath.length -1]);
                }
                @Override
                public void mouseExited (MouseEvent evnt){
                    pictit[pictit.length -1].setForeground(Color.BLUE);
                    pictit[pictit.length -1].validate();
                }            
            });

            cnt++;
        } // for (int rw = LiveDB.LiveSharedDB[pd].length -1, cnt = 0, W = 0, H = 0;
    }
    
    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
