/*
 * @(#)Packages MaintainData,PitStart,DataEntryPrograms
 * Version 1.0 of LensView Photographic Sales Software
 * Release Date : 17/10/2011
 * Author : Kodangudi Vaidyanathswamy Padmanabhan Sai Krishna
 *
 * Copyright (c) 2011 – until end of time FotoKrafts All Rights Reserved.
 * FotoKrafts (www.fotokrafts.net) C-1678, Sahakara Nagar, Bangalore -92.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL and COMMERCIAL purposes and
 * without fee is hereby granted EXCEPT (1) you may not re-produce this in
 * E-Books or other Books from any publishing house (2)You may not copy,
 * modify, and distribute this software as offerings clubbed with other
 * commercial software today, in future or commercial software released in
 * the past.
 *
 * FotoKrafts MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 * OR NON-INFRINGEMENT. FotoKrafts SHALL NOT BE LIABLE  FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS
 * SOFTWARE OR ITS DERIVATIVES.
 *
 * THIS SOFTWARE IS NOT DESIGNED OR INTENDED FOR USE OR RESALE AS ON-LINE
 * CONTROL EQUIPMENT IN HAZARDOUS ENVIRONMENTS REQUIRING FAIL-SAFE
 * PERFORMANCE, SUCH AS IN THE OPERATION OF NUCLEAR FACILITIES, AIRCRAFT
 * NAVIGATION OR COMMUNICATION SYSTEMS, AIR TRAFFIC CONTROL, DIRECT LIFE
 * SUPPORT MACHINES, OR WEAPONS SYSTEMS, IN WHICH THE FAILURE OF THE
 * SOFTWARE COULD LEAD DIRECTLY TO DEATH, PERSONAL INJURY, OR SEVERE
 * PHYSICAL OR ENVIRONMENTAL DAMAGE ("HIGH RISK ACTIVITIES"). FotoKrafts
 * SPECIFICALLY DISCLAIMS ANY EXPRESS OR IMPLIED WARRANTY OF FITNESS FOR
 * HIGH RISK ACTIVITIES.
 *
 * THIS ENTIRE SOFTWARE IS DEDICATED TO MY CREATOR Group Captain K.V Padmanabhan [retd]
 */

package DatabaseEngine;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JApplet;
import java.io.IOException;
import java.io.InputStream;
import java.awt.Toolkit;
import javax.swing.JProgressBar;
import javax.swing.ProgressMonitor;
import java.awt.EventQueue;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.util.Random;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import static DatabaseEngine.LiveDB.appframe;
import static DataEntryPrograms.DotingEntry.NetworkDriveAbsent;

/*
 * WIRING DIAGRAM :
 * THREAD NAME : LensView.threadmain
 * CLASS NAME : LensView
 *
 * @LOOKSY:LiveDB.command_line,LiveDB.command_line_params
 *
 * Method Name : public static void main(String[] args)
 * Parameters : String[] args  --  Command Line arguments dummy one or two at best
 * Returns : None
 *
 * Chained Methods : protected static void InstallDB.getAppProperties()
 *                   protected static void InstallDB.readconffile ()
 *                   protected static void InstallDB.checkcommandline ()
 *                   protected static void InstallDB.getserializedfilespath ()
 *                   protected static void InstallDB.setandwritepolicyfile()
 *                   protected static void InstallDB.getRESTOCKPERCENT ()
 *                   protected static void InstallDB.selectLanguages ()
 *                   protected static void InstallDB.writeConfFile ()
 *                   protected static void InstallDB.initDates ()
 *                   protected static void InstallDB.threadLaunch()
 *                   protected static boolean LiveDB.programmingScrewups()
 *
 * Associated Methods : protected static boolean LiveDB.redirectstderr ()
 *                      public static void LiveDB.LogFileSabotageCheck ()
 *
 * Data File : ./filetabledatafile.txt
 * Other Data Files : For static tables data will be provided shortly along with a data entry program
 * Language Files : Language files will also be provided as *.lfn shortly to be copied to serializedfilespath.
 * Information File : howtoinstall.txt
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is the main start up program for this Application. Currently the command line
 * parameters may be two at best.After compiling program if you run $LensView --help from O/S command line
 * it willl list all the SYSADM commands available for this application. Some of those commands require one
 * one extra parameter which is captured in command_line_params. The main program is almost self-explanatory
 * It starts by capturing command line parameters. Then it determines the main thread as threadmain for just
 * academic purposes. Then it calls some methods in a correct sequence. Since serializedfilespath is not
 * specified immediately at start of Install it is taken as the local directory in which an ErrorLogFile is
 * created and stderr redirected to that. After accepting serializedfilespath from the user the program will
 * redirect stderr once again to the correct location for the lifetime of the application. Each of these
 * methods will internally differentiate between install time and normal application launch and SYSADM
 * commands. A quick look at each of these methods will provide a sufficient over-view of the flow of logic.
 * I have seperated the main program which was previously in class InstallDB into this class hoping to fake
 * the class loader mechanism by hook/crook.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : A Potrait of Louis Armstrong
 *
 * Start Date: 24th July 2011
 * End Date: 24th July 2011
 * Last Modified Date : 12th August 2011
 * Last Modification : Re-Shuffled the calls to various InstallDB static methods in method main().
 * Also added several calls to new method showProgress () to display a progress Dialog both at times
 * of Install and other times. Also this class name has been changed from installDB to LensView. So
 * the executable will be LensView now.
 *
 * Last Modified Date : 12th October 2011
 * Last Modifications : changed Applet to JApplet appframe = new InstallDB(new JApplet());
 *
 * Last Modified Date : 12th October 2011
 * Last Modifications : This call to readconffile () has been re-positioned before the call to
 * getserializedfilespath ();
 *
        InstallDB.readconffile (); // some more properties
        showProgress("Completed Read Configuration File", 25);

        getserializedfilespath ();
        showProgress("Completed Fetch Database Repository Path", 20);
 *
 * Last Modified Date : 13th October 2011
 * Last Modifications : added this patch of code as below to check O/S supported
        // Can you Install or Run ?
        if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap"))
        {
            if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) == -1 &&
                LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.MACINTOSH) == -1 &&
                LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.SOLARIS) == -1 &&
                LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.LINUX) == -1 )
            {
                JOptionPane.showMessageDialog(appframe, "Sorry Your Operating System "
                     + '\n' + LiveDB.OPERATINGSYSTEM + '\n' + " Is not supported yet");
                System.exit(1);
            }
        }
 *
 * Last Modified Date : 13th October 2011
 * Last Modifications : added this window listener to appframe
              appframe.addWindowListener(new WindowListener (){

                  @Override
                  public void windowDeactivated (WindowEvent evnt){
                     // you might want to use the thread controller to tweak priority here
                     // reduce priority but please check if O/S is windows. If Windows dont finger
                     // that bugger. You may tweak the piority so low that pre-emption will NOT
                     // allow the GUI to function. But for non-Windows O/S go ahead and finger
                     // repeatedly "Shaam Ka Plan !!"
                  }

                  @Override
                  public void windowActivated (WindowEvent evnt)
                  {
                      if(Thread.currentThread().getStackTrace()[0].getMethodName().indexOf("main") == -1)
                          appframe.pack();
                  }

                  @Override
                  public void windowDeiconified (WindowEvent evnt){appframe.pack();}

                  @Override
                  public void windowIconified (WindowEvent evnt){
                     // you might want to use the thread controller to tweak priority here
                     // reduce priority but please check if O/S is windows. If Windows dont finger
                     // that bugger. You may tweak the piority so low that pre-emption will not
                     // allow the GUI to function. But for non-Windows O/S go ahead and finger
                     // repeatedly "Shaam Ka Plan !!"
                     // Next Release Plan will allow the users to paint the GUI as per their
                     // wishes using a simple interactive form with combo boxes. And then I shall
                     // write a bit pattern to disk and the GUI will obey the bit pattern when it
                     // loads in IRobot. Needs one month of thinking and typing perhap a little more.
                     // But it is possible. If I manage it in next release it will be in honor of the
                     // pretty woman "Shaam ka Plan" on Telly. Hey whats your name ? Married to Boredom ?
                  }

                  @Override
                  public void windowClosed (WindowEvent evnt){
                      LiveDB.system_exit = 1;
                      LiveDB.SmoothExitCondition.signalAll();
                  }

                  @Override
                  public void windowClosing (WindowEvent evnt){
                      LiveDB.system_exit = 1;
                      LiveDB.SmoothExitCondition.signalAll();
                  }

                  @Override
                  public void windowOpened (WindowEvent evnt){
                      if(Thread.currentThread().getStackTrace()[0].getMethodName().indexOf("main") == -1
                         && Thread.currentThread().getStackTrace()[0].getMethodName()
                                                                             .indexOf("FirstPage") == -1)
                          appframe.pack();
                  }
              });
              appframe.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
              appframe.setVisible(true);
           }
        });
 *
 * Last Modification Date: June 7th 2012
 * Last Modifications : Added some extra message dialogs such as the code patch below where-ever there
 * is a System.exit(1)
           JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
               System.exit(1);
 * Also set some write perms. What I have done is to set the top level directory LiveDB.serializedfilespath
 * to read and all directory perms under it to write (most of them) because toggling these directory perms
 * continuously is very difficult to perfect and it will play havoc in a multi user mode.
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class Madagascar
{
    final static int DEFAULT_WIDTH = (int)Toolkit.getDefaultToolkit().getScreenSize().getWidth();
    final static int DEFAULT_HEIGHT = (int)Toolkit.getDefaultToolkit().getScreenSize().getHeight();

    public static void main(String[] args)
    {
        EventQueue.invokeLater(new Runnable()
        {
           @Override
           public void run()
           {
              // appframe is a static import
              appframe = new InstallDB(new JApplet());
              appframe.setTitle(LiveDB.versionControl.getApplicationName() + " Photographic Sales Software");
              appframe.setSize(DEFAULT_WIDTH, DEFAULT_HEIGHT);
              appframe.addWindowListener(new WindowListener (){

                  @Override
                  public void windowDeactivated (WindowEvent evnt){
                     // you might want to use the thread controller to tweak priority here
                     // reduce priority but please check if O/S is windows. If Windows dont finger
                     // that bugger. You may tweak the piority so low that pre-emption will NOT
                     // allow the GUI to function. But for non-Windows O/S go ahead and finger
                     // repeatedly "Shaam Ka Plan !!"
                  }

                  @Override
                  public void windowActivated (WindowEvent evnt)
                  {
                      if(Thread.currentThread().getStackTrace()[0].getMethodName().indexOf("main") == -1)
                          appframe.pack();
                  }

                  @Override
                  public void windowDeiconified (WindowEvent evnt){appframe.pack();}

                  @Override
                  public void windowIconified (WindowEvent evnt){
                     // you might want to use the thread controller to tweak priority here
                     // reduce priority but please check if O/S is windows. If Windows dont finger
                     // that bugger. You may tweak the piority so low that pre-emption will not
                     // allow the GUI to function. But for non-Windows O/S go ahead and finger
                     // repeatedly "Shaam Ka Plan !!"
                     // Next Release Plan will allow the users to paint the GUI as per their
                     // wishes using a simple interactive form with combo boxes. And then I shall
                     // write a bit pattern to disk and the GUI will obey the bit pattern when it
                     // loads in IRobot. Needs one month of thinking and typing perhap a little more.
                     // But it is possible. If I manage it in next release it will be in honor of the
                     // pretty woman "Shaam ka Plan" on Telly. Hey whats your name ? Married to Boredom ?
                  }

                  @Override
                  public void windowClosed (WindowEvent evnt){
                      LiveDB.system_exit = 1;
                      LiveDB.SmoothExitCondition.signalAll();
                  }

                  @Override
                  public void windowClosing (WindowEvent evnt){
                      LiveDB.system_exit = 1;
                      LiveDB.SmoothExitCondition.signalAll();
                  }

                  @Override
                  public void windowOpened (WindowEvent evnt){
                      if(Thread.currentThread().getStackTrace()[0].getMethodName().indexOf("main") == -1
                         && Thread.currentThread().getStackTrace()[0].getMethodName()
                                                                     .indexOf("FirstPage") == -1)
                          appframe.pack();
                  }
              });
              appframe.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
              appframe.setVisible(true);
           }
        });

        LiveDB.command_line = args[0];

        if (args.length >  1)
            if (args.length > 2)
                LiveDB.command_line_params = args[1] + " " + args[2];
            else
                LiveDB.command_line_params = args[1];

        LiveDB.mainthread = Thread.currentThread();

        if (LiveDB.command_line == null)
        {
            LiveDB.progressbar = new JProgressBar(0,100);
            LiveDB.progressbar.setName("LENSVIEW APPLICATION LAUNCH PROGRESS");
            LiveDB.progressbar.setStringPainted(true);
            LiveDB.databaseloading = 2;
        }

        if (LiveDB.command_line.equals("FileTableDataFileMap"))
            LiveDB.progressMonitor = new ProgressMonitor (appframe, "LENSVIEW INSTALLATION PROGRESS",
                                                                "Redirecting Standard Error", 0, 100);

        if (LiveDB.redirectstderr() == false)
        {
            System.out.println ("SYSADM:error in redirecting stderr Exiting " + "\n");
            JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
            System.exit(1);
        }
        showProgress("Completed Redirect Standard Error", 5);

        InstallDB.checkcommandline ();
        showProgress("Completed Checking Command Line", 10);

        InstallDB.getAppProperties(); // get system properties
        showProgress("Completed Fetch Application Properties", 15);

        // Can you Install or Run ?
        if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap"))
        {
            if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) == -1 &&
                LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.MACINTOSH) == -1 &&
                LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.SOLARIS) == -1 &&
                LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.LINUX) == -1 )
            {
                JOptionPane.showMessageDialog(appframe, "Sorry Your Operating System "
                     + '\n' + LiveDB.OPERATINGSYSTEM + '\n' + " Is not supported yet");
                JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
                System.exit(1);
            }
        }

        InstallDB.readconffile (); // some more properties
        showProgress("Completed Read Configuration File", 25);

        getserializedfilespath ();
        showProgress("Completed Fetch Database Repository Path", 20);

        InstallDB.getRESTOCKPERCENT ();
        showProgress("Completed Fetch Restock Percent", 30);

        InstallDB.selectLanguages();
        showProgress("Completed Select Languages", 35);

        InstallDB.initDates(); // get some dates parsed right
        showProgress("Completed Initializing Dates", 37);

        InstallDB.writeConfFile ();
        showProgress("Completed Writing Configuration File", 40);

        LiveDB.LogFileSabotageCheck ();
        showProgress("Completed Log File Sabotage Check", 45);

        if (LiveDB.redirectstderr() == false)
        {
            System.err.println (LiveDB.grassHopper("error in redirecting stderr Exiting"));
            JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
            System.exit(1);
        }
        showProgress("Completed Redirect Standard Error", 50);

        if (InstallDB.validateFileTableDataFileMap() == false)
        {
            System.err.println(LiveDB.grassHopper("Validation of FileTableDataFileMap failed"));
            JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
            System.exit(1);
        }

        showProgress("Completed Validating Critical File:filetabledatafilemap.txt", 55);

        // some perms to be set
        new File (LiveDB.serializedfilespath + "reports").setReadOnly();
        new File (LiveDB.serializedfilespath + "dump").setReadOnly();
        new File (LiveDB.serializedfilespath + "etc").setReadOnly();
        new File (LiveDB.serializedfilespath + "syc").setReadOnly();

        if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false)
        {
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
            LiveDB.system_exit = 1;
            LiveDB.SmoothExitCondition.signalAll();
        }
        // delete a prank file . A leftover daemon file from previous crash will be cleared by fsck()
        new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadrefreshdb"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).delete();

        // delete a leftover crash file
        if (new File (LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT").exists()
                && LiveDB.Prankster ())
                new File (LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR
                                                                        + "ALLUSERSEXIT").delete();

        showProgress("Completed Setting Perms", 60);

        LiveDB.LogFileSabotageCheck ();
        showProgress("Completed Log File Sabotage Check", 62);

        InstallDB.setandwritepolicyfile ();
        showProgress("Completed Writing Java Policy Files", 65);

        if (LiveDB.programmingScrewups() == false)
        {
            System.err.println(LiveDB.grassHopper("Programming Screwups in Source Code"));
            JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
            System.exit(1);
        }

        showProgress("Completed Check for Programming Blunders", 70);

        LiveDB.LogFileSabotageCheck (); // this will also check space left
        showProgress("Completed Log File Sabotage Check", 75);

        InstallDB.threadLaunch(); // launch all threads in right order
        showProgress("Completed ThreadLaunch", 100);

    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY : LiveDB.command_line, LiveDB.progressMonitor, LiveDB.ALRTLVL, LiveDB.progressbar, LiveDB.appframe
 * Method Name : private static void showProgress (String p_note, int p_progress)
 * Parameters : String p_note -- The note to display on the dialog
 *              int p_progress -- the unit for displaying the percentage of completion in dialog
 * Returns : none
 *
 * Data File : None
 *
 * Called From : LensView::main method
 *
 * @Since Version : 1.0
 *
 * Running Commentary : At Install time this method update the progressMonitor and also check if the user
 * cancelled the Install. At other times it just shows the progress of the program.
 *
 * Technical Reference : None
 *
 * Start Date: 11th August 2011
 * End Date: 11th August 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static void showProgress (String p_note, int p_progress)
    {
        if (LiveDB.command_line.equals("FileTableDataFileMap"))
        {
            if (LiveDB.progressMonitor.isCanceled())
            {
                LiveDB.progressMonitor.setNote("USER CANCELLED INSTALL");
                LiveDB.progressMonitor.setProgress(p_progress);
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("USER CANCELLED LENSVIEW INSTALL EXITING...."));
                JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
                System.exit(1);
            }
            LiveDB.progressMonitor.setNote(p_note);
            LiveDB.progressMonitor.setProgress(p_progress);
        }
        else
        {
            LiveDB.progressbar.setValue(p_progress);
        }
        appframe.validate();
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.FILESEPERATOR, LiveDB.OPERATINGSYSTEM
 * @LOOKSY:LiveDB.PATHSEPERATOR, LiveDB.command_line, LiveDB.WINDOWS, LiveDB.LINUX, LiveDB.SOLARIS
 *
 * Method Name : private static void getserializedfilespath ()
 * Parameters : None
 * Returns :None
 *
 * Chained Method : private static void copyimagesto ()
 *
 * Data File : LiveDB.COPYTRANSFILESFROM, LiveDB.COPYFROM
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method prompts and accepts and validates user input with a JFileChooser dialog
 * and stores it in LiveDB.serializedfilespath as database location directory where all database related
 * files will be stored. The database location directory itself will contain several sub-directories to
 * prevent accidental deletion of important files. These sub-directories under serializedfilespath will be
 * created automatically at install time. At other times the application will check for existense of these
 * sub directories and write to ErrorLogFile if these directories have been deleted. After writing to
 * ErrorLogFile the application will System.exit(1). There are some sub directories which are non-critical
 * so application will try and re-create these sub directories and continue to run instead of System.exit(1).
 * Given below is a list of sub directories that will be present under LiveDB.serializedfilespath.
 *
 * SUB DIRECTORY NAME     CRITICAL   PURPOSE
 * etc                     no        miscellaneous files that dont fit in elsewhere like shell scripts, fsck
 * spool                   no        print requests for a later time (next release)
 * archive                 no        archive database files
 * bin                     no        supplementary programs other than InstallDB
 * tmp                     no        temp files if for some reason system tmp cannot be used
 * var                     no        files with a short life
 * dump                    no        dump files
 * dataload                no        data entry files to load including corrected dump files
 * syc                     no        ipcs synchronization files
 * daemon                  no        daemon files
 * policy                 yes        policy files
 * conf                   yes        configuration files
 * reports                yes        all reports generated
 * images                 yes        all audio, video, photo images
 * version                yes        version control files
 * usr                    yes        user login info and other user related files
 * backup                 yes        auto backups, restore files, old backup files
 * rowsets                yes        next release will contain row sets files for all tables
 * dev                    yes        files for some device names (next release)
 * libs                   yes        next release for some libraries if needed
 * dbf                    yes        database files Integrated release integrating other databases NANPA etc
 * sccs                   yes        source code control system (next release)
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 24th May 2011
 *
 * Last Modified : 25th July 2011
 * Modification : Moved this method from class InstallDB to this class and changed access specifier to
 * private. Also the original source of the method accepted the serializedfilespath specified by user from
 * stdin and then validated it. Instead I have now replaced that functionality with a JFileChooser dialog so
 * the need for validating it is reduced.
 *
 * Last Modified : 12th August 2011
 * Last Modifications : search for AUTOINSTALL that is where patches of coded has been added to support
 * Auto Installation without stupid questions. Also look for HOME_EDITION and the else clause where code
 * has been added for a PRO Installation.
 *
 * Last Modified : 5th October 2011
 * Last Modifications : Your Picture Image Files in location specified in PitureDatabase table must exist
 * so we automatically copy those image files for PRO EDITION CHAPS from LiveDB.COPYFROM, LiveDB.COPYTO
 * WE must also autocopy the LENSVIEWPROPERTIESFILE FROM LiveDB.USRDIR to LiveDB.serializedfilespath/conf
 * and so this stretch of code.
            // copy the lensview properties file here to "conf" directory
            Process process = null;
            InputStream se = null;
            BufferedReader brse = null;
            String command = "COPY " + LiveDB.USRDIR + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE"
                    + "  " + LiveDB.serializedfilespath + "conf";
            String errline = null;

            if (new File(LiveDB.serializedfilespath + "conf").setWritable(true, false) == false)
            {
                 System.err.println(LiveDB.grassHopper("Cant setwrite on "
                                          + LiveDB.serializedfilespath + "conf"));
                 System.exit(1);
            }

            try{
               process = Runtime.getRuntime().exec(command);
            }catch(IOException ex_NOKIA62){
                 System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                 System.exit(1);
            }

            se = process.getErrorStream();

            brse = new BufferedReader (new InputStreamReader(se));

            try{
                 if ((errline = brse.readLine()) != null)
                 {
                    System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                    System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "COPY LENSVIEWPROPERTIES FILE MANUALLY TO CONF DIRECTORY");
                    JOptionPane.showMessageDialog(appframe,
                                LiveDB.USRDIR + "LENSVIEWPROPERTIESFILE"
                                + '\n' + " COPY FAILED" + '\n' +
                                "COPY MANUALLY TO "
                                + LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "conf");
                 }
            }catch (IOException ex_NOKIA5){
                System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                System.exit(1);
            }

            LiveDB.LENSVIEWPROPERTIESFILE = LiveDB.serializedfilespath + "conf"
                                            + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE";

            if (new File(LiveDB.serializedfilespath + "conf").setReadOnly() == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setReadOnly on "
                                              + LiveDB.serializedfilespath + "conf"));
            }

            // now copy images from directory to directory here
            if (LiveDB.HOME_EDITION == false) // Pro Edition
            {
                if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                    command = "COPY " + LiveDB.COPYFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.COPYTO;
                else
                    command = "cp " + LiveDB.COPYFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.COPYTO ;
                try{
                    process = Runtime.getRuntime().exec(command);
                }catch(IOException ex_NOKIA62){
                    System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                    System.exit(1);
                }

                se = process.getErrorStream();
                brse = new BufferedReader (new InputStreamReader(se));

                try{
                    if ((errline = brse.readLine()) != null)
                    {
                        System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                        System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "FAIL COPY IMAGES FILES MANUALLY TO DIRECTORY");
                        JOptionPane.showMessageDialog(appframe,
                                "IMAGES COPYING FAILED" + '\n' + "COPY FROM:" + LiveDB.COPYFROM
                                + '\n' + "COPY TO:" + LiveDB.COPYTO + '\n'
                                + "TELL SYSADMIN TO COPY MANUALLY" +
                                '\n' + "CONTINUING INSTALLATION ...");
                    }
                }catch (IOException ex_NOKIA5){
                    System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                    System.exit(1);
                }
            }
 *
 * Last Modified : October 12th 2011
 * Last Modifications : Added this patch of code to copy transalated language files to etc directory
            try{
                brse.close();
            }catch (IOException ex_YESKIA23){
               System.err.println(LiveDB.grassHopper(ex_YESKIA23));
            }

            if (LiveDB.HOME_EDITION == false) // Pro Edition
            {
                if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                    command = "COPY " + LiveDB.COPYTRANSFILESFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.serializedfilespath + "etc";
                else
                    command = "cp " + LiveDB.COPYTRANSFILESFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.serializedfilespath + "etc" ;
                try{
                    process = Runtime.getRuntime().exec(command);
                }catch(IOException ex_NOKIA62){
                    System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                    System.exit(1);
                }

                se = process.getErrorStream();
                brse = new BufferedReader (new InputStreamReader(se));

                try{
                    if ((errline = brse.readLine()) != null)
                    {
                        System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                        System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "FAIL COPY LANGUAGE FILES MANUALLY TO DIRECTORY");
                        JOptionPane.showMessageDialog(appframe,
                                "LANGUAGE FILE COPY FAILED" + '\n' + "COPY FROM:" + LiveDB.COPYTRANSFILESFROM
                                + '\n' + "COPY TO:" + LiveDB.serializedfilespath + "etc" + '\n'
                                + "TELL SYSADMIN TO COPY MANUALLY" +
                                '\n' + "CONTINUING INSTALLATION ...");
                    }
                }catch (IOException ex_NOKIA5){
                    System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                    System.exit(1);
                }
            }
 *
 * Last Modified : October 12th 2011
 * Last Modifications : Added the following code patch
            String errline = null;

            if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                command = "COPY " + LiveDB.USRDIR + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE"
                                                          + "  " + LiveDB.serializedfilespath + "conf";
            else
                command = "cp " + LiveDB.USRDIR + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE"
                                                          + "  " + LiveDB.serializedfilespath + "conf";

            if (new File(LiveDB.serializedfilespath + "conf").setWritable(true, false) == false)
 *
 * Last Modified : 13th October 2011
 * Last Modifications : Added this patch of code to copy LENSVIEWPROPERTIESFILE.txt to USER HOME DIR
 *
            // now copy the LENSVIEWPROPERTIESFILE.txt here to USRHOMEDIR
            if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                command = "COPY " + LiveDB.serializedfilespath + "conf"
                        + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE.txt" + " " + LiveDB.USRHOMEDIR
                        + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE.txt";
            else
                command = "cp " + LiveDB.serializedfilespath + "conf"
                        + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE.txt" + " " + LiveDB.USRHOMEDIR
                        + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE.txt";

            if (new File(LiveDB.serializedfilespath + "conf").setWritable(true, false) == false)
            {
                 System.err.println(LiveDB.grassHopper("Cant setwrite on "
                                          + LiveDB.serializedfilespath + "conf"));
                 System.exit(1);
            }

            try{
               process = Runtime.getRuntime().exec(command);
            }catch(IOException ex_NOKIA62){
                 System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                 System.exit(1);
            }

            se = process.getErrorStream();

            brse = new BufferedReader (new InputStreamReader(se));

            try{
                 if ((errline = brse.readLine()) != null)
                 {
                    System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                    System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "COPY LENSVIEWPROPERTIES FILE MANUALLY TO " + LiveDB.USRHOMEDIR);
                    JOptionPane.showMessageDialog(appframe,
                                LiveDB.USRDIR + "LENSVIEWPROPERTIESFILE.txt"
                                + '\n' + " COPY FAILED" + '\n' + "COPY MANUALLY TO "
                                + LiveDB.USRHOMEDIR);
                 }
            }catch (IOException ex_NOKIA5){
                System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                System.exit(1);
            }

            try{
                 brse.close();
            }catch (IOException ex_YESKIA23){
               System.err.println(LiveDB.grassHopper(ex_YESKIA23));
            }

            // now copy images from directory TO to directory here
 *
 * Last Modified : 13th October 2011
 * Last Modifications : added this patch of code to create a default LensView directory for non-windows
 * operating systems.
                else
                {
                    if (new File ("." + LiveDB.FILESEPERATOR + "LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create "
                                + "." + LiveDB.FILESEPERATOR + "LensView" + " directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                        System.exit(1);
                    }
                    else
                    {
                        if (new File ("." + LiveDB.FILESEPERATOR + "LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default "
                                  + "." + LiveDB.FILESEPERATOR + "LensView" + " directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            System.exit(1);
                        }
                    }
                    LiveDB.serializedfilespath = new String(("." + LiveDB.FILESEPERATOR + "LensView").toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }
            }
            else if (result == JFileChooser.ERROR_OPTION)
 *
 *
 * Last Modified : 13th October 2011
 * Last Modifications : added this patch of code to create a default LensView directory for non-windows
 * operating systems.
                else
                {
                    if (new File ("." + LiveDB.FILESEPERATOR + "LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create "
                                + "." + LiveDB.FILESEPERATOR + "LensView" + " directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                        System.exit(1);
                    }
                    else
                    {
                        if (new File ("." + LiveDB.FILESEPERATOR + "LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default "
                                  + "." + LiveDB.FILESEPERATOR + "LensView" + " directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            System.exit(1);
                        }
                    }
                    LiveDB.serializedfilespath = new String(("." + LiveDB.FILESEPERATOR + "LensView").toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }

            LiveDB.checkSpaceLeft();
 *
 * Last Modified : 17th October 2011
 * Last Modifications : added this extra chained method
 * private static void copyimagesto ()
 *
 * Last Modified : 17th October 2011
 * Last Modifications : added this extra patch of code to autocopy companylogo to images directory
 * of LiveDB.serializedfilespath.
            if (LiveDB.HOME_EDITION || (LiveDB.COPYTO.isEmpty() || LiveDB.COPYTO.trim().length() == 0))
            {
                    // just copy one companylogo to images directory
                    JOptionPane.showMessageDialog(appframe, "YOUR lensview.copyimagesto key=value"
                            + '\n' + "IN " + LiveDB.LENSVIEWPROPERTIESFILE + '\n'
                            + "IS INVALID PLEASE MANUALLY COPY AT O/S ALL IMAGES" + '\n'
                            + "TO " + LiveDB.serializedfilespath + "images");

                    if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                        command = "COPY " + LiveDB.USRDIR +  "companylogo.jpg"
                                                          + "  " + LiveDB.serializedfilespath + "images";
                    else
                        command = "cp " + LiveDB.USRDIR + "companylogo.jpg"
                                                          + "  " + LiveDB.serializedfilespath + "images";

                    if (new File(LiveDB.serializedfilespath + "images").setWritable(true, false) == false)
                    {
                        System.err.println(LiveDB.grassHopper("Cant setwrite on "
                                          + LiveDB.serializedfilespath + "images"));
                        System.err.println("LINE:" + LiveDB.logerrorno + "COPY companylogo.jpg manually to images directory");
                        JOptionPane.showMessageDialog(appframe,"Cant setwrite on " + '\n'
                                          + LiveDB.serializedfilespath + "images" + '\n'
                                          + "COPY companylogo.jpg manually to " + '\n'
                                          + LiveDB.serializedfilespath + "images directory");
                    }

                    try{
                        process = Runtime.getRuntime().exec(command);
                    }catch(IOException ex_NOKIA62){
                        System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                        System.exit(1);
                    }

                    se = process.getErrorStream();

                    brse = new BufferedReader (new InputStreamReader(se));

                    try{
                        if ((errline = brse.readLine()) != null)
                        {
                            System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                            System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "COPY companylogo.jpg FILE MANUALLY TO images DIRECTORY");
                            JOptionPane.showMessageDialog(appframe,
                                LiveDB.USRDIR + "companylogo.jpg"
                                + '\n' + " COPY FAILED" + '\n' +
                                "COPY MANUALLY TO "
                                + LiveDB.serializedfilespath + "images");
                        }
                    }catch (IOException ex_NOKIA5){
                        System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                        System.exit(1);
                    }

                    if (new File(LiveDB.serializedfilespath + "images").setReadOnly() == false)
                    {
                        System.err.println(LiveDB.grassHopper("Cant setReadOnly on "
                                              + LiveDB.serializedfilespath + "images"));
                    }

                    try{
                        brse.close();
                    }catch (IOException ex_YESKIA23){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA23));
                    }
            }
 *
 * Last Modified : 17th October 2011
 * last Modifications : Added this patch of code to accomodate for possible user errors during Install
         String imagedir = null;
            if (LiveDB.HOME_EDITION)
                imagedir = LiveDB.USRDIR + "imagery";
            else
                imagedir = LiveDB.COPYFROM;
            // now copy images from directory TO to directory here
            if (new File (imagedir).isDirectory())
            {
                if (LiveDB.COPYTO.isEmpty() == false && LiveDB.COPYTO.trim().length() != 0)
                {
                    if (new File(LiveDB.COPYTO).isDirectory() == false)
                    {
                        System.err.println(LiveDB.grassHopper("LENSVIEWPROPERTIESFILE.txt:"
                                + "key copyimagesto"
                                + " value not directory"));
                        if (new File(LiveDB.COPYTO).mkdir() == false)
                            System.err.println("Cant create directory " + LiveDB.COPYTO);
                        else
                        {
                            if (new File(LiveDB.COPYTO).setWritable(true, false) == false)
                            {
                                System.err.println(LiveDB.grassHopper("Cant setWritable on "
                                        + LiveDB.COPYTO));
                            }
                            else copyimagesto (imagedir);
                        }
                    }
                    else copyimagesto (imagedir);
                }
            }
            else
            {
                System.err.println(LiveDB.grassHopper("LENSVIEWPROPERTIESFILE.txt:"
                                + "key copyimagesfrom"
                                + " value not directory"));
                JOptionPane.showMessageDialog(appframe, "LENSVIEWPROPERTIESFILE.txt:" + "key copyimagesfrom"
                        + '\n' + " value not directory" +'\n' + "Manually copy images at O/S" + '\n'
                        + "TO " + LiveDB.serializedfilespath + "images");
            }
 *
 *
 * Last Modified : 30th May 2012
 * Last Modifications : altered the following error message
                JOptionPane.showMessageDialog(appframe, "LENSVIEWPROPERTIESFILE.txt:" + "key copyimagesfrom"
                        + '\n' + " value not directory" +'\n'
                        + "Or " + imagedir + "not created as directory" + '\n'
                         + "Manually copy images at O/S" + '\n'
                        + "TO " + LiveDB.serializedfilespath + "images");
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    private static void getserializedfilespath ()
    {
        File sdp = null;

        if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == false)
        {
            // make some directories for better organization of data and also to avoid accidental
            // deletions

            // RESET PERMS ON TOP LEVEL DIRECTORY TO WRITE BEFORE MAKEDIR
            if (new File (LiveDB.serializedfilespath).setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWrite on " + LiveDB.serializedfilespath));
                JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
                System.exit(1);
            }

            if ((sdp = new File(LiveDB.serializedfilespath + "dbf")).isDirectory() == false)
            {

                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "dbf"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "dbf" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);

            }
            if ((sdp = new File(LiveDB.serializedfilespath + "policy")).isDirectory() == false)
            {

                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "policy"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "policy" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "conf")).isDirectory() == false)
            {

                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "conf"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "conf" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "daemon")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "daemon" + " deleted trying mkdir"));

                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "daemon"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "daemon" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "daemon" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "syc")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "syc" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "syc"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "syc" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "syc" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "reports")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "reports"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "reports" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "dataload")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "dataload" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dataload"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dataload" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "dataload" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "dump")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "dump" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dump"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dump" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "dump" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "version")).isDirectory() == false)
            {

                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "version"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "version" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "etc")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "etc" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "etc"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "etc" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "etc" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "usr")).isDirectory() == false)
            {

                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "usr"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "usr" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "backup")).isDirectory() == false)
            {

                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "backup"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "backup" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "archive")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "archive" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "archive"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "archive" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "archive" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "rowsets")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "rowsets"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "rowsets" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "dev")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "dev"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "dev" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "spool")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "spool" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "spool"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "spool" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "spool" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "tmp")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "tmp" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "tmp"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "tmp" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "tmp" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "var")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "var" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "var"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "var" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "var" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "bin")).isDirectory() == false)
            {
                System.err.println(LiveDB.grassHopper("non-critical directory " + LiveDB.serializedfilespath + "bin" + " deleted trying mkdir"));
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "bin"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "bin" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "bin" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "libs")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "libs"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "libs" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "sccs"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "boot")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "boot"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "boot" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "checkin")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "checkin"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "checkin" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "chuckout")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "chuckout"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "chuckout" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' + LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "checkout")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "checkout"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "checkout" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "source")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "source"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "sccs" + "source" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "images")).isDirectory() == false)
            {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Critical directory deleted " + LiveDB.serializedfilespath + "images"));
                    JOptionPane.showMessageDialog(appframe, "Critical directory deleted " + LiveDB.serializedfilespath + "images" + " contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
            }

            // NOW RESET PERMS on top level directory to Read once again
            if (new File (LiveDB.serializedfilespath).setReadOnly() == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setRead on " + LiveDB.serializedfilespath));
                // dont exit jaanaa dho maaf kar do just read perms
            }
        } // if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == false)


        boolean okay = false;
        String usrinput = null;
        InputStreamReader is = new InputStreamReader(System.in);
        BufferedReader scan = new BufferedReader(is);
        int result = 0;


       // now get the values for serialized files path other than the default value
       // i have initialized it too.

        if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == true)
        {
            result = JOptionPane.showConfirmDialog(appframe, "YOU ARE INSTALLING/RE-INSTALLING LensView WHICH WILL ERASE PREVIOUS INSTALLATION",
                     "LensView Installation", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);

            if (result != JOptionPane.OK_OPTION)
            {
                JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                System.exit(1);
            }
        } // if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == true)

        okay = true;
        if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == true)
        {
            result = JOptionPane.showConfirmDialog(appframe, "YOU WILL LOOSE ALL PREVIOUS DATA SURE TO PROCEED PLEASE CONFIRM",
                     "LensView Installation", JOptionPane.OK_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);

            if (result != JOptionPane.OK_OPTION)
            {
                JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                System.exit(1);
            }
        } // if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == true)

        okay = false;
        if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == true && LiveDB.AUTOINSTALL == false)
        {
            JOptionPane.showMessageDialog(appframe, "USE NEXT FILECHOOSER TO CHOOSE DIRECTORY FOR DATABASE STORAGE");
            JFileChooser chooser = new JFileChooser ();
            chooser.setCurrentDirectory(new File(".")); // "." indicates cwd (current working directory)
            chooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            result = chooser.showOpenDialog(appframe);

            if (result == JFileChooser.APPROVE_OPTION)
            {
                LiveDB.serializedfilespath = chooser.getSelectedFile().getPath();
                sdp = new File (LiveDB.serializedfilespath);
            }
            else if (result == JFileChooser.CANCEL_OPTION)
            {
                // i create a default directory called LensView and install it there
                if (LiveDB.HOME_EDITION && LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) != -1)
                {
                    if (new File ("C:\\LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create C:\\LensView directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                        JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
                        System.exit(1);
                    }
                    else
                    {
                        if (new File ("C:\\LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default C:\\LensView directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                            System.exit(1);
                        }
                        else new File("C:\\LensView").setReadOnly();
                    }
                    LiveDB.serializedfilespath = new String("C:\\LensView".toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }
                else if (LiveDB.HOME_EDITION == false && LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) != -1)
                {
                    if (NetworkDriveAbsent)
                    {
                        System.err.println(LiveDB.grassHopper("NetWork Drive Absent Assuming " +
                                                    LiveDB.NETWORKDRIVE + ":" + " Add to Network Later"));
                    }

                    if (new File (LiveDB.NETWORKDRIVE + ":\\LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create "
                                + LiveDB.NETWORKDRIVE + ":\\LensView directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                        JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                        System.exit(1);
                    }
                    else
                    {
                        if (new File (LiveDB.NETWORKDRIVE + ":\\LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default "
                                                     + LiveDB.NETWORKDRIVE + ":\\LensView directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                            System.exit(1);
                        }else new File (LiveDB.NETWORKDRIVE + ":\\LensView").setReadOnly();
                    }
                    LiveDB.serializedfilespath = new String((LiveDB.NETWORKDRIVE + ":\\LensView").toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }
                else
                {
                    if (new File (LiveDB.USRDIR + "LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create "
                                + LiveDB.USRDIR + "LensView" + " directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                        JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                        System.exit(1);
                    }
                    else
                    {
                        if (new File (LiveDB.USRDIR + "LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default "
                                  + LiveDB.USRDIR + "LensView" + " directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                            System.exit(1);
                        }else new File (LiveDB.USRDIR + "LensView").setReadOnly();
                    }
                    LiveDB.serializedfilespath = new String((LiveDB.USRDIR  + "LensView").toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }
            }
            else if (result == JFileChooser.ERROR_OPTION)
            {
                System.err.println(LiveDB.grassHopper("Error in choosing serializedfilespath"));
                JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                System.exit(1);
            }

            LiveDB.checkSpaceLeft();

            LiveDB.serializedfilespath += LiveDB.FILESEPERATOR;

            LiveDB.lgfl = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                 + "LensViewLog" + String.valueOf(LiveDB.today.getTime()).trim() + "PID"
                 + String.valueOf(LiveDB.pid).trim()
                 + "_" + LiveDB.DefaultLocale.getDisplayName().toUpperCase().trim() + "_"
                 + LiveDB.LogExtensions [(new Random ()).nextInt(LiveDB.LogExtensions.length)].toUpperCase().trim();

            LiveDB.ErrorLogFile = LiveDB.lgfl.substring(0, LiveDB.lgfl.indexOf(" ") == -1 ?LiveDB.lgfl.length():LiveDB.lgfl.indexOf(" "));

        } // if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == true)

        if (LiveDB.AUTOINSTALL && LiveDB.command_line.equals("FileTableDataFileMap"))
        {
                // i create a default directory called LensView and install it there
                if (LiveDB.HOME_EDITION && LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) != -1)
                {
                    if (new File ("C:\\LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create C:\\LensView directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                        JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                        System.exit(1);
                    }
                    else
                    {
                        if (new File ("C:\\LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default C:\\LensView directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                            System.exit(1);
                        }else new File ("C:\\LensView").setReadOnly();
                    }
                    LiveDB.serializedfilespath = new String("C:\\LensView".toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }
                else if (LiveDB.HOME_EDITION == false && LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS) != -1)
                {
                    if (NetworkDriveAbsent)
                    {
                        System.err.println(LiveDB.grassHopper("NetWork Drive Absent Assuming " +
                                                    LiveDB.NETWORKDRIVE + ":" + " Add to Network Later"));
                    }

                    if (new File (LiveDB.NETWORKDRIVE + ":\\LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create "
                                + LiveDB.NETWORKDRIVE + ":\\LensView directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                      JOptionPane.showMessageDialog(appframe,
                      "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                      System.exit(1);
                    }
                    else
                    {
                        if (new File (LiveDB.NETWORKDRIVE + ":\\LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default "
                                                     + LiveDB.NETWORKDRIVE + ":\\LensView directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                            System.exit(1);
                        }else new File (LiveDB.NETWORKDRIVE + ":\\LensView").setReadOnly();
                    }
                    LiveDB.serializedfilespath = new String((LiveDB.NETWORKDRIVE + ":\\LensView").toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }
                else
                {
                    if (new File (LiveDB.USRDIR + "LensView").isDirectory())
                    {
                        System.err.println(LiveDB.grassHopper("Cannot create "
                                + LiveDB.USRDIR + "LensView" + " directory already exists"));
                        System.err.println(LiveDB.grassHopper("Specify serializedfilespath "
                                + "using FileChooser dialog"));
                        JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                        System.exit(1);
                    }
                    else
                    {
                        if (new File (LiveDB.USRDIR + "LensView").mkdir() == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cannot create default "
                                  + LiveDB.USRDIR + "LensView" + " directory"));
                            System.err.println(LiveDB.grassHopper("Specify serializedfilespath directory using FileChooser dialog"));
                            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                            System.exit(1);
                        }else new File (LiveDB.USRDIR + "LensView").setReadOnly();
                    }
                    LiveDB.serializedfilespath = new String((LiveDB.USRDIR + "LensView").toCharArray());
                    sdp = new File (LiveDB.serializedfilespath);
                }

            LiveDB.checkSpaceLeft();

            LiveDB.serializedfilespath += LiveDB.FILESEPERATOR;

            LiveDB.lgfl = LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR
                 + "LensViewLog" + String.valueOf(LiveDB.today.getTime()).trim() + "PID"
                 + String.valueOf(LiveDB.pid).trim()
                 + "_" + LiveDB.DefaultLocale.getDisplayName().toUpperCase().trim() + "_"
                 + LiveDB.LogExtensions [(new Random ()).nextInt(LiveDB.LogExtensions.length)].toUpperCase().trim();

            LiveDB.ErrorLogFile = LiveDB.lgfl.substring(0, LiveDB.lgfl.indexOf(" ") == -1 ?LiveDB.lgfl.length():LiveDB.lgfl.indexOf(" "));
        }

        if (LiveDB.command_line.equals("FileTableDataFileMap"))
        {
            // make some directories for better organization of data and also to avoid accidental
            // deletions

            //But before all this set the directory perms to write
            try{
                if (sdp.setWritable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("Cant setWrite on:" + LiveDB.serializedfilespath));
                    JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }catch (SecurityException ex_NOKIA77){
                System.err.println(LiveDB.grassHopper(ex_NOKIA77, "Cant setWrite on:" + LiveDB.serializedfilespath));
                JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                System.exit(1);
            }

            if ((sdp = new File(LiveDB.serializedfilespath + "dbf")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dbf"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dbf" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }

                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "dbf" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "policy")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "policy"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "policy" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "policy" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "conf")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "conf"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "conf" + "contact SYSADM");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "conf" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "daemon")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "daemon"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "daemon" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "daemon" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "syc")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "syc"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "syc" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "syc" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "reports")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "reports"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "reports" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "reports" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "dataload")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dataload"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dataload" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "dataload" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "dump")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dump"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dump" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "dump" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "version")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "version"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "version" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "version" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "etc")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "etc"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "etc" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "etc" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "usr")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "usr"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "usr" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "usr" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "backup")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "backup"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "backup" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "backup" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "archive")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "archive"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "archive" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "archive" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "rowsets")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "rowsets"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "rowsets" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "rowsets" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "dev")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dev"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "dev" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "dev" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "spool")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "spool"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "spool" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "spool" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "tmp")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "tmp"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "tmp" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "tmp" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "var")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "var"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "var" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "var" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "bin")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "bin"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "bin" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "bin" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "libs")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "libs"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "libs" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "libs" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }else sdp.setWritable(true, false);
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "boot")).isDirectory() == false)
            {
                // make this directory
                // store the boot image LensView here the other supplementary programs in bin
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "boot"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "boot" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "boot" ));
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "checkin")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "checkin"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "checkin" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "sccs" + "checkin"));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " +  '\n' + LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "chuckout")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "chuckout"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "chuckout" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "sccs" + "chuckout" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "checkout")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "checkout"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "checkout" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "sccs" + "checkout"));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "images")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "images"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "images" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setWritable(true, false) == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setWrite on directory " +
                            LiveDB.serializedfilespath + "images" ));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            if ((sdp = new File(LiveDB.serializedfilespath + "sccs" + "source")).isDirectory() == false)
            {
                // make this directory
                if (sdp.mkdir() == false)
                {
                    System.err.println(LiveDB.grassHopper("In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "source"));
                    JOptionPane.showMessageDialog(appframe, "In-Adequate perms to create directory " + LiveDB.serializedfilespath + "sccs" + "source" + "contact SYSADM ");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + '\n' +  LiveDB.ErrorLogFile);
                    System.exit(1);
                }
                if (sdp.setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant set readonly on directory " +
                            LiveDB.serializedfilespath + "source" ));
                }
            }

            // copy the lensview properties file here to conf directory
            Process process = null;
            InputStream se = null;
            BufferedReader brse = null;
            String command = null;
            String errline = null;

            if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                command = "COPY " + LiveDB.USRDIR + "LENSVIEWPROPERTIESFILE.txt"
                                                  + "  " + LiveDB.serializedfilespath + "conf";
            else
                command = "cp " + LiveDB.USRDIR + "LENSVIEWPROPERTIESFILE.txt"
                                               + "  " + LiveDB.serializedfilespath + "conf";

            if (new File(LiveDB.serializedfilespath + "conf").setWritable(true, false) == false)
            {
                 System.err.println(LiveDB.grassHopper("Cant setwrite on "
                                          + LiveDB.serializedfilespath + "conf"));
                 JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                 System.exit(1);
            }

            try{
               process = Runtime.getRuntime().exec(command);
            }catch(IOException ex_NOKIA62){
                 System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                 JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                 System.exit(1);
            }

            se = process.getErrorStream();

            brse = new BufferedReader (new InputStreamReader(se));

            try{
                 if ((errline = brse.readLine()) != null)
                 {
                    System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                    System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "COPY LENSVIEWPROPERTIES FILE MANUALLY TO CONF DIRECTORY");
                    JOptionPane.showMessageDialog(appframe,
                                LiveDB.USRDIR + "LENSVIEWPROPERTIESFILE.txt"
                                + '\n' + " COPY FAILED" + '\n' +
                                "COPY MANUALLY TO "
                                + LiveDB.serializedfilespath + LiveDB.FILESEPERATOR + "conf");
                 }
            }catch (IOException ex_NOKIA5){
                System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                System.exit(1);
            }

            LiveDB.LENSVIEWPROPERTIESFILE = LiveDB.serializedfilespath + "conf"
                                            + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE.txt";

            if (new File(LiveDB.serializedfilespath + "conf").setReadOnly() == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setReadOnly on "
                                              + LiveDB.serializedfilespath + "conf"));
            }

            try{
                 brse.close();
            }catch (IOException ex_YESKIA23){
               System.err.println(LiveDB.grassHopper(ex_YESKIA23));
            }

            // NOW RESET PERMS ON LiveDB.serializedfilespath

            if (new File (LiveDB.serializedfilespath.substring(0,
                    LiveDB.serializedfilespath.lastIndexOf(LiveDB.FILESEPERATOR))).setReadOnly() == false)
            {
                LiveDB.ALRTLVL = 3; // WARNING
                System.err.println(LiveDB.grassHopper("Cant Set ReadOnly on:" + LiveDB.serializedfilespath));
                // DONT EXIT ITS OKAY JUSt READ PERMS
            }

            // now copy the LENSVIEWPROPERTIESFILE.txt here to USRHOMEDIR
            if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                command = "COPY " + LiveDB.serializedfilespath + "conf"
                        + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE.txt" + " " + LiveDB.USRHOMEDIR
                        + "LENSVIEWPROPERTIESFILE.txt";
            else
                command = "cp " + LiveDB.serializedfilespath + "conf"
                        + LiveDB.FILESEPERATOR + "LENSVIEWPROPERTIESFILE.txt" + " " + LiveDB.USRHOMEDIR
                        + "LENSVIEWPROPERTIESFILE.txt";

            if (new File(LiveDB.serializedfilespath + "conf").setWritable(true, false) == false)
            {
                 System.err.println(LiveDB.grassHopper("Cant setwrite on "
                                          + LiveDB.serializedfilespath + "conf"));
                 JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                 System.exit(1);
            }

            try{
               process = Runtime.getRuntime().exec(command);
            }catch(IOException ex_NOKIA62){
                 System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                 JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                 System.exit(1);
            }

            se = process.getErrorStream();

            brse = new BufferedReader (new InputStreamReader(se));

            try{
                 if ((errline = brse.readLine()) != null)
                 {
                    System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                    System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "COPY LENSVIEWPROPERTIES FILE MANUALLY TO " + LiveDB.USRHOMEDIR);
                    JOptionPane.showMessageDialog(appframe,
                                LiveDB.USRDIR + "LENSVIEWPROPERTIESFILE.txt"
                                + '\n' + " COPY FAILED" + '\n' + "COPY MANUALLY TO "
                                + LiveDB.USRHOMEDIR);
                 }
            }catch (IOException ex_NOKIA5){
                System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                System.exit(1);
            }

            try{
                 brse.close();
            }catch (IOException ex_YESKIA23){
               System.err.println(LiveDB.grassHopper(ex_YESKIA23));
            }

            String imagedir = null;
            if (LiveDB.HOME_EDITION)
                imagedir = LiveDB.USRDIR + "imagery";
            else
                imagedir = LiveDB.COPYFROM;
            // now copy images from directory TO to directory here
            if (new File (imagedir).isDirectory())
            {
                if (LiveDB.COPYTO.isEmpty() == false && LiveDB.COPYTO.trim().length() != 0)
                {
                    if (new File(LiveDB.COPYTO).isDirectory() == false)
                    {
                        System.err.println(LiveDB.grassHopper("LENSVIEWPROPERTIESFILE.txt:"
                                + "key copyimagesto"
                                + " value not directory"));
                        if (new File(LiveDB.COPYTO).mkdir() == false)
                            System.err.println("Cant create directory " + LiveDB.COPYTO);
                        else
                        {
                            if (new File(LiveDB.COPYTO).setWritable(true, false) == false)
                            {
                                System.err.println(LiveDB.grassHopper("Cant setWritable on "
                                        + LiveDB.COPYTO));
                            }
                            else copyimagesto (imagedir);
                        }
                    }
                    else copyimagesto (imagedir);
                }
            }
            else
            {
                System.err.println(LiveDB.grassHopper("LENSVIEWPROPERTIESFILE.txt:"
                                + "key copyimagesfrom"
                                + " value not directory"));
                JOptionPane.showMessageDialog(appframe, "LENSVIEWPROPERTIESFILE.txt:" + "key copyimagesfrom"
                        + '\n' + " value not directory" +'\n'
                        + "Or " + imagedir + "not created as directory" + '\n'
                         + "Manually copy images at O/S" + '\n'
                        + "TO " + LiveDB.serializedfilespath + "images");
            }

            if (LiveDB.HOME_EDITION || (LiveDB.COPYTO.isEmpty() || LiveDB.COPYTO.trim().length() == 0))
            {
                    // just copy one companylogo to images directory
                    JOptionPane.showMessageDialog(appframe, "YOUR lensview.copyimagesto key=value"
                            + '\n' + "IN " + LiveDB.LENSVIEWPROPERTIESFILE + '\n'
                            + "IS INVALID PLEASE MANUALLY COPY AT O/S ALL IMAGES" + '\n'
                            + "TO " + LiveDB.serializedfilespath + "images");

                    if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                        command = "COPY " + LiveDB.USRDIR +  "companylogo.jpg"
                                                          + "  " + LiveDB.serializedfilespath + "images";
                    else
                        command = "cp " + LiveDB.USRDIR + "companylogo.jpg"
                                                          + "  " + LiveDB.serializedfilespath + "images";

                    if (new File(LiveDB.serializedfilespath + "images").setWritable(true, false) == false)
                    {
                        System.err.println(LiveDB.grassHopper("Cant setwrite on "
                                          + LiveDB.serializedfilespath + "images"));
                        System.err.println("LINE:" + LiveDB.logerrorno + "COPY companylogo.jpg manually to images directory");
                        JOptionPane.showMessageDialog(appframe,"Cant setwrite on " + '\n'
                                          + LiveDB.serializedfilespath + "images" + '\n'
                                          + "COPY companylogo.jpg manually to " + '\n'
                                          + LiveDB.serializedfilespath + "images directory");
                    }

                    try{
                        process = Runtime.getRuntime().exec(command);
                    }catch(IOException ex_NOKIA62){
                        System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                        JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                        System.exit(1);
                    }

                    se = process.getErrorStream();

                    brse = new BufferedReader (new InputStreamReader(se));

                    try{
                        if ((errline = brse.readLine()) != null)
                        {
                            System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                            System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "COPY companylogo.jpg FILE MANUALLY TO images DIRECTORY");
                            JOptionPane.showMessageDialog(appframe,
                                LiveDB.USRDIR + "companylogo.jpg"
                                + '\n' + " COPY FAILED" + '\n' +
                                "COPY MANUALLY TO "
                                + LiveDB.serializedfilespath + "images");
                        }
                    }catch (IOException ex_NOKIA5){
                        System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                        JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                        System.exit(1);
                    }

                    if (new File(LiveDB.serializedfilespath + "images").setReadOnly() == false)
                    {
                        System.err.println(LiveDB.grassHopper("Cant setReadOnly on "
                                              + LiveDB.serializedfilespath + "images"));
                    }

                    try{
                        brse.close();
                    }catch (IOException ex_YESKIA23){
                        System.err.println(LiveDB.grassHopper(ex_YESKIA23));
                    }
            }

            if (LiveDB.HOME_EDITION == false) // Pro Edition
            {
                if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
                    command = "COPY " + LiveDB.COPYTRANSFILESFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.serializedfilespath + "etc";
                else
                    command = "cp " + LiveDB.COPYTRANSFILESFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.serializedfilespath + "etc" ;
                try{
                    process = Runtime.getRuntime().exec(command);
                }catch(IOException ex_NOKIA62){
                    System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
                    JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                    System.exit(1);
                }

                se = process.getErrorStream();
                brse = new BufferedReader (new InputStreamReader(se));

                try{
                    if ((errline = brse.readLine()) != null)
                    {
                        System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                        System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "FAIL COPY LANGUAGE FILES MANUALLY TO DIRECTORY");
                        JOptionPane.showMessageDialog(appframe,
                                "LANGUAGE FILE COPY FAILED" + '\n' + "COPY FROM:" + LiveDB.COPYTRANSFILESFROM
                                + '\n' + "COPY TO:" + LiveDB.serializedfilespath + "etc" + '\n'
                                + "TELL SYSADMIN TO COPY MANUALLY" +
                                '\n' + "CONTINUING INSTALLATION ...");
                    }
                }catch (IOException ex_NOKIA5){
                    System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
                    JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
                    System.exit(1);
                }

                try{
                    brse.close();
                }catch (IOException ex_YESKIA23){
                    System.err.println(LiveDB.grassHopper(ex_YESKIA23));
                }
            }
        } // if (LiveDB.command_line.equalsIgnoreCase("FileTableDataFileMap") == true)
    }

    // thisis just a auxilliary static method for the above method
    private static void copyimagesto (String p_COPYFROM){

        Process process = null;
        InputStream se = null;
        BufferedReader brse = null;
        String command = null;
        String errline = null;

        // FIRST setWrite on LiveDB.COPYTO
        if (new File(LiveDB.COPYTO).setWritable(true, false) == false)
        {
            System.err.println(LiveDB.grassHopper("Can setWrite on " + LiveDB.COPYTO ));
            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
            System.exit(1);
        }

        if (LiveDB.OPERATINGSYSTEM.indexOf(LiveDB.WINDOWS)!= -1)
            command = "COPY " + p_COPYFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.COPYTO;
        else
            command = "cp " + p_COPYFROM + LiveDB.FILESEPERATOR + "*.*"
                                     + "  " + LiveDB.COPYTO ;
        try{
              process = Runtime.getRuntime().exec(command);
        }catch(IOException ex_NOKIA62){
               System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA62));
               JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
               System.exit(1);
        }

        se = process.getErrorStream();
        brse = new BufferedReader (new InputStreamReader(se));

        try{
              if ((errline = brse.readLine()) != null)
              {
                 System.err.println(LiveDB.grassHopper(errline.substring(0,
                                       errline.length() > 60 ? 60: errline.length())));
                 System.err.println("LINE:" + LiveDB.logerrorno + ":"
                                       + "FAIL COPY IMAGES FILES MANUALLY TO DIRECTORY");
                 JOptionPane.showMessageDialog(appframe,
                         "IMAGES COPYING FAILED" + '\n' + "COPY FROM:" + p_COPYFROM
                         + '\n' + "COPY TO:" + LiveDB.COPYTO + '\n'
                         + "TELL SYSADMIN TO COPY MANUALLY" +
                         '\n' + "CONTINUING INSTALLATION ...");
              }
       }catch (IOException ex_NOKIA5){
               System.err.println(LiveDB.grassHopper("Command:" + command, ex_NOKIA5));
               JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
               System.exit(1);
       }

       try{
              brse.close();
       }catch (IOException ex_YESKIA23){
               System.err.println(LiveDB.grassHopper(ex_YESKIA23));
       }

       // RESET PERMS ON LiveDB.COPYTO to setReadonly

      if (new File (LiveDB.COPYTO).setReadOnly() == false)
      {
          LiveDB.ALRTLVL = 3;
          System.err.println(LiveDB.grassHopper("Cant setReadonly on " + LiveDB.COPYTO));
          JOptionPane.showMessageDialog(appframe,
                         "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                         + '\n' + LiveDB.ErrorLogFile);
          System.exit(1);
      }
    }

}

