/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.UTFDataFormatException;
import java.util.Date;
import java.io.ObjectOutput;
import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.Externalizable;
import java.io.File;
import java.util.concurrent.Semaphore;
import static DatabaseEngine.LiveDB.ni;
import static DatabaseEngine.LiveDB.ct;
import static DatabaseEngine.LiveDB.ft;


public class NodalInfo implements Externalizable, Cloneable, Tables {
    private short screenX;
    private short screenY;
    private String weather;
    private String poachers;
    private String poachingincidents;
    private WildLifeTypes [] wildlifetypes;
    private short goslinbug;
    private String wildlifeofficers;
    private String wildlifeencounters;
    private String maneaters;
    private String vegetation;
    private String contourmap;
    private String physicalmap;
    private String roadmap;
    private String trekmaps;
    private String watermap;
    private String homestay;
    private String hotels;
    private String foresthouses;
    private String carrentals;
    private String scooterrentals;
    private String cyclerentals;
    private String donkeyrentals;
    private String horserentals;
    private String banks;
    private String currencyexch;
    private String hospitals;
    private String lawenforce;
    private String researchteams;
    private String researchprojects;
    private String wildlifereserves;
    private String protectedparks;
    private String areaevents;
    private String vetdoctors;
    private String triballeaders;
    private String picsales;
    private String statebusservices;
    private String prvtbusservices;
    private String taxicompanies;
    private String airports;
    private String airlines;
    private String harbour;
    private String shiplines;
    private String roadcondition;
    private String guides;
    private String porters;
    private String cooks;
    private String trekcompanies;
    private String restaurants;
    private String camerastores;
    private String filmlabs;
    private long rowid; // 51 fields

    private transient NodalInfo nod;
    private transient WildLifeTypes myclones [];
    private transient Semaphore rowlock ;
    private transient File srf;
    private transient int itn;
    private transient long fieldchanges; // for Ultra Fast Commits

    {
        myclones = null;
        nod = null;
        rowlock = new Semaphore (1,true);
        srf = null;
        itn = 14;
        fieldchanges = 0L;
    }

    public NodalInfo (short p_sx, short p_sy, String p_weather, String p_poachers, String p_poachinc,
            WildLifeTypes [] p_wldtyps, String p_wldoffrs, String p_wldlfenc, String p_maneat,
            String p_veg, String p_contmap, String p_phymap, String p_roadmap, String p_trekmap,
            String p_watermap, String p_homestay, String p_hotels, String p_frsthouses,
            String p_carrentals, String p_scooterrentals, String p_cyclerentals, String p_donkeyrentals,
            String p_horserentals, String p_banks, String p_currexch, String p_hosp, String p_lawenf,
            String p_researchteams, String p_researchproj, String p_wildrsvrs, String p_protparks,
            String p_areaevents, String p_vetdoctors, String p_triballeaders, String p_picsales,
            String p_bussrvc, String p_prvtbusrvc, String p_taxicomp, String p_airports, String p_airlines,
            String p_harbour, String p_shiplines, String p_roadcond, String p_guides, String p_porters,
            String p_cooks, String p_trekcomp, String p_restau, String p_camerastore, String p_filmlabs,
            long rowid)
    {
            setScreenX(p_sx);
            setScreenY(p_sy);
            setWeather(p_weather);
            setPoachers(p_poachers);
            setPoachingincidents(p_poachinc);
            setWildlifetypes(p_wldtyps);
            goslinbug = 256; // some number
            setWildlifeofficers(p_wldoffrs);
            setWildlifeencounters(p_wldlfenc);
            setManeaters(p_maneat);
            setVegetation(p_veg);
            setContourmap(p_contmap);
            setPhysicalmap(p_phymap);
            setRoadmap(p_roadmap);
            setTrekmaps(p_trekmap);
            setWatermap(p_watermap);
            setHomestay(p_homestay);
            setHotels(p_hotels);
            setForesthouses(p_frsthouses);
            setCarrentals(p_carrentals);
            setScooterrentals(p_scooterrentals);
            setCyclerentals(p_cyclerentals);
            setDonkeyrentals(p_donkeyrentals);
            setHorserentals(p_horserentals);
            setBanks(p_banks);
            setCurrencyexch(p_currexch);
            setHospitals(p_hosp);
            setLawenforce(p_lawenf);
            setResearchteams(p_researchteams);
            setResearchprojects(p_researchproj);
            setWildlifereserves(p_wildrsvrs);
            setProtectedparks(p_protparks);
            setAreaevents(p_areaevents);
            setVetdoctors(p_vetdoctors);
            setTriballeaders(p_triballeaders);
            setPicsales(p_picsales);
            setStatebusservices(p_bussrvc);
            setPrvtbuservices(p_prvtbusrvc);
            setTaxicompanies(p_taxicomp);
            setAirports(p_airports);
            setAirlines(p_airlines);
            setHarbour(p_harbour);
            setShiplines(p_shiplines);
            setRoadcondition(p_roadcond);
            setGuides(p_guides);
            setPorters(p_porters);
            setCooks(p_cooks);
            setTrekcompanies(p_trekcomp);
            setRestaurants(p_restau);
            setCamerastores(p_camerastore);
            setFilmlabs(p_filmlabs);
    }

    @Override
    protected Object clone (){
        rowlock.acquireUninterruptibly();
        try{
            nod = (NodalInfo)super.clone();
            for (int i = 0 ; i < nod.wildlifetypes.length; i++)
                nod.wildlifetypes[i] = (WildLifeTypes)nod.wildlifetypes[i].clone();
            nod.setWeather(nod.getWeather());
            nod.setPoachers(nod.getPoachers());
            nod.setPoachingincidents(nod.getPoachingincidents());
            nod.setWildlifeofficers(nod.getWildlifeofficers());
            nod.setWildlifeencounters(nod.getWildlifeencounters());
            nod.setManeaters(nod.getManeaters());
            nod.setVegetation(nod.getVegetation());
            nod.setContourmap(nod.getContourmap());
            nod.setPhysicalmap(nod.getPhysicalmap());
            nod.setRoadmap(nod.getRoadmap());
            nod.setTrekmaps(nod.getTrekmap());
            nod.setWatermap(nod.getWatermap());
            nod.setHomestay(nod.getHomestay());
            nod.setHotels(nod.getHotels());
            nod.setForesthouses(nod.getForesthouses());
            nod.setCarrentals(nod.getCarrentals());
            nod.setScooterrentals(nod.getScooterrentals());
            nod.setCyclerentals(nod.getCyclerentals());
            nod.setDonkeyrentals(nod.getDonkeyrentals());
            nod.setHorserentals(nod.getHorserentals());
            nod.setBanks(nod.getBanks());
            nod.setCurrencyexch(nod.getCurrencyexch());
            nod.setHospitals(nod.getHospitals());
            nod.setLawenforce(nod.getLawenforce());
            nod.setResearchteams(nod.getResearchteams());
            nod.setResearchprojects(nod.getResearchprojects());
            nod.setWildlifereserves(nod.getWildlifereserves());
            nod.setProtectedparks(nod.getProtectedparks());
            nod.setAreaevents(nod.getAreaevents());
            nod.setVetdoctors(nod.getVetdoctors());
            nod.setTriballeaders(nod.getTriballeaders());
            nod.setPicsales(nod.getPicsales());
            nod.setStatebusservices(nod.getStatebusservices());
            nod.setPrvtbuservices(nod.getPrvtbusservices());
            nod.setTaxicompanies(nod.getTaxicompanies());
            nod.setAirports(nod.getAirports());
            nod.setAirlines(nod.getAirlines());
            nod.setHarbour(nod.getHarbour());
            nod.setShiplines(nod.getShiplines());
            nod.setRoadcondition(nod.getRoadcondition());
            nod.setGuides(nod.getGuides());
            nod.setPorters(nod.getPorters());
            nod.setCooks(nod.getCooks());
            nod.setTrekcompanies(nod.getTrekcompanies());
            nod.setRestaurants(nod.getRestaurants());
            nod.setCamerastores(nod.getCamerastores());
            nod.setFilmlabs(nod.getFilmlabs());                                    
        }catch (CloneNotSupportedException ex_NOKIA4){
            throw new InternalError (ex_NOKIA4.toString());
        }
        rowlock.release();
        return nod;
    }

    protected int SIZEOF () {
        int totsize = 0;

        totsize = 2 + 2 + ((weather.length() + poachers.length() + poachingincidents.length() +
                wildlifeofficers.length() + wildlifeencounters.length() + maneaters.length() +
                vegetation.length() + contourmap.length() + physicalmap.length() + roadmap.length()
                + trekmaps.length() + watermap.length() + homestay.length() + hotels.length()
                + foresthouses.length() + carrentals.length() + scooterrentals.length()
                + cyclerentals.length() + donkeyrentals.length() + horserentals.length()
                + banks.length() + currencyexch.length() + hospitals.length() + lawenforce.length()
                + researchteams.length() + researchprojects.length() + wildlifereserves.length()
                + protectedparks.length() + areaevents.length() + vetdoctors.length() + triballeaders.length()
                + picsales.length() + statebusservices.length() + prvtbusservices.length()
                + taxicompanies.length() + airports.length() + airlines.length() + harbour.length()
                + shiplines.length() + roadcondition.length() + guides.length() + porters.length()
                + cooks.length() + trekcompanies.length() + restaurants.length() + camerastores.length()
                + filmlabs.length()) * 2) + 8 ;

        for (int i = 0; i < wildlifetypes.length; i++)
            totsize += wildlifetypes[i].SIZEOF();

        totsize += 2; // goslin bug

        return totsize;
    }

    void setScreenX (short p_sx){

        if (p_sx < 0 || p_sx > 500)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid Value p_sx = " + p_sx));
            System.exit(1);
        }

        rowlock.acquireUninterruptibly();
        screenX = p_sx;
        rowlock.release();
    }

    void setScreenY (short p_sy) {

        if (p_sy < 0 || p_sy > 200)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid Value p_sy = " + p_sy));
            System.exit(1);
        }

        rowlock.acquireUninterruptibly();
        screenY = p_sy;
        rowlock.release();
    }

    void setWeather (String p_url){
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        weather = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setPoachers (String p_url){
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        poachers = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setPoachingincidents (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        poachingincidents = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setWildlifetypes (WildLifeTypes [] p_wldtyp) {
        rowlock.acquireUninterruptibly();
        if (p_wldtyp == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid param p_wldtyp = null"));
            System.exit(1);
        }

        for (int i = 0; i < p_wldtyp.length; i++)
            wildlifetypes [i] = (WildLifeTypes)p_wldtyp[i].clone();
        
        rowlock.release();
    }

    void setWildlifeofficers (String p_url){
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        wildlifeofficers = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setWildlifeencounters (String p_url){
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        wildlifeencounters = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setManeaters (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        maneaters = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setVegetation (String p_url){
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        vegetation = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setContourmap (String p_url){
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        contourmap = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setPhysicalmap (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        physicalmap = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setRoadmap (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        roadmap = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setTrekmaps (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        trekmaps = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setWatermap (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        watermap = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setHomestay (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        homestay = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setHotels (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        hotels = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setForesthouses (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        foresthouses = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setCarrentals (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        carrentals = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setScooterrentals (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        scooterrentals = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setCyclerentals (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        cyclerentals = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setDonkeyrentals (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        donkeyrentals = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setHorserentals (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        horserentals = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setBanks (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        banks = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setCurrencyexch (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        currencyexch = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setHospitals (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        hospitals = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setLawenforce (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        lawenforce = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setResearchteams (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        researchteams = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setResearchprojects (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        researchprojects = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setWildlifereserves (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        wildlifereserves = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setProtectedparks (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        protectedparks = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setAreaevents (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        areaevents = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setVetdoctors (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        vetdoctors = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setTriballeaders (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        triballeaders = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setPicsales (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        picsales = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setStatebusservices (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        statebusservices = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setPrvtbuservices (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        prvtbusservices = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setTaxicompanies (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        taxicompanies = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setAirports (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        airports = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setAirlines (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        airlines = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setHarbour (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        weather = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setShiplines (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        shiplines = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setRoadcondition (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        roadcondition = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setGuides (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        guides = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setPorters (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        porters = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setCooks (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        cooks = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setTrekcompanies (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        trekcompanies = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setRestaurants (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        restaurants = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setCamerastores (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        camerastores = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setFilmlabs (String p_url) {
        rowlock.acquireUninterruptibly();
        if (validurl(p_url) == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid URL:" + p_url));
            System.exit(1);
        }
        filmlabs = new String(p_url.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_url.length()));
        rowlock.release();
    }

    void setRowid (long p_rowid){
        if (LiveDB.LiveSharedDB[ni].length == 0 && p_rowid != 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid Args p_Rowid " + p_rowid +
                    " table NodalInfo"));
            System.exit(1);
        }
        rowlock.acquireUninterruptibly();
        rowid = p_rowid;
        rowlock.release();
    }

    protected short getScreenX () {
        return screenX;
    }

    protected short getScreenY () {
        return screenY;
    }

    protected String getWeather () {
        return new String (weather.trim().toCharArray());
    }

    protected String getPoachers () {
        return new String (poachers.trim().toCharArray());
    }

    protected String getPoachingincidents () {
        return new String (poachingincidents.trim().toCharArray());
    }

    protected WildLifeTypes [] getWildlifetypes () {        
        for ( int i = 0; i < wildlifetypes.length; i++)
            myclones[i] = (WildLifeTypes)wildlifetypes[i].clone();
                    
        return myclones;
    }

    protected String getWildlifeofficers () {
        return new String (wildlifeofficers.trim().toCharArray());
    }

    protected String getWildlifeencounters () {
        return new String (wildlifeencounters.trim().toCharArray());
    }

    protected String getManeaters () {
        return new String (maneaters.trim().toCharArray());
    }

    protected String getVegetation () {
        return new String (vegetation.trim().toCharArray());

    }

    protected String getContourmap () {
        return new String (contourmap.trim().toCharArray());
    }

    protected String getPhysicalmap () {
        return new String (physicalmap.trim().toCharArray());
    }

    protected String getRoadmap () {
        return new String (roadmap.trim().toCharArray());
    }

    protected String getTrekmap () {
        return new String (trekmaps.trim().toCharArray());
    }

    protected String getWatermap () {
        return new String (watermap.trim().toCharArray());
    }

    protected String getHomestay () {
        return new String (homestay.trim().toCharArray());
    }

    protected String getHotels () {
        return new String (hotels.trim().toCharArray());
    }

    protected String getForesthouses () {
        return new String (foresthouses.trim().toCharArray());
    }

    protected String getCarrentals () {
        return new String (carrentals.trim().toCharArray());
    }

    protected String getScooterrentals () {
        return new String (scooterrentals.trim().toCharArray());
    }

    protected String getCyclerentals () {
        return new String (cyclerentals.trim().toCharArray());
    }

    protected String getDonkeyrentals () {
        return new String (donkeyrentals.trim().toCharArray());
    }

    protected String getHorserentals () {
        return new String (horserentals.trim().toCharArray());
    }

    protected String getBanks () {
        return new String (banks.trim().toCharArray());
    }

    protected String getCurrencyexch () {
        return new String (currencyexch.trim().toCharArray());
    }

    protected String getHospitals () {
        return new String (hospitals.trim().toCharArray());
    }

    protected String getLawenforce () {
        return new String (lawenforce.trim().toCharArray());
    }

    protected String getResearchteams () {
        return new String (researchteams.trim().toCharArray());
    }

    protected String getResearchprojects () {
        return new String (researchprojects.trim().toCharArray());
    }

    protected String getWildlifereserves () {
        return new String (wildlifereserves.trim().toCharArray());
    }

    protected String getProtectedparks () {
        return new String (protectedparks.trim().toCharArray());
    }

    protected String getAreaevents () {
        return new String (areaevents.trim().toCharArray());
    }

    protected String getVetdoctors () {
        return new String (vetdoctors.trim().toCharArray());
    }

    protected String getTriballeaders () {
        return new String (triballeaders.trim().toCharArray());
    }

    protected String getPicsales () {
        return new String (picsales.trim().toCharArray());
    }

    protected String getStatebusservices () {
        return new String (statebusservices.trim().toCharArray());
    }

    protected String getPrvtbusservices () {
        return new String (prvtbusservices.trim().toCharArray());
    }

    protected String getTaxicompanies () {
        return new String (taxicompanies.trim().toCharArray());
    }

    protected String getAirports () {
        return new String (airports.trim().toCharArray());
    }

    protected String getAirlines () {
        return new String (airlines.trim().toCharArray());
    }

    protected String getHarbour () {
        return new String (harbour.trim().toCharArray());
    }

    protected String getShiplines () {
        return new String (shiplines.trim().toCharArray());
    }

    protected String getRoadcondition () {
        return new String (roadcondition.trim().toCharArray());
    }

    protected String getGuides () {
        return new String (guides.trim().toCharArray());
    }

    protected String getPorters () {
        return new String (porters.trim().toCharArray());
    }

    protected String getCooks () {
        return new String (cooks.trim().toCharArray());
    }

    protected String getTrekcompanies () {
        return new String (trekcompanies.trim().toCharArray());
    }

    protected String getRestaurants () {
        return new String (restaurants.trim().toCharArray());
    }

    protected String getCamerastores () {
        return new String (camerastores.trim().toCharArray());
    }

    protected String getFilmlabs () {
        return new String (filmlabs.trim().toCharArray());
    }

    protected long getRowid () {
        return rowid;
    }

    static boolean validurl (String p_url){
        // can be a url
        // can also be file:
        // can also be unc path
        // but all html files
        return true;
    }

    @Override
    public final void readExternal (ObjectInput stream) throws EOFException, IOException {

        rowlock.acquireUninterruptibly();
        try{
              screenX = stream.readShort();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class NodalInfo Field screenX"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class NodalInfo Field screenX"));
              throw new IOException ();
        }

        try{
              screenY = stream.readShort();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class NodalInfo Field screenY"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class NodalInfo Field screenY"));
              throw new IOException ();
        }

        try{
              weather = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field weather"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field weather"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field weather"));
              throw new IOException ();
        }

        try{
              poachers = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field poachers"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field poachers"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field poachers"));
              throw new IOException ();
        }

        try{
              poachingincidents = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field poachingincidents"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field poachingincidents"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field poachingincidents"));
              throw new IOException ();
        }

        // THIS CRITTER IS TRICKY CHECK DURING TESTING
        // Now it should be safe with the field goslinbug
        do
        {
            try
            {
                wildlifetypes [wildlifetypes.length] = new WildLifeTypes() ;
                this.wildlifetypes[wildlifetypes.length -1].readExternal(stream);
            }catch (EOFException ex_NOKIA8){
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper(ex_NOKIA8));
                System.exit(1);
            }catch (UTFDataFormatException ex_NOKIA77){
                 this.wildlifetypes[wildlifetypes.length -1] = null;
                 break;                
            }catch (IOException ex_NOKIA55){
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper(ex_NOKIA55));
                System.exit(1);
            }
        }while (true);

        try{
              goslinbug = stream.readShort();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class NodalInfo Field goslinbug"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class NodalInfo Field goslinbug"));
              throw new IOException ();
        }

        try{
              wildlifeofficers = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field wildlifeofficers"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field wildlifeofficers"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field wildlifeofficers"));
              throw new IOException ();
        }

        try{
              wildlifeencounters = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field wildlifeencounters"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field wildlifeencounters"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field wildlifeencounters"));
              throw new IOException ();
        }

        try{
              maneaters = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field maneaters"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field maneaters"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field maneaters"));
              throw new IOException ();
        }

        try{
              vegetation = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field vegetation"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field vegetation"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field vegetation"));
              throw new IOException ();
        }
        try{
              contourmap = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field contourmap"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field contourmap"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field contourmap"));
              throw new IOException ();
        }

        try{
              physicalmap = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field physicalmap"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field physicalmap"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field physicalmap"));
              throw new IOException ();
        }

        try{
              roadmap = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field roadmap"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field roadmap"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field roadmap"));
              throw new IOException ();
        }

        try{
              trekmaps = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field trekmaps"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field trekmaps"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field trekmaps"));
              throw new IOException ();
        }

        try{
              watermap = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field watermap"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field watermap"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field watermap"));
              throw new IOException ();
        }

        try{
              homestay = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field homestay"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field homestay"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field homestay"));
              throw new IOException ();
        }

        try{
              hotels = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field hotels"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field hotels"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field hotels"));
              throw new IOException ();
        }


        try{
              foresthouses = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field foresthouses"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field foresthouses"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field foresthouses"));
              throw new IOException ();
        }

        try{
              carrentals = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field carrentals"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field carrentals"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field carrentals"));
              throw new IOException ();
        }

        try{
              scooterrentals = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field scooterrentals"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field scooterrentals"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field scooterrentals"));
              throw new IOException ();
        }

        try{
              cyclerentals = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field cyclerentals"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field cyclerentals"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field cyclerentals"));
              throw new IOException ();
        }

        try{
              donkeyrentals = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field donkeyrentals"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field donkeyrentals"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field donkeyrentals"));
              throw new IOException ();
        }

        try{
              horserentals = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field horserentals"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field horserentals"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field horserentals"));
              throw new IOException ();
        }

        try{
              banks = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field banks"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field banks"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field banks"));
              throw new IOException ();
        }

        try{
              currencyexch = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field currencyexch"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field currencyexch"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field currencyexch"));
              throw new IOException ();
        }

        try{
              hospitals = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field hospitals"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field hospitals"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field hospitals"));
              throw new IOException ();
        }

        try{
              lawenforce = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field lawenforce"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field lawenforce"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field lawenforce"));
              throw new IOException ();
        }

        try{
              researchteams = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field researchteams"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field researchteams"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field researchteams"));
              throw new IOException ();
        }

        try{
              researchprojects = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field researchprojects"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field researchprojects"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field researchprojects"));
              throw new IOException ();
        }

        try{
              wildlifereserves = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field wildlifereserves"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field wildlifereserves"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field wildlifereserves"));
              throw new IOException ();
        }

        try{
              protectedparks = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field protectedparks"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field protectedparks"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field protectedparks"));
              throw new IOException ();
        }

        try{
              areaevents = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field areaevents"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field areaevents"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field areaevents"));
              throw new IOException ();
        }

        try{
              vetdoctors = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field vetdoctors"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field vetdoctors"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field vetdoctors"));
              throw new IOException ();
        }

        try{
              triballeaders = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field triballeaders"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field triballeaders"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field triballeaders"));
              throw new IOException ();
        }

        try{
              picsales = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field picsales"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field picsales"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field picsales"));
              throw new IOException ();
        }

        try{
              statebusservices = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field statebusservices"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field statebusservices"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field statebusservices"));
              throw new IOException ();
        }

        try{
              prvtbusservices = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field prvtbusservices"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field prvtbusservices"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field prvtbusservices"));
              throw new IOException ();
        }

        try{
              taxicompanies = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field taxicompanies"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field taxicompanies"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field taxicompanies"));
              throw new IOException ();
        }

        try{
              airports = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field airports"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field airports"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field airports"));
              throw new IOException ();
        }

        try{
              airlines = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field airlines"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field airlines"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field airlines"));
              throw new IOException ();
        }

        try{
              harbour = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field harbour"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field harbour"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field harbour"));
              throw new IOException ();
        }

        try{
              shiplines = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field shiplines"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field shiplines"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field shiplines"));
              throw new IOException ();
        }

        try{
              roadcondition = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field roadcondition"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field roadcondition"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field roadcondition"));
              throw new IOException ();
        }

        try{
              guides = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field guides"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field guides"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field guides"));
              throw new IOException ();
        }

        try{
              porters = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field porters"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field porters"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field porters"));
              throw new IOException ();
        }

        try{
              cooks = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field cooks"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field cooks"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field cooks"));
              throw new IOException ();
        }

        try{
              trekcompanies = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field trekcompanies"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field trekcompanies"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field trekcompanies"));
              throw new IOException ();
        }

        try{
              restaurants = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field restaurants"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field restaurants"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field restaurants"));
              throw new IOException ();
        }

        try{
              camerastores = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field camerastores"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field camerastores"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field camerastores"));
              throw new IOException ();
        }

        try{
              filmlabs = stream.readUTF();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal NodalInfo Field filmlabs"));
              throw new EOFException ();
        }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "readExternal NodalInfo Field filmlabs"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal NodalInfo Field filmlabs"));
              throw new IOException ();
        }
 
        try{
              rowid = stream.readLong();
        }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "readExternal Class NodalInfo Field rowid"));
              throw new EOFException ();
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "readExternal Class NodalInfo Field rowid"));
              throw new IOException ();
        }

        rowlock.release();
    }

    @Override
    public final void writeExternal(ObjectOutput stream) throws IOException {

        rowlock.acquireUninterruptibly();
        int itr = -1; // Installed table row in InstalledTables

        // first find the rowid for this table pcn = 17 in InstalledTables
        if (LiveDB.indxinstalledTables.get(Integer.toString(ni)) == null)
        {
            LiveDB.ALRTLVL = 4;
            System.err.println(LiveDB.grassHopper("NodalInfo misses entry for self in indxinstalledTables"));
            // perhaps the index is corrupted so check the physical table
            for (int i = 0; i < LiveDB.LiveSharedDB[itn].length; i++)
            {
                if (((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getTableno() == ni)
                   itr = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getRowid();
            }

            if (itr == -1 || itr > LiveDB.maxtables)
            {
                LiveDB.ALRTLVL = 2;
                System.err.println(LiveDB.grassHopper("NodalInfo misses entry for self in indxinstalledTables"));
                System.exit(1);
            }
        }
        else
            itr = (int)(long)LiveDB.indxinstalledTables.get(Integer.toString(ni));

        srf = new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft]
                [(int)((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).getTableno()]).getFilename());

        // outsize should be negative before every write
        ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeShort(screenX);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field screenX"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeShort(screenY);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field screenY"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(weather);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field weather"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(poachers);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field poachers"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during WildLifeTypes serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(poachingincidents);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field poachingincidents"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/


        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        for (int i = 0; i < wildlifetypes.length; i++)
        {
            try{
                wildlifetypes[i].writeExternal(stream);
            }catch (IOException ex_NOKIA88){
                LiveDB.ALRTLVL = 15;
                System.err.println(LiveDB.grassHopper(ex_NOKIA88));
                System.exit(1);
            }
        }

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeShort(goslinbug);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field goslinbug"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/
        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(wildlifeofficers);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field wildlifeofficers"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(wildlifeencounters);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field wildlifeencounters"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(maneaters);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field maneaters"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(vegetation);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field vegetation"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(contourmap);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field contourmap"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(physicalmap);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field physicalmap"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(roadmap);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field roadmap"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(trekmaps);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field trekmaps"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(watermap);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field watermap"));
              throw new IOException ();
        }
        
        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(homestay);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field homestay"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(hotels);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field hotels"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(foresthouses);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field foresthouses"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(carrentals);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field carrentals"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(scooterrentals);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field scooterrentals"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/


        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(cyclerentals);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field cyclerentals"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(donkeyrentals);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field donkeyrentals"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(horserentals);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field horserentals"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(banks);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field banks"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(currencyexch);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field currencyexch"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(hospitals);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field hospitals"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(lawenforce);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field lawenforce"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(researchteams);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field researchteams"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(researchprojects);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field researchprojects"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(wildlifereserves);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field wildlifereserves"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(protectedparks);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field protectedparks"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(areaevents);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field areaevents"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(vetdoctors);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field vetdoctors"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(triballeaders);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field triballeaders"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/


        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(picsales);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field picsales"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(statebusservices);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field statebusservices"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(prvtbusservices);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field prvtbusservices"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(taxicompanies);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field taxicompanies"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(airports);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field airports"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(airlines);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field airlines"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(harbour);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field harbour"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(shiplines);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field shiplines"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(roadcondition);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field roadcondition"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(guides);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field guides"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(porters);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field porters"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(cooks);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field cooks"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(trekcompanies);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field trekcompanies"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(restaurants);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field restaurants"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(camerastores);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field camerastores"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeUTF(filmlabs);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field filmlabs"));
              throw new IOException ();
        }

        /*
        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }*/

        // outsize should be negative before every write
        // uncomment this line if you are writing code for Ultra Fast commits
        // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
        try{
              stream.writeLong(rowid);
        }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "writeExternal Class NodalInfo Field rowid"));
              throw new IOException ();
        }


        try{
            stream.flush();
        }catch (IOException ex_NOKIA73){
            System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during NodalInfo serialization"));
            System.exit(1);
        }

        // setOutsize to positive value after every successfull write
        // so if there is a power outage in between we will know that there has been a serialization
        // failure and the serialized file is corrupted and take necessary steps to restpre the
        // serialized file from CrashRecovery or ChangeTracker or if both CrashRecovery and ChangeTracker
        // are corrupted then restore from last autobackup
        ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length());
        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
        new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
        LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);
        rowlock.release();
    }
    // although each instance of this Class NodalInfo represents a single row
    // we are committing the entire table here but before that a few checks and balances

    @Override
    public final boolean COMMIT(){

        boolean fnd = false;

        // we are committing the FileTableDataFileMap so mark those rows with change_flag 'C'
        for (int rw =  (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
            if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == ni
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'F'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'C'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'K'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'T')
            {
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).setChange_flag('C');
                fnd = true;
                // insert an entry in ChangeTracker table for this table
                // Basically what this does is to backup this entirerow where you
                // setChange_flag('C') otherwise database reconstruct of ChangeTracker will fail.
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker ((long)ct,rw, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ct][rw],(long)LiveDB.LiveSharedDB[ct].length);
            }
        }

        if (fnd)
        {
            // for the sake of dbfRepair we take a restore file which may be a BAD copy
            // since we are not checking for the presence of a .syc file on disk. If we
            // look for a .syc file on disk then this commit will take very very long.
            LiveDB.CopyFile(LiveDB.serializedfilespath
                   + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][ni]).getFilename() + ".ser",
                   LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
                   ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][ni]).getFilename() + ".ser" + ".res");
            if ( LiveDB.commit_database(ni) == false )
                return false;
        }

        return true;
    }

    @Override
    public final boolean COMMITINDEXES(){

        if (LiveDB.LiveSharedDB[ni].length == 0)
            return false;
        return LiveDB.write_IndexFile(ni);
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(ni) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }
}


