/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Random;
import java.util.Set;
import static DatabaseEngine.LiveDB.ct;
import static DatabaseEngine.LiveDB.cr;
import static DatabaseEngine.LiveDB.crr;
import static DatabaseEngine.LiveDB.it;
import static DatabaseEngine.LiveDB.rt;


/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadsrtindx
 * CLASS NAME : SortandIndex implements Runnable
 * @LOOKSY:ReportsTable.java
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:ShoppingCart.java
 *
 *
 * @LOOKSY:ThreadController.TakeOffTimes[2], ThreadController.LandingTimes[2], LiveDB.system_exit, LiveDB.DiamondsAreForeverReport
 * @LOOKSY:LiveDB.LogFileSabotageCheck(), LiveDB.pid, LiveDB.reindexall, LiveDB.REALTABLES, LiveDB.SmoothExitCondition
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.databaseloading, LiveDB.command_line, LiveDB.tablenameidentifier
 * @LOOKSY:LiveDB.QuantumOfSolaceReport, LiveDB.LiveSharedDB, LiveDB.RunAwayBrideReport, LiveDB.CityOfAngelsReport
 * @LOOKSY:LiveDB.maxrepid,LiveDB.minrepid,LiveDB.usersloggedin, LiveDB.CRSR, LiveDB.midnight, LiveDB.YouGotMailReport
 * @LOOKSY:LiveDB.indxreportAllocation, LiveDB.srt1reportstable, LiveDB.srt2reportstable, LiveDB.srt3reportstable
 * @LOOKSY:LiveDB.reportsforthispid, LiveDB.indxreportRecentRow, LiveDB.indxreportGeneration, LiveDB.reportmethodidentifier
 * @LOOKSY:LiveDB.indxcustomerRegister, LiveDB.OctopussyReport, LiveDB.HerMajestiesServiceReport, LiveDB.TopGunReport
 * @LOOKSY:LiveDB.FrenchKissReport, LiveDB.NeverSayNeverAgainReport, LiveDB.YouOnlyLiveTwiceReport
 * @LOOKSY:LiveDB.WhenHarryMetSallyReport, LiveDB.TheDoorsReport, LiveDB.SleeplessInSeattleReport, LiveDB.iQReport
 * @LOOKSY:LiveDB.LivingDaylightsReport, LiveDB.CourageUnderFireReport, LiveDB.indxcrashRecovery, LiveDB.MoneyMoneyMoneyReport
 * @LOOKSY:LiveDB.DrNoReport
 *
 * Method Name : public void run ()
 * Parameters : None
 * Returns : None
 *
 * Chained Methods : public boolean sort_DataFile ()
 *
 * Associated Methods : LiveDB::protected static void LogFileSabotageCheck ()
 *                      RefreshDatabase::protected static boolean index_DataFile(int p_Tableno)
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This is a heavy duty thread which queries the database for report rowids. It starts
 * by allocating report generation work evenly amongst all users logged in at any given point in time. This
 * algorithm of report load distribution needs to be fine tuned a little more during beta testing. After
 * allocating reports to each of the users on the system it creates some sort tables LiveDB.srt1reportstable,
 * LiveDB.srt2reportstable, LiveDB.srt3reportstable usefull sorts for you to use even if you modify the
 * source. Then it proceed to fetch rowids for each of the report queries. So for example the rowids which
 * are relevant to the report RunAwayBrideReport will be pinned on the wall at LiveDB.RunAwayBrideReport.
 * The Generic Report Writer just picks up these rowids and prints the report in the background.
 *
 * Technical Reference : None
 * Musical Accompanyments : TRAFFIC "The low spark of high heeled boys"
 *
 *
 * Start Date: 18th October 2010
 * End Date: 8th June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
class SortandIndex implements Runnable {
    
   private long oneday = 1000 * 60 * 60 * 24;
   private boolean okay = true;

   private static class High {
            long highonqty;
            float highontotal;
            public High(long p_Highonqty, float p_Highontotal) {
                highonqty = p_Highonqty;
                highontotal = p_Highontotal;
            }
   }
 
   private static Set <String> map1 = new HashSet <String> ();
   private static HashMap <String, Long> map2 = new HashMap <String, Long> ();
   private static List <String> queryresult = new ArrayList <String> ();
   private static List <Long> queryresultrows = new ArrayList <Long> ();
   private static List <String> map3 = new ArrayList <String> ();
   private static HashMap<String, High> map4 = new HashMap<String, High> ();
   private static Long rs = 0L;
   private Integer reportid = 18;

    public void run () {        
        
        waiting:
        while (LiveDB.databaseloading == 1 || LiveDB.command_line != null)
            continue waiting;
        ThreadController.TakeOffTimes[2] = new Date ();
        LiveDB.LogFileSabotageCheck ();
        if (LiveDB.reindexall == 1)
        {
            String tbn = null;
            for (int tn = 0; tn <= LiveDB.REALTABLES; tn++)
            {
                for (int i = 0; i < LiveDB.tablenameidentifier.length; i++)
                {
                    if (Integer.parseInt(LiveDB.tablenameidentifier[i][0]) == tn)
                        tbn = LiveDB.tablenameidentifier[i][1];
                }
                if ((okay = RefreshDatabase.index_DataFile (tn)) == false)
                {
                   System.err.println(LiveDB.grassHopper("Indexing Failure for tablename " + tbn));
                   LiveDB.system_exit = 1;
                   LiveDB.SmoothExitCondition.signalAll();
                }
            }
            ThreadController.LandingTimes[2] = new Date ();
            LiveDB.reindexall = 0;
        }
        if ((okay = sort_DataFile ()) == false)
        {
            System.err.println(LiveDB.grassHopper("Sort has failed check immediately exiting ..."));
            System.exit(1);
        }
        LiveDB.LogFileSabotageCheck ();
        ThreadController.LandingTimes[2] = new Date ();
    } /* public void run () */

   /* This is an EXAMPLE OF method overloading and generic parameters
    * and varargs and anonymous classes all rolled into one for ease
    * of undrstanding for teaching track.
    * And so I am using these overloaded methods to generate numbers
    * of Quantum of Solace Report. 
    */

    @SuppressWarnings("unchecked")
    public <CanBeASingleAlphabet> CanBeASingleAlphabet quantumofsolace (Class<? extends CanBeASingleAlphabet> p_Param){

        // Any kind of processing in method
        // I did not call this because of possible ambiguity
        // Lesson Thanks to Mark Davis Technology Head IBM Labs OpenJDK

        /* Now if you had two methods in a class such as
         * public <T> T Currency (BigDecimal value, String code) { .....}
         * public <E> E Currency (double value, String code) {.....}
         *
         * And you called method Currency ("45.0", "USD");
         *
         * Then you would get a RunTime unchecked error message
         * "I dont know what to do ... I dont know what to do
         *  You tell me how to do"
         */

        Integer trial = (Integer)((CanBeASingleAlphabet)p_Param);

        return (CanBeASingleAlphabet)trial ;

    }

    /* Even if you change the <TagName> its the same signature
    public <NoPrimitiveDataTypesOnlyObjects> NoPrimitiveDataTypesOnlyObjects quantumofsolace (Class<? extends NoPrimitiveDataTypesOnlyObjects> o){

        Integer trial = (Integer)((NoPrimitiveDataTypesOnlyObjects)o);

        return (NoPrimitiveDataTypesOnlyObjects)trial ;
    }
    */

    /* NOTE:- ALL THESE ARE EXAMPLES OF USING GENERICS BUT ERASURE MAY NOT HANDLE IT PROPERLY AT ALL
     * JUST ILLUSTRATIVE EXAMPLES TO GET YOU LESS NERVOUS AND SHAKY ABOUT GENERICS. ERASURE CAN BE
     * VERY VERY DIFFICULT TO UNDERSTAND AND TO EXPLAIN
     * WE WILL EXPLAIN IN THE ADVANCED JAVA COURSE LATER
     */
    /* You can even go <BottomLess> boys */
    @SuppressWarnings("unchecked")
    public <Topless> Topless quantumofsolace (Topless... p_Param){

        /* I Will call this method with an anonymous class */
        /* from this method call only some other overloaded methods
         * in a sequence just as you can call all constructors
         * in a sequence within a class using this(parameters-list)
         */

        return (Topless) quantumofsolace(p_Param[0]);

    }

    private <FollowIdentifierDeclarationRules> FollowIdentifierDeclarationRules quantumofsolace (FollowIdentifierDeclarationRules p_O){

             return (FollowIdentifierDeclarationRules) quantumofsolace(1, "NoWildCards", p_O);

    }


    <AnyLegalCharacter> AnyLegalCharacter quantumofsolace (AnyLegalCharacter E, AnyLegalCharacter K, AnyLegalCharacter AnyLegalUnicodeCharacter){

        // NOW this will process the anonymous class and do the number crunching for QuantumOfSolaceReport using Reflections

        Method numbercrunch = null;  // this works somewhat like a function pointer in C programming
        try{
            numbercrunch = E.getClass().getMethod ("reportnumbers");
        }catch(NoSuchMethodException ex_YESKIA3){
            // nah this wont happen
            System.err.println(LiveDB.grassHopper(ex_YESKIA3, String.valueOf(E)));
            System.exit(1);
        }

        Object Values = null;
        try{
            // Thanks to a lesson from Eamonn McManus (McGuiness ??)  A very complicated Irish cluck who writes generic cut and paste code
            Values = numbercrunch.invoke(E);  // invoke on that anonymous class object E this method. That object E will arrive instantiated.
        }catch (IllegalAccessException ex_YESKIA1){
            System.err.println(LiveDB.grassHopper(ex_YESKIA1, String.valueOf(E)));
            System.exit(1);
            // nah rarity should not happen
        }catch (Exception ex_YESKIA2){
            System.err.println(LiveDB.grassHopper(ex_YESKIA2, String.valueOf(E)));
            System.exit(1);
        }

        LiveDB.QuantumOfSolaceReport = (String)Values;
        LiveDB.LiveSharedDB[34] = (String []) Values;
        
        /*
         *   public InstalledTables (long p_Tableno, Date p_Accesstime, Date p_Modifiedtime,
         *   Date p_installtime, String p_country, String p_iso3lc, long p_Initialsize, long p_Rowid )
         */

        File InSz = null;
        long insize = 0L;

        
        for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
        {
            if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 34)
            {
                InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                if (InSz.exists())
                    insize = InSz.length();
                break;
            }
        }

        LiveDB.LiveSharedDB[34] = (Long []) LiveDB.RunAwayBrideReport;
        LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
        new InstalledTables(34,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
        Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
        /* Update Change Tracker Table by inserting a new row there */
        /* ChangeTracker (long p_Tableno, long p_Rowid, char p_Change_flag) */
        LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
        new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
        LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
        (long)LiveDB.LiveSharedDB[ct].length);
        
        return (AnyLegalCharacter)E ;
    }

    <NoWildCards> NoWildCards quantumofsolace (int num, String stringval, NoWildCards... p_Param){

        return (NoWildCards) quantumofsolace(p_Param, null, null);  /* look above */

    }

    public boolean sort_DataFile () {

        int i = 0;
        boolean ok = true;
        File InSz = null;
        long insize = 0L;
        final int  hopfactor = 5; // dont change this

        /* if there are several users on the system why should you do all the donkey load
         * work.
         */

        /* Get users logged in Now from CustomerRegister table */
        for (i = (int)LiveDB.CRSR; i < LiveDB.LiveSharedDB[cr].length ; i++)
        {
            if (((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustlogintime().after(LiveDB.midnight)
                && ((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustlogouttime() != null)
                         LiveDB.usersloggedin += 1;
        }

        i = 0; /* dont erase */
        boolean al = false; /* alloted report ?? */
        tonextallotment:
        while ((reportid = (new Random ()).nextInt(75)) > 0 )
        {
                if ( i > (LiveDB.maxrepid - LiveDB.minrepid)/LiveDB.usersloggedin && al == true )
                      break;

                if (reportid >= LiveDB.minrepid && reportid <= LiveDB.maxrepid)
                {
                    if (LiveDB.indxreportAllocation.put(reportid,reportid) != null )
                    {
                       i++;
                       al = true;
                    }
                }
                else al = al == true ? al:false;

                continue tonextallotment;                
        }

        LiveDB.reportsforthispid = i;  /* these are the maximum number of reports this pid
                                        * is expected to do. It could do less also
                                        */

        /* ReportsTable long p_Documentno, String p_Doctype, String p_Pathname,
           long p_Size, Date p_Reportdate, long p_Rowid */

        /* DAILY GRIND MUST DO WITH EVERY USER WHO LOGS IN MUST BE UPTODATE AS OF NOW */
        /* clear all previous entries before re-building */
        LiveDB.srt1reportstable.clear();
        LiveDB.srt2reportstable.clear();
        LiveDB.srt3reportstable.clear();
        for ( i = 0; i < LiveDB.LiveSharedDB[rt].length; i++)
        {
            /* WE CAN USE TREESET BECAUSE DOCUMENTNO IS UNIQUE AND RANDOMLY GENERATED */
            /* create sort table on id */
            ok = LiveDB.srt1reportstable.add(new ReportsTable (((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getDocumentno(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getId(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getDoctype(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getPathname(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getSize(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getReportdate(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getStatus(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getByteswritten(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getPid(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getRowid()));

            /* create sort table on reportdate */
            ok = LiveDB.srt2reportstable.add(new ReportsTable (((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getDocumentno(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getId(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getDoctype(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getPathname(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getSize(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getReportdate(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getStatus(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getByteswritten(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getPid(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getRowid()));

            /* create sort table on status */
            ok = LiveDB.srt3reportstable.add(new ReportsTable (((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getDocumentno(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getId(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getDoctype (),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getPathname(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getSize(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getReportdate(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getStatus(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getByteswritten(),
                ((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getPid(),((ReportsTable)LiveDB.LiveSharedDB[rt][i]).getRowid()));
        }

        if (ok == false) return ok;

        Long rw = null;
        Date td = null;

        LiveDB.indxreportGeneration.clear();
        LiveDB.indxreportRecentRow.clear();

        ReportsTable [] srt2array = (ReportsTable []) LiveDB.srt2reportstable.toArray();

        for ( ReportsTable element : srt2array )
        {   /* so we have built a hashmap where each unique report id has a latest report generation date */
            td = LiveDB.indxreportGeneration.put( element.getId(), element.getReportdate());
            rw = LiveDB.indxreportRecentRow.put (element.getReportdate(), element.getRowid ());
        }
        
        Integer [] tm ; /* temp */
        tm = (Integer []) LiveDB.indxreportAllocation.keySet().toArray();

        for ( Integer v : tm )  /* These are all report id's alloted to this process id your work to complete */
        {  /* now what we going to do is to add a new record in the reports table for each report allocated to
            * this process id. But before that we need to check if there is an already existing record for this
            * report id which has status 'I' Incomplete. It doesent matter if the pid of that record in the reports
            * table is not your pid !! It only means that a previous report was Incomplete by some other process.
            */
            td = LiveDB.indxreportGeneration.get((long)v); /* most recent report generation date */
            rw = LiveDB.indxreportRecentRow.get (td); /* row for most recent report generation date */
            if (((ReportsTable)LiveDB.LiveSharedDB[rt][(int)((long)rw)]).getStatus() == 'I' ||
                ((ReportsTable)LiveDB.LiveSharedDB[rt][(int)((long)rw)]).getStatus() == 'i' )
                /* Orphan report found */
            {
               /* change the report generation date */
               ((ReportsTable)LiveDB.LiveSharedDB[rt][(int)((long)rw)]).setReportdate( new Date());
               // insert an entry in ChangeTracker table for this table
               LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
               new ChangeTracker ((long)rt,rw, 'U',
               LiveDB.pid, new Date (),
               LiveDB.LiveSharedDB[rt][(int)((long)rw)],
               (long)LiveDB.LiveSharedDB[ct].length);
               ((ReportsTable)LiveDB.LiveSharedDB[rt][(int)((long)rw)]).setPid(LiveDB.pid); /* allocated to your pid */
               // insert an entry in ChangeTracker table for this table
               LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
               new ChangeTracker ((long)rt,rw, 'U',
               LiveDB.pid, new Date (),
               LiveDB.LiveSharedDB[rt][(int)((long)rw)],
               (long)LiveDB.LiveSharedDB[ct].length);
            }
            else if (((ReportsTable)LiveDB.LiveSharedDB[rt][(int)((long)rw)]).getStatus() != 'P') /* report printing */
            {
                /* create a new record for this allocation as status 'T' taken */
                /* public ReportsTable (long p_Documentno, long p_Id, String p_Doctype, String p_Pathname,
                 * long p_Size, Date p_Reportdate, char p_Status, long p_Byteswritten, long p_Pid, long p_Rowid)
                 */
                for ( int w = 0, l = 0; w < LiveDB.reportmethodidentifier.length; w++ )
                {
                      if (Integer.parseInt(LiveDB.reportmethodidentifier[w][0]) == v)
                      {
                          LiveDB.LiveSharedDB[rt][LiveDB.LiveSharedDB[rt].length] =
                          new ReportsTable (new Random().nextLong(), v,
                          (v >= 18 && v <= 33 ? "CR": v == 35 ? "PO": v == 34 || v == 36 ? "SC": v >= 37 && v <= 38 ? "MIS" : v == 39 ? "POST":
                           v >=40 && v <= 41 ? "PLOT": v >= 42 && v <= 43 ? "GRAPH" : v >= 44 && v <= 45 ? "PIE" : v >= 46 && v <= 47 ? "MAIL" : "MIS" ),
                          LiveDB.serializedfilespath + "reports" + LiveDB.reportmethodidentifier[w][1] + LiveDB.reportmethodidentifier[w][0] + ".rpt",
                          0L, new Date (), 'T', 0L, LiveDB.pid,LiveDB.LiveSharedDB[rt].length);
                          /* Now plug in a record in the ChangeTracker table for fastcommit to take over and commit this new record */
                          LiveDB.LiveSharedDB[ct][l = LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker(rt,LiveDB.LiveSharedDB[rt].length -1,'I', LiveDB.pid, new Date(),
                                LiveDB.LiveSharedDB[rt][LiveDB.LiveSharedDB[rt].length -1],
                                (long)LiveDB.LiveSharedDB[ct].length);
                          /* Add this entry also to sort table */
                          ok = LiveDB.srt2reportstable.add(new ReportsTable (((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getDocumentno(),
                               ((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getId(),((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getDoctype(),
                               ((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getPathname(),((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getSize(),
                               ((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getReportdate(),((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getStatus(),
                               ((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getByteswritten(),((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getPid(),
                               ((ReportsTable)LiveDB.LiveSharedDB[rt][l]).getRowid()));

                          srt2array = (ReportsTable []) LiveDB.srt2reportstable.toArray();
                          LiveDB.indxreportGeneration.clear();
                          LiveDB.indxreportRecentRow.clear();
                          for ( ReportsTable element : srt2array )  /* Rebuild this darned index everytime find me a better algorithm */
                          {   /* so we have built a hashmap where each unique report id has a latest report generation date */
                              td = LiveDB.indxreportGeneration.put( element.getId(), element.getReportdate());
                              rw = LiveDB.indxreportRecentRow.put (element.getReportdate(), element.getRowid ());
                          }
                      } /* if (Integer.parseInt(LiveDB.reportmethodidentifier[w][0]) == v) */
                } /* for ( int w = 0, l = 0; w < LiveDB.reportmethodidentifier.length; w++ ) */
           } /*  else if (((ReportsTable)LiveDB.LiveSharedDB[rt][(int)((long)rw)]).getStatus() != 'P') */
        } /* for ( Integer v : tm ) */


        long mts45 = 1000 * 60 * 45;

        /* RUNAWAY BRIDE REPORT : 18
         * Get all customers from CustomerRegister Who have logged in for more than 45 minutes
         * and there is total inactivity in the ShoppingCart
         */

        /* What is the report frequency */                                               /* 3 days */
        if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(18L).getTime()) > (oneday * 3)
                && LiveDB.indxreportAllocation.get(18) == 18 )  /* has this report been alloted to this pid ?? */
                /* tomorrow you could be alloted a different report to do at random */
        {
            /* Build the first Map map1
            * Get all customers from CustomerRegister who have been logged in for a very long time
            */
            map1.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[cr].length; i++ )
            {
               // actually getCustlastdate is more accurate but if crash recovery is disabled then
               // if there is a system crash that date does not get filled out
               if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                        .before(LiveDB.indxreportGeneration.get(18L))
                        && LiveDB.indxreportGeneration.get(18L) != null)
                        i += hopfactor;
                if ((new Date ()).getTime() - ((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustlogintime().getTime () > mts45)
                    ok = map1.add (((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCid());
            }
            /* Now get all customers who have shopped in ShoppingCart table */
            map2.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
               if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                        .before(LiveDB.indxreportGeneration.get(18L))
                        && LiveDB.indxreportGeneration.get(18L) != null)
                        i += hopfactor;
                /* Is shop date after todays midnight ? */
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getShopdate().after(LiveDB.midnight))
                   map2.put (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid(), ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getRowid ());
            }
           /* queryresult : check if cid in map1 is contained in map2.
            * If No put that cid from map1  into queryresult
            */
            queryresult.clear();
            for ( String v : map1)
            {
                if ((ok = map2.containsKey(v)) != true)
                    queryresult.add(v);
            }
           /* Now crunch queryresult into an array of rowids
            * These are the rowids that the report writer needs
            * to look up in CustomerRegister Table and print
            */
            int as = 0; /* array subscript */
            for ( String v: queryresult)
            {
                if ((rs = LiveDB.indxcustomerRegister.get(v)) != null)
                {
                    LiveDB.RunAwayBrideReport[as]= rs;
                    as++;
                }
                else ok = false;
            }
           /* Hang the RunAwayBrideReport on LiveSharedDB for serialization/deserialization
            * also have it available as a global Long array called RunAwayBrideReport
            */
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 18)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[18] = (Long []) LiveDB.RunAwayBrideReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(18,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            /* ChangeTracker (long p_Tableno, long p_Rowid, char p_Change_flag) */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF RUNAWAYBRIDE REPORT */

        /* OCTOPUSSY REPORT : 19 -> get all new customers from CustomerRegister who register daily who are
         * female customers.Get first eight female customers.
         */

        /* What is the report frequency */                                            /* 1 days */
        if ( ( (new Date()).getTime() - LiveDB.indxreportGeneration.get(19L).getTime()) > (oneday)
                               && LiveDB.indxreportAllocation.get(19) == 19 )
        /* tomorrow you could be alloted a different report to do at random */
        {
            map2.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[cr].length; i++ )
            {
               if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                        .before(LiveDB.indxreportGeneration.get(19L))
                        && LiveDB.indxreportGeneration.get(19L) != null)
                        i += hopfactor;
                
                if (((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustregisterdate().after(LiveDB.midnight)
                    && ((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustsex () == 'F' )
                    map2.put(((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCid(),
                                              ((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getRowid());
            }
            queryresultrows.clear();
            queryresultrows = (List) map2.values();
            /* Just pick eight out of these */
            LiveDB.OctopussyReport = (Long []) queryresultrows.toArray();
            LiveDB.LiveSharedDB[19] = (Long []) LiveDB.OctopussyReport;

            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 19)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }

            LiveDB.LiveSharedDB[19] = (Long []) LiveDB.OctopussyReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(19,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
           /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],(long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF OCTOPUSSY REPORT */
        
      /* ROYAL REPORT : 20 -> Get all customers from CustomerRegister who have custflag = 'R' or 'C'
       */
        /* What is the report frequency */                                            /* 30 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(20L).getTime()) > (oneday * 30)
                               && LiveDB.indxreportAllocation.get(20) == 20 )
       /* tomorrow you could be alloted a different report to do at random */
       {
            queryresultrows.clear();
            for (i = 0; i < LiveDB.LiveSharedDB[cr].length; i++)
            {
                if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                        .before(LiveDB.indxreportGeneration.get(20L))
                        && LiveDB.indxreportGeneration.get(20L) != null)
                        i += hopfactor;

                if (((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustflag () == 'C'
                    || ((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustflag () == 'R')
                    queryresultrows.add(((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getRowid ());
            }
            LiveDB.HerMajestiesServiceReport = (Long []) queryresultrows.toArray();
            LiveDB.LiveSharedDB[20] = (Long []) LiveDB.HerMajestiesServiceReport;

            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 20)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[20] = (Long []) LiveDB.HerMajestiesServiceReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(20,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
       } /*  END OF ROYAL REPORT */

       /* TOP GUN REPORT : 21 -> CELEBRITY REPORT BUYS
        * Get all customers from CustomerRegister where custflag = 'C' or custflag = 'R'
        * AND they must be customers in ShoppingCart who have been billed = 1
        */
           /* What is the report frequency */                                           /* 5 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(21L).getTime()) > (oneday * 5)
                               && LiveDB.indxreportAllocation.get(21) == 21 )
       /* tomorrow you could be alloted a different report to do at random */
       {
            map1.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[cr].length; i++ )
            {
                if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                                                .before(LiveDB.indxreportGeneration.get(21L))
                        && LiveDB.indxreportGeneration.get(21L) != null)
                        i += hopfactor;

                if (((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustflag () == 'C'
                    || ((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCustflag () == 'R')
                    ok = map1.add(((CustomerRegister)(LiveDB.LiveSharedDB[cr][i])).getCid ());
            }
            /* get all cids from shopping cart who have been billed */
            map2.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(21L))
                        && LiveDB.indxreportGeneration.get(21L) != null)
                        i += hopfactor;

                if (((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getBilled () == 1)
                    map2.put(((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getCid (),
                       ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getRowid () );
            }

            /* for each cid in map1 get the same in map2 */
            queryresultrows.clear();
            for ( String v : map1)
            {
                if ((rs = map2.get(v)) != null)
                    ok = queryresultrows.add(rs);
            }
            
            LiveDB.TopGunReport = (Long []) queryresultrows.toArray();
            LiveDB.LiveSharedDB[21] = (Long []) LiveDB.TopGunReport;

            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 21)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[21] = (Long []) LiveDB.TopGunReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(21,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
       } /* END OF TOP GUN REPORT */

       /* Get all Zip Codes from CustomerRegister for customers who have a lot of activity in ShoppingCart where the
        * number of rows in shopping cart for such zip codes exceed 25.
        * City of Angels Report --> 22
        */

       long k,j = 0L;   /* dont erase */

         /* What is the report frequency */                                            /* 25 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(22L).getTime()) > (oneday * 25)
                              && LiveDB.indxreportAllocation.get(22) == 22 )
       /* tomorrow you could be alloted a different report to do at random */
       {
            map2.clear();
            queryresult.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
               if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(22L))
                        && LiveDB.indxreportGeneration.get(22L) != null)
                        i += hopfactor;
               
                if ( ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getBilled () < 2 )
                {
                    ok = queryresult.add(((CustomerRegister)LiveDB.LiveSharedDB[cr]
                         [(int)(j=LiveDB.indxcustomerRegister.get(((ShoppingCart)
                         (LiveDB.LiveSharedDB[sc][i])).getCid()))]).getCustzip ());
                    /* add the zip codes to a hash map map2 and get keyset */
                    k = map2.put(((CustomerRegister)(LiveDB.LiveSharedDB[cr][(int)j])).getCustzip(),
                            ((CustomerRegister)(LiveDB.LiveSharedDB[cr][(int)j])).getRowid());
                }
           }
            map1.clear();
            map1 = map2.keySet();
            map3.clear();
            for ( String v : map1 )
                if ( ((queryresult.lastIndexOf(v)- queryresult.indexOf(v)) + 1) >= 25 )
                   map3.add(v);
            queryresultrows.clear();
            for ( String v :  map3 )
                  queryresultrows.add(map2.get(v));
            LiveDB.CityOfAngelsReport = (Long []) queryresultrows.toArray();
            LiveDB.LiveSharedDB[22] = (Long []) LiveDB.CityOfAngelsReport;
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 22)
                {
                   InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                   if (InSz.exists())
                      insize = InSz.length();
                   break;
                }
             }
             LiveDB.LiveSharedDB[22] = (Long []) LiveDB.CityOfAngelsReport;
             LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
             new InstalledTables(22,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
             Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
             /* Update Change Tracker Table by inserting a new row there */
             LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
             new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
             LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
             (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF CITY OF ANGELS REPORT */

       /*
        * YOU GOT MAIL 23: Gigantic Customers Report
        * Get customer from CustomerRegister who is Celebs or Royals
        * who have the highest purchase "order" quantity or billed amount
        */
       High high = new High (0L,0F);
       High rth = new High (0l, 0f);
       String giantcid [] = null;
       int x = 0, y = 0;

       /* What is the report frequency */                                       /* 4 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(23L).getTime()) > (oneday * 4)
                              && LiveDB.indxreportAllocation.get(23) == 23 )
           /* has this report been alloted to this pid ?? */
       /* tomorrow you could be alloted a different report to do at random */
       {
            queryresult.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[cr].length; i++ )
            {
                if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                                                .before(LiveDB.indxreportGeneration.get(23L))
                        && LiveDB.indxreportGeneration.get(23L) != null)
                        i += hopfactor;
                
                if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCustflag () == 'C' ||
                    ((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCustflag () == 'R')
                    queryresult.add(((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCid());
            }

            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(23L))
                        && LiveDB.indxreportGeneration.get(23L) != null)
                        i += hopfactor;

                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getBilled () == 1 )
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getPic_qty () > high.highonqty
                        || ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getTotal () > high.highontotal)
                    {
                        high.highonqty = ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getPic_qty ();
                        high.highontotal = ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getTotal ();
                        rth = map4.put (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid (), high);
                        /* keep three rows and knock the rest out */
                        if (i >= 3) rth = map4.remove(((ShoppingCart)LiveDB.LiveSharedDB[sc][i - 3]).getCid ());
                    }
            }

            map1.clear();
            map1 = map4.keySet();
            giantcid = (String []) map1.toArray(); /* just three of them */
            String reportcid [] = {"","",""};

            for (i = 0, y = 0; i < 3; i++)
            if ((x = queryresult.indexOf(giantcid[i])) != -1)
            {
               reportcid [y] = queryresult.get(x);
               y++;
            }

            for (i = 0, y = 0; i < 3; i++, y++)
                LiveDB.YouGotMailReport[y] = rs = LiveDB.indxcustomerRegister.get(reportcid[i]);
            LiveDB.LiveSharedDB[23] = (Long []) LiveDB.YouGotMailReport;

            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 23)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }

            LiveDB.LiveSharedDB[23] = (Long []) LiveDB.YouGotMailReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(23,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
       } /* END OF YOU GOT MAIL REPORT */

       /* DIAMONDS ARE FOREVER 24: HIGH QUANTUM PURCHASE REPORT
        * Get all customers from CustomerRegister who have the highest purchase "order" quantity
        * or billed amount
        */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(24L).getTime()) > (oneday * 4)
                              && LiveDB.indxreportAllocation.get(24) == 24 )
       {
            map4.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(24L))
                        && LiveDB.indxreportGeneration.get(24L) != null)
                        i += hopfactor;

                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getBilled() == 1 )
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getPic_qty() > high.highonqty
                        || ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getTotal() > high.highontotal)
                    {
                        high.highonqty = ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getPic_qty();
                        high.highontotal = ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getTotal();
                        rth = map4.put (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid(), high);
                        /* keep three rows and knock the rest out */
                        if (i >= 3) rth = map4.remove(((ShoppingCart)LiveDB.LiveSharedDB[sc][i - 3]).getCid());
                    }
            }
            map1.clear();
            map1 = map4.keySet();
            giantcid = (String []) map1.toArray(); /* just three of them */
            for (i = 0, y = 0; i < 3; i++, y++)
                LiveDB.DiamondsAreForeverReport[y] = rs = LiveDB.indxcustomerRegister.get(giantcid[i]);
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 24)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[24] = (Long []) LiveDB.DiamondsAreForeverReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(24,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF DIAMONDS ARE FOREVER REPORT */

        /* FRENCH KISS REPORT : 25
         * Get all customers from CustomerRegister who have placed their
         * first orders in the shopping cart.
         */

       /* What is the report frequency */                                       /* 2 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(25L).getTime()) > (oneday * 2)
                              && LiveDB.indxreportAllocation.get(25) == 25 )
       {

            queryresult.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                   if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(25L))
                        && LiveDB.indxreportGeneration.get(25L) != null)
                        i += hopfactor;
                
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getBilled() == 1
                    && ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getOrdernumber() == 1
                    && ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getShopdate().getTime()
                    > (LiveDB.midnight.getTime() - oneday * 2))
                    /* Add to some List or even a SET since duplicates wont be there */
                    /* You can even check here for shopdate if you want */
                    queryresult.add(((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid());
            }
            y = 0;
            for ( String v : queryresult )
            {                                            /* readymade index to use */
                LiveDB.FrenchKissReport [y] = rs = LiveDB.indxcustomerRegister.get(v);
                y++;
            }
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 25)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[25] = (Long []) LiveDB.FrenchKissReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(25,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF FRENCH KISS REPORT */



      /*
       * NeverSayNeverAgainReport 26: FAST TRACK REPORT
       * Get all customers from CustomerRegister who have a history of customer cancellations
       * in shopping cart.
       */
      /* DISEASE SYMPTOMS
       * some users of the program have been playing mischief by emptying there shopping carts repeatedly
       * after shopping FastTrack. We need to cross check with such fellers. Maybe some kid called Dennis
       * logging into office intranets from where-ever. Mark such customers as 'S' in customer register
       * 'S' means staying alive.Also Print Stayin Alive Report
       */
              /* What is the report frequency */                                       /* 3 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(26L).getTime()) > (oneday * 3)
                              && LiveDB.indxreportAllocation.get(26) == 26 )
       {
            map2.clear();
            queryresult.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(26L))
                        && LiveDB.indxreportGeneration.get(26L) != null)
                        i += hopfactor;
                
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getBilled ()== 2 )
                /* Use a List since there will be duplicates due to multiple
                 * occurences of order cancellations.
                 */
                {
                    queryresult.add(((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid());
                    /* Also add it to some HashMap */
                    map2.put(((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid(),
                        ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getRowid());
                }
            }

            map1.clear();
            map1 = map2.keySet ();
            giantcid = (String []) map1.toArray(); /* just get the keys */
            map1.clear();
            map3.clear();
            for ( i = 0; i < giantcid.length; i++ )
            {
                if ((queryresult.lastIndexOf(giantcid[i]) - queryresult.indexOf(giantcid[i])) > 2)
                /* add such customers to another SET */
                    map1.add(giantcid[i]);  /* Bad customers need a scolding letter */
                else
                /* use some list or set or whatever is available */
                    map3.add(giantcid[i]);
            }
            y = 0;
            for (String v : map1)
            {
                LiveDB.NeverSayNeverAgainReport[y] = rs = LiveDB.indxcustomerRegister.get(v);
                y++;
            }
            /* Hang it on the Wall */
            LiveDB.LiveSharedDB[26] = (Long []) LiveDB.NeverSayNeverAgainReport;
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 26)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }

            LiveDB.LiveSharedDB[26] = (Long []) LiveDB.NeverSayNeverAgainReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(26,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF NEVER SAY NEVER AGAIN REPORT */

        /*
         * YouOnlyLiveTwiceReport 27:
         * Get all customers from customer register who have been emptying shopping carts.
         */
              /* What is the report frequency */                                       /* 3 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(27L).getTime()) >= (oneday * 3)
                              && LiveDB.indxreportAllocation.get(26) == 26 )
       /* has this report been alloted to this pid ?? NO but you will still do it if 26 has been alloted to you */
       /* Slight variant tomorrow you could be alloted a different report to do at random */
       {
           /* Yeah allot this report to your pid if 26 has been alloted to you */
           LiveDB.indxreportAllocation.put(27,27);
           /* all the other cids are not frequent offenders so they go into another report */
           y = 0;
           for (String v : map3)
           {
               LiveDB.YouOnlyLiveTwiceReport[y] = rs = LiveDB.indxcustomerRegister.get(v);
               y++;
           }

           for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
           {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 27)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[27] = (Long []) LiveDB.YouOnlyLiveTwiceReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(27,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF YOU ONLY LIVE TWICE REPORT */

        /*
         * WhenHarryMetSallyReport 28:
         * Get all customers from CustomerRegister
         * who have done a lot of window shopping in ShoppingCart
         * with billed = 0;
         */
        /* What is the report frequency */                                              /* 10 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(28L).getTime()) > (oneday * 10)
                                             && LiveDB.indxreportAllocation.get(28) == 28 )
       {
            map2.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(28L))
                        && LiveDB.indxreportGeneration.get(28L) != null)
                        i += hopfactor;
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getBilled()== 0 )
                    map2.put(((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid(),
                            ((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getRowid());
            }

            map1.clear();
            map1 = map2.keySet ();
            y = 0;
            for (String v : map1)
            {
                LiveDB.WhenHarryMetSallyReport[y] = rs = LiveDB.indxcustomerRegister.get(v);
                y += 1;
            }

            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 28)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
           /* Hang it on the Wall */
            LiveDB.LiveSharedDB[28] = (Long []) LiveDB.WhenHarryMetSallyReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(28,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF WHEN HARRY MET SALLY REPORT */

        /*
         * TheDoorsReport : 29
         * Get all customers from customer register who have not logged in for more than one year.
         */
        /* What is the report frequency */                                              /* 366 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(29L).getTime()) > (oneday * 366)
                                             && LiveDB.indxreportAllocation.get(29) == 29 )
       {
            j = 60000 * 60 * 24 * 366 ;  /* one year */
            queryresultrows.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[cr].length; i++ )
            {
                if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                                                .before(LiveDB.indxreportGeneration.get(28L))
                        && LiveDB.indxreportGeneration.get(28L) != null)
                        i += hopfactor;
                
                if (((new Date()).getTime()) -
                    (((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCustlogintime()).getTime() > j)
                    queryresultrows.add(((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getRowid());
            }

            LiveDB.TheDoorsReport = (Long [])queryresultrows.toArray();

            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 29)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[29] = (Long []) LiveDB.TheDoorsReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(29,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
       } /* END OF THE DOORS REPORT */

        /* 30 Customers Lost and Found Customers who have returned to active
         * Window Shopping after nine months
         *
         */
        j = 1000 * 60 * 60 * 24 * 270 ;  /* nine months */
               /* What is the report frequency */                            /* 9 months */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(30L).getTime()) > j
                                             && LiveDB.indxreportAllocation.get(30) == 30 )
       {
            map1.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[cr].length; i++ )
            {
                if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                                                .before(LiveDB.indxreportGeneration.get(30L))
                        && LiveDB.indxreportGeneration.get(30L) != null)
                        i += hopfactor;
                
                if (((new Date()).getTime()) -
                    (((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCustlogintime()).getTime() > j)
                    ok = map1.add(((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCid());
            }
            queryresult.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getBilled() < 3)
                    queryresult.add(((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getCid());
            x = 0;
            for (String v : map1)
            {
                LiveDB.SleeplessInSeattleReport[x] = rs =
                    LiveDB.indxcustomerRegister.get(queryresult.get(queryresult.indexOf(v)));
                x += 1;
            }
            
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 30)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[30] = (Long []) LiveDB.SleeplessInSeattleReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(30,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF SLEEPLESS IN SEATTLE REPORT */

        /* 31
         * LivingDaylightsReport
         * Get all customers from CustomerRegister who have been shopping at weird hours
         */

        String datingpattern = "HH:mm:ss 'on' dd/MM/yyyy";
        SimpleDateFormat sd = new SimpleDateFormat(datingpattern, LiveDB.DefaultLocale);
        StringBuffer ds; /* date string */
        StringBuffer ta = null; /* To Append to */
        String checkhour = null;

       /* What is the report frequency */                                       /* 6 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(31L).getTime()) > (oneday * 6)
                                              && LiveDB.indxreportAllocation.get(31) == 31 )
       {
            /* First Get all customers who logged in at weird times */
            map2.clear();
            for ( i = 0; i < LiveDB.LiveSharedDB[cr].length; i++ )
            {
                if (LiveDB.LiveSharedDB[cr].length > hopfactor)
                    if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i + hopfactor]).getCustlogintime()
                                                .before(LiveDB.indxreportGeneration.get(31L))
                        && LiveDB.indxreportGeneration.get(31L) != null)
                        i += hopfactor;
                
                /* get midnight */
                if (((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCustlogintime().after(LiveDB.midnight))
                {
                    ds =  sd.format(((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCustlogintime(), ta, null);
                    /* go back home to bed with your wife */
                    if (Integer.parseInt((checkhour = ds.substring(0,1))) > 22 || Integer.parseInt((checkhour = ds.substring(0,1))) < 7)
                        map2.put(((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getCid(), ((CustomerRegister)LiveDB.LiveSharedDB[cr][i]).getRowid());
                }
            }
            /* Now get all customers from shopping cart who shopped at weird times */
            /* Dont clear map2 keep putting it will overwrite duplicate cid's it okay */
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {                                                              /* get midnight */
                if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getShopdate().after(LiveDB.midnight))
                {
                    ds =  sd.format(((ShoppingCart)LiveDB.LiveSharedDB[sc][i]).getShopdate(), ta, null);
                    /* go back home to bed with your wife or else i will send this report to your boss */
                    if (Integer.parseInt((checkhour = ds.substring(0,1))) > 22 || Integer.parseInt((checkhour = ds.substring(0,1))) < 7)
                        map2.put(((CustomerRegister)LiveDB.LiveSharedDB[sc][i]).getCid(),
                            LiveDB.indxcustomerRegister.get(((CustomerRegister)LiveDB.LiveSharedDB[sc][i]).getCid()));
                }
            }
            map1.clear();
            map1 = map2.keySet ();
            LiveDB.LivingDaylightsReport = (Long []) map1.toArray();
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 31)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[31] = (Long []) LiveDB.LivingDaylightsReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(31,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF LIVING DAYLIGHTS REPORT */

        /*
         * iQReport 32: Best Buys -- You Ripped Me Off Report
         * Look for a mid-range discount in the customers purchases The report is nothing but a "GREAT BUY"
         * Letter patting the customer on the back. Post or Email the letter immediately or it makes no sense
         * at all.
         */
               /* What is the report frequency */                                       /* 4 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(32L).getTime()) > (oneday * 4)
                                              && LiveDB.indxreportAllocation.get(32) == 32 )
       {
            queryresult.clear();
            Double ad = 0.0; /* average order discount */
            j = 1000 * 60 * 60 * 24 * 3;  /* three days */
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
                ad += ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getOrderdiscount() ;
            ad /= i;  /* average */
            for ( i = 0; i < LiveDB.LiveSharedDB[sc].length; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(32L))
                        && LiveDB.indxreportGeneration.get(32L) != null)
                        i += hopfactor;

                if ((LiveDB.midnight.getTime() -  ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getShopdate().getTime()) > j
                        && ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getOrderdiscount() >= ad)
                        queryresult.add(((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getCid());
            }
            y = 0;
            for (String v : queryresult)
            {
                LiveDB.iQReport[y] = rs = LiveDB.indxcustomerRegister.get(v);
                y += 1;
            }

            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 32)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[32] = (Long []) LiveDB.iQReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(32,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF iQReport */

        /*
         * Courage Under Fire Report 33:
         * Look at the crash recovery table and search for that record in ShoppingCart. If that record is found
         * then you check if billed in crashrecovery was 0 and 1 now in ShoppingCart Recommend this customer
         * for a Bharat Ratna !
         */

       /* What is the report frequency */ /* distribute report load since it is a min priority process */ /* 7 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(33L).getTime()) > (oneday * 7)
                                              && LiveDB.indxreportAllocation.get(33) == 33 )
       {
            queryresult.clear();
            for (i = 0; i < LiveDB.LiveSharedDB[crr].length ; i++)
                if (((CrashRecovery)(LiveDB.LiveSharedDB[crr][i])).getTableno() == sc)
                    if (((ShoppingCart)(LiveDB.LiveSharedDB[sc][(int)((CrashRecovery)(LiveDB.LiveSharedDB[crr][i])).getRowid()])).getBilled () == 1)
                        if (Integer.parseInt(((CrashRecovery)(LiveDB.LiveSharedDB[crr][i])).getValues()[7]) == 0) /* billed was zero originally */
                            queryresult.add(((CrashRecovery)(LiveDB.LiveSharedDB[crr][i])).getValues()[0]);  /* this cid gets a BHARAT RATNA */

            y = 0;
            for (String v:queryresult)
            {
                LiveDB.CourageUnderFireReport[y] = rs  = LiveDB.indxcustomerRegister.get(v);
                y++;
            }
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 33)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[33] = (Long []) LiveDB.CourageUnderFireReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(33,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
        } /* END OF COURAGE UNDER FIRE REPORT */

        /*
         * QuantumOfSolaceReport : 34
         */

        /*
         * Pass this as an anonymous class for teaching cracks
         * This code is complicated and not necessary but will do for
         * teaching as simple as it gets
         */

        abstract class Quantumofsolace{
            /* normally you cant instantiate an abstract class
             * Quantumofsolace qs = new Quantumofsolace();
             * but in this anonymous class usage it takes it as
             * a class declaration and instantiation !!
             */
            /* abstract public boolean reportnumbers(); */
        }
        /* What is the report frequency */                                       /* 2 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(34L).getTime()) > (oneday * 2)
                                              && LiveDB.indxreportAllocation.get(34) == 34 )
       {
            Object tp = (Object) quantumofsolace(new Quantumofsolace () {
            public String reportnumbers ()
            {
                long sc = 3;
                return (LiveDB.indxcrashRecovery.get(sc)) ;
            }
        });
        } /* END OF QUANTUM OF SOLACE REPORT */

        /*
         * MoneyMoneyMoneyReport: 35
         * Generate Purchase Orders
         */

        /* What is the report frequency */                                            /* 1 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(35L).getTime()) > (oneday)
                                              && LiveDB.indxreportAllocation.get(35) == 35 )
       {
            queryresultrows.clear();
            for ( i=0 ; i < LiveDB.LiveSharedDB[sc].length ; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(35L))
                        && LiveDB.indxreportGeneration.get(35L) != null)
                        i += hopfactor;
                if ( ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getShopdate().after(LiveDB.indxreportGeneration.get(35L))
                     || ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getShopdate().compareTo(LiveDB.indxreportGeneration.get(35L)) == 0 )
                     if (((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getBilled() == 1 &&
                         ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getRma() == 0 ) /* RMA NOT REQUESTED */
                         queryresultrows.add(((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getRowid());
            }

            LiveDB.MoneyMoneyMoneyReport = (Long []) queryresultrows.toArray();
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 35)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }

            LiveDB.LiveSharedDB[35] = (Long []) LiveDB.MoneyMoneyMoneyReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(35,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
                /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
       }

        /*
         * DrNoReport : 36
         * Get all customers from ShoppingCart with a return material authorization number
         * Look for billed = 3
         */
                      /* What is the report frequency */                                       /* 2 days */
       if ( ((new Date()).getTime() - LiveDB.indxreportGeneration.get(36L).getTime()) > (oneday * 2)
                                              && LiveDB.indxreportAllocation.get(36) == 36 )
       {
            queryresultrows.clear();
            for ( i=0 ; i < LiveDB.LiveSharedDB[sc].length ; i++ )
            {
                if (LiveDB.LiveSharedDB[sc].length > hopfactor)
                    if (((ShoppingCart)LiveDB.LiveSharedDB[sc][i + hopfactor]).getShopdate()
                                                .before(LiveDB.indxreportGeneration.get(36L))
                        && LiveDB.indxreportGeneration.get(36L) != null)
                        i += hopfactor;

                if ( (((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getShopdate().after(LiveDB.indxreportGeneration.get(36L))))
                    if (((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getBilled() == 3 && /* RMA REQUESTED */
                        ((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getRma() != 0 )
                        queryresultrows.add(((ShoppingCart)(LiveDB.LiveSharedDB[sc][i])).getRowid());
            }

            LiveDB.DrNoReport = (Long []) queryresultrows.toArray();
                
            for (int row = 0; row < LiveDB.tablenameidentifier.length; row++)
            {
                if (Integer.parseInt(LiveDB.tablenameidentifier[row][0]) == 36)
                {
                    InSz = new File (LiveDB.serializedfilespath + LiveDB.tablenameidentifier[row][1] + ".ser");
                    if (InSz.exists())
                        insize = InSz.length();
                    break;
                }
            }
            LiveDB.LiveSharedDB[36] = (Long []) LiveDB.DrNoReport;
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length] =
            new InstalledTables(36,new Date(),null,new Date(),Locale.getDefault().getDisplayName(),
            Locale.getDefault().getISO3Language(),insize,LiveDB.LiveSharedDB[it].length);
            /* Update Change Tracker Table by inserting a new row there */
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker(it,LiveDB.LiveSharedDB[it].length -1,'I', LiveDB.pid, new Date(),
            LiveDB.LiveSharedDB[it][LiveDB.LiveSharedDB[it].length -1],
            (long)LiveDB.LiveSharedDB[ct].length);
       }  /* END OF DR.No REPORT */

       return ok;
    }
}
