/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.File;
import java.io.IOException;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import javax.swing.JOptionPane;

/*
 * WIRING DIAGRAM :
 * THREAD NAME : InstallDB.threadsysexit
 * CLASS NAME : SystemExit
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:InstalledTables.java
 * 
 * @LOOKSY:ThreadController.TakeOffTimes[], ThreadController.LandingTimes[]
 *         Dont read the entire ThreadController.java you will go mad.
 * @LOOKSY:LiveDB.LogFileSabotageCheck(), LiveDB.SmoothExitCondition, LiveDB.system_exit,
 *         LiveDB.SerializeJustOnceTable(), LiveDB.tablenameidentifier, LiveDB.SendLogFileMessage(),
 *         LiveDB.commit_database(), LiveDB.write_IndexFile()
 * @LOOKSY:SystemExit.java run () method
 *
 * Method Name : public void run ()
 *
 * Parameters : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Your flight is landing now a smooth touchdown sometime even when there are errors
 * on board. It is not a belly landing. So it does a smooth touch down. It slow commits all tables not yet
 * committed and then writes all indexes and exits.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 11th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

final class SystemExit extends LiveDB implements Runnable, CommitDatabase {
    
    Lock SysExitLock = new ReentrantLock ();
    boolean ok = true;

    @Override
    public void run () {

        ThreadController.TakeOffTimes[4] = new Date ();

        if (new File(LiveDB.serializedfilespath + "daemon").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "daemon"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "daemon").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                    + LiveDB.serializedfilespath + "daemon"));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }

        try
        {
            new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).createNewFile();
        }catch (IOException ex_YESKIA41){
            System.err.println(LiveDB.grassHopper(ex_YESKIA41, "Cant create DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        } // to hell with this error it wont happen continue processing


        SysExitLock.lock();
        LiveDB.SmoothExitCondition = SysExitLock.newCondition();
        try{
            
        
        if (LiveDB.system_exit == 0)
        {
            LiveDB.SmoothExitCondition.awaitUninterruptibly();  
        }

        
        /* First check on ChangeTracker table for flag 'I' or 'U' or 'D'
         * such tables are the only ones that need a commit all other tables
         * have been fastcomitted.
         */

        HashMap<Long, String> committables = new HashMap<Long, String> ();
        Set<Long> committablesset = new HashSet<Long> ();

        for ( int i = (int) LiveDB.CTSR; i < LiveDB.LiveSharedDB[ct].length; i++)
        {            
            if (((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getDmldate().after(LiveDB.today)
                || ((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getDmldate().compareTo(LiveDB.today) == 0 )
            {
               if (((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'U' ||
                  ((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'I'  ||
                  ((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'D'  ||
                  ((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'J'  ||
                  ((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getChange_flag() == 'R' )
               {
                  if (((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getPid() == LiveDB.pid)
                  {
                     if (LiveDB.ENABLEFASTCOMMIT || LiveDB.command_line != null)
                        committables.put(((ChangeTracker)LiveDB.LiveSharedDB[ct][i]).getTableno(), "somejunk");
                     // else ENABLEFASTCOMMIT is false and commits are under programmer control and for
                     // whatever reasons he has not commited these tables
                  }
               }
            }
        }

        // just put one more table if it is not there
        committables.put(1L,"somejunk");
        committablesset = committables.keySet();

        // place here
        for (Long v :committablesset)
        {
            if (LiveDB.SerializeJustOnceTable(v) == false)
            {
                if ((ok = commit_database (v)) == false)
                {
                    System.err.println(LiveDB.grassHopper("Fatal Error in commit_database()"));
			JOptionPane.showMessageDialog(appframe, "FATAL ERROR IN COMMITING DATABASE " + "\n");
                        JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
                }
                else
                {
                    // Now do some alteration to all entries in InstalledTables
                    for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++)
                    {
                        if (((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getTableno() == v)
                        {
                           // now insize may show negative for some tables if serialization fails
                           ((InstalledTables)LiveDB.LiveSharedDB[it][rw]).
                           setInitialsize(((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getOutsize());
                           // ChangeTracker entry for this change
                           // insert an entry in ChangeTracker table for this table
                           LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,rw, 'U', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[it][rw],(long)LiveDB.LiveSharedDB[ct].length);
                        }
                    }
                    // now remove
                    committablesset.remove(v);
                }
            }
            else
            {
                LiveDB.ALRTLVL = 1;
                System.err.println(LiveDB.grassHopper("SerializeJustOnce Table in ChangeTracker Table:" +
                        String.valueOf(v)));
                // dont exit continue with serialization of other tables
            }
        } // for (Long v :committablesset)

        setchangetrackerflags ();  // i am calling this repeatedly because system might crash NOW !!

        // Now commit also those tables which are SerializeJustOnce table if command_line equals
        // "FileTableDataFileMap" || "FiXdAtAcOrRuPtIoN"

        if (LiveDB.command_line.equals("FileTableDataFileMap") || LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
        {
            for (Long v :committablesset)
            {
                if (LiveDB.SerializeJustOnceTable(v))
                {
                    if ((ok = commit_database (v)) == false)
                    {
                        System.err.println(LiveDB.grassHopper("Fatal Error in commit_database()"));
			JOptionPane.showMessageDialog(appframe, "FATAL ERROR IN COMMITING DATABASE ");
                        JOptionPane.showMessageDialog( appframe,"IMPORTANT INFORMATION YOUR LOG FILE NAME" + '\n'
                               + "FOR THIS SESSION IS : " + '\n' + LiveDB.ErrorLogFile);
                    }
                    else
                    {
                        // Now do some alteration to all entries in InstalledTables
                        for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++)
                        {
                            if (((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getTableno() == v)
                            {
                                // now insize may show negative for some tables if serialization fails
                                ((InstalledTables)LiveDB.LiveSharedDB[it][rw]).
                                setInitialsize(((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getOutsize());
                                // ChangeTracker entry for this change
                                // insert an entry in ChangeTracker table for this table
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,rw, 'U', LiveDB.pid, new Date (),
                                LiveDB.LiveSharedDB[it][rw],(long)LiveDB.LiveSharedDB[ct].length);
                            }
                        }
                        // now remove
                        committablesset.remove(v);
                    }
                }
            }  // for (Long v :committablesset)
        } // if (LiveDB.command_line.equals("FileTableDataFileMap") || LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))

        setchangetrackerflags ();  // i am calling this repeatedly because system might crash NOW !!

        if (committablesset.isEmpty() == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("committablesset not empty some error"));
        }

        /* Now Commit those report tables which are fake tables just used for number crunching */

        for ( int i = LiveDB.REALTABLES + 1; i < (LiveDB.CUSTOMREPORTSON == false ? 36:LiveDB.tablenameidentifier.length) ; i++ )
        {
            if (Integer.parseInt(LiveDB.tablenameidentifier[i][0]) > LiveDB.REALTABLES) /* start with fake table 18 */
            {
               if ((ok = commit_database (Integer.parseInt(LiveDB.tablenameidentifier[i][0]))) == false)
               {
                    System.err.println(LiveDB.grassHopper("FATAL ERROR IN COMMIT DATABASE REPORT TABLES FOR NUMBER CRUNCHING"));                    
		    JOptionPane.showMessageDialog(appframe, "FATAL ERROR IN COMMITING DATABASE FOR REPORT TABLES FOR NUMBER CRUNCHING" + "\n");
		    JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
               }
            }
        }

        setchangetrackerflags ();  // i am calling this repeatedly because system might crash NOW !!

        for ( int i = LiveDB.REALTABLES + 1; i < (LiveDB.CUSTOMREPORTSON == false ? 36:LiveDB.tablenameidentifier.length) ; i++ )
        {
            // Now do some alteration to all entries in InstalledTables
            for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++)
            {
                if (((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getTableno() == Integer.parseInt(LiveDB.tablenameidentifier[i][0]))
                {
                   // now insize may show negative for some tables if serialization fails
                   ((InstalledTables)LiveDB.LiveSharedDB[it][rw]).
                            setInitialsize(((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getOutsize());
                   // ChangeTracker entry for this change
                   // insert an entry in ChangeTracker table for this table
                   LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                   new ChangeTracker (it,rw, 'U', LiveDB.pid, new Date (),
                           LiveDB.LiveSharedDB[it][rw],(long)LiveDB.LiveSharedDB[ct].length);
                }
            }
        }

        setchangetrackerflags ();  // i am calling this repeatedly because system might crash NOW !!

        for ( int tbl = 0; tbl <= LiveDB.REALTABLES ; tbl++ )
        {
             if (write_IndexFile(tbl) == false)
                System.err.println(LiveDB.grassHopper("FATAL ERROR IN write_IndexFile for Table No :" + String.valueOf(tbl)));
        }
        setchangetrackerflags ();  // i am calling this repeatedly because system might crash NOW !!

        }finally {SysExitLock.unlock();}

        // this setchangetrackerflags () will do a LiveDB.commit_database(ct) which will keep adding entries
        // to the change tracker table so I will turn on the fast commit mechanism if it is off by chance
        // to place that final full stop entry on the change tracker so by the time it goes thru the rest
        // of this code below fast commit mechanism should have done the job.
        
        if (LiveDB.ENABLEFASTCOMMIT == false)
            LiveDB.ENABLEFASTCOMMIT = true;

	JOptionPane.showMessageDialog(appframe, "IMPORTANT INFORMATION YOUR LOG FILE NAME FOR THIS SESSION IS : " + LiveDB.ErrorLogFile + "\n");
        LiveDB.LogFileSabotageCheck ();

        errfile.close();  // this is the stderr close it

        // Now email the Logfiles to proprietor of company
        if (LiveDB.SendLogFileMessage() == false)
            System.err.println(LiveDB.grassHopper("Error Emailing " + LiveDB.ErrorLogFile + " at System Exit"));

        LiveDB.FASTCOMMITEXIT = true;
        ThreadController.LandingTimes[4] = new Date ();

        // that fast commit mechanism may be in the middle of something so it may take a while to sense this
        // flag change. Until it senses this flag change you must not exit abruptly like a jerk !!

        // so sleep for ONE second and give that fast commit mechanism some time to sense
        // the change in status of flag LiveDB.FASTCOMMITEXIT; because by the time your thread
        // wakes up and moves into Runnable pool once again it will be a while lets say five seconds
        // And by then fast commit would have completed whatever it was doing and sense the flag and
        // exit.
        try{
                Thread.sleep(1000);
        }catch (InterruptedException ex_NOKIA14){}

        // buy another three seconds
        LiveDB.LogFileSabotageCheck ();
        
        // just before exiting check the command line again and create a file on disk
        // buy another 100 milliseconds just in case !!
        if (LiveDB.command_line.equals("FileTableDataFileMap")
                                      || LiveDB.command_line.equals("FiXdAtAcOrRuPtIoN"))
        {
            try{
                if ( new File(LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES")
                                                              .createNewFile() == false )
                {
                    if (new File(LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES")
                                                                       .delete() == false )
                    {
                        System.err.println(LiveDB.grassHopper("Error in deleting File "
                               + LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES" ));
                        ok = false;
                    }
                }
            }catch (SecurityException ex_NOKIA81){
                System.err.println(LiveDB.grassHopper(ex_NOKIA81, "File "
                            + LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES" ));
                ok = false;
            }catch (IOException ex_NOKIA69){
                System.err.println(LiveDB.grassHopper(ex_NOKIA69, "File "
                            + LiveDB.serializedfilespath + "DATALOADEDFROMCHARACTERFILES" ));
                ok = false;
            }
        }

        if (new File (LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
                  + LiveDB.pid + LiveDB.NODENAME + ".daemon" ).delete() == false)
        {
            System.err.println(LiveDB.grassHopper("Cant delete DEMONIC File:" +
               LiveDB.serializedfilespath + "daemon" + LiveDB.FILESEPERATOR + "threadsysexit"
               + LiveDB.pid + LiveDB.NODENAME + ".daemon"));
        }

        if (new File (LiveDB.serializedfilespath + "daemon").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                    + LiveDB.serializedfilespath + "daemon"));
        }

        // set write on a couple of directories where I have used deleteonexit
        if (new File (LiveDB.serializedfilespath + "syc").setWritable(true,false) == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                + LiveDB.serializedfilespath + "syc"));
        }
        if (new File (LiveDB.serializedfilespath + "daemon").setWritable(true,false) == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                + LiveDB.serializedfilespath + "daemon"));
        }
        if (new File (LiveDB.serializedfilespath + "etc").setWritable(true,false) == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                + LiveDB.serializedfilespath + "etc"));
        }
        if (new File (LiveDB.serializedfilespath + "dump").setWritable(true,false) == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                + LiveDB.serializedfilespath + "dump"));
        }        
       // This threadcontroller daemon must continue to loop or run until the last second and
        // so this is where i tell it to exit by setting flag to true. ThreadController must not
        // sense the LiveDB.system_exit flag.
        LiveDB.EXITTHREADCONTROLLER = true;
        if (ok) System.exit(0); else System.exit(1);        
    } /* public void run () */

   // Self Explanatory
   // This will be a slow gradual touch down on the tarmac Pilot is well experienced.
   // Kripya aaap apni kursi ki peti khol kay rakhaan Unlike the announcement of the Big Boys
   // they are not confident of their landing skills.
   // You boys want some flying lessons come right over !!!
   // if only i was flying on the Mangalore route that air tragedy might have been averted
   private void setchangetrackerflags (){

        for (int tuple = LiveDB.LiveSharedDB[ct].length; tuple >= (int)LiveDB.CTSR ; tuple--)
        {
             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][tuple]).getChange_flag() == 'U')
             {
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][tuple]).setChange_flag('C');
                 // ChangeTracker entry for this change
                 // insert an entry in ChangeTracker table for this table
                // but this time fake this entry to place a full stop on this ever-growing table
                 LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                 new ChangeTracker (ct,tuple, 'C', LiveDB.pid, new Date (),
                 LiveDB.LiveSharedDB[ct][tuple],(long)LiveDB.LiveSharedDB[ct].length);
             }
        }
        
        if ((ok = commit_database (ct)) == false)
            System.err.println(LiveDB.grassHopper("ChangeTracker serialization failure"));
        // but dont exit the SYS ADM will do the necessary later we have to continue with rest of process        
   }

   @Override
   public boolean commit_database (long p_Tableno){
       return LiveDB.commit_database ((int)p_Tableno);
   }

    /* protected boolean write_SortedFile ()  */
   @Override
    public boolean write_SortedFile (int p_Tableno){
        return LiveDB.write_IndexFile(p_Tableno);
    } /* protected boolean write_SortedFile () */

   @Override
    public boolean write_IndexFile ( long p_Tableno ){
        return LiveDB.write_IndexFile ((int)p_Tableno);
    }
} /* class SystemExit implements Runnable, CommitDatabase */
