/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.io.ObjectOutput;
import java.io.EOFException;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.UTFDataFormatException;
import java.io.Externalizable;
import java.io.File;
import java.util.Date;
import java.util.concurrent.Semaphore;
import static DatabaseEngine.LiveDB.us;
import static DatabaseEngine.LiveDB.ct;
import static DatabaseEngine.LiveDB.ft;

/**
 *
 * @author SAI KRISHNA
 */
public class UserSubmits implements Externalizable, Tables, Cloneable {

    private String cid;
    private String filename;
    private Date submitdate;
    private String submitlocale;
    private String reason;
    private byte type ; // 0 Audio 1 Video 2 html 3 plain file miscellaneous 4 program file
    private long rowid;

    private transient Semaphore rowlock;
    private transient UserSubmits usm;
    private transient File srf;
    private transient int itn;
    private transient long fieldchanges ; // for Ultra Fast Commits

    {
       usm = null;
       srf = null;
       fieldchanges = 0L;
       itn = 14;
       rowlock = new Semaphore (1, true);
    }

    public UserSubmits (String p_cid, String p_filename, String p_reason, String p_type, long p_rowid){

    }

    @Override
    protected Object clone () {

        rowlock.acquireUninterruptibly();

        try{
            usm = (UserSubmits)super.clone();
            usm.setCid(usm.getCid());
            usm.setFilename(usm.getFilename());
            usm.setSubmitdate(usm.getSubmitdate());
            usm.setSubmitlocale(usm.getSubmitlocale());
            usm.setReason(usm.getReason());
        }catch (CloneNotSupportedException ex_NOKIA89){
            throw new InternalError (ex_NOKIA89.toString());
        }

        rowlock.release();
        return usm;
    }

    protected int SIZEOF () {
        return ((cid.length() * 2) + (filename.length() * 2) + 8 + (submitlocale.length() * 2)
                + (reason.length() * 2) + 1 + 8);
    }

    protected String getCid () {
        return new String(cid.toCharArray()).trim();
    }

    protected String getFilename () {
        return new String (filename.toCharArray()).trim();
    }

    protected Date getSubmitdate () {
        return new Date (submitdate.getTime());
    }

    protected String getSubmitlocale() {
        return new String (submitlocale.toCharArray()).trim();
    }

    protected String getReason () {
        return new String (reason.toCharArray()).trim();
    }

    protected byte getType() {
        return type;
    }

    protected long getRowid () {
        return rowid;
    }

    void setCid(String p_cid){

           if (p_cid == null)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println(LiveDB.grassHopper("Invalid p_Cid=null"));
               System.exit(1);
           }

           if (LiveDB.indxcustomerRegister.get(p_cid) == null)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println(LiveDB.grassHopper("Invalid Cid:" + p_cid + " table UserSubmits"));
               System.exit(1);
           }
           rowlock.acquireUninterruptibly();
           cid = new String(p_cid.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_cid.length()));
           rowlock.release();
    }

    void setFilename (String p_filename){

        try{
        if (new File (p_filename).isFile() == false)
        {
            System.err.println(LiveDB.grassHopper("Not a normal File:" + p_filename));
            System.exit(1);
        }
        }catch (SecurityException ex_NOKIA66){
            System.err.println(LiveDB.grassHopper(ex_NOKIA66, "Cant read file to determine type"));
            System.exit(1);
        }

        try{
        if (new File (p_filename).exists() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("User Submitted a File which does not exist"));
        }
        }catch (SecurityException ex_NOKIA99){
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper(ex_NOKIA99, "User may have submit file that dont exist"));
        }

        rowlock.acquireUninterruptibly();
        filename = new String(p_filename.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_filename.length()));
        rowlock.release();
        
    }

    void setSubmitdate (Date p_submitdate) {

        if (p_submitdate == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Null p_submitdate table UserSubmits"));
            System.exit(1);
        }
        rowlock.acquireUninterruptibly();
        submitdate = new Date (p_submitdate.getTime());
        rowlock.release();
    }

    void setSubmitlocale (String p_locale){
        rowlock.acquireUninterruptibly();
        submitlocale = new String(p_locale.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_locale.length()));
        rowlock.release();
    }

    void setReason (String p_reason) {
        rowlock.acquireUninterruptibly();
        reason = new String(p_reason.toCharArray())
                   .concat(new String(LiveDB.BlankPads.toCharArray(),0,
                   LiveDB.MAXSTRINGFLDLEN - p_reason.length()));
        rowlock.release();
    }

    void setType (byte p_type){
        if (p_type < 0 || p_type > 4 )
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid type Valid values are 0 thru 4"));
        }
        rowlock.acquireUninterruptibly();
        type = p_type;
        rowlock.release();
    }

    void setRowid (long p_rowid){

           if (LiveDB.LiveSharedDB[us].length == 0 && p_rowid != 0)
           {
              LiveDB.ALRTLVL = 7;
              System.err.println(LiveDB.grassHopper("Invalid Args p_Rowid " + p_rowid));
              System.exit(1);
           }
           rowlock.acquireUninterruptibly();
           rowid = p_rowid;
           rowlock.release();
    }
    // although each instance of this Class InstallerDues represents a single row
    // we are committing the entire table here but before that a few checks and balances

    @Override
    public final boolean COMMIT(){

        boolean fnd = false;

        // we are committing the FileTableDataFileMap so mark those rows with change_flag 'C'
        for (int rw =  (int) LiveDB.CTSR; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
            if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == us
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'F'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'C'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'K'
                && ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getChange_flag() != 'T')
            {
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).setChange_flag('C');
                fnd = true;
                // insert an entry in ChangeTracker table for this table
                // Basically what this does is to backup this entirerow where you
                // setChange_flag('C') otherwise database reconstruct of ChangeTracker will fail.
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker ((long)ct,rw, 'U', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[ct][rw],(long)LiveDB.LiveSharedDB[ct].length);
            }
        }

        if (fnd)
        {
            // for the sake of dbfRepair we take a restore file which may be a BAD copy
            // since we are not checking for the presence of a .syc file on disk. If we
            // look for a .syc file on disk then this commit will take very very long.
            LiveDB.CopyFile(LiveDB.serializedfilespath
                   + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][us]).getFilename() + ".ser",
                   LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
                   ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][us]).getFilename() + ".ser" + ".res");
            if ( LiveDB.commit_database(us) == false )
                return false;
        }

        return true;
    }

    @Override
    public final boolean COMMITINDEXES(){

        if (LiveDB.LiveSharedDB[us].length == 0)
            return false;
        return LiveDB.write_IndexFile(us);
    }

    @Override
    public final boolean REFRESH(){
        if (RefreshDatabase.read_database(us) == false)
           return false;
        return true;
    }

    // this is a programming interface if you wish to change the logic of the Thin Client
    // but it will be slow
    // CAUTION : THIS DOES NOT ROLLBACK THE ENTIRE TRANSACTION
    // IT WILL ROLBACK THIS TABLE
    // to ROLLBACK transaction use LiveDB.TRANSACTIONROLLBACK()
    @Override
    public final boolean ROLLBACK (boolean lastsavepoint){
        // not for this table it is very dangerous
        return false;
    }

    @Override
    public final boolean ROLLBACK(){
        return ROLLBACK(false);
    }

    @Override
    public final boolean ROLLFORWARD (){
        return ROLLFORWARD (null, null);
    }

    @Override
    public final boolean ROLLFORWARD (Date p_fromtime, Date p_upto_time){
       // this cannot be provided for this table too very dangerous
        return false;
    }

    @Override
    public final void readExternal (ObjectInput stream) throws EOFException, IOException {
            rowlock.acquireUninterruptibly();
            // now read in all values here
            try{
              cid = stream.readUTF();
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "UserSubmits field cid"));
              throw new EOFException ();
            }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "UserSubmits field cid"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "UserSubmits field cid"));
              throw new IOException ();
            }

            try{
              filename = stream.readUTF();
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "UserSubmits field filename"));
              throw new EOFException ();
            }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "UserSubmits field filename"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "UserSubmits field filename"));
              throw new IOException ();
            }

            try{
              submitdate = new Date(stream.readLong());
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "UserSubmits field submitdate"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "UserSubmits field submitdate"));
              throw new IOException ();
            }

            try{
              submitlocale = stream.readUTF();
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "UserSubmits field submitlocale"));
              throw new EOFException ();
            }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "UserSubmits field submitlocale"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "UserSubmits field submitlocale"));
              throw new IOException ();
            }

            try{
              reason = stream.readUTF();
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "UserSubmits field reason"));
              throw new EOFException ();
            }catch (UTFDataFormatException ex_NOKIA93){
              System.err.println(LiveDB.grassHopper(ex_NOKIA93, "UserSubmits field reason"));
              throw new IOException (); // fake it to deque it from LiveDB.TrainsInWaiting
              // LiveDB.system_exit = 1;
              // LiveDB.SmoothExitCondition.signalAll();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "UserSubmits field reason"));
              throw new IOException ();
            }


            try{
              type = stream.readByte();
            }catch (EOFException ex_NOKIA92){
              System.err.println(LiveDB.grassHopper(ex_NOKIA92, "UserSubmits Field type"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "UserSubmits Field type"));
              throw new IOException ();
            }

            try{
              rowid = stream.readLong();
            }catch (EOFException ex_YESKIA92){
              System.err.println(LiveDB.grassHopper(ex_YESKIA92, "UserSubmits field rowid"));
              throw new EOFException ();
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "UserSubmits field rowid"));
              throw new IOException ();
            }

            rowlock.release();
    }
    
    @Override
    public final void writeExternal (ObjectOutput stream )  throws IOException {
            rowlock.acquireUninterruptibly();
            int itr = -1; // Installed table row in InstalledTables

            // first find the rowid for this table in InstalledTables
            if (LiveDB.indxinstalledTables.get(Integer.toString(us)) == null)
            {
                LiveDB.ALRTLVL = 4;
                System.err.println(LiveDB.grassHopper("UserSubmits misses entry in indxinstalledTables"));
                // perhaps the index is corrupted or has not been updated someplace so check the physical table
                for (int i = 0; i < LiveDB.LiveSharedDB[itn].length; i++)
                {
                    if (((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getTableno() == us)
                        itr = (int)((InstalledTables)LiveDB.LiveSharedDB[itn][i]).getRowid();
                }

                if (itr == -1 || itr > LiveDB.maxtables)
                {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("UserSubmits misses entry in indxinstalledTables"));
                    System.exit(1);
                }
            }
            else
                itr = (int)(long)LiveDB.indxinstalledTables.get(Integer.toString(us));

            srf = new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft]
                [(int)((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).getTableno()]).getFilename());

            // outsize should be negative before every write
            ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
            LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);

            try{
              stream.writeUTF(cid);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field cid"));
              throw new IOException ();
            }

            /*
             try{
             stream.flush();
             }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during UserSubmits serialization"));
                System.exit(1);
             }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeUTF(filename);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field filename"));
              throw new IOException ();
            }

            /*
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during UserSubmits serialization"));
                System.exit(1);
            }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeLong(submitdate.getTime());
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field submitdate"));
              throw new IOException ();
            }

            /*
             try{
             stream.flush();
             }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during UserSubmits serialization"));
                System.exit(1);
             }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeUTF(submitlocale);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field submitlocale"));
              throw new IOException ();
            }

            /*
             try{
             stream.flush();
             }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during UserSubmits serialization"));
                System.exit(1);
             }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeUTF(reason);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field reason"));
              throw new IOException ();
            }
            /*
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during UserSubmits serialization"));
                System.exit(1);
            }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);


            try{
              stream.writeByte(type);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field type"));
              throw new IOException ();
            }

            /*
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during UserSubmits serialization"));
                System.exit(1);
            }*/

            // outsize should be negative before every write
            // uncomment this line if you are writing code for Ultra Fast commits
            // ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length() * -1);

            try{
              stream.writeLong(rowid);
            }catch (IOException ex_NOKIA91){
              System.err.println(LiveDB.grassHopper(ex_NOKIA91, "field rowid"));
              throw new IOException ();
            }

            // This last flush is valid after each row Uncomment the above flushes for UltraFastCommits
            try{
                stream.flush();
            }catch (IOException ex_NOKIA73){
                System.err.println(LiveDB.grassHopper(ex_NOKIA73, "flush failed during UserSubmits serialization"));
                System.exit(1);
            }

            // setOutsize to positive value after every successfull write
            // so if there is a power outage in between we will know that there has been a serialization
            // failure and the serialized file is corrupted and take necessary steps to restpre the
            // serialized file from CrashRecovery or ChangeTracker or if both CrashRecovery and ChangeTracker
            // are corrupted then restore from last autobackup
            ((InstalledTables)LiveDB.LiveSharedDB[itn][itr]).setOutsize(srf.length());
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (itn,itr, 'U', LiveDB.pid, new Date (),
            LiveDB.LiveSharedDB[itn][itr], (long)LiveDB.LiveSharedDB[ct].length);
            rowlock.release();
    }
}
