/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;

import java.awt.Color;
import java.awt.GridBagConstraints;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;

/*
 * WIRING DIAGRAM :
 * CLASS NAME : WestAdvertPanel
 * @LOOKSY: LiveDB.ANIMATIONADVERT, LiveDB.IMAGEADVERT, LiveDB.VIDEOADVERT, LiveDB.AUDIOADVERT,
 * @LOOKSY: LiveDB.ALRTLVL, LiveDB.system_exit, LiveDB.SmoothExitCondition, LiveDB.appframe,
 * @LOOKSY: LiveDB.VIDEOPLAYERERROR
 *
 * @LOOKSY: FirstPage.java
 *
 * Associated Methods : protected static boolean DrawImage (String p_size, String p_path, JPanel p_panel,
 *                                                                                     String... p_suffix)
 *                      protected static boolean PlayAnimation (String p_size, String p_path,
 *                                                                                         JPanel p_panel)
 *                      protected static boolean PlayVideo (String p_size, String p_path, JPanel p_panel)
 *                      protected static boolean PlayAudio (String p_path, JPanel p_panel, String p_size)
 *
 * Constructor Called From : protected static void PlayAudio (long p_direction, String p_path, String p_size)
 *                           protected static boolean PlayAnimationAdvert (long p_direction, String p_path,
 *                                                                                           String p_size)
 *                           protected static boolean PlayVideo (long p_direction, String p_path,
 *                                                                                           String p_size)
 *                           protected static boolean DrawImageAdvert (long p_direction, String p_path,
 *                                                                                           String p_size)
 *
 * Constructor Parameters : byte p_type -- either of LiveDB.IMAGEADVERT, LiveDB.ANIMATIONADVERT,
 *                                                   LiveDB.VIDEOADVERT, LiveDB.AUDIOADVERT
 *                          String p_size -- when p_type is IMAGADVERT this parameter is un-used for now.
 *                                           when p_type is ANIMATIONADVERT p_size = imagewidthXimageheight
 *                                           when p_type is VIDEOADVERT p_size = HeightXWidth
 *                                           when p_type is AUDIOADVERT p_size = HeightXWidth
 *                          String p_path -- the path of the image or animation or video or audio file
 *
 * Date File : String p_path passed to constructor
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This class constructor is meant to construct the West direction AdvertPanel.
 * It checks parameter p_type and calls associated methods above. In the call to PlayVideo it sets
 * LiveDB.VIDEOPLAYERERROR to true.
 *
 * Technical Reference : Buy and Read Tin Tin and Shooting Star
 * Musical Accompanyments : Al Jarreau Tenderness
 *
 * Start Date: 18th August 2011
 * End Date: 9th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class WestAdvertPanel {
    
    protected static JPanel westadvertpanel = null;
    GridBagConstraints constraints = null ;
    
    public WestAdvertPanel (byte p_type, String p_size, String p_path)
    {
        westadvertpanel = new JPanel();
        westadvertpanel.setLayout(new BoxLayout(westadvertpanel, BoxLayout.Y_AXIS));
        westadvertpanel.setBorder(BorderFactory.createEtchedBorder(Color.DARK_GRAY, Color.LIGHT_GRAY));
        
        LiveDB.appframe.add(westadvertpanel,
                setConstraints((int)(LiveDB.appframe.LEFT_ALIGNMENT * 10),
        (int)(LiveDB.appframe.BOTTOM_ALIGNMENT * 10) - (int)(LiveDB.appframe.BOTTOM_ALIGNMENT * 10)/4 * 3,
        Integer.parseInt(p_size.substring(p_size.toUpperCase().lastIndexOf("X"), p_size.length())), //Width
        Integer.parseInt(p_size.substring(0,p_size.toUpperCase().indexOf("X")))));
        
        westadvertpanel.setBounds((int)(LiveDB.appframe.LEFT_ALIGNMENT * 10),
        (int)(LiveDB.appframe.BOTTOM_ALIGNMENT * 10) - (int)(LiveDB.appframe.BOTTOM_ALIGNMENT * 10)/4 * 3,
        Integer.parseInt(p_size.substring(p_size.toUpperCase().lastIndexOf("X"), p_size.length())), //Width
        Integer.parseInt(p_size.substring(0,p_size.toUpperCase().indexOf("X")))); // height
        if (p_type == LiveDB.IMAGEADVERT)
        {
            if (FirstPage.DrawImage(p_size, p_path, westadvertpanel) == false)
                return;
        }
        else if (p_type == LiveDB.ANIMATIONADVERT)
        {
            if (FirstPage.PlayAnimation(p_size, p_path, westadvertpanel) == false)
                return;
        }
        else if (p_type == LiveDB.VIDEOADVERT)
        {
            if (FirstPage.PlayVideo(p_size, p_path, westadvertpanel) == false)
            {
                LiveDB.VIDEOPLAYERERROR = true;
                return;
            }
        }
        else if (p_type == LiveDB.AUDIOADVERT)
        {
            if (FirstPage.PlayAudio(p_path, westadvertpanel, p_size) == false)
                return;
        }
        else
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Error specifying ADVERT type"));
            LiveDB.system_exit = 1;
            LiveDB.SmoothExitCondition.signalAll();
        }
    }
    
    GridBagConstraints setConstraints (int X, int Y, int W, int H)
    {
        constraints = new GridBagConstraints ();
        constraints.weightx = 100;
        constraints.weighty = 100;
        constraints.gridx = X;  // default 2
        constraints.gridy = Y; // default 1
        constraints.gridwidth = W; // 1
        constraints.gridheight = H; // 1
        return constraints;
    }
}
