/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package DatabaseEngine;


import javax.swing.JProgressBar;
import javax.swing.ProgressMonitor;
import javax.swing.JOptionPane;
import java.awt.Toolkit;
import java.util.NoSuchElementException;
import java.io.DataInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import javax.mail.internet.AddressException;
import javax.mail.Address;
import javax.mail.MessagingException;
import java.util.Properties;
import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.activation.FileDataSource;
import javax.mail.BodyPart;
import javax.mail.Message;
import javax.mail.Multipart;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import java.util.MissingResourceException;
import java.io.Serializable;
import java.io.OptionalDataException;
import java.io.StreamCorruptedException;
import java.io.InvalidClassException;
import java.text.ParseException;
import java.io.PrintStream;
import java.io.FileInputStream;
import java.io.EOFException;
import java.io.UTFDataFormatException;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;
import java.io.File;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.Semaphore;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.nio.channels.ClosedChannelException;
import java.nio.channels.FileChannel;
import java.nio.channels.FileLock;
import java.nio.channels.OverlappingFileLockException;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Random;
import java.util.TreeSet;
/* WATCH OUT static imports */
import static DatabaseEngine.InstallDB.threadcontroller;
import static DatabaseEngine.InstallDB.threadleash;
import static DatabaseEngine.InstallDB.threadsrtindx;
import static DatabaseEngine.InstallDB.threadrefreshdb;
import static DatabaseEngine.InstallDB.threadsysexit;
import static DatabaseEngine.InstallDB.threadwritetables;
import static DatabaseEngine.InstallDB.threadroyal;
import static DatabaseEngine.InstallDB.threadloveall;
import static DatabaseEngine.InstallDB.threadspy;
import static DatabaseEngine.InstallDB.threadgui;
//import static DataEntryPrograms.DotingEntry.SenseNetworkDrives;

/*
 * WIRING DIAGRAM :
 *
 * Class Name : LiveDB
 * Methods : Look in Class definition
 * Data Attributes : Look in Class definition for a complete list also there is substantial documentation
 * next to every field definition to assist understanding
 *
 * Data File : None
 *
 * @Since Version 1.0
 *
 * Running Commentary : This class LiveDB is your entire LensView application system environment (which
 * includes all identifiers such as variables, methods, indexes, sorts PLUS actual database LiveSharedDB
 * which contains all tables and rows for each table.
 *
 * Technical References : You will notice that nearly everything in this class is static. YES i want them
 * to be static and I dont want you to instantiate this class although you may extend it where you need it.
 *
 * There is also a special algorithm which has been explained at the bottom of this passage for
 * handling of rowsets. I have not used that algoritm in this release will use it in next release.
 *
 * PEDHA PEDHA BYTES ALGORITHM
 * First decide on a number for each rowset. Meaning that a rowset can only contain at best so many
 * records. Let this number be in multiples of 1000 (one thousand). You need to decide on a good number
 * because very small numbers will mean very frequent disk I/O but a small memory footprint and very large
 * numbers will mean very little disk I/O and large memory usage. So ask some benchmarking expert to give
 * you the ideal number.
 *
 * write a simple method called protected static int rowsets(int tbl, long rowid)
 * Every time you refer to LiveSharedDB in source code as LiveDB.LiveSharedDB[ct][rowsets(ct,1039)]
 * plug in this method in the index subscript. So the method quickly looks up 1039 in the current rowset
 * that is loaded in memory and returns the same 1039. going by the number the method knows that 1039
 * will be in the second rowset and so if that rowset2 for ct table is currently loaded in memory it
 * returns 1039 straightaway but if rowset two was not in memory currently it will refresh rowset 2 from
 * disk. Using this algorithm you can refer rows far beyond what the normal subscripts allow because all
 * it does is to look for that row set where the row would belong and returns a integer number which is
 * the rowset rowid. So the largest number of records each rowset can contain is the maximum value of
 * an integer. So that is reason why all tables rowids have been declared as long . Al other indexes
 * and sorts will remain unchanged. Get the hang of it.
 *
 * Musical Accompanyments : THELONIUS MONK "ALL MONK" The Riverside Albums
 * Class Dedicated to : Dhrisya and TukTuk (My nieces)
 *
 * Start Date: 18th October 2010
 * End Date: 12th June 2011
 * Last Modified : 11th August 2011
 * Last Modification : Added declaration protected static String COUNTRY; Also added initialization
 * Block
 * {
 *       USRDIR = new Properties().getProperty("user.dir");
 *       TMPDIR = new Properties().getProperty("java.io.tmpdir") == null ? USRDIR : TMPDIR;
 * }
 * Added Declarations
 * public static boolean AUTOINSTALL = true;
 * public static Character NETWORKDRIVE = SenseNetworkDrives ()[0];
 *
 * Last Modified : 12th August 2011
 * Last Modifications : Added Declarations as below look in class LensView method showProgress () and main
 * for usage of these identifiers.
 * protected static ProgressMonitor progressMonitor;
 * protected static JProgressBar progressbar;
 *
 * Last Modified : 13th October 2011
 * Last Modifications : the field seperator chosen by user to compile should be validated and reset to
 * defaults if he chooses something else. I would like to retain that variable as final but cant.
    static
    {
        if (fieldseperator.equals("!") == false && fieldseperator.equals("|") == false
            && fieldseperator.equals(":") == false )
            LiveDB.fieldseperator = "|";
    }
 *
 * Last Modified : 14th October 2011
 * Last Modifications : added another declaration for the installed node name where LensView is installed
 * protected static String INSTALLEDNODE;
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

public class LiveDB {

    // Change here to desired vendor name and compile dont exceed character beyond <......>
    protected static final String DISKVENDOR = "<Your Existing Vendor Name>";
    protected static final String MEMORYVENDOR = "<Your Existing Vendor Name>";
    protected static final String PROCESSORVENDOR = "<Your Existing Vendor Name>";
    protected static final String BOARDVENDOR = "<Your Existing Vendor Name>";
    protected static final String PAPERVENDOR = "<Your Existing Paper Vendor>";
    protected static final String UPSVENDORNAME = "<Your Existing Vendor Name>";
    protected static final String BATTERYVENDORNAME = "<Your Existing Vendor Name>";
    protected static final String OSVENDORNAME = "<Existing Vendor>";
    protected static final String LOCKVENDORNAME = "<What Do You Suggest>";
    protected static final String CLOCKVENDORNAME = "<What Do You Suggest>";

    /* Globals for various screen layout positions that you dictate
     * for your advertising images.
     */

    public static final short north = 0;
    public static final short south = 1;
    public static final short east = 2;
    public static final short west = 3;
    public static final short middle = 4;
    public static final short northwest = 5;
    public static final short northeast = 6;
    public static final short southwest = 7;
    public static final short southeast = 8;

    protected static long threadroyalid = 1;  /* re-init later in program */
    protected static long threadspyid = 2; /* re-init later in program */
    protected static long threadhearts = 3; /* re-init later in program */

    /* Fetch from system properties */
    public static String OPERATINGSYSTEM = new Properties().getProperty("os.name");
    protected static String USRHOMEDIR = new Properties ().getProperty("usr.home");
    protected static String USRDIR;
    protected static String JAVAVER;
    protected static String JAVAVENDORURL;
    protected static String USRNAME;
    protected static String NODENAME;
    protected static String INSTALLEDNODE;
    protected static String JAVACLASSPATH;
    protected static String JAVACLASSVERSION;
    protected static String OSVERSION;
    protected static String OSARCH;
    protected static String TMPDIR;
    protected static String PATHSEPERATOR;
    protected static String COUNTRY;
    protected static String DRIVESEPERATOR = ":";
    public static String FILESEPERATOR = new Properties().getProperty("file.seperator");

    public static String WINDOWS = "Windows";
    public static String LINUX = "Linux";
    public static String SOLARIS = "Solaris";
    public static String MACINTOSH = "Mac";

    {
        USRDIR = new Properties().getProperty("user.dir");
        if (USRDIR == null)
        {
            if (USRHOMEDIR != null)
                USRDIR = USRHOMEDIR;
            else USRHOMEDIR += FILESEPERATOR;
        }
        USRDIR += FILESEPERATOR;
        TMPDIR = new Properties().getProperty("java.io.tmpdir") == null ? USRDIR : TMPDIR;
    }

    // get these later from LensView Properties file
    // do not exceed 80 characters mention Time Zone if you want to better LOCAL TIME
    protected static String STOREHOLIDAYS = "Sunday,Labor Day,Thanksgiving,Christmas,Good Friday,Mandatory National Holidays";
    // do not exceed 80 Characters
    protected static String STORETIMINGS = "10 AM to 5 PM LOCAL TIME";
    protected static String OTHERHOLIDAYS = "Deepavali,Ganesh Chaturthi,ShivaRatri,Janmashtami,Buddha Purnima,Bakrid,Hanukah";

    protected static float EURO; // how many euros make 1 usd
    protected static float INR; // how many rupees make 1 usd
    protected static float POUNDSTERLING; // how many pound sterling make 1 usd
    protected static float USD; // how many usd make 1 euro
    protected static float CURRENCYTHRESHOLD = 0.41f;

    // get from properties file
    protected static boolean CLOUDY = false;
    protected static boolean RAINY = false;
    protected static String TEMPERATURE = "28C";

    // Copy priceless potraits from directory to directory COPYTO
    protected static String COPYFROM = null;
    protected static String COPYTO = null;
    protected static String COPYTRANSFILESFROM = null;

    // FILL OUT  THE USERNAME AND PASSWORD FOR EMAIL1 in ARTLEAVES WHICH FOR EXAMPLE MAYBE pskris@gmail.com
    // ALSO FILL OUT THE PASSWORD AND COMPILE THE PROGRAM AND DONT LEAVE THE SOURCE CODE FOR THE WORLD !!!
    // I CAN WRITE THESE DETAILS IN A BINARY PASSWORD FILE WHICH MAY BE STOLEN
    protected static String GMAILUSERNAME = "pskris";
    protected static String GMAILPASSWORD = "acrabacadra506";

    protected static boolean MEMDUMP = true;    // dump data from LiveSharedDB in readable/data reload format
    protected static boolean DISKDUMP = true;  // dump data from disk file in readable/data reload format
    protected static boolean BKUPDUMP = true; // dump data from bkup disk file in readable/data reload format
    public static boolean HOME_EDITION = false; // change this in LENSVIEWPROPERTIESFILE.txt before compiling if yours is home Ed
    public static boolean AUTOINSTALL = true;
    //public static Character NETWORKDRIVE = SenseNetworkDrives ()[0];

    protected static VersionControl versionControl = new VersionControl();
    protected static Thread mainthread = null;
    /*
     * serializedfilespath is a pathname where all database files will be stored for LensView
     * under different sub-directories. Intial value for this is "user.dir" which will be changed
     * after a call to getserializedfilespath (); or readconffile() in main method of InstallDB.
     * When you are short of disk space. This LiveDB.serializedfilespath is redirected to userhomedir
     * as an action of last resort to prevent the application from crashing.
     */
    public static String serializedfilespath = new Properties().getProperty("user.dir");
    
    protected static String LENSVIEWPROPERTIESFILE = LiveDB.USRDIR + "LENSVIEWPOPERTIESFILE";
    
    /* Languages selected by user initialized after a call to selectLanguages () or readconffile()
     * These methods are called from InstallDB main method.
     */
    protected static String LanguageSelections;

    protected static byte MAXPLATFORMENTRIES = 9; // can be increased upto 14
    protected static int SLEEPTIME = 2000; // based on moderate usage can be reduced upto 500
                                           // and increase to 4000 for low usage

    protected static boolean DUMPSECURITY = true; // dump files will be deleted after mailing them out
    // enable or disable programmingScrewups function
    protected static boolean CHECKPROGRAM = true;
    protected static boolean EXITTHREADCONTROLLER = false; // must be false always at startup
    // If this flags is set to false PowerOutageSensor () will not be called
    protected static boolean POWEROUTAGEENABLED = true;
    // re-init later after checking file size of table FileTableDataFileMap on disk
    protected static long MINCRITICALFILESIZE = 2048 ;
    // increase or reduce in multiples of 1024
    // if you wish to reduce this take the advise of a good Java programmer.
    // I have kept the number high to accomodate any future additions you may make to fields.
    protected static final int MARKREADLIMIT = 4096; 

    // These are very usefull globals that help speed loop searches of tables. Each of these gives
    // you the start row for this session immediately after a snapshot of the database is taken but before
    // the user logs in.
    protected static long CTSR = 0L; // ChangeTracker start row
    protected static long CRSR = 0L; // CustomerRegister start row
    protected static long RTSR = 0L; // ReportsTable start row
    
    // some indian names can be as long as 75 characters for example my name is
    // kodangudi vaidyanathswamy padmanabhan sai krishna so 50 chars so school reduced my name to fit paper
    protected static byte MAXSTRINGFLDLEN = 75; // increase more if you want but file footprint will increase
    // there are a 100 blanks in this string increase to 127 at best to support MAXSTRINGFLDLEN
    protected static String BlankPads = "                                                                                                        ";

    // runtime enable or disable if you disable you slow commit
    protected static boolean ENABLEFASTCOMMIT = true; 
    protected static final byte REALTABLES = 17; /* beyond table no 17 these are all fake tables */
    
    // set to values between 3 & 5 not more not less bigger number increases timeslice
    protected static final byte TIMESLICER = 4; 

    protected static final byte ALLOWUSERS = 64; // MAX USERS TO ALLOW TO LOGIN AT ANY POINT OF TIME

    protected static short RESTOCKPERCENT = 12; // RESTOCK FEE PERCENT
    protected static final short MINRESTOCKPERCENT = 4;
    protected static final short MAXRESTOCKPERCENT = 15;
    protected static InstallDB appframe; // The main application frame use this always or most times.

    protected static byte SPACEFACTOR = 3; // this is used in thread AUTOBACKUP dont reduce but you can increase
    protected static byte BACKUPFREQUENCY = 10; // used by autobackup thread time in minutes dont go below ten and above 60
    static  // auto correct if user accidentally specifies a higher value
    {
        if (LiveDB.SPACEFACTOR > 50) SPACEFACTOR = 50;
        else if (LiveDB.SPACEFACTOR < 3) SPACEFACTOR = 3;

        if (LiveDB.BACKUPFREQUENCY > 60) BACKUPFREQUENCY = 60;
        else if (LiveDB.BACKUPFREQUENCY < 10) BACKUPFREQUENCY = 10;

        if (LiveDB.MAXPLATFORMENTRIES > 14)
            MAXPLATFORMENTRIES = 14;
        else if (LiveDB.MAXPLATFORMENTRIES < 9)
            MAXPLATFORMENTRIES = 9;

        if (LiveDB.SLEEPTIME > 4000)
            SLEEPTIME = 4000;
        else if (LiveDB.SLEEPTIME < 500)
            SLEEPTIME = 500;
        
        appframe = null;
    }    
                                             // jiro        one         two         three
    protected static String [] AlertLabels = {"SYSADM:", "INTRUDER:", "SABOTAGE:", "WARNING:",
            // four       five        six        seven                   eight        nine
       "CORRUPTION:", "ADVISORY:", "GENERAL:", "PROGRAMMING SCREWUPS:", "EMERGENCY:", "LOWBATTERY:",
       // ten        // eleven       // twelve         // thirteen     // fourteen      // fifteen
       "OUTOFSPACE:", "FAKEDATABASE:", "DATABASE CRASH:", "DISK FAILURE:", "OUT OF MEMORY:", "BAD-DATA:"
    };
    public static int ALRTLVL = 0; // based on this it picks a label above

    // add more standard error message for each type of error and pick yours from this list
    protected static String [] ErrMesgs =
    {
        // 0 Default
        " Self Explanatory and/or read explanation below with same line number ",
        // 1 IOEXception
        " stream has been closed, input stream does not support reading after close or another I/O error occurs ",
        // 2 IOException
        " I/O error occurs ",
        // 3 IOException
        " file could not be created ",
        // 4
        " Variant 4 ", // must have single space on both sides
        // 5 UTFDataFormatException
        " the bytes do not represent a valid modified UTF-8 encoding of a string ",
        // 6
        " Variant 2 ", // must have single space on both sides
        // 7 EOFException
        " this input stream reaches the end before reading all the bytes ",
        // 8
        " Variant 2 ", // must have single space on both sides
        // 9 SecurityException
        " SecurityManager.checkRead(java.lang.String) method denies read access to file ",
        // 10 SecurityException
        " SecurityManager.checkWrite(java.lang.String) method denies write access to the file ",
        // 11 SecurityException
        "SecurityManager.checkExec(java.lang.String) method denies execute access to the file ",
        // 12 SecurityException
        " SecurityManager.checkDelete method denies delete access to the file ",
        // 13 SecurityException
        " a required system property value cannot be accessed ",
        // 14 SecurityException  use this with getFreeSpace getUsableSpace getTotalSpace etc
        " Security Manager denies RuntimePermission(\"getFileSystemAttributes\") or read denied to pathname ",
        // 15 
        " the current thread cannot modify this thread ",
        // 16 IllegalArgumentsException
        " argument contains fewer characters or invalid number of arguments or invalid characters ",
        // 17 NumberFormatException
        " attempt to convert string to numeric types, string format incorrect ",
        // 18 NumberFormatException
        " Variant 2 ", // must have single space on both sides
        // 19 ClosedChannelException
        " this channel is already closed ",
        // 20 OverlappingFileLockException
        " lock overlaps request region held by JVM, other thread blocked in trylock overlap region same file ",
        // 21 ArrayOutofBoundsException
        " specified index argument is negative, or is greater than or equal to length of specified array ",
        // 22 NullPointerException
        " Specified Object is null ",
        // 23 IllegalThreadStateException
        " this thread is already active ",
        // 24 IllegalThreadStateException
        " Variant 2 ", // must have single space on both sides
        //25 ParseException
        " beginning of the specified string cannot be parsed ",
        //26 ParseException
        " Variant 2 ", // must have single space on both sides
        //27 ParseException
        " Variant 3 ", // plug in your customized error message here if you dont like system error message
        // 28 ClassNotFoundException
        " Class of a serialized object cannot be found ",
        // 29 InvalidClassException
        " Something is wrong with a class used by serialization ",
        // 30 StreamCorruptedException
        " Control information in the stream is inconsistent ",
        // 31 OptionalDataException No longer need with Java SE 6 autoboxing from primitive to Object
        " Primitive data was found in the stream instead of objects ",
        // 32 MissingResourceException
        " A Resource Bundle is Missing ",
        // 33 AddressException
        " Invalid Email Address Specified ",
        // 34 MessagingException
        " MessagePreparationFailure:cant add specified Recipient[s] addRecipient/addRecipients ",
        // 35 MessagingException
        " MessagePreparationFailure:cant set subject setSubject ",
        // 36 MessagingException
        " MessagePreparationFailure:cant set from setFrom ",
        // 37 MessagingException
        " MessagePreparationFailure:cant set body of message setContent ",
        // 38 MessagingException
        " MessagePreparationFailure:cant set text of message with attachment setText ",
        // 39 MessagingException
        " MessagePreparationFailure:cant set DataHandler for message setDataHandler ",
        // 40 MessagingException
        " MessagePreparationFailure:cant add body part for message addBodyPart ",
        // 41 MessagingException
        " MessagePreparationFailure:cant attach specified file to message setFileName ",
        // 42 MessagingException
        " AirportPostOfficeClosed:cant connect using specified username,password connect() ",
        // 43 MessagingException
        " MessageNotDelivered:message not delivered sendMessage ",
        // 44 MessagingException
        " PostBoxOpen:could not close transport connection Zip Up !! close () ",
        //45 IllegalAccessException
        " Executing method dont have access to definition of class,field,method or constructor ",
        //46 IllegalAccessException
        " Variant 2 ", // must have single space on both sides
        //47 InvocationTargetException
        " the underlying method invoked by Method throws an exception ",
        //48 InvocationTargetException
        " Variant 2 ", // must have single space on both sides
        //49 NoSuchMethodException
        " particular Method cannot be found in class ",
        //50 NoSuchMethodException
        " Variant 2 " // must have single space on both sides
    };

    protected static int ErrMesgNo = 0; // dont change this default

    // Look at Method AllUsersKickedOut () below
    protected static FileOutputStream FOS  = null;
    protected static FileLock Xclusive = null;

    // look at PRANKSTER() method
    protected static FileOutputStream FSCKFILE = null;
    protected static FileLock FSCKLOCK = null;

    // look at Prankster() methods
    protected static FileOutputStream [] IPCSSYNC = null;
    protected static FileLock [] IPCSSYNCLOCKS = null;
    protected static FileOutputStream [] READINPROGRESS = null;
    protected static FileLock [] READINPROGRESSLOCKS = null;
    protected static ProgressMonitor progressMonitor;
    protected static JProgressBar progressbar;

    // These important bytes will most probably be tampered with by a malevolent program
    // we plug in the byte numbers in the ReportWriter and also some defaults for now. The report format
    // could change if you choose to customize/re-write the ReportWriter and so the new byte pos
    // must be plugged in here for tampering checking. It is being done automatically in the reportwriter
    // dont worry be happy
 
    protected static final String [][] BallTamperingBytes =
    {
        // the first is report id followed by all byte numbers that may be tampered except the last two
        // the last in the size of each row of report data and the second last is the size of the headerfooter
        // in bytes on every page.
        // FrenchKiss Report may have a different set of numbers you may wish to check
        {"36","0000000000", "0000000000","0000000000","0000000000","0000000000","0000000000"},  /* RMA Refunds */
        {"25","0000000000", "0000000000","0000000000","0000000000","0000000000"},  /* " French Kiss - First Orders " */
        {"35","0000000000", "0000000000","0000000000","0000000000","0000000000","0000000000","0000000000"}
        /* Purchase Order Report Capable of 8,000 plus orders from a single customer */
        /* There are five important bytes possitions to check for cid, pic, qty, disc, amount for each PO */
        /* so each set of five numbers in the above array belong to a single purchase order */
    };

    /* some frequently used tables dont delete final specifier */
    
    protected static final int ft = 0, ct = 1, cr = 2, id = 3, ls = 4, lt = 5, cp = 6, pt = 7, ni = 8,
                               us = 9, sd = 10, da = 11, ar = 12, crr = 13, it = 14, rt = 15, ll = 16,
                               pc = 17;

    protected static final byte MAXLONGITUDE = 30;
    protected static final byte MINLONGITUDE = -30;
    protected static final byte MAXLATITUDE = 40;
    protected static final byte MINLATITUDE = -40;

    public static final String[][] tablenameidentifier =
    {
     // tableno, tablename, approx rows, exact cols
        {"00","FileTableDataFileMap","18","8"}, /* this field count */   /* RW table */
        {"01","ChangeTracker","5000","8"},        /* must be accurate here */  /* RW table */
        {"02","CustomerRegister","300","25"},  /* RW table */
        {"03","InstallerDues","10","9"},  /* RW table */
        {"04","LanguageSupport","30","4"},
        {"05","LanguageTitles","1000","4"},
        {"06","CustomerPayments","50","6"},
        {"07","PaymentType","10", "3"},
        {"08","NodalInfo","100", "51"},
        {"09","UserSubmits","3000", "5"},
        {"10","SearchDatabase","3000","3"},   // approx rows are initial guestimates can be updated later
        {"11","DefaultAdvertisingImages","10", "10"}, // i have added a little extra
        {"12","Artleaves","1", "30"},
        {"13","CrashRecovery","13", "4"}, /* RW table */
        {"14","InstalledTables","55", "9"}, /* RW table */
        {"15","ReportsTable","35", "10"}, /* RW table */
        {"16","LatLongMap","100","5"},
        {"17","PlatformClearance","750","6"}, /* I am not registering TrainRunningInformation here */ /* RW table */
        {"18","RunAwayBrideReport","25","25"},  /* re-init the row and column values later */
        {"19","OctopussyReport","25","25"},
        {"20","HerMajestiesServiceReport","25","25"},
        {"21","TopGunReport","25","25"},
        {"22","CityOfAngelsReport","25","25"},
        {"23","YouGotMailReport","25","25"},
        {"24","DiamondsAreForeverReport","25","25"},
        {"25","FrenchKissReport","25","25"},
        {"26","NeverSayNeverAgainReport","25","25"},
        {"27","YouOnlyLiveTwiceReport","25","25"},
        {"28","WhenHarryMetSallyReport","25","25"},
        {"29","TheDoorsReport","25","25"},
        {"30","SleeplessInSeattleReport","25","25"},
        {"31","LivingDaylightsReport","25","25"},
        {"32","iQReport","25","25"},
        {"33","CourageUnderFireReport","25","25"},
        {"34","QuantumOfSolaceReport","25","25"},
        {"35","MoneyMoneyMoneyReport","25","25"},
        {"36","DrNoReport","25","25"},
        {"37","CustomShoppingCartReport","25","25"},
        {"38","CustomCustomerRegisterReport","25","25"},
        {"39","EnvelopeReport","25","25"},
        {"40","PlotterReport","25","25"},
        {"41","CustomPlotterReport","25","25"},
        {"42","GraphReport","25","25"},
        {"43","CustomGraphReport","25","25"},
        {"44","ApplePieReport","25","25"},
        {"45","CustomApplePieReport","25","25"},
        {"46","BulkMailReport","25","25"},
        {"47","CustomBulkMailReport","25","25"},
        {"48","MicrophoneReport","25","25"},
        {"49","BlueToothReport","25","25"},
        {"50","EyeBallRecognitionReport","25","25"}
    };

    
    /* Indexes and Sort Names Identifier ready lookup */
    protected static final String[][] indxsrtnameidentifier =
    {  /* CHANGE HERE */
        /* tableno, index or sort name, index no or sort no */
        {"00","fileTableDataFileMap","36"},  /* 36 is the index number */
        {"01","indxchangeTracker","37"},
        {"02","indxcustomerRegister","38"},
        {"03","indx1shoppingCart","39"},
        {"03","indx2shoppingCart","40"},
        {"04","indxlanguageSupport","50"},
        {"05","indxlanguageTitles","51"},
        
        {"06","indx1languageTransalations","53"},
        {"06","indx2languageTransalations","54"},

        {"07","indxpaymentType","55"},
        {"08","indxpictureDatabase","56"},
        {"09","indxpictureOptions","57"},
        {"10","indxsearchDatabase","58"},
        {"13","indxcrashRecovery","59"},
        {"14","indxinstalledTables","60"},
        {"15","indxreportsTable","61"},
        {"15","srt1reportstable","62"}, /* 62 is the sort number */
        {"15","srt2reportstable","63"},
        {"15","srt3reportstable","64"},
        {"09","indx2pictureOptions","65"}
    };

    // Next Release we will deliver a sophisticated printing system whereby
    // you can define your own print policy using a text file in a specific format.
    // As of now it will siviourly delay the ReportWriter as well as mail system
    // As of now it will also compromise data security but anyways data security
    // will always be compromised if somebody reads the printout any place
    // The print security policy that you define will allow you to name printers, 
    // which reports/files to print that have been generated by this application.
    // Time of Day to print report, Week of day, notification emails etc.
    // Java has a fairly sophisticated printing system to abuse
    protected static final Boolean IMMEDIATEPRINT = false;
    protected static String NETWORKPRINTERNAME = null;
    protected static String HOMEPRINTERNAME = null; // must be connected to corporate network as network printer
    // you might have to cheese up some pizzas for a sysadm to get your home computer on his network
    // Also your printer at home must have a built in network card option.

    protected static final boolean CUSTOMREPORTSON = false;
    /* Report Types Generated ... May add more types for easy search */
    protected static final String reporttype [] = {"PO", "INV", "RMA", "CR", "SC", "MIS", "PLOT", "POST", "GRAPH", "PIE", "MAIL" };

    /* This will be used to get access to Main Line */
    /* By default your pid (alias sid) will place all I/O requests on this queue
     * with the initial default capacity of 16 for an ArrayDeque
     * If this initial capacity is not sufficient then there is a
     * very very very serious performance issue on the table.
     * In such sictuations procure a copy of the Station Masters Report
     * and then do some fine tuning in the Thread controller.
     * More than 16 Trains waiting for TrackClearance at any railway
     * station in the world is unheard of !!
     * PlatformClearance is FIFO.
     * In fact at any given point in time there should not be more than five or
     * six trains in waiting although the capacity is sixteen !!
     * Five or six is bad enough perhaps just two or three is ideal. SO be real
     * fast on the draw.
     */

    // compiler synchronizes with volatile
    protected static volatile ArrayDeque<PlatformClearance> TrainsInWaiting = new ArrayDeque<PlatformClearance> ();
    // define a single gate for TrainsInWaiting
    protected static Semaphore CABINGATEC;
    static
    {
       CABINGATEC = new Semaphore(1,true); // fair weather locking
    }

    protected static String [][] reportmethodidentifier = {
        {"18","RunAwayBride"," Run Away Bride - Inactivity "},
        {"19","Octopussy", " Octopussy - New Females "},
        {"20","HerMajestiesService", " Majesty Service - Celeb/Royal "}, /* Hey this last bit is the default Report  Title */
        {"21","TopGun", " Top Gun - Celeb/Royal Buys "}, /* Make Em Short to fit into potrait A4 or else it will result in code bloat !! */
        {"22","CityOfAngels", " City Of Angels - Active Zips "},/*I am Jap programmer named HEROGANA FLUNK like to skip code so eating KUNJI !!*/
        {"23","YouGotMail", " You Got Mail - Celeb/Royal XXL Buy "}, /* Use Monotype Corsiva Font on Invite Envelope free Bonus */
        {"24","DiamondsAreForever", " Diamonds Forever - XXL Buy "}, /* Make him/her  Celebrity in Future Releases and then Royalty */
        {"25","FrenchKiss", " French Kiss - First Orders "},
        {"26","NeverSayNeverAgain", " Say Never Again - Many Drops "},
        {"27","YouOnlyLiveTwice", " Only Live Twice - Two Drops "},
        {"28","WhenHarryMetSally", " Hurry Meet Silly - Door Shopper "},
        {"29","TheDoors", " The Doors - Lost More than a Year "},
        {"30","SleeplessInSeattle", "Sleepless Seattle - Lost/Found "},
        {"31","LivingDaylights", " Living DayLights - Weird Hours "},
        {"32","iQReport", " IQ - Rip Off Customers "},
        {"33","CourageUnderFire", " Courage In Fire - Buy post Crash "},
        {"34","QuantumOfSolace", " Quantum of Solace - Cart Recovery "},
        {"35","MoneyMoneyMoney", " Money Money - Purchase Order "},
        {"36","DrNo", " Dr No - RMA Refunds "},
        {"37","CustomShoppingCart", "Your Custom ShopCart Data"},
        {"38","CustomCustomerRegister", "Your Custom CustRegister Data"},
        {"39","Envelope", "CONTENTS TO BE VIEWED BY ADRESSEE ONLY"}, /* I dont do any printing you might want to Any Envelope Size */
        {"40","Plotter", "Line Graph"},
        {"41","CustomPlotter", "The Plot you Hatched"},  /* Use this for yourself dont mess with mine */
        {"42","Graph", "Bar Graph"}, /* for next release some default bar graph, line graph using ReportWriter */
        {"43","CustomGraph", "Your Customised Graph"}, /* Use this for yourself dont mess with mine */
        {"44","ApplePie", "Pie Chart"}, /* This will short circuit my brains (will eat humble pie) so I will wait for next release */
        {"45","CustomApplePie", "The Pie You Baked YUCK !!"}, /* Your Pie Chart dont even attempt !! Free handover to your secretary
                                                               * Look MORONS I have to incorporate Colors and draw in html so please
                                                               * wait. I will supply standard html colors nothing more. I will have
                                                               * to read a book Called MATH for DUMMIES.
                                                               * To assist your brains with this. If the variety of data is more then
                                                               * draw a much bigger circle to bake your PIE or else you had it.
                                                               */
        {"46","BulkMail", "Bulk Mail"}, /* This is for me I use it to mail myself generated reports dont mess with this */
        {"47","CustomBulkMail", "From Sgt BILKO Meet the Press"},           // You use this one dont mess with mine I will plug in a GenericMailBox
        {"48","MicrophoneReport", "From Sgt IRobot Your Orders"},           // for you using JavaMail API so please wait or do it yourself/struggle
        {"49","BlueToothReport", "From Sgt Rabbit Your Called Report"},     // For BlueTooth Report install Classic Phone Tools or use plugins
        {"50","EyeBallRecognitionReport", "Shiela Ki Jawani Hut meri Rani"}, // We will store your picture in database and compare it with one captured
                                                                            // by IBalls pixel by pixel and then take commands from Master.
        {"51","ResponseTimesReport", "Station Masters Report RESPONSE TIMES"}
    };


  /* HEY HEY HEY if you tweak upstairs set this downstairs from the upstairs
   */
    
   protected static  int minrepid = 18;  /* lowest report id */
   protected static int maxrepid = 51; /* highest report id */

    /* Dont Support too many fonts just the common fonts used an extensive set may not be supported with those nroff troff stone age caveman primitive
     * html of kinds that browsers cannot understand. The problem with html files is that browsers can interpret. Support only those fonts that have
     * been around since the birth of microsoft. Fonts like Arial Black, Impact can be used to boldface text and Monotype Corsiva for handwriting Envelopes
     * or even as a substitute for Italics. If the user specifies a font which is not supported default to "Times New Roman". What will you do with so
     * many fonts anyways for MIS Reports. Twelve fonts Bara bajgaya !!
     */

    protected static final String [] Supportedfonts = {"Times New Roman", "Bookman Old Style", "Courier New", "Centaur", "Century", "Arial",
                                              "Arial Black", "Arial Narrow", "Georgia", "Monotype Corsiva", "Verdana", "Impact" };

    /* Add more stationary that you like at your installation from  -92, -93, -94, -95, -96, -97, -98, -99  Six more Jap envelopes or anything else !! */
    /* I have not added code for all stationary you do it if you want .... i have added code for only some stationary which non-envelopes */

    protected static String [][] SupportedStationary = {
        /* if POTRAIT Cols = (Width/A4Width * POTRAITCOLS) Rows = (Tall/A4Tall * POTRAITROWS)
         * if LANDSCAPE Cols = (Tall/A4Tall * LANDSCAPECOLS) Rows = (Width/A4Width * LANDSCAPEROWS)
         * Based on Times New Roman 10 point. Dont worry about the font thickness I have plugged in an appropriate default number for POTRAITROWS and
         * LANDSCAPEROWS afer taking into account all kinds of font thickness such as Arial Narrow and Bookman Old Style. Only make a slight change for
         * fontsize. So if fontsize is 20 then that formula result above multiplied by fontsize(20)/10. So if fontsize is 8 then 8/10.
         */
        /* SID */       /*Width*//*Tall*/ /*Row,Col,Row,Col for Potrait and Landscape. Potrait paper width will be Width in Landscape Width=Tall, Tall=Width */
        {"-73","Envelope#9","3.88","8.87", "0", "0", "0", "0" },    
        {"-74","Statement","5.5","8.5", "0", "0", "0", "0" },
        {"-75","Envelope#14","5.00","11.5", "0", "0", "0", "0" },  /* fill these zero's later in GenericReportWriter */
        {"-76","A5","5.83","8.27", "0", "0", "0", "0" },   /* formula to use given above */
        {"-77","B5(JIS)","7.17","10.12", "0", "0", "0", "0" },  /* formula will be used in GenericReportWriter after discovery of fontsize */
        {"-78","Executive","7.25","10.5", "0", "0", "0", "0" },
        {"-79","A4","8.27","11.69", "0", "0", "0", "0" }, // this must remain here at index 6
        {"-80","Quarto","8.46","10.83", "0", "0", "0", "0" },
        {"-81","Letter","8.5","11", "0", "0", "0", "0" },
        {"-82","Folio","8.5","13", "0", "0", "0", "0" },
        {"-83","Legal","8.5","14", "0", "0", "0", "0" },
        {"-84","Envelope Invite","8.66","8.66", "0", "0", "0", "0" },
        {"-85","A4 Extra","9.27","12.69", "0", "0", "0", "0" },
        {"-86","B4(JIS)","10.12","14.33", "0", "0", "0", "0" },
        {"-87","Tabloid","11","17", "0", "0", "0", "0" },
        {"-88","A3","11.69","16.54", "0", "0", "0", "0" },
        {"-89","US Std Fanfold","14.87","11", "0", "0", "0", "0" },
        {"-90","Ledger","17","11", "0", "0", "0", "0" },
        {"-91","C size sheet","17","22", "0", "0", "0", "0" }
    };

    protected static byte VIDEOADVERT = 1;
    protected static byte IMAGEADVERT = 2;
    protected static byte ANIMATIONADVERT = 3;
    protected static byte AUDIOADVERT = 4;
    protected static byte MAXADVERTS = 10;
    protected static boolean VIDEOPLAYERERROR = false;

    /* A4 131Tall 11.69  WIDTH=33 8.27 Based on this characters per inch for A4 Times New Roman 10 point calculate values */

    public static final short CHARSPERINCH = 12; /* dont calculate this based on paper sizes you will go terribly wrong see the actual print for a font size */
    protected static final short POTRAITROWS = 128; /* Calculate based on page size user specified for his ReportWriter calls and re-init */
    protected static final short POTRAITCOLS = 30;   /* calculations kip them for ready use */
    protected static final short LANDSCAPEROWS = 30; /* these numbers are for the default A4 paper size */
    protected static short LANDSCAPECOLS = 128; /* calcualted based on Times  New Roman 10 point font on A4 paper so if font size increases to 12 point add 1/5th */
    protected static final short DEFAULTTOPMARGIN = 30 ; /* 30 characters any pagesize top && bottom I have allowed a little margin for user resizing margins but they might
                                                 * as well use the next paper size beyond a certain amount of margin resizing.
                                                 * IF YOU CHANGE THIS MAKE IT AN EVEN NUMBER NOT ODD
                                                 */
    // EVEN NUMBERS ONLY NOT ODD
    protected static final short DEFAULTSIDEMARGIN = 18 ; /* 18 characters any pagesize side left and right */
    // EVEN NUMBERS ONLY NOT ODD since nroff/troff takes only even sized fonts
    protected static byte MINFONTSIZE = 10; /* 10 point is sometimes used in AirLine Tickets kind of applications */
    protected static byte MAXFONTSIZE = 72; /* Maybe used on C size sheets */


    /* rows and columns for each of the papersizes for easy reference */
    protected static int FANFOLDROWS []; /* re-init later in code i am not you do it */
    protected static int FANFOLDCOLS []; /* re-init later in code i am not you do it */
    protected static int LETTERROWS []; /* re-init later in code */
    protected static int LETTERCOLS []; /* re-init later in code */
    protected static int FOLIOROWS []; /* re-init later in code */
    protected static int FOLIOCOLS []; /* re-init later in code */
    protected static int LEGALROWS []; /* re-init later in code */
    protected static int LEGALCOLS []; /* re-init later in code */
    protected static int TABLOIDROWS []; /* re-init later in code */
    protected static int TABLOIDCOLS []; /* re-init later in code */
    protected static int A3ROWS []; /* re-init later in code */
    protected static int A3COLS []; /* re-init later in code */
    protected static int INVITEROWS []; /* re-init later in code */
    protected static int INVITECOLS []; /* re-init later in code */

    /* Flags to be passed to the ReportWriter */
    /* keep these values negative as is because report writer is not all that intelligent while sensing */
    protected static final int PAGETOTALS = -11;
    protected static final int NOPAGETOTALS = -10;
    protected static final int DIRECTOPRINTER = -9;
    protected static final int PREPRINTED = -8;
    protected static final int POTRAIT = -7;
    protected static final int LANDSCAPE = -6;
    protected static final int BOLD = -5;
    protected static final int ITALIC = -4;
    protected static final int UNDERLINE = -3;
    protected static final int STRIKETHROUGH = -2;

    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] RunAwayBrideReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] OctopussyReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] LivingDaylightsReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] FrenchKissReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] YouOnlyLiveTwiceReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] HerMajestiesServiceReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] CityOfAngelsReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] TopGunReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] iQReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] DiamondsAreForeverReport;
    /* from shopping cart table */
    /* NOTE This one is different contains string */
    protected static String  QuantumOfSolaceReport;  
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] CourageUnderFireReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] YouGotMailReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] NeverSayNeverAgainReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] WhenHarryMetSallyReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] TheDoorsReport;
    /* All rowid in CustomerRegister Table for this report */
    protected static Long [] SleeplessInSeattleReport;
    /* from shopping cart table */
    protected static Long [] MoneyMoneyMoneyReport;
    /* from shopping cart table */
    protected static Long [] DrNoReport;
    /* from shopping cart table */
    protected static Long [] CustomShoppingCartReport;
    /* from Customer Register table */
    protected static Long [] CustomCustomerRegisterReport;
    /* For MAAIL MERGE KIND OF USES just Rowid's from CustomerRegister */
    protected static Long [] EnvelopeReport;
    /* from Customer Register table containing email id's and rowids */
    protected static Long [] BulkMailReport;
    protected static Long [] CustomBulkMailReport;
    protected static Long [] MicrophoneReport ; /* wait for next release */
    protected static Long [] BlueToothReport ;  /* wait for next release */
    protected static Long [] EyeBallRecognitionReport ; /* wait for next release */

    protected static Plotter [] PlotterReport;
    protected static Plotter [] CustomPlotterReport;
    protected static Graph [] GraphReport;
    protected static Graph [] CustomGraphReport;
    protected static Pie [] ApplePieReport;
    protected static Pie [] CustomApplePieReport;

    /* Response Times generated daily wondering if it will contain data */
    /* Yes right now the data will be nill. But I will instantiate this enum
     * in one of the report threads and so it will fill the data up.
     */
    protected static Long ReadResponseTimes [];
    protected static Long WriteResponseTimes [];
    protected static Long ReadObjResponseTimes [];
    protected static Long WriteObjResponseTimes [];
    protected static Long FastCommitResponseTimes [];
    protected static Long OtherResponseTimes [];
    protected static Long ReadLineResponseTimes [];
    protected static Long WriteLineResponseTimes [];
    protected static Long ReportWriterResponseTimes [];


    /* Try and Make this as Generic as Possible so that Dummy Programmers can
     * construct their charts with just a few instantiations. Will attempt
     * to make this photographer friendly with just a few keystrokes of
     * programming that they can cut and paste. This is the very essence
     * of Object Oriented Programming. Just a few instantions of a few
     * Classes should SelfContruct everything for the programmer. Maybe
     * we should use a programming language called JAVA instead of a long
     * COBOL program like this which looks like a OAK Coffin to me.
     */

    /* by the time i finish with this I hope it will be as easy as eating papdi chat */
    /* Hey idiots use only Plotter, GRaph, Pie as <E> */
    /* ME THINKS THIS SHOULD WORK SILENT PRAYER */
    class Chart<E> implements Serializable {
          E ThisChart;
          Integer ChartWindowHeight;  /* optional we will resize a JFrame */
          Integer ChartWindowWidth;

          public Chart (E p_WhichChart, Integer p_WinHt, Integer p_WinWidth){
              ThisChart = p_WhichChart;
              if (ThisChart instanceof Plotter || ThisChart instanceof Graph || ThisChart instanceof Pie )
                        ThisChart = p_WhichChart;
              else ThisChart = null;

              ChartWindowHeight = p_WinHt;
              ChartWindowWidth = p_WinWidth;
          }
          public Chart ChartAssembler (){
              /* Assemble the Chart Here */
              return this;
          }

    }


    class Plotter implements Serializable {
        Notches [] XCoordinate; /* notches on X Coordinate */
        Notches [] YCoordinate; /* notches on Y Coordinate */
        Line [] ManyLines;

        public Plotter (Notches [] p_X, Notches [] p_Y, Line [] p_ManyLines){
            XCoordinate = p_X;
            YCoordinate = p_Y;
            ManyLines = p_ManyLines;
        }

        public Plotter LineAssembler (){
            /* assemble all the lines here */
            return this;
        }
    }

    class Line<E> implements Serializable {
        E[] LineData;
        Integer[] FromTo; /* Row, Col, Row,Col FromTo.length <= 4 && >= 2 but not 3 */
        Integer InkColor;
        Integer Thickness;  /* Line Thickness restrict to some reasonable size */
        Method FunctionPointer;
        Object ThisLine;

        public Line(E[] p_LineData, Integer p_InkColor, Integer p_Thickness ){
            LineData = p_LineData;
            InkColor = p_InkColor;
            Thickness = p_Thickness;
        }

        public <F> Line DrawLine ( F p_Functionptr ){
            try{          /* Outsource to United States of America ME Hee Haw */
            FunctionPointer = p_Functionptr.getClass().getMethod("DrawOneLine");
             /* Beg Borrow Steal this method "BakeOnceSlice" from some JAVA AWT Guru or use C Curses Library/Visual Basic */
            ThisLine = FunctionPointer.invoke(this, this.LineData, this.InkColor, this.FromTo, this.Thickness);
            }catch (NoSuchMethodException ex_YESKIA30){
                return null;
            }catch (IllegalAccessException ex_YESKIA31){
                return null;
            }catch (InvocationTargetException ex_YESKIA29){
                return null;
            }
            return this; /* some usable object to setvisible etc etc */
                        /* Jaisa maina socha tha Twinkle Twinkle little stars */
        }
    }

    class Notches implements Serializable {
        Integer NotchesPerUnit;  /* any number may be 10 notches per Inch or Cm or just two NotchesPerUnit */
        String Unit;  /* Inches, Cms */
        public Notches (Integer p_UnitNotches, String p_Unit ){
            NotchesPerUnit = p_UnitNotches < 0 ? 0: p_UnitNotches > 10 ? 10: p_UnitNotches;
            if (p_Unit.equalsIgnoreCase("Inch") || p_Unit.equalsIgnoreCase("Cm"))
                Unit = p_Unit;
            else Unit = "Inch";
        }
    }

    class Graph implements Serializable {
        Notches [] XCoordinate; /* notches on X Coordinate */
        Notches [] YCoordinate; /* notches on Y Coordinate */
        Tower [] TowerResidents;

        /* wondering why the parameter I got a double headed approach here */
        public Graph (Notches [] p_X, Notches [] p_Y, Tower [] p_Twr){
            XCoordinate = p_X;
            YCoordinate = p_Y;
            TowerResidents = p_Twr;
        }
        public Graph TowerAssembler (){
            return this;
        }
    }


    class Tower<E> implements Serializable {
        E [] EachData; /* Data for each Tower can be an array */
        Integer Paint ; /* Choose from PieColors */
        Object ThisTower;
        Integer TowerSize;  /* Data Size */
        Integer Height;  /* height and width we will figure it out */
        Integer Width;
        Method FunctionPointer;

        /* wondering why the parameter I got a double headed approach here */
        public Tower (E[] p_This, Integer p_Shade){
            EachData = p_This;
            Paint = p_Shade;
        }

        public <F> Tower TowerConstruct ( F p_Functionptr ){
            try{
            FunctionPointer = p_Functionptr.getClass().getMethod("BuildOneTower");
             /* Beg Borrow Steal this method "BakeOnceSlice" from some JAVA AWT Guru or use C Curses Library/Visual Basic */
            ThisTower = FunctionPointer.invoke(this, this.EachData, this.Paint, this.Height,
                                                this.Width);
            }catch (NoSuchMethodException ex_YESKIA30){
                return null;
            }catch (IllegalAccessException ex_YESKIA31){
                return null;
            }catch (InvocationTargetException ex_YESKIA29){
                return null;
            }
            return this; /* some usable object to setvisible etc etc */
                        /* Jaisa maina socha tha Twinkle Twinkle little stars */
        }
    }

    class Pie implements Serializable {
        PieSlices [] SeveralSlices;
        /* wondering why the parameter I got a double headed approach here */
        public Pie (PieSlices [] p_Slices ){
            SeveralSlices = p_Slices;
        }
        public Pie PieAssembler (){
        /* I will Assemble the Pie Here */
               return this;
        }
    }

    /* Theoritically 360 slices of this pie  !!!
     * thats a lot to handle for the human brain (aka foot and mouth)
     */
    class PieSlices<E> implements Serializable {
        E [] EachData ; /* data for each Slice can be an Array of whatever */
        Integer ThisColor ; /* get the ordinal value idiot */
        Double Degrees; /* how many degrees dont exceed 360.00 in all keep count */
        Integer SliceSize;
        Method FunctionPointer;
        Object BakedSlice;
        Integer Radius;
        Integer [] Arc;  /* Row,Col,Row,Col,Row,Col Arc.length() always in multiples of two Use '*' to draw
                          * Actually I should work this out here i you get it wrong !!! you fill up.
                          */
        Integer CenterPoint;
        public PieSlices (E [] p_EachData, Integer p_Color, Double p_degree, Integer p_Radius, Integer [] p_Arc, Integer p_CenterPoint){
            EachData = p_EachData;
            ThisColor = p_Color;
            /* not important you can pass any value to constructor and then reset it later */
            Degrees = p_degree < 1.0 ? 1.0 : p_degree > 60.0 ? 60.0 : p_degree ;  /* Just Bake me six Slices */
            SliceSize = EachData.length; /* some default you get it right */
            FunctionPointer = null;
            Radius = p_Radius;
            Arc = p_Arc;
        }
        public <F> PieSlices SelfConstruct ( F p_Functionptr ){
            try{
            FunctionPointer = p_Functionptr.getClass().getMethod("BakeOneSlice");
             /* Beg Borrow Steal this method "BakeOnceSlice" from some JAVA AWT Guru or use C Curses Library/Visual Basic */
            BakedSlice = FunctionPointer.invoke(this, this.EachData, this.ThisColor, this.Degrees,
                                                this.SliceSize, this.Radius, this.CenterPoint, this.Arc );
            }catch (NoSuchMethodException ex_YESKIA30){
                return null;
            }catch (IllegalAccessException ex_YESKIA31){
                return null;
            }catch (InvocationTargetException ex_YESKIA29){
                return null;
            }
            return this; /* some usable object to setvisible etc etc */
                         /* Jaisa maina socha tha Twinkle Twinkle little stars */
        }
    }

    /* Shut up and make use of these no practical
     * Apple Pie exceeds so many Colors !!! (SURD)
     * What are you printing Election Data ?? NERD
     */
    protected static enum PieColors {
        RED,
        BLUE,
        GREEN,
        YELLOW,
        WHITE,
        BLACK,
        BROWN,
        ORANGE,
        MAGENTA,
        PINK,
        VIOLET,
        GOLD,
        SILVER,
        CREAM /* dont you want some ?? */
    }

    /* Instantiate this enum PieColors with Hex values for different Shades you can add more */

    /* For each of these reports above there should be a default row header.
     * If the programmer calls ReportWriter without any parameters this is
     * the default row header it assumes and starts printing. There will also
     * be a generic row header if the programmer has called the ReportWriter
     * with his own data and without a rowheader which wont happen normally.
     * REMEMBER I AM USING AN A4 PAGE BY DEFAULT SO DONT EXCEED SEVEN COLUMNS
     */

    protected static String [][] DefaultRowHeaders =
    {
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "18"},
        {"CUSTOMER ID  CUSTOMER NAME   CUSTOMER  EMAIL   CUSTOMER PHONE   CUSTOMER CITY   CUSTOMER NATION    REGISTER DATE", "19"},
        {"CUSTOMER NAME       TYPE  MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "20"},
        {"CUSTOMER NAME       MARRIED  SEX  TYPE  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "21"},
        {"CUSTOMER NAME       SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION     ZIP CODE ", "22"},
        {"CUSTOMER NAME       SEX  CUSTOMER EMAIL    CUSTOMER PHONE   CUSTOMER ADDRESS  CUSTOMER NATION  ZIP CODE", "23"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "24"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "25"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "26"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "27"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "28"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "29"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "30"},
        {"CUSTOMER NAME       SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION   LOGIN TIME", "31"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "32"},
        {"CUSTOMER NAME       MARRIED  SEX  CUSTOMER EMAIL    CUSTOMER PHONE     CUSTOMER CITY    CUSTOMER NATION", "33"},
        {"CUSTOMER NAME       CUSTOMER EMAIL   CUSTOMER PHONE  CUSTOMER CITY  CUSTOMER NATION   PIC CODE  BILLED  QTY   TOTAL", "34"},
        {"CID           NAME&ADDRESS     PIC CODE  OPTION DESC     SUB-OPTION        QTY  PRICE   DISCOUNT   AMOUNT", "35"},
        {"CUSTOMER NAME       CUSTOMER EMAIL   CUSTOMER PHONE  CUSTOMER CITY  CUSTOMER NATION  RMA      QTY   REFUND", "36"},
        {"CID           PIC   PONUMBER      OPTION   SUBOPTION   PAYMENT   QTY   TOTAL    BILLED   SHOPDATE   DISCOUNT", "37"},
        {"CID       NAME          BIRTHDATE     SEX   MARITAL   ADDRESS1   ADDRESS2    CITY   NATION     ZIP        EMAIL", "38"},
        {"TRAIN NAME              TRACK NAME            REQUEST TYPE   RUNNING TIME", "51"}
    };

    /*
     * Lock wait period beyond which there is some lock release problem in this program. I have set this
     * to 5000 ms which is reasonable. It may be as simple as forgetting to unlock with "U" after a lock
     * with "L" in FileTableDataFileMap.
     */

    protected static short LOCKWAITPERIOD = 5000;

    protected static long LOCKWAITTIME = 0;  /* this will be set frequently within setTable_lock() in class FileTableDataFileMap */

    protected static String LASTLOCKMETHOD = "main";
    

    /* Get the default locale based on this we can get all the other
     * information we need later in the program.
     */
    public static final Locale DefaultLocale = Locale.getDefault (); // Installed Locale

    /* Use a field seperator of your liking like |,:,!
     * Choose the field seperator carefully if your data strings
     * contain them.
     */
    public static String fieldseperator = "|"; // this is the best stick with this

    static
    {
        if (fieldseperator.equals("!") == false && fieldseperator.equals("|") == false
            && fieldseperator.equals(":") == false )
            LiveDB.fieldseperator = "|";
    }
    
    protected static short usersloggedin = 0;  /* this global will be re-init later */

    protected static int reportsforthispid = 17; /* this global will be re-init later */

    /* Maximum database dimensions Change here if dil mangey more */
    protected static final short maxtables = 51; /* read as 51 */

    static long magicnumber = 2147483647; // change for 64 bit machines and recompile

    static final int rowlimit = 2147483647; // the maximum number that you can stuff into a unsigned integer
                                            // on 32 bit 2's complement machines
    /* I will write a purge routine later to archive and reduce database weight hulka phulka */
    static final int maxrows = rowlimit - 3647; // 3647 is like one weeks entries on extremely heavy usage
                                                // Therefore my application will not collapse for 12,267 years
                                               // which bugar gives you such product guarantees.
    static final int MAXROWSETS = 2; // based on rowlimit also read commentary in licencetoKill() in Spy.java
   
    // Use this for Spy thread only dont mixup report writer is not thread safe at all
    protected GenericReportWriter Generic = new GenericReportWriter ();
    
    // use this for Royalty Tracker thread only dont mixup for heaven sake that report writer
    // is just not thread safe it will screw up all method pointers
    protected GenericReportWriter CrownPrincessCatherine = new GenericReportWriter();

    // Use this Instance for thread Billion Hearts only dont mixup
    // The report writer is not thread safe
    protected GenericReportWriter Isabella = new GenericReportWriter ();

    // Use this instance of the ReportWriter from any other non-reporting threads if YOU WANT TO USE IT
    // dont screw up with the Instances that I have already used for Gods Sake.
    protected GenericReportWriter Sonam = new GenericReportWriter ();
    // OR USE THIS ONE
    protected static GenericReportWriter Kangana = new GenericReportWriter ();
    
    protected static GenericReportWriter StationMaster = new GenericReportWriter ();

    /* The Log File Error Line Number. This is just a Line Number for Easy Reading. This is not the actual
     * database error number Actually this should be replaced by the source code line number which is
     * available as a method somewhere but I can locate the damn thing. I have seen it.
     */
    protected static long logerrorno = 0L;

    /* instead of using system.exit () set this flag
     */
    protected static short system_exit = 0;
    protected static boolean FASTCOMMITEXIT = false;

    // current lid used in generic report writer. lid is language id
    protected static int currentlid = 0;

    /* If this flag is 1 sortandindex tables that have refreshed or have been updated in memory database
     * LiveShareDB
     */
    protected static short sortandindex = 0;

    /* condition for a Refresh Database */
    protected static Condition RefreshCondition; // just for teach track superfluous
    protected static Condition SmoothExitCondition; // just for teach track superfluous

    /* Store the command line arg[0] in this global */
    protected static String command_line = null;
    protected static String command_line_params = null;

    /* Four states or values
     * databaseloading = 0  Error in loading database from DataEntryFile
     *                      OR Error in loading database from serialized files
     * databaseloading = 1  database loaded from Data Entry File
     * databaseloading = 2  database must load all tables from serialized files
     * databaseloading = 3  database must load only updated tables from serialized files
     *                     
     */
    protected static short databaseloading = 2;  /* dont change this default */

    /* reindex all tables after a database refresh or just those tables that have changed */
    protected static short reindexall = 1;

    /* fast commits will start only when this flag is 1 */
    protected static short startfastcommit = 0;

    // these valid log file extensions are meant to confuse Mr Harry Hacker. He wont know which log file to
    // delete or corrupt even the sys admin will have to check system dates/time on all log files to spot the
    // correct log file totally 33 extensions to choose from ADD MORE bindaas more the merrier
    public static final String LogExtensions [] = {".txt", ".logs", ".log", ".err", ".error", ".bug", ".bugs",
    ".errlog", ".errorlog", ".mistakes", ".dberr", ".dbfail", ".fail", ".erep", ".errrep", ".blunders", ".bugger",
    ".flaws", ".flaw", ".lfile", ".lfiles", ".logrep", ".logreps", ".lg", ".lgs", ".run", ".runs", ".exit",
    ".buggers", ".screwups", ".coredump", ".sys", ".system", ".fault", ".faults", ".galti", ".illegit", ".crash",
    };
    
    
    // This is used by ManualTransmission () and update_tracker () in RefreshDB
    // update_tracker() will set it to a valid Date('Now') at the very start and then
    // un-set it at the very end.
    protected static Date FRESHOLOGY = null;

    /* Todays Login Date and Time */
    public static final Date today = new Date ();

    /* Todays midnight I will reset this in main to correct value */
    protected static Date midnight = today;

    /* The randomly generated pid of this process */
    public static final long pid = new Random ().nextLong();
    protected static long ADMINSESSIONON = -1;

    protected static PrintStream errfile = null;
    
    /* Error log file name it will create in directory defined by LiveDB.serializedfilespath */
    public static String lgfl = LiveDB.serializedfilespath
    + "LensViewLog" + String.valueOf(LiveDB.today.getTime()).trim() + "PID"
    + String.valueOf(LiveDB.pid).trim()
    + "_" + DefaultLocale.getDisplayName().toUpperCase().trim() + "_"
    + LogExtensions [(new Random ()).nextInt(LogExtensions.length)].toUpperCase().trim();

    public static String ErrorLogFile = LiveDB.lgfl.substring(0, LiveDB.lgfl.indexOf(" ") == -1 ?LiveDB.lgfl.length():LiveDB.lgfl.indexOf(" "));

    protected static final byte MAXTHREADS = 10; // zero thru ten

    protected static boolean STATIONMASTERSREPORT = true;  /* if this flag is false it wont print the report as under */

    protected static Condition [] IPCSCondition;

    // if you feel that the application is slow this could be a reason so increase this semaphore count
    // in mulitiples of two dont go beyond eight at best. Which mean 4 thru eight error messages in and
    // around the same time which is a lot.
    protected static Semaphore GrassHopperLock = new Semaphore(2,true); // For GrassHopper ()
    protected static Semaphore IPCSLOCK = new Semaphore(1,true); // acquire this permit externally to know if some other thread is using
                                                                // InterProcessSynchronization trigger which itself will tell you that
                                                               // some write is happening.
    protected static Integer SYNCOBJID = -1; // this indicates the table number that is being written to disk by fastcommit or committables
                                            // by whichever process dont care which one so we must wait until it completes and then reset
                                           //  this flag to -1.

/*
 * WIRING DIAGRAM :
 * @LOOKSY: PlatformClearance.java
 * @LOOKSY:LiveDB.IPCSTrigger(), LiveDB.IPCSLOCK, LiveDB.IPCSCondition
 * Advanced Type Enum Name : InterProcessSynchronization
 * Constructor Name :  private InterProcessSynchronization (long p_dummy)
 * Constructor Parameters : long p_dummy = SYNCOBJID
 * Method Names : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This trigger is meant for Inter Process Synchronization for write related actions
 * on database tables only (refer to LiveDB.Action).This enum type Trigger (as i will refer to it will
 * create a file on disk called "ipcssync_" + Integer.toString(SYNCOBJID)+ ".syc" at serializedfilespath.
 * This SYNCOBJID is nothing but the table number that you passed using a call to method LiveDB.IPCSTrigger()
 * This SYNCOBJID can also be a negative. Based on this value the Trigger can perform two kinds of actions.
 * If negative it can delete the old ipcsfile[s] which for whatever reasons could not be deleted from disk.
 * If these old files remain on disk the application will HANG sooner or later. If possitive it creates a
 * new file on disk appending that SYNCOBJID (table number) to it. The whole idea is that any other process
 * including any other thread must know that there is a database table related write Action already happening
 * on the table and so it must wait until it completes. Also it must wait even if there is a readinprogress on
 * that table already happening. Then common sense states that thou shall not write. So if you take a quick
 * look at the code it continues to topreviousrequest. Okay so constructor gets a call by value of SYNCOBJID
 * and does file creations and deletions and toggles IPCSCondition with SignalAll etc etc etc .....
 *
 * TECHNICAL NOTE BEFORE I FORGET IT :-
 * The beauty of these advanced enum types is that you can pass them as parameters to a method to provide values
 * to the method and at the very same time it can also trigger some event for you. It will be very complicated
 * way to get it to function but will work as 007 !!! So instead of LiveDB.SYNCOBJID I can call a method which
 * returns some value which is what the method you are calling needs and at the same time this advanced enum can
 * trigger something else for you. Jolly good rascal. So what this means is you can call a method with several
 * parameters of any valid type which is just a dummy function that does nothing but just that method call can
 * trigger a thousand different actions on your applications or database. I will try it here if time permits.
 * Try it with varargs it will curdle your brains beyond recovery you will need insurance !!
 *
 *
 * Start Date : 18th October 2010
 * End Date : 17th May 2011
 *
 * Last Modification Date : June 7th 2012
 * Last Modifications : I have cleaned up this advanced enum thoroughly. It had a lot of messy code
 * with some bugs. Basically it was toggling file perms from read to write on the syc directory which
 * I have discontinued with since it will play havoc in a multi user mode. I have simplified the logic
 * and cleaned it up a bit here and there.
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    static ArrayDeque<Integer> prevObjid = new ArrayDeque<Integer> ();

    protected static enum InterProcessSynchronization {
        WRITEHAPPENING   (SYNCOBJID); // perfectly okay to ignore this warning in this context.

        private InterProcessSynchronization (int p_dummy){

            // enum InterProcessSynchronization is static but these are not
            String sycfile = null;
            File ipcsfile = null;
            File newname = null;
            int t, j = 0;


            if (p_dummy < 0 && prevObjid.isEmpty() == false)
            {
                sycfile = "syc" + LiveDB.FILESEPERATOR + "ipcssync_"
                                                        + Integer.toString(prevObjid.peekLast())+ ".syc";
                ipcsfile = new File (serializedfilespath + sycfile);
                if (ipcsfile.exists())
                {
                    // There may be some backlogs of files to delete clear those
                    // actually this should not happen at best prevObjid.size() == 2
                    if (prevObjid.size() > 1)
                    {
                        t = prevObjid.size() -2;
                        j = LiveDB.LiveSharedDB[pc].length -2;

                        while (t >= 0 && j >= 0)
                        {
                                  /* Has that Action completed ? */
                                  topreviousrequest:
                                  while ((((TrainRunningInformation)((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getTrainid()).
                                  getArrivaltime() == null && ((TrainRunningInformation) ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).
                                  getTrainid()).getAccident() == null))
                                  {
                                          // both getArrivaltime() and getAccident() are null so continue to
                                          // previous request.
                                          continue topreviousrequest;
                                  }
                                  if ((((TrainRunningInformation)((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getTrainid()).getTrain()
                                          == (Integer)prevObjid.toArray()[t]
                                     && ( ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type()== LiveDB.Action.FASTCOMMIT.ordinal()
                                     || ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.WRITEOBJECT.ordinal()
                                     || ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type()== LiveDB.Action.WRITELINE.ordinal() )))
                                  {
                                        sycfile = "syc" + LiveDB.FILESEPERATOR + "ipcssync_"
                                            + Integer.toString((Integer)prevObjid.toArray()[t])+ ".syc" ;
                                        ipcsfile = new File (serializedfilespath + sycfile);
                                        j--;
                                        try{
                                            LiveDB.IPCSSYNCLOCKS[(Integer)prevObjid.toArray()[t]].release();
                                            LiveDB.IPCSSYNC[(Integer)prevObjid.toArray()[t]].close();
                                        }catch (IOException ex_NOKIA86){
                                            System.err.println(LiveDB.grassHopper(ex_NOKIA86,"Error closing/releasing lock on ipcssync_"
                                                + prevObjid.toArray()[t]));
                                            system_exit = 1;
                                            SmoothExitCondition.signalAll();
                                        }

                                        if (new File(LiveDB.serializedfilespath + "syc").canWrite() == false)
                                        {
                                            if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                                            {
                                                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                                    + LiveDB.serializedfilespath + "syc"));
                                                LiveDB.system_exit = 1;
                                                LiveDB.SmoothExitCondition.signalAll();
                                            }
                                        }

                                        try{
                                            ipcsfile.delete();
                                        }catch(SecurityException ex_YESKIA37){
                                            try{
                                            newname = new File (serializedfilespath + sycfile + Integer.toString((new Random ()).nextInt()));
                                            ipcsfile.renameTo(newname);
                                            }catch(SecurityException ex_NOKIA29){
                                                System.err.println(LiveDB.grassHopper(ex_NOKIA29,"Rename of IPS File:"
                                                      + LiveDB.serializedfilespath + sycfile + "Failed"));
                                                 system_exit = 1;  // flag error and smooth exit rotten operating system underneath
                                             SmoothExitCondition.signalAll();
                                            } /* catch */
                                        } /* catch */
                                  }

                               prevObjid.remove((Integer)prevObjid.toArray()[t]);
                               t--;
                        } // while (t >= 0 && j >= 0)
                    } /* if (prevobjid.length > 1) */
                    else // just one entry in prevObjid
                    {
                        try{
                           // before a delete let us release the locks and close
                           try{
                           LiveDB.IPCSSYNCLOCKS[prevObjid.peekLast()].release();
                           }catch (ClosedChannelException ex_NOKIA15){
                               System.err.println(LiveDB.grassHopper(ex_NOKIA15));
                               system_exit = 1;
                               SmoothExitCondition.signalAll();
                           }catch (IOException ex_NOKIA51){
                               System.err.println(LiveDB.grassHopper(ex_NOKIA51));
                               system_exit = 1;
                               SmoothExitCondition.signalAll();
                           }
                           try{
                           LiveDB.IPCSSYNC[prevObjid.peekLast()].close();
                           }catch (IOException ex_YESKIA83){
                               LiveDB.ALRTLVL = 3;
                               System.err.println(LiveDB.grassHopper(ex_YESKIA83));
                           }

                           if (new File(LiveDB.serializedfilespath + "syc").canWrite() == false)
                           {
                                if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                                {
                                    System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                                    LiveDB.system_exit = 1;
                                    LiveDB.SmoothExitCondition.signalAll();
                                }
                           }
                           ipcsfile.delete();

                        }catch(SecurityException ex_YESKIA37){
                            System.err.println(LiveDB.grassHopper(ex_YESKIA37,"Delete of IPS File:"
                                        + LiveDB.serializedfilespath + sycfile + "Failed"));
                            try{
                            newname = new File (serializedfilespath + sycfile + Integer.toString((new Random ()).nextInt()));
                            ipcsfile.renameTo(newname);
                            }catch(SecurityException ex_NOKIA29){
                                System.err.println(LiveDB.grassHopper(ex_NOKIA29,"Rename of IPS File:"
                                        + LiveDB.serializedfilespath + sycfile + "Failed"));
                                system_exit = 1;
                                SmoothExitCondition.signalAll();
                            } /* catch */
                        }
                    }
                } /* if (ipcsfile.exists()) */
                return; // otherwise return the file has already been deleted
            }
            else if (p_dummy >= 0)
            {
                prevObjid.addLast(new Integer(p_dummy));
                sycfile =  "syc" + LiveDB.FILESEPERATOR + "ipcssync_" + Integer.toString(p_dummy)+ ".syc";
                ipcsfile = new File (serializedfilespath + sycfile);
            }

            // this ipcs file that we are looking for checks if a write is already in progress on
            // that table check if ipcsfile already exists. It will exist until signalled for delete
            // by some other process or thread using LiveDB.IPCSTrigger(-1)
            while (ipcsfile.exists())
                IPCSCondition[ThreadController.getcurrenthread()].awaitUninterruptibly();

            // so it dont exist now signalall
            // those threads in waitset for this condition may proceed provided they get permit
            IPCSCondition[ThreadController.getcurrenthread()].signalAll();


            // so it dont exist now you create your file So this is a signal that no other process
            // is telling you to wait
            do{

                // GO INTO A LOOP HERE
                // Check for a readinprogress file on disk then thou shall not write
                   tokeeplooping:
                   while (new File ((LiveDB.serializedfilespath + "syc" +
                               LiveDB.FILESEPERATOR + "readinprogress"
                                                          +  p_dummy).trim()).exists())
                                continue tokeeplooping;
                   try{
                        if (new File(LiveDB.serializedfilespath + "syc").canWrite() == false)
                        {
                            if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                            {
                                System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                                LiveDB.system_exit = 1;
                                LiveDB.SmoothExitCondition.signalAll();
                            }
                        }

                        if (ipcsfile.createNewFile()== false)
                        {   // some other JVM instance of this application or thread has got past us
                            // okay a file already exists on disk but could this be a prank file that
                            // we could re-use
                             if (Prankster(ipcsfile, p_dummy, true))
                             {
                                // so we do have a file there which is a prankster file so lets re-use
                                LiveDB.IPCSSYNC[p_dummy]
                                         = new FileOutputStream (ipcsfile);
                                LiveDB.IPCSSYNCLOCKS[p_dummy]
                                         = LiveDB.IPCSSYNC[p_dummy].getChannel().tryLock();
                                // now lets thanks the prankter in a thanksgiving prayer
                                System.err.println(LiveDB.grassHopper("Prankster Prank File has been re-used"));
                                break;
                             }

                            IPCSCondition[ThreadController.getcurrenthread()].awaitUninterruptibly();
                            continue; // it will check for tokeeplooping and then try a create again
                        }
                        else
                        {
                            ipcsfile.setReadable(true, false); // dont bother to check even if it fails
                            ipcsfile.deleteOnExit(); // just in case we goof up someplace
                            IPCSCondition[ThreadController.getcurrenthread()].signalAll();
                            break;
                        }
                    }catch (SecurityException ex_YESKIA71){
                            System.err.println(LiveDB.grassHopper(ex_YESKIA71));
                            system_exit = 1;  // flag error and smooth exit rotten operating system underneath
                            SmoothExitCondition.signalAll();

                    }catch (IOException ex_YESKIA65){
                        System.err.println(grassHopper(ex_YESKIA65, "InterProcessSynchronization " + sycfile));
                        system_exit = 1;  // flag error and smooth exit rotten operating system underneath
                        SmoothExitCondition.signalAll();
                        break;
                    }

            }while (true);
       } // private InterProcessSynchronization (int p_dummy)
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY: PlatformClearance.java
 * @LOOKSY:LiveDB.STATIONMASTERSREPORT, LiveDB.StationMaster
 * @LOOKSY:LiveDB.ReadResponseTimes, LiveDB.WriteResponseTimes, LiveDB.ReadLineResponseTimes
 * @LOOKSY:LiveDB.WriteLineResponseTimes, LiveDB.ReadObjResponseTimes, LiveDB.WriteObjResponseTimes,
 * @LOOKSY:LiveDB.FastCommitResponseTimes, LiveDB.OtherResponseTimes, LiveDB.ReportWriterResponseTimes
 *
 * Advanced Type Enum Name : Action
 * Constructor Name :  private Action (int p_Type)
 * Constructor Parameters : int p_Type
 * Method Names : public boolean readResponseTimes ()
 *                public boolean writeResponseTimes ()
 *                public boolean readLineResponseTimes ()
 *                protected boolean writeLineResponseTimes ()
 *                protected boolean readobjResponseTimes ()
 *                protected boolean writeobjResponseTimes ()
 *                protected boolean fastcommitResponseTimes ()
 *                private boolean otherResponseTimes ()
 *                private boolean reportwriterResponseTimes ()
 *                protected void readTimes (int... p_whichtypes)
 *
 * Instantiated From : RoyaltyTracker.java method run()
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This advanced type enum is used for generating/refreshing and printing response
 * times of various kinds. This Advanced type enum is the perfect example of Object oriented programming
 * whereby just instantiating this enum should do all the magic required and print you a station masters
 * report. If you set that global STATIONMASTERSREPORT = false then it will still generate the numbers
 * for you but will not print the report.
 *
 * Start Date : 18th October 2010
 * End Date : 3rd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static enum Action {  
        READFILES   (0),
        WRITEFILES  (1),
        READLINE    (2),
        WRITELINE   (3),
        READOBJECT  (4),
        WRITEOBJECT (5),
        FASTCOMMIT  (6),
        OTHERS  (7),    /* Use this for checking response times of a specific new feature you plugged in */
                        /* OR you want to monitor response times of a specific method or module */
                        /* DONT OVERDO any of these statistics collection unless you need it because gathering
                         * these statistics will itself slow down the overall response times.
                         */
        REPORTWRITER  (8);
        
        /* @Attributes */
        private static HashSet<PlatformClearance> pcs = new HashSet<PlatformClearance> ();
        private static List<PlatformClearance> pcl = new ArrayList<PlatformClearance> ();
        private static TreeSet<PlatformClearance> pct = new TreeSet<PlatformClearance> ();


        /* constructor is private */
        private Action (int p_Type){

            switch (p_Type)
            {
                case 0:
                    this.readResponseTimes ();
                    break;
                case 1:
                    this.writeResponseTimes ();
                    break;
                case 2:
                    this.readLineResponseTimes ();
                    break;
                case 3:
                    this.writeLineResponseTimes ();
                    break;
                case 4:
                    this.readobjResponseTimes ();
                    break;
                case 5:
                    this.writeobjResponseTimes ();
                    break;
                case 6:
                    this.fastcommitResponseTimes();
                    break;
                case 7:
                    this.otherResponseTimes();
                    break;
                case 8:
                    this.reportwriterResponseTimes();
                default:
                    break;
            }
        }


        /* Kip these Superfluous methods intact for now we might need them */
        public boolean readResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.READFILES.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        public boolean writeResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.WRITEFILES.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        public boolean readLineResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.READLINE.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        protected boolean writeLineResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.WRITELINE.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        protected boolean readobjResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.READOBJECT.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        protected boolean writeobjResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.WRITEOBJECT.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        protected boolean fastcommitResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.FASTCOMMIT.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        private boolean otherResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.OTHERS.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        private boolean reportwriterResponseTimes (){
            boolean ok = true;

            readTimes(LiveDB.Action.REPORTWRITER.ordinal());
            if (STATIONMASTERSREPORT == true)
                StationMaster.ReportWriter();

            return ok;
        }

        protected void readTimes (int... p_whichtypes){
         for (int i = 0; i < p_whichtypes.length; i++)
         {
            switch (p_whichtypes[i])
            {
                case 0:
                  ReadResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                    if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.READFILES.ordinal())
                       ReadResponseTimes[ReadResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 1:
                  WriteResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                     if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.WRITEFILES.ordinal())
                        WriteResponseTimes[WriteResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 2:  /* Dont use this really not needed */
                  ReadLineResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                      if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.READLINE.ordinal())
                         ReadLineResponseTimes[ReadLineResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 3: /* Dont use this really not needed */
                  WriteLineResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                      if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.WRITELINE.ordinal())
                         WriteLineResponseTimes[WriteLineResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 4:
                  ReadObjResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                      if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.READOBJECT.ordinal())
                         ReadObjResponseTimes[ReadObjResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 5:
                  WriteObjResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                      if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.WRITEOBJECT.ordinal())
                         WriteObjResponseTimes[WriteObjResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 6:
                  FastCommitResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                      if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.FASTCOMMIT.ordinal())
                         FastCommitResponseTimes[FastCommitResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 7:
                  OtherResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                      if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.OTHERS.ordinal())
                         OtherResponseTimes[OtherResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                case 8:
                  ReportWriterResponseTimes = null;
                  for (int j = 0; j < LiveDB.LiveSharedDB[pc].length; i++)
                  {
                      if (((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRequest_type() == LiveDB.Action.REPORTWRITER.ordinal())
                         ReportWriterResponseTimes[ReportWriterResponseTimes.length -1] = ((PlatformClearance)(LiveDB.LiveSharedDB[pc][j])).getRowid();
                  }
                  break;
                default:
                  break;
            }
          }
        }
     } /* public enum Action */

    // A regular enum used extensively in ThreadController.java
    // Self Explanatory
     protected static enum Priority {
         SIGNALWAIT, /* 0 */
         GOODSTRAIN, /* 1 */
         PASSENGER, /* 2 */
         LASTLOCAL, /* 3 */
         FASTLOCAL, /* 4 */
         HOLIDAYSPECIAL, /* 5 */
         INTERCITY, /* 6 */
         EXPRESS, /* 7 */
         SHATABDI, /* 8 */
         RAJDHANI, /* 9 */
         BULLETTRAIN /* 10 */
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstallDB.java -- just the top twenty lines of source
 * @LOOKSY: ThreadController.java
 * @LOOKSY:LiveDB.OPERATINGSYSTEM, LiveDB.WINDOWS, LiveDB.TIMESLICER
 *
 * Advanced Type Enum Name : PilotLessTrigger
 * Constructor Name : private PilotLessTrigger(int p_Witch)
 * Constructor Parameters : int p_Witch
 * Method Names : None
 *
 * Instantiated From : ThreadController.java -- private static void PullTrigger ()
 *
 * Technical Reference : Indrajal Comic Books Phantom the Ghost who Walks.
 *                       Watch The 6th Day
 *
 * Musical Accompanyments : BOB SEGER & THE SILVER BULLET BAND
 * 
 * @Since Version : 1.0
 *
 * Running Commentary : This advanced type enum is used for driving your database engine in a ghost mode.
 * Phantom the Ghost who Walks will take on automatically. In technical terms it tries to do its own time
 * slicing minus pre-emption on any O/S. As of now I have not tampered with Windows. I just let windows
 * be windows.
 *
 * Start Date : 18th October 2010
 * End Date : 3rd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static enum PilotLessTrigger {
        THREADCONTROLLER    (0),    /* this will use three bits only so max priority 7  */
        THREADLEASH         (1),
        THREADSRTINDX       (2),
        THREADREFRESHDB     (3),
        THREADSYSEXIT       (4),
        THREADWRITETABLES   (5),
        THREADROYAL         (6),
        THREADLOVEALL       (7),
        THREADSPY           (8),
        THREADGUI           (9),
        THREADAUTOBACKKUP   (10),
        DUMMY1              (11),  // these dummies will help invoke the constructor more number of times and every
        DUMMY2              (12),  // time the constructor is invoked the thread execution time is checked this way
        DUMMY3              (13),  // time slicing on Linux. Pre-Empting as in Windows is excluded because it is
        DUMMY4              (14),  // a nuisance
        DUMMY5              (15),
        DUMMY6              (16),
        DUMMY7              (17),
        DUMMY8              (18),
        DUMMY9              (19),
        DUMMY10             (20);

        /* Attributes */
        long flyingtime;
        int CurrentThread = ThreadController.getcurrenthread();
        int yieldtothisthread = 0;
        int t = ThreadController.getSortedAccelerator().length;

        private PilotLessTrigger(int p_Witch){
        /* This constructor will be called twentyone times for each of those values */
        /* so fool the switch */
           CurrentThread = ThreadController.getcurrenthread();

           if (OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) == -1) p_Witch = CurrentThread;
           
           if (t >= 1) t-- ; else return; // this array getSortedAccelerator uses it

           ThreadController.setSortedAccelerator ();
        
           switch(p_Witch){
                case 0:
                       if (OPERATINGSYSTEM.toUpperCase().indexOf(LiveDB.WINDOWS.toUpperCase()) != -1)
                       {
                           if ( ThreadController.OnRadar (p_Witch) == true )
                              threadcontroller.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                          {                             
                             threadcontroller.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                             /* check if it has completed the time slice as per our wish list */
                             flyingtime = ThreadController.getFlyingTimes(p_Witch);
                             if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                   ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                   ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                             {
                                   if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                   {
                                       yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);
                                         
                                       while (Thread.currentThread().getId() != yieldtothisthread )
                                       {
                                            Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                       }
                                       break;
                                   } /*  Thread.currentThread().getId()  */                                
                             } /* if */
                          } /* if */
                          
                       }                   
                    break;
                case 1:                    
                       if (OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadleash.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {                           
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadleash.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {

                                 if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                 {
                                     yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                     while (Thread.currentThread().getId() != yieldtothisthread )
                                     {
                                         Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                     }
                                     break;
                                 } /* if */                                 
                              } /* if */
                           } /* if */
                       }                   
                    break;
                case 2:
                       if (OPERATINGSYSTEM.toUpperCase().indexOf(LiveDB.WINDOWS.toUpperCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadsrtindx.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {                           
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadsrtindx.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                   ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                   ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {

                                   if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                   {
                                       yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                       while (Thread.currentThread().getId() != yieldtothisthread )
                                       {
                                            Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                       }
                                       break;
                                    } /* if */                                 
                              } /* if */
                           } /* if */
                       }                   
                    break;
                case 3:
                       if (OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadrefreshdb.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadrefreshdb.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {

                                  if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                  {
                                      yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                      while (Thread.currentThread().getId() != yieldtothisthread )
                                      {
                                            Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                      }
                                      break;
                                  } /* if */                                 
                              } /* if */
                           } /* if */
                       }                    
                    break;
                case 4:
                       if (OPERATINGSYSTEM.toUpperCase().indexOf(LiveDB.WINDOWS.toUpperCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadsysexit.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {                           
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadsysexit.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {

                                 if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                 {
                                     yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                     while (Thread.currentThread().getId() != yieldtothisthread )
                                     {
                                           Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                     }
                                     break;
                                 } /* if */                                 
                              } /* if */
                           } /* if */
                       }                   
                    break;
                case 5:
                       if (OPERATINGSYSTEM.toUpperCase().indexOf(LiveDB.WINDOWS.toUpperCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadwritetables.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {                           
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadwritetables.setPriority((int)ThreadController.getAccelerator()[p_Witch]);                          
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {

                                 if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                 {
                                     yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                     while (Thread.currentThread().getId() != yieldtothisthread )
                                     {
                                            Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                     }
                                     break;
                                  } /* if */                                 
                              } /* if */
                           } /* if */
                       }                    
                    break;
                case 6:
                       if (OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadroyal.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {                           
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadroyal.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                   ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                   ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {

                                   if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                   {
                                       yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                       while (Thread.currentThread().getId() != yieldtothisthread )
                                       { // why is it bitching about a  yield here ?
                                            Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                       }
                                       break;
                                   } /* if */                                 
                              } /* if */
                           } /* if */
                       }                    
                    break;
                case 7:
                       if (OPERATINGSYSTEM.toUpperCase().indexOf(LiveDB.WINDOWS.toUpperCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadloveall.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {                           
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadloveall.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {
 
                                 if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                 {
                                     yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                     while (Thread.currentThread().getId() != yieldtothisthread )
                                     {
                                            Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                     }
                                     break;
                                 } /* if */                                 
                              } /* if */
                           } /* if */
                       }                    
                    break;
                case 8:                    
                       if (OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadspy.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadspy.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {

                                 if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                 {
                                     yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                     while (Thread.currentThread().getId() != yieldtothisthread )
                                     {
                                         Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                     }
                                     break;
                                 } /* if */                                 
                              } /* if */
                           } /* if */
                       }                    
                    break;
                case 9:
                       if (OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadgui.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadgui.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER ) )
                              {
 
                                 if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                 {
                                     yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                     while (Thread.currentThread().getId() != yieldtothisthread )
                                     {
                                            Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                     }
                                     break;
                                  } /* if */
                              } /* if */
                           } /* if */
                       }                    
                    break;
                case 10: /* FILL THIS UP LATER */
                       if (OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) != -1)
                       {
                          if ( ThreadController.OnRadar (p_Witch) == true )
                             threadcontroller.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                       }
                       else
                       {
                           if ( ThreadController.OnRadar (p_Witch) == true )
                           {                              
                              threadcontroller.setPriority((int)ThreadController.getAccelerator()[p_Witch]);
                              /* check if it has completed the time slice as per our wish list */
                              flyingtime = ThreadController.getFlyingTimes(p_Witch);
                              if ( flyingtime >= ( ThreadController.getG4x4() == false ?
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * (TIMESLICER -2):
                                 ThreadController.getAccelerator()[p_Witch] * 1000 * TIMESLICER) )
                              {
                                 if (Thread.currentThread().getId() != ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1])
                                                && ThreadController.getSortedAccelerator()[t][1] != p_Witch)
                                 {
                                     yieldtothisthread = (int)ThreadController.getSystemThreadID((int)ThreadController.getSortedAccelerator()[t][1]);

                                     while (Thread.currentThread().getId() != yieldtothisthread )
                                     {
                                          Thread.yield(); // yield gives other runnable threads a "chance" to run which it will pick at random
                                            // so is this the threadid that we want which yield() has yielded to at random ?
                                     }
                                     break;
                                 } /* if */                                 
                              } /* if */
                            } /* if */
                       }                    
                    break;
                default:
                   break;
             }
        }
    }

    protected static long RevvoMeter = VROOM ();  /* ThreadController and ThunderBall will use this long version TachyMeter */

    /* This will be used for garbage cleaning
     * some rows will be deleted so they will be removed
     * and only wanted rows of any table will be re-assigned to table
     */
    protected static Object wanted_rows [];
    protected static transient Semaphore wanted_rows_permit = new Semaphore(1,true);

    /* Now define the LiveSharedDB
     * Which will host the Shared Database for all sessions
     * This will be the In memory database loaded from physical
     * database files of the operating system and will be refreshed
     * continuously by an independent thread dedicated to this job
     * This Database will at best contain 51 tables at any given point
     * of time including indexes, sort files, dbf files etc
     * The other index subscript is left blank because we dont yet
     * know the number of rows in each table
     * The method get_DataEntryFile will allocate memory for table rows
     * as it loads all tables into memory
     */

    /* fence this memory off my share of cake GC will still work
     * suppress optimization or this code below may flunk. Ignore
     * that volatile array field warning. It is also a lock free
     * mechanism to synchronize access to this database.
     */
    // why is it bitching about a volatile here when the book says use it ??
    protected static volatile Object [][] LiveSharedDB = new Object [maxtables][];

    /*
     * The initial capacity by default for these HashMaps are just fine. We dont
     * have such a huge load factor. It will re-hash automatically. Set the
     * initialcapacity only if you expect a very huge load.
     * I have set the initial capacity for some BUT IF THE PROGRAM STARTS
     * CRAWLING THE CULPRIT COULD BE THIS.
     */

    // This is not an index just a container for DecodedReport files for different drv.reportid
    protected static HashMap<Integer, String> DecodedReport = new HashMap<Integer, String>(32);
    // tables that had a serialization failure due to whatever reasons will be listed here 
    protected static HashMap<Integer, Long> SerializationFailure = new HashMap<Integer, Long>(45);

    // use this global to Rebuild any Indexes 
    protected static HashMap<String, Long> RebuildIndexes = new HashMap<String, Long>();
    /* indxcustomerRegister indexed on CID use to find CID will return rowid in table CustomerRegister */
    protected static HashMap<String, Long> indxcustomerRegister = new HashMap<String, Long>(100);
    //protected static HashMap<String, Long> indxpictureDatabase = new HashMap<String, Long>(100);
    /* searchkey = AnyValidCID + AnyValidPictureCode + Sub_opt_id
     * searchkey returns Long rowid in the table */
    //protected static HashMap<String, Long> indx1shoppingCart = new HashMap<String, Long>(600);
    /* Shopping Cart index 2 on String cid duplicates will be overwritten. This index will
     * identify unique cids in shopping cart.
     */
    //protected static HashMap<String, Long> indx2shoppingCart = new HashMap<String, Long>(600);
    /* LanguageTitles index on langcode, englishlabel */
    protected static HashMap<String, String> indxlanguageTitles = new HashMap<String, String>(3000);

    protected static HashMap<String, Long> indx1languageTransalations = new HashMap<String, Long>(500);
    /* LanguageTransalations index 2 on long lid, String pic */
    protected static HashMap<String, Long> indx2languageTransalations = new HashMap<String, Long>(500);
    /* LanguageTransalations index 3 on long lid, String pic, String gui_text_area_type */
    // protected static HashMap<String, String> indx3languageTransalations = new HashMap<String, String>(500);

    /* PictureOptions index on String pic, long lid, long opt_id, long sub_opt_id */
    /* This table PictureOptions is STATIC with no new row additions
     * 
     */
    /* indxpictureOptions index on langcode + opt_id to find language sub text for opt_id
     */
    //protected static HashMap<String, String> indxpictureOptions = new HashMap<String, String>(1000);
    /* indx2pictureOptions index on opt_id + langcode to find LiveDB.fieldseperator seperated language_sub texts for all sub_opt_id
     */
    //protected static HashMap<String, String> indx2pictureOptions = new HashMap<String, String>(1000);
    protected static HashMap<String, Long> indxinstalledTables = new HashMap<String, Long>(35);
    protected static HashMap<String, Long> indxreportsTable = new HashMap<String, Long>(50);
    protected static HashMap<String, Long> indxchangeTracker = new HashMap<String, Long>(5000);
    protected static HashMap<Long, String> indxcrashRecovery = new HashMap<Long, String>();
    protected static HashMap<String, Long> indxfileTableDataFileMap = new HashMap<String, Long>(18);
    protected static HashMap<String, Long> indxpaymentType = new HashMap<String, Long>();
    protected static HashMap<String, Long> indxlanguageSupport = new HashMap<String, Long>(40);
    protected static HashMap<String, String> indxLanguageIDs = new HashMap<String, String>(40);
    /* SearchDatabase index  on keyword only */
    protected static HashMap<String, String> indxsearchDatabase = new HashMap<String, String> (1000);

    /* Rebuild this HashMap everday */
    protected static HashMap<Long, Date> indxreportGeneration = new HashMap<Long, Date> (32);
    protected static HashMap<Date, Long> indxreportRecentRow = new HashMap<Date, Long> (32);
    protected static HashMap<Integer, Integer> indxreportAllocation = new HashMap<Integer, Integer> (32);
    
    protected static HashMap<Date,Long> indxplatformClearance = new HashMap<Date, Long> (500);
    protected static HashMap<String,Long>indx1platformClearance = new HashMap<String,Long> (500);
    

    /* Some Comparator declarations for the sort tables */
    static final Comparator datecomparator = new DateComp ();
    static final Comparator statuscomparator = new StatusComp ();
    
    //protected static TreeSet<PictureOptions> picoptssrttable = new TreeSet<PictureOptions> ();
    /* sorted on id ascending */
    protected static TreeSet<ReportsTable> srt1reportstable = new TreeSet<ReportsTable> ();
    /* sorted on report date ascending */
    protected static TreeSet<ReportsTable> srt2reportstable = new TreeSet<ReportsTable> (datecomparator);
    /* sorted on status ascending */
    protected static TreeSet<ReportsTable> srt3reportstable = new TreeSet<ReportsTable> (statuscomparator);


    protected static boolean FancyNumberPlates = true;

    protected static final String YourFancyNumberPlate = "101010000101000010000100001001010010111010110101101010000000000";

/*
 * WIRING DIAGRAM :
 * Method Name : protected static long VROOM ()
 * Parameters : None
 * Returns : long base 2 converted to long
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Turn on the Rolls Royce Phantom Engine to default values. Use this Remote VROOM ().
 * This Engine uses a V64 GearBox but our Engineers are working on a V128 GearBox for our next HyperSonic
 * Engine Called the "Break Of Dawn".
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 3rd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static long VROOM (){
        if (FancyNumberPlates == true)
           return ThreadController.CustomNumberPlates(YourFancyNumberPlate);
        else
           return ThreadController.CustomNumberPlates("101010000101000010000100001001010010111010110101101010000000000");
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.CHECKPROGRAM, LiveDB.errfile, LiveDB.CTSR, LiveDB.CRSR, LiveDB.RTSR
 * @LOOKSY:LiveDB.magicnumber, LiveDB.logerrorno, LiveDB.ErrMesgNo, LiveDB.ALRTLVL, LiveDB.AlertLabels
 * @LOOKSY:LiveDB.ErrMesgs, LiveDB.MAXTHREADS, LiveDB.SYNCOBJID, LiveDB.reportsforthispid, LiveDB.minrepid
 * @LOOKSY:LiveDB.STATIONMASTERSREPORT, LiveDB.maxrepid, LiveDB.STRIKETHROUGH, LiveDB.UNDERLINE
 * @LOOKSY:LiveDB.BOLD, LiveDB.LANDSCAPE, LiveDB.POTRAIT, LiveDB.PREPRINTED, LiveDB.DIRECTOPRINTER
 * @LOOKSY:LiveDB.NOPAGETOTALS, LiveDB.PAGETOTALS, LiveDB.ITALIC, LiveDB.POWEROUTAGEENABLED
 * @LOOKSY:LiveDB.system_exit, LiveDB.reindexall, LiveDB.ADMINSESSIONON, LiveDB.databaseloading
 * @LOOKSY:LiveDB.startfastcommit, LiveDB.usersloggedin, LiveDB.maxtables, LiveDB.REALTABLES
 * @LOOKSY:LiveDB.maxrows, LiveDB.rowlimit, LiveDB.reportmethodidentifier, LiveDB.north, LiveDB.south
 * @LOOKSY:LiveDB.northwest, LiveDB.northeast, LiveDB.southeast, LiveDB.southwest, LiveDB.west, LiveDB.east
 * @LOOKSY:LiveDB.grassHopper(), LiveDB.SupportedStationary, LiveDB.SupportedFonts, LiveDB.MAXROWSETS
 *
 * Method Name : protected static boolean programmingScrewups()
 * Parameters : None
 * Returns : boolean true if zero programming screwups
 *           boolean false if programming screwups discovered in source code
 *
 * Data File : LiveDB.java
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will check your globals in your running program class LiveDB. There are
 * some globals in the program that must not be altered or must have specific values for the program to run
 * eror free. So calling this method enforces correct values on those globals. This method can be turned on
 * or off using a global LiveDB.CHECKPROGRAM. So if this is false it wont check assertions even if you have
 * turned on assertions on the command line. This is a highly un-necessary superfluous method which is never
 * implemented in programming world. This is being done because this is OPEN SOURCE & some novice programmer
 * may try and customize the program on his own so some tight checks as far as possible and detailed error
 * reports in ErrorLogFile which can itself serve as a rudimentary debugger.
 *
 * Technical Reference : [Buy] and Read Tin Tin and Red Sea Sharks
 *
 * Start Date: 18th October 2010
 * End Date: 25th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   protected static boolean programmingScrewups(){
       long logline = 0L;
       // This will be the very first method to be called before everything else in main
       
       // some assertions for teach track
       // actually assertions could be a dis-advantage in this context if disabled at coomand line
       // so we will use assertions as an example for not so sensitive variables. Dont use assertions
       // in actual programming practice because you will end up embedding bugs in the program when
       // you are a start up programmer.
       if (LiveDB.CHECKPROGRAM) // this my enable assertions kind of internal flag so even if assertions
                                // are enabled on command line they wont work if this flag is false
       {
           // the assertions below for CTSR, CRSR, RTSR are not really sensitive
           // they are set when the database comes up. So you really dont need to assert
           // these values. So even if assert is turned off it wont hurt
           assert LiveDB.CTSR == 0:LiveDB.grassHopper("non-zero init value for LiveDB.CTSR");
           
           assert LiveDB.CRSR == 0:LiveDB.grassHopper("non-zero init value for LiveDB.CRSR");
           assert LiveDB.RTSR == 0:LiveDB.grassHopper("non-zero init value for LiveDB.RTSR");
           assert LiveDB.magicnumber == 2147483647; // this is another way to assert without an expression;

           // the above is not the perfect use for assertions Use them in places where you are
           // expecting the un-expected in the form of a bug due to programming screwups.
           // what i have done thru-out this program is to use LiveDB.ALRTLVL = 7; followed
           // by a call to System.err.println to print a very detailed error message to ErrorLogFile
           // which will help debug a lot more and help analyze the nature of system down times and
           // bad programmers who need to be hanged from the nearest tree. (programmers who dont get
           // it upright first time on time every time !!!) a theoritical phrase in the programming
           // world that needs to be ignored.
           
           // this will hurt if assertion is turned off so we will check with if butts
           // this is so because this must be checked even if you turn off assertions.
           
           // These presets are the graphic equalizers of your system without which the
           // the system wont play to rythm.

           // Check log specific presets
           if (LiveDB.logerrorno != 0 || LiveDB.ALRTLVL != 0 || LiveDB.ErrMesgNo != 0)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.logerrorno=0,ALRTLVL=0,ErrMesgNo=0"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // Check message specific presets
           if (LiveDB.AlertLabels.length != 16)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("There must be 16 LiveDB.AlertLabels in original source"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }
           
           // continue with message specific preset checks
/*
                                             // jiro        one         two         three
    protected static String [] AlertLabels = {"SYSADM:", "INTRUDER:", "SABOTAGE:", "WARNING:",
            // four       five        six        seven                   eight        nine
       "CORRUPTION:", "ADVISORY:", "GENERAL:", "PROGRAMMING SCREWUPS:", "EMERGENCY:", "LOWBATTERY:",
       // ten        // eleven       // twelve         // thirteen     // fourteen      // fifteen
       "OUTOFSPACE:", "FAKEDATABASE:", "DATABASE CRASH:", "DISK FAILURE:", "OUT OF MEMORY:", "BAD-DATA:"
    };
 */
           if (LiveDB.AlertLabels[0].equalsIgnoreCase("SYSADM:") == false 
               || LiveDB.AlertLabels[1].equalsIgnoreCase("INTRUDER:") == false
               || LiveDB.AlertLabels[2].equalsIgnoreCase("SABOTAGE:") == false
               || LiveDB.AlertLabels[3].equalsIgnoreCase("WARNING:") == false
               || LiveDB.AlertLabels[4].equalsIgnoreCase("CORRUPTION:") == false
               || LiveDB.AlertLabels[5].equalsIgnoreCase("ADVISORY:") == false
               || LiveDB.AlertLabels[6].equalsIgnoreCase("GENERAL:") == false
               || LiveDB.AlertLabels[7].equalsIgnoreCase("PROGRAMMING SCREWUPS:") == false
               || LiveDB.AlertLabels[8].equalsIgnoreCase("EMERGENCY:") == false
               || LiveDB.AlertLabels[9].equalsIgnoreCase("LOWBATTERY:") == false
               || LiveDB.AlertLabels[10].equalsIgnoreCase("OUTOFSPACE:") == false
               || LiveDB.AlertLabels[11].equalsIgnoreCase("FAKEDATABASE:") == false
               || LiveDB.AlertLabels[12].equalsIgnoreCase("DATABASE CRASH:") == false
               || LiveDB.AlertLabels[13].equalsIgnoreCase("DISK FAILURE:") == false
               || LiveDB.AlertLabels[14].equalsIgnoreCase("OUT OF MEMORY:") == false
               || LiveDB.AlertLabels[15].equalsIgnoreCase("BAD-DATA:") == false
               )
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("define/set in LiveDB protected static String[] AlertLabels = {\"SYSADM:\","));
               logline = LiveDB.logerrorno;
               System.err.println("LINE" +  ":" + String.valueOf(logline) + " "
               + "\"INTRUDER:\", \"SABOTAGE:\", \"WARNING:\",\"CORRUPTION:\", \"ADVISORY:\",");
               logline = LiveDB.logerrorno;
               System.err.println("LINE" +  ":" + String.valueOf(logline) + " "
               + "\"GENERAL:\", \"PROGRAMMING SCREWUPS:\", \"EMERGENCY:\", \"LOWBATTERY:\",");
               logline = LiveDB.logerrorno;
               System.err.println("LINE" +  ":" + String.valueOf(logline) + " "
               + "\"OUTOFSPACE:\", \"FAKEDATABASE:\", \"DATABASE CRASH:\",");
               logline = LiveDB.logerrorno;
               System.err.println("LINE" +  ":" + String.valueOf(logline) + " "
               + "\"DISK FAILURE:\",\"OUT OF MEMORY:\", \"BAD-DATA:\"");
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // continue with message specific preset checks
           // check error messages itself for an error
/*
    protected static String [] ErrMesgs =
    {
        // 0 Default
        " Self Explanatory and/or read explanation below with same line number ",
        // 1 IOEXception
        " stream has been closed, input stream does not support reading after close or another I/O error occurs",
        // 2 IOException
        " I/O error occurs ",
        // 3 IOException
        " file could not be created ",
        // 4
        " Variant 4 ",
        // 5 UTFDataFormatException
        " the bytes do not represent a valid modified UTF-8 encoding of a string ",
        // 6
        " Variant 2 ",
        // 7 EOFException
        " this input stream reaches the end before reading all the bytes ",
        // 8
        " Variant 2 ",
        // 9 SecurityException
        " SecurityManager.checkRead(java.lang.String) method denies read access to file ",
        // 10 SecurityException
        " SecurityManager.checkWrite(java.lang.String) method denies write access to file ",
        // 11 SecurityException
        " SecurityManager.checkExec(java.lang.String) method denies execute access to file ",
        // 12 SecurityException
        " SecurityManager.checkDelete method denies delete access to file ",
        // 13 SecurityException
        " a required system property value cannot be accessed ",
        // 14 SecurityException  use this with getFreeSpace getUsableSpace getTotalSpace etc
        " Security Manager denies RuntimePermission(\"getFileSystemAttributes\") or read denied to pathname ",
        // 15
        " current thread cannot modify this thread ",
        // 16 IllegalArgumentsException
        " argument contains fewer characters or invalid number of arguments or invalid characters ",
        // 17 NumberFormatException
        " attempt to convert string to numeric types, string format incorrect ",
        // 18 NumberFormatException
        " Variant 2 ",
        // 19 ClosedChannelException
        " this channel is already closed ",
        // 20 OverlappingFileLockException
        " lock overlaps request region held by JVM, other thread blocked in trylock overlap region same file ",
        // 21 ArrayOutofBoundsException
        " specified index argument is negative, or is greater than or equal to length of specified array ",
        // 22 NullPointerException
        " Specified Object is null ",
        // 23 IllegalThreadStateException
        " this thread is already active ",
        // 24 IllegalThreadStateException
        " Variant 2 ",
        //25 ParseException
        " beginning of specified string cannot be parsed ",
        //26 ParseException
        " Variant 2 ",
        //27 ParseException
        " Variant 3 ", // plug in your customized error message here if you dont like system error message
        // 28 ClassNotFoundException
        " Class of a serialized object cannot be found ",
        // 29 InvalidClassException
        " Something is wrong with a class used by serialization ",
        // 30 StreamCorruptedException
        " Control information in stream is inconsistent ",
        // 31 OptionalDataException No longer need with Java SE 6 autoboxing from primitive to Object
        " Primitive data was found in the stream instead of objects ",
        // 32 MissingResourceException
        " A Resource Bundle is Missing ",
        // 33 AddressException
        " Invalid Email Address Specified ",
        // 34 MessagingException
        " MessagePreparationFailure:cant add specified Recipient[s] addRecipient[s] ",
        // 35 MessagingException
        " MessagePreparationFailure:cant set subject setSubject ",
        // 36 MessagingException
        " MessagePreparationFailure:cant set from setFrom ",
        // 37 MessagingException
        " MessagePreparationFailure:cant set body of message setContent ",
        // 38 MessagingException
        " MessagePreparationFailure:cant set text of message with attachment setText ",
        // 39 MessagingException
        " MessagePreparationFailure:cant set DataHandler for message setDataHandler ",
        // 40 MessagingException
        " MessagePreparationFailure:cant add body part for message addBodyPart ",
        // 41 MessagingException
        " MessagePreparationFailure:cant attach specified file to message setFileName ",
        // 42 MessagingException
        " AirportPostOfficeClosed:cant connect using specified username,password connect() ",
        // 43 MessagingException
        " MessageNotDelivered:message not delivered sendMessage ",
        // 44 MessagingException
        " PostBoxOpen:could not close transport connection Zip Up !! close () ",
        //45 IllegalAccessException
        " Executing method dont have access to definition of class,field,method or constructor ",
        //46 IllegalAccessException
        " Variant 2 ",
        //47 InvocationTargetException
        " the underlying method invoked by Method throws an exception ",
        //48 InvocationTargetException
        " Variant 2 ",
        //49 NoSuchMethodException
        " particular Method cannot be found in class ",
        //50 NoSuchMethodException
        " Variant 2 "
    };
 */
           if (LiveDB.ErrMesgs[0].equalsIgnoreCase(" Self Explanatory and/or read explanation below with same line number ") == false
              || LiveDB.ErrMesgs[1].equalsIgnoreCase(" stream has been closed, input stream does not support reading after close or another I/O error occurs ") == false
              || LiveDB.ErrMesgs[2].equalsIgnoreCase(" I/O error occurs ") == false
              || LiveDB.ErrMesgs[3].equalsIgnoreCase(" file could not be created ") == false
              || LiveDB.ErrMesgs[5].equalsIgnoreCase(" the bytes do not represent a valid modified UTF-8 encoding of a string ") == false
              || LiveDB.ErrMesgs[7].equalsIgnoreCase(" this input stream reaches the end before reading all the bytes ") == false
              || LiveDB.ErrMesgs[9].equalsIgnoreCase(" SecurityManager.checkRead(java.lang.String) method denies read access to file ") == false
              || LiveDB.ErrMesgs[10].equalsIgnoreCase(" SecurityManager.checkWrite(java.lang.String) method denies write access to file ") == false
              || LiveDB.ErrMesgs[11].equalsIgnoreCase(" SecurityManager.checkExec(java.lang.String) method denies execute access to file ") == false
              || LiveDB.ErrMesgs[12].equalsIgnoreCase(" SecurityManager.checkDelete method denies delete access to file ") == false
              || LiveDB.ErrMesgs[13].equalsIgnoreCase(" a required system property value cannot be accessed ") == false
              || LiveDB.ErrMesgs[14].equalsIgnoreCase(" Security Manager denies RuntimePermission(\"getFileSystemAttributes\") or read denied to pathname ") == false
              || LiveDB.ErrMesgs[15].equalsIgnoreCase(" current thread cannot modify this thread ") == false
              || LiveDB.ErrMesgs[16].equalsIgnoreCase(" argument contains fewer characters or invalid number of arguments or invalid characters ") == false
              || LiveDB.ErrMesgs[17].equalsIgnoreCase(" attempt to convert string to numeric types, string format incorrect ") == false
              || LiveDB.ErrMesgs[19].equalsIgnoreCase(" this channel is already closed ") == false
              || LiveDB.ErrMesgs[20].equalsIgnoreCase(" lock overlaps request region held by JVM, other thread blocked in trylock overlap region same file ") == false
              || LiveDB.ErrMesgs[21].equalsIgnoreCase(" specified index argument is negative, or is greater than or equal to length of specified array ") == false
              || LiveDB.ErrMesgs[22].equalsIgnoreCase(" Specified Object is null ") == false
              || LiveDB.ErrMesgs[23].equalsIgnoreCase(" this thread is already active ") == false
              || LiveDB.ErrMesgs[25].equalsIgnoreCase(" beginning of specified string cannot be parsed ") == false
              || LiveDB.ErrMesgs[28].equalsIgnoreCase(" Class of a serialized object cannot be found ") == false
              || LiveDB.ErrMesgs[29].equalsIgnoreCase(" Something is wrong with a class used by serialization ") == false
              || LiveDB.ErrMesgs[30].equalsIgnoreCase(" Control information in stream is inconsistent ") == false
              || LiveDB.ErrMesgs[31].equalsIgnoreCase(" Primitive data was found in the stream instead of objects ") == false
              || LiveDB.ErrMesgs[32].equalsIgnoreCase(" A Resource Bundle is Missing ") == false
              || LiveDB.ErrMesgs[33].equalsIgnoreCase(" Invalid Email Address Specified ") == false
              || LiveDB.ErrMesgs[34].equalsIgnoreCase(" MessagePreparationFailure:cant add specified Recipient[s] addRecipient[s] ") == false
              || LiveDB.ErrMesgs[35].equalsIgnoreCase(" MessagePreparationFailure:cant set subject setSubject ") == false
              || LiveDB.ErrMesgs[36].equalsIgnoreCase(" MessagePreparationFailure:cant set from setFrom ") == false
              || LiveDB.ErrMesgs[37].equalsIgnoreCase(" MessagePreparationFailure:cant set body of message setContent ") == false
              || LiveDB.ErrMesgs[38].equalsIgnoreCase(" MessagePreparationFailure:cant set text of message with attachment setText ") == false
              || LiveDB.ErrMesgs[39].equalsIgnoreCase(" MessagePreparationFailure:cant set DataHandler for message setDataHandler ") == false
              || LiveDB.ErrMesgs[40].equalsIgnoreCase(" MessagePreparationFailure:cant add body part for message addBodyPart ") == false
              || LiveDB.ErrMesgs[41].equalsIgnoreCase(" MessagePreparationFailure:cant attach specified file to message setFileName ") == false
              || LiveDB.ErrMesgs[42].equalsIgnoreCase(" AirportPostOfficeClosed:cant connect using specified username,password connect() ") == false
              || LiveDB.ErrMesgs[43].equalsIgnoreCase(" MessageNotDelivered:message not delivered sendMessage ") == false
              || LiveDB.ErrMesgs[44].equalsIgnoreCase(" PostBoxOpen:could not close transport connection Zip Up !! close () ") == false
              || LiveDB.ErrMesgs[45].equalsIgnoreCase(" Executing method dont have access to definition of class,field,method or constructor ") == false
              || LiveDB.ErrMesgs[47].equalsIgnoreCase(" the underlying method invoked by Method throws an exception ") == false
              || LiveDB.ErrMesgs[49].equalsIgnoreCase(" particular Method cannot be found in class ") == false
              )
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("Error messages are not originals refer source line 2300 LiveDB.java"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               // never mind he may have changed it a bit to his liking dont System.exit(1)
           }

           // Thread specific flags
           if (LiveDB.MAXTHREADS != 10)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.MAXTHREADS=10;"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // Trigger specific flags
           if (LiveDB.SYNCOBJID >= 0)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.SYNCOBJID = -1;"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // Now check report specific flags

           if (LiveDB.reportsforthispid != 17 || LiveDB.minrepid != 18 || LiveDB.maxrepid != 51)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.reportsforthispid=17,minrepid=18,maxrepid=51"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // Now check some ReportWriter specifics

           // start with station masters report
           if (LiveDB.STATIONMASTERSREPORT == false)
           {
               LiveDB.ALRTLVL = 5;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.STATIONMASTERSREPORT=true;,Usefull report for tuning"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               // dont exit
           }

           // Check page formatting flags that ReportWriter uses

           if (LiveDB.STRIKETHROUGH != -2 || LiveDB.UNDERLINE != -3 || LiveDB.ITALIC != -4)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.STRIKETHROUGH = -2,UNDERLINE = -3,ITALIC = -4"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }
           // continue page formatting flag checks
           if (LiveDB.BOLD != -5 || LiveDB.LANDSCAPE != -6 || LiveDB.POTRAIT != -7 )
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.BOLD = -5,LANDSCAPE = -6,POTRAIT = -7"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }
           // continue page formatting flag checks
           if (LiveDB.PREPRINTED != -8 || LiveDB.DIRECTOPRINTER != -9 || LiveDB.NOPAGETOTALS != -10
               || LiveDB.PAGETOTALS != -11 )
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set LiveDB.PREPRINTED = -8,DIRECTOPRINTER = -9,NOPAGETOTALS = -10,PAGETOTALS = -11"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }
           
           // Check report types
/*
    protected static final String reporttype [] = {"PO", "INV", "RMA", "CR", "SC", "MIS", "PLOT", "POST", "GRAPH", "PIE", "MAIL" };
 */
           if (LiveDB.reporttype[0].equals("PO") == false
              || LiveDB.reporttype[1].equals("INV") == false
              || LiveDB.reporttype[2].equals("RMA") == false
              || LiveDB.reporttype[3].equals("CR") == false
              || LiveDB.reporttype[4].equals("SC") == false
              || LiveDB.reporttype[5].equals("MIS") == false
              || LiveDB.reporttype[6].equals("PLOT") == false
              || LiveDB.reporttype[7].equals("POST") == false
              || LiveDB.reporttype[8].equals("GRAPH") == false
              || LiveDB.reporttype[9].equals("PIE") == false
              || LiveDB.reporttype[10].equals("MAIL") == false
              )
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("LiveDB.reporttype[] dont match original refer source line 2442 LiveDB.java"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // some crash recovery flags
           if (LiveDB.POWEROUTAGEENABLED == false)
           {
               LiveDB.ALRTLVL = 5;
               System.err.println (LiveDB.grassHopper("set LiveDB.POWEROUTAGEENABLED=true;,Usefull if UPS not installed"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               // dont exit
           }
           
           // now check some system critical flags presets
           if (LiveDB.system_exit != 0 || LiveDB.reindexall != 1 || LiveDB.ADMINSESSIONON != -1)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.system_exit=0,reindexall=1,ADMINSESSIONON=-1"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // check some table specific presets
           if ( ft != 0 || ct != 1 || cr != 2 || id != 3 || crr != 13 || it != 14 || rt != 15
                   || pc != 17 || ni != 8 || ll != 16 || cp != 6 )
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("Bad values:correct as LiveDB.ft=0,ct=1,cr=2,id=3,ni=8,cp=6,ll=16,crr=13,it=14,rt=15,pc=17"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // now check some database specific flags presets
           if (LiveDB.databaseloading != 2 || LiveDB.startfastcommit != 0 || LiveDB.usersloggedin != 0)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets LiveDB.databaseloading=2,startfastcommit=0,usersloggedin=0"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // now check some database dimension specifier flags presets
           if (LiveDB.maxtables != 51 || LiveDB.REALTABLES != 17 || LiveDB.rowlimit !=  2147483647
               || LiveDB.maxrows != (LiveDB.rowlimit - 3647))
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("SET LiveDB.maxtables=51,REALTABLES=17,rowlimit=2147483647,maxrows=rowlimit -3647"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // Check LiveDB.reportmethodidentifier
           for (int rw = 0, rid = LiveDB.REALTABLES + 1; rw < LiveDB.reportmethodidentifier.length; rw++, rid++)
           {
               if (Integer.parseInt(LiveDB.reportmethodidentifier[rw][0]) != rid)
               {
                    LiveDB.ALRTLVL = 7;
                    System.err.println (LiveDB.grassHopper("LiveDB.reportmethodidentifier[rw][0] Incorrrect"));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
                    return false;
               }
           }
           
           // check directions the north is fake the south is the truth ........
           // the southwest are luck seven and the southeast the son of a gun got lucky with all eight
           // of them !!!
           if (LiveDB.north != 0 || LiveDB.south != 1 || LiveDB.east != 2 || LiveDB.west != 3
               || LiveDB.middle != 4 || LiveDB.northwest != 5 || LiveDB.northeast != 6
               || LiveDB.southwest != 7 || LiveDB.southeast != 8)
           {
               LiveDB.ALRTLVL = 7;
               System.err.println (LiveDB.grassHopper("set presets north=0,south=1,east=2,west=3,middle=4,northwest=5,northeast=6,southwest=7,southeast=8"));
               JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
               return false;
           }

           // check Supported Stationary
           // dont add any more stationary and add to your headaches supported stationary is commonly used.

           for (int rw = LiveDB.SupportedStationary.length -1, sid = -91; rw >= 0; rw--, sid++)
           {
               if (Integer.parseInt(LiveDB.SupportedStationary[rw][0]) != sid)
               {
                    LiveDB.ALRTLVL = 7;
                    System.err.println (LiveDB.grassHopper("LiveDB.SupportedStationary[rw][0] Incorrrect"));
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
                    return false;
               }
           }

           // Check BallTamperingBytes after counting bytes precisely after rectifying report writer
           // and testing it preferably
           
       }
       
       // this is a valid use of assertions where the program must launch with ALRTLVL = 0
       assert ALRTLVL == 0:LiveDB.grassHopper("LiveDB.ALRTLVL not reset to zero at end of method");
       assert MAXROWSETS >= 0:LiveDB.grassHopper("LiveDB.MAXROWSETS negative !!");
       // this field count must be exact or else ...... the database will not install at all
       assert Integer.parseInt(tablenameidentifier[0][3]) == 8:LiveDB.grassHopper("Field Count for table FileTableDataFileMap Incorrect");
       assert Integer.parseInt(tablenameidentifier[1][3]) == 8:LiveDB.grassHopper("Field Count for table ChangeTracker Incorrect");
       assert Integer.parseInt(tablenameidentifier[2][3]) == 25:LiveDB.grassHopper("Field Count for table CustomerRegister Incorrect");
       assert Integer.parseInt(tablenameidentifier[3][3]) == 15:LiveDB.grassHopper("Field Count for table ShoppingCart Incorrect");
       assert Integer.parseInt(tablenameidentifier[4][3]) == 4:LiveDB.grassHopper("Field Count for table LanguageSupport Incorrect");
       assert Integer.parseInt(tablenameidentifier[5][3]) == 6:LiveDB.grassHopper("Field Count for table LanguageTitles Incorrect");
       assert Integer.parseInt(tablenameidentifier[6][3]) == 6:LiveDB.grassHopper("Field Count for table LanguageTransalations Incorrect");
       assert Integer.parseInt(tablenameidentifier[7][3]) == 3:LiveDB.grassHopper("Field Count for table PaymentType Incorrect");
       assert Integer.parseInt(tablenameidentifier[8][3]) == 10:LiveDB.grassHopper("Field Count for table PictureDatabase Incorrect");
       assert Integer.parseInt(tablenameidentifier[9][3]) == 6:LiveDB.grassHopper("Field Count for table PictureOptions Incorrect");
       assert Integer.parseInt(tablenameidentifier[10][3]) == 3:LiveDB.grassHopper("Field Count for table SearchDatabase Incorrect");
       assert Integer.parseInt(tablenameidentifier[11][3]) == 10:LiveDB.grassHopper("Field Count for table DefaultAdvertisingImages Incorrect");
       assert Integer.parseInt(tablenameidentifier[12][3]) == 19:LiveDB.grassHopper("Field Count for table ArtLeaves Incorrect");
       assert Integer.parseInt(tablenameidentifier[13][3]) == 4:LiveDB.grassHopper("Field Count for table CrashRecovery Incorrect");
       assert Integer.parseInt(tablenameidentifier[14][3]) == 9:LiveDB.grassHopper("Field Count for table InstalledTables Incorrect");
       assert Integer.parseInt(tablenameidentifier[15][3]) == 10:LiveDB.grassHopper("Field Count for table ReportsTable Incorrect");
       assert Integer.parseInt(tablenameidentifier[16][3]) == 1:LiveDB.grassHopper("Field Count for table CelebrityTable Incorrect");
       assert Integer.parseInt(tablenameidentifier[17][3]) == 6:LiveDB.grassHopper("Field Count for table PlatformClearance Incorrect");
       assert LiveDB.YourFancyNumberPlate.length() == 64:LiveDB.grassHopper("LiveDB.YourFancyNumberPlate must contain 64 digits of 0 and/or 1");
       assert LiveDB.Supportedfonts.length == 12:LiveDB.grassHopper("Supported Fonts should be Sardarji");

       // a few more essentials in life even if you turn off checking
       if (LiveDB.CHECKPROGRAM == false)
       {          
            assert LiveDB.SupportedStationary.length == 19:LiveDB.grassHopper("Supported Stationary should be nineteen");
            assert system_exit == 0:LiveDB.grassHopper("SET LiveDB.system_exit = 0");
            assert EXITTHREADCONTROLLER == false:LiveDB.grassHopper("SET LiveDB.EXITTHREADCONTROLLER to false");
            assert LiveDB.startfastcommit == 0:LiveDB.grassHopper("SET LiveDB.startfastcommit = 0");
            assert LiveDB.databaseloading == 2:LiveDB.grassHopper("SET LiveDB.databaseloading = 2");
            assert LiveDB.ADMINSESSIONON == -1:LiveDB.grassHopper("SET LiveDB.ADMINSESSIONON = -1");
            assert LiveDB.reindexall == 1:LiveDB.grassHopper("SET LiveDB.reindexall = 1");
            assert ft == 0:LiveDB.grassHopper("SET LiveDB.ft = 0");
            assert ct == 1:LiveDB.grassHopper("SET LiveDB.ct = 1");
            assert cr == 2:LiveDB.grassHopper("SET LiveDB.cr = 2");
            assert id == 3:LiveDB.grassHopper("SET LiveDB.id = 3");
            assert ni == 8:LiveDB.grassHopper("SET LiveDB.ni = 8");
            assert cp == 6:LiveDB.grassHopper("SET LiveDB.cp = 6");
            assert ll == 16:LiveDB.grassHopper("SET LiveDB.ll = 16");
            assert crr == 13:LiveDB.grassHopper("SET LiveDB.crr = 13");
            assert it == 14:LiveDB.grassHopper("SET LiveDB.it = 14");
            assert rt == 15:LiveDB.grassHopper("SET LiveDB.rt = 15");
            assert pc == 17:LiveDB.grassHopper("SET LiveDB.pc = 17");
            /* THATS IT  */
       }
       
       return true;
   }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:
 * @LOOKSY:
 * @LOOKSY:
 * @LOOKSY:
 *
 * Parameters :
 *
 *
 * Running Commentary :
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    public static boolean REMOTECONTROL (Object ... IRobot){
        /* PUBLIC HANDSET */
        /* PAISA MANGTA HAI */
        /* BRITISH POUND STERLING 250 ONLY MADE IN BRIGHTON */
        /* OKAY I GIVES SOURCE CODE ALSO */
        /* YOU WILL FINDS THIS USEFULL IF YOU INTEGRATE ALL THOSE NANPA, NINPA, JANPA etc etc DATABASES */
        return true;
    }

    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.IPCSSYNC, LiveDB.READINPROGRESS, LiveDB.IPCSSYNCLOCKS, LiveDB.READINPROGRESSLOCKS
 *
 * Method Name : protected static boolean Prankster (File prankfile, int tbl, boolean IPCSSYNCFILE)
 * Parameters : File prankfile -- Could this be a prankfile ??
 *              int tbl -- which table number is the pranfile for ?
 *              boolean IPCSSYNCFILE -- Is the above prankfile a IPCSSYNCFILE ?
 *                                      boolean true ipcssync_<tbl>.syc
 *                                      else boolean false readinprogress<tbl> file
 * Returns : boolean true if some prankster has created this prank file
 *           boolean false if this file is authentic synchronization file
 *
 * Calling Methods: LiveDB::protected static void PranksterCheck ()
 *                  LiveDB::protected static boolean QueueTrainsInWaiting (PlatformClearance mytrain,
 *                                                           FileChannel ch, FileLock fl, int requestno )
 *                  You may also call it elsewhere in code where needed. Time consuming thats all !!
 * Calling Triggers : LiveDB::protected static enum InterProcessSynchronization
 *
 * Prank Files : LiveDB.serializedfilespath/syc/ipcssync_*.syc,
 *               LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Some mischief maker can just plug in a Prank File as above into the syc sub
 * directory and hang the system literally. So these are just marker files just a file with no data
 * in it. So these are easy to create files by just about anybody. So this method checks if such files
 * exist and then validates them making sure they are authentic in there. Dont confuse this method with
 * the other overloaded Prankster() method that takes zero parameters. That other method authneicates
 * different kind of file and this method authenticates Prank Files listed above. But both follow a
 * similar approach to validation. Basically a thread that created an authentic file ipcssync_*.syc
 * or readinprogress* will get hold of an xclusive lock on that file. So all that this method does is
 * to try getting an exclusive lock on this suspected File prankfile and if it cant get that lock then
 * it is assumed to be a authentic file. Otherwise if it gets the lock then it is assumed to be a fake
 * file. If you look at the source code for the Trigger there is a delete but just before that the lock
 * is released and then the stream is closed and then the delete happens. So this may be perceived as a
 * Bug which it is not. Just look at it simply if that file is not locked already it is a prank file.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean Prankster (File prankfile, int tbl, boolean IPCSSYNCFILE)
    {      

       // just remember you dont close these streams LiveDB.IPCSSYNC or LiveDB.READINPROGRESS and
       // neither do you release exclusive locks LiveDB.IPCSSYNCLOCKS or LiveDB.READINPROGRESSLOCKS
       // Both these actions will be done by the Deque mechanisms and Trigger.

       try{
            if (IPCSSYNCFILE)
               LiveDB.IPCSSYNC[tbl] = new FileOutputStream (prankfile);
            else LiveDB.READINPROGRESS[tbl] = new FileOutputStream (prankfile);
       }catch (FileNotFoundException ex_NOKIA33){
           LiveDB.ALRTLVL = 2;
           System.err.println(LiveDB.grassHopper("File just created Deleted ", ex_NOKIA33));
           return true;
       }

       try{
           if (IPCSSYNCFILE)
               LiveDB.IPCSSYNCLOCKS[tbl] = LiveDB.IPCSSYNC[tbl].getChannel().tryLock();
           else LiveDB.READINPROGRESSLOCKS[tbl] = LiveDB.READINPROGRESS[tbl].getChannel().tryLock();
        }catch (ClosedChannelException ex_NOKIA72){
            System.err.println(LiveDB.grassHopper(ex_NOKIA72));
            return true;
        }catch (OverlappingFileLockException ex_NOKIA81){
              // This file already locked so some other thread or process has already locked it.
             // authentic file
              return false;
        }catch (IOException ex_NOKIA72){
            System.err.println(LiveDB.grassHopper(ex_NOKIA72));
            return true;
        }

        // again a jillionth of a chance that some other .... got past us
        if (IPCSSYNCFILE)
        {
            if (LiveDB.IPCSSYNCLOCKS[tbl] == null) // authentic file already locked
                return false;
        }
        else
        {
            if (LiveDB.READINPROGRESSLOCKS[tbl] == null) // authentic file already locked
                return false;
        }

       // you got the lock you are a prankster
       // This is based on the simple household logic that only the head of the household holds the
       // key to the specific wardrobes. If someone else gets it then thats a prankster (that miserable ........
       // ..... (you fill out the rest)

        return true;
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.FILESEPERATOR, LiveDB.OPERATINGSYSTEM
 * @LOOKSY:LiveDB.DRIVESEPERATOR, LiveDB.USRDIR, LiveDB.WINDOWS
 *
 * Method Name : protected static boolean CopyFile (String p_fromfile, String p_to_file)
 * Parameters : String p_fromfile -- from file with path
 *              String p_to_file  -- destination file name with path -- Optional can be null
 *
 * Returns : boolean true if good copy
 *           boolean false if bad copy or streams error or any other error
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method can be used to copy a file of raw bytes to another file. The method
 * does all validations necessary before copying the file to the destination file. The method is fairly
 * complicated because it does lots of checks and balances on the filenames passed and also auto corrects
 * to some extent. The path seperator i am looking for in this method is in a different context. It will
 * be the same ":".
 *
 * Technical Reference : Buy and Read Tun Tun in America (North Indian Beauty)
 *
 * Start Date: 18th October 2010
 * End Date: 24th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean CopyFile (String p_fromfile, String p_to_file){

    if (p_fromfile == null)
        return false;
   
        if (p_fromfile.indexOf(LiveDB.DRIVESEPERATOR) == -1)
        {
            if (p_fromfile.indexOf(LiveDB.FILESEPERATOR) == -1)
            {
                if (LiveDB.OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) == -1)
                    p_fromfile = LiveDB.USRDIR + LiveDB.FILESEPERATOR + p_fromfile; // not windows
                else
                    p_fromfile = LiveDB.USRDIR + LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR + p_fromfile;
            }
            else
            {   // file seperator is there
                if (p_fromfile.length() == p_fromfile.lastIndexOf(LiveDB.FILESEPERATOR) + 1)
                    return false; // invalid from file name cant be auto corrected
                else
                {
                    if (p_fromfile.indexOf(LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR) == -1)
                    {
                        if (p_fromfile.indexOf(LiveDB.FILESEPERATOR) == 0)
                            p_fromfile = LiveDB.USRDIR + p_fromfile;
                        else p_fromfile = LiveDB.USRDIR + LiveDB.FILESEPERATOR + p_fromfile;
                    }
                    else
                    {
                        p_fromfile = LiveDB.USRDIR + p_fromfile.substring(p_fromfile.
                                lastIndexOf(LiveDB.FILESEPERATOR),p_fromfile.length());
                    }
                }
            }
        }
        else
        { // path seperator is there
           if (LiveDB.OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) == -1)
               return false; // not windows path seperator invalid
           if (p_fromfile.indexOf(LiveDB.FILESEPERATOR) == -1)
           {
               p_fromfile = p_fromfile.substring(0,p_fromfile.indexOf(LiveDB.DRIVESEPERATOR))
               + LiveDB.DRIVESEPERATOR + LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR
               + p_fromfile.substring(p_fromfile.indexOf(LiveDB.DRIVESEPERATOR) + 1, p_fromfile.length());
           }
           else
           { // file seperator  is there
               if (p_fromfile.indexOf(LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR) == -1)
               {
                   p_fromfile = p_fromfile.substring(0,p_fromfile.indexOf(LiveDB.DRIVESEPERATOR))
                                + LiveDB.DRIVESEPERATOR + LiveDB.FILESEPERATOR
                                + p_fromfile.substring(p_fromfile.indexOf(LiveDB.FILESEPERATOR),
                                p_fromfile.length());
               }
               else
               {
                   p_fromfile = p_fromfile.substring(0,p_fromfile.indexOf(LiveDB.DRIVESEPERATOR))
                                + LiveDB.DRIVESEPERATOR
                                + p_fromfile.substring(p_fromfile.indexOf(LiveDB.FILESEPERATOR),
                                p_fromfile.length());
               }
           }
        }
    

    if (new File(p_fromfile).isFile() == false)
    {
        System.err.println(grassHopper("The from File " + p_fromfile + " is not a normal file"));
        return false;
    }

    if (p_fromfile != null && p_to_file == null)
    {        
        p_to_file = LiveDB.serializedfilespath + p_fromfile.substring(p_fromfile.lastIndexOf(LiveDB.FILESEPERATOR) + 1,
                p_fromfile.length());
    }
    else if (p_fromfile != null && p_to_file != null)
    {
        if (p_to_file.indexOf(LiveDB.DRIVESEPERATOR) == -1)
        {
            if (p_to_file.indexOf(LiveDB.FILESEPERATOR) == -1)
            {
                if (LiveDB.OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) == -1)
                    p_to_file = LiveDB.USRDIR + LiveDB.FILESEPERATOR + p_to_file; // not windows
                else
                    p_to_file = LiveDB.USRDIR + LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR + p_to_file;
            }
            else
            {   // file seperator is there
                if (p_to_file.length() == p_to_file.lastIndexOf(LiveDB.FILESEPERATOR) + 1)
                    return false; // invalid from file name cant be auto corrected
                else
                {
                    if (p_to_file.indexOf(LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR) == -1)
                    {
                        if (p_to_file.indexOf(LiveDB.FILESEPERATOR) == 0)
                            p_to_file = LiveDB.USRDIR + p_to_file;
                        else p_to_file = LiveDB.USRDIR + LiveDB.FILESEPERATOR + p_to_file;
                    }
                    else
                    {
                        p_to_file = LiveDB.USRDIR + p_to_file.substring(p_to_file.
                                lastIndexOf(LiveDB.FILESEPERATOR),p_to_file.length());
                    }
                }
            }
        }
        else
        { // path seperator is there
           if (LiveDB.OPERATINGSYSTEM.toLowerCase().indexOf(LiveDB.WINDOWS.toLowerCase()) == -1)
               return false; // not windows path seperator invalid
           if (p_to_file.indexOf(LiveDB.FILESEPERATOR) == -1)
           {
               p_to_file = p_to_file.substring(0,p_to_file.indexOf(LiveDB.DRIVESEPERATOR))
               + LiveDB.DRIVESEPERATOR + LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR
               + p_to_file.substring(p_to_file.indexOf(LiveDB.DRIVESEPERATOR) + 1, p_to_file.length());
           }
           else
           { // file seperator  is there
               if (p_to_file.indexOf(LiveDB.FILESEPERATOR + LiveDB.FILESEPERATOR) == -1)
               {
                   p_to_file = p_to_file.substring(0,p_to_file.indexOf(LiveDB.DRIVESEPERATOR))
                                + LiveDB.DRIVESEPERATOR + LiveDB.FILESEPERATOR
                                + p_to_file.substring(p_to_file.indexOf(LiveDB.FILESEPERATOR),
                                p_to_file.length());
               }
               else
               {
                   p_to_file = p_to_file.substring(0,p_to_file.indexOf(LiveDB.DRIVESEPERATOR))
                                + LiveDB.DRIVESEPERATOR
                                + p_to_file.substring(p_to_file.indexOf(LiveDB.FILESEPERATOR),
                                p_to_file.length());
               }
           }
        }
    } // else if (p_fromfile != null && p_to_file != null)

    if (new File(p_to_file).isFile() == false)
    {
        System.err.println(grassHopper("The To File " + p_to_file + " is not a normal file"));
        return false;
    }
    
    if (p_fromfile.equals(p_to_file))
    {        
        System.err.println(LiveDB.grassHopper("From file:" + p_fromfile + " To file:" + p_to_file + " are same"));
        return false;
    }

    String to_disk = p_to_file.substring(0, p_to_file.lastIndexOf(LiveDB.FILESEPERATOR));

    String pf = p_fromfile;
    File in = new File(pf);
    File ou = new File(p_to_file);
    File bd = new File (to_disk);


    if (in.exists() == false)
    {
       System.err.println(grassHopper("File to Back Up From Does not exist " + pf));
       return false;
    }


    if (in.canRead() == false)
    {
       System.err.println(grassHopper("Java Security Manager denied READ on Backup From File " + pf));
       return false;
    }

    // first check the backup directory for space File bd

    if (bd.isDirectory() == true)
    {
        if (bd.getUsableSpace() < in.length())
        {
           LiveDB.ALRTLVL = 10;
           System.err.println(grassHopper("File:" + p_to_file));
           // you can add code here to create filespace by deleting the files in the temp area
           // but system administrators will not approve of this without their explicit permission.
           // it can also lead to data loss if the temp area is being used to unzip and install some other program
           // UNCOMMENT THIS IF YOU WANT TO AUTOFIX SPACE PROBLEM
           /* if (createSpace (in.length() + 1024L) < in.length())
              return false; */
           return false;
        }
    }
    else
    {
       System.err.println(grassHopper("Invalid TO directory " + to_disk + " From File = " + p_fromfile));
       return false;
    }


    try{
       if (ou.createNewFile() == false)
       {
          if (ou.canWrite() == false)
          {
             if (ou.setWritable(true,true) == false)
             {
                System.err.println(grassHopper("No Perms to change access of pathname " + p_to_file));
                return false;
              }
          }
          System.err.println(grassHopper("target file exists overwriting file:" + p_to_file));
       }
    }catch(IOException ex_NOKIA82){
       System.err.println(grassHopper(ex_NOKIA82, "File:" + p_to_file));
       return false;
    }catch (SecurityException ex_NOKIA83){
       System.err.println(grassHopper(ex_NOKIA83, "JSM denied write perms on File to Backup " + p_to_file));
       return false;
    }

    FileInputStream fis = null;
    FileOutputStream fos = null;
    FileChannel ch = null, ch2 = null;
    FileLock fl = null;
    FileLock fl2 = null;
    
    try{
        
        fis = new FileInputStream(in);
        ch = fis.getChannel();
        while (fl == null)
        {
            try{
                fl = ch.tryLock(0, Long.MAX_VALUE, true); // get a shared lock
            }catch (IllegalArgumentException ex_NOKIA84){
                LiveDB.ALRTLVL = 7;
                System.err.println(grassHopper(ex_NOKIA84, "Parameter mismatch in tryLock " + pf));
                try{
                    fis.close();
                }catch(IOException ex_NOKIA81){                    
                    return false;
                }
                System.err.println(grassHopper(ex_NOKIA84, "Copy From " +  p_fromfile + " Copy To " +  p_to_file));
                return false;
            }catch(ClosedChannelException ex_NOKIA85){
                System.err.println(grassHopper(ex_NOKIA85, "File is already closed () CopyFile() " + pf));
                return false;
            }catch(OverlappingFileLockException ex_NOKIA86){
                LiveDB.ALRTLVL = 7;
                System.err.println(grassHopper(ex_NOKIA86, "Filename:" + pf));
                try{
                    fis.close();
                }catch(IOException ex_NOKIA81){
                    System.err.println(grassHopper(ex_NOKIA81, "Input File:" + pf));
                    return false;
                }
                return false;
            }catch (IOException ex_NOKIA87){
                System.err.println(grassHopper(ex_NOKIA87, "From File:" + pf));
                try{
                    fis.close();
                }catch(IOException ex_NOKIA81){
                    System.err.println(grassHopper(ex_NOKIA81, "From File:" + pf));
                    return false;
                }
                return false;
            }
        } // while (fl == null)

        fos = new FileOutputStream(ou);
        ch2 = fos.getChannel();

        while (fl2 == null)
        {
           try{
                fl2 = ch2.tryLock(); // get an xclusive lock
            }catch (IllegalArgumentException ex_NOKIA84){
                LiveDB.ALRTLVL = 7;
                System.err.println(grassHopper(ex_NOKIA84, "Param mismatch"));
                try{
                    fos.close();
                }catch(IOException ex_NOKIA81){                    
                    return false;
                }
                System.err.println(grassHopper(ex_NOKIA84, "To File:" + p_to_file));
                return false;
            }catch(ClosedChannelException ex_NOKIA85){
                LiveDB.ALRTLVL = 7;
                System.err.println(grassHopper(ex_NOKIA85));
                return false;
            }catch(OverlappingFileLockException ex_NOKIA86){
                LiveDB.ALRTLVL = 7;
                System.err.println(grassHopper(ex_NOKIA86));
                try{
                    fos.close();
                }catch(IOException ex_NOKIA81){
                    System.err.println(grassHopper(ex_NOKIA81, "To File:" + p_to_file));
                    return false;
                }
                return false;
            }catch (IOException ex_NOKIA87){
                System.err.println(grassHopper(ex_NOKIA87, "Share Lock Fail Filename:" + p_to_file));
                try{
                    fos.close();
                }catch(IOException ex_NOKIA81){
                    System.err.println(grassHopper(ex_NOKIA81, "To File:" + p_to_file));
                    return false;
                }
                return false;
            }
        } // while (fl2 == null)

    }catch (FileNotFoundException ex_NOKIA78){
       System.err.println(grassHopper(ex_NOKIA78, "From File:" + pf + " or To File:" + p_to_file + " Not Found"));
       return false;
    }

    byte readbuff [] = new byte [(int)in.length() -1];
    boolean ok = true;    

    try{
           // first read then write
           try{
                if (fis.available() == in.length())
                {
                   if (fis.read(readbuff,0,(int)in.length()) == -1)
                       return ok = false;
                   else ok = true;
                }
                else return false;

           }catch(IOException ex_NOKIA79){
              System.err.println(grassHopper(ex_NOKIA79, "To File:" + pf + " To " + p_to_file));
              return ok = false;
           }
           // now write
           try{
               fos.write(readbuff);
           }catch(IOException ex_NOKIA80){
              System.err.println(grassHopper(ex_NOKIA80, "From File:" + pf + " To:" + p_to_file));
              return ok = false;
           }
    }finally{
        if (ou.setReadOnly() == false)
        {
            System.err.println(grassHopper("cant set write perms File:" + p_to_file));
            ok = false;
        }
        try{
           fis.close();
           fos.close();
        }catch(IOException ex_NOKIA81){
            System.err.println(grassHopper(ex_NOKIA81, "From File:" + pf + " To File:" + p_to_file));
            return ok = false;
        }
    }

        return ok;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.FILESEPERATOR, LiveDB.REALTABLES
 *
 * Method Name : protected static void PranksterCheck ()
 * Parameters : None
 * Returns : None
 *
 * Calling Methods: LiveDB::protected static void LogFileSabotageCheck ()
 *                  You may also call it elsewhere in code where needed. Time consuming thats all !!
 *
 * Associated Methods : protected static boolean Prankster (File prankfile, int tbl, boolean IPCSSYNCFILE)
 *
 * Prank Files : LiveDB.serializedfilespath/syc/ipcssync_*.syc,
 *               LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Some mischief maker can just plug in a Prank File as above into the syc sub
 * directory and hang the system literally. So these are just marker files just a file with no data
 * in it. So these are easy to create files by just about anybody. So this method checks if such files
 * exist and then validates them making sure they are authentic in there. If not it just deletes those
 * files on disk. To authenticate these files this method calls the overloaded Prankster method that
 * takes parameters.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static void PranksterCheck (){

        File PRANKFILE = null;

        for (int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++)
        {
            if ((PRANKFILE = new File(LiveDB.serializedfilespath + "syc" +
                LiveDB.FILESEPERATOR + "ipcssync_" + tbl + ".syc")).exists())
            {
                if (Prankster(PRANKFILE, tbl, true))
                {
                    PRANKFILE.delete();
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Prank File:" + LiveDB.serializedfilespath 
                    + "syc" + LiveDB.FILESEPERATOR + "ipcssync_" + tbl + ".syc" + " Deleted"));
                }
            }
        }
        
        // now check for fake readinprogess files that could hang the database
        for (int tbl = 0; tbl <= LiveDB.REALTABLES; tbl++)
        {
            if ((PRANKFILE = new File(LiveDB.serializedfilespath + "syc" +
                LiveDB.FILESEPERATOR + "readinprogress" + tbl)).exists())
            {
                if (Prankster(PRANKFILE, tbl, false))
                {
                    PRANKFILE.delete();
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("Prank File:" + LiveDB.serializedfilespath
                    + "syc" + LiveDB.FILESEPERATOR + "readinprogress" + tbl + " Deleted"));
                }
            }
        }
    }
    
    protected static boolean LogFileExists (){
        return new File(LiveDB.ErrorLogFile).exists();
    }

    protected static boolean LogFileCanWrite (){
        return new File(LiveDB.ErrorLogFile).canWrite();
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:AutoBackup.java -- just the run() method
 * @LOOKSY:BillionHearts.java -- just the run() method
 * @LLOKSY:RefreshDatabase.java -- just the run() method
 * @LOOKSY:RoyaltyTracker.java -- just the run() method
 * @LOOKSY:Spy.java -- just the run() method
 * @LOOKSY:SystemExit.java -- just the run() method
 * @LOOKSY:WriteTables.java -- just the run() method
 * @LOOKSY:ThreadController.java -- just the run() method
 * @LOOKSY:InstallDB.java method public static void main(String[] args)
 * @LOOKSY:LiveDB.system_exit, LiveDB.ALRTLVL, LiveDB.SmoothExitCondition, LiveDB.errfile
 * @LOOKSY:LiveDB.FILESEPERATOR, LiveDB.serializedfilespath, LiveDB.ADMINSESSIONON, LiveDB.TMPDIR
 *
 * Method Name : protected static void LogFileSabotageCheck ()
 * Parameters : None
 * Returns :None
 *
 * Calling Methods: run() methods of different threads
 *                  Also called a couple of times in threadspy, threadroyal, threadloveall
 *
 * Log File : LiveDB.ErrorLogFile, LiveDB.serializedfilespath/etc/FSCK_IN_PROGRESS,
 *            LiveDB.TMPDIR/admincommands.dbs
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method achieves several purposes. First whenever a SYSADM command is issued
 * it prevents new users from logging in. In fact it forces an immediate System.exit(1). Also whenever a
 * fsck() is started by first database service that detects it; It creates a file FSCK_IN_PROGRESS in the
 * etc sub directory. So this method looks for that file and does an immediate System.exit(1). The third
 * purpose is an OVERDO. Any SYSADM command will call a method LiveDB.AllUsersKickedOut () to verify that
 * there are zero users on the system. This method will create a file ALLUSERSEXIT which will cannot be
 * duplicated. If the file is not a prank file it exits immediately. The reason for this OVERDO is it
 * can be checked for authenticity whereas the admincommands.dbs cannot be checked for authenticity. The
 * other file ALLUSERSEXIT can be used elsewhere also if you change the programming logic wherein there
 * is a method which is not exactly a SYSADM method but is invoked internally by the application and runs
 * like one for example fsck(). The next purpose is to check for a missing ErrorLogFile which may have
 * been deleted intentionally by some prankster. If that happens quickly try and redirect standard error
 * once again and if even a redirectstderr fails try a desperate attempt to Smooth Exit because application
 * may perhaps generate an advisory message of some sort some time later and so it could continue to
 * function until then. After this it Checks for prankster files of synchronization type created on the
 * system and deletes them if found. Then it does a leftover space check. Sometimes there can be a runaway
 * process on the system that was running overnight that could have filled up the entire disk. Finally it
 * flushes the ErrorLogFile and completes. So this is a very usefull method but dont overdo it otherwise
 * it will consume time. At startup in main() you must call it several times to ensure that other apps
 * exit quickly (read first few lines of this passage).
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static void LogFileSabotageCheck (){


        File userexit = new File (LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT");


        if ((new File(LiveDB.TMPDIR + "admincommands.dbs").exists() && LiveDB.ADMINSESSIONON < 0)
           || new File(LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR +  "FSCK_IN_PROGRESS")
                                                                  .exists() && LiveDB.ADMINSESSIONON < 0)
        {
               LiveDB.ALRTLVL = 5;
               System.err.println(LiveDB.grassHopper("Other user running Admin Command log in after five minutes"));
               JOptionPane.showMessageDialog(appframe, "OTHER USER RUNNING ADMIN COMMAND LOG IN AFTER 5 MINUTES");
               System.exit(1); // if this file already exists users who log in exit immediately
        }

        if ( userexit.exists() )
        {
            // now not so fast any mischief maker can create this file and down the application.
            // So try and get hold of a Exclusive lock on this file. The creating process would
            // have already got hold of a XClusive lock and not released it. So if we try for a
            // XClusive lock it will fail which means its an authentic file and not a prankster.
            // never know what those Chinese kids can do !
            if (!Prankster())
               System.exit(1);

            // else if there is one such prankster dont bother harmless feller keep going
        }

        if (new File(LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR + "FSCK_IN_PROGRESS")
                                                                                        .exists())
        {
            if (!PRANKSTER())
               System.exit(1);
        }

        if (LogFileExists () == false)
        {
            LiveDB.ALRTLVL = 2;
            System.err.println(LiveDB.grassHopper("Log File Deleted attempting to Recreate again"));
            // call stderr redirect method to make quick attempt at preventing application crash
            if (redirectstderr() == false)
            {
               LiveDB.system_exit = 1; // try a last ditch attempt to smooth exit
               LiveDB.SmoothExitCondition.signalAll(); // anyways it will crash out
               System.err.println(LiveDB.grassHopper("Log File Deleted redirectstderr () failed"));
            }
        }

        if (LogFileCanWrite() == false)
        {
            LiveDB.ALRTLVL = 1;
            System.err.println(LiveDB.grassHopper("Log File Perms changed to read resetting to write"));

            try{
            if (new File (LiveDB.ErrorLogFile).setWritable(true, true) == false)
            {
                System.err.println(LiveDB.grassHopper("resetting LogFilePerms to write failed"));
                LiveDB.system_exit = 1; // try a smooth exit it may crash before this can happen
                LiveDB.SmoothExitCondition.signalAll(); // there is a chance it may smooth exit
            }
            }catch(SecurityException ex_NOKIA14){
                System.err.println(LiveDB.grassHopper(ex_NOKIA14));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }

        PranksterCheck ();
        checkSpaceLeft(); // quick check while system is running
        // everything okay flush it
        errfile.flush();

    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB::protected static boolean NewPictureAdditions(String... p_file)
 *         LiveDB::protected static boolean PictureUpdates (String... p_file)
 *         LiveDB::protected static boolean OldPictureDeletions (String p_file)
 *
 * Method Name : protected static boolean SerializeJustOnceTable(long p_tbl)
 * Parameters : int p_tbl -- Is this table a serialize just once table ?
 * Returns :String -- boolean true if the table is a serialize just once table
 *                    boolean false if the table is not a serialize just once table
 *
 * Calling Methods: Any method can call this method to check a specific table
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : There are some tables that are loaded at Install Time and then the data is
 * just looked up. There are no further updates or inserts or deletes on those tables via LensView
 * Application. This one table called PictureDatabase referred in the code as pd is also one such
 * table except that are some SYSADM commands that apply on that table. So it is a grey area.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean SerializeJustOnceTable(long p_tbl){
        if (p_tbl != ft && p_tbl != ct && p_tbl != cr && p_tbl != cp && p_tbl != crr
            && p_tbl != it && p_tbl != rt && p_tbl != pc && p_tbl != id )
            return true;
        else return false;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstallDB.java method private static boolean blocklogin ()
 * @LOOKSY:InstallDB.java method private static void threadLaunch()
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.FILESEPERATOR
 *
 * Method Name : protected static boolean AllUsersKickedOut ()
 * Parameters : None
 * Returns :boolean true if all users have logged out of LensView and all daemons have exited
 *          boolean false if users still logged into application LensView or daemons still running.
 *
 * Calling Methods: LiveDB::protected static boolean DATABASE_RECONSTRUCT (Date p_upto, boolean p_usebackup)
 *                  LiveDB::protected static boolean DATABASE_ROLLBACK (Date p_upto)
 *                  InstallDB::private static void threadLaunch()
 *                  LiveDB::protected static boolean QuickRepairChangeTracker ()
 *                  LiveDB::protected static boolean NewPictureAdditions(String... p_file)
 *                  LiveDB::protected static boolean PictureUpdates (String... p_file)
 *                  LiveDB::protected static boolean OldPictureDeletions (String p_file)
 *
 * Chained Methods : private static boolean Prankster ()
 *
 * Assocaited Methods : protected static void LogFileSabotageCheck ()
 *
 * Data File : LiveDB.serializedfilespath/usr/ULI.chr, LiveDB.serializedfilespath/usr/ULI.inf,
 *             LiveDB.serializedfilespath/daemon/*.daemon files, LiveDB.TMPDIR/admincommands.dbs,
 *             LiveDB.serializedfilespath/var/ALLUSERSEXIT
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method serves two purposes. 
 *
 * The first purpose is to ease out users who have logged in already. Remember that blocklogin ()
 * method created a LiveDB.TMPDIR/admincommands.dbs file which prevents any more users from logging in.
 * What this does it to smoothly push out the existing users on the system. So it initiates that process
 * by creating a catalyst file LiveDB.serializedfilespath/var/ALLUSERSEXIT. If this file already exists
 * and !Prankster() then some other session has already started a SYSADM command so this method will return
 * false. Even if there is a Prankster() it will still return false but will delete the prank file and
 * issue a error message to SYSADM.
 *
 * Second purpose it checks to see if users are still logged on. If users are not logged in any more then
 * it checks to see if daemon services are still running. If either users are logged in or daemon services
 * other than your sessions are still running it will return false. Those two files ULI.inf and ULI.chr
 * will be created by the GUI and updated by the GUI constantly every time users log in and log out from
 * the LensView Application. For Home Users the file will be there but will be irrelevant unless it is a
 * HUF (Hindu Undivided Family) or CUF (Christian Undivided Family) or MUF (Muslim Undivided Family) or
 * JUF (Jewsish Undivided Family). The desktop version of this software will not be supplied to Iyer
 * Divided Families (No Rokda).
 *
 * Technical Reference : Dennis the Menace Strikes Again
 *
 * Start Date: 18th October 2010
 * End Date: 31st May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean AllUsersKickedOut (){
       final File uli = new File (LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR + "ULI.inf");
       File ulic = null;
       File userexit = null;
       FileInputStream fis = null;
       DataInputStream dis = null;
       long users = -1L;
       byte retries = 0; // number of retries

       userexit = new File (LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT");

       try{
                if (userexit.createNewFile() == false)
                {
                    // This file already exists so some other chap has already issued a SYSADM command.
                    // so let us check if this is an authentic file or some prankster
                   if (Prankster())
                   {
                       System.err.println(LiveDB.grassHopper("PRANKSTER created File:"
                               + LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT"));
                       userexit.delete();
                       return false;
                   }
                   else
                       return false; // authentic file
                }
       }catch (SecurityException ex_NOKIA39){
            System.err.println("Security Manager denies create File:" + LiveDB.serializedfilespath
                    + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT");
            return false;
       }catch (IOException ex_NOKIA47){
            System.err.println("Create File ALLUSERSEXIT failed. Suggested Disk Vendor:"
                    + LiveDB.DISKVENDOR );
            return false;
       }

       userexit.deleteOnExit();  // this file must be deleted on exit

       try{
            LiveDB.Xclusive = (LiveDB.FOS = new FileOutputStream (userexit)).getChannel().tryLock();
       }catch (FileNotFoundException ex_NOKIA33){
           LiveDB.ALRTLVL = 2;
           System.err.println(LiveDB.grassHopper("File just created Deleted "
                   + LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT",
                   ex_NOKIA33));
           return false;
       }catch (IOException ex_NOKIA43){
           System.err.println(LiveDB.grassHopper(ex_NOKIA43, "Suggested O/S Vendor:" + LiveDB.OSVENDORNAME));
           return false;
       }


       // character file same info as ULI.inf for database admin to lookup quickly
       // before running this program it will tell you which idiot has logged in and where
       // in next release. For now it is simplified as just a number.

       ulic = new File (LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR + "ULI.chr");

       if (uli.exists())
       {
           do{
                if (uli.canWrite())
                {
                    // uli.setReadOnly(); dont it may be writing
                    System.err.println(LiveDB.grassHopper("Perms changed to write on " +
                    LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR + "ULI.inf"));
                }
                try{
                    fis = new FileInputStream (uli);
                }catch (FileNotFoundException ex_NOKIA69){
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper(ex_NOKIA69, "File Deleted " 
                    + LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR + "ULI.inf"));
                    return false;
                }
                // open and readLong and check number of users logged in currently and if more than zero keep looping
                // until it reduces to zero

                dis = new DataInputStream (fis);
                try{
                    users = dis.readLong();
                }catch (IOException ex_NOKIA89){
                    System.err.println(LiveDB.grassHopper(ex_NOKIA89, "File:" + LiveDB.serializedfilespath
                       + "usr" + LiveDB.FILESEPERATOR + "ULI.inf cant process command."));
                    try{
                        dis.close();
                    }catch (IOException ex_NOKIA87){
                        System.err.println(LiveDB.grassHopper(ex_NOKIA87, "File:"
                        + LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR
                                + "ULI.inf cant process command."));
                    }
                    return false;
                }

                // if the above file exists then one more file must also exist called ulic
                if (ulic.exists() == true)
                {
                    if (ulic.canWrite() == true)
                    {
                        // ulic.setReadOnly(); dont it may be writing
                        LiveDB.ALRTLVL = 1;
                        System.err.println(LiveDB.grassHopper("Perms Changed to write on "
                            + LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR
                            + "ULI.chr have reset to read"));
                    }
                }
                else
                {
                    LiveDB.ALRTLVL = 2;
                    System.err.println(LiveDB.grassHopper("File Deleted:" 
                     + LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR + "ULI.chr"));
                    return false;
                }

                if (users > 0) retries++ ;

                // close the stream every time and re-open it because we dont know if markSupported() on this
                // stream will return true. If by chance markSupported does not return true on this stream we
                // cant take chances. so keep doing this.
                try{
                    dis.close();
                }catch (IOException ex_NOKIA87){
                  System.err.println(LiveDB.grassHopper(ex_NOKIA87, "File:"
                        + LiveDB.serializedfilespath + "usr" + LiveDB.FILESEPERATOR
                                                    + "ULI.inf cant process command."));
                  return false;
               }
           // else it exists so move on actually the value in both files must be the same but it can also
           // differ at times since ulic is written first and then uli is written so there could be a slight
           // difference in the numbers + - 2 or 3.
           }while (users > 0 && retries <= 126); // until then keep screaming at users use adams apple
           // you can also send repeat emails modify source if you want to
       }

       if (retries > 126 && users > 0) return false;

       // else continue to process because users are zero
       // now check for some .daemon files
       // the only .daemon files that should exist are threadrefreshdb + LiveDB.pid + .daemon

       String dirlist [] = null;
       long dennis = 0L, joey = 0L;
       boolean foundjoey = false;
       retries = 0;
       while ((dirlist = new File (LiveDB.serializedfilespath + "daemon").list()) != null)
       {
             for (int i = 0; i < dirlist.length; i++)
             {
                 if (dirlist[i].indexOf(".daemon") == -1)
                     dennis++;
                 else joey++;
             }

             if (joey > 1) return false;
             else if (joey == 0)
             {
                 // Dennis again one daemon file must be around but never mind return true
                 return true;
             }
             else if (joey == 1)
             {
                 // find that joey in that haystack
                 for (int i = 0; i < dirlist.length; i++)
                 {
                     if (dirlist[i].indexOf("threadrefreshdb" + LiveDB.pid + LiveDB.NODENAME + ".daemon") != -1)
                         // found the bugger
                         foundjoey = true;
                 }

                 if (foundjoey == false) return false;
             }
       }
       return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.FILESEPERATOR, LiveDB.FSCKFILE,
 * @LOOKSY:LiveDB.FSCKLOCK, LiveDB.system_exit
 *
 * Method Name : protected static boolean PRANKSTER ()
 * Parameters : None
 * Returns :boolean true if FSCK_IN_PROGRESS file has been created by a Prankster
 *          boolean false if FSCK_IN_PROGRESS has been created by a valid LensView session.
 *
 * Calling Methods: LiveDB::protected static void LogFileSabotageCheck ()
 *                  InstallDB::public static void main(String[] args)
 *
 * Data File : LiveDB.serializedfilespath/etc/FSCK_IN_PROGRESS
 *
 * @Since Version : 1.0
 *
 * Running Commentary : There is a file FSCK_IN_PROGRESS on disk. How do i know that the file is a
 * valid file created by an authentic LensView session ?? So to do that in the absence of certificates.
 * I get an exclusive lock on the file. Anyways it is just a marker file and if i cant get that exclusive
 * lock then i assume it is an authentic file so return false (not Prankster). If you get the lock then you
 * are a Prankster because method InstallDB.fsck() that created this file should hold the lock so you
 * should not be able to get a lock on it. Understood ?? Read the rest of the bullshit i have written
 * below.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean PRANKSTER ()
    {
       File userexit = new File (LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR + "FSCK_IN_PROGRESS");

       if (userexit.exists() == false)
           return false;
       // just remember you dont close this stream FSCKFILE and neither do you release FSCKLOCK
       // fsck() will do this for ya. Sorry about this last minute spaghetti code.
       
       try{
            FSCKFILE = new FileOutputStream (userexit);
       }catch (FileNotFoundException ex_NOKIA33){
           LiveDB.ALRTLVL = 2;
           System.err.println(LiveDB.grassHopper("File just created Deleted "
             + LiveDB.serializedfilespath + "etc" + LiveDB.FILESEPERATOR + "FSCK_IN_PROGRESS", ex_NOKIA33));
           return true;
       }

       try{
          FSCKLOCK = FSCKFILE.getChannel().tryLock();
        }catch (ClosedChannelException ex_NOKIA72){
            System.err.println(LiveDB.grassHopper(ex_NOKIA72));
            return true;
        }catch (OverlappingFileLockException ex_NOKIA81){
              // This file already locked so some other chap has already issued
              //  authentic SYSADM command.
              LiveDB.system_exit = 1;
              return false;
        }catch (IOException ex_NOKIA72){
            System.err.println(LiveDB.grassHopper(ex_NOKIA72));
            return true;
        }

        
        if (FSCKLOCK == null) // authentic file already locked
        {
            LiveDB.system_exit = 1;
            return false;
        }

       // you got the lock you are a prankster

        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstallDB.java method private static boolean blocklogin ()
 * @LOOKSY:InstallDB.java method private static void threadLaunch()
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.FILESEPERATOR, LiveDB.system_exit
 * @LOOKSY:LiveDB.FOS, LiveDB.Xclusive
 *
 * Method Name : protected static boolean Prankster ()
 * Parameters : None
 * Returns :boolean true if ALLUSERSEXIT file has been created by a Prankster
 *          boolean false if ALLUSERSEXIT has been created by a valid LensView session.
 *
 * Calling Methods: LiveDB::protected static boolean AllUsersKickedOut ()
 *                  LiveDB::protected static void LogFileSabotageCheck ()
 *                  InstallDB::public static void main(String[] args)
 *
 * Data File : LiveDB.serializedfilespath/var/ALLUSERSEXIT
 *
 * @Since Version : 1.0
 *
 * Running Commentary : There is a file ALLUSERSEXIT on disk. How do i know that the file is a valid file
 * created by an authentic LensView session ?? So to do that in the absence of certificates. I get an
 * exclusive lock on the file. Anyways it is just a marker file and if i cant get that exclusive lock
 * then i assume it is an authentic file so return false (not Prankster). If you get the lock then you
 * are a Prankster because method AllUsersKickedOut that created this file should hold the lock so you
 * should not be able to get a lock on it. Understood ?? Read the rest of the bullshit i have written
 * below.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 31st May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean Prankster ()
    {
       File userexit = new File (LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT");

       // In the next release we will better implement a Queue system for SYSADM commands
       // So the SYSADM will be able to check out early for dinner with his honey and not worry
       // It will work like a crony cron job.
       // In the next release you can mail in a SYSADM command or a set of SYSADM commands along
       // with time we will download that email from you and execute those SYSADM commands for you
       // Until then beg borrow steal at least a guest rlogin or telnet login for the time being
       // from the SYSADM or request him to do it for you.
       // First Come First Served. I am running out of time on my stopwatch.
       

       // just remember you dont close this stream FOS and neither do you release Xclusive lock
       // the other SYSADM command will do this for ya. Sorry about this last minute spaghetti code.
       
       try{
            FOS = new FileOutputStream (userexit);
       }catch (FileNotFoundException ex_NOKIA33){
           LiveDB.ALRTLVL = 2;
           System.err.println(LiveDB.grassHopper("File just created Deleted "
                   + LiveDB.serializedfilespath + "var" + LiveDB.FILESEPERATOR + "ALLUSERSEXIT",
                   ex_NOKIA33));
           return true;
       }

       try{
          Xclusive = FOS.getChannel().tryLock();
        }catch (ClosedChannelException ex_NOKIA72){
            System.err.println(LiveDB.grassHopper(ex_NOKIA72));
            return true;
        }catch (OverlappingFileLockException ex_NOKIA81){
              // This file already locked so some other chap has already issued
              //  authentic SYSADM command.
              LiveDB.system_exit = 1;
              return false;
        }catch (IOException ex_NOKIA72){
            System.err.println(LiveDB.grassHopper(ex_NOKIA72));
            return true;
        }

        // again a jillionth of a chance that some other .... got past us
        if (Xclusive == null) // authentic file already locked
        {
            LiveDB.system_exit = 1;
            return false;
        }

       // you got the lock you are a prankster
       // This is based on the simple household logic that only the head of the household holds the
       // key to the vault. If someone else gets it then thats a prankster (that miserable ........
       // ..... (you fill out the rest)
       
        return true;
    }



/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.ErrorLogFile, LiveDB.errfile
 *
 * Method Name : protected static boolean redirectstderr ()
 * Parameters : None
 * Returns : boolean true if stderr sucessfully redirected to LiveDB.ErrorLogFile
 *           boolean false if FileNotFound or Java Security Manager perms issues.
 *
 * Log File : LiveDB.ErrorLogFile
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will redirect stderr to LiveDB.ErrorLogFile
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 25th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean redirectstderr (){
        
        boolean okay = true;

        // close the previous errfile. Sometimes a prankser may delete the ErrorLogFile
        // and/or this may be a second redirect
        if (errfile != null)
        {
            errfile.close();
            SendLogFileMessage ();
        }
 
        try {
                errfile = new PrintStream (LiveDB.ErrorLogFile);
                System.setErr(errfile);
            }catch (FileNotFoundException ex_NOKIA1){
                System.err.println(LiveDB.grassHopper(ex_NOKIA1));
                JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
                okay = false;
            }catch (SecurityException ex_NOKIA2){
                System.err.println(LiveDB.grassHopper(ex_NOKIA2, "Security does not permit Log File "
                                                                             + LiveDB.ErrorLogFile));
                JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
                okay = false;
            }
        
        errfile.close();

        return okay;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY: ChangeTracker.java
 * @LOOKSY: CrashRecovery.java
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.LiveSharedDB 
 *
 * Method Name : protected static void prepareCrashRecovery(long p_table, long p_rw, String ... p_vals)
 * Parameters : long p_table -- the tableno for which CrashRecovery row is to be constructed
 *              long p_rw  -- the row of the other table
 *              String ... p_vals the values of [p_table][p_rw]
 * Returns : None
 *
 * Method Called From : ChangeTracker constructor
 *
 * Relevant Indexes: LiveDB.indxcrashRecovery
 * searchkey = AnyValidTableNumber(Long)
 * searchkey returns String containing the completed rowdata for the table
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method prepares single row for CrashRecovery Table & COMMITS CrashRecovery Table
 * After every DML on table there is always a new ChangeTracker () call. So the ChangeTracker constructor will
 * call this method. This method is called for only a few tables see ChangeTracker () constructor.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 3rd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static void prepareCrashRecovery(long p_table, long p_rw, String... p_vals){
        
        if (p_vals.length == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("No values in call to prepareCrashRecovery()"));
            return;
        }

        
        if (LiveDB.indxcrashRecovery.get(p_table) != null)
        { // then it is already there so update just values
            boolean fnd = false;
            int rw = 0;
            for (rw = 0; rw < LiveDB.LiveSharedDB[crr].length; rw++)
            {
                if (((CrashRecovery)LiveDB.LiveSharedDB[crr][rw]).getTableno() == p_table)
                {
                    rw = (int)((CrashRecovery)LiveDB.LiveSharedDB[crr][rw]).getCrrowid();
                    fnd = true;
                    break;
                }
            }
            
            if (fnd)
            {
               ((CrashRecovery)LiveDB.LiveSharedDB[crr][rw]).setValues(p_vals);
               // now tuck in a ChangeTracker entry for this table
               LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
               new ChangeTracker (crr,rw, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[crr][rw],
               (long)LiveDB.LiveSharedDB[ct].length);
            }
            else
            {
                LiveDB.ALRTLVL = 1;
                System.err.println(LiveDB.grassHopper("Table:" + Long.toString(p_table) +
                " found in indxcrashRecovery is missing in physical table"));
                System.exit(1);
            }
        }
        else
        {
            LiveDB.LiveSharedDB[crr][LiveDB.LiveSharedDB[crr].length] =
                    new CrashRecovery (p_table, p_rw, LiveDB.LiveSharedDB[crr].length, p_vals);
            // now tuck in a ChangeTracker entry for this table
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (crr,LiveDB.LiveSharedDB[crr].length -1, 'I', LiveDB.pid, new Date (),
                LiveDB.LiveSharedDB[crr][LiveDB.LiveSharedDB[crr].length -1],
                (long)LiveDB.LiveSharedDB[ct].length);
        }

        // KNOWN BUG: If there is a system crash even before CrashRecovery is slow committed
        // and fast commit mechanism has not committed ChangeTracker entries then fsck cant
        // recover this row for you because it is not a serialization failure and neither is
        // it in the CrashRecovery table !!! So live with it until I find a solution.
        // Normally even the fastest draw at pulling out the power cord of your computer takes
        // 450 milliseconds and by then it should have completed all the above and gone into
        // serialization phase write where it fails and so fsck () recovers it. I am not lying
        // try the fastest draw at pulling the power cord out on your computers with stop watch.
        // Also in case of power failure residual power remains for nearly the same time.
        
        // slow commit this CrashRecovery table
        if (((CrashRecovery)LiveDB.LiveSharedDB[crr][0]).COMMIT() == false)
        {
            System.err.println(LiveDB.grassHopper("CrashRecovery Table Slow Commit Failed"));
            System.exit(1);
        }
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.GrassHopperLock, LiveDB.ALRTLVL, LiveDB.AlertLabels
 * @LOOKSY:LiveDB.errfile, LiveDB.ErrMesgNo, LiveDB.ErrMesgs
 *
 * Method Name : public static String grassHopper (Object... ex_Exception)
 * Parameters : Object... ex_Exception -- Variable arguments. Beyond two values passed it will ignore rest
 *                                        Typically either/or or both arguments. One would be an error mesg
 *                                        and the other would be an exception that occurred in the program.
 * Returns :String -- Formatted Error Message with all details filled up
 *
 * Calling Methods: Typically System.err.println () will call this method.
 *                  For example : System.err.println(LiveDB.grassHopper(ex_NOKIA52, "Error fl.release()"));
 *                                System.err.println(LiveDB.grassHopper("Error fl.release()", ex_NOKIA52));
 *                                System.err.println(LiveDB.grassHopper("Error fl.release()"));
 *                                System.err.println(LiveDB.grassHopper(ex_NOKIA52));
 *                  Immediately after calling grassHopper() as above you can take value of LiveDB.logerrorno
 *                  into a temp variable and then do the following two times at best because that is all
 *                  the linespace left on the page. So do the following as in this example
 *                  temp = LiveDB.logerrorno;
 *                  System.err.println("LINE:" + temp + "This is continuation of previous error message");
 *                  System.err.println("LINE:" + temp + "with same line number providing different details");
 *                  Other methods may also call this grassHopper () it will return a String which is nothing
 *                  but a formatted error message that you may want for some purpose.
 *
 * Assocaited Methods : protected static boolean SendLogFileMessage ()
 *
 * Log File : LiveDB.ErrorLogFile
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method serves two purposes. One as an error logger which formats a very detailed
 * error message and returns a formatted String. Two it also serves purpose of a rudimentary easy to lookup
 * debugger for novice programmers. It can also serve purpose of error message standardization to log file
 * and also serve as a quality document for Quality control purposes. Last but not the least this can help
 * trace sabotage to a specific node name.
 *
 * It works like magic if you pass just the exception instance to it. It will pick an appropriate error mesg
 * and format it for you. You can set your own LiveDB.ALRTLVL before the call to grassHopper() but even if
 * you dont do that it will default to SYSADM. Feel free to add some more magic to this if you wish to. I
 * felt keeping it nice and bare minimal and simple would be ideal. For xample you can also process a
 * LiveDB.ALRTLVL in the same call.
 *
 * Before this method returns a formatted error message for printing it also flushes the LiveDB.ErrorLogFile
 * and mails out the most recent log file as an attachment by calling method SendLogFileMessage ()
 *
 * Technical Reference : Carry on Jeeves P.G Wodehouse (Pricey ........... )
 *
 * Start Date: 18th October 2010
 * End Date: 30th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    public static String grassHopper (Object... ex_Exception){
        
        int alrtlvl = LiveDB.ALRTLVL;

        // use the system beep
        if (alrtlvl == 7)
            for (int b = 0; b < 11; b++)
                 System.out.print("\007");


        // Use the motherboard buzzer this time around
        if (alrtlvl == 8)
            for (int b = 0; b < 23; b++)
                 Toolkit.getDefaultToolkit().beep();
        
        System.out.flush();

        // You can also used the javax.sound API libraries to play your own pre-recorded voice error
        // messages. I am running out of time now. Next release there will be a voice message for every
        // LiveDB.ALRTLVL;

        // this funny step because if some other thread has set LiveDB.ALRTLVL before calling grassHopper()
        // and I blindly reset it to zero here then that value set by other thread is lost. It can happen
        // in a few milliseconds so just to catch that little error margin even if you dont its one in a
        // Jillion
        LiveDB.ALRTLVL = LiveDB.ALRTLVL == alrtlvl ? 0:LiveDB.ALRTLVL;

        LiveDB.GrassHopperLock.acquireUninterruptibly();

        int ii = 0;
        String verbose = null;
        Exception EX = null;
        StackTraceElement st [] = Thread.currentThread().getStackTrace();       

        if (alrtlvl < 0 || alrtlvl > (LiveDB.AlertLabels.length - 1))
           alrtlvl = 6;

        if (ex_Exception.length > 0)
        {
            if (ex_Exception.length >= 2)
            {
                if (ex_Exception[0] instanceof String && ex_Exception[1] instanceof String)
                    verbose = String.valueOf(ex_Exception[0]);
                else if (ex_Exception[0] instanceof String)
                    verbose = String.valueOf(ex_Exception[0]);
                else if (ex_Exception[1] instanceof String)
                    verbose = String.valueOf(ex_Exception[1]);
                else if (ex_Exception[0] instanceof Exception && verbose == null)
                    EX = (Exception)ex_Exception[0];                              
                else if (ex_Exception[1] instanceof Exception && verbose == null)
                    EX = (Exception)ex_Exception[1];
                else verbose = LiveDB.ErrMesgs[0];
            }

            if (ex_Exception.length == 1)
                ii = 1;
            else ii = 2;

            for (int i = 0; i < ii ; i++)
            {
                if (ex_Exception[i] instanceof String)
                    verbose = String.valueOf(ex_Exception[i]);
                else if (ex_Exception[i] instanceof IOException)
                    EX = (IOException)ex_Exception[i];
                else if (ex_Exception[i] instanceof EOFException)
                    EX = (EOFException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ClosedChannelException)
                    EX = (ClosedChannelException)ex_Exception[i];
                else if (ex_Exception[i] instanceof OverlappingFileLockException)
                    EX = (OverlappingFileLockException)ex_Exception[i];
                else if (ex_Exception[i] instanceof NumberFormatException)
                    EX = (NumberFormatException)ex_Exception[i];
                else if (ex_Exception[i] instanceof IllegalArgumentException)
                    EX = (IllegalArgumentException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ArrayIndexOutOfBoundsException)
                    EX = (ArrayIndexOutOfBoundsException)ex_Exception[i];
                else if (ex_Exception[i] instanceof NullPointerException)
                    EX = (NullPointerException)ex_Exception[i];
                else if (ex_Exception[i] instanceof SecurityException)
                    EX = (SecurityException)ex_Exception[i];
                else if (ex_Exception[i] instanceof IllegalThreadStateException)
                    EX = (IllegalThreadStateException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ParseException)
                    EX = (ParseException)ex_Exception[i];
                else if (ex_Exception[i] instanceof ClassNotFoundException)
                    EX = (ClassNotFoundException)ex_Exception[i];
                else if (ex_Exception[i] instanceof InvalidClassException)
                    EX = (InvalidClassException)ex_Exception[i];
                else if (ex_Exception[i] instanceof StreamCorruptedException)
                    EX = (StreamCorruptedException)ex_Exception[i];
                else if (ex_Exception[i] instanceof OptionalDataException)
                   EX = (OptionalDataException)ex_Exception[i];
                else if (ex_Exception[i] instanceof MissingResourceException)
                   EX = (MissingResourceException)ex_Exception[i];
                else if (ex_Exception[i] instanceof AddressException)
                   EX = (AddressException)ex_Exception[i];
                else if (ex_Exception[i] instanceof MessagingException)
                   EX = (MessagingException)ex_Exception[i];
                else if (ex_Exception[i] instanceof IllegalAccessException)
                   EX = (IllegalAccessException)ex_Exception[i];
                else if (ex_Exception[i] instanceof InvocationTargetException)
                   EX = (InvocationTargetException)ex_Exception[i];
                else if (ex_Exception[i] instanceof NoSuchMethodException)
                   EX = (NoSuchMethodException)ex_Exception[i];
            }

            if (EX instanceof IOException)
            {
                LiveDB.ErrMesgNo = 1;
                if (alrtlvl == 0)
                   alrtlvl = 4;                
            }
            else if (EX instanceof MissingResourceException)
            {
                LiveDB.ErrMesgNo = 32;
                if (alrtlvl == 0)
                   alrtlvl = 2;
            }
            else if (EX instanceof ParseException)
            {
                LiveDB.ErrMesgNo = 25;
                if (alrtlvl == 0)
                   alrtlvl = 4;
            }
            else if (EX instanceof ClassNotFoundException)
            {
                LiveDB.ErrMesgNo = 28;
                if (alrtlvl == 0)
                   alrtlvl = 2;
            }
            else if (EX instanceof InvalidClassException)
            {
                LiveDB.ErrMesgNo = 29;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof StreamCorruptedException)
            {
                LiveDB.ErrMesgNo = 30;
                if (alrtlvl == 0)
                   alrtlvl = 4;
            }
            else if (EX instanceof OptionalDataException)
            {
                LiveDB.ErrMesgNo = 31;
                if (alrtlvl == 0)
                   alrtlvl = 6;
            }
            else if (EX instanceof UTFDataFormatException)
            {
                LiveDB.ErrMesgNo = 5;
                if (alrtlvl == 0)
                   alrtlvl = 4;                
            }
            else if (EX instanceof EOFException)
            {
                LiveDB.ErrMesgNo = 7;
                if (alrtlvl == 0)
                   alrtlvl = 4;                
            }
            else if (EX instanceof ClosedChannelException)
            {
                LiveDB.ErrMesgNo = 19;
                if (alrtlvl == 0)
                   alrtlvl = 7;                
            }
            else if (EX instanceof OverlappingFileLockException)
            {
                LiveDB.ErrMesgNo = 20;
                if (alrtlvl == 0)
                   alrtlvl = 7;                
            }
            else if (EX instanceof NumberFormatException)
            {
                LiveDB.ErrMesgNo = 17;
                if (alrtlvl == 0)
                   alrtlvl = 7;                
            }
            else if (EX instanceof IllegalAccessException)
            {
                LiveDB.ErrMesgNo = 45;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof InvocationTargetException)
            {
                LiveDB.ErrMesgNo = 47;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof NoSuchMethodException)
            {
                LiveDB.ErrMesgNo = 49;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof IllegalArgumentException)
            {
                LiveDB.ErrMesgNo = 16;
                if (alrtlvl == 0)
                   alrtlvl = 7;                
            }
            else if (EX instanceof ArrayIndexOutOfBoundsException)
            {
                LiveDB.ErrMesgNo = 21;
                if (alrtlvl == 0)
                   alrtlvl = 7;                
            }
            else if (EX instanceof NullPointerException)
            {
                LiveDB.ErrMesgNo = 22;
                if (alrtlvl == 0)
                   alrtlvl = 7;                
            }
            else if (EX instanceof AddressException)
            {
                LiveDB.ErrMesgNo = 33;
                if (alrtlvl == 0)
                   alrtlvl = 7;
            }
            else if (EX instanceof MessagingException)
            {
                if (st.length >= 4)
                {
                    if (st[3].getMethodName().indexOf("addRecipient") != -1)
                        LiveDB.ErrMesgNo = 34;
                    else if (st[3].getMethodName().indexOf("setSubject") != -1)
                        LiveDB.ErrMesgNo = 35;
                    else if (st[3].getMethodName().indexOf("setFrom") != -1)
                        LiveDB.ErrMesgNo = 36;
                    else if (st[3].getMethodName().indexOf("setContent") != -1)
                        LiveDB.ErrMesgNo = 37;
                    else if (st[3].getMethodName().indexOf("setText") != -1)
                        LiveDB.ErrMesgNo = 38;
                    else if (st[3].getMethodName().indexOf("setDataHandler") != -1)
                        LiveDB.ErrMesgNo = 39;
                    else if (st[3].getMethodName().indexOf("addBodyPart") != -1)
                        LiveDB.ErrMesgNo = 40;
                    else if (st[3].getMethodName().indexOf("setFileName") != -1)
                        LiveDB.ErrMesgNo = 41;
                    else if (st[3].getMethodName().indexOf("connect") != -1)
                        LiveDB.ErrMesgNo = 42;
                    else if (st[3].getMethodName().indexOf("sendMessage") != -1)
                        LiveDB.ErrMesgNo = 43;
                    else if (st[3].getMethodName().indexOf("close") != -1)
                        LiveDB.ErrMesgNo = 44;
                }
                else if (st.length == 0)
                {
                    LiveDB.ErrMesgNo = 0;
                    if (alrtlvl == 0)
                       alrtlvl = 3;
                    verbose = "getStackTrace() returns 0 elements enable JSM" + "\n";
                }
            }
            else if (EX instanceof SecurityException)
            {
                if (st.length >= 4)
                {
                    if (st[3].getMethodName().indexOf("checkRead") != -1)
                        LiveDB.ErrMesgNo = 9;
                    else if (st[3].getMethodName().indexOf("checkWrite") != -1)
                        LiveDB.ErrMesgNo = 10;
                    else if (st[3].getMethodName().indexOf("checkDelete") != -1)
                        LiveDB.ErrMesgNo = 12;
                    else if (st[3].getMethodName().indexOf("checkExec") != -1)
                        LiveDB.ErrMesgNo = 11;
                    else if (st[3].getMethodName().indexOf("checkAccess") != -1)
                        LiveDB.ErrMesgNo = 15;
                    else if (st[3].getMethodName().indexOf("Space") != -1)
                        LiveDB.ErrMesgNo = 14;
                }
                else if (st.length == 0)
                {
                    LiveDB.ErrMesgNo = 0;
                    if (alrtlvl == 0)
                       alrtlvl = 3;                    
                    verbose = "Thread.currentThread().getStackTrace() returns zero elements enable JSM" + "\n";
                }
            }
            else if (EX instanceof IllegalThreadStateException)
            {
                LiveDB.ErrMesgNo = 23;
                if (alrtlvl == 0)
                    alrtlvl = 6;               
            }
        } // if (ex_Exception.length > 0)        

        String PrintMesg = "LINE " +  ": " + LiveDB.logerrorno++
            + "DATE NOW:" + new Date().toString()
            + "\n" //1
            + "LOGGED AT NODENAME:" + LiveDB.NODENAME + " ALERTLEVEL:" + LiveDB.AlertLabels[alrtlvl] + ","
            + "\n" //2
            + "ERRMESG:" + LiveDB.ErrMesgs[LiveDB.ErrMesgNo]
            + "\n" //3
            +  " CLASS NAME :"
            + (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE":Thread.currentThread().getStackTrace()[2].getClassName())
            + "," + "METHOD NAME:" + (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE":Thread.currentThread().getStackTrace()[2].getMethodName()) + ","
            + "\n" //4
            + "EXCEPTION VALUE : " + (EX == null ? "UNAVAILABLE" : EX.toString())
            + "\n" //5
            + "SOURCE LINE NUMBER :"
            + (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE":String.valueOf(Thread.currentThread().getStackTrace()[2].getLineNumber()))
            + "THREADNAME :" + Thread.currentThread().getName() + " "
            + "THREAD TAKE OFF TIME:" + ThreadController.TakeOffTimes[ThreadController.getcurrenthread()].toString()
            + "\n" //6
            +  "THREAD PRIORITY:" + String.valueOf(Thread.currentThread().getPriority())
            + " THREAD GROUP:" + Thread.currentThread().getThreadGroup().getName() + "SOURCE CODE UNIT :"
            + (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE" : Thread.currentThread().getStackTrace()[2].getFileName())
            + "\n" //7
            + "THREAD STATE:" + String.valueOf(Thread.currentThread().getState())
            + "\n" //8
            + "STACK TRACE:" + (Thread.currentThread().getStackTrace().length == 0 ? "UNAVAILABLE" : Thread.currentThread().getStackTrace().length > 3 ?
            Thread.currentThread().getStackTrace()[2].getMethodName() + "," + Thread.currentThread().getStackTrace()[3].getMethodName() : Thread.currentThread().getStackTrace().length == 3
            ? Thread.currentThread().getStackTrace()[2].getMethodName():" ")
            + " OPERATING SYSTEM :" + LiveDB.OPERATINGSYSTEM + "OS VERSION :" + LiveDB.OSVERSION
            + "\n" //9
            + "JAVA VERSION:" + LiveDB.JAVAVER + " JAVA CLASS VERSION :" + LiveDB.JAVACLASSVERSION
            + "JAVA CLASS PATH:" + LiveDB.JAVACLASSPATH
            + "\n" //10
            + " JAVA VENDOR URL:" + LiveDB.JAVAVENDORURL
            + "\n" //11
            + "LOOK AT SESSION SPECIFIC ERRORLOGFILE NAME FOR DETAILS SUCH AS PID, COUNTRY NAME "
            + "\n" //12
            + "PROGRAM VERSION: " + LiveDB.versionControl.getProgramVersion() + " "
            + (LiveDB.versionControl.isSpecialRelease() ? "SPECIAL RELEASE":LiveDB.versionControl.isBetaRelease() ? "BETA RELEASE": "REGULAR RELEASE")
            + "\n" // 13
            + "RELEASE NUMBER:" + LiveDB.versionControl.getReleaseNumber() + " VERSION : "
            + LiveDB.versionControl.getVersionNumber() + " BUG FIX NUMBER : " + LiveDB.versionControl.getBugFixNumber()
            + " BUG FIX DATE :" + LiveDB.versionControl.getBugFixDate().toString()
            + "\n" // 14
            + "INTEGRATED RELEASE NAME :" + LiveDB.versionControl.getIntegratedReleaseName()
            + " DATABASE RELEASE NAME :" + LiveDB.versionControl.getDatabaseReleaseName()
            + " GUI RELEASE NAME :" + LiveDB.versionControl.getGUIReleaseName()
            + "\n" // 15
            + "APPLICATION NAME : " + LiveDB.versionControl.getApplicationName()
            + "\n" // 16
            + "SESSION ERRORLOGFILE:" + LiveDB.ErrorLogFile
            + "\n" //17
            + " LOCALE LANGUAGE:"
            + LiveDB.DefaultLocale.getDisplayLanguage() + " COUNTRY:" + LiveDB.COUNTRY
            + "\n" //18
            + "CONFIGURATION FILENAME:" + LiveDB.USRHOMEDIR + "photodbapp.conf"
            + "\n" //19
            + " USER NAME:" + LiveDB.USRNAME + "USER HOME DIR:" + LiveDB.USRHOMEDIR
            + "\n" //20
            + "WORKING USER DIRECTORY:" + LiveDB.USRDIR  + "END"
            + "\n" //21
            + "VERBOSE ERROR MESSAGE FOR DUMMIES GIVEN BELOW MAY BE MISSING IN SOME PLACES :"
            + "\n" //22
            + verbose == null ? "EXPLANATION:LOOK BELOW FOR SAME LINE NUMBER END VERBOSE": verbose 
            + "\n" //23
            + "END VERBOSE"
            + "\n" //24
            + "Print ErrorLog in Landscape mode on A4 plain paper" 
            + "\n" //25
            + " Suggested Paper Vendor:" + LiveDB.PAPERVENDOR
            + "\n" //26  // whatever prescribed format replace with locale ISO Executives Name
            + "ISO CONTROL DOCUMENT NUMBER PIG/SWINE/PORK/HAM/" + LiveDB.USRNAME;
            // Basically write a small method that will give you an iso control number and suffix it above
            // You know those iso pest control chaps dont you ??? any time you run out of meat in the
            // freezer for a sandwich you know where to get it !!!

        // To the Above you can add just one line of any extra information that you want to print
        // i need the other lines and i am using them also at some places in the source code.
        // It will be an exact fit on one page.

        LiveDB.ErrMesgNo = 0;
        LiveDB.GrassHopperLock.release();
        errfile.flush();
        
        
        // Now email the Logfiles to proprietor of company
        LiveDB.SendLogFileMessage();

        // I have commented this patch of code. You can un-comment it if you want and comment the line
        // above instead. The reason is that if there is an error you will have to increase the permits
        // for semaphore grassHopperLock to four. Also if there is some problem at the mail carrier end
        // such as gmail then SendLogFileMessage will return false and it will print another error mesg
        // thru another call to grassHopper which will obviously fail again. So it will go into a never
        // ending loop that wll behave like a runaway process and fill up your hard disk with a massive
        // log file overnight. So if we are living in a perfect world uncomment the line below and line
        // above can be commented.
        // if (LiveDB.SendLogFileMessage() == false)
        //    System.err.println(LiveDB.grassHopper("Error Emailing " + LiveDB.ErrorLogFile
        //                                                                      + " at System Exit"));

        return PrintMesg;
    }
    
  
/*
 * WIRING DIAGRAM :
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.pid, LiveDB.InterProcessSynchronization, LiveDB.QueueTrainsInWaiting()
 * @LOOKSY:LiveDB.SYNCOBJID, LiveDB.IPCSLOCK
 *
 * Method Name : protected static void IPCSTrigger (int ObjectNumber)
 * Parameters : None
 * Returns :None
 *
 * Calling Methods: only PlatformClearance constructor can call this method. If you wish to call this
 * from other methods do so at your own peril.
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary :This method is just a wrapper to instantiate advanced enum InterProcessSynchronization
 * But before that it acquires semaphore IPCSLOCK and then sets a critical global called SYNCOBJID to a valid
 * ObjectNumber (LiveDB.REALTABLES) or even a negative value. To better understand this read all documentation
 * for PlatformClearance.java, InterProcessSynchronization, LiveDB.QueueTrainsInWaiting()
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 30th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   protected static void IPCSTrigger (int ObjectNumber){
       IPCSLOCK.acquireUninterruptibly();
       SYNCOBJID = ObjectNumber;
       InterProcessSynchronization IPCS; // the actual Trigger instance
       IPCSLOCK.release();
   }


/*
 * WIRING DIAGRAM :
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.ALRTLVL, LiveDB.grassHopper()
 *
 * Method Name : public static boolean INSERT (int p_tbl, Object... p_vals )
 * Parameters : int p_tbl -- can only be cr, sc
 *              Object... p_vals -- Values for the  p_tbl row
 * Returns :boolean true if row was added to p_tbl
 *          boolean false if p_vals contains an invalid value or a wrong table number p_tbl
 *
 * Calling Methods: just about any method can call this.
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary :This method is just a wrapper to Insert rows into a table. Only two tables can
 * use this INSERT and those are CustomerRegister and ShoppingCart. This method will also validate
 * values before calling the constructor. The method will also add a ChangeTracker entry for the new
 * row and the ChangeTracker constructor will in turn take care of Index Updates.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   public static boolean INSERT (int p_tbl, Object... p_vals ){
       int i = 0;

       if (p_vals.length == 0)
       {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("No Values for INSERT"));
            return false;
       }

       if (p_tbl == cr )
       {
           switch (p_tbl)
           {
               case cr:
/*
                public CustomerRegister (String p_Cid, String p_Custname,
                       Date p_Custbirthdate, String p_Custbirthcity, String p_Custbirthstate,
                       String p_Custbirthnation, char p_Custsex, String p_Custmaritalstatus,
                       Date p_Custlogintime, Date p_Custlogouttime,Date p_Custregisterdate,
                       String p_Custaddr1, String p_Custaddr2, String p_Custaddr3, String p_Custaddr4,
                       String p_Landmark, String p_Custcity, String p_Custnation, String p_Custzip,
                       String p_Custemail, String p_Custphone, String p_Custfax, char p_Custflag, 
                       Date p_Custlastdate, long p_Rowid)
 */
                   // validate Object ... p_vals as per above constructor
                   if (!(p_vals[i] instanceof String)) // 1 String p_Cid
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 2  String p_Custname
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Date)) // 3 Date p_Custbirthdate
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 4 String p_Custbirthcity
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 5 String p_Custbirthstate
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 6 String p_Custbirthnation
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Character)) // 7 char p_Custsex
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 8 String p_Custmaritalstatus
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Date)) // 9 Date p_Custlogintime
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Date)) // 10  Date p_Custlogouttime
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Date)) // 11 Date p_Custregisterdate
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 12 String p_Custaddr1
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 13 String p_Custaddr2
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 14 String p_Custaddr3
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 15 String p_Custaddr4
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 16 String p_Landmark
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 17 String p_Custcity
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 18 String p_Custnation
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 19 String p_Custzip
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 20 String p_Custemail
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 21 String p_Custphone
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof String)) // 22 String p_Custfax
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Character)) // 23 char p_Custflag
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Date)) // 24  Date p_Custlastdate
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   i++;
                   if (!(p_vals[i] instanceof Long)) // 25  long p_Rowid
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Value for INSERT:" + String.valueOf(p_vals[0])));
                        return false;
                   }
                   LiveDB.LiveSharedDB[cr][LiveDB.LiveSharedDB[cr].length] =
                   new CustomerRegister ((String) p_vals[0], (String) p_vals[1],
                   (Date) p_vals[2], (String) p_vals[3], (String) p_vals[4],
                   (String) p_vals[5], (Character) p_vals[6], (String) p_vals[7],
                   (Date) p_vals[8], (Date) p_vals[9], (Date) p_vals[10],
                   (String) p_vals[11], (String) p_vals[12], (String) p_vals[13], (String) p_vals[14],
                   (String) p_vals[15], (String) p_vals[16], (String) p_vals[17], (String) p_vals[18],
                   (String) p_vals[19], (String) p_vals[20], (String) p_vals[21], (Character) p_vals[22],
                   (Date) p_vals[23], (Long) p_vals[24]);
                   // insert an entry in ChangeTracker table for this table
                   LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                   new ChangeTracker (cr,LiveDB.LiveSharedDB[cr].length -1, 'I', LiveDB.pid, new Date (),
                       LiveDB.LiveSharedDB[cr][(int)LiveDB.LiveSharedDB[cr].length -1],
                       (long)LiveDB.LiveSharedDB[ct].length);
                   // we are done
                   break;

               default:
                   break;
           }
       }
       else
       {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Insert not permitted in Table:" + String.valueOf(p_tbl)));
            return false;
       }
       
       return true;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.ALRTLVL, LiveDB.grassHopper()
 *
 * Method Name : public static <K,V> boolean UPDATE ( int p_tbl, K p_Key, V... p_Update )
 * Parameters : int p_tbl -- can only be cr, sc
 *              K p_Key -- The table key must be String
 *              V... p_Update --- Field Values for Update other than the KEY and some other fields
 *                                mentioned in the documentation below. Next release we will write
 *                                something better
 *
 * Returns :boolean true if row was UPDATED at p_tbl
 *          boolean false if p_Update contains an invalid value sequence or a wrong table number p_tbl
 *
 * Relevant Indexes :
 * LiveDB.indxcustomerRegister
 * searchkey = AnyValidCID
 * searchkey returns Long rowid in the table
 * 
 * LiveDB.indx1shoppingCart
 * searchkey = AnyValidCID + AnyValidPictureCode + toString(Opt_id) + toString(Sub_opt_id)
 * searchkey returns Long rowid in the table
 *
 * Calling Methods: just about any method can call this.
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary :This method is just a wrapper to Update rows into a table. Only two tables can
 * use this UPDATE and those are CustomerRegister and ShoppingCart. This method will also validate
 * values before calling the constructor. The method will also add a ChangeTracker entry for the new
 * row and the ChangeTracker constructor will in turn take care of Index Updates.
 *
 * WHEN YOU CALL THIS METHOD HELP ME A LITTLE V... p_Update -- pass them all as Object. If there are
 * some fields that you dont want to Update then pass them as null.
 * 
 * For example :- UPDATE (cr, "CID11", (Object)"Miguel Fernandez", (Object)new Date(), (Object)"Real Madrid",
 *                        (Object)"Catalan", (Object)"Spain", null, null, null, null, null, null, null, null,
 *                        null, null, null, null, null, null, null, null, null, null);
 * So right above you will find the count of fields starting Miguel to be wrong that is because two fields
 * are not allowed to be set so you dont pass those values either setCustregisterdate, setRowid. Also you
 * are not allowed to UPDATE the KEY which is field cid in CustomerRegister table.
 *
 * For the Shopping Cart table it is a similar call
 * For example: UPDATE(sc, "CID11PIC4015", (Object)3L, (Object)4L, (Object)2.0F, (Object)13L, null, null, null);
 * sc is the table number, "CID11PIC4015" is the Key for table Shopping Cart.
 * searchkey = AnyValidCID + AnyValidPictureCode + Sub_opt_id
 * The key is followed by values for fields to update. The fields that can be updated are restricted to
 * setPmtid,  setPic_qty, setTotal, setBilled, setShopdate, setOrdernumber, setOrderdiscount
 * As in the call above some values can be passed as null.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 * Last Modification Date : 15th September 2011
 * Due to changes in Schema of ShoppingCart table and its constructor the logic of case sc:
 * has changed a bit. Also the example above in the documentation was not very clear that
 * example documentation has been changed.
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   // this may not work properly V... p_Update dont know how erasure will handle this ?? This V may
   // result in a problem.
   // lets check during testing if it gets thru. That erasure mechanism is a whole bunch of bullshit
   public static <K,V> boolean UPDATE ( int p_tbl, K p_Key, V... p_Update ){

       // if there is certain value you dont want to update pass it as null or negative for numbers
       // V has to be the entire row or else we will have to hazard a long slow guess as to which column
       // the value belongs to. For example if V is a String then which column value would it be in
       // CustomerRegister table then we will have to write methods like isAddress(), isNation(),
       // isName() someone could have named their kid America or Britain or Britney !!
       // Whadoyoudo with such people.

       int rid = 0;
       int i = 0;

       if (p_tbl == cr)
       {
           switch(p_tbl){
               case cr:
                   if (LiveDB.indxcustomerRegister.get((String)p_Key) == null)
                   {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Invalid Update Key for CustomerRegister:" + String.valueOf(p_Key)));
                        return false;
                   }
                   else
                   {
                       // There is a private transient long fieldchanges in every table that we could use
                       // here for writing this method but it wont remain private any longer and that is
                       // not very desirable for ultra fast commits. You can use that flag if you want to.
                       // but you will need to turn on and off that specific bit and check it here in the
                       // code.
                       if (p_Update.length < 23)
                       {
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("Insufficient Update Values for CustomerRegister"));
                            return false;
                       }
               
                       rid = (int)(long)LiveDB.indxcustomerRegister.get((String)p_Key);
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 1
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustname((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof Date))
                           return false;
                       if (p_Update[i] != null) // 2
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustbirthdate((Date)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 3
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustbirthcity((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 4
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustbirthstate((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 5
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustbirthnation((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof Character))
                           return false;
                       if (p_Update[i] != null) // 6
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustsex((Character)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 7
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustmaritalstatus((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof Date))
                           return false;
                       if (p_Update[i] != null) // 8
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustlogintime((Date)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof Date))
                           return false;
                       if (p_Update[i] != null) // 9
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustlogouttime((Date)p_Update[i]);
                       i++;
                       // this is again a value we dont want un-educated users to set
                       //if (p_Update[i] != null) // 10
                       //((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustregisterdate((Date)p_Update[i]);
                       i++; // but do increment this
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 11
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustaddr1((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 12
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustaddr2((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 13
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustaddr3((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 14
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustaddr4((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 15
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setLandmark((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 16
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustcity((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 17
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustnation((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 18
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustzip((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 19
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustemail((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 20
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustphone((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof String))
                           return false;
                       if (p_Update[i] != null) // 21
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustfax((String)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof Character))
                           return false;
                       if (p_Update[i] != null) // 22
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustflag((Character)p_Update[i]);
                       i++;
                       if (p_Update[i] != null && !(p_Update[i] instanceof Date))
                           return false;
                       if (p_Update[i] != null) // 23
                       ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setCustlastdate((Date)p_Update[i]);
                       i++;
                       // This is one value we dont want the user to set just in case he ......
                       // if (p_Update[i] != null) // 24
                       // ((CustomerRegister)LiveDB.LiveSharedDB[cr][rid]).setRowid((Long)p_Update[i]);
                       // just make it one single ChangeTracker entry for all the sets since we are doing it all
                       // at the same time
                       // insert an entry in ChangeTracker table for this table
                       LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                       new ChangeTracker (cr,rid, 'U', LiveDB.pid, new Date (),
                       LiveDB.LiveSharedDB[cr][rid],
                       (long)LiveDB.LiveSharedDB[ct].length);
                       // okay we are done
                   }
                   break;
                 default:
                     break;
           }
       }
       else
       {
           LiveDB.ALRTLVL = 3;
           System.err.println(LiveDB.grassHopper("Invalid Table for UPDATE:" + String.valueOf(p_tbl)));
           return false;
       }
       return true;
   }


/*
 * WIRING DIAGRAM :
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.ALRTLVL, LiveDB.grassHopper()
 *
 * Method Name : public static boolean DELETE ( int p_Tableno, long p_Rowid )
 * Parameters : int p_Tableno -- can only be cr, sc, rt
 *              long p_Rowid --  the rowid to delete
 *
 * Returns :boolean true if row was added to p_tbl
 *          boolean false if p_vals contains an invalid value or a wrong table number p_tbl
 *
 * Calling Methods: just about any method can call this.
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary :This method is just a wrapper to DELETE rows from a table. Only three tables can
 * use this DELETE and those are CustomerRegister and ShoppingCart, ReportsTable. This method will just
 * mark the rows for deletion. The method will also add a ChangeTracker entry for the deleted row and
 * and the ChangeTracker constructor will in turn take care of Index removals.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   public static boolean DELETE ( int p_Tableno, long p_Rowid ){

        String searchkey = null;

        if (p_Rowid < LiveDB.LiveSharedDB[p_Tableno].length)
        {
            if (p_Tableno == cr ||  p_Tableno == rt)
            {
                // insert an entry in ChangeTracker table for this table
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (p_Tableno,p_Rowid, 'D', LiveDB.pid, new Date (),
                                   LiveDB.LiveSharedDB[p_Tableno][(int)p_Rowid],
                                   (long)LiveDB.LiveSharedDB[ct].length);
               // ChangeTracker will take care of Index Removal
            }
            else
            {
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Delete not allowed on Table Number:" + String.valueOf(p_Tableno)));
                return false;
            }
        }
        else
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Invalid rowid:" + String.valueOf(p_Rowid)
                    + " to delete from Table:" + String.valueOf(p_Tableno)));
            return false;
        }

        return true;
   }


/*
 * WIRING DIAGRAM :
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.pid
 *
 * Method Name : protected static void DECLARE_EMERGENCY ()
 * Parameters : None
 * Returns :None
 *
 * Calling Methods: Call it anywhere anytime but remember it is advisable only in certain circumstances
 * where the application cannot run at all due to data corruption etc.
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will setTable_lock ("E") for all rows (tables) in FileTableDataFileMap.
 * This will pause all running instances of this Application at all user terminals for LOCKWAITPERIOD and
 * when the pause time has exceeded LOCKWAITPERIOD it writes an error message and does a smooth exit from
 * the application. Look at FileTableDataFileMap.java protected void setTable_lock(String p_Table_lock).
 * You set that LiveDB.LOCKWAITPERIOD to your requirements.
 * During this pause period if you -- protected void setPid(long p_Pid) on FileTableDataFileMap
 * followed by a setTable_lock(String p_Table_lock) you can revoke emergency at run time itself.
 * But if it is your LiveDB.pid that declared emergency in the first place then you can revoke it at
 * run time simply by calling setTable_lock(String p_Table_lock) without a setPid(long p_Pid).
 * This may be a usefull feature during application programming. Dont overdo this setTable_lock()
 * I have it there only because some operating systems implement advisory locks only. It is not thread
 * safe at all. You will have put in some extra lines of programming to ensure thread safety.
 * This pause button may be usefull in certain peculiar circumstances where you want to apply the pause
 * based on certain conditions and then continue to check certain other conditions thru gets on tables.
 * In simple terms if your pid declares emergency then all other pids that are looking for that lock
 * will simply timeout and exit although slowly one at a time. So only your pid will be alive.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 30th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static void DECLARE_EMERGENCY (){
       
        for (int tbl = 0; tbl < LiveDB.LiveSharedDB[ft].length; tbl++)
        {
            /* EMERGENCY DECLARED BASIC FUNDAMENTAL RIGHTS DENIED */
            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tbl])).setTable_lock ("E");
            // insert an entry in ChangeTracker table for this table
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (ft,tbl, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[ft][tbl],
                (long)LiveDB.LiveSharedDB[ct].length);
            /* internal pid that set 'E' */
            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][tbl])).setPid (LiveDB.pid);
            // insert an entry in ChangeTracker table for this table
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (ft,tbl, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[ft][tbl],
                (long)LiveDB.LiveSharedDB[ct].length);
        }
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.pid, LiveDB.LOCKWAITPERIOD, LiveDB.LOCKWAITTIME
 *
 * Method Name : protected static void REVOKE_EMERGENCY ()
 * Parameters : None
 * Returns :None
 *
 * Calling Methods: Read the previous passage on protected static void DECLARE_EMERGENCY (). Okay
 * there is a pause period on declaration of emergency during which you can revoke emergency at run time
 * itself. So if the pause time which you define has lapsed then the application does a smooth exit.
 * Once the application does a smooth exit. The only way to revoke emergency is to use SYSADM command
 * $InstallDB FiXdAtAcOrRuPtIoN. Therefore the only calling method is threadleash run() method.
 * 
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will setTable_lock ("U") for all rows (tables) in FileTableDataFileMap.
 * If this is not done the application will start but will very soon exit at different terminals depending
 * on the LiveDB.LOCKWAITPERIOD that you have specified.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 30th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   protected static void REVOKE_EMERGENCY (){
        
        for ( int rw = 0; rw < LiveDB.LiveSharedDB[ft].length; rw++)
        {
            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][rw])).setTable_lock ("U");
            // insert an entry in ChangeTracker table for this table
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (ft,rw, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[ft][rw],
                (long)LiveDB.LiveSharedDB[ct].length);
            /* pid that unlocked */
            ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][rw])).setPid (LiveDB.pid);
            // insert an entry in ChangeTracker table for this table
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (ft,rw, 'U', LiveDB.pid, new Date (), LiveDB.LiveSharedDB[ft][rw],
                (long)LiveDB.LiveSharedDB[ct].length);
        }
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath,LiveDB.command_line
 *
 * Method Name : protected static void checkSpaceLeft ()
 * Parameters : None
 * Returns :None
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will check space left on disk. It checks usable space which is a more
 * accurate count than free space. Space will never get so short on a system unless you are running it off
 * a 2 GB Pen Drive OR There is some run-away process on the system which was running overnight etc.
 * 
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 25th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

  protected static void checkSpaceLeft ()
  {
       File sdp = new File (LiveDB.serializedfilespath);
       long usablebytes = sdp.getFreeSpace();
       long minspace = 1024 * 1024 * 100;
       // get usable space for this partition

       if (usablebytes == 0L)
       {
          JOptionPane.showMessageDialog(appframe, "The path you specified does not name a partition");
          
          System.exit(1);
       }
       else if (usablebytes < 1024 * 1000 * 1950)
       {
            if (LiveDB.command_line.equals("FileTableDataFileMap"))
            {
                JOptionPane.showMessageDialog(appframe, "The path/directory you specified has" + "\n" + " insufficient space for an INSTALL contact SYSADM ");
                
                JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
            }
            else
            {
                LiveDB.ALRTLVL = 10;
                System.err.println(LiveDB.grassHopper("Your Partition has only " + usablebytes + "free bytes" + " contact SYSADM"));
                if (usablebytes < minspace) // Look at only quantity of extra data that will be added in this Session in next write of any kind
                {
                    // Uncomment below line after writing createSpace method
                    // if (createSpace(1024 * 1000 * 500) < minspace) {
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);                   
                    JOptionPane.showMessageDialog(appframe, "DELETE OLD ERRORLOGFILES/REPORTFILES TO CREATE SPACE IMMEDIATELY");
                    System.exit(1);
                    // }
                    // Uncomment above line after writing createSpace method
                }
            }

            if (LiveDB.command_line.equals("FileTableDataFileMap"))
                System.exit(1);
        }
  }
  
/*
 * WIRING DIAGRAM :
 * @LOOKSY:
 * @LOOKSY:
 * @LOOKSY:
 * @LOOKSY:
 *
 * Parameters :
 *
 *
 * Running Commentary :
 *
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
 public long createSpace(long p_spaceneeded){
     
    // THIS METHOD WILL ONLY BE REQUIRED IF YOU ARE USING A 2GB PEN DRIVE
    // WITH 2GB IT WILL BE A TRIAL/DRY RUN FOR 3 MONTHS PLUS ON HEAVY USE
    // EVEN WITH 4GB THIS MAY BE USEFULL AND IT MAY RUN 6 MONTHS PLUS ON HEAVY USE
    // IF YOU HAVE 16GB AND ABOVE THERE ARE NO OUTOFSPACE ISSUES 
    // YOU WILL RUN ON 16 GB FOR 5 YEARS WITH HEAVY USAGE AND WEEKLY SYSADM PHYSICAL CLEANUP

    // if you run out of space change this LiveDB.serializedfilespath at run time
    // you need to monitor the space here in the database service and as a last minute
    // reaction to save the sictuation change the LiveDB.serializedfilespath
    // but this is not advisable unless you are very sure the application will collapse
    // do it only with table backups etc and then declare emergency
    // PAISA MUNGTA HAI
     
    long spc = 0L; // space created
    
    // First Delete Old ErrorLog Files from LiveDB.serializedfilespath
    // Then Delete Old Report Files from LiveDB.serializedfilespath

    // now delete all the files which are not directories in the temp area
    // check the size of each file before delete so that you delete the lowest
    // size files first and then the others. After each delete check if p_spaceneeded
    // criteria is met if so return with spc (space created).

    // if spaceneeded is still not met and there are still directories in the temp
    // area that can be deleted then delete the directory with the lowest possible
    // size first and then the rest. After every directory delete check if the
    // spaceneeded is met with if so return with spc (space created). Dont delete
    // more space than what is requested. Yes you may delete a file which results
    // in more space created than space needed but dont create any more space via
    // deletes.

    // Aquire a xclusive lock on each file before every delete and if the exclusive
    // lock throws an OverlappedFileLock Exception that file must be skipped and
    // must not be deleted.

    // Thou shall not delete any file or directory created under two hours ago. Anything
    // beyond two hours may be deleted. SysAdm may have done some download stored to temp
    // for some install purpose or other processes may have used temp for some purpose
    // so dont be a quick gun murugun

    return spc;
 }
 
/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstallDB.java
 * @LOOKSY:FileTableDataFileMap.java  -- Quick Look
 * @LOOKSY:ChangeTracker.java  -- Quick Look
 * @LOOKSY:CustomerRegister.java  -- Quick Look
 * @LOOKSY:ShoppingCart.java  -- Quick Look
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.LiveSharedDB, LiveDB.grassHopper()
 *
 * Method Name : protected static boolean DATABASE_ROLLBACK (Date p_upto)
 * Parameters : Date p_upto  -- upto this date
 *
 * Returns : boolean true if tables CustomerRegister and/or ShoppingCart were rolled back
 *           boolean false if all users could not be kicked out
 *
 * Method Called From : InstallDB.java method private static void threadLaunch()
 *
 * Asociated Methods : LiveDB::protected static boolean AllUsersKickedOut ()
 *
 * Relevant Indexes :
 * LiveDB.indxchangeTracker -- Is there a ChangeTracker entry for a given tableno and rowid ?
 * searchkey = toString(AnyRealTableno) + toString(AnyRowid)
 * searchkey returns Long ctrowid which is the rowid for the ChangeTracker table.
 * This is a dual purpose index and so
 * searchkey = toString(AnyRealTableNo) -- Is there an entry for this tableno in ChangeTracker ?
 * searchkey returns Long the same tableno
 *
 * LiveDB.indxcustomerRegister
 * searchkey = AnyValidCID
 * searchkey returns Long rowid in the table
 *
 * LiveDB.indx1shoppingCart
 * searchkey = AnyValidCID + AnyValidPictureCode + toString(Opt_id) + toString(Sub_opt_id)
 * searchkey returns Long rowid in the table
 * LiveDB.indx2shoppingCart  -- This second index is meant to identify unique CID's IN ShoppingCart table
 * searchkey = AnyValidCID   -- The second index is an ODDBALL index
 * searchkey returns Long rowid in the table
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Only two tables qualify for Database RollBack tables 2,3 (cr,sc) -- CustomerRegister,
 * ShoppingCart. Use this with caution it is meant to repair Database in case some wrong transactional logic
 * has been committed already or some erroneous data has been loaded using FixDataCorruption command. Please
 * be carefull while using this database rollback. You have to specify that time correctly after carefully 
 * analyzing your transaction logic. Because I am blindly nullifying those rows totally un-aware of the 
 * transaction logic that caused those rows to be there. You would be better off deleting rows within your 
 * transaction logic but if something really goes wrong such as data corruption to just a transaction worth 
 * of records use this. All we do here is take that p_upto and until that we nullify those rows. It will only
 * do a Database Rollback comitted transactions which have not been RolledForward 'J' or 'R' RolledBack 
 * Already so if that point is met in the records of the database it will stop there and ignore p_upto.
 * Use this with greatest caution it has the ability to screw up the database nice and proper. Dont ask me
 * to guess your transactional logic nobody can do that for you.
 *
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 30th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean DATABASE_ROLLBACK (Date p_upto){

       Object thisentirerow = null; // for cloning purposes

       if (LiveDB.AllUsersKickedOut() == false)
       {
           System.err.println(LiveDB.grassHopper("Retried 126 times. All Users have not logged out. Try Shooting !"));
           return false;
       }
       int ctr = 0;

       // refresh it always shubh arambh
       ((CustomerRegister)LiveDB.LiveSharedDB[ct][ctr]).REFRESH();
       // march backwards
       for (int rw = LiveDB.LiveSharedDB[cr].length -1; rw >= 0; rw--)
       {

           if (LiveDB.indxchangeTracker.get(Integer.toString(cr) + Integer.toString(rw)) != null )
           {
               // get the rowid in ChangeTracker using index for table and row
               ctr = (int) (long) LiveDB.indxchangeTracker.get(Integer.toString(cr) + Integer.toString(rw));

               if (((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getOldchangeflag() == 'R' ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'J' ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'K' ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'T' )
                   break; // ignore date/time supplied by user break from loop we cant proceed further

               // he wanted it rolled back upto that date and after it if before that date break
               if (((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getDmldate().compareTo(p_upto) < 0)
                   break;

               if (((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'F'
                   || ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getChange_flag() == 'C' )
               {
                    // we will just nullify those rows simply use this with greatest caution
                    // it has the ability to screw up the database nice and proper
                    
                    thisentirerow = ((CustomerRegister)LiveDB.LiveSharedDB[cr]
                            [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getRowid()]).clone();

                    LiveDB.LiveSharedDB[cr]
                            [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getRowid()] = null;

                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (cr, ((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getRowid(),
                        'K', LiveDB.pid, new Date (), (CustomerRegister)thisentirerow,
                        (long)LiveDB.LiveSharedDB[ct].length);

                    if (LiveDB.indxcustomerRegister.remove(((CustomerRegister)thisentirerow).getCid()) == null)
                    {
                        LiveDB.ALRTLVL = 4;
                        System.err.println(grassHopper("indxcustomerRegister remove fail"
                        + " for DB RollBack of CustomerRegister Rowid:"
                        + String.valueOf(((ChangeTracker)LiveDB.LiveSharedDB[ct][ctr]).getRowid())));
                    }
               }               
           }
       } 

       ctr = 0;
       
       LiveDB.system_exit = 1;
       LiveDB.SmoothExitCondition.signalAll();

              // Take a good look at protected static boolean AllUsersKickedOut ()
       // for an explanation of the lines of code below
       try{
           LiveDB.Xclusive.release();
           LiveDB.FOS.close();
       }catch (IOException ex_NOKIA71){
           System.err.println(LiveDB.grassHopper(ex_NOKIA71, "Suggested O/S Vendor:" + LiveDB.OSVENDORNAME));
       }
       
       return true;
   }

   
/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.tablenameidentifier
 *
 * Method Name : protected static boolean restoreMostRecent (int tbl, File bd, File rf, Boolean bkupcopyused,
 *                                                           Boolean oldbkupcopyused, String... p_fn)
 * Parameters : int tbl  --  zero thru LiveDB.REALTABLES
 *              File bd  -- backup directory
 *              File rf  -- The restore file (.res file)
 *              Boolean bkupcopyused   -- This will be set by call to restoreBkups() method
 *              Boolean oldbkupcopyused -- This will be set by call to restoreBkups() method
 *              String... p_fn  -- Optional or just a single filename without path
 *
 * Returns : boolean true if method successfully restores the most recent or some backup file
 *           boolean false if restoreBkups () method returns false.
 *
 * Chained Methods : None
 *
 * Associated Methods :
 *           LiveDB::private static boolean restoreBkups (Boolean bkupcopyused, Boolean oldbkupcopyused,
 *                                                                                            String fn)
 *           LiveDB::protected static boolean CopyFile (String p_fromfile, String p_to_file)
 *
 * Data File : .res files, .dsk.bkp files, .dsk.bkp.old files
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method just restores meaning copies the ".res" files for the table to ".ser"
 * file for the table provided the lastModified time stamp on the file is greater than or equal to the
 * time stamp on the autobackup file. If that is not true it tries to restore backups.
 *
 * Technical Reference : Buy and Read Tin Tin in America
 *
 * Start Date: 18th October 2010
 * End Date: 23rd May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean restoreMostRecent (int tbl, File bd, File rf, Boolean bkupcopyused, 
                                               Boolean oldbkupcopyused, String... p_fn)
   {

        if ( tbl < 0 || tbl > LiveDB.REALTABLES)
        {
            System.err.println(LiveDB.grassHopper("Invalid Table to restore " + tbl));
            return false;
        }

        String tn = null;
        // this is the autobackup file which could be more recent than the restore file itself !!
        File abk = new File (LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
        ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + ".ser" + ".dsk" + ".bkp");

        String fn = (p_fn.length == 0 ? ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename():p_fn[0]);

        for (int i = 0; i < LiveDB.tablenameidentifier.length; i++)
        {
            if (Integer.parseInt(LiveDB.tablenameidentifier[i][0]) == tbl)
                tn = LiveDB.tablenameidentifier[i][1];
        }

        if (rf.exists() && rf.lastModified() >= abk.lastModified())
        {
            if (LiveDB.CopyFile(LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR + fn + ".ser" + ".res",
                    LiveDB.serializedfilespath + fn + ".ser") == false)
            {
                // are we out of usable space ??
                if (bd.getUsableSpace() < rf.length())
                {
                    LiveDB.ALRTLVL = 10;
                    System.err.println(LiveDB.grassHopper("cannot restore " + tn + " post database crash"));
                    JOptionPane.showMessageDialog(appframe, "OUTOFSPACE in " + "\n" + LiveDB.serializedfilespath + "\n" +
                                " create space, reload application or database reconstruct");
                    JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
                    System.exit(1);
                }
            }
            else return true;
        }

        // try the backup file

        if (restoreBkups(bkupcopyused, oldbkupcopyused, fn) == false)
        {
            LiveDB.ALRTLVL = 12;
            System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
            return false;
        }

        return true;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.tablenameidentifier
 *
 * Method Name : private static boolean restoreBkups (Boolean bkupcopyused, Boolean oldbkupcopyused,
 *                                                                                                String fn)
 * Parameters : Boolean bkupcopyused  -- will be set
 *              Boolean oldbkupcopyused -- will be set
 *              String fn -- filename without path
 *
 * Returns : boolean true if method successfully restores the backup file or old backup file
 *           boolean false if there is a copy error.
 *
 * Chained Methods : private static boolean restoreBkups (Boolean bkupcopyused, Boolean oldbkupcopyused,
 *                                                                                                String fn)
 *
 * Associated Methods : LiveDB::protected static boolean CopyFile (String p_fromfile, String p_to_file)
 *
 * Data File : .dsk.bkp files, .dsk.bkp.old files
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method just restores meaning copies the ".dsk.bkp", ".dsk.bkp.old" files for
 * the table to ".ser" file for the table.
 *
 * Technical Reference : Buy and Read Tin Tin in America
 *
 * Start Date: 18th October 2010
 * End Date: 23rd May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   private static boolean restoreBkups (Boolean bkupcopyused, Boolean oldbkupcopyused, String fn){

        String backup = "backup" + LiveDB.FILESEPERATOR;

        if (LiveDB.CopyFile(LiveDB.serializedfilespath + backup + fn + ".ser" + ".dsk" + ".bkp", LiveDB.serializedfilespath + fn + ".ser") == false)
        {
            // there is still a problem with CopyFile so lets retry again with old backup
            if (LiveDB.CopyFile(LiveDB.serializedfilespath + backup + fn + ".ser" + ".dsk" + ".bkp" + ".old",LiveDB.serializedfilespath + fn + ".ser") == false)
            {
                if (new File(LiveDB.serializedfilespath + backup + fn + ".ser" + ".dsk" + ".bkp" + ".old").exists() == true)
                {
                    LiveDB.ALRTLVL = 13;
                    System.err.println(LiveDB.grassHopper("Suggested Hard Disk Vendor" + LiveDB.DISKVENDOR));
                    return false;
                }
                return false;
             }
             else
                  oldbkupcopyused = true;
         }
         else
              bkupcopyused = true;

         return true;
   }

   
/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:LanguageSupport.java
 * @LOOKSY:LanguageTitles.java
 * @LOOKSY:LanguageTransalations.java
 * @LOOKSY:PaymentType.java
 * @LOOKSY:PictureDatabase.java
 * @LOOKSY:SearchDatabase.java
 * @LOOKSY:DefaultAdvertisingImages.java
 * @LOOKSY:ArtLeaves.java
 * @LOOKSY:CrashRecovery.java
 * @LOOKSY:ReportsTable.java
 * @LOOKSY:CelebrityTable.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean useOutDatedBkups (int tbl, Boolean bkupcopyused,
 *                                                              Boolean oldbkupcopyused, String... p_fn)
 * Parameters : int tbl -- Self Explanatory
 *              Boolean bkupcopyused  -- has backup copy been used ?
 *              Boolean oldbkupcopyused -- has old backup copy been used ?
 *              String... p_fn -- Not being used currently in calling methods. If used just filename
 *                                without path.
 *
 * Returns : boolean true if method successfully restores the backup file or old backup file and then
 *           does a successfull REFRESH on all tables and validate on some tables only
 *           boolean false if there is a copy error.
 *
 * Chained Methods : None
 *
 * Associated Methods : LiveDB::protected static boolean CopyFile (String p_fromfile, String p_to_file)
 *                      LiveDB::protected static boolean validateFileTableDataFileMap(Integer... dummy)
 *                      LiveDB::protected static boolean validateChangeTracker ()
 *
 * Data File : .dsk.bkp files, .dsk.bkp.old files
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method just restores meaning copies the ".dsk.bkp", ".dsk.bkp.old" files for
 * the table to ".ser" file for the table. It checks a couple of flags if oldbkupcopyused then returns false.
 * If bkupcopyused == false it tries to copy the .dsk.bkp files for the table to ".ser" files.
 * if (bkupcopyused || bkupcopyfailed) then it tries to restore the old backup. Having restore some backup
 * it tries to REFRESH the table. If the table is ft(0) or ct(1) it calls validateFileTableDataFileMap(),
 * validateChangeTracker()
 *
 * Technical Reference : Buy and Read Tun Tun in America (North Indian Beauty)
 *
 * Start Date: 18th October 2010
 * End Date: 23rd May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean useOutDatedBkups (int tbl, Boolean bkupcopyused, Boolean oldbkupcopyused, String... p_fn)
   {
        String backup = "backup" + LiveDB.FILESEPERATOR ;

        boolean bkupcopyfailed = false;
        String fn = (p_fn.length == 0 ? ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + ".ser" :p_fn[0]);

        if (oldbkupcopyused)
        {
             LiveDB.ALRTLVL = 4;
             System.err.println(LiveDB.grassHopper("post crash refresh of table no:" + String.valueOf(tbl) +  "failed try reconstruct"));
             return false;
        }
        else if (bkupcopyused == false)
        {
            // then try copying the auto backup and then refresh again
            if (LiveDB.CopyFile(LiveDB.serializedfilespath + backup + fn + ".ser" + ".dsk" + ".bkp",
                                                        LiveDB.serializedfilespath + fn + ".ser") == false)
            {
                if (new File(LiveDB.serializedfilespath + backup + fn + ".ser" + ".dsk" + ".bkp").exists()
                                                                                                   == true)
                {
                     LiveDB.ALRTLVL = 3;
                     System.err.println(LiveDB.grassHopper("Disk Failure Suggested Hard Disk Vendor" + LiveDB.DISKVENDOR));
                     return false;
                 }
                 bkupcopyfailed = true;
            }
        } // else if (bkupcopyused == false)

        if (bkupcopyused || bkupcopyfailed)
        {
            // then try copying the old backup and then refresh again
            if (LiveDB.CopyFile(LiveDB.serializedfilespath + backup + fn + ".ser" + ".dsk" + ".bkp" + ".old",
                                                       LiveDB.serializedfilespath + fn + ".ser") == false)
            {
                if (new File(LiveDB.serializedfilespath + backup + fn + ".ser" + ".dsk" + ".bkp" + ".old").exists() == true)
                {
                     LiveDB.ALRTLVL = 13;
                     System.err.println(LiveDB.grassHopper("Suggested Hard Disk Vendor" + LiveDB.DISKVENDOR));
                     return false;
                 }
                 return false;
            }
        }

        if (tbl == it)
        {
            if (((InstalledTables)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh of InstalledTables failed try reconstruct"));
                return false;
            }
            // dont validate InstalledTables here 
        }
        else if (tbl == ft)
        {
            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh FileTableDataFileMap failed try reconstruct"));
                return false;
            }
            if (validateFileTableDataFileMap() == false) return false;
        }
        else if (tbl == ct)
        {
            if (((ChangeTracker)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh of ChangeTracker failed try reconstruct"));
                return false;
            }
            if (validateChangeTracker() == false) return false;
            // we can use a corrupted change tracker and proceed but there is a quick repair command
            // so validate it and return false if corrupted
       }
       else if (tbl == cr)
       {
            if (((CustomerRegister)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh CustomerRegister fail try reconstruct"));
                return false;
            }
            // dont ever validate master detail relationships otherwise in case of a partial recovery
            // like PearlHarbor the database will go up for two minutes and go down again !!!
       }

       else if (tbl == crr)
       {
            if (((CrashRecovery)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh CrashRecovery fail try reconstruct"));
                return false;
            }
       }
       else if (tbl == pc)
       {
            if (((PlatformClearance)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh PlatformClearance fail try reconstruct"));
                return false;
            }
       }

       else if (tbl == rt)
       {
            if (((ReportsTable)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh ReportsTable fail try reconstruct"));
                return false;
            }
       }
       else if (tbl == ls)
       {
            if (((LanguageSupport)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh LanguageSupport fail try reconstruct"));
                return false;
            }
       }
       else if (tbl == lt)
       {
            if (((LanguageTitles)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh LanguageTitles fail try reconstruct"));
                return false;
            }
       }

       else if (tbl == pt)
       {
            if (((PaymentType)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh PaymentType fail try reconstruct"));
                return false;
            }
       }

       else if (tbl == sd)
       {
            if (((SearchDatabase)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh SearchDatabase fail try reconstruct"));
                return false;
            }
       }
       else if (tbl == da)
       {
            if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh DefaultAdvertisingImages fail try reconstruct"));
                return false;
            }
       }
       else if (tbl == ar)
       {
            if (((ArtLeaves)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
            {
                LiveDB.ALRTLVL = 14;
                System.err.println(LiveDB.grassHopper("post crash refresh ArtLeaves fail try reconstruct"));
                return false;
            }
       }
        
       return true;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.LiveSharedDB
 *
 * Method Name : protected static boolean fake_database_check ()
 * Parameters : None
 *
 * Returns : boolean true if fake database
 *           boolean false if authentic database
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to check if the database is real. It is a quick flimsy check.
 * Basically the outsize in InstalledTables must match the length of the file on disk to be authentic.
 * Wait until next release. I will have to use Certificates and plug in an evil personalised signature
 * into the Externalizable files since those write just data and there is no metadata in that file. I
 * will have to encrypt that signature and decrypt that signature via dynamic linking.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   protected static boolean fake_database_check (){
       // dont call this in dbfRepair since it may be a partial recovery
       // for an extensive check wait next release where an evil signature will be written at Random
       // to each database file which will be difficult to decrypt (256 bits). The decrypt key will
       // be supplied to you and if you loose it you had it.
       for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++)
       {
            if (((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getOutsize() !=
                new File(((FileTableDataFileMap)LiveDB.LiveSharedDB[ft]
                [(int)((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getTableno()]).getFilename()).length())
                return true;
       }
       return false;
       // CERTIFICATE CHECK IN NEXT RELEASE
       // Anyways certificate checks will need signatures and I am using Externalizable which
       // contains just the data and nothing else. So just a few of those SerializeJustOnce tables
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean validateFileTableDataFileMap(Integer... dummy)
 * Parameters : Integer... dummy  ---- dummy parameter. Originally this method was a part of InstallDB
 *                                     class and there were two such methods with identical names and
 *                                     return values. So to differentiate for overloading i pluuged in
 *                                     a dummy parameter which can still be used to visually differentiate
 *                                     between the two calls in the source code.
 *
 * Returns : boolean true if method successfully validated all fields of table FileTableDataFileMap
 *           boolean false if there is a invalid data contained in the table FileTableDataFileMap.
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method does quick check to validate data contained in FileTableDataFileMap.
 *
 * Technical Reference : Buy and Read Tun Tun in America (North Indian Beauty)
 *
 * Start Date: 18th October 2010
 * End Date: 24th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean validateFileTableDataFileMap(Integer... dummy)
   {        
        boolean ok = false;        

        if (LiveDB.LiveSharedDB[ft].length >= 0 && LiveDB.LiveSharedDB[ft].length < LiveDB.REALTABLES + 1)
        {
            System.err.println(LiveDB.grassHopper("Tables in FileTableDataFileMap != LiveDB.REALTABLES + 1"));
            return false;
        }

        if (LiveDB.LiveSharedDB[ft].length > LiveDB.REALTABLES + 1)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Tables in FileTableDataFileMap post restore > LiveDB.REALTABLES"));
            return false;
        }

        for (int row = 0, tbl = 0; row < LiveDB.LiveSharedDB[ft].length; row++, tbl++)
        {
            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getTableno() != tbl)
                return false;
            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getRowid() != row)
                return false;
            if (new File(((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getDatafilename()).exists() == false)
                return false;
            if (new File(((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getDatafilename()).isFile() == false)
                return false;
            if (new File(((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getDatafilename()).length() == 0)
            {
                if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getTableno() != cr
                   && ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getTableno() != cp
                   && ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getTableno() != id
                   && ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getTableno() != crr )
                      return false;
            }
            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getFilename().length() < 4)
                return false;
            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getFilename().
                    indexOf(LiveDB.serializedfilespath) != -1)
                return false;
            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][row]).getTable_lock().length() > 1)
                return false;
        }
        return true;
   }


/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean validateChangeTracker ()
 * Parameters : None
 *
 * Returns : boolean true if method successfully quick validated fields of table ChangeTracker
 *           boolean false if there is invalid data contained in table ChangeTracker.
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method does quick check to validate data contained in ChangeTracker.
 *
 * Technical Reference : Buy and Read Tun Tun in America (North Indian Beauty)
 *
 * Start Date: 18th October 2010
 * End Date: 24th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean validateChangeTracker (){
               
        if (LiveDB.command_line.equals("FileTableDataFileMap"))
            return true;
        
        // This is not a complete validate since ChangeTracker can contain entries of all Tables
        // at Install time but we dont call this function at Install time.
        // this will take a very long time if ChangeTracker table is extremely large
        for (int rw = 0; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
            if ((((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == ft &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof FileTableDataFileMap))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == ct &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof ChangeTracker))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == cr &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof CustomerRegister))               
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == crr &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof CrashRecovery))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == it &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof InstalledTables))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == rt &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof ReportsTable))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == pc &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof PlatformClearance))               
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == pt &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof PaymentType))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == lt &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof LanguageTitles))               
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == ar &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof ArtLeaves))               
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == sd &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof SearchDatabase))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == ls &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof LanguageSupport))
               || (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == da &&
                !(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof DefaultAdvertisingImages))
               )
                  return false;

            switch ((int)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno()){
                case ft:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((FileTableDataFileMap)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case ct:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((ChangeTracker)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case cr:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((CustomerRegister)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;

                case ls:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((LanguageSupport)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;

                case pt:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((PaymentType)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;

                case lt:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((LanguageTitles)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;

                case ar:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((ArtLeaves)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case sd:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((SearchDatabase)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case da:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((DefaultAdvertisingImages)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case crr:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((CrashRecovery)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case it:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((InstalledTables)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case rt:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((ReportsTable)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case ni:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((NodalInfo)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case id:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((InstallerDues)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case cp:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((CustomerPayments)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                case ll:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((LatLongMap)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                
                case pc:
                    if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid() !=
                       ((PlatformClearance)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow())
                            .getRowid())
                    {
                        LiveDB.ALRTLVL = 7;
                        System.err.println(LiveDB.grassHopper("rowid in ChangeTracker dont match rowid in EntireRow"));
                        return false;
                    }
                    break;
                default:
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Invalid tableno in ChangeTracker"));
                    break;
            } // switch

        } // for (int rw = 0; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        
        return true;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.LiveSharedDB
 *
 * Method Name : protected static boolean IsFSCKNeeded()
 * Parameters : None
 *
 * Returns : boolean true if fsck() needed
 *           boolean false if fsck() not required
 *
 * Asociated Methods : LiveDB::protected static boolean validateFileTableDataFileMap(Integer... dummy)
 *                     LiveDB::protected static boolean validateChangeTracker ()
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method does quick check for negative Outsize to determine if fsck() is
 *                      really needed. It also validates FileTableDataFileMap and ChangeTracker. This
 *                      is a very usefull method which CAN be called before every writeExternal to
 *                      quickly detect any problems during serialization.
 *
 * Technical Reference : Buy and Read Tun Tun in America (North Indian Beauty)
 *
 * Start Date: 18th October 2010
 * End Date: 24th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   protected static boolean IsFSCKNeeded(){

        for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++)
        {
            if (((InstalledTables)LiveDB.LiveSharedDB[it][rw]).getOutsize() < 0)     
                 return true;
        } // for (int rw = 0; rw < LiveDB.LiveSharedDB[it].length; rw++)

        if (LiveDB.validateFileTableDataFileMap(9) == false)
            return true;

        if (LiveDB.validateChangeTracker() == false)
            return true;

        return false;
   }

   protected static boolean PearlHarbour (){
       // This is the Ultimo of Crashes to be detected in next release
       // if everything is destroyed and the ........... comes back with
       // just his limbs we could partial recover but it may be a futile
       // effort because the database may go up and down like Newtons Law.
       // If this is sensed then you will find a UOWEME file which is a
       // Invoice @ USD $80 per KB recovered.
       
       return true;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.LiveSharedDB, LiveDB.wanted_rows
 *
 * Method Name : protected static boolean QuickRepairChangeTracker ()
 * Parameters : None
 * Returns : boolean true if ChangeTracker has been quick repaired
 *           boolean false if errors at any stage
 *
 * Relevant Indexes : LiveDB.indxchangeTracker
 *
 * Asociated Methods : LiveDB::protected static boolean validateFileTableDataFileMap(Integer... dummy)
 *                     LiveDB::protected static boolean validateChangeTracker ()
 *
 * Data File : NONE
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is a SYSADM command. What it does is a quick repair of ChangeTracker
 * table which is the most critical table on LevsView. Use this command only as an action of last resort.
 * What this method does is to toss out all corrupted entries in the ChangeTracker and retain only the
 * good ones. So this will at best help in an inconsistent partial recovery of the database which may
 * be a futile effort.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean QuickRepairChangeTracker (){
       
        boolean ok = true;

        if (LiveDB.LiveSharedDB[ct].length == 0)
            return false;

        LiveDB.wanted_rows = null;

        if (LiveDB.AllUsersKickedOut() == false)
        {
            System.err.println(LiveDB.grassHopper("Retried 126 times. All Users have not logged out. Try Shooting !"));
            return false;
        }
        
        // this will take a very long time if ChangeTracker table is extremely large
        for (int rw = 0, i = 0; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == ft &&
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof FileTableDataFileMap)
             {
                if (((FileTableDataFileMap)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow()).getRowid()
                   == ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid())
                {
                   LiveDB.wanted_rows[i] = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).clone();
                   i++;
                }
                else ok = false;
             }
             else ok = false;

             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == ct &&
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof ChangeTracker)
             {
                if (((ChangeTracker)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow()).getCtrowid()
                   == ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid())
                {
                   LiveDB.wanted_rows[i] = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).clone();
                   i++;
                }
                else ok = false;
             }
             else ok = false;

             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == cr &&
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof CustomerRegister)
             {
                if (((CustomerRegister)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow()).getRowid()
                   == ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid())
                {
                   LiveDB.wanted_rows[i] = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).clone();
                   i++;
                }
                else ok = false;
             }
             else ok = false;



             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == crr &&
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof CrashRecovery)
             {
                if (((CrashRecovery)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow()).getCrrowid()
                   == ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid())
                {
                   LiveDB.wanted_rows[i] = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).clone();
                   i++;
                }
                else ok = false;
             }
             else ok = false;

             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == it &&
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof InstalledTables)
             {
                if (((InstalledTables)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow()).getRowid()
                   == ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid())
                {
                   LiveDB.wanted_rows[i] = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).clone();
                   i++;
                }
                else ok = false;
             }
             else ok = false;

             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == rt &&
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof ReportsTable)
             {
                if (((ReportsTable)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow()).getRowid()
                   == ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid())
                {
                   LiveDB.wanted_rows[i] = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).clone();
                   i++;
                }
                else ok = false;
             }
             else ok = false;

             if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() == pc &&
                ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow() instanceof PlatformClearance)
             {
                if (((PlatformClearance)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getEntirerow()).getRowid()
                   == ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid())
                {
                   LiveDB.wanted_rows[i] = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).clone();
                   i++;
                }
                else ok = false;
             }
             else ok = false;
        } // for

        // now renumber the ctrowid
        for (int rw = 0; rw < LiveDB.LiveSharedDB[ct].length; rw++)
            ((ChangeTracker)LiveDB.wanted_rows[rw]).setCtrowid((long)rw);

        if (LiveDB.wanted_rows.length != 0)
        {
            for (int rw = 0; rw < LiveDB.wanted_rows.length; rw++)
                 LiveDB.LiveSharedDB[ct][rw] = ((ChangeTracker)LiveDB.wanted_rows[rw]).clone();
        }
        else return ok;

        boolean ok1 = false;

        ok = ok == false ? false : (ok1 = ((ChangeTracker)LiveDB.LiveSharedDB[ct][0]).COMMIT());

        if (ok1 == false)
        {
            System.err.println("ChangeTracker table commit failed");
            return ok1;
        }

        String searchkey = null;
        Long value = 0L;

        // rebuild the indexes post QuickRepair
        LiveDB.indxchangeTracker.clear();
        for (int rw = 0; rw < LiveDB.LiveSharedDB[ct].length; rw++)
        {
             searchkey = Integer.toString((int)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno())
                                + Long.toString(((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getRowid());
             value = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getCtrowid(); /* take the rowid of ChangeTracker table */
                   /* do a put into the HashMap */
             LiveDB.indxchangeTracker.put(searchkey,value);
                   // this is a dual purpose index
                   // you can search for a tableno OR what is above in searchkey
                   // prefereably define those HashMaps as <String>, <Long> to be used as multiple
                   // purpose indexes such as this .. you can use it for n different purposes but
                   // overdoing it is fraught with danger
             searchkey = Integer.toString((int)((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno());
             value = ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getTableno() ;
             LiveDB.indxchangeTracker.put(searchkey,value);
        }

       // Take a good look at protected static boolean AllUsersKickedOut ()
       // for an explanation of the lines of code below
       try{
           LiveDB.Xclusive.release();
           LiveDB.FOS.close();
       }catch (IOException ex_NOKIA71){
           System.err.println(LiveDB.grassHopper(ex_NOKIA71, "Suggested O/S Vendor:" + LiveDB.OSVENDORNAME));
       }
       // Now commit Indexes
       ok = ok == false ? ok : ((ChangeTracker)LiveDB.LiveSharedDB[ct][0]).COMMITINDEXES();
       
       return ok;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:InstallDB.java
 * @LOOKSY:FileTableDataFileMap.java  -- Quick Look
 * @LOOKSY:ChangeTracker.java  -- Quick Look
 * @LOOKSY:LanguageTransalations.java  -- Quick Look
 * @LOOKSY:CustomerRegister.java  -- Quick Look
 * @LOOKSY:ShoppingCart.java  -- Quick Look
 * @LOOKSY:InstalledTables.java  -- Quick Look
 * @LOOKSY:ReportsTable.java  -- Quick Look
 * @LOOKSY:PlatformClearance.java  -- Quick Look
 * @LOOKSY:PictureDatabase.java  -- Quick Look
 * @LOOKSY:LanguageSupport.java  -- Quick Look
 * @LOOKSY:LanguageTitles.java  -- Quick Look
 * @LOOKSY:PictureOptions.java  -- Quick Look
 * @LOOKSY:PaymentType.java  -- Quick Look
 * @LOOKSY:LanguageTitles.java  -- Quick Look
 * @LOOKSY:ArtLeaves.java  -- Quick Look
 * @LOOKSY:CrashRecovery.java  -- Quick Look
 * @LOOKSY:SearchDatabase.java  -- Quick Look
 * @LOOKSY:DefaultAdvertisingImages.java  -- Quick Look
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.LiveSharedDB, LiveDB.REALTABLES
 *
 * Method Name : protected static boolean DATABASE_RECONSTRUCT (Date p_upto, boolean p_usebackup)
 * Parameters : Date p_upto  -- upto this date, Can be null then reconstruct till end of ChangeTracker
 *              boolean p_usebackup  --- true or false
 *
 * Returns : boolean true if all tables were reconstructed successfully
 *           boolean false if even a single table fails reconstruct
 *
 * Method Called From : InstallDB.java method private static void threadLaunch()
 *
 * Asociated Methods : LiveDB::protected static boolean AllUsersKickedOut ()
 *                     LiveDB::protected static boolean validateChangeTracker ()
 *                     LiveDB::protected static boolean reconstructtable(int tbl, Date start, Date... p_upto)
 *                     LiveDB::protected static boolean restoreMostRecent (int tbl, File bd, File rf,
 *                                             Boolean bkupcopyused, Boolean oldbkupcopyused, String... p_fn)
 *                     LiveDB::protected static boolean useOutDatedBkups (int tbl, Boolean bkupcopyused,
 *                                                                    Boolean oldbkupcopyused, String... p_fn)
 *
 * Data File : All serialized table files *.res, *.dsk.bkp, *.dsk.bkp.old
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to reconstruct the entire database if all is lost. Normally
 * fsck() should do the job pretty well. If it does not then try using the SYSADM command with a copy of
 * any of the old backups you had on a external storage media. You need to assist this command with some
 * old backup files for it to succeed. Therefore specifying parameter p_usebackup as true is mostly futile
 * effort. if p_usebackup is true then check if backup file exists and copy it to serialized file and then
 * check last modified time on serialized file and start reconstruct from there upto Date p_upto (if this
 * null then till end of ChangeTracker table). If p_backup is false reconstruct from the very start of
 * ChangeTracker table row zero till the last row of ChangeTracker table. during DATABASE_RECONSTRUCT if
 * one table fails it does not return false. It continues processing all other tables.
 * NOTE:- This method call to LiveDB.useOutDatedBkups() will also try a REFRESH and validation.
 *
 * Technical Reference : Buy and Read Tun Tun in America (North Indian Beauty)
 *
 * Start Date: 18th October 2010
 * End Date: 27th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
   
   protected static boolean DATABASE_RECONSTRUCT (Date p_upto, boolean p_usebackup){

       File rf = null; // restore file
       File ser = null;
       File bd = new File (LiveDB.serializedfilespath.
                substring(0, LiveDB.serializedfilespath.lastIndexOf(LiveDB.FILESEPERATOR)));
       Date st = null; // start time for reconstruct
       Boolean bkupcopyused = false, oldbkupcopyused = false;
       boolean failures = false;
       boolean hasanytablefailed = false;

       // if during fsck the ErrorLogFile states try database reconstruct it has already tried all existing
       // files on disk and they have failed. So you have to assist DATABASE_RECONSTRUCT by providing files
       // from a backup on some other storage device if you want to use the backup and then rebuild tables.
       // Otherwise reconstruct the entire table without using backups from scratch.

       // This SYSADM command "Reconstruct" can only be run in Single User actually a zero user mode with
       // just the database service running.
       
       if (LiveDB.AllUsersKickedOut() == false)
       {
           System.err.println(LiveDB.grassHopper("Retried 126 times. All Users have not logged out. Try Shooting !"));
           return false;
       }

      // The ChangeTracker table itself may be corrupted at this stage so do a quick check
       // a quick repair of ChangeTracker entries is available but will not be reliable at all
       // try the QuickRepairChangeTracker command after trying this once and you get this error message
       // to know for sure that there is corruption in ChangeTracker
       if (validateChangeTracker() == false)
       {
           LiveDB.ALRTLVL = 4;
           System.err.println(LiveDB.grassHopper("ChangeTracker corrupt use QuickRepairChangeTracker"));
           return false;
       }

       for (int tbl = 0; tbl <= LiveDB.REALTABLES ; tbl++, failures = false)
       {
           if (p_usebackup)
           {
                    rf = new File(LiveDB.serializedfilespath + "backup" + LiveDB.FILESEPERATOR +
                    ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + ".ser" + ".res");
                
                    if (LiveDB.restoreMostRecent (tbl, bd, rf, bkupcopyused, oldbkupcopyused) == false)
                    {
                        LiveDB.ALRTLVL = 12;
                        System.err.println(LiveDB.grassHopper("All restore,backup,old backup files corrupt/dont exist try database reconstruct"));
                        return false;
                    }

                    // now refresh it
                    switch(tbl)
                    {
                        case ft:
                            if (((FileTableDataFileMap)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case ct:
                            if (((ChangeTracker)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case cr:
                            if (((CustomerRegister)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;

                        case ls:
                            if (((LanguageSupport)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case lt:
                            if (((LanguageTitles)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;

                        case pt:
                            if (((PaymentType)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;


                        case sd:
                            if (((SearchDatabase)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case da:
                            if (((DefaultAdvertisingImages)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case ar:
                            if (((ArtLeaves)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case crr:
                            if (((CrashRecovery)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case it:
                            if (((InstalledTables)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                        case rt:
                            if (((ReportsTable)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;

                        case pc:
                            if (((PlatformClearance)LiveDB.LiveSharedDB[tbl][0]).REFRESH() == false)
                            {
                                // it was a bad copy so use the backup file did it already restore the bkup
                                // or old bkup check that
                                if ( LiveDB.useOutDatedBkups(tbl, bkupcopyused, oldbkupcopyused) == false )
                                {
                                    LiveDB.ALRTLVL = 12;
                                    System.err.println(LiveDB.grassHopper("All restore,backup,oldbackup file corrupt/dont exist try database reconstruct"));
                                    failures = true;
                                }
                            }
                            // else good copy we have refreshed this table
                            break;
                    }
                    if (failures == false)
                    {
                        ser =  new File (((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename());
                        st = new Date(ser.lastModified()); // reconstruct start time
                    }
           }  // if (p_usebackup)

           if (failures == false && p_usebackup == true)
           {
              if (p_upto == null)
              {
                 if (reconstructtable(tbl,st) == false)
                 {
                    LiveDB.ALRTLVL = 12;
                    System.err.println(LiveDB.grassHopper("reconstruct for Table:" + String.valueOf(tbl)
                                                                                             + " failed"));
                    // dont exit here one table may have failed we go ahead with other tables
                 }
              }
              else
              {
                 if (reconstructtable(tbl,st, p_upto) == false)
                 {
                    LiveDB.ALRTLVL = 12;
                    System.err.println(LiveDB.grassHopper("reconstruct for Table:" + String.valueOf(tbl)
                                                                                             + " failed"));
                    // dont exit here one table may have failed we go ahead with other tables
                 }                  
              }
           } // if (failures == false)

           if (p_usebackup == false)
           {
                 if (reconstructtable(tbl,null) == false)
                 {
                    LiveDB.ALRTLVL = 12;
                    System.err.println(LiveDB.grassHopper("reconstruct for Table:" + String.valueOf(tbl)
                                                                                             + " failed"));
                    failures = true;
                    // dont exit here one table may have failed we go ahead with other tables
                 }
           }

           if (failures)
               hasanytablefailed = true;
       }  // for (int tbl = 0; tbl <= LiveDB.REALTABLES ; tbl++)

       // Take a good look at protected static boolean AllUsersKickedOut ()
       // for an explanation of the lines of code below
       try{
           LiveDB.Xclusive.release();
           LiveDB.FOS.close();
       }catch (IOException ex_NOKIA71){
           System.err.println(LiveDB.grassHopper(ex_NOKIA71, "Suggested O/S Vendor:" + LiveDB.OSVENDORNAME));           
       }

       return hasanytablefailed;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java  -- Quick Look
 * @LOOKSY:ChangeTracker.java  -- Quick Look
 * @LOOKSY:LanguageTransalations.java  -- Quick Look
 * @LOOKSY:CustomerRegister.java  -- Quick Look
 * @LOOKSY:ShoppingCart.java  -- Quick Look
 * @LOOKSY:InstalledTables.java  -- Quick Look
 * @LOOKSY:ReportsTable.java  -- Quick Look
 * @LOOKSY:PlatformClearance.java  -- Quick Look
 * @LOOKSY:PictureDatabase.java  -- Quick Look
 * @LOOKSY:LanguageSupport.java  -- Quick Look
 * @LOOKSY:LanguageTitles.java  -- Quick Look
 * @LOOKSY:PictureOptions.java  -- Quick Look
 * @LOOKSY:PaymentType.java  -- Quick Look
 * @LOOKSY:LanguageTitles.java  -- Quick Look
 * @LOOKSY:ArtLeaves.java  -- Quick Look
 * @LOOKSY:CrashRecovery.java  -- Quick Look
 * @LOOKSY:SearchDatabase.java  -- Quick Look
 * @LOOKSY:DefaultAdvertisingImages.java  -- Quick Look
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.LiveSharedDB, LiveDB.REALTABLES
 *
 * Method Name : protected static boolean reconstructtable(int tbl, Date start, Date... p_upto)
 * Parameters : int tbl -- the table number to reconstruct zero thru LiveDB.REALTABLES except ct.
 *              Date start -- start date for reconstruct. Can be null.
 *              Date... p_upto -- reconstruct uptill this date. Can be null.
 *
 * Returns : boolean true only if specified table was reconstructed successfully
 *           boolean false can be returned also if you modify logic
 *
 * Method Called From : LiveDB.java protected static boolean DATABASE_RECONSTRUCT (Date p_upto, boolean p_usebackup)
 *                      InstallDB.java private static boolean reconstructentiretable (int tbl)
 *                      InstallDB.java private static boolean tablerecovery (int tbl)
 * 
 * Relevant Indexes :
 * LiveDB.indxfileTableDataFileMap
 * searchkey = Integer.toString(AnyLiveDB.REALTABLES);
 * searchkey returns Long rowid in the table
 *
 * LiveDB.indxcrashRecovery
 * searchkey = AnyValidTableNumber(Long)
 * searchkey returns String containing the completed rowdata for the table
 *
 * LiveDB.indxchangeTracker
 * searchkey = toString(AnyRealTableno) + toString(AnyRowid)
 * searchkey returns Long ctrowid which is the rowid for the ChangeTracker table.
 * This is a dual purpose index and so
 * searchkey = toString(AnyRealTableNo) -- Is there an entry for this tableno in ChangeTracker ?
 * searchkey returns Long the same tableno
 *
 * LiveDB.indxcustomerRegister
 * searchkey = AnyValidCID
 * searchkey returns Long rowid in the table
 *
 * LiveDB.indx1shoppingCart
 * searchkey = AnyValidCID + AnyValidPictureCode + toString(Opt_id) + toString(Sub_opt_id)
 * searchkey returns Long rowid in the table
 *
 * LiveDB.indxinstalledTables
 * searchkey = Integer.toString(AnyTableNumber); Any table number is inclusive of fake tables
 * searchkey returns Long rowid in the table
 *
 * LiveDB.indxreportsTable
 * searchkey = Integer.toString(getDocumentno());
 * searchkey returns Long rowid in the table
 *
 * LiveDB.indx1platformClearance
 * searchkey = toString(Valid request number + sid)
 * searchkey returns Long rowid in the table
 *
 * Data File : All serialized table files *.res, *.dsk.bkp, *.dsk.bkp.old
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from DATABASE_RECONSTRUCT(). Its parameters start and
 * p_upto can be null.If p_upto is null it gets the last dmldate in the ChangeTracker table. If start
 * is null it starts with row 0 of ChangeTracker table. If start is not null then it tries a funny
 * algorithm to locate the start row in ChangeTracker. Then it runs thru the ChangeTracker table and
 * applies all EntireRow contained in ChangeTracker to this tbl (param). It also rebuilds all indexes.
 * Since this method will mostly be used with zero users logged in with just the database service
 * running. we wont need to clear the indexes before a put. Actually clearing the indexes can create
 * a bug instead. Finally it writes all the indexes. These indexes which are written are not being
 * read in anywhere in the application. I have them on disk for PearlHarbour() in InstallDB for the
 * worst possible scenario of recovery.
 *
 * Technical Reference : Buy and Read Tin Tin Calculus Affair
 *
 * Start Date: 18th October 2010
 * End Date: 27th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean reconstructtable(int tbl, Date start, Date... p_upto)
   {
           String searchkey = null; // for index maintenance
           long value = 0L; // for index maintenance           
           int row = 0;
           int hopfactor = 0;           
           int rx = 10;
           Date upto = null;
           boolean fnd = false;

           if (tbl == ct)
           {
               System.err.println(LiveDB.grassHopper("ChangeTracker cannot be reconstructed using this method"));
               return false;
           }

           if (p_upto.length == 0) // get the last date entry in ChangeTracker table 
           {
                upto = ((ChangeTracker)LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length -1]).getDmldate();
           }
           else upto = p_upto[0];

           for (int rec = 0; rec < LiveDB.LiveSharedDB[it].length; rec++)
           {
                if (((InstalledTables)LiveDB.LiveSharedDB[it][rec]).getTableno() == tbl)
                      start = ((InstalledTables)LiveDB.LiveSharedDB[it][rec]).getInstalltime();
           }

           if (start == null) // maybe even Installed Tables is corrupted
               hopfactor = 0; // this hopfactor is to reduce the search thru a long ChangeTracker table
           // This is the Cuthbert Calculus index for VLDB's FINDS on number of oscillations
           // called dinga-lings. Super fast faster than VLDB indexes
           
           if (start != null)
           {
               for (int rw = 0, hop = 5; rw < LiveDB.LiveSharedDB[ct].length && fnd == false; rw++)
               {
                   if (rw + hop <  LiveDB.LiveSharedDB[ct].length)
                   {
                       if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw + hop]).getDmldate().before(start))
                       {   // nobel laureate in Quantum Jumps from Fort Bragg
                           if (rw + (hop * 2) < LiveDB.LiveSharedDB[ct].length - hop) hop *= 2;
                           rw += hop;
                       }
                       else
                       {
                           if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getDmldate().compareTo(start) == 0)
                           {
                               hopfactor = rw; fnd = true;
                               break;
                           }
                           else if (((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).getDmldate().after(start))
                           {
                               for (int ro = rw; ro >= 0; ro--)
                               {
                                   if (((ChangeTracker)LiveDB.LiveSharedDB[ct][ro]).getDmldate().compareTo(start) == 0)
                                   {
                                       hopfactor = ro; fnd = true; break;
                                   }
                               }
                           }
                       }
                   }
                   else
                   {
                      rw = LiveDB.LiveSharedDB[ct].length - hop -1;
                      if (rw < -1)
                      {
                          rw = -1;
                          if (hop > LiveDB.LiveSharedDB[ct].length) hop = hop - LiveDB.LiveSharedDB[ct].length;
                      }
                   }
               } // for
           }
           
           // start the reconstruct here depending on flags passed

           for (row = hopfactor; row < LiveDB.LiveSharedDB[ct].length; row++ )
           {
               if (((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getChange_flag() == 'K' ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getChange_flag() == 'T' ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getChange_flag() == 'R' ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getChange_flag() == 'r' )
                         continue; // skip these rows
               // skip K because these rows have been nullified by you for whatever reason
               // skip T because some reconstruct had already happened at this stage
               // skip R because it is a RolledBack Row that has no value
               // skip r because it was the original row to be rolledback which is a special
               // case for processing but neverthless should not be picked up by the FastCommit
               // mechanism and written to disk and should therefore not be there either.
               // DONT skip J because it is a rollforward and a over-write record would have been placed
               // in the ChangeTracker.
               
               if (((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getDmldate().after(upto))
                     break;
                              
               // continue with rest of reconstruct based on oldchangeflag

               if ((((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getOldchangeflag() == 'U' ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getOldchangeflag() == 'I'  ||
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getOldchangeflag() == 'D') &&
                   ((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getTableno() == tbl)
               {
                       // apply entire row
                       switch (tbl){
                           case ft:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (FileTableDataFileMap)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();

                               searchkey = Integer.toString((int)(((FileTableDataFileMap)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getTableno()), rx);
                               value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(); /* take the rowid */
                               /* do a put into the HashMap here it is necessary because index wont update auto */
                               LiveDB.indxfileTableDataFileMap.put(searchkey,value);
                               break;
                           case ct: // dont do a thing we cant reconstruct this one if you dont backup
                               break; // on papad (CD) Actually there is a way out with intelli guesses
                                      // wait until next release paisa mungtah hai
                           case cr:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (CustomerRegister)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                               searchkey = ((CustomerRegister) (LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()])).getCid();
                               value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(); /* take the rowid */
                               /* do a put into the HashMap */
                               LiveDB.indxcustomerRegister.put(searchkey,value);
                               break;

                           case ls:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (LanguageSupport)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                               searchkey = ((LanguageSupport)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getLanguage();
                               value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(); /* take the rowid */
                               /* do a put into the HashMap */
                               LiveDB.indxlanguageSupport.put(searchkey,value);
                               break;
                           case lt:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (LanguageTitles)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();

                               searchkey = ((LanguageTitles)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getlangCode()
                                       +
                               ((LanguageTitles)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getenglishLabel();
                               
                               /* do a put into the HashMap */
                               LiveDB.indxlanguageTitles.put(searchkey,
                                       ((LanguageTitles)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getLanguage_text());

                               break;

                           case pt:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (PaymentType)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                               searchkey = Integer.toString((int)(((PaymentType)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getPmtid()), rx);
                               value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(); /* take the rowid */
                               /* do a put into the HashMap */
                               LiveDB.indxpaymentType.put(searchkey,value);
                               break;

                           case sd:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (SearchDatabase)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                               searchkey = ((SearchDatabase) (LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()])).getKeyword();
                               value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(); /* take the rowid */
                               /* This time tuck in the picture code as value */
                               /* do a put into the HashMap */
                               LiveDB.indxsearchDatabase.put(searchkey,((SearchDatabase) (LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()])).getPic());
                               break;
                           case da:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (DefaultAdvertisingImages)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();

                               break;
                           case ar:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (ArtLeaves)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                               break;
                           case crr:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (CrashRecovery)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                               LiveDB.indxcrashRecovery.clear();
                               /* just construct search key for every row
                                * and Long value and do a put()
                                */                                                        
                                searchkey = null;
                                /* do a put into the HashMap */
                                for ( int k = 0; k < ((CrashRecovery)LiveDB.LiveSharedDB[tbl]
                                    [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getValues().length; k++ )
                                {
                                    searchkey += LiveDB.fieldseperator + ((CrashRecovery)LiveDB.LiveSharedDB[tbl]
                                            [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getValues()[k];
                                }
                                LiveDB.indxcrashRecovery.put(((CrashRecovery)LiveDB.LiveSharedDB[tbl]
                                        [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getTableno(),
                                Long.toString(((CrashRecovery)LiveDB.LiveSharedDB[tbl]
                                [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getRowid()) + searchkey);                                                            
                                break;
                           case it:
                              LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                              (InstalledTables)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                              searchkey = Integer.toString((int)(((InstalledTables)LiveDB.LiveSharedDB[tbl]
                                      [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getTableno()), rx);
                              value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(); /* take the rowid */
                              /* do a put into the HashMap */
                              LiveDB.indxinstalledTables.put(searchkey,value);
                              break;
                           case rt:
                              LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                              (ReportsTable)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();
                              searchkey = Integer.toString((int)(((ReportsTable)LiveDB.LiveSharedDB[tbl]
                              [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getDocumentno()), rx);
                              value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(); /* take the rowid */
                              /* do a put into the HashMap */
                              LiveDB.indxreportsTable.put(searchkey,value);
                              break;

                           case pc:
                               LiveDB.LiveSharedDB[tbl]
                                       [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()] =
                               (PlatformClearance)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getEntirerow();

                               searchkey = Integer.toString((int)(((PlatformClearance)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getRequestno()))
                               + Long.toString((long)(((PlatformClearance)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getSid()));
                               value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid();
                               value = (long)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid();
                               LiveDB.indx1platformClearance.put(searchkey,value);
                               // now the second index
                               LiveDB.indxplatformClearance.put(((PlatformClearance)LiveDB.LiveSharedDB[tbl]
                               [(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()]).getRequest_time(),
                                       value);

                               break;
                       } // switch                   
               } // if (((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getOldchangeflag() == 'U'

           } // for (int row = 0; row < LiveDB.LiveSharedDB[ct].length; row++ )

           if (tbl != ct)
           {
                if (write_IndexFile (tbl) == false)
                {
                    System.err.println(LiveDB.grassHopper("Index Write Fail Table:" + String.valueOf(tbl)
                        + " will attempt on exit check modified time"));
                }
           }

           // just plug in one single entry for each table in ChangeTracker instead of each Row
           // insert an entry in ChangeTracker table for this table
           LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
           new ChangeTracker (tbl, ((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid(),
           'T', LiveDB.pid, new Date (),
           LiveDB.LiveSharedDB[tbl][(int)((ChangeTracker)LiveDB.LiveSharedDB[ct][row]).getRowid()],
           (long)LiveDB.LiveSharedDB[ct].length);

           LiveDB.system_exit = 1;
           LiveDB.SmoothExitCondition.signalAll();
           return true;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:LiveDB.LiveSharedDB
 *
 * Method Name : protected static boolean TRANSACTION_ROLLBACK()
 * Parameters : None
 * Returns : boolean true if ROLLBACK succeeded on both tables
 *           boolean false if ROLLBACK failed on either or both tables
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is just a handy wrapper method that calls ROLBACK on both tables
 * ShoppingCart and CustomerRegister. These are the only two tables with end-user transactions on them.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static boolean TRANSACTION_ROLLBACK(){
       
       boolean ok = true;

       

       ok = (ok == false) ? ok: ((CustomerRegister)LiveDB.LiveSharedDB[cr][ft]).ROLLBACK(); // now the master

       return ok;
   }

/*
 * WIRING DIAGRAM :
 * Method Name : protected static void qsort (Long p_sortids [])
 * Parameters : Long p_sortids []
 * Returns : None
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is just a handy sort ascending. Pass it an array of Longs and it
 * is sorted and returned back in the same array.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

   protected static void qsort (Long p_sortids []){
        // sort ascending

        boolean ok = false;
        long rows [] = null;
        long tmp = 0L;

        if (p_sortids.length <= 1) return; // no need to sort

        for (int i = 0; i < p_sortids.length; i++)
            rows[i] = p_sortids[i];

        for (int i = 1; i < rows.length; i++)
        {
            if (rows [i -1] > rows[i])
            {
                tmp = rows[i];
                rows[i] = rows[i -1];
                rows [i -1] = tmp;
            }
        }

        for (int i = 0; i < rows.length; i++)
            p_sortids[i] = rows[i];

        return;
   }

/*
 * WIRING DIAGRAM :
 * @LOOKSY: FileTableDataFileMap.java
 * @LOOKSY: ChangeTracker.java
 * @LOOKSY: CustomerRegister.java
 * @LOOKSY: ShoppingCart.java
 * @LOOKSY: CrashRecovery.java
 * @LOOKSY: ReportsTable.java
 * @LOOKSY: InstalledTables.java
 * @LOOKSY: PlatformClearance.java
 * @LOOKSY: LanguageTitles.java
 * @LOOKSY: PictureDatabase.java
 * @LOOKSY: PictureOptions.java
 * @LOOKSY:LiveDB.ALRTLVL, LiveDB.LiveSharedDB, LiveDB.tablenameidentifier, LiveDB.command_line
 * @LOOKSY:LiveDB.IPCSCondition, LiveDB.REALTABLES, LiveDB.LASTLOCKMETHOD, LiveDB.Action, LiveDB.MAXROWSETS
 *
 * Method Name : protected static boolean commit_database (int p_Tableno)
 * Parameters : int p_Tableno -- the tableno to commit
 * Returns : boolean true if p_Tableno serialized successfully.
 *           boolean false if any errors
 *
 * Method Called From : COMMIT() implementation of Tables Interface
 *
 * Associated Methods : protected static boolean QueueTrainsInWaiting (PlatformClearance mytrain, 
 *                                                           FileChannel ch, FileLock fl, int requestno)
 *                      protected static boolean DeQueueTrainsInWaitingArrivals ()
 *                      protected static boolean DeQueueTrainsInWaiting ()
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method will serialize any table including fake tables from 18 onwards to disk.
 * if LiveDB.CUSTOMREPORTSON == false and p_Tableno you have passed as param is > 36 method returns false.
 * When called as a SYSADM command "Archive" this method will serialize the table to archive/*.rs* files.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 3rd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static synchronized boolean commit_database (int p_Tableno){

        if (p_Tableno > LiveDB.maxtables || p_Tableno < 0)
            return false;

        if (LiveDB.CUSTOMREPORTSON == false)
        {
            if (p_Tableno > 36)
               return false;
        }
        
        File rsf = null; 
        File psf = null;
        FileLock fl = null;
        Lock WriteObjectLock = new ReentrantLock();
        IPCSCondition[ThreadController.getcurrenthread()] = WriteObjectLock.newCondition();        
        boolean ok = true;

        int itr = 0; // installed table row used in loop below
        int requestno = (new Random ()).nextInt();

        TrainRunningInformation myrunninginfo = new TrainRunningInformation (p_Tableno,
                Thread.currentThread().getId(), Thread.currentThread().getName(),
                Thread.currentThread().getThreadGroup().getName(), null, null, null, 0L);

        // FIRST setWrite on LiveDB.serializedfilespath
        if (new File (LiveDB.serializedfilespath
                .substring(0, LiveDB.serializedfilespath.lastIndexOf(LiveDB.FILESEPERATOR)))
                .setWritable(true, false) == false)
        {
            System.err.println("Cant setWrite on " + LiveDB.serializedfilespath );
            JOptionPane.showMessageDialog(appframe,
                             "System Error Exiting" + '\n' + "Your Log File Name for Session is:"
                             + '\n' + LiveDB.ErrorLogFile);
            System.exit(1);
        }


        LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] = new PlatformClearance ( requestno, 
               LiveDB.pid, Action.WRITEOBJECT, new Date (), myrunninginfo, LiveDB.LiveSharedDB[pc].length);

        PlatformClearance mytrain = (PlatformClearance) LiveDB.LiveSharedDB[pc]
                                                                    [LiveDB.LiveSharedDB[pc].length -1];

        String pf = null; /* persistent storage file name */
         
        // find the row id in Installed Tables for this p_Tableno
        for (itr = 0; itr < LiveDB.LiveSharedDB[it].length; itr++)
        {
            if (((InstalledTables)LiveDB.LiveSharedDB[it][itr]).getTableno() == p_Tableno)
            {
               itr = (int)((InstalledTables)LiveDB.LiveSharedDB[it][itr]).getRowid();
               break;
            }
        }

        if (p_Tableno <= LiveDB.REALTABLES )
        {
            if (LiveDB.command_line.equals("ArChIvE"))
            {
                if (new File(LiveDB.serializedfilespath + "archive").canWrite())
                {
                    System.err.println(LiveDB.grassHopper("Perms Tampered File:"
                                                              + LiveDB.serializedfilespath + "archive"));
                }
                else
                {
                    if (new File(LiveDB.serializedfilespath + "archive").setWritable(true, false) == false)
                    {
                        System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                                              + LiveDB.serializedfilespath + "archive"));
                        LiveDB.system_exit = 1;
                        LiveDB.SmoothExitCondition.signalAll();
                    }
                }
                pf = ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][p_Tableno]).getFilename() + ".ser";
            }
            else
                 pf = LiveDB.serializedfilespath
                   + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][p_Tableno]).getFilename() + ".ser";
        }
        else 
        {
            for (int ftr = LiveDB.REALTABLES + 1 ; ftr < LiveDB.tablenameidentifier.length; ftr++)
            {
                 if (p_Tableno == Integer.parseInt(LiveDB.tablenameidentifier[ftr][0]))
                 {
                     pf = LiveDB.serializedfilespath + LiveDB.tablenameidentifier[ftr][1] + ".ser";
                     break;
                 }
            }
        }

        if (LiveDB.command_line.equals("ArChIvE") == true)
        {
            for (int rs = 1; rs < LiveDB.MAXROWSETS; rs++)
            {
                 rsf = new File (LiveDB.serializedfilespath + "archive" + pf + ".rs" + rs );
                 if (rsf.exists()) continue;
                 else
                 {
                      pf = LiveDB.serializedfilespath + "archive" + pf + ".rs" + rs;
                      break;
                 }
            }
        }


        try{                
                psf = new File (pf);
                FileOutputStream fo = new FileOutputStream (psf);
                FileChannel ch = fo.getChannel();

                if (LiveDB.QueueTrainsInWaiting(mytrain, ch, fl, requestno) == false)
                {
                    System.err.println(LiveDB.grassHopper("Error QueueTrainsInWaiting table :" +
                                                                    mytrain.getTrainid().getTrain()));
                    return false;
                }

                /* since this is just an advisory lock on some operating systems set lock_flag
                 * to "L" in fileTableDataFileMap
                 */
                      
                ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][p_Tableno])).setTable_lock("L");
                // insert an entry in ChangeTracker table for this table
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (ft, p_Tableno, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[ft][p_Tableno], (long)LiveDB.LiveSharedDB[ct].length);

                LiveDB.LASTLOCKMETHOD = "commit_database";

                ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][p_Tableno])).setPid (LiveDB.pid);

                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (ft, p_Tableno, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[ft][p_Tableno], (long)LiveDB.LiveSharedDB[ct].length);

                ObjectOutputStream os = new ObjectOutputStream (fo);
                    
                WriteObjectLock.lock();                    
                      
                for (int rw = 0; rw < LiveDB.LiveSharedDB[p_Tableno].length; rw++ )
                {                          
                     switch (p_Tableno){
                              case ft:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((FileTableDataFileMap)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              case ct:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((ChangeTracker)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              case cr:   // catch IOException here if wanted Actually dont more of a headache
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((CustomerRegister)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;

                              case lt:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((LanguageTitles)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;

                              case us:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((UserSubmits)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;

                              case cp:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((CustomerPayments)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;

                              case ni:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((NodalInfo)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              case id:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((InstallerDues)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              case crr:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((CrashRecovery)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              case it:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((InstalledTables)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              case rt:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((ReportsTable)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              case pc:
                                if (psf.canWrite() == true)
                                {
                                    LiveDB.ALRTLVL = 1;
                                    System.err.println(grassHopper("File perms tampered setting it to write on file " + pf));
                                }

                                psf.setWritable(true,false);
                                ((PlatformClearance)LiveDB.LiveSharedDB[p_Tableno][rw]).writeExternal(os);

                                ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                                new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                                psf.setWritable(false,false);
                                break;
                              default:
                                break;
                     } // switch (p_Tableno)
                 } // for (int rw = 0; rw < LiveDB.LiveSharedDB[p_Tableno].length; rw++ )

                 if ((p_Tableno != cr && p_Tableno != cp && p_Tableno != rt && p_Tableno != lt
                    && p_Tableno != ft && p_Tableno != it && p_Tableno != pc && p_Tableno != us
                    && p_Tableno != ni && p_Tableno != crr && p_Tableno != ct && p_Tableno != id )
                    || p_Tableno > LiveDB.REALTABLES)
                 {
                    if (psf.canWrite() == true)
                    {
                        LiveDB.ALRTLVL = 1;
                        System.err.println(grassHopper("File perms tampered setting to write on file "
                                + pf));
                    }

                    psf.setWritable(true,false);

                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setOutsize(-1L);
                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                         LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);

                    os.writeObject(LiveDB.LiveSharedDB[p_Tableno]);  // WRITE OBJECT  HERE
                         
                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setOutsize(psf.length());

                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);

                    ((InstalledTables)LiveDB.LiveSharedDB[it][itr]).setModifiedtime(new Date());
                    LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                    new ChangeTracker (it,itr, 'U', LiveDB.pid, new Date (),
                        LiveDB.LiveSharedDB[it][itr], (long)LiveDB.LiveSharedDB[ct].length);
                    psf.setWritable(false,false);

                 }

                 // we dont use a externalizable interface for some objects to make it less hacker
                 // friendly

                 try{
                       fl.release();
                 }catch (ClosedChannelException ex_NOKIA52){
                          System.err.println(LiveDB.grassHopper(ex_NOKIA52, "Error fl.release()"));
                 }
                                        
                 ch.close();

                 ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][p_Tableno])).setTable_lock("U");
                           // insert an entry in ChangeTracker table for this table
                 LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                 new ChangeTracker (ft, p_Tableno, 'U', LiveDB.pid, new Date (),
                     LiveDB.LiveSharedDB[ft][p_Tableno], (long)LiveDB.LiveSharedDB[ct].length);

                 os.close();
                 
                 if (LiveDB.DeQueueTrainsInWaitingArrivals() == false)
                 {
                        LiveDB.ALRTLVL = 7; // programming screwup most probably
                        System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaitingArrivals()"));
                 }

            }catch (FileNotFoundException ex_NOKIA42){

                if (LiveDB.DeQueueTrainsInWaiting() == false)
                {
                    LiveDB.ALRTLVL = 7; // programming screwup most probably
                    System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                }
                System.err.println(LiveDB.grassHopper(ex_NOKIA42));         
                return ok = false;

            }catch (IOException ex_NOKIA43){

                if (LiveDB.DeQueueTrainsInWaiting() == false)
                {
                        LiveDB.ALRTLVL = 7; // programming screwup most probably
                        System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                }
                    
                ((FileTableDataFileMap)(LiveDB.LiveSharedDB[ft][p_Tableno])).setTable_lock("U");
                    // insert an entry in ChangeTracker table for this table
                LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                new ChangeTracker (ft,p_Tableno, 'U', LiveDB.pid, new Date (),
                    LiveDB.LiveSharedDB[ft][p_Tableno], (long)LiveDB.LiveSharedDB[ct].length);
                System.err.println(LiveDB.grassHopper(ex_NOKIA43));
                return ok = false;
                
            }finally{WriteObjectLock.unlock();}
 
        if (ok == false)
        {
           System.err.println(grassHopper("Culprit File:" + pf));
           JOptionPane.showMessageDialog(appframe, "YOUR LOG FILE FOR THIS SESSION IS : " + LiveDB.ErrorLogFile);
           return false;
        }

        if (psf.setReadOnly() == false)
           System.err.println(grassHopper("Unable to set readonly via java application " + pf));



       // dont reset perms here on LiveDB.serializedfilespath to setReadonly
       // because it will play havoc in a multi user mode. Some user may have setWrite just
       // one second back and proceed to write. Meanwhile you have set Read here and the other
       // users write will fail

        return true;

    } /* public boolean commit_database (long p_Tableno) */


/*
 * WIRING DIAGRAM :
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.ALRTLVL, LiveDB.LiveSharedDB, LiveDB.indxsrtnameidentifier
 *
 * Method Name : protected static boolean write_IndexFile (int p_Tableno)
 * Parameters : int p_Tableno -- the table number for which all relevant indexes are to be serialized
 *
 * Returns : boolean true if relevant indexes pertaining to table p_Tableno were successfully serialized
 *           boolean false if serialization not successfull or any other error encountered.
 *
 * Method Called From : LiveDB.java protected static boolean reconstructtable(int tbl, Date start, Date... p_upto)
 *
 * Relevant Indexes to be Serialized :
 * LiveDB.indxfileTableDataFileMap
 * LiveDB.indxcrashRecovery
 * LiveDB.indxcustomerRegister
 * LiveDB.indx1shoppingCart
 * LiveDB.indx2shoppingCart
 * LiveDB.indxinstalledTables
 * LiveDB.indxreportsTable
 * LiveDB.indxplatformClearance
 * LiveDB.indx1platformClearance
 * 
 * Associated Methods : protected static boolean QueueTrainsInWaiting (PlatformClearance mytrain,
 *                                                            FileChannel ch, FileLock fl, int requestno )
 *                      protected static boolean DeQueueTrainsInWaitingArrivals ()
 *                      protected static boolean DeQueueTrainsInWaiting ()
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method serializes all relevant indexes pertaining to the parameter p_Tableno
 * Relevant indexes are serialized to file serializedfilespath + LiveDB.indxsrtnameidentifier[i][1] + ".ser"
 * 
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 28th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean write_IndexFile (int p_Tableno){
        Lock WriteIndexLock = new ReentrantLock();  
        
        boolean ok = true, found = false;

        int requestno = (new Random ()).nextInt();
        TrainRunningInformation myrunninginfo = new TrainRunningInformation (p_Tableno, Thread.currentThread().getId(), Thread.currentThread().getName(),
                Thread.currentThread().getThreadGroup().getName(), null, null, null, 0L);
        LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] = new PlatformClearance ( requestno, LiveDB.pid, Action.WRITEOBJECT, new Date (), myrunninginfo,
                LiveDB.LiveSharedDB[pc].length);
        PlatformClearance mytrain = (PlatformClearance) LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1];
        FileOutputStream fo = null;
        FileChannel ch = null;
        FileLock fl = null;
        File isf = null;
        String pf = null;
        int i = 0;

        for ( i = 0; Integer.parseInt(LiveDB.indxsrtnameidentifier[i][0]) <= p_Tableno; i++ )
        {
            if (Integer.parseInt(LiveDB.indxsrtnameidentifier[i][0]) == p_Tableno)
            {
               pf = LiveDB.serializedfilespath + LiveDB.indxsrtnameidentifier[i][1] + ".ser";
               found = true;
               break;
            }
        } // for

        if (found == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("table number not found in LiveDB.indxsrtnameidentifier[i][0]"));
            return false;
        }
        
        try{
                    
                    isf = new File (pf);
                    fo = new FileOutputStream (isf);
                    ch = fo.getChannel(); /* return a Channel for locking */
                    fl = null;

                     if (LiveDB.QueueTrainsInWaiting(mytrain, ch, fl, requestno) == false)
                     {
                          System.err.println(LiveDB.grassHopper("Error QueueTrainsInWaiting table :" +
                                               mytrain.getTrainid().getTrain()));
                          return false;
                     }

                    ObjectOutputStream os = new ObjectOutputStream (fo);
                    
                    WriteIndexLock.lock();
                    IPCSCondition[ThreadController.getcurrenthread()] = WriteIndexLock.newCondition();
                   // try{
                    switch (p_Tableno){
                        case ft:
                           if (isf.canWrite() == true)
                              System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                 isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxfileTableDataFileMap);
                            if (isf.setReadOnly() == false)
                                System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            break;
                        case ct:
                            if (isf.canWrite() == true)
                               System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                 isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxchangeTracker);
                            if (isf.setReadOnly() == false)
                               System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            break;
                        case cr:
                            if (isf.canWrite() == true)
                              System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                 isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxcustomerRegister);
                            if (isf.setReadOnly() == false)
                               System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            break;

                        case ls:
                            if (isf.canWrite() == true)
                               System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                 isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxlanguageSupport);
                            if (isf.setReadOnly() == false)
                                System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            break;
                        case lt:
                            if (Integer.parseInt(LiveDB.indxsrtnameidentifier[i][2]) == 51)
                            {
                                if (isf.canWrite() == true)
                                   System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                                 if (isf.exists())
                                     isf.setWritable(true,false);
                                os.writeObject(LiveDB.indxlanguageTitles);
                                if (isf.setReadOnly() == false)
                                   System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            }

                            break;

                        case pt:
                            if (isf.canWrite() == true)
                               System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxpaymentType);
                            if (isf.setReadOnly() == false)
                               System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                        
                            break;


                        case sd:
                            if (isf.canWrite() == true)
                              System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                 isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxsearchDatabase);
                            
                            if (isf.setReadOnly() == false)
                               System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            break;
                        case crr:
                           if (isf.canWrite() == true)
                              System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                 isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxcrashRecovery);
                            if (isf.setReadOnly() == false)
                               System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
      
                            break;
                        case it:
                            if (isf.canWrite() == true)
                               System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                            if (isf.exists())
                                 isf.setWritable(true,false);
                            os.writeObject(LiveDB.indxinstalledTables);
                            if (isf.setReadOnly() == false)
                               System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));

                            break;
                        case rt:
                            if (Integer.parseInt(LiveDB.indxsrtnameidentifier[i][2]) == 61)
                            {
                                if (isf.canWrite() == true)
                                   System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                                if (isf.exists())
                                    isf.setWritable(true,false);
                                os.writeObject(LiveDB.indxreportsTable);
                                if (isf.setReadOnly() == false)
                                   System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            }
                            else if (Integer.parseInt(LiveDB.indxsrtnameidentifier[i][2]) == 62)
                            {
                                if (isf.canWrite() == true)
                                   System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                                if (isf.exists())
                                    isf.setWritable(true,false);
                                os.writeObject(LiveDB.srt1reportstable);
                                if (isf.setReadOnly() == false)
                                   System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            }
                            else if (Integer.parseInt(LiveDB.indxsrtnameidentifier[i][2]) == 63)
                            {
                                if (isf.canWrite() == true)
                                   System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                                if (isf.exists())
                                    isf.setWritable(true,false);
                                os.writeObject(LiveDB.srt2reportstable);

                                if (isf.setReadOnly() == false)
                                   System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            }
                            else if (Integer.parseInt(LiveDB.indxsrtnameidentifier[i][2]) == 64)
                            {
                                if (isf.canWrite() == true)
                                   System.err.println(grassHopper("Tampered file perms to write on File:" + pf));
                                if (isf.exists())
                                    isf.setWritable(true,false);
                                os.writeObject(LiveDB.srt3reportstable);
                                if (isf.setReadOnly() == false)
                                   System.err.println(grassHopper("Unable to setReadOnly via java application " + pf));
                            }
                            break;
                        default:
                            break;
                    } /* switch */

                    fl.release();
                    os.close();
        }catch (FileNotFoundException ex_NOKIA61){
              if (LiveDB.DeQueueTrainsInWaiting() == false)
              {
                  LiveDB.ALRTLVL = 7; // programming screwup most probably
                  System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
              }
              System.err.println(LiveDB.grassHopper(ex_NOKIA61, "File:" + LiveDB.serializedfilespath
                            + LiveDB.indxsrtnameidentifier[i][1] + ".ser"));
              ok = false;
        }catch (IOException ex_NOKIA62){
              if (LiveDB.DeQueueTrainsInWaiting() == false)
              {
                  LiveDB.ALRTLVL = 7; // programming screwup most probably
                  System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
              }
              System.err.println(LiveDB.grassHopper(ex_NOKIA62, "File:" + LiveDB.serializedfilespath + LiveDB.indxsrtnameidentifier[i][1] + ".ser"));
              ok = false;
        }

       WriteIndexLock.unlock();
                
       if (ok)
       {
            if (LiveDB.DeQueueTrainsInWaitingArrivals() == false)
            {
                LiveDB.ALRTLVL = 7; // programming screwup most probably
                System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaitingArrivals()"));
            }
       }
       
       return ok;
    } /*  protected boolean write_IndexFile () */
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean SendNotificationEmail (String p_mesg)
 * Parameters : String p_mesg -- Your Notification message
 * Returns : boolean true if Notification mail message hopped out of your sending mailbox
 *           boolean false if message did not hop out of your sending mailbox or retries fail or any error
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to Notification email with several retries to other MailBoxes.
 * Your question why cant i use PrepareAndSendMailMesg (). Yes you can but this handy wrapper method takes
 * care of all validations and the retries. This notification mailbox is the only mailbox proprietor of
 * company will have to check. This notification mail box will inform proprietor about emails received in
 * other mailboxes. If you use this handy method you will receive notification messages in your ntoification
 * mailbox very frequently. You can use a good email client to pop up alerts of specific mails based on some
 * filters that you create in your email clients.
 *
 * Technical Reference : Watch Moulin Rougue
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean SendNotificationEmail (String p_mesg){

        if (p_mesg == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Notification message null"));
            return false;
        }

        if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
            ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),  // CC to BKUP MAILBOX
            null, "EMAIL FROM " + LiveDB.NODENAME, p_mesg, null) == false)
        {
            // Retry to a different mailbox
            if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11(),
                ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
                null, "EMAIL FROM " + LiveDB.NODENAME, p_mesg, null) == false)
            {
                    // if you want you can give it yet another retry from that other mandatory gmailid
                    // maybe something wrong with this gmail account you are sending out from
                    // but this retry will succeed only if password for both email accounts is common
                    // otherwise type in the password here
                    // THIS IS RETRY FROM A DIFFERENT MAILBOX
                 if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(), null,
                     ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                     ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
                     null, "EMAIL FROM " + LiveDB.NODENAME, p_mesg, null) == false)
                 {
                      System.err.println(LiveDB.grassHopper("SendNotificationEmail Retry Failed Contact gmail services"));
                      return false;
                 }
                 else
                 {
                    LiveDB.ALRTLVL = 5;
                    System.err.println(LiveDB.grassHopper("Notification Email sent to email id:" +
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4()));
                 }
            }
            else
            {
                LiveDB.ALRTLVL = 5;
                System.err.println(LiveDB.grassHopper("Notification Email sent to email id:" +
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11()));
            }
        }
        return true;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean SendLogFileMessage ()
 * Parameters : None
 * Returns : boolean true if mail message with ErrorLogFile attachment hopped out of your sending mailbox
 *                        and also a notification email hopped out of your sending mailbox
 *           boolean false if message did not hop out of your sending mailbox or retries fail or any error
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Data File : LiveDB.ErrorLogFile
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to Mailout ErrorLogFile with several retries to other MailBoxes.
 * Your question why cant i use PrepareAndSendMailMesg (). Yes you can but this handy wrapper method takes
 * care of all validations and the retries and notify messages and also sends out a notification email to
 * your notification mailbox which is the only mailbox the proprietor of company will have to check. This
 * notification mail box will inform proprietor about emails received in other mailboxes. If you use this
 * handy method you will receive ErrorLogFiles in your mailbox very frequently for monitoring purposes but
 * they will be received in your mailbox from several different NODES (each node is a session).
 *
 * Technical Reference : Watch Moulin Rougue
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean SendLogFileMessage (){
        
        String notify = null;
        if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail2(),
               ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
               null, "EMAIL FROM " + LiveDB.NODENAME, "Find attached ErrorLogFile", ErrorLogFile)
                == false)
        {
            // Retry to a different mailbox
            if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11(),
                ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), // CC to BKUP MAILBOX
                null, "EMAIL FROM " + LiveDB.NODENAME, "Find attached ErrorLogFile", ErrorLogFile) == false)
            {
                // if you want you can give it yet another retry from that other mandatory gmailid
                // maybe something wrong with this gmail account you are sending out from
                // but this retry will succeed only if password for both email accounts is common
                // otherwise type in the password here
                // THIS IS RETRY FROM A DIFFERENT MAILBOX
                if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(), null,
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail2(),
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),null,
                    "EMAIL FROM " + LiveDB.NODENAME, "Find attached ErrorLogFile",
                    ErrorLogFile) == false)
                {
                    System.err.println(LiveDB.grassHopper("SendLogFileMessage Retry Failed Contact gmail services"));
                    return false;
                }
                else notify = "Log File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail2();
            }
            else
            {
                LiveDB.ALRTLVL = 5;
                System.err.println(LiveDB.grassHopper(notify = "Log File sent to email id:" +
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11()));
            }
        }
        else notify = "Log File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail2();

        if (SendNotificationEmail(notify) == false)
        {
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Notify Email Sent for SendLogFileMessage() Failed after Retries"));
                return false;
        }
        return true;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:Spy.java -- method dump()
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL, LiveDB.MEMDUMP,
 * @LOOKSY:LiveDB.DISKDUMP, LiveDB.BKUPDUMP, LiveDB.serializedfilespath, LiveDB.FILESEPERATOR, LiveDB.pid,
 * @LOOKSY:LiveDB.NODENAME, LiveDB.DUMPSECURITY
 *
 * Method Name : protected static boolean SendDumpFileMessages ()
 * Parameters : None
 * Returns : boolean true if dump files attachments were emailed and hopped out of your sending mailbox
 *           AND notification email to your notification mailbox also hopped out of your sending mailbox
 *           boolean false if emailed attachments did not hop out of your sending mailbox and/or retries
 *           fail and/or errors.
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 *
 * Data File : LiveDB.serializedfilespath/dump/*.mem.dmp, LiveDB.serializedfilespath/dump/*.dsk.dmp,
 *             LiveDB.serializedfilespath/dump/*.bkp.dmp
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to mailout dump files with several retries to other MailBoxes.It
 * will only mail out the dump files contained in dump sub directory if they exist on disk. Your question why
 * cant i use PrepareAndSendMailMesg (). Yes you can but this wrapper method takes care of all validations
 * and retries and notify messages and also sends out a notification email to your notification mailbox which
 * is the only mailbox the proprietor of company will have to check. This notification mail box will inform
 * proprietor about emails received in other mailboxes.
 *
 * If you use this handy method it will also delete the dump files on disk after emailing if DUMPSECURITY is
 * set to true. It is advisable to set DUMPSECURITY to true otherwise that data will be available on disk for
 * someone to view easily using any text editor available.
 *
 * Technical Reference : Watch Moulin Rougue
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean SendDumpFileMessages (){
        
        int tbl = 1;
        int i = 0;
        boolean exit = false;
        String DumpFiles [] = null;
        String notify = null;

        do{
              if (MEMDUMP)
              {
                 if (new File(LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                         ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + LiveDB.pid
                         + ".mem" + ".dmp").exists())
                 {
                     DumpFiles[i] = LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                     ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + LiveDB.pid
                     + ".mem" + ".dmp";
                     i++;
                 }
              }
              if (DISKDUMP)
              {
                 if (new File(LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                     ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + LiveDB.pid
                     + ".dsk" + ".dmp").exists())
                 {
                     DumpFiles[i] = LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                     ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + LiveDB.pid
                     + ".dsk" + ".dmp";
                     i++;
                 }
              }
              if (BKUPDUMP)
              {
                 if (new File(LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                     ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + LiveDB.pid
                     + ".bkp" + ".dmp").exists())
                 {
                     DumpFiles[i] = LiveDB.serializedfilespath + "dump" + LiveDB.FILESEPERATOR +
                     ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][tbl]).getFilename() + LiveDB.pid
                     + ".bkp" + ".dmp";
                     i++;
                 }
              }
              tbl++;
              
              if (tbl == 4)
                  tbl = 14;
              else
              {
                  if (tbl == 16)
                      exit = true;
              }
        }while (exit == false);

        // for each of the DumpFiles send an email
        i = 0; exit = true;
        while (i < DumpFiles.length)
        {
            if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail10(),
               ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
               null, "EMAIL FROM " + LiveDB.NODENAME + " Dump File:" + DumpFiles[i],
               "Find attached DumpFile", DumpFiles[i])
                == false)
            {
                // Retry to a different mailbox
                if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11(),
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
                    null, "EMAIL FROM " + LiveDB.NODENAME + " Dump File:" + DumpFiles[i],
                    "Find attached DumpFile", DumpFiles[i]) == false)
                {
                    // if you want you can give it yet another retry from that other mandatory gmailid
                    // maybe something wrong with this gmail account you are sending out from
                    // but this retry will succeed only if password for both email accounts is common
                    // otherwise type in the password here
                    // THIS IS RETRY FROM A DIFFERENT MAILBOX
                    // there is yet another level of retry i wont tell you about paisa mungtah hai
                    if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(), null,
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail10(),
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
                       null, "EMAIL FROM " + LiveDB.NODENAME + " Dump File:" + DumpFiles[i],
                       "Find attached DumpFile", DumpFiles[i]) == false)
                    {
                       System.err.println(LiveDB.grassHopper("SendDumpFileMessages Retry Failed Contact gmail services"));
                       return false;
                    }
                    else notify = "Dump File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail10();
                }
                else
                {
                    LiveDB.ALRTLVL = 5;
                    System.err.println(LiveDB.grassHopper(notify = "Dump File sent to email id:" +
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11()));
                    exit = exit == false ? false:true;
                }
                exit = false;
            }
            else notify = "Dump File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail10();
            if (SendNotificationEmail(notify) == false)
            {
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Notify Email Sent for SendLogFileMessage() Failed after Retries"));
                exit = false;
            }
            if (LiveDB.DUMPSECURITY) // email atachment may not reach you but you take that risk with this
                                     // flag set to true
                new File(DumpFiles[i]).delete();
            i++;
        }
  
        return exit;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean TakeExternalBackupToMailBox (String p_bkupfile)
 *
 * Parameters : String p_bkupfile -- The Backup file to take an email backup of
 *
 * Returns : boolean true if mail message with backupfile attachment hopped out of your sending mailbox
 *                        and also a notification email hopped out of your sending mailbox
 *           boolean false if message did not hop out of your sending mailbox or any other error
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Data File : String p_bkupfile -- canonical filename
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to Mailout backup files to an external mailbox  with several
 * retries to other MailBoxes. Your question why cant i use PrepareAndSendMailMesg (). Yes you can but this
 * handy wrapper method takes care of all validations and the retries and notify messages and also sends out
 * a notification email to your notification mailbox which is the only mailbox the proprietor of company will
 * have to check. This notification mail box will inform proprietor about emails received in other mailboxes.
 * If you use this handy method you wont have to buy external storage media any more other than just a pen
 * drive perhaps.
 *
 * Technical Reference : Watch Moulin Rougue
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean TakeExternalBackupToMailBox (String p_bkupfile){

        if (p_bkupfile == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Backup File not specified"));
            return false;
        }
        
        String notify = null;
        if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
            null, null, "EMAIL FROM " + LiveDB.NODENAME,
            "Backup File Attached Copy to External Media and Delete from MailBox", p_bkupfile)
            == false)
        {
            // Retry to a different mailbox
            if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11(),
                null, null, "EMAIL FROM " + LiveDB.NODENAME,
                "Backup File Attached Copy to External Media and Delete from MailBox", p_bkupfile) == false)
            {
                // if you want you can give it yet another retry from that other mandatory gmailid
                // maybe something wrong with this gmail account you are sending out from
                // but this retry will succeed only if password for both email accounts is common
                // otherwise type in the password here
                // THIS IS RETRY FROM A DIFFERENT MAILBOX
                if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(), null,
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(),
                    null,null, "EMAIL FROM " + LiveDB.NODENAME,
                    "Backup File Attached Copy to External Media and Delete from MailBox",
                    p_bkupfile) == false)
                {
                    System.err.println(LiveDB.grassHopper("TakeExternalBackupToMailBox Retry Failed Contact gmail services"));
                    return false;
                }
                else notify = "Backup File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13();
            }
            else
            {
                LiveDB.ALRTLVL = 5;
                System.err.println(LiveDB.grassHopper(notify = "Backup File sent to email id:" +
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11()));
            }
        }
        else notify = "Backup File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13();

        if (SendNotificationEmail(notify) == false)
        {
           LiveDB.ALRTLVL = 6;
           System.err.println(LiveDB.grassHopper("Notify Email Sent for TakeExternalBackupToMailBox() Failed after Retries"));
           return false;
        }
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:GenericReportWriter.java -- search for "print"
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean MailOutReports (String p_TOEMAIL, String p_reportfile)
 *
 * Parameters : String p_TOEMAIL -- To Email Id mandatory you can also override what is in ArtLeaves.java
 *              String p_reportfile -- the Decoded Report File as an attachment
 *
 * Returns : boolean true if mail message with reportfile attachment hopped out of your sending mailbox
 *                        and also a notification email hopped out of your mailbox
 *           boolean false if message did not hop out of your sending mailbox or any other error
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Data File : p_reportfile
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to Mailout reports with several retries to other MailBoxes.
 * Your question why cant i use PrepareAndSendMailMesg (). Yes you can but this handy wrapper method takes
 * care of all validations and the retries and notify messages and also sends out a notification email to
 * your notification mailbox which is the only mailbox the proprietor of company will have to check. This
 * notification mail box will inform the proprietor about emails received in other mailboxes.
 *
 * Technical Reference : None.
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean MailOutReports (String p_TOEMAIL, String p_reportfile){
        
        String notify = null;

        if (p_reportfile == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Report File not specified"));
            return false;
        }

        if (p_TOEMAIL == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("To EMAIL ID not specified"));
            return false;
        }

        if (new File(p_reportfile).isFile() == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("MailOutReports Invalid Attachment Specified:" + p_reportfile ));
            return false;
        }

        if (PrepareAndSendMailMesg(null, null, p_TOEMAIL,
            ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null, "EMAIL FROM " + LiveDB.NODENAME,
            "Report File Attached Copy to External Media, Delete from MailBox", p_reportfile)
            == false)
        {
            // Retry to a different mailbox
            if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11(),
                ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                "EMAIL FROM " + LiveDB.NODENAME,
                "Report File Attached Copy to External Media, Delete from MailBox",
                p_reportfile) == false)
            {
                // if you want you can give it yet another retry from that other mandatory gmailid
                // maybe something wrong with this gmail account you are sending out from
                // but this retry will succeed only if password for both email accounts is common
                // otherwise type in the password here
                // THIS IS RETRY FROM A DIFFERENT MAILBOX
                if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(), null,
                    p_TOEMAIL,
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                    "EMAIL FROM " + LiveDB.NODENAME,
                    "Report File Attached Copy to External Media, Delete from MailBox",
                    p_reportfile) == false)
                {
                    System.err.println(LiveDB.grassHopper("MailOutReports Retry Failed Contact gmail services"));
                    return false;
                }
                else notify = "Report File sent to email id:" + p_TOEMAIL;
            }
            else
            {
                LiveDB.ALRTLVL = 5;
                System.err.println(LiveDB.grassHopper(notify = "Report File sent to email id:" +
                       ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail11()));
            }
        }
        else notify = "Report File sent to email id:" + p_TOEMAIL;

        if (SendNotificationEmail(notify) == false)
        {
                LiveDB.ALRTLVL = 6;
                System.err.println(LiveDB.grassHopper("Notify Email Sent for MailOutReports() Failed after Retries"));
                return false;
        }
        
        return true;
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:InvoicePage.java
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean EmailInvoice (String p_invoice)
 *
 * Parameters : String p_invoice -- The INVOICE attachment file as text file
 *
 * Returns : boolean true if mail message with invoicefile attachment hopped out of your sending mailbox
 *                        and also a notification email hopped out of your mailbox
 *           boolean false if message did not hop out of your sending mailbox or any other error
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Data File : p_invoice
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to Mail INVOICES with several retries to other MailBoxes.
 * Your question why cant i use PrepareAndSendMailMesg (). Yes you can but this handy wrapper method takes
 * care of all validations and the retries and notify messages and also sends out a notification email to
 * your notification mailbox which is the only mailbox the proprietor of company will have to check. This
 * notification mail box will inform the proprietor about emails received in other mailboxes.
 *
 * Technical Reference : None.
 *
 * Start Date: 30th September 2011
 * End Date: 30th September 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  protected static boolean EmailInvoice (String p_invoice)
  {
      String notify = null;

      if (p_invoice == null)
      {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invoice File not specified"));
            return false;
      }

      if (new File(p_invoice).isFile() == false)
      {
          LiveDB.ALRTLVL = 7;
          System.err.println(LiveDB.grassHopper("EmailInvoice Invalid Attachment Specified:" + p_invoice ));
          return false;
      }

      if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5(),
            ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null, "EMAIL FROM " + LiveDB.NODENAME,
            "Invoice File Attached Copy to External Media, Delete from MailBox", p_invoice)
            == false)
      {
            // Retry to a different mailbox
            if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                "EMAIL FROM " + LiveDB.NODENAME,
                "Invoice File Attached Copy to External Media, Delete from MailBox",
                p_invoice) == false)
            {
                // if you want you can give it yet another retry from that other mandatory gmailid
                // maybe something wrong with this gmail account you are sending out from
                // but this retry will succeed only if password for both email accounts is common
                // otherwise type in the password here
                // THIS IS RETRY FROM A DIFFERENT MAILBOX
                if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(), null,
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5(),
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                    "EMAIL FROM " + LiveDB.NODENAME,
                    "Invoice File Attached Copy to External Media, Delete from MailBox",
                    p_invoice) == false)
                {
                    System.err.println(LiveDB.grassHopper("EmailInvoice Retry Failed Contact gmail services"));
                    return false;
                }
                else notify = "Invoice File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4();
            }
            else notify = "Invoice File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4();
      }
      else notify = "Invoice File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5();

      if (SendNotificationEmail(notify) == false)
      {
          LiveDB.ALRTLVL = 6;
          System.err.println(LiveDB.grassHopper("Notify Email Sent for EmailInvoice() Failed after Retries"));
          return false;
      }

      return true;
  }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:InvoicePage.java
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean MailCustomerDetailFile (String p_cdetfile)
 *
 * Parameters : String p_cdetfile -- The Customer Detail attachment file as text file
 *
 * Returns : boolean true if mail message with customer detail file attachment hopped out of your sending mailbox
 *                        and also a notification email hopped out of your mailbox
 *           boolean false if message did not hop out of your sending mailbox or any other error
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Data File : p_cdetfile
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to Mail Customer Detail File with several retries to other MailBoxes.
 * Your question why cant i use PrepareAndSendMailMesg (). Yes you can but this handy wrapper method takes
 * care of all validations and the retries and notify messages and also sends out a notification email to
 * your notification mailbox which is the only mailbox the proprietor of company will have to check. This
 * notification mail box will inform the proprietor about emails received in other mailboxes.
 *
 * Technical Reference : None.
 *
 * Start Date: 30th September 2011
 * End Date: 30th September 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  protected static boolean MailCustomerDetailFile (String p_cdetfile){

      String notify = null;

      if (p_cdetfile == null)
      {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Customer Detail File not specified"));
            return false;
      }

      if (new File(p_cdetfile).isFile() == false)
      {
          LiveDB.ALRTLVL = 7;
          System.err.println(LiveDB.grassHopper("MailCustomerDetailFile Invalid Attachment Specified:" + p_cdetfile ));
          return false;
      }

      if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5(),
            ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null, "EMAIL FROM " + LiveDB.NODENAME,
            "Customer Detail File Attached Copy to External Media, Delete from MailBox", p_cdetfile)
            == false)
      {
            // Retry to a different mailbox
            if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                "EMAIL FROM " + LiveDB.NODENAME,
                "Customer Detail File Attached Copy to External Media, Delete from MailBox",
                p_cdetfile) == false)
            {
                // if you want you can give it yet another retry from that other mandatory gmailid
                // maybe something wrong with this gmail account you are sending out from
                // but this retry will succeed only if password for both email accounts is common
                // otherwise type in the password here
                // THIS IS RETRY FROM A DIFFERENT MAILBOX
                if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(), null,
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5(),
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                    "EMAIL FROM " + LiveDB.NODENAME,
                    "Customer Detail File Attached Copy to External Media, Delete from MailBox",
                    p_cdetfile) == false)
                {
                    System.err.println(LiveDB.grassHopper("MailCustomerDetailFile Retry Failed Contact gmail services"));
                    return false;
                }
                else notify = "Customer Detail File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4();
            }
            else notify = "Customer Detail File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4();
      }
      else notify = "Customer Detail File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5();

      if (SendNotificationEmail(notify) == false)
      {
          LiveDB.ALRTLVL = 6;
          System.err.println(LiveDB.grassHopper("Notify Email Sent for MailCustomerDetailFile() Failed"));
          return false;
      }
      
      return true;
  }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:InvoicePage.java
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.LiveSharedDB, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean EasyMail (String p_custemail, String p_mailbody, String p_file)
 *
 * Parameters :
 * String p_custemail -- Customers email id
 * String p_mailbody -- The email body text
 * String p_file -- The attachment file as text file
 *
 * Returns : boolean true if mail message with file attachment hopped out of your sending mailbox
 *                        and also a notification email hopped out of your mailbox
 *           boolean false if message did not hop out of your sending mailbox or any other error
 *
 * Associated Methods : protected static boolean SendNotificationEmail (String p_mesg)
 *                      protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                           String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Data File : p_file
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to Mail RMA File with several retries to other MailBoxes. Your
 * question why cant i use PrepareAndSendMailMesg (). Yes you can but this handy wrapper method takes care
 * of all validations and the retries and notify messages and also sends out a notification email to your
 * notification mailbox which is only mailbox the proprietor of company will have to check. This
 * notification mail box will inform proprietor about emails received in other mailboxes.
 * The difference between this Wrapper Method and other Wrapper methods is that the sequence of retries
 * has changed a bit.
 *
 * NOTE:- This EasyMail method can be used as a generic to email anybody with mailbody and any attachment.
 *
 * Technical Reference : None.
 *
 * Start Date: 4th October 2011
 * End Date: 4th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
  protected static boolean EasyMail (String p_custemail, String p_mailbody, String p_file){

      String notify = null;
      

      if (p_custemail == null)
      {
          LiveDB.ALRTLVL = 3;
          System.err.println(LiveDB.grassHopper("custemail id null in EasyMail substituting with "
                  + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5()));
          p_custemail = ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5();
      }

      if (new File(p_file).isFile() == false)
      {
          LiveDB.ALRTLVL = 7;
          System.err.println(LiveDB.grassHopper("EasyMail Invalid Attachment Specified:" + p_file ));
          return false;
      }

      if (PrepareAndSendMailMesg(null, null, p_custemail,
            ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
            "EMAIL FROM " + LiveDB.NODENAME, p_mailbody == null ?
            p_file + " File Attached Copy to External Media, Delete from MailBox":p_mailbody, p_file)
            == false)
      {
            // if you want you can give it yet another retry from that other mandatory gmailid
            // maybe something wrong with this gmail account you are sending out from
            // but this retry will succeed only if password for both email accounts is common
            // otherwise type in the password here
            // THIS IS RETRY FROM A DIFFERENT MAILBOX
            if (PrepareAndSendMailMesg(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail5(), null,
                    p_custemail,
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                    "EMAIL FROM " + LiveDB.NODENAME,
                    p_file + " File Attached Copy to External Media, Delete from MailBox" + '\n'
                    + "Could not be emailed to " + p_custemail + " " + p_mailbody,
                    p_file) == false)
            {
                // Retry to a different mailbox
                if (PrepareAndSendMailMesg(null, null, ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4(),
                    ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13(), null,
                    "EMAIL FROM " + LiveDB.NODENAME,
                    p_file + " File Attached Copy to External Media, Delete from MailBox" + '\n'
                    + "Could not be emailed to " + p_custemail + " " + p_mailbody,
                    p_file) == false)
                {
                    System.err.println(LiveDB.grassHopper("MailRMA() Retry Failed Contact gmail services"));
                    return false;
                }
                else notify = p_file + " File sent to email id:" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail4();
            }
            else notify = p_file + " File sent to email id:" + p_custemail;

      }
      else notify = p_file + " File sent to email id:" + p_custemail;

      if (SendNotificationEmail(notify) == false)
      {
          LiveDB.ALRTLVL = 6;
          System.err.println(LiveDB.grassHopper("Notify Email Sent for EasyMail() Failed"));
          return false;
      }

      return true;
  }
  
/*
 * WIRING DIAGRAM :
 * @LOOKSY:ArtLeaves.java -- Everything in there
 * @LOOKSY:LiveDB.GMAILUSERNAME, LiveDB.GMAILPASSWORD, LiveDB.NODENAME, LiveDB.grassHopper(), LiveDB.ALRTLVL
 *
 * Method Name : protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd,
 *                          String p_sendTo, String p_copyTo, String p_Bcc,String p_subject, String p_text,
 *                                                                                          String p_attach)
 * Parameters : String p_from -- gmail id from which to send emails can be null will default to GMAILUSERNAME
 *              String p_frompasswd -- password can be null will default to GMAILPASSWORD or new password will
 *                                     will reset GMAILPASSWORD to the one you supplied
 *              String p_sendTo -- To email address
 *              String p_copyTo -- Copy to email address
 *              String p_Bcc -- Bcc email address
 *              String p_subject -- subject line of email can be null then it will default to
 *                                  "Message from " + host + " Node:" + NODENAME
 *              String p_text -- Body Text
 *              String p_attach -- The attachment with complete canonical path
 *
 * Returns : boolean true if message hopped out of your sending mailbox
 *           boolean false if message did not hop out of your sending mailbox or any other error
 *
 * Calling Wrapper Methods : protected static boolean MailOutReports (String p_TOEMAIL, String p_reportfile)
 *                           protected static boolean TakeExternalBackupToMailBox (String p_bkupfile)
 *                           protected static boolean SendDumpFileMessages ()
 *                           protected static boolean SendLogFileMessage ()
 *                           protected static boolean SendNotificationEmail (String p_mesg)
 * 
 * Data File : p_attach
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is the fundamental mail mechanism for all the other wrapper mail
 * methods. What it does is self explanatory if you just read the params and the method declaration.
 * It uses the gmail free email service to send out mails. Normally there is some limit of about 150
 * emails with these carriers. We wont be exceeding that limit even with the wildest usage. Even if
 * you use the Custom Bulk Email facility of LensView filter down the email ids to just 75 customers
 * at best. The LensView application will itself need 75 emails to be sent but not all at once.
 * Just one thing dont change this mail session Session.getDefaultInstance(props) to getInstance(props)
 * because the one i have plugged in will hold during multi-part messages. You can change the settings
 * in you mailbox for send of multipart messages.
 *
 * Technical Reference : None.
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 * Last Modification Date : 30th September 2011
 * Last Modified : There is this mandatory email id in ArtLeaves.java email13. So if novice
 * programmer has passed p_copyTo or p_Bcc as null then we include this email13 for critical
 * backup of all business emails. This mailbox must be backed up periodically to external
 * media and mailbox contents deleted to make space for new emails since this is a heavily
 * used mailbox and there may be space restrictions on this mailbox imposed by service provider.
 * In the other case he may not have specified email13 in either CC or BCC at all. Therefore to
 * deal with this error this patch of code as follows
        if (p_sendTo == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Send Email To not specified" + p_sendTo));
            return false;
        }

        if (p_sendTo.indexOf(",") == 0 || p_sendTo.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_sendTo));
            return false;
        }

        if (p_from.indexOf(",") == 0 || p_from.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_from));
            return false;
        }

        if (p_copyTo.indexOf(",") == 0 || p_copyTo.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_copyTo));
            return false;            
        }

        if (p_Bcc.indexOf(",") == 0 || p_Bcc.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_Bcc));
            return false;            
        }

        if (p_copyTo.indexOf(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13()) == -1)
        {
            if (p_Bcc != null
                && p_Bcc.indexOf(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13()) == -1)
            {
                if (p_Bcc.lastIndexOf(";") == -1 && p_Bcc.lastIndexOf(",") == -1)
                    p_Bcc += (";" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13());
                else if (p_Bcc.lastIndexOf(";") == p_Bcc.length() -1
                                   || p_Bcc.lastIndexOf(",") == p_Bcc.length() -1)
                    p_Bcc += ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13();
                else if (p_Bcc.lastIndexOf(";") != p_Bcc.length() -1
                                   || p_Bcc.lastIndexOf(",") != p_Bcc.length() -1)
                     p_Bcc += (";" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13());
            }
            else p_Bcc = ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13();
        }
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean PrepareAndSendMailMesg (String p_from, String p_frompasswd, String p_sendTo,
            String p_copyTo, String p_Bcc,String p_subject, String p_text, String p_attach) {

        // We will support only single attachment. We are sending in Parts but
        // it will clog up i fear with large attachments at times
        // actually cleaning your drainage is not my job !!

        if (p_attach != null)
        {
            if (new File(p_attach).isFile() == false)
            {
                LiveDB.ALRTLVL = 7;
                System.err.println(LiveDB.grassHopper("Invalid Attachment:" + p_attach));
                return false;
            }
        }

        if (p_sendTo == null)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Send Email To not specified" + p_sendTo));
            return false;
        }

        if (p_sendTo.indexOf(",") == 0 || p_sendTo.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_sendTo));
            return false;
        }

        if (p_from.indexOf(",") == 0 || p_from.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_from));
            return false;
        }

        if (p_copyTo.indexOf(",") == 0 || p_copyTo.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_copyTo));
            return false;            
        }

        if (p_Bcc.indexOf(",") == 0 || p_Bcc.indexOf(";") == 0)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid EmailID:" + p_Bcc));
            return false;            
        }


        if (p_copyTo.indexOf(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13()) == -1)
        {
            if (p_Bcc != null
                && p_Bcc.indexOf(((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13()) == -1)
            {
                if (p_Bcc.lastIndexOf(";") == -1 && p_Bcc.lastIndexOf(",") == -1)
                    p_Bcc += (";" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13());
                else if (p_Bcc.lastIndexOf(";") == p_Bcc.length() -1
                                   || p_Bcc.lastIndexOf(",") == p_Bcc.length() -1)
                    p_Bcc += ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13();
                else if (p_Bcc.lastIndexOf(";") != p_Bcc.length() -1
                                   || p_Bcc.lastIndexOf(",") != p_Bcc.length() -1)
                     p_Bcc += (";" + ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13());
            }
            else p_Bcc = ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail13();
        }

        int i = 0, bi = -1;
        Address [] tomany = null;
        Address [] ccmany = null;
        Address [] bccmany = null;

        // check for multiple to addresses
        if (p_sendTo.indexOf(';') != -1 || p_sendTo.indexOf(',') != -1)
        {
            do{
                  try{
                        tomany[i] = new InternetAddress(p_sendTo.substring(bi+1,
                        bi = p_sendTo.indexOf(';') == -1 ? p_sendTo.indexOf(','):p_sendTo.indexOf(';')));
                  }catch (AddressException ex_NOKIA73){
                      System.err.println(LiveDB.grassHopper(ex_NOKIA73));
                      return false;
                  }
                  i++;
            }while (p_sendTo.indexOf(';') != -1 || p_sendTo.indexOf(',') != -1);

            try{
                   tomany[i] = new InternetAddress(p_sendTo.substring(bi+1,
                   bi = p_sendTo.indexOf(';') == -1 ? p_sendTo.indexOf(','):p_sendTo.indexOf(';')));
               }catch (AddressException ex_NOKIA3){
                   System.err.println(LiveDB.grassHopper(ex_NOKIA3));
                   return false;
               }
        }
        
        // check for multiple copy addresses
        bi = -1; i = 0;
        if (p_copyTo.indexOf(';') != -1 || p_copyTo.indexOf(',') != -1)
        {
            do{
                  try{
                        ccmany[i] = new InternetAddress(p_copyTo.substring(bi+1,
                        bi = p_copyTo.indexOf(';') == -1 ? p_copyTo.indexOf(','):p_copyTo.indexOf(';')));
                  }catch (AddressException ex_NOKIA73){
                      System.err.println(LiveDB.grassHopper(ex_NOKIA73));
                      return false;
                  }
                  i++;
            }while (p_copyTo.indexOf(';') != -1 || p_copyTo.indexOf(',') != -1);

            try{
                   ccmany[i] = new InternetAddress(p_copyTo.substring(bi+1,
                   bi = p_copyTo.indexOf(';') == -1 ? p_copyTo.indexOf(','):p_copyTo.indexOf(';')));
               }catch (AddressException ex_NOKIA3){
                   System.err.println(LiveDB.grassHopper(ex_NOKIA3));
                   return false;
               }
        }

        // check for multiple BCC addresses
        // dont permit your wife to compile this program
        bi = -1; i = 0;
        if (p_Bcc.indexOf(';') != -1 || p_Bcc.indexOf(',') != -1)
        {
            do{
                  try{
                        bccmany[i] = new InternetAddress(p_Bcc.substring(bi+1,
                        bi = p_Bcc.indexOf(';') == -1 ? p_Bcc.indexOf(','):p_Bcc.indexOf(';')));
                  }catch (AddressException ex_NOKIA73){
                      System.err.println(LiveDB.grassHopper(ex_NOKIA73));
                      return false;
                  }
                  i++;
            }while (p_Bcc.indexOf(';') != -1 || p_Bcc.indexOf(',') != -1);

            try{
                   bccmany[i] = new InternetAddress(p_Bcc.substring(bi+1,
                   bi = p_Bcc.indexOf(';') == -1 ? p_Bcc.indexOf(','):p_Bcc.indexOf(';')));
               }catch (AddressException ex_NOKIA3){
                   System.err.println(LiveDB.grassHopper(ex_NOKIA3));
                   return false;
               }
        }

        
        String host = "smtp.gmail.com";        
        String from = p_from;
        String password = p_frompasswd;
        String to = p_sendTo;
        String cc = p_copyTo;
        String bcc = p_Bcc;   // for secretary second wife (ves?)
        String body = p_text;
        String subject = p_subject;
        String SSL_FACTORY = "javax.net.ssl.SSLSocketFactory";
        String filename = new String (p_attach.toCharArray()); // attachment filename
        Boolean debug = true; // this will tell you if mailed hopped out of your server
                              // further down you cant track

        if (from == null)
            from = GMAILUSERNAME; // take the default
                       
        if (p_from == null && password != null)
            GMAILPASSWORD = password; // you may changed the password !!!

        if (password == null)
            password = GMAILPASSWORD; // same password for several accounts

        Properties props = System.getProperties();
        // this will handle parallelism, thread safety blah blah by itself
        props.put("mail.host", host);
        props.put("mail.smtp.host", host);
        props.put("mail.transport.protocol", "smtp");
        props.put("mail.smtp.auth", "true"); 
        props.put("mail.smtp", true);
        // we will use the gmail server 465 to sendFrom since you wont get an email id at any
        // Corporate if you are not an employee.
        props.put("mail.smtp.port", "465");
        props.put("mail.smtp.socketFactory.fallback", "false");
        props.put("mail.smtp.socketFactory.class", SSL_FACTORY);

        // Get the default Session object.
        // Session session = Session.getDefaultInstance(properties);
        // If there is a problem here we will have to use Authenticator
        // and pass input non-interactively then you change this call to
        // Session.getDefaultInstance(props,authenticator) and connect to port 587 of gmail.
        Session thismailing = Session.getDefaultInstance(props);
        thismailing.setDebug(debug);

        if (subject == null)
            subject = "Message from " + host + " Node:" + NODENAME ;

        if (p_from == null) ((ArtLeaves)LiveDB.LiveSharedDB[ar][0]).getEmail1();
        // must be a gmail account
        if (p_from.toLowerCase().indexOf("gmail") == -1)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("p_From must be valid gmail account:" + p_from));
            return false;
        }
        else if (p_from.length() < 16)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid gmail id:" + p_from));
            return false;
        }
        
        // Define message
        Message message = new MimeMessage(thismailing);
        // MessagingException
        // AddressException
        try{
            message.setFrom(new InternetAddress(from));
            if (tomany.length == 1)
                message.addRecipient(Message.RecipientType.TO,
                    new InternetAddress(new String(to.toCharArray())));
            else if (tomany.length != 0)
                message.addRecipients(Message.RecipientType.TO, tomany);

            if (ccmany.length == 1)
                message.addRecipient(Message.RecipientType.CC, new InternetAddress(new String(cc.toCharArray())));
            else if (ccmany.length != 0)
                message.addRecipients(Message.RecipientType.CC, ccmany);

            if (bccmany.length == 1)
                message.addRecipient(Message.RecipientType.BCC, new InternetAddress(new String(bcc.toCharArray())));
            else if (bccmany.length != 0)
                message.addRecipients(Message.RecipientType.BCC, bccmany);
            
            message.setSubject(subject);
            if (p_attach == null) // for attachments sendmessage will take care
                message.setContent(body, "text/html");
            
        }catch (MessagingException ex_NOKIA91){
            System.err.println(LiveDB.grassHopper("To:" + to +  " CC:" + cc + " BCC:" + bcc
                    + " SUBJECT:" + subject, ex_NOKIA91));
            return false;
        }
        
        if (p_attach != null)
        {
            // Create the message part
            BodyPart messageBodyPart = new MimeBodyPart();
            // Fill the message
            try{
                messageBodyPart.setText(body);
            }catch (MessagingException ex_NOKIA91){
                System.err.println(LiveDB.grassHopper(ex_NOKIA91));
                return false;
            }

            Multipart multipart = new MimeMultipart();
            try{
                multipart.addBodyPart(messageBodyPart);
            }catch (MessagingException ex_NOKIA91){
                System.err.println(LiveDB.grassHopper(ex_NOKIA91));
                return false;
            }

            // Part two is attachment
       
            messageBodyPart = new MimeBodyPart();
            
            DataSource source = new FileDataSource(filename);
            try{
                messageBodyPart.setDataHandler(new DataHandler(source));
                messageBodyPart.setFileName(new String(filename.toCharArray()));
                multipart.addBodyPart(messageBodyPart);
                // Put parts in message
                message.setContent(multipart);
            }catch (MessagingException ex_NOKIA91){
                System.err.println(LiveDB.grassHopper("Attachment Filename:" + filename, ex_NOKIA91));
                return false;
            }
        }

        Transport airmail = null;
        try{
              airmail = thismailing.getTransport("smtp");
        }catch (javax.mail.NoSuchProviderException ex_NOKIA77){
            return false;
        }
        

        try{
        airmail.connect(host, new String(from.toCharArray()), new String(password.toCharArray()));
        }catch (MessagingException ex_NOKIA71){
            System.err.println(LiveDB.grassHopper(ex_NOKIA71));
            return false;
        }

        try{
        // Send the message
        airmail.sendMessage(message, message.getAllRecipients());
        }catch (MessagingException ex_NOKIA91){
            System.err.println(LiveDB.grassHopper(ex_NOKIA91));
            return false;
        }

        try{
        airmail.close();
        }catch (MessagingException ex_NOKIA91){
            System.err.println(LiveDB.grassHopper(ex_NOKIA91));
            return false;
        }
        
        return debug ;
    }
    
/*
 * WIRING DIAGRAM :
 * @LOOKSY:GenericReportWriter.java -- search for this method name
 * @LOOKSY:LiveDB.grassHopper(), LiveDB.ALRTLVL, LiveDB.minrepid, LiveDB.maxrepid
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.DecodedReport
 *
 * Method Name : protected static boolean ReportDecoder (String p_file, int p_repid)
 * Parameters : String p_file -- A file of raw bytes to be decoded into a character file. Canonical path
 *              int p_repid --  The report id can be guessed but would be better if you supply it.
 * 
 * Returns : boolean true if file of raw bytes was decoded into a character readable file
 *           boolean false if file of raw bytes could not be decoded into a character readable file
 *           OR streams error or any other error
 *
 * Data File : p_file converted into a Character File in LiveDB.serializedfilespath/tmp/p_file*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is used to convert a file of raw bytes into a Character readable file.
 * This is used mainly for reports but you could mis-use it for other files also. That decoded character
 * filename with complete path will be contained in the Hashmap DecodedReport.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 2nd June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean ReportDecoder (String p_file, int p_repid)
    {
        if (p_repid < LiveDB.minrepid || p_repid > LiveDB.maxrepid)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("Invalid report id:" + p_repid));
            return false;            
        }
        
        if (p_file == null)
            return false;

        if (new File(p_file).isFile() == false)
        {
            LiveDB.ALRTLVL = 7;
            System.err.println(LiveDB.grassHopper("parameter to ReportDecoder is not File:" + p_file));
            return false;
        }

        if (new File(p_file).canWrite())
        {
            LiveDB.ALRTLVL = 2;
            System.err.println(LiveDB.grassHopper("Report File has been tampered with File:" + p_file));
            return false;
        }

        char fl [] = null;
        for (int i = 0; i < 17; i++)
        {
            fl[i] = (char)('A' + new Random().nextInt(23));
        }
        
        DecodedReport.put(p_repid, LiveDB.serializedfilespath + "tmp".concat(p_file).concat(new String(fl))); // generate this

        FileInputStream fis = null;
        try{
         fis = new FileInputStream(new File(p_file));
        }catch(FileNotFoundException ex_NOKIA51){
            LiveDB.ALRTLVL = 2;
            System.err.println(LiveDB.grassHopper(ex_NOKIA51, "File has been deleted just now"));
            return false;
        }

        InputStreamReader isr = null;

        isr = new InputStreamReader (fis);

        FileWriter fw = null;

        try{
          fw = new FileWriter (new File(DecodedReport.get(p_repid)));
        }catch(IOException ex_NOKIA33){
            System.err.println(LiveDB.grassHopper(ex_NOKIA33, "new FileWriter failed"));
            return false;
        }

// set the directory perms first

        if (new File(LiveDB.serializedfilespath + "tmp").canWrite())
        {
            System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                        + "tmp"));
        }
        else
        {
            if (new File(LiveDB.serializedfilespath + "tmp").setWritable(true, false) == false)
            {
                System.err.println(LiveDB.grassHopper("Cant setWritable File:" + LiveDB.serializedfilespath
                                                                                         + "tmp"));
                LiveDB.system_exit = 1;
                LiveDB.SmoothExitCondition.signalAll();
            }
        }

        char In[] = null;
        int i = -1;
        int c = 0;
        int off = 0;

        try{
            if (isr.ready())  // one char at a time although slow if stream corrupted you will know
            {                // also i dont know how that stream of raw bytes has been written
                do{
                    i++;
                    c = isr.read();
                    if (c != -1) 
                        In[i] = (char)c;
                    if (In.length == 512)
                    {
                        fw.write(In, off, In.length);
                        fw.flush();
                        if (c != -1)
                            off = In.length;
                    }
                }while(c != -1);
                fw.write(In, off, In.length);
                fw.close();
                isr.close();
            }
            else
            {
                LiveDB.ALRTLVL = 4;
                System.err.println(LiveDB.grassHopper("InputStream not ready"));
                return false;
            }
        }catch(IOException ex_NOKIA12){
              LiveDB.ALRTLVL = 4;
              System.err.println(LiveDB.grassHopper(ex_NOKIA12, "InputStream not ready or corrupted"));
              return false;
        }

        if (new File(DecodedReport.get(p_repid)).setReadOnly() == false)
            System.err.println(LiveDB.grassHopper("Unable to setReadonly DecodedReport:" +  DecodedReport.get(p_repid)));

        if (new File (LiveDB.serializedfilespath + "tmp").setReadOnly() == false)
        {
            LiveDB.ALRTLVL = 3;
            System.err.println(LiveDB.grassHopper("Cant setReadonly File:" + LiveDB.serializedfilespath 
                                                                                                 + "tmp"));
        }

        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:RefreshDatabase.java
 * @LOOKSY:Spy.java
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.TrainsInWaiting, LiveDB.CABINGATEC, LiveDB.Action, LiveDB.READINPROGRESSLOCKS
 * @LOOKSY:LiveDB.READINPROGRESS, LiveDB.system_exit, LiveDB.SmoothExitCondition, LiveDB.serializedfilespath
 * @LOOKSY:LiveDB.FILESEPERATOR, LiveDB.MAXPLATFORMENTRIES
 *
 * Method Name : protected static boolean QueueTrainsInWaiting (PlatformClearance mytrain, FileChannel ch,
 *                                                                             FileLock fl, int requestno )
 * Parameters : PlatformClearance mytrain -- It is this that needs to Queued
 *              FileChannel ch -- This is the channel on which you are going to I/O
 *              FileLock fl --  We will fill this up for ya.
 *              int requestno -- This is randomly generated request number (token as at railway reservations)
 *                               which you should look for.
 *
 * Returns : boolean true if your request is offered to queue and accepted and departure time set
 *           boolean false if streams error
 *
 * Calling Methods : RefreshDatabase::protected static boolean read_database (int tableno)
 *                   LiveDB::protected static boolean commit_database (int p_Tableno)
 *                   Spy::protected static void dump()
 *                   Many other methods can call it
 *
 * Associated Methods: LiveDB::private static boolean CheckPreviousIncompleteRequests (Date p_request_time)
 *                     LiveDB::protected static boolean DeQueueTrainsInWaiting ()
 *                     LiveDB::protected static boolean Prankster (File prankfile,int tbl,boolean IPCSSYNCFILE)
 * Associated Triggers : LiveDB::protected static enum InterProcessSynchronization
 *
 * Synchronization Files : LiveDB.serializedfilespath/syc/ipcssync_*.syc,
 *                         LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method queue's requests in LiveDB.TrainsInWaiting. You must queue your
 * request in LiveDB.TrainsInWaiting for every database related I/O. Some LiveDB.Action are optional.
 * You dont have to queue such requests. For example OTHERS and REPORTWRITER. OTHERS is just used for
 * Benchmarking. THIS IS THE STANDARD PROCEDURE BUT NORMS MAY BE VIOLATED AT SOME STATIONS FOR EXAMPLE
 * method protected final boolean get_DataEntryFile(int tableno) of IntranetCompliantRadioTaggedCollar.java
 * manually queue's it because locks and final channels are not involved in that method.
 *
 * The flow of the Algorithm is as below.
 * It checks the entries already in LiveDB.TrainsInWaiting if these are greater than MAXPLATFORMENTRIES
 * it keeps looping until it can get a leg in. Reduce this MAXPLATFORMENTRIES to just 5 after testing.
 * Because it should not exceed those many pending requests at any given point in time for acceptable
 * performance levels. That ArrayDeque TrainInWaiting let the initial capacity default to 16. Next it
 * offers your train (mytrain) to the queue which is constructed on PlatformClearance. So you have
 * joined the queue now wait until your token number is displayed (requestno idiot). Next step you
 * call this method CheckPreviousIncompleteRequests(). This step is necessary it does Inter-Station
 * synchronization. TrainsInWaiting contains requests for you sid (station id or process id alone). So
 * there may be some train at some other station who queued his request at his local queue before you.
 * So basic manners dictate aaap pehlaa. So you wait for those critters before you at other sid's to
 * finish their requests and then you proceed. Then just like the safety valve on the pressure cooker
 * you check if some other chap is writing if your intention is to read. You allow him to complete his
 * book write before you read. Common sense ! Then you get an appropriate lock on the file. If your
 * intention is to READ then you create a readinprogress file to tell the other bugar not to scribble.
 * And then you set the departure time of your request. Wondering what happened to write. Magic when
 * you instantiated mytrain PlatformClearance constructor has already triggered InterProcessSynchronization
 * which has created the ipcssync_ file while this method is being executed. Somewhat like that
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean QueueTrainsInWaiting (PlatformClearance mytrain, FileChannel ch, 
                                                                   FileLock fl, int requestno )
    {
        boolean ok = true;
        Object adhoclock = new Object();
        PlatformClearance pr = null;

        synchronized(adhoclock){
            /* Check the local queue first then queue your request number
             * or goahead if queue is empty
             */
             if (LiveDB.TrainsInWaiting.isEmpty()== false)
             {
                 /* NOT EMPTY Then queue your request also and keep waiting */
                 yellingatstationmaster:
                 while (LiveDB.TrainsInWaiting.size() > LiveDB.MAXPLATFORMENTRIES)
                 {
                      System.err.println(LiveDB.grassHopper("Failed platform clearance method read_database "
                                           + mytrain.getTrainid().getTrain()));
                      continue yellingatstationmaster;
                 }
              }

             /* queue your request also (discipline) but you have permission
              * to proceed immediately FlyingScottsMan if isEmpty == true
              */

              LiveDB.CABINGATEC.acquireUninterruptibly();

              do{ /* be disciplined add your request to the queue and wait your turn */
                    ok = LiveDB.TrainsInWaiting.offer (mytrain) ;
              }while (ok == false);

              topeep:  /* chutiya ki sarkari naukri hai keep peeping */
              while ((LiveDB.TrainsInWaiting.peek()).getRequestno() != requestno)
                  continue topeep;
              
              // Check Previous Requests. This is that tiny bug i mentioned in the documentation of
              // PlatformClearance. We are not not merging the TrainInWaiting belonging to different
              // processes anywhere so we do this to check requests of other processes that may still
              // be incomplete.
              towait:
              while ( CheckPreviousIncompleteRequests(mytrain.getRequest_time()) )
                      continue towait;

              // Okay now one final check
              if (mytrain.getRequest_type() == LiveDB.Action.READOBJECT.ordinal())
              {
                    // check if an ipcs file exists for this Object number created by any process.
                    // Then that means that some process is writing this Object number to disk so
                    // wait a while until it completes. Only then must you read !!
                    towait:
                    while (new File (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "ipcssync_"
                            + ((TrainRunningInformation)((PlatformClearance)mytrain)
                                                    .getTrainid()).getTrain() + ".syc").exists())
                        continue towait;
              }
              LiveDB.CABINGATEC.release();
         } // synchronized (lock)

         togetlock:
         do
         {
               try{
                     /* get a shared lock for read keep trying */
                     if (mytrain.getRequest_type() == LiveDB.Action.READOBJECT.ordinal()
                         || mytrain.getRequest_type() == LiveDB.Action.READFILES.ordinal()
                         || mytrain.getRequest_type() == LiveDB.Action.READLINE.ordinal())
                         fl = ch.tryLock(0L, Long.MAX_VALUE, true);
                     else
                         fl = ch.tryLock(); // get an exclusive lock on the entire godammn file
                  }catch (OverlappingFileLockException ex_NOKIA97){
                       continue togetlock;
                  }catch (ClosedChannelException ex_NOKIA98){
                      if (LiveDB.DeQueueTrainsInWaiting() == false)
                      {
                          LiveDB.ALRTLVL = 7; // programming screwup most probably
                          System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                      }
                      System.err.println(LiveDB.grassHopper(ex_NOKIA98, "File:" + LiveDB.serializedfilespath +
                      ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][mytrain.getTrainid().getTrain()]).getFilename() + ".ser"));
                      return ok = false;
                  }catch (IOException ex_NOKIA99){
                      if (LiveDB.DeQueueTrainsInWaiting() == false)
                      {
                          LiveDB.ALRTLVL = 7; // programming screwup most probably
                          System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                      }
                      System.err.println(LiveDB.grassHopper(ex_NOKIA99, "File:" + LiveDB.serializedfilespath
                      + ((FileTableDataFileMap)LiveDB.LiveSharedDB[ft][mytrain.getTrainid().getTrain()]).getFilename() + ".ser"));
                      return ok = false;
                  }
         }while (fl == null);

         // create just one more file for this Object number. This is basically to
         // prevent a write from starting while you are reading some database table file

         if (mytrain.getRequest_type() == LiveDB.Action.READOBJECT.ordinal()
                         || mytrain.getRequest_type() == LiveDB.Action.READFILES.ordinal()
                         || mytrain.getRequest_type() == LiveDB.Action.READLINE.ordinal())
         {
             try{
                    if (new File(LiveDB.serializedfilespath + "syc").canWrite())
                    {
                        System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "syc"));
                    }
                    else
                    {
                        if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                        {
                            System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                            LiveDB.system_exit = 1;
                            LiveDB.SmoothExitCondition.signalAll();
                        }
                    }
                    if ( new File (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + ("readinprogress"
                        +  ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain())
                           .trim()).createNewFile() == false )
                    {
                         // that means some file already exists
                         if (Prankster(new File (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                             + ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain()),
                               ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain(),
                               false))
                         {
                             // so we do have a file there which is a prankster file so lets re-use it for good
                             // of humanity
                             LiveDB.READINPROGRESS[((TrainRunningInformation)
                                     ((PlatformClearance)mytrain).getTrainid()).getTrain()]
                              = new FileOutputStream (new File (LiveDB.serializedfilespath + "syc"
                              + LiveDB.FILESEPERATOR + "readinprogress"
                              + ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain()));
                             LiveDB.READINPROGRESSLOCKS[((TrainRunningInformation)
                                     ((PlatformClearance)mytrain).getTrainid()).getTrain()] =
                             LiveDB.READINPROGRESS[((TrainRunningInformation)
                                     ((PlatformClearance)mytrain).getTrainid()).getTrain()].getChannel().tryLock();
                             // now lets thanks the prankter in a thanksgiving prayer
                             System.err.println(LiveDB.grassHopper("Dear Prankster Prank File you donated has been humbly accepted. AMEN !!"));
                         }
                         LiveDB.ALRTLVL = 5;
                         System.err.println(LiveDB.grassHopper("Currently a read is already in progress for table"
                          + ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain()));
                         // Never mind many people can read the same book
                    }
                    // mark the file for deletion on exit just in case system we goof up somewhere
                    new File (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + ("readinprogress"
                        +  ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain())
                           .trim()).deleteOnExit();
             }catch (IOException ex_NOKIA54){
                    if (LiveDB.DeQueueTrainsInWaiting() == false)
                    {
                        LiveDB.ALRTLVL = 7; // programming screwup most probably
                        System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                    }
                    System.err.println(LiveDB.grassHopper(ex_NOKIA54, " File:" +
                    LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                    + ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain()));
                    return false;
             }catch (SecurityException ex_NOKIA21){
                    if (LiveDB.DeQueueTrainsInWaiting() == false)
                    {
                        LiveDB.ALRTLVL = 7; // programming screwup most probably
                        System.err.println(LiveDB.grassHopper("Error DeQueueTrainsInWaiting()"));
                    }
                    if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                    {
                        LiveDB.ALRTLVL = 3;
                        System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                + LiveDB.serializedfilespath + "syc"));
                    }
                    System.err.println(LiveDB.grassHopper(ex_NOKIA21, " File:" +
                    LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                    + ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain()));
                    return false;
             }

             if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
             {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                           + LiveDB.serializedfilespath + "syc"));
             }
             
             if ( new File (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + ("readinprogress"
                        +  ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain())
                           .trim()).setReadOnly() == false)
             {
                    System.err.println(LiveDB.grassHopper("File:" +
                    LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                    + ((TrainRunningInformation)((PlatformClearance)mytrain).getTrainid()).getTrain()
                    + "Cannot set ReadOnly"));
             }
         }
         
         LiveDB.TrainsInWaiting.peek().getTrainid().setDeparturetime (new Date ());

         return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.LiveSharedDB
 *
 * Method Name : private static boolean CheckPreviousIncompleteRequests (Date p_request_time)
 * Parameters : Date p_request_time -- any requests before this time ?
 *
 * Returns : boolean true if yes there are previous pending requests at other railway stations (sid's)
 *           boolean false if all is clear no more pending request before this time.
 *
 * Method Called From : protected static boolean QueueTrainsInWaiting (PlatformClearance mytrain, FileChannel ch,
 *                                                                              FileLock fl, int requestno )
 * Relevant Indexes : LiveDB.indxplatformClearance
 * searchkey = AnyValidDate (getRequesttime)
 * searchkey returns Long rowid which is the rowid for this table
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Running Commentator Read English Idiot. Now Dork dont reply you dont understand
 * English.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    private static boolean CheckPreviousIncompleteRequests (Date p_request_time){

         long rrow = LiveDB.indxplatformClearance.get(p_request_time);

         for ( int row = (int) rrow -1;
              ((PlatformClearance)LiveDB.LiveSharedDB[pc][row]).getRequest_time().before(p_request_time)
              && ((PlatformClearance)LiveDB.LiveSharedDB[pc][row]).getRequest_time().after(LiveDB.today)
              && row >= 0; row-- )
         {
             if (((TrainRunningInformation)((PlatformClearance)LiveDB.LiveSharedDB[pc][row]).getTrainid())
                     .getArrivaltime() == null
                && ((TrainRunningInformation)((PlatformClearance)LiveDB.LiveSharedDB[pc][row]).getTrainid())
                     .getAccident() == null
                && ((PlatformClearance)LiveDB.LiveSharedDB[pc][row]).getSid() != LiveDB.pid )
                 return true;
         }
         
         return false;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java method protected final boolean get_DataEntryFile(int tableno)
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.LiveSharedDB, LiveDB.READINPROGRESSLOCKS
 * @LOOKSY:LiveDB.READINPROGRESS, LiveDB.TrainsInWaiting, LiveDB.FILESEPERATOR, LiveDB.grassHopper()
 *
 * Method Name : protected static boolean DeQueueTrainsInWaitingRunning ()
 * Parameters : None
 *
 * Returns : boolean true if your request was successfully removed from TrainsInWaiting
 *           boolean false if streams error
 *
 * Method Called From :RefreshDatabase::protected static boolean read_database (int tableno)
 *                     LiveDB::protected static boolean commit_database (int p_Tableno)
 *                     Spy::protected static void dump()
 *                     Many other methods can call it.
 *
 * Synchronization Files : LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method as the name suggests is meant to remove your request from the Queue
 * TrainsInWaiting. This method is to be called only after successfull completion of your request whatever
 * it may be because this method will set only Running time and not Arrival time of your request before
 * it is removed from the queue. Setting the Arrival time is your responsibility. The method first deletes
 * the readinprogress file it it exists. Just before deleting readinprogress file it will release the
 * exclusive meant for authentication and also close stream. Note:- you need to take care about calling this
 * method at the right place because i am not checking that. Also a request should have been Queued already
 * before calling this method. I dont check that either.
 * THIS METHOD WILL BE USEFULL FOR BENCHMARKING
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean DeQueueTrainsInWaitingRunning (){
        boolean ok = true;
        Object ADHOCKLOCK = new Object ();
        PlatformClearance pr = null;

        if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()).trim()).exists())
        {
        try{
            // release locks on this file and close this file before deleting
            LiveDB.READINPROGRESSLOCKS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].release();
            LiveDB.READINPROGRESS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].close();
            if (new File(LiveDB.serializedfilespath + "syc").canWrite())
            {
                        System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "syc"));
            }
            else
            {
                 if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                 {
                     System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                     LiveDB.system_exit = 1;
                     LiveDB.SmoothExitCondition.signalAll();
                 }
            }
            if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()).trim()).delete() == false)
            {
                System.err.println(LiveDB.grassHopper("Cant delete File:" +
                (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR  + "readinprogress"
                    +  LiveDB.TrainsInWaiting.peek().getTrainid()
                    .getTrain() + "Delete manually NOW")));
                if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                            + LiveDB.serializedfilespath + "syc"));
                }
                return false;
            }
            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                + LiveDB.serializedfilespath + "syc"));
            }
        }catch (SecurityException ex_NOKIA83){
            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                + LiveDB.serializedfilespath + "syc"));
            }
            System.err.println(LiveDB.grassHopper("Cant delete File:" +
            (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
            +  LiveDB.TrainsInWaiting.peek().getTrainid()
            .getTrain() + "Delete manually NOW")));
            return false;
        }catch (IOException ex_NOKIA82){
            System.err.println(LiveDB.grassHopper(ex_NOKIA82,"Error closing/releasing lock on readinprogress"
                    + LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()));
            return false;
        }
        }
        else // some prankster could have deleted this file
        {   // we will need to check on the accuracy of this zatak during testing
            try{
                LiveDB.READINPROGRESSLOCKS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].release();
                LiveDB.READINPROGRESS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].close();
            }catch (IOException ex_NOKIA82){
                System.err.println(LiveDB.grassHopper(ex_NOKIA82, "Error closing/releasing lock on readinprogress"
                    + LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()));
                return false;
            }
        }

        synchronized(ADHOCKLOCK){

            LiveDB.TrainsInWaiting.peek().getTrainid().setRunningtime((new Date ()).getTime()
                    - LiveDB.TrainsInWaiting.peek().getTrainid().getDeparturetime().getTime());
            // Now clone whatever you were peeking at. Clone the return element
            LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] = LiveDB.TrainsInWaiting.peek().clone();
            // insert an entry in ChangeTracker table for this table
            // CHECK THIS DURING BETA TESTING
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (pc,LiveDB.LiveSharedDB[pc].length -1, 'I',
            LiveDB.pid, new Date (), LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1],
                                         (long)LiveDB.LiveSharedDB[ct].length);
            // Now clear this requestno from the deque
            // Passengers dis-embarking at station end of journey
            try{
                  if ((pr = LiveDB.TrainsInWaiting.remove()) == null) ok = false;
            }catch (NoSuchElementException ex_NOKIA13){
                 LiveDB.ALRTLVL = 7;
                 System.err.println(LiveDB.grassHopper("NoSuchElementException TrainsInWaiting is empty"));
                 return ok = false;
            }
        }
        return ok;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:IntranetCompliantRadioTaggedCollar.java method protected final boolean get_DataEntryFile(int tableno)
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.LiveSharedDB, LiveDB.READINPROGRESSLOCKS
 * @LOOKSY:LiveDB.READINPROGRESS, LiveDB.TrainsInWaiting, LiveDB.FILESEPERATOR, LiveDB.grassHopper()
 *
 * Method Name : protected static boolean DeQueueTrainsInWaitingRunning ( int p_request )
 * Parameters : int p_request -- the request number that you want to remove from TrainsInWaiting
 *
 * Returns : boolean true if your request was successfully removed from TrainsInWaiting
 *           boolean false if streams error
 *
 * Method Can be Called From :RefreshDatabase::protected static boolean read_database (int tableno)
 *                            LiveDB::protected static boolean commit_database (int p_Tableno)
 *                            Spy::protected static void dump()
 *                            Many other methods can call it.
 *
 * Synchronization Files : LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method as the name suggests is meant to remove your request from the Queue
 * TrainsInWaiting. This method is to be called only after successfull completion of your request whatever
 * it may be because this method will set only Running time and not Arrival time of your request before
 * it is removed from the queue. Setting the Arrival time is your reponsibility. The method first deletes
 * the readinprogress file it it exists. Just before deleting readinprogress file it will release the
 * exclusive meant for authentication and also close the stream. Note:- you need to take care about calling
 * this method at the right place because i am not checking that. Also a request should have been Queued
 * already before calling this method. I dont check that either. This method is identical to the other
 * overloaded method without parameters except that this could be usefull if you change the
 * LiveDB.TrainsInWaiting programming logic.
 * THIS METHOD WILL BE USEFULL FOR BENCHMARKING
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static boolean DeQueueTrainsInWaitingRunning ( int p_request ){

        Object ADHOCKLOCK = new Object ();
        boolean ok = true;


        // NOTE: just keep repeatedly doing a toArray() every time dont take a local array
        // PlatformClearance [] because you dont take chances with a stupid language that
        // copies references.

        // That earlier scheme of blindly peeking () into womens blouses has been abandoned here
        // Zatak the right one in the rest room

        // Use this scheme if you change the programming logic for TrainsInWaiting to Ungal Choice
        // The earlier method is okay but you might end yup peeking in wrong blouse. SLAAAAAAAAP !
        // Big Sound !!

        synchronized(ADHOCKLOCK){  // maybe this ADHOCLOCK is one too many check during testing
              for (int q = 0; q < LiveDB.TrainsInWaiting.size(); q++)
              {
                  if (((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getRequestno() == p_request)
                  {
                      if (new File((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR
                          + "readinprogress" + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q])
                          .getTrainid().getTrain()).trim()).exists())
                      {
                      try{
                            // release locks on this file and close this file before deleting
                            LiveDB.READINPROGRESSLOCKS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].release();
                            LiveDB.READINPROGRESS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].close();
                            if (new File(LiveDB.serializedfilespath + "syc").canWrite())
                            {
                                System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "syc"));
                            }
                            else
                            {
                                if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                                {
                                        System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                                        LiveDB.system_exit = 1;
                                        LiveDB.SmoothExitCondition.signalAll();
                                }
                            }
                            if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR
                                + "readinprogress"
                                + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()).trim())
                                .delete() == false)
                            {
                                System.err.println(LiveDB.grassHopper("Cant delete File:" +
                                (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR  + "readinprogress"
                                + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()
                                + "Delete manually NOW")));
                                if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                                {
                                    LiveDB.ALRTLVL = 3;
                                    System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                                + LiveDB.serializedfilespath + "syc"));
                                }
                                return false;
                            }
                            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                            {
                                LiveDB.ALRTLVL = 3;
                                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                    + LiveDB.serializedfilespath + "syc"));
                            }
                      }catch (SecurityException ex_NOKIA83){
                            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                            {
                                LiveDB.ALRTLVL = 3;
                                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                            + LiveDB.serializedfilespath + "syc"));
                            }
                            System.err.println(LiveDB.grassHopper("Cant delete File:" +
                            (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR  + "readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()
                            + "Delete manually NOW")));
                            return false;
                      }catch (IOException ex_NOKIA82){
                            System.err.println(LiveDB.grassHopper(ex_NOKIA82,"Error closing/releasing lock on readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()));
                            return false;
                      }
                      } // some prankster could have deleted the file for you so to play safe
                      else
                      {
                          try{
                            LiveDB.READINPROGRESSLOCKS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].release();
                            LiveDB.READINPROGRESS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].close();
                          }catch (IOException ex_NOKIA82){
                            System.err.println(LiveDB.grassHopper(ex_NOKIA82,"Error closing/releasing lock on readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()));
                            return false;
                          }
                      }

                      
                      ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()
                      .setRunningtime((new Date ()).getTime()
                      - ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getDeparturetime().getTime());

                      LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] =
                                    ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).clone();
                      // insert an entry in ChangeTracker table for this table
                      LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                      new ChangeTracker (pc,LiveDB.LiveSharedDB[pc].length -1, 'I',
                                         LiveDB.pid, new Date (),
                                         LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1],
                                         (long)LiveDB.LiveSharedDB[ct].length);
                      // Now clear this requestno from the deque
                      // Passengers dis-embarking at station end of journey
                      try{
                            ok = LiveDB.TrainsInWaiting.remove((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]);
                         }catch (NoSuchElementException ex_NOKIA13){
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("NoSuchElementException TrainsInWaiting is empty"));
                            return ok = false;
                         }
                  }
              } // for (int q = 0; q < LiveDB.TrainsInWaiting.size(); q++)
        }
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:RefreshDatabase.java
 * @LOOKSY:Spy.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.LiveSharedDB, LiveDB.READINPROGRESSLOCKS
 * @LOOKSY:LiveDB.READINPROGRESS, LiveDB.TrainsInWaiting, LiveDB.FILESEPERATOR, LiveDB.grassHopper()
 *
 * Method Name : protected static boolean DeQueueTrainsInWaitingArrivals ()
 * Parameters : None
 *
 * Returns : boolean true if your request was successfully removed from TrainsInWaiting
 *           boolean false if streams error
 *
 * Method Called From :RefreshDatabase::protected static boolean read_database (int tableno)
 *                     LiveDB::protected static boolean commit_database (int p_Tableno)
 *                     LiveDB::protected static boolean NewPictureAdditions(String... p_file)
 *                     LiveDB::protected static boolean PictureUpdates (String... p_file)
 *                     LiveDB::protected static boolean OldPictureDeletions (String p_file)
 *                     Spy::protected static void dump()
 *                     Many other methods can call it.
 *
 * Synchronization Files : LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method as the name suggests is meant to remove your request from the Queue
 * TrainsInWaiting. This method is to be called only after successfull completion of your request whatever
 * it may have been because this method will set both Arrival time and running time of your request before
 * it is removed from the queue. The method first deletes the readinprogress file it it exists. Just before
 * deleting readinprogress file it will release the exclusive meant for authentication and also close the
 * stream. Note:- you need to take care about calling this method at the right place because i am not
 * checking that. Also a request should have been Queued already before calling this method. I dont check
 * that either.
 * 
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean DeQueueTrainsInWaitingArrivals (){
        boolean ok = true;
        Object ADHOCKLOCK = new Object ();
        PlatformClearance pr = null;

        if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()).trim()).exists())
        {
        try{
            // release locks on this file and close this file before deleting
            LiveDB.READINPROGRESSLOCKS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].release();
            LiveDB.READINPROGRESS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].close();
            if (new File(LiveDB.serializedfilespath + "syc").canWrite())
            {
                System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "syc"));
            }
            else
            {
                if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                }
            }
            if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()).trim()).delete() == false)
            {
                System.err.println(LiveDB.grassHopper("Cant delete File:" +
                (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR  + "readinprogress"
                    +  LiveDB.TrainsInWaiting.peek().getTrainid()
                    .getTrain() + "Delete manually NOW")));
                if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                            + LiveDB.serializedfilespath + "syc"));
                }
                return false;
            }
            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                + LiveDB.serializedfilespath + "syc"));
            }
        }catch (SecurityException ex_NOKIA83){
            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                + LiveDB.serializedfilespath + "syc"));
            }
            System.err.println(LiveDB.grassHopper("Cant delete File:" +
            (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
            +  LiveDB.TrainsInWaiting.peek().getTrainid()
            .getTrain() + "Delete manually NOW")));
            return false;
        }catch (IOException ex_NOKIA82){
            System.err.println(LiveDB.grassHopper(ex_NOKIA82,"Error closing/releasing lock on readinprogress"
                    + LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()));
            return false;
        }
        }
        else // some prankster could have deleted this file
        {   // we will need to check on the accuracy of this zatak during testing
            try{
                LiveDB.READINPROGRESSLOCKS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].release();
                LiveDB.READINPROGRESS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].close();
            }catch (IOException ex_NOKIA82){
                System.err.println(LiveDB.grassHopper(ex_NOKIA82, "Error closing/releasing lock on readinprogress"
                    + LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()));
                return false;
            }
        }
        
        synchronized(ADHOCKLOCK){
            LiveDB.TrainsInWaiting.peek().getTrainid().setArrivaltime (new Date ());
            LiveDB.TrainsInWaiting.peek().getTrainid().setRunningtime((new Date ()).getTime()
                    - LiveDB.TrainsInWaiting.peek().getTrainid().getDeparturetime().getTime());
            // Now clone whatever you were peeking at. Clone the return element
            LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] = LiveDB.TrainsInWaiting.peek().clone();
            // insert an entry in ChangeTracker table for this table
            LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
            new ChangeTracker (pc,LiveDB.LiveSharedDB[pc].length -1, 'I',
            LiveDB.pid, new Date (), LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1],
                                         (long)LiveDB.LiveSharedDB[ct].length);
            // Now clear this requestno from the deque
            // Passengers dis-embarking at station end of journey
            try{
                  if ((pr = LiveDB.TrainsInWaiting.remove()) == null) ok = false;
            }catch (NoSuchElementException ex_NOKIA13){
                 LiveDB.ALRTLVL = 7;
                 System.err.println(LiveDB.grassHopper("NoSuchElementException TrainsInWaiting is empty"));
                 return ok = false;
            }
        }    
        return ok;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:RefreshDatabase.java
 * @LOOKSY:Spy.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.LiveSharedDB, LiveDB.READINPROGRESSLOCKS
 * @LOOKSY:LiveDB.READINPROGRESS, LiveDB.TrainsInWaiting, LiveDB.FILESEPERATOR, LiveDB.grassHopper()
 *
 * Method Name : protected static boolean DeQueueTrainsInWaitingArrivals ( int p_request )
 * Parameters : int p_request -- the request number that you want to remove from TrainsInWaiting
 *
 * Returns : boolean true if your request was successfully removed from TrainsInWaiting
 *           boolean false if streams error
 *
 * Method Can be Called From :RefreshDatabase::protected static boolean read_database (int tableno)
 *                            LiveDB::protected static boolean commit_database (int p_Tableno)
 *                            Spy::protected static void dump()
 *                            Many other methods can call it.
 *
 * Synchronization Files : LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method as the name suggests is meant to remove your request from the Queue
 * TrainsInWaiting. This method is to be called only after successfull completion of your request whatever
 * it may have been because this method will set both Arrival time and running time of your request before
 * it is removed from the queue. The method first deletes the readinprogress file it it exists. Just before
 * deleting readinprogress file it will release the exclusive meant for authentication and also close the
 * stream. Note:- you need to take care about calling this method at the right place because i am not
 * checking that. Also a request should have been Queued already before calling this method. I dont check
 * that either. This method is identical to the other overloaded method without parameters except that this
 * could be usefull if you change the LiveDB.TrainsInWaiting programming logic.
 * THIS METHOD WILL BE USEFULL FOR BENCHMARKING
 * 
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static boolean DeQueueTrainsInWaitingArrivals ( int p_request ){

        Object ADHOCKLOCK = new Object ();
        boolean ok = true;


        // NOTE: just keep repeatedly doing a toArray() every time dont take a local array
        // PlatformClearance [] because you dont take chances with a stupid language that
        // copies references.

        // That earlier scheme of blindly peeking () into womens blouses has been abandoned here
        // Zatak the right one in the rest room

        // Use this scheme if you change the programming logic for TrainsInWaiting to Ungal Choice
        // The earlier method is okay but you might end yup peeking in wrong blouse. SLAAAAAAAAP !
        // Big Sound !! 

        synchronized(ADHOCKLOCK){  // maybe this ADHOCLOCK is one too many check during testing
              for (int q = 0; q < LiveDB.TrainsInWaiting.size(); q++)
              {
                  if (((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getRequestno() == p_request)
                  {
                      if (new File((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR
                          + "readinprogress" + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q])
                          .getTrainid().getTrain()).trim()).exists())
                      {
                      try{
                            // release locks on this file and close this file before deleting
                            LiveDB.READINPROGRESSLOCKS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].release();
                            LiveDB.READINPROGRESS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].close();
                            if (new File(LiveDB.serializedfilespath + "syc").canWrite())
                            {
                                System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "syc"));
                            }
                            else
                            {
                                if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                                {
                                        System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                                        LiveDB.system_exit = 1;
                                        LiveDB.SmoothExitCondition.signalAll();
                                }
                            }
                            if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR
                                + "readinprogress"
                                + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()).trim())
                                .delete() == false)
                            {
                                System.err.println(LiveDB.grassHopper("Cant delete File:" +
                                (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR  + "readinprogress"
                                + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()
                                + "Delete manually NOW")));
                                if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                                {
                                    LiveDB.ALRTLVL = 3;
                                    System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                                   + LiveDB.serializedfilespath + "syc"));
                                }
                                return false;
                            }
                            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                            {
                                LiveDB.ALRTLVL = 3;
                                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                                + LiveDB.serializedfilespath + "syc"));
                            }
                      }catch (SecurityException ex_NOKIA83){
                            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                            {
                                LiveDB.ALRTLVL = 3;
                                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                                + LiveDB.serializedfilespath + "syc"));
                            }
                            System.err.println(LiveDB.grassHopper("Cant delete File:" +
                            (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR  + "readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()
                            + "Delete manually NOW")));
                            return false;
                      }catch (IOException ex_NOKIA82){
                            System.err.println(LiveDB.grassHopper(ex_NOKIA82,"Error closing/releasing lock on readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()));
                            return false;
                      }
                      } // some prankster could have deleted the file for you so to play safe
                      else
                      {
                          try{
                            LiveDB.READINPROGRESSLOCKS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].release();
                            LiveDB.READINPROGRESS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].close();
                          }catch (IOException ex_NOKIA82){
                            System.err.println(LiveDB.grassHopper(ex_NOKIA82,"Error closing/releasing lock on readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()));
                            return false;
                          }
                      }
                      
                      ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().setArrivaltime(new Date());
                      ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()
                      .setRunningtime((new Date ()).getTime()
                      - ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getDeparturetime().getTime());

                      LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] =
                                    ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).clone();
                      // insert an entry in ChangeTracker table for this table
                      LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                      new ChangeTracker (pc,LiveDB.LiveSharedDB[pc].length -1, 'I',
                                         LiveDB.pid, new Date (),
                                         LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1],
                                         (long)LiveDB.LiveSharedDB[ct].length);
                      // Now clear this requestno from the deque
                      // Passengers dis-embarking at station end of journey
                      try{
                            ok = LiveDB.TrainsInWaiting.remove((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]);
                         }catch (NoSuchElementException ex_NOKIA13){
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("NoSuchElementException TrainsInWaiting is empty"));
                            return ok = false;
                         }
                  }
              } // for (int q = 0; q < LiveDB.TrainsInWaiting.size(); q++)
        }
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:RefreshDatabase.java
 * @LOOKSY:Spy.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.LiveSharedDB, LiveDB.READINPROGRESSLOCKS
 * @LOOKSY:LiveDB.READINPROGRESS, LiveDB.TrainsInWaiting, LiveDB.FILESEPERATOR, LiveDB.grassHopper()
 *
 * Method Name : protected static boolean DeQueueTrainsInWaiting ()
 * Parameters : None
 *
 * Returns : boolean true if your request was successfully removed from TrainsInWaiting
 *           boolean false if streams error
 *
 * Method Called From :RefreshDatabase::protected static boolean read_database (int tableno)
 *                     LiveDB::protected static boolean commit_database (int p_Tableno)
 *                     Spy::protected static void dump()
 *                     Many other methods can call it.
 *
 * Synchronization Files : LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method as the name suggests is meant to remove your request from the Queue
 * TrainsInWaiting. This method is to be called only after failure of your request whatever it may have
 * been because this method will set both Accident time and running time of your request before it is
 * removed from the queue. The method first deletes the readinprogress file it it exists. Just before
 * deleting readinprogress file it will release the exclusive meant for authentication and also close the
 * stream. Note:- you need to take care about calling this method at the right place because i am not
 * checking that. Also a request should have been Queued already before calling this method. I dont check
 * that either.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    // BOTH THESE ZATAKS ARE MEANT FOR EXCEPTIONS
    protected static boolean DeQueueTrainsInWaiting (){
        
        // This is a blind Zatak ... Blind Mans Choice. My choice
        // I just called to say I love you ..... in my heart ....... aaai yaaai yaaa
        
        boolean ok = true;
        Object ADHOCKLOCK = new Object (); // hey this new Object is necessary it uses this to lock all
        PlatformClearance pr = null;

        if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()).trim()).exists())
        {
        try{
            // release locks on this file and close this file before deleting
            LiveDB.READINPROGRESSLOCKS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].release();
            LiveDB.READINPROGRESS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].close();
            if (new File(LiveDB.serializedfilespath + "syc").canWrite())
            {
                System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "syc"));
            }
            else
            {
                if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                {
                    System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                    LiveDB.system_exit = 1;
                    LiveDB.SmoothExitCondition.signalAll();
                 }
            }
            if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()).trim()).delete() == false)
            {
                System.err.println(LiveDB.grassHopper("Cant delete File:" +
                (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                 +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain() + "Delete manually NOW")));
                if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                {
                    LiveDB.ALRTLVL = 3;
                    System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                            + LiveDB.serializedfilespath + "syc"));
                }
                return false;
            }
            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                + LiveDB.serializedfilespath + "syc"));
            }
        }catch (SecurityException ex_NOKIA83){
            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
            {
                LiveDB.ALRTLVL = 3;
                System.err.println(LiveDB.grassHopper("Cant setReadonly File:" + LiveDB.serializedfilespath
                                                                             + "syc"));
            }
            System.err.println(LiveDB.grassHopper("Cant delete File:" +
            (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR  + "readinprogress"
             +  LiveDB.TrainsInWaiting.peek().getTrainid().getTrain() + "Delete manually NOW")));
            return false;
        }catch (IOException ex_NOKIA82){
            System.err.println(LiveDB.grassHopper("Error closing/releasing lock on readinprogress"
                    + LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()));
            return false;
        }
        }
        else // some prankster could have deleted the file
        {
            try{
            LiveDB.READINPROGRESSLOCKS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].release();
            LiveDB.READINPROGRESS[LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()].close();
            }catch (IOException ex_NOKIA82){
                System.err.println(LiveDB.grassHopper(ex_NOKIA82, "Error closing/releasing lock on readinprogress"
                    + LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()));
                return false;
            }
        }

        synchronized(ADHOCKLOCK){ // check during testing if this ADHOCLOCK is one too many
              LiveDB.TrainsInWaiting.peek().getTrainid().setAccident (new Date ());
              LiveDB.TrainsInWaiting.peek().getTrainid().setRunningtime ((new Date ()).getTime()
                      - LiveDB.TrainsInWaiting.peek().getTrainid().getDeparturetime().getTime());
              // Now clone whatever you were peeking at. Clone the return element
              LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] = LiveDB.TrainsInWaiting.peek().clone(); // do a deep copy and assign to LiveSharedDB
              // insert an entry in ChangeTracker table for this table
              LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                     new ChangeTracker (pc,LiveDB.LiveSharedDB[pc].length -1, 'I',
                     LiveDB.pid, new Date (),
                     LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1],
                     (long)LiveDB.LiveSharedDB[ct].length);
              // Now clear this requestno from the deque
              // Passengers dis-embark aap apni kursi ki peti khol sakta hain
              try{
                 if ((pr = LiveDB.TrainsInWaiting.remove()) == null) ok = false;
              }catch (NoSuchElementException ex_NOKIA13){
                   LiveDB.ALRTLVL = 7;
                   System.err.println(LiveDB.grassHopper("NoSuchElementException TrainsInWaiting is empty"));
                   return ok = false;
              }
        }
        return true;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:RefreshDatabase.java
 * @LOOKSY:Spy.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:LiveDB.serializedfilespath, LiveDB.LiveSharedDB, LiveDB.READINPROGRESSLOCKS
 * @LOOKSY:LiveDB.READINPROGRESS, LiveDB.TrainsInWaiting, LiveDB.FILESEPERATOR, LiveDB.grassHopper()
 *
 * Method Name : protected static boolean DeQueueTrainsInWaiting ( int p_request )
 * Parameters : int p_request -- the request number that you want to remove from TrainsInWaiting
 *
 * Returns : boolean true if your request was successfully removed from TrainsInWaiting
 *           boolean false if streams error
 *
 * Method Called From :RefreshDatabase::protected static boolean read_database (int tableno)
 *                     LiveDB::protected static boolean commit_database (int p_Tableno)
 *                     Spy::protected static void dump()
 *                     Many other methods can call it.
 *
 * Synchronization Files : LiveDB.serializedfilespath/syc/readinprogress*
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method as the name suggests is meant to remove your request from the Queue
 * TrainsInWaiting. This method is to be called only after failure of your request whatever it may have
 * been because this method will set both Accident time and running time of your request before it is
 * removed from the queue. The method first deletes the readinprogress file it it exists. Just before
 * deleting readinprogress file it will release the exclusive meant for authentication and also close the
 * stream. Note:- you need to take care about calling this method at the right place because i am not
 * checking that. Also a request should have been Queued already before calling this method. I dont check
 * that either. This is removing a specific request number from the queue. So use this method if you change
 * the programming logic.
 *
 * Technical Reference : None
 *
 * Start Date: 18th October 2010
 * End Date: 1st June 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    protected static boolean DeQueueTrainsInWaiting ( int p_request ){
        
        Object ADHOCKLOCK = new Object ();
        boolean ok = true;

        // NOTE: just keep repeatedly doing a toArray() every time dont take a local array
        // PlatformClearance [] because you dont take chances with a stupid language that
        // copies references.

        // That earlier scheme of blindly peeking () into womens blouses has been abandoned here
        // Zatak the right one in the rest room

        // Use this scheme if you change the programming logic for TrainsInWaiting to Ungal Choice
        // The earlier method is okay but you might end yup peeking in wrong blouse. SLAAAAAAAAP !
        // Big Sound !! 
        
        synchronized(ADHOCKLOCK){
              for (int q = 0; q < LiveDB.TrainsInWaiting.size(); q++)
              {
                  if (((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getRequestno() == p_request)
                  {
                      if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                                + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()).trim()).exists())
                      {
                      try{
                            // release locks on this file and close this file before deleting
                            LiveDB.READINPROGRESSLOCKS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].release();
                            LiveDB.READINPROGRESS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].close();
                            if (new File(LiveDB.serializedfilespath + "syc").canWrite())
                            {
                                System.err.println(LiveDB.grassHopper("Perms Tampered File:" + LiveDB.serializedfilespath
                                                                                           + "syc"));
                            }
                            else
                            {
                                if (new File(LiveDB.serializedfilespath + "syc").setWritable(true, false) == false)
                                {
                                        System.err.println(LiveDB.grassHopper("Cant setWritable File:"
                                            + LiveDB.serializedfilespath + "syc"));
                                        LiveDB.system_exit = 1;
                                        LiveDB.SmoothExitCondition.signalAll();
                                }
                            }
                            if (new File ((LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                                + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()).trim())
                                .delete() == false)
                            {
                                System.err.println(LiveDB.grassHopper("Cant delete File:" +
                                (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                                + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()
                                + "Delete manually NOW")));
                                if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                                {
                                    LiveDB.ALRTLVL = 3;
                                    System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                                    + LiveDB.serializedfilespath + "syc"));
                                }
                                return false;
                            }
                            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                            {
                                LiveDB.ALRTLVL = 3;
                                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                                + LiveDB.serializedfilespath + "syc"));
                            }
                      }catch (SecurityException ex_NOKIA83){
                            if (new File (LiveDB.serializedfilespath + "syc").setReadOnly() == false)
                            {
                                LiveDB.ALRTLVL = 3;
                                System.err.println(LiveDB.grassHopper("Cant setReadonly File:"
                                                    + LiveDB.serializedfilespath + "syc"));
                            }
                            System.err.println(LiveDB.grassHopper("Cant delete File:" +
                            (LiveDB.serializedfilespath + "syc" + LiveDB.FILESEPERATOR + "readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()
                            + "Delete manually NOW")));
                            return false;
                      }catch (IOException ex_NOKIA82){
                            System.err.println(LiveDB.grassHopper("Error closing/releasing lock on readinprogress"
                            + ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()));
                            return false;
                      }
                      }
                      else // some prankster could have deleted it
                      {
                          try{
                            LiveDB.READINPROGRESSLOCKS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].release();
                            LiveDB.READINPROGRESS[((PlatformClearance)
                                   LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getTrain()].close();
                          }catch (IOException ex_NOKIA82){
                                System.err.println(LiveDB.grassHopper(ex_NOKIA82,"Error closing/releasing lock on readinprogress"
                                + LiveDB.TrainsInWaiting.peek().getTrainid().getTrain()));
                                return false;
                          }
                      }
                      
                      ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().setAccident(new Date());
                      ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid()
                      .setRunningtime((new Date ()).getTime()
                      - ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).getTrainid().getDeparturetime().getTime());
                      LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length] =
                                    ((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]).clone();
                      // insert an entry in ChangeTracker table for this table
                      LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
                      new ChangeTracker (pc,LiveDB.LiveSharedDB[pc].length -1, 'I',
                                         LiveDB.pid, new Date (),
                                         LiveDB.LiveSharedDB[pc][LiveDB.LiveSharedDB[pc].length -1],
                                         (long)LiveDB.LiveSharedDB[ct].length);
                      // Now clear this requestno from the deque
                      // Passengers dis-embarking at station end of journey
                      try{
                            ok = LiveDB.TrainsInWaiting.remove((PlatformClearance)LiveDB.TrainsInWaiting.toArray()[q]);
                         }catch (NoSuchElementException ex_NOKIA13){
                            LiveDB.ALRTLVL = 7;
                            System.err.println(LiveDB.grassHopper("NoSuchElementException TrainsInWaiting is empty"));
                            return ok = false;
                         }
                  }
              } // for (int q = 0; q < LiveDB.TrainsInWaiting.size(); q++)
        }
        return true;
    }
/*
 * WIRING DIAGRAM :
 * @LOOKSY:FileTableDataFileMap.java
 * @LOOKSY:ChangeTracker.java
 * @LOOKSY:CustomerRegister.java
 * @LOOKSY:ShoppingCart.java
 * @LOOKSY:LanguageSupport.java
 * @LOOKSY:LanguageTitles.java
 * @LOOKSY:LanguageTransalations.java
 * @LOOKSY:PaymentType.java
 * @LOOKSY:PictureDatabase.java
 * @LOOKSY:PictureOptions.java
 * @LOOKSY:SearchDatabase.java
 * @LOOKSY:DefaultAdvertisingImages.java
 * @LOOKSY:ArtLeaves.java
 * @LOOKSY:CrashRecovery.java
 * @LOOKSY:InstalledTables.java
 * @LOOKSY:ReportsTables.java
 * @LOOKSY:CelebrityTable.java
 * @LOOKSY:PlatformClearance.java
 * @LOOKSY:Spy.java -- method dump()
 * @LOOKSY:LiveDB.command_line, LiveDB.REALTABLES
 *
 * Method Name : protected static Object createValidInstance (StringBuffer parsedinst, int p_tbl,
 *                                                                                    Character... p_char)
 * Parameters : StringBuffer parsedinst -- parsed instance as StringBuffer to convert to Object & return
 *              int p_tbl -- The table number of this parsedinst
 *              Character... p_char -- Newly introduced varargs to specify a char to parse
 *                                     look at toString method of ChangeTracker table for clarity
 *
 * Returns : Valid Object which is an instance of a valid LiveDB.REALTABLES from zero thru 17
 *
 * Associated Method : protected void ParseThisRow(String p_rowdata, StringBuffer [] p_stuff, char p_char)
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from get_DataEntryFile() PowerOutageSensor () only.This method
 * is usefull when corrected dump files are reloaded with LiveDB.command_line equals "FiXdAtAcOrRuPtIoN".
 * So when it is reloading the ChangeTracker from corrected dump files copied to correct data files on disk
 * the method get_DataEntryFile has to deal with a field of the ChangeTracker table called EntireRow which
 * is a row of either the same ChangeTracker table or a row of some other table.
 *
 * For Example the user wrote this patch of code
 *
 * // The programmer 'Inserts' a new row in ShoppingCart table as under
 * LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length] =
 *        new ShoppingCart(fld[0],fld[1],fld[2],Long.parseLong(fld[3]),
 *        Long.parseLong(fld[4]),Long.parseLong(fld[5]),Long.parseLong(fld[6]),
 *        Float.parseFloat(fld[7]),Long.parseLong(fld[8]),
 *        ld1,Long.parseLong(fld[10]),Float.parseFloat(fld[11]),
 *                                    Long.parseLong(fld[12]),rs);
 *
 * // insert an entry in ChangeTracker table for this new row addition into ShoppingCart table with flag 'I'
 * LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] =
 *        new ChangeTracker (tableno,LiveDB.LiveSharedDB[tableno].length -1, 'I',
 *        LiveDB.pid, new Date (),
 *        LiveDB.LiveSharedDB[tableno][LiveDB.LiveSharedDB[tableno].length -1], // This ShoppingCart EntireRow
 *        (long)LiveDB.LiveSharedDB[ct].length);
 * // so in the previous call it backed up the ShoppingCart Row to the ChangeTracker
 *
 * Next the user did this set on a ChangeTracker row that contained a valid ShoppingCart Row
 * ((ChangeTracker)LiveDB.LiveSharedDB[ct][rw]).setChange_flag('C');
 *
 * // now add a ChangeTracker entry for this modification to ChangeTracker table row itself with flag 'U'
 * LiveDB.LiveSharedDB[ct][LiveDB.LiveSharedDB[ct].length] = 
 *                  new ChangeTracker ((long)ct,rw, 'U', LiveDB.pid, new Date (),
 *                  LiveDB.LiveSharedDB[ct][rw], // This ChangeTracker EntireRow
 *                  (long)LiveDB.LiveSharedDB[ct].length);
 *
 * // So in the previous call to new ChangeTracker we added a new row to ChangeTracker with flag 'U'
 * // AND the EntireRow this time was the ChangeTracker row itself. Now this is the special condition where
 * // this EntireRow contains another EntireRow which is an instance of ShoppingCart.
 * // so in this case the parameter parsedinst will have EntireRow fields seperated by '#' to indicate the
 * // presence of another ChangeTracker row. This is called the first level of madness.
 * // Now if you programmer does another set and another new ChangeTracker then the EntireRow whoose
 * // fields were seperated by '#' will contain another EntireRow whoose fields will be seperated by '~'
 * // This is referred to as the second level of madness.
 * // Now you the programmer does yest another set so the ChangeTracker row is backed up again in
 * // ChangeTracker table. This is referred to as the third level of madness.
 *
 * So this method strips EntireRow parsedinst by calling method ParseThisRow() and constructs a new Instance
 * of a valid LiveDB.REALTABLES Object and returns that Object. As explained in the example above this method
 * can be called recursively.
 *
 * Technical References : Watch movie Entrapment (would you rather watch SHE legend in Legend of Zoro)
 *
 * Start Date: 18th October 2010
 * End Date: 18th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static Object createValidInstance (StringBuffer parsedinst, int p_tbl, Character... p_char){
        StringBuffer parsed [] = null;
        StringBuffer parsedVals [] = null;
        String Vals [] = null;
        TrainRunningInformation tid = null;
        char charused = '%';
        final int erfno = 6; // EntireRow field number

        if (p_char.length == 0)
        {
            if (parsedinst.toString().indexOf('#') != -1)
                charused = '#'; // if # is used it is the first level of madness
            if (parsedinst.toString().indexOf('~') != -1 && charused != '#')
                charused = '~'; // second level of madness in recursive calls
            if (parsedinst.toString().indexOf('^') != -1 && (charused != '~' && charused != '#'))
                charused = '^'; // third level of madness in recursive calls
        }
        
        ParseThisRow(parsedinst.toString().trim(), parsed, p_char.length == 0 ? charused : p_char[0]);
        
        switch (p_tbl){
               case ft:
                  // call the appropriate constructor
                  return new FileTableDataFileMap(Integer.parseInt(parsed[0].toString().trim()),
                         parsed[1].toString().trim(),parsed[2].toString().trim(),
                         parsed[3].toString().trim(),parsed[4].toString().trim(),
                         parsed[5].toString().trim(),Long.parseLong(parsed[6].toString().trim()));

               case ct:
                   //CHECK DURING BETA TESTING
                  return new ChangeTracker(Long.parseLong(parsed[0].toString().trim()),
                         Long.parseLong(parsed[1].toString().trim()),
                         (parsed[2].toString().trim().toCharArray())[0],
                         Long.parseLong(parsed[3].toString().trim()),
                         new Date(Long.parseLong(parsed[4].toString().trim())),
                         createValidInstance(parsed[erfno],Integer.parseInt(parsed[0].toString())),
                         Long.parseLong(parsed[6].toString().trim()));

               case cr:
                  return new CustomerRegister(parsed[0].toString().trim(),
                         parsed[1].toString().trim(),
                         new Date(Long.parseLong(parsed[2].toString().trim())),
                         parsed[3].toString().trim(),
                         parsed[4].toString().trim(), parsed[5].toString().trim(),
                         (parsed[6].toString().toCharArray())[0],
                         parsed[7].toString().trim(),
                         new Date(Long.parseLong(parsed[8].toString().trim())),
                         new Date(Long.parseLong(parsed[9].toString().trim())),
                         new Date(Long.parseLong(parsed[10].toString().trim())),
                         parsed[11].toString().trim(),
                         parsed[12].toString().trim(),
                         parsed[13].toString().trim(),
                         parsed[14].toString().trim(),
                         parsed[15].toString().trim(),
                         parsed[16].toString().trim(),
                         parsed[17].toString().trim(),
                         parsed[18].toString().trim(),
                         parsed[19].toString().trim(),
                         parsed[20].toString().trim(),
                         parsed[21].toString().trim(),
                         (parsed[22].toString().toCharArray())[0],
                         new Date(Long.parseLong(parsed[23].toString().trim())),
                         Long.parseLong(parsed[24].toString().trim()));



               case ls:
                  return new LanguageSupport(Integer.parseInt(parsed[0].toString().trim()),
                         parsed[1].toString().trim(),
                         Long.parseLong(parsed[2].toString().trim()));

               case lt:
                  return new LanguageTitles(parsed[0].toString().trim(),
                         parsed[1].toString().trim(),
                         parsed[2].toString().trim(),                        
                         Integer.parseInt(parsed[3].toString().trim()));



               case pt:
                  return new PaymentType(Integer.parseInt(parsed[0].toString().trim()),
                         parsed[1].toString().trim(),
                         Long.parseLong(parsed[2].toString().trim()));




               case sd:
                  return new SearchDatabase(parsed[0].toString().trim(),
                         parsed[1].toString().trim(),
                         Long.parseLong(parsed[2].toString().trim()));

               case da:
                  return new DefaultAdvertisingImages(parsed[0].toString().trim(),
                         parsed[1].toString().trim(),
                         parsed[2].toString().trim(),
                         Integer.parseInt(parsed[3].toString().trim()),
                         Integer.parseInt(parsed[4].toString().trim()),
                         Integer.parseInt(parsed[5].toString().trim()),
                         parsed[6].toString().trim(),
                         Integer.parseInt(parsed[7].toString().trim()),
                         parsed[8].toString().trim(),
                         Long.parseLong(parsed[9].toString().trim()));

               case ar:
                  return new ArtLeaves(parsed[0].toString().trim(),
                         parsed[1].toString().trim(),
                         parsed[2].toString().trim(),
                         parsed[3].toString().trim(),
                         parsed[4].toString().trim(),
                         parsed[5].toString().trim(),
                         parsed[6].toString().trim(),
                         parsed[7].toString().trim(),
                         parsed[8].toString().trim(),
                         parsed[9].toString().trim(),
                         parsed[10].toString().trim(),
                         parsed[11].toString().trim(),
                         parsed[12].toString().trim(),
                         parsed[13].toString().trim(),
                         parsed[14].toString().trim(),
                         parsed[15].toString().trim(),
                         parsed[16].toString().trim(),
                         parsed[17].toString().trim(),
                         parsed[18].toString().trim(),
                         parsed[19].toString().trim(),
                         parsed[20].toString().trim(),
                         parsed[21].toString().trim(),
                         parsed[22].toString().trim(),
                         parsed[23].toString().trim(),
                         parsed[24].toString().trim(),
                         parsed[25].toString().trim(),
                         parsed[26].toString().trim(),
                         parsed[27].toString().trim(),
                         Long.parseLong(parsed[28].toString().trim()));

               case crr:
                  ParseThisRow(parsed[3].toString().trim(), parsedVals, '#');
                  for (int k = 0; k < parsedVals.length; k++)
                       Vals[k] = parsedVals[k].toString();

                  return new CrashRecovery (Long.parseLong(parsed[0].toString().trim()),
                         Long.parseLong(parsed[1].toString().trim()),
                         Long.parseLong(parsed[2].toString().trim()),
                         Vals);

               case it:
                  return new InstalledTables(Long.parseLong(parsed[0].toString().trim()),
                         new Date(Long.parseLong(parsed[1].toString().trim())),
                         new Date(Long.parseLong(parsed[2].toString().trim())),
                         new Date(Long.parseLong(parsed[3].toString().trim())),
                         parsed[4].toString().trim(),
                         parsed[5].toString().trim(),
                         Long.parseLong(parsed[6].toString().trim()),
                         Long.parseLong(parsed[7].toString().trim()));

               case rt:
                  return new ReportsTable (Long.parseLong(parsed[0].toString().trim()),
                         Long.parseLong(parsed[1].toString().trim()),
                         parsed[2].toString().trim(),
                         parsed[3].toString().trim(),
                         Long.parseLong(parsed[4].toString().trim()),
                         new Date(Long.parseLong(parsed[5].toString().trim())),
                         (parsed[6].toString().toCharArray())[0],
                         Long.parseLong(parsed[7].toString().trim()),
                         Long.parseLong(parsed[8].toString().trim()),
                         Long.parseLong(parsed[9].toString().trim()));



               case pc:
                  LiveDB.Action act = null;
                  switch(Integer.parseInt(parsed[2].toString().trim())){
                         case 0:
                           act = LiveDB.Action.READFILES;
                           break;
                         case 1:
                           act = LiveDB.Action.WRITEFILES;
                           break;
                         case 2:
                           act = LiveDB.Action.READLINE;
                           break;
                         case 3:
                           act = LiveDB.Action.WRITELINE;
                           break;
                         case 4:
                           act = LiveDB.Action.READOBJECT;
                           break;
                         case 5:
                           act = LiveDB.Action.WRITEOBJECT;
                           break;
                         case 6:
                           act = LiveDB.Action.FASTCOMMIT;
                           break;
                         case 7:
                           act = LiveDB.Action.OTHERS;
                           break;
                         case 8:
                           act = LiveDB.Action.REPORTWRITER;
                           break;
                         default:
                           act = LiveDB.Action.OTHERS;
                           LiveDB.ALRTLVL = 15;
                           System.err.println(LiveDB.grassHopper("Invalid Action ordinal : FiXdAtAcOrRuPtIoN "
                           + String.valueOf(Integer.parseInt(parsed[2].toString().trim()))));
                           break;
                  }

                  ParseThisRow(parsed[4].toString().trim(), parsedVals, '#');
                  tid = new TrainRunningInformation (Integer.parseInt(parsedVals[0].toString().trim()),
                        Long.parseLong(parsedVals[1].toString().trim()),
                        parsedVals[2].toString().trim(),
                        parsedVals[3].toString().trim(),
                        new Date(Long.parseLong(parsedVals[4].toString().trim())),
                        new Date(Long.parseLong(parsedVals[5].toString().trim())),
                        new Date(Long.parseLong(parsedVals[6].toString().trim())),
                        Long.parseLong(parsedVals[7].toString().trim()));

                  return new PlatformClearance (Integer.parseInt(parsed[0].toString().trim()),
                         Long.parseLong(parsed[1].toString().trim()),
                         act,
                         new Date(Long.parseLong(parsed[3].toString().trim())),
                         tid,
                         Long.parseLong(parsed[5].toString().trim()));

               default:
                  System.err.println(LiveDB.grassHopper("case default:"));
                  break;
        }
        return parsed;
    }

/*
 * WIRING DIAGRAM :
 * @LOOKSY:ChangeTracker.java -- toString() method
 * @LOOKSY:Spy.java -- method dump()
 * @LOOKSY:LiveDB.java -- protected static Object createValidInstance (StringBuffer parsedinst, int p_tbl,
 *                                                                                     Character... p_char)
 *
 * Method Name : protected static void ParseThisRow(String p_rowdata, StringBuffer [] p_stuff, char p_char)
 * Parameters : String p_rowdata -- the EntireRow whoose fields are seperated by '%' or '#'
 *              StringBuffer [] p_stuff -- The mutable StringBuffer into which dissected fields are placed.
 *              char p_char -- the field seperator character '%' or '#'
 *
 * Returns : None
 *
 * Associated Methods : protected Object createValidInstance (StringBuffer parsedinst, int p_tbl)
 *                      protected final boolean get_DataEntryFile (int tableno)
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : This method is called from createValidInstance () && get_DataEntryFile(). This
 * method is called and usefull only when corrected dump files are reloaded with LiveDB.command_line equals
 * "FiXdAtAcOrRuPtIoN". So when it is reloading the ChangeTracker from corrected dump files copied to correct
 * data files on disk the method get_DataEntryFile has to deal with a field of the ChangeTracker table called
 * EntireRow which is a row of either the same ChangeTracker table or a row of some other table. So this row
 * has to be parsed and split into field components where each field will be seperated by a p_char. The p_char
 * currently used in the software is either '%' or '#' or '~' or '^'. The default is '%'. So you need to tell
 * this method which is the p_char to look for in the embedded EntireRow in each row of ChangeTracker.
 * Dissected fields are placed in a mutable StringBuffer[] p_stuff and returned to the calling method.
 * NOW there is a special condition where ChangeTracker table row HAS another ChangeTracker row as an
 * EntireRow. Then in this case fields of this embedded ChangeTracker row will be seperated by p_char '#'
 * or '~' or '^'.
 * In simplest terms when you do a toString of a ChangeTracker row containing an EntireRow of any table other
 * than ChangeTracker. That EntireRow will be surrounded by %EntireRow%.
 * if you do a toString of a ChangeTracker row that contains another EntireRow of ChangTracker itself then
 * that second EntireRow will be enclosed in '#' so it will look like %......#EntireRow#.%.
 * 
 * Technical Reference : None.
 *
 * Start Date: 18th October 2010
 * End Date: 18th May 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */

    protected static void ParseThisRow(String p_rowdata, StringBuffer [] p_stuff, char p_char){
        // use StringBuffer which is mutable .. String is immutable

        if (p_rowdata == null)
        {
            p_stuff = null;
            return;
        }

        int bi = 0, ei = 0, i = 0;

        if (p_rowdata.indexOf(p_char) == -1)
        {
            p_stuff[i] = new StringBuffer(p_rowdata);
            return;
        }

        while ((ei = p_rowdata.indexOf(p_char, bi)) != -1)
        {
            p_stuff[i] = new StringBuffer(p_rowdata.substring(bi, ei));
            if (ei + 1 < p_rowdata.length())
                bi = ei + 1;
            i++;
        }

        if (ei == -1)
        {
            p_stuff[i] = new StringBuffer(p_rowdata.substring(p_rowdata.lastIndexOf(p_char) + 1, p_rowdata.length()));
        }
        return;
    }

    protected static WildLifeTypes [] createValidWildLifeTypes ( StringBuffer p_parsedrow ){

        WildLifeTypes [] gowild  = null;
        StringBuffer parsed [] = null;
        StringBuffer parsedtilde [] = null;        

        // This WildLifeTypes is an array
        // So first look for % whatever is between the two % is the entire array of WildLifeTypes
        // which has already been done for you in StringBuffer p_parsedrow
        //
        // Next look for # whatever is betweeen the two # is each element of the array
        // Next look for '~' which seperates each field


        ParseThisRow(p_parsedrow.toString().trim(), parsed, '#');

        for (int i = 0; i < parsed.length; i++)
            ParseThisRow (parsed[i].toString().trim(), parsedtilde, '~');

        // Now parsedtilde should be in multiples of seven

        for ( int i = -1, k = 0; i < parsedtilde.length; i += 7, k++)
        {
            // set in exactly the same order very important
            gowild[k].setScientificname(new String(parsedtilde[i+1].toString().trim()));
            gowild[k].setPopulationcount(new String(parsedtilde[i+2].toString().trim()));
            gowild[k].setDeathcount(new String(parsedtilde[i+3].toString().trim()));
            gowild[k].setPregnancycount(new String(parsedtilde[i+4].toString().trim()));
            gowild[k].setBirthcount(new String(parsedtilde[i+5].toString().trim()));
            gowild[k].setDiseasecount(new String(parsedtilde[i+6].toString().trim()));
            gowild[k].setRadiotags(new String(parsedtilde[i+7].toString().trim()));
        }

        return gowild;
    }


/*
 * WIRING DIAGRAM :
 * Method Name : protected static String convertFileName (String p_filename)
 * Parameters : String p_filename -- the pathname to be converted
 * Returns : String converted file name or even null if parameter is null
 *
 * Data File : None
 *
 * @Since Version : 1.0
 *
 * Running Commentary : Before you read this method read howtoinstall.txt very quickly. See you are
 * serving up Option 2 from your web start. Now for that self-install java executable you may have
 * done the data entry in windows and/or specified windows file names in different data entry files
 * but the user is now installing it on non-windows O/S so the windows file name has to be converted
 * to the local O/S equivalent filename at install time only. This method still needs a slight tweak
 * for UNC pathnames = "\\\\" + hostname + sharename. I will update it shortly. See when you do a
 * new File(pathname) it auto converts the pathname to abstract but for Hetrogenious intranet installs
 * a UNC like pathname must already be there.
 *
 * Technical Reference : None
 *
 * Start Date: 14th October 2011
 * End Date: 14th October 2011
 *
 * AUTHOR : Padmanabhan Sai Krishna
 * Email : pskris@sify.com
 * Phone(s) : +91-80-41689002
 *            +91-80-23624473
 * Mobile : +91-9900516842
 * Residential Address for Darshan : C-1678, Sahakara Nagar, Bangalore - 92.
 */
    
    protected static String convertFileName (String p_filename)
    {
        
        char newfilename [] = null;
        char driveletter = ' ';

        if (p_filename == null) return null;
        
        if (p_filename.indexOf(":\\") != -1)
        {
            if (LiveDB.OPERATINGSYSTEM.indexOf(WINDOWS) == -1)
            {
                // the we need to convert this file name to non-windows format and return filename
                newfilename = (LiveDB.FILESEPERATOR + p_filename.substring(p_filename.indexOf(":\\") + 2,
                  p_filename.indexOf(":\\") + 2 >= p_filename.length() ? p_filename.length() + 1:
                  p_filename.length())).toCharArray();
                for (int i = 0; i < newfilename.length; i++)
                {
                    if (newfilename[i] == '\\')
                        newfilename[i] = '/';
                }
                return newfilename.toString();
            }
            else
            {
                return new String(p_filename.toCharArray());
            }
        }
        else if (p_filename.indexOf("/") != -1)
        {
                if (LiveDB.OPERATINGSYSTEM.indexOf(WINDOWS) != -1)
                {
                    driveletter = LiveDB.USRDIR.toCharArray()[LiveDB.USRDIR.indexOf(":\\") - 1];
                    // the we need to convert this file name to windows format and return filename
                    newfilename = (driveletter + p_filename.substring(p_filename.indexOf('/'),
                    p_filename.indexOf('/') + 1 >= p_filename.length() ? p_filename.length() + 1:
                    p_filename.length())).toCharArray();
                    for (int i = 0; i < newfilename.length; i++)
                    {
                        if (newfilename[i] == '/')
                            newfilename[i] = '\\';
                    }
                    return newfilename.toString();
                }
                else return new String(p_filename.toCharArray());           
        }
        else if (p_filename.indexOf("\\\\") != -1) // UNC path
        {
            // Say your prayers hope java converts this file to abstract on non-windows
            return new String(p_filename.toCharArray());
        }

        // it is a relative filename

        return new String((LiveDB.USRDIR + p_filename).toCharArray()) ;
    }
} /* class LiveDB */
